define(function(require, exports, module) {

	var nativeBroadcast = window.nativeBroadcast = _.extend({}, Backbone.Events);

	var App = window.App = new Application();

	App.storage.set("UserInfo", new Model());
	App.storage.set("security/otpSwitch", new Model());

	// APP LAYOUT DEFINITION
	// =====================

	App.addRegions({
		headerRegion : "#js-site-header",
		footerRegion : "#js-site-footer",
		container : "#js-site-container"
	});


	// App.container.show.error = function(options){
		// var ErrorView = require("mod/common/view/error/error");
		// App.container.show(new ErrorView({model:new Model(options)}));
	// };

	var Header = require("mod/common/header/main");
	App.header = new Header();
	App.headerRegion.show(App.header);

	var Footer = require("mod/common/footer/main");
	App.footer = new Footer();
	App.footerRegion.show(App.footer);
	App.footer.reset({visible:true, selectedIndex:0});

	// 手机端调用壳方法 获取 webview 区域高度
	// =====================
	if (!App.locStorage.get('webviewHeight')) {

		App.locStorage.set('webviewHeight', document.documentElement.clientHeight || window.innerHeight);

		if (IS_RUN_ON_DEVICE) {
			utils.native.getWebviewHeight(function (height) {

				App.locStorage.set('webviewHeight', height);

			});
		}
	}

	App.listenTo(nativeBroadcast, "change:footer:selected:tab", function(idx) {
		// // 这里需要重构。 有一部分页面会禁用侧滑栏，然后在这个事件中重新打开
		// // 妥当的解决方案应该是在那个view销毁时再重新启用
		// if(App.storage.get("isUserLoggedIn")){
			// utils.native.setSideMenuDisabled(false);
		// }

		if(App.storage.get("isUserLoggedIn")){
			switch(idx) {
				case 0 : return App.navigate("index/indexLogined/index", true);
				case 1 : return App.navigate("products/index/index/depositTake", true);
				case 2 : return App.navigate("search/search/index", true);
				case 3 : return App.navigate("me/logined/index",true);
			}
		}else{
			switch(idx) {
				case 0 : return App.navigate("index/index/index", true);
				case 1 : return App.navigate("products/index/index/depositTake", true);
				case 2 : return App.navigate("search/search/index", true);
				case 3 : return App.navigate("me/me/unlogin",true);
			}
		}


	});


	// APP COMMANDS DEFINITION
	// =======================

	App.commands.setHandler("logout", require("./logout"));

	App.commands.setHandler("removeGestrueLogin",require("./removeGestrueLogin"));

	App.commands.setHandler("exitApp", function(){
		utils.dialog.confirm("确定要退出平安橙子吗？", function(ok){
			if(ok && ENABLE_PHONEGAP) utils.native.exitApp();
		});
	});



	// SYNC SIDE MENU CONTENT
	// =====================

	App.listenTo(App.storage.get("security/otpSwitch"),"change",function(otpSwitch){
		if(otpSwitch.get("otpSwitch") == "1"){
			utils.native.getDeviceInfo().always(function(data){
				var temp = {tokenId:data.tokenId};
				App.commands.execute("removeGestrueLogin",{data:temp});
			});
		}

	});



	App.listenTo(nativeBroadcast,"click:notice:push",function(content){
		//content : 你在#xxxxxx#有新消费，快点我完成记账！（流水号J12345678）
		var subName = content.indexOf("流水号");
		var param = {
			"subName" : subName == -1 ? "" : subName
		}
		App.storage.set("noticePush",param);
		if(subName != -1){
			var type = content.substr(subName+3,1).toLocaleUpperCase();
			var id = content.substring(subName+4,content.length-1);
			var convertStr = "type="+type+"&id="+id;
			param.type = type;
			param.id = id;
			param.convertStr = convertStr;
			App.storage.set("noticePush",param);
			var isLogin = App.storage.get("isUserLoggedIn");
			if(isLogin){
				App.navigate("noticePush/noticePush/index?"+param.convertStr+"&"+Date.parse(new Date()),true);
			}

		}
	});


	App.listenTo(nativeBroadcast, "click:button", function(name) {
		if(name === "about") return App.navigate("settings/about/index", true);
		if(name === "authMessage") return App.navigate("personalCenter/authMessage/index", true);
		if(name === "portrait") return App.navigate("personalCenter/index/index/3", true);
		if(name === "signUp") return App.navigate("register/register/index", true);
		if(name === "recommend") return App.navigate("activityRecommend/activityRecommend/index", true);
	});




	// HANDLE BACKBUTTON EVENT
	// =======================

	App.listenTo(nativeBroadcast, "click:backbutton", function() {
		var event = $.Event("backbutton");
		nativeBroadcast.trigger("backbutton", event);
		if(event.isDefaultPrevented()) return;

		if(App.header.leftButtonContent == "@back") App.header.execLeftButtonHandler();
		else App.back();
	});


	App.listenTo(nativeBroadcast, "backbutton", function(event){
		function match(fragment){
			if(fragment.indexOf("index/index/index") == 0) return true;
			if(fragment.indexOf("products/index/index") == 0 && !ANYDOOR_ENABLED) return true;
			if(fragment.indexOf("search/search/index") == 0) return true;
			if(fragment.indexOf("me/me/unlogin") == 0) return true;
			if(fragment.indexOf("login/login/toaIndex") == 0 && !ANYDOOR_ENABLED) return true;
			if(fragment.indexOf("index/indexLogined/index") == 0) return true;
			if(fragment.indexOf("me/logined/index") == 0) return true;
		}


		if(match(App.history.fragment)){
			event.preventDefault();
			App.commands.execute("exitApp");
			return;
		}

		var fragmentArr = [
			"login/login/toLoginTerms",
			"openAccount/main/securitySet",
			"openAccount/main/bindToa",
			"verifyAccount/bindCard/bindCardSuccess",
			"verifyAccount/bindCard/inputBindCard",
			"verifyAccount/bindCard/bindCardAuth",
			"verifyAccount/bindCard/toBankInfo"
		]

		function match1(fragment){
			if(fragmentArr.join(",").indexOf(fragment) >= 0) return true;
		}

		if(match1(App.history.fragment)){
			event.preventDefault();
			return;
		}
	});

	//手势密码登录成功之后native所触发的事件
	App.listenTo(nativeBroadcast, "gestureLoginToUrl",function(param){
		var customUrl = param || "login/login/gestureLogin";
		App.navigate(customUrl,true);
	});
	//手势密码忘记埋点标记
	App.listenTo(nativeBroadcast, "forgetGesturePassword",function(){
		utils.native.talkingDataTrackEvent("2.0登录-手势密码-忘记手势密码");
	});
	//手势密码其他登陆方式埋点标记
	App.listenTo(nativeBroadcast, "otherLoginWays",function(){
		utils.native.talkingDataTrackEvent("2.0登录-手势密码-其他方式登录");
	});
	//2.0首页-登录后-手势密码设置-下次再说
	App.listenTo(nativeBroadcast, "gestureSetNextTime",function(){
		utils.native.talkingDataTrackEvent("2.0首页-登录后-手势密码设置-下次再说");
	});
	//2.0首页-登录后-手势密码设置-马上设置
	App.listenTo(nativeBroadcast, "gestureSetRightNow",function(){
		utils.native.talkingDataTrackEvent("2.0首页-登录后-手势密码设置-马上设置");
	});
	//2.0首页-登录后-手势密码设置-不再提示
	App.listenTo(nativeBroadcast, "gestureSetNeverShow",function(){
		utils.native.talkingDataTrackEvent("2.0首页-登录后-手势密码设置-不再提示");
	});

	//分享成功之后送积分的监听事件
	App.listenTo(nativeBroadcast, "getShareReturn",function(param){
		//是否分享成功 true成功false失败
		var shareRe = param.shareRe || false;
		if(shareRe && App.storage.get("isUserLoggedIn")){
			var accountModel = require("mod/common/model/accountModel");
			//分享缓存信息
			var data = App.storage.remove("shareWLTData");
			//分享渠道 1微信朋友分享 2微信朋友圈分享 3新浪微博分享
			data.share_channel = param.shareChannel;
			//首次分享送积分接口
			accountModel.wanlitongShare(data);
		}
	});

	//保持橙子登录态
	App.listenTo(nativeBroadcast, "setOrangeHearBeat", function () {
		var deferred = $.Deferred();
		var url = config.urls.get("bankToaMaintainLogin");
		App.request(url, {cancelWhenRouting: false}).complete(function (error, res) {
			if (error) {
				deferred.reject(error);
				return;
			}
			deferred.resolve(res);
		});
		return deferred.promise();
	});

	// this function will be called from native
	App.redirectToLogin = function(query){
		var search = $.param(query || {"open-anydoor-plugin-after-login":true}, true);
		var loginUrl = config.base.login_url + "?" + search;
		App.navigate(loginUrl, true);
	};

	// LOGOUT IF APP PAUSE OVER 5 MINUTES
	// ==================================

	var logoutTimer = null;

	document.addEventListener("pause", function(){
		if (App.storage.get("isToaf")) {
			App.storage.remove("isToaf");
			return;
		}
		clearTimeout(logoutTimer);
		logoutTimer = setTimeout(function(){ App.commands.execute("logout", true); }, 300000);
	}, false);

	document.addEventListener("resume", function(){
		clearTimeout(logoutTimer);
	}, false);




	var Requester = require("./requester/main");
	App.requester = new Requester();
	App.request = _.bind(App.requester.request, App.requester);


	App.history.on("beforeRoute", require("./authorization").handler);
	App.history.on("beforeRoute", require("./manageRequestOnRoute").handler);
	App.history.on("beforeRoute", require("./checkToaPwd").handler);

	//2015-12-24 ex-huangzit
	App.history.on("beforeRoute", require("./bindCardFilter").handler);


	require("./renderDuringRequest/main")(App);
	require("./initNativeComponent")(App);

	App.history.route(/^\s*$/, function() {
		App.navigate(config.base.login_url, {
			trigger : true,
			replace : true
		});
	});

	App.start();
	App.history.start();


	document.addEventListener("backbutton", function(event){
		event.preventDefault();
	}, false);



});