define(function (require, exports, module) {

    function defaultAuthorize(){
        if(!App.storage.get("isUserLoggedIn"))
            return false;
    }

    exports.handler = function(event){
        if(event.router === App.loader)
            return;

        var router = event.router;
        var authorize = router.authorize || defaultAuthorize;

        if(authorize.call(router, event.fragment, event.name, event.args) === false) {
            event.preventDefault();
            
            var returnURL = encodeURIComponent(event.fragment);
            var loginURL = config.base.login_url;
            App.navigate(loginURL + "?returnURL=" + returnURL, { trigger: true, replace: true });
        }
    };

});