define(function(require, exports, module) {
    var CheckToaPwdInput = require('component/password/checkToaPwdInput');

    exports.handler = function(event) {
        if (event.router === App.loader) return;
        if (!App.storage.get('isUserLoggedIn')) return;
        //登入类型，0:手势密码登入，1:一账通登入，2手机OTP登入
        //手势登录，需要弹窗再次输入登录密码，其他不需要
        var userInfo = App.storage.get('UserInfo'), //用户信息
            loginType = userInfo && (userInfo.get('loginType') + ''); //登入类型
        if ('0' !== loginType) return;


        //2015-10-15 用手势登录后，需要再次输入登录密码的锚点列表
        //1、资金转出          me/transfer/index
        //2、交易密码修改      me/passmanagement/tradepasspage
        //3、信用卡还款        me/creditCard/payBack
        //4、修改手机号码      me/meInfo/modifyIphoneStep1
        var filterAnchors = [
            'me/transfer/index',
            'me/passmanagement/tradepasspage',
            'me/creditCard/payBack',
            'me/meInfo/modifyIphoneStep1',
            'dinghuotong/draw/dhtDraw'
        ];


        var fragment = event.fragment,
            checkToaPwdInput,
            gestureStorageKey = 'checkToaPwd::GestureDraw', //授权key
            authorized = App.storage.get(gestureStorageKey) || false; //是否已经授权

        if (!!~filterAnchors.indexOf(fragment) && !authorized) {
            event.preventDefault();
            checkToaPwdInput = new CheckToaPwdInput({
                callback: function(flag) {
                    var prev = App.browseList[0];
                    if (flag === 'ok') {
                        App.storage.set(gestureStorageKey, true);
                        App.history.loadUrl(fragment);
                    } else {
                        if (fragment === prev) {
                            App.back();
                        } else {
                            if (!~prev.indexOf('login/login')) {
                                App.navigate(prev);
                            } else {
                                App.navigate('me/logined/index', true);
                            }
                        }
                    }
                }
            });
            App.history.once('beforeRoute', function() {
                checkToaPwdInput._destoryCustom();
            });
        }

    };

});
