require.config({

    urlArgs: AVOID_CACHE ? +new Date() : "",

    baseUrl: "./",

    paths: {
        "underscore": "vendor/underscore",
        "backbone": "vendor/backbone",
        "marionette": "vendor/backbone.marionette",
        "text": "vendor/require.text",
        "jquery": "vendor/jquery",
        "highcharts": "vendor/highcharts",
        "highchartsMore":"vendor/highcharts-more"
    },

    shim: {
        "underscore": { exports: "_" },
        "backbone": { deps: ["underscore", "jquery"], exports: "Backbone" },
        "marionette": { deps: ["backbone"], exports: "Marionette" },
        "vendor/jquery.tap": { deps: ["jquery"] },
        "vendor/iscroll": { exports: "iScroll" },
        "highcharts": { deps: ["jquery"] },
        "highchartsMore": { deps: ["highcharts"] }
    }
});


require(["vendor/index"], function(){

    document.addDeviceReadyEventListener(function(){

        require(["conf/main", "lib/main", "utils/main"], function(config, lib, utils){
            _.extend(window, lib);

            window.config = config;
            window.utils = utils;

            require(["app/application"]);
        });
    });

});