define(function (require, exports, module) {

    var LoadingLayer = require("./loadingLayer");

    var loadingLayer = new LoadingLayer();
    var processing = 0;
    var timerToHide = null;

    function handleRequestComing(settings) {
        if (settings && settings.silent) return;

        processing++;
        loadingLayer.show();
        clearTimeout(timerToHide);
    }

    function handleRequestComplete(settings) {
        if (settings && settings.silent) return;

        processing--;
        timerToHide = setTimeout(function () {
            if (processing === 0) loadingLayer.hide();
        }, 25);
    }

    function handleHideLoading() {
        if (processing != 0) {
            loadingLayer.hide();
        }
    }

    var renderDuringRequest = module.exports = function (App) {

        App.loader.on("before:load", handleRequestComing);
        App.loader.on("after:load", handleRequestComplete);

        App.requester.on("before:request", handleRequestComing);
        App.requester.on("after:request", handleRequestComplete);
        App.history.on("beforeRoute", handleHideLoading);

        //2015-8-26 wuyongsheng560
        //手机端js线程崩溃时，loader并未触发后续事件, 遮罩层未隐藏
        if (IS_RUN_ON_DEVICE)
            window.addEventListener('error', function () {
                processing = 0;
                return true;
            }, false);
    };

});