define(function (require, exports, module) {

    var requestByNative = module.exports = function(originalSettings, callback){

        var canceled = false;
        var aborted = false;
        var settings = {};

        settings.url = originalSettings.url;
        settings.params = originalSettings.data;
        settings.type = originalSettings.type || "POST";

        //2015-05-10 wuyongsheng560 缓存接口需要传入 {key : 'xxx', isSave: true}
        settings.key = originalSettings.key || originalSettings.urlKey;
        settings.isSave = originalSettings.isSave || false;

        var xhr = utils.native.HTTPRequest(settings);

        xhr.done(function(status, data){
            if(!canceled && !aborted) callback("success", data);
        });

        xhr.fail(function(statusText){
            if(!canceled && !aborted) callback(statusText);
        });

        var result = {};
        result.cancel = function(){ canceled = true; callback("canceled"); };
        result.abort = function(){ aborted = true; callback("abort"); };

        return result;
    };
});