define(function (require, exports, module) {
    var IScroll = require("vendor/iscroll");
    var tpl = require("text!component/chooseBankPlugin/chooseBank.html");
    var transModel = require("mod/me/model/transferModel");
    var _callback;
    var banksSortByLetterList;
    var temp;
    var flag = false;  //解决 选择银行,出现多次执行回调函数的bug
    $.fn.chooseBank = function (options, callback) {
//        App.listenTo(nativeBroadcast,"chooseBank:left:click",function(){alert(1)});
        _callback = callback;
        if (!isBanksExist()) {
            //查询平安付支持的银行列表
            qryBanks(options);
        }
        this.click(function () {
            //重置上次选择银行的结果
            initChooseBank();
            if ($("#sectionDivOld").length === 0) {  //是否第一次进来
                var sectionDiv = $(this).parent("section");
                var sectionDivOld = $("<div id=\"sectionDivOld\"></div>").append($(this).parent("section").children());
                sectionDiv.append(sectionDivOld);
                $(this).parent().parent("section").append(temp);
            }
            //隐藏原来页面 显示选择银行页面
            $("#sectionDivOld").hide();
            $("#chooseBank_plugIn").show();
            //初始化事件
            initEvents();
            //初始化滚动条
            initScroll();
        });
    };
    //重置上次选择银行的结果
    var initChooseBank = function () {
        flag = false;
        $(".dswkb .iconA59").hide();
        $(".por").show();
        $("#defaultBankDiv").show();
        $("#transForIntoInfo").show();
        $("#searchResult").hide();
        $("#searchFail").hide();
        $("#trnsforOutputBanksByLetter").show();
        $("#trnsforOutputBanksByLetter .qyMain").show();
        $("#trnsForIntoBanksByChinese").hide();
        $("#searchBank").val("");
    };
    //判断缓存中是否已经有所有银行数据
    var isBanksExist = function () {
        var payBanklist = App.storage.get("payBanklist");
        if (payBanklist === undefined) {
            return false;
        } else {
            return true;
        }
    };
    ////查询平安付支持的银行列表
    var qryBanks = function (options) {
        transModel.qryPaPayBankList({
            url: "qryPaPayBankList",
            callback: function (resp) {
                if (resp.object.payBanklist) {
                    //将默认银行数据转成按字母排序
                    banksSortByLetterList = trnsforDfltBanksToSortByLetter(resp.object.payBanklist);
                    App.storage.set("payBanklist", banksSortByLetterList);
                    options.trnsforOutputBanksByLetter = banksSortByLetterList;
                    temp = _.template(tpl, {model: options});
                } else {
                    utils.dialog.alert("平安付支持银行列表为空");
                }
            },
            errorCallback: function (resp) {
                utils.dialog.alert(resp.message);
            }
        });
    };
    //初始化事件
    var initEvents = function () {
        $("#searchBank").bind("input", filterBank);
        $(".dswkb").bind('click', chooseBank);
    };
    //初始化滚动条
    var initScroll = function () {
        var el = $('#wrapper');
        var height = $(window).height() - el.offset().top;
        el.css({height: height, position: 'relative'});
        var myScroll = new IScroll("wrapper", {
            "hScroll": false,
            "hideScrollbar": true,
//            "bounceLock":true,
            checkDOMChanges: true
        });
    };
    //将默认银行数据转成按字母排序
    var trnsforDfltBanksToSortByLetter = function (defaultList) {
        var banksSortByLetter = [];
        for (var i = 0, dLLength = defaultList.length; i < dLLength; i++) {
            var tempLetter = defaultList[i].recBankPinyin[0].toUpperCase();
            if (banksSortByLetter.length === 0) {
                var tempLetterAndLetter = {
                    "letter": "",
                    "banks": []
                };
                tempLetterAndLetter.letter = tempLetter;

                var tempBank = {};
                tempBank.bankName = defaultList[i].recBankName;
                tempBank.bankPinyinName = defaultList[i].recBankPinyin;
//                tempBank.bankIcon = "../../images/PA_logo2.png";
                tempBank.bankIcon = "images/" + defaultList[i].recBankId + ".png";
                tempLetterAndLetter.banks.push(tempBank);
                banksSortByLetter.push(tempLetterAndLetter);
            } else {
                var flag = false;
                for (var j = 0, bSLLength = banksSortByLetter.length; j < bSLLength; j++) {
                    if (banksSortByLetter[j].letter === tempLetter) {
                        flag = true;
                        var tempBank = {};
                        tempBank.bankName = defaultList[i].recBankName;
                        tempBank.bankPinyinName = defaultList[i].recBankPinyin;
                        tempBank.bankIcon = "images/PA_logo2.png";
                        banksSortByLetter[j].banks.push(tempBank);
                    }
                }
                if (!flag) {
                    var tempLetterAndLetter = {
                        "letter": "",
                        "banks": []
                    };
                    tempLetterAndLetter.letter = tempLetter;

                    var tempBank = {};
                    tempBank.bankName = defaultList[i].recBankName;
                    tempBank.bankPinyinName = defaultList[i].recBankPinyin;
                    tempBank.bankIcon = "images/PA_logo2.png";
                    tempLetterAndLetter.banks.push(tempBank);
                    banksSortByLetter.push(tempLetterAndLetter);
                }
            }
        }
        //按字母顺序排序
        for (var h = 1, oBSLLength = banksSortByLetter.length; h < oBSLLength; h++) {
            for (var k = 0; k < oBSLLength - h; k++) {
                if (banksSortByLetter[k].letter > banksSortByLetter[k + 1].letter) {
                    var tempObject = banksSortByLetter[k + 1];
                    banksSortByLetter[k + 1] = banksSortByLetter[k];
                    banksSortByLetter[k] = tempObject;
                }
            }
        }
        return banksSortByLetter;
    };
    /*****************************  定义事件 *******************************/
    //过滤银行
    var filterBank = function (e) {
        $(".por").show();
        var inputSearchContent = $(e.currentTarget).val();
        if (inputSearchContent === "") {     //搜索内容为空 显示默认
            $(".por").show();
            $("#defaultBankDiv").show();
            $("#transForIntoInfo").show();
            $("#searchResult").hide();
            $("#searchFail").hide();
            $("#trnsforOutputBanksByLetter").show();
            $("#trnsforOutputBanksByLetter .qyMain").show();
            $("#trnsForIntoBanksByChinese").hide();
        } else {                             //搜索内容不为空 显示搜索结果
            /*
             * A~Z 正则表达式 判定是按照字母查询？还是按照中文拼音查询？还是按照中文查询？
             * 从而判定是否显示 div搜索结果
             * 如果true  表示按字母查找 不显示 div搜索结果
             *   1 **
             * 如果false 表示按中文查找 显示 div搜索结果
             *   1 将银行全部放入一个数组 trnsForIntoBanksByChinese
             *   2 遍历数组(正则) 将其显示
             */
            var checkLetter = /^[A-Za-z]+$/;
            var isLetter = checkLetter.test(inputSearchContent);
            if (inputSearchContent.length === 1 && isLetter) { //按照字母查询
                $("#trnsforOutputBanksByLetter").show();
                $("#defaultBankDiv").hide();
                $("#trnsForIntoBanksByChinese").hide();
                var banks = $("#trnsforOutputBanksByLetter .qyMain");
                var j = 0;
                for (var i = 0, bL = banks.length; i < bL; i++) {
                    $($("#trnsforOutputBanksByLetter.qyMain")[i]).show();
                    var letter = $($($("#trnsforOutputBanksByLetter .qyMain")[i]).find("p")[0]).html().trim();
                    if (letter !== inputSearchContent.toUpperCase() && letter !== inputSearchContent.toLowerCase()) {
                        $($("#trnsforOutputBanksByLetter .qyMain")[i]).hide();
                        j++;
                    }
                }
                if (j === bL) {
                    $("#searchResult").show();
                    $("#searchFail").show();
                    $(".por").hide();
                    $("#trnsforOutputBanksByLetter").hide();
                } else {
                    $("#searchResult").hide();
                    $("#searchFail").hide();
                }
            } else {            //按照中文拼音、中文查询
                $("#defaultBankDiv").hide();
                $("#trnsForIntoBanksByLetter").hide();
                $("#trnsforOutputBanksByLetter").hide();
                $("#trnsForIntoBanksByChinese .searchCon .Columns ul").empty();
                var trnsForIntoBanksByChinese = $("#trnsforOutputBanksByLetter .qyMain .Columns ul>li");
                var count = 0;
                for (var i = 0, bL = trnsForIntoBanksByChinese.length; i < bL; i++) {
                    var bankLi = trnsForIntoBanksByChinese[i];
                    var bankName = $(bankLi).find("div p").html().trim();
                    var bankPinyinName = $(bankLi).find("span").html().trim();
                    if (bankName.indexOf(inputSearchContent) > -1 || bankPinyinName.indexOf(inputSearchContent) > -1) {
//                            this.$("#trnsForIntoBanksByChinese")
                        var divClone = $(bankLi).clone();
                        $("#trnsForIntoBanksByChinese .searchCon .Columns ul").append(divClone);
                        count++;
                    }
                }
                if (count === 0) {      //没有搜索到一个可匹配银行
                    $("#searchFail").show();
                    $("#searchResult").show();
                    $("#trnsForIntoBanksByChinese").hide();
                    $("#trnsforOutputBanksByLetter").hide();
                    $(".por").hide();
                } else {
                    $(".por").hide();
                    $("#searchFail").hide();
                    $("#searchResult").show();
                    $("#trnsForIntoBanksByChinese").show();
                }
            }
        }
    };
    var chooseBank = function (e) {
        if(!flag){
            flag = true;
            var temp = $(e.currentTarget);
            if ($(temp).attr("dataflag") !== "inputSearch") {
                var chooseIcon = $(".dswkb .iconA59").show();
                $($(temp)[0]).append(chooseIcon);
                setTimeout(function () {
                    //隐藏选择银行页面 显示之前页面
                    $("#sectionDivOld").show();
                    $("#chooseBank_plugIn").hide();
                }, 300);
                _callback($(temp).find("div p").text().trim());
            }
            e.preventDefault();
        }
    };
    /*****************************  定义事件 *******************************/
});