define(function (require, exports, module) {

    var Component = module.exports = function(HTMLElement, form){

        this.el = HTMLElement;
        this.el.__component__ = this;
        this.$el = $(HTMLElement);
        this.form = form;

        this.id = this.readAttr("id");
        this.name = this.readAttr("name");

        this.bindDOMEvents();
    };

    Component.extend = Backbone.Model.extend;

    _.extend(Component.prototype, Backbone.Events, {

        render: function(){ },

        bindDOMEvents: function(){ },

        readAttr: function(name){
            var value = this.$el.attr("data-" + name);
            if(value == null) value = this.$el.attr(name);
            return value;
        },

        triggerBoth: function(type){
            this.trigger.apply(this, arguments);
            var componentName = this.$el.attr("data-component").toLowerCase();
            this.$el.trigger(componentName + ":" + type, _.toArray(arguments).slice(1));
        },

        destroy: function(){
            this.$el.off();
            this.stopListening();

            this.el.__component__ = null;
            this.el = null;
            this.$el = null;
            this.form = null;
        }
    });
});