define(function (require, exports, module) {

    var ComponentFactory = exports;

    ComponentFactory.createComponent = function(HTMLElement, form){
        var componentName = HTMLElement.getAttribute("data-component");
        var constructor = ComponentFactory.getConstructorByName(componentName);
        if(!constructor) throw "component '" + componentName + "' is not defined";
        return new constructor(HTMLElement, form);
    };

    ComponentFactory.getConstructorByName = function(name){
        switch(name.toLowerCase()){
            case "component":   return require("./component");
            case "input":       return require("./input");
            case "datepicker":  return require("./datepicker");
            case "moneyinput":  return require("./moneyInput");
        }
    }
});