/**
 * OTP公用组件
 */
define(function(require,exports,module){
    var OtpService=require('./OtpService');
    var otpTpl=require('text!./OtpTpl.html');
    var FormComponent=require("component/form");
  var OtpView = module.exports=FormComponent.extend({
    id : 'otpView',
    name : 'otpView',
    tagName : 'div',
    className : "dswkb h50",
    template : _.template(otpTpl),


    initialize : function() {
      var html = this.template();
      this.$el.html(html);
    },
    events :
        {
      'focus #otp_passWord':'_focus',
      'blur #otp_passWord':'_blur',
      "keypress #otp_passWord":"keyUp"
        },



    /**
     * otpParentId ：一个页面多处使用OTP组件时，必须传递OTP组件的祖先元素"#ID"（一般传父元素"#ID"）；一个页面只有一处使用OTP时可以不传此参数
     * isOtpSended：是否已自动发送OTP到手机
     * otpSendFlag：OTP发送类型（默认为2）    2:发送非转账类OTP；其他：发送转账类OTP；3：登录otp发送 1：口袋银行快付功能绑定设备otp发送
     * isNeedSendOtpValidate：是否需要调用接口验证OTP
     * callbackSubmit：点击“确认”按钮（页面输入校验通过）调用的函数
     * callbackError：发送业务请求失败的回调函数
     * isQryOtpPhoneNo：需要通过调用接口查询手机号码
     * otpEnable：是否开启OTP功能，true强制开启；false强制关闭；null为高级并且设置了安全工具,则开启otp,否则关闭
     * isMobilePhoneByUser：true手机号码是用户输入的，false手机号码是通过调用接口查询的
     * resendBtnHandler（可选）：当isMobilePhoneByUser为true时，resendBtnHandler为必选（用户输入手机号码时，”立即获取“必须绑定到此函数）
     */
    initOtp : function(options) {
        var self=this;
      this.otpService = new OtpService({
          otpParentId : options.otpParentId,
        phoneCodeField : this.$el.find('#otp_passWord'),
        resendField : this.$el.find('#btn_resend'),
        countdownLabel : this.$el.find('#otp_label'),
        otpInputContainer : this.$el.find('#otp_input_container'),
        otpLabelContainer : this.$el.find('#otp_label'),
        isOtpSended : options.isOtpSended,
        otpSendFlag : options.otpSendFlag,
        isNeedSendOtpValidate: options.isNeedSendOtpValidate,
        // callbackValidate : options.callbackValidate,
        callbackSubmit : options.callbackSubmit,
        callbackError : options.callbackError,
        resendBtnHandler : options.resendBtnHandler,
        isOutLogin:options.isOutLogin,
        cat:options.cat,
        values:options.values,
        phone: options.phone
      });

      this.otpService.initOtp(options.isQryOtpPhoneNo,options.otpEnable,options.isMobilePhoneByUser);

    },

    OtpKeyboard : function(e)
    {
      // 隐藏错误提示信息
      this.$el.find("#otp_passWord").parent().removeClass("inputText1Error");
      this.$el.find("#otp_passWord_ErrorTip").hide();

    },

    /**
     * 发送OTP到手机：主要用于登录区外，由用户输入手机号码的OTP发送
     * urlName：OTP请求接口URL
     * parameter：OTP请求入参
     * */
    sendSmsOTP : function(urlName, parameter) {
      this.otpService.sendSmsOTP(urlName, parameter);
    },

        submit:function(){
            this.otpService.submit();
        },
    /**
     * 停止计时（动态密码倒数计时）
     * */
    stopService : function() {
      this.otpService.stopService();
    },
    keyUp : function(e) {
        
        var keyCode=e.which||e.keyCode;
            if(keyCode < 48  || keyCode > 57) {
                   return false;
               }
               if(this.getValue().length>=7) return false;
        },
        _focus:function(){
            var el=this.$("#otp_passWord");
             if(el.next().hasClass("js-error-icon")){
                 el.next().remove();
             }
             el.after($('<i class="iconA54 m_r10 js-clear-input"></i>'));
             el.removeClass("error").addClass("focus");
             $(".js-clear-input").on("tap",function(){
                el.val("");
             });
             $(".js-clear-input").on("touchstart",function(e){
                e.preventDefault();
             });
        },
        _blur:function(){
            $(".js-clear-input").remove();
             this.$("#otp_passWord").removeClass("focus");
        },
        
        setCustomValidity: function(message){
            var el=this.$("#otp_passWord");
             if(!el.next().hasClass("js-error-icon")){
                 el.after($('<i class="iconA54 js-error-icon"></i>'));
             }
             el.addClass("error");
            if(message !== ""){
                utils.dialog.toast(message);
                return;
            }
        },

        getValue: function(){
            return this.$("#otp_passWord").val();
        },

        isSendedOTP:function(){
            return this.otpService.isSendedOTP();
        }

  });
});