/*
 * @Author: LINQIUGUI177
 * @Date:   2016-05-11 19:43:56
 * @Last Modified by:   EX-MANINGJIE001
 * @Last Modified time: 2016-05-16 18:03:52
 */
// 红包公共方法用法：
// HTML:
//  <div id="redPacketSelect"></div>
// JS:
//  onShow初始化：
//   this.redPacket = new RedPacket({
//       // className : "h50 lh12",     // 一级标签class
//       redPacketCategoryCode : "00",  // 00手机充值
//       redPacketStatusCode   : "0|1", // 0为未到使用期，1为未使用
//       text : "信用卡还款红包",      // 页面显示的文字
//       // textClassName : "c_000 f16",// 页面文字的样式
//       title : "支付红包",            // 弹窗显示的标题
//       amt : "100",                   // 金额
//       selectionBox : "checkbox"      // radio || checkbox
//   });
//   this.$("#redPacketSelect").empty();
//   this.$("#redPacketSelect").append($(this.redPacket.$el[0]));
//  取值及方法：
//   this.redPacket.getType();    // 获取已选红包id号
//   this.redPacket.getSaleAmt();    // 获取已选红包总金额
//   this.redPacket.reload({amt: amt});     // 更新此试图（局部刷新）
define(function(require, exports, module) {
	var RedPacketTpl    = require("text!./redPacket.html");
	var RedPacketModel  = require("./model");
	var redPacketSelect = require("./redPacketSelect");
	module.exports = Layout.extend({
		id: "redPacketView",
		tagName: 'div',
		className: "Columns",
		regions: {
			redPacketDom : "#redPacketDom"
		},
		template: function() {},

		events: {
			"tap #redPacketList,#notUsePacket,#redPacketCheckboxList" : "toRedPacketList"
		},

		initialize: function(options) {
			this.text = options.text || "";    //支付红包名称
			this.textClassName = options.textClassName || "c_999";  // 支付红包样式
			this.selectionBox = options.selectionBox || "radio";    // 单选radio || 多选checkbox
			this.amt = (options.amt || 0).toString().replace(/,/g, "");    // 限制的值
			this.title = options.title || "";    // 标题
			this.callback = options.callback;

			this.listNum = [];
			this.redPacketId = [];
			this.sumAmt = 0;
			this.length = 0;//未使用红包长度
			this.useFlag = 0;//1 有可使用红包
			this.render();
		},

		onRender: function() {
			this.qryList();
		},

		// 查询红包列表
		qryList: function() {
			var self = this;
			var redPacketList = App.storage.get("redPacketLists");
			if(redPacketList!==undefined && redPacketList.redPacketList[0].redPacketCategoryCode==self.options.redPacketCategoryCode){
				this.initRedPacket(redPacketList);
			}else{
				RedPacketModel.qryRedPacketList({
					data: {
						redPacketCategoryCode : self.options.redPacketCategoryCode,        // 00手机充值
						redPacketStatusCode   : self.options.redPacketStatusCode        // 0为未到使用期，1为未使用
					},
					callback: function(response) {
						if(response.object.redPacketList && response.object.redPacketList.length>0){
							App.storage.set("redPacketLists", response.object);
						}
						self.initRedPacket(response.object);
					},
					errorCallback: function(response) {
						$("#redPacketView").hide();
						console.log(response.message);
					}
				});
			}
		},

		// 初始化数据
		initRedPacket: function(object){
			var Tpl = _.template(RedPacketTpl);
			this.redPacketList = object.redPacketList;
			// 显示红包菜单
			this.$el.html(Tpl(_.extend(
				object, {
					textClassName : this.textClassName,
					selectionBox  : this.selectionBox,
					text          : this.text
				}
			)));
			// 循环遍历并选中第一个能用的红包
			for(var i=0; i<this.redPacketList.length; i++){
				if(this.checkStatus(this.redPacketList[i])){
					if(this.redPacketList[i].redPacketStatusCode=="0"){
						this.length++;
					}else{
						this.useFlag = 1;
						this.redPacketId = [this.redPacketList[i].redPacketId.toString()];
						this.listNum = [i];
						this.showRedPacket();
						break;
					}
				}
			}
			if(this.useFlag==0 && this.length!=0){
				$("#noUseNum").text(this.length);
				$("#noPacket").hide();
				$("#notUsePacket").show();
			}
		},

		// 校验status跟limitAmt
		checkStatus: function(redPacketList){
			if(parseFloat(this.amt)>=parseFloat(redPacketList.redPacketLimitAmt)){
				return true;
			}else{
				return false;
			}
		},

		// 单选————显示已选择的红包
		showRedPacket: function(){
			var length = this.listNum.length;
			var num = 0;
			var data = {};
			this.sumAmt = 0;
			for(; num<length; num++){
				data = this.redPacketList[this.listNum[num]];
				this.sumAmt += parseFloat(data.redPacketAmt);
			}
			$("#noPacket").hide();
			if(this.selectionBox == "radio"){    // 单选
				$("#redPacketList").show();
				$("#UsePacket").text(this.sumAmt + "元");
			}else if(this.selectionBox == "checkbox"){    // 多选
				$("#redPacketCheckboxList").show();
				$("#UsePacketNum").text(num);
				$("#UsePacket").text(this.sumAmt);
			}
			if(this.callback){
				this.callback();
			}
		},

		// 红包列表弹窗
		toRedPacketList : function(){
			var self = this;
			var model = {
				redPacketList   : this.redPacketList,
				selectionBox    : this.selectionBox,
				amt             : this.amt,
				title           : this.title,
				listNum         : this.listNum,
				redPacketId     : this.redPacketId
			};
			var view = new redPacketSelect({
				model: new Model(model)
			});
			view.on("submit", function (options) {
				self.listNum = options.listNum;
				self.redPacketId = options.redPacketId;
				if(self.useFlag == 1){
					self.showRedPacket();
				}
				view.close();
			});
			this.redPacketDom.show(view);
		},

		// 获取已选红包id号
		getType: function() {
			App.storage.remove("redPacketLists");
			return this.redPacketId.join("|") || "";
		},

		// 获取已选红包总金额
		getSaleAmt: function(){
			return this.sumAmt || 0;
		},

		// 刷新
		reload: function(options){
			this.initialize(_.extend(this.options, options));
		}
	});
});