define(function(require, exports, module) {

	var baseConfig = require("./base");
	var URLMap = {};

	_.extend(URLMap, {

		//每日盈
		"buyFundStrong"           : "/ibd/rest/fund/buyFundStrong",        //购买
		"fundStrongRedeem"        : "/ibd/rest/fund/fundStrongRedeem",     //赎回
		"qryFundStrongInfo"       : "/ibd/rest/fund/qryFundStrongInfo",    //收益详情
		"qryFundStrongRecord"     : "/ibd/rest/fund/qryFundStrongRecord",  //交易记录
		"qryFundStrongIncome"     : "/ibd/rest/fund/qryFundStrongIncome",  //累计收益
		"qryFundStrongIncomeList" : "/ibd/rest/portal/product/qryFundStrongIncomeList",  //每日盈收益率


		"isFundSign" : "/ibd/rest/fund/isFundSign", //基金签约状态
		"fundSign" : "/ibd/rest/fund/fundSign", //基金签约
		"fundBuy" : "/ibd/rest/fund/fundBuy", //基金购买
		"qryFundPrdList" : "/ibd/rest/fund/qryFundPrdList", //非详情页面进入购买基金
		"fund_riskexam" : "https://ssl.pingan.com/bank/xieyi/zt-jijinqianyuexieyi.html", //基金签约协议
		"goldtreasure" : "https://ssl.pingan.com/bank/xieyi/huangjinzhanghuxieyi.html", //黄金开户
		"toBuyGoldConfirm" : "/ibd/rest/gold/toBuyGoldConfirm", //购买黄金宝
		"appToBuyGoldConfirm" : "/ibd/rest/gold/appToBuyGoldConfirm", //app购买黄金宝
		"checkEmailNo" : "/ibd/rest/account/checkEmailNo", //验证Email是否被使用,非注册使用
		"userVerifyMode" :   "/ibd/rest/paypa/userVerifyMode", //用户激活方式，如借记卡、信用卡、上传身份证
		//账号列表（含子账户）
		"qryAccountList" : "/ibd/rest/wish/qryAccountList",
		"addWishAccount" : "/ibd/rest/wish/addWishAccount",
		"qryWishAccountListByPage" : "/ibd/rest/wish/qryWishAccountListByPage",

		//首页资产动态
		"currentTotalProfit" : "/ibd/rest/invest/currentTotalProfit", //我的资产动态—收益（赚）
		"qryConsumptionOfAsset" : "/ibd/rest/index/qryConsumptionOfAsset", //我的资产动态—最高三笔消费（花）
		"creditCardDueAmt" : "/ibd/rest/index/creditCardDueAmt", //我的资产动态—信用卡消费（欠）

		//我的投资首页
		"dhtBuyedMoneyQry" : "/ibd/rest/invest/dhtBuyedMoneyQry", //定活通已购买全部金额
		"ylProductMoneyQry" : "/ibd/rest/invest/ylProductMoneyQry", //养老保障已购买
		"lcProductMoneyQry" : "/ibd/rest/invest/lcProductMoneyQry", //理财产品已购买
		"paynfProductMoneyQry" : "/ibd/rest/invest/paynfProductMoneyQry", //平安盈南方
		"paydhProductMoneyQry" : "/ibd/rest/invest/paydhProductMoneyQry", //平安盈大华
		"searchAccountDetail" : "/ibd/rest/smartdeposit/searchAccountDetail", //智能定活通交易明细查询

		//证券-第三方存管
		"qrySignListBase" : "/ibd/rest/stock/qrySignListBase", //预指定确认列表及是未签约列表
		"instructionConfirm" : "/ibd/rest/stock/instructionConfirm", //预指定确认
		"qryInstructionInfo" : "/ibd/rest/stock/qryInstructionInfo", //银转证、证转银签约关系列表
		"qrySecuritiMoney" : "/ibd/rest/stock/qrySecuritiMoney", //查询证券账户可用余额
		"qryBankToSecurities" : "/ibd/rest/stock/qryBankToSecurities", //查询银证转账交易记录
		"bankToSecurities" : "/ibd/rest/stock/bankToSecurities", //银转证确认
		"securitiesToBank" : "/ibd/rest/stock/securitiesToBank", //证转银确认

		// 更改预留验证信息
		"saveCustomerMessage" : "/ibd/rest/account/saveCustomerMessage",

		// 获取身份证号码
		"getIdentityCardNumber" : "/ibd/rest/account/getUpCardNo",

		// 获取关联的信用卡列表，以及是否设置自动还款
		"relatingCreditCard" : "/ibd/rest/account/relatingCreditCard",

		// 平安盈协议
		"terms_of_autorepay_service_pinganying" : "https://ssl.pingan.com/bank/xieyi/zt-payhxyk.html",
		"terms_of_service_pinganying" : "https://ssl.pingan.com/bank/xieyi/zt-payxieyi.html",
		"terms_of_service_pinganying_nanfang" : "https://ssl.pingan.com/bank/xieyi/zt-nanfang.html",
		"terms_of_service_pinganying_dahua" : "https://ssl.pingan.com/bank/xieyi/zt-dahua.html",
		"pinganying_limit_searching" : "https://cz.pingan.com/gonggao/list/sj0002.shtml",
		"terms_of_service_creditCardPaymentBinding" : "https://ssl.pingan.com/bank/xieyi/zt-xykzdhk.html",

		//智能理财协议
		"terms_of_smartFinancial" : "https://ssl.pingan.com/bank/xieyi/zt/zhinenglicai.html",

		// 平安盈接口
		"qryPaYingIncomeList" : "/ibd/rest/portal/product/qryPaYingIncomeList", //平安盈收益列表查询
		"queryFundCancelCommision" : "/ibd/rest/financing/queryFundCancelCommision", //当前委托查询
		"entrustCommision4PAY" : "/ibd/rest/financing/entrustCommision4PAYNC", //平安盈委托撤销
		"profitSignUpQryList" : "/ibd/rest/financing/profitSignUpQryList",
		"profitTransferInto" : "/ibd/rest/financing/profitTransferInto",
		"querySevenIncomeRate" : "/ibd/rest/financing/querySevenIncomeRate", //平安盈7日年华化收益率
		"qryProfitUseVol" : "/ibd/rest/financing/qryProfitUseVol", // 平安盈T+1可赎回份额
		"qryPaYingInfo" : "/ibd/rest/portal/product/qryPaYingInfo",

		//无卡取现
		"bookingNocardCash" : "/ibd/rest/paypa/bookingNocardCash", //无卡取现预约
		"qryBookingNocardRecordList" : "/ibd/rest/paypa/qryBookingNocardRecordList", //查询无卡取款列表
		"cancelNocardCash" : "/ibd/rest/paypa/cancelNocardCash", //无卡取款撤销
		"bookingNocardCashBalance" : "/ibd/rest/paypa/bookingNocardCashBalance", //无卡取现预约限额查询

		// 通过信用卡认证身份
		"creditCardActivation" : "/ibd/rest/account/checkIdentityByCreditCardActivation",

		// 转账
		"queryAllBankList" : "/ibd/rest/transfer/qryBankInfo", // 查询所有银行列表
		"queryRealBankList" : "/ibd/rest/transfer/qryRealBankInfo", // 查询所有支持实时转账的银行
		"queryBranchBankList" : "/ibd/rest/transfer/qryBranchbankInfo", // 根据开户行和开户城市查询支行信息
		"isDuplicatedOrder" : "/ibd/rest/transfer/getDuplicateOrder", // 是否重复转账
		"sameBankTransferCheck" : "/ibd/rest/transfer/transferValid2", // 同行转账校验
		"sameBankTransferConfirm" : "/ibd/rest/transfer/transferConfirm", // 同行转账确认提交
		"otherBankTransferCheck" : "/ibd/rest/transfer/crossBankTransferIntegrateCheck2", // 跨行转账校验
		"otherBankTransferConfirm" : "/ibd/rest/transfer/crossBankTransferIntegrate", // 跨行转账确认提交
		"qryTransferLimit" : "/ibd/rest/transfer/qryBusinessLimit", // 查询转账交易限额
		"setTransferLimit" : "/ibd/rest/transfer/transferLimitSettingConfirm", // 转账交易限额设置
		"queryTransferResultOrder" : "/ibd/rest/transfer/transferQueryResult", // 查询转账交易记录
		"queryTransferDetail" : "/ibd/rest/transfer/transQueryDetail", // 查询交易明细
		"qryPayAccList" : "/ibd/rest/gathering/qryPayAccList", // 查询付款方账户列表
		"qryPaPayBankList" : "/ibd/rest/gathering/qryPaPayBankList", // 查询平安付银行列表
		"gatheringCheck" : "/ibd/rest/gathering/gatheringCheck", // 平安付转入校验
		"gatheringConfirm" : "/ibd/rest/gathering/gatheringConfirm", // 平安付转入确认
		"getGatheringSwitch" : "/ibd/rest/gathering/getGatheringSwitch", // 平安付开关
		"qryBankBinInfo" : "/ibd/rest/transfer/queryBankBinInfo", //卡Bin

		// 平安信用卡还款
		"queryCreditCardInfo" : "/ibd/rest/transfer/getCreditCardRepay", // 查询信用卡相关信息
		"creditCardRepayInput" : "/ibd/rest/transfer/creditCardRepayInput", // 信用卡还款校验接口
		"creditCardRepayConfirm" : "/ibd/rest/transfer/creditCardRepayConfirm", // 信用卡还款确认接口

		//定活通
		"qryDhtRateAndInterest" : "/ibd/rest/product/qryDhtRateAndInterest", //靠档计息利率
		"currentToFixedTransferBalance" : "/ibd/rest/deposit/currentToFixedTransferBalance", //获取余额
		"currentToFixedTransferConfirm" : "/ibd/rest/deposit/currentToFixedTransferConfirm", //提交
		"fixedToCurrentTransferList" : "/ibd/rest/deposit/fixedToCurrentTransferList", //定活通列表（定活通详情）
		"fixedToCurrentTransferConfirm" : "/ibd/rest/deposit/fixedToCurrentTransferConfirm", //定活通支取（定转活）
		"fixedToCurrentDetail" : "/ibd/rest/deposit/fixedToCurrentDetail", //定活通支取详情
		"dinghuotongYearsIncome" : "/ibd/rest/portal/deposit/qryDepositInterestRate", //定活通年化收益查询(最高)
		//"dinghuotongYearsIncome"                  : "/mock/dinghuotongYearsIncome.json",//定活通年化收益查询(最高) 挡板数据

		"qryDepositInterestRate" : "/ibd/rest/portal/deposit/qryDepositInterestRate", //定活通年化收益查询(最高)

		"login" : "/ibd/rest/portal/login", //登录
		"index" : "/ibd/rest/work/main", //主页信息
		"timestamp" : "/ibd/rest/portal/timestamp", //系统时间
        "getTime":"/ibd/rest/portal/getTime",//系统时间（毫秒数）
		"vCode" : "/ibd/rest/portal/vcode", //验证码
		"showCheckCode" : "/ibd/rest/portal/login/showCheckCode",
		"logout" : "/ibd/rest/account/securityExit", //安全退出
		"agreementChecking" : "/ibd/rest/portal/login/agreementChecking", //财富E批量强制升级首次登陆重置状态
		"terms_of_service" : "https://ssl.pingan.com/bank/xieyi/zt-zhuche.html", //平安直通银行服务协议
		"terms_of_service_caifu" : "https://ssl.pingan.com/bank/xieyi/zt/shengji.html", //财富e账户升级为平安直通账户业务服务责任条款

		"loginIDVerify" : "/ibd/rest/portal/login/loginIDVerify", //交易密码设置-身份验证
		"loginRersetPassword" : "/ibd/rest/portal/login/loginRersetPassword", //交易密码设置-密码设置

		"upLoadImFile" : "/ibd/rest/account/upLoadImFile",
		"uploadHeadPhotoApp" : "/ibd/rest/account/uploadHeadPhotoApp",
		"uploadIdPhoto" : "https://bankupload.pingan.com.cn/ibp/portal/ibd/upLoadFile.do",

		/*OTP接口*/
		//登录区内
		"sendSmsOTP" : "/ibd/rest/common/otp/send",
		"verifyOTP" : "/ibd/rest/common/otp/verify",
		"sendByPhoneNo" : "/ibd/rest/common/otp/sendByPhoneNo",
		"verifyByPhoneNo" : "/ibd/rest/common/otp/verifyByPhoneNo",
		//登录区外
		"sendSMJson" : "/ibd/rest/portal/otp/send",
		"validateSMJson" : "/ibd/rest/portal/otp/verify",
		"vToken" : "/ibd/rest/portal/otp/send/vToken", //发送otp（需要上送token）
		//注册
		"basicInfo" : "/ibd/rest/portal/register/basicInfo", //填写身份信息
		"accountInfo" : "/ibd/rest/portal/register/accountInfo", //设置账户信息
		"securityInfo" : "/ibd/rest/portal/register/securityInfo", //设置安全信息
		"creditCardAccountInfo" : "/ibd/rest/portal/register/creditCardAccountInfo", //设置账户信息(录入邮箱、手机号)
		"autoMobileLogin" : "/ibd/rest/portal/autoMobileLogin", //免登录接口

		//低门槛开户 2015-06-16
		"registerOfLowThreshold" : "/ibd/rest/portal/register/registerOfLowThreshold", //填写身份信息

		//2.0 激活(财富E迁移情况下，卡已激活，但需要再次验证身份) 2015-06-30
		"againVerify" : "/ibd/rest/activate/againVerify", //判断是否能再次身份验证(0:不需要身份验证   1：需要身份验证)

		"checkMobile" : "/ibd/rest/portal/register/checkMobile", //验证手机号是否被使用
		"checkEmail" : "/ibd/rest/portal/register/checkEmail", //验证Email是否被使用
		"checkToaName" : "/ibd/rest/portal/register/checkToaName", //验证用户名是否可用
		"qryCityInfo" : "/ibd/rest/portal/register/qryCityInfo", //根据省份查找城市
		"qryCityRegInfo" : "/ibd/rest/portal/register/qryCityRegInfo", //注册根据省份查找城市
		"basicInfo4WhiteList" : "/ibd/rest/portal/register/basicInfo4WhiteList", //填写一账通信息
		"securityInfo4WhiteList" : "/ibd/rest/portal/register/securityInfo4WhiteList", //验证otp
		"repayment" : "/ibd/rest/portal/register/repayment", //设置信用卡返款设置
		"jSessoinId" : "/ibd/rest/portal/register/jSessoinId", //用与safari浏览器获取cookie
		"autoLogin" : "/ibd/rest/portal/register/autoLogin",
		"registerIndex" : "/ibd/rest/portal/register/registerIndex", //注册免图形验证码
		"logConReg" : "/ibd/rest/portal/register/logConReg",
		"logConRegWhiteList" : "/ibd/rest/portal/register/logConRegWhiteList",
		"loadUserInfo4mobile" : "/ibd/rest/portal/register/loadUserInfo4mobile",
		"loadOnLineRegisterInfo" : "/ibd/rest/portal/register/loadOnLineRegisterInfo",

		"setEditCreditCardSubmit" : "/ibd/rest/account/setEditCreditCardSubmit", //设置信用卡自动还款
		"cancelSetCreditCard" : "/ibd/rest/account/cancelSetCreditCard", // 取消信用卡自动还款
		"modifyTransferPwd" : "/ibd/rest/account/changePassword", //交易密码修改

		"sampebanktransfer" : "/ibd/rest/transfer/sampetransferconfirm",
		"qryBindAccount" : "/ibd/rest/account/qryBindAccount",
		"autoBindAccount" : "/ibd/rest/account/autoBindAccount",
		"cancelBindAccount" : "/ibd/rest/account/cancelBindAccount",
		"profitTransferExport" : "/ibd/rest/financing/profitTransferExport",
		"profitTransferExportAddOne" : "/ibd/rest/financing/profitTransferExportAddOne",
		"profitHistoricalYieldsQry" : "/ibd/rest/financing/profitHistoricalYieldsQry",
		"toBuyFinanceAccBalance" : "/ibd/rest/finance/toBuyFinanceAccBalance", //获取账户余额
		"toBuyFinanceConfirm" : "/ibd/rest/finance/toBuyFinanceConfirm", //新单购买理财
		"toBuyPensionConfirm" : "/ibd/rest/pension/toBuyPensionConfirm", //新单购买养老保障
		"toBuyPapiaoConfirm" : "/ibd/rest/pension/toBuyPapiaoConfirm", //新单平安票购买
		"qryPensionEntrustList" : "/ibd/rest/finance/qryPensionEntrustList", //查看我的委托（养老保障）
		"riskExam" : "/ibd/rest/financing/riskAbilityTestExam", //风险测评
		"checkFirstRisk":"/ibd/rest/wanlitong/checkRiskAssessWanlitong", //是否首次风险测评
		"buyEntrustRevocation" : "/ibd/rest/finance/financeToRevokeBuyNC", //购买委托撤销
		"pensionEntrustRevocation" : "/ibd/rest/finance/ToRevokeBuyTrustConfirmNC", //养老保障委托撤销
		"pingAnPRevocation" : "/ibd/rest/finance/ToRevokeBuyPapConfirm", //平安票委托撤销
		"financeHistorPapiaoQry" : "/ibd/rest/finance/financeHistorPapiaoQry", //平安票交易明细

		//激活
		"validateUserInfo" : "/ibd/rest/activate/validateUserInfo", //一账通账号绑定判断
		"settingUserInfo" : "/ibd/rest/activate/settingUserInfo", //设置一账通用户信息
		"activateLoginVerify" : "/ibd/rest/activate/activateLoginVerify", //验证一账通

		//可以名单
		"checkAccountSuspicious" : "/ibd/rest/account/checkAccountSuspicious", //可疑名单

		//银联鉴权
		"unionPaySign" : "/ibd/rest/unionPay/sign", //加签
		"successUpdate" : "/ibd/rest/unionPay/successUpdate", //鉴权变更状态
		"qryUseSwitch" : "/ibd/rest/unionPay/qryUseSwitch", //银联鉴权的开关
		"qryBalanceForUnionPay" : "/ibd/rest/unionPay/qryBalanceForUnionPay", //查询资产
		"checkPasswordAndOtp" : "/ibd/rest/unionPay/checkPasswordAndOtp", //验证OTP
		"unionSendBack" : "/ibd/rest/unionPay/unionSendBack", //银联鉴权新接口
		"checkPassword" : "/ibd/rest/unionPay/checkPassword", //验密接口

		//养老保障
		"financeListPersonQuery" : "/ibd/rest/finance/financeListPersonQuery", //养老保障我的持仓
		"pensionTranAmountQry" : "/ibd/rest/pension/tranAmountQry",

		// 产品推荐
		"qryExclusiveFinanceList" : "/ibd/rest/financing/qryFinanceExclusiveList", // 查询专属理财产品
		"qryExclusivePensionList" : "/ibd/rest/financing/qryFinancePensionExclusiveList", // 查询专属养老保障产品
		"riskAbilityTestQry" : "/ibd/rest/financing/riskAbilityTestQry", // 查询个人风险评估信息
		"qryFinanceRecommendList" : "/ibd/rest/financing/qryFinanceRecommendList", // 查询推荐理财和养老保障产品列表
		"qryProductRiskBook" : "/ibd/rest/financing/toBuyQryConfirmBook", // 查询确认函标志及信息
		"confirmProductRiskBook" : "/ibd/rest/financing/toBuyMakeConfirmBook", // 确认风险确认函
		"qryProductsByCMS" : "https://caifu.pingan.com/ZT/commendatoryProductList.js", // 取CMS上配置的推荐理财产品

		//理财产品
		"tranAmountQry" : "/ibd/rest/finance/tranAmountQry", //待清算资金
		"qryBuyEntrustList" : "/ibd/rest/finance/qryBuyEntrustList", //我的委托详情
		"myFinanceListQuery" : "/ibd/rest/finance/myFinanceListQuery", //持有详情（持仓）
		//（日添利，滚动，净值三种产品）理财赎回提交
		"financialRedemption" : "/ibd/rest/finance/financeRedeem",
		//理财赎回委托撤销
		"financialEntrustRevocation" : "/ibd/rest/finance/revokeRedeemConsignationApp",

		//投资记录交易明细
		"profitTransferQry" : "/ibd/rest/financing/profitTransferQry",
		"financeHistoryTradeQuery" : "/ibd/rest/finance/financeHistoryTradeQuery",
		"precontractFixedCurrentTransferResultList" : "/ibd/rest/deposit/precontractFixedCurrentTransferResultList",
		"financeHistorPension" : "/ibd/rest/finance/financeHistorPension",

		//身份验证OTP
		"veryifyByOtp" : "/ibd/rest/account/otpVerify",
		"veryifyByDebitCard" : "/ibd/rest/account/checkIdentityByDebitCardActivation",
		"veryifyGetUserType" : "/ibd/rest/account/getUserTypeGrade",

		// 重置交易密码
		"otpVerifyEmail" : "/ibd/rest/account/otpVerifyEmail",
		"rersetPassword" : "/ibd/rest/account/rersetPassword",
		"isExistHandPwd" : "/ibd/rest/account/isExistHandPwd", //判断是否设置过手势密码
		"delHandPassWord" : "/ibd/rest/account/delHandPassWord", //删除手势密码

		//个人中心
		"editEmailNo" : "/ibd/rest/account/editEmailNo", //修改email
		"mailVerificationSend" : "/ibd/rest/account/mailVerificationSend", //验证email,发送邮件
		"mailVerification" : "/ibd/rest/portal/account/mailVerification", //验证email,验证身份证后4位
		//修改手机号码
		"modifyMobCheckPassword" : "/ibd/rest/account/modifyMobCheckPassword",
		"modifyMobCheckNewOtp" : "/ibd/rest/account/modifyMobCheckNewOtp",
		// 重置手机号码
		"resetMobCheckEmailCode" : "/ibd/rest/account/resetMobile/checkEmailCode",
		"resetMobSubmit" : "/ibd/rest/account/resetMobile/submit",
		"checkUniqeMobile" : "/ibd/rest/account/checkUniqeMobile", // 验证手机号是否可用
		//个人中心—功能管理
		"functionManage" : "/ibd/rest/account/functionManage",

		//个人中心—安全设置信息
		"settingSecurity" : "/ibd/rest/account/settingSecurity",
		//个人中心个人信息
		"qryAccountBaseInfo" : "/ibd/rest/account/qryAccountBaseInfo",
		"updateAccountGXInfo" : "/ibd/rest/account/updateAccountGXInfo",
		"updateAccountContactInfo" : "/ibd/rest/account/updateAccountContactInfo",
		//上传头像
		"getImagePath" : "/ibd/rest/account/getImageFilepathHeadPhoto",
		"uploadPhoto" : "/ibd/rest/account/uploadHeadPhoto",

		//万里通积分
		"getPointsLeft" : "/ibd/rest/account/getPointsLeft",
		//万里通送积分开关(登录区内)
		"getWLTCheckRule" : "/ibd/rest/wanlitong/checkRule",
		//万里通送积分开关（登录区外）
		"checkRuleOutside"  : "/ibd/rest/portal/wanlitong/checkRuleRigist",
		//万里通查询
		"qryWanlitong" : "/ibd/rest/wanlitong/checkWanlitongDetail",
		//首次分享万里通送积分
		"wanlitongShare" : "/ibd/rest/wanlitong/wanlitongShare",

		//精彩消费
		"myConsumeEdit" : "/ibd/rest/worderful/myConsume/myConsumeEdit", //编辑精彩消费
		"uploadPhotoConfirm" : "/ibd/rest/account/confirmupload", //上传头像确认
		"cancelUpload" : "/ibd/rest/account/cancelupload", //取消上传
		"queryMyConsumeList" : "/ibd/rest/worderful/myConsume/myConsumeQueryApp", //精彩消费（按日期分组后的数据）
		"consumeList" : "/ibd/rest/worderful/myConsume/myConsumeQuery", //精彩消费
		"consumeType" : "/ibd/rest/worderful/myConsume/consumeTypeQuery", //消费类型
		"qryConsumeScale" : "/ibd/rest/consume/qryConsumeScale", // 消费分类统计结果
		"qryConsumeScaleDetail" : "/ibd/rest/consume/qryConsumeScaleDetail", // 消费分类统计结果
		"consumeImageQuery" : "/ibd/rest/worderful/myConsume/consumeImageQuery",
		"costSaving" : "/ibd/rest/transfer/SaveFeeSumInfo", //首页节省接口
		"qryAptitudeReckoning" : "/ibd/rest/consume/qryAptitudeReckoning", //消费类型前5名,
		"editStory" : "/ibd/rest/consume/editStory", //消费编辑保存
		"qryMyConsumeInfo" : "/ibd/rest/worderful/myConsume/qryMyConsumeInfo", //查看消费详情
		"creditCardQuery" : "/ibd/rest/worderful/myConsume/creditCardQuery",

		//橙子娱乐--彩票游戏  (发现模块)
		"terms_of_search_orangeGame" : "http://gameapp.wanlitong.com/?act=game_collection&track_u=czyh",
		"terms_of_search_insure_product" : "http://b.pingan.com/cz/bxcp/index.shtml", //生产环境
		"terms_of_search_insure_test" : "http://wap-stg.pingan.com.cn:8010/c3/huodong/app/bank/index.shtml", //测试环境

		//基金定投管理
		"qryFundFix" : "/ibd/rest/fund/fundFixQry", //基金定投管理
		"qryFundFixModify" : "/ibd/rest/fund/modifyFundFix", //基金修改
		"qryFundFixOpera" : "/ibd/rest/fund/operationFundFix", //基金终止、暂停、恢复

		//我的许愿
		"qryWishInfoList" : "/ibd/rest/wish/qryWishAndTransferList",
		"cancelWishAccount" : "/ibd/rest/wish/cancelWishAccount",
		"drawWishAccount" : "/ibd/rest/wish/drawWishAccount",

		// 数据采集： 用户与注册页文本域的交互数据
		"focusAndBlurMonitoring" : "/ibd/rest/portal/register/focusAndBlurMonitoring",

		// 数据采集： 用户登陆数据
		"userLoginMessage" : "/ibd/rest/portal/monitor/userLoginMessage",
		//任意门加密
		"encryption" : "/ibd/rest/account/encryption",

		// 生成sso登录态
		"anydoorSSOLogin" : "/ibd/rest/account/ssoLogin",
		// 生成sso登录态（新）
		"mamcSsoLogin" : "/ibd/rest/account/mamcSsoLogin",

		// 查询平安盈万份收益(登陆区外)
		"qryProfitMillionIncome" : "/ibd/rest/portal/financing/qryProfitMillionIncome",

		//----------------------黄金------------------------------
		//黄金账户开户
		"openGoldAcct" : "/ibd/rest/goldacct/openGoldAcct",
		//黄金账户销户
		"closeGoldAcct" : "/ibd/rest/goldacct/closeGoldAcct",
		//黄金账户余额信息
		"goldAcctQryAsset" : "/ibd/rest/goldacct/goldAcctQryAsset",
		//黄金凭证密码校验，查询余额
		"goldVoucherCheckQryInfo" : "/ibd/rest/goldacct/goldVoucherCheckQryInfo",
		//黄金卡充值优惠比例查询
		"goldVoucherQryPrepaidDiscount" : "/ibd/rest/goldacct/goldVoucherQryPrepaidDiscount",
		//黄金凭证转入黄金账户
		"goldVoucherCertTransferAcct" : "/ibd/rest/goldacct/goldVoucherCertTransferAcct",
		// 黄金账户开户信息查询
		"qryGoldAcctInfo" : "/ibd/rest/goldacct/qryGoldAcctInfo",
		// 黄金单价查询
		"goldAcctQryGoldPrice" : "/ibd/rest/goldacct/goldAcctQryGoldPrice",
		// 黄金产品认购赎回试算
		"goldAcctTestBuyOrRedeemGold" : "/ibd/rest/goldacct/goldAcctTestBuyOrRedeemGold",
		// 黄金产品认购赎回
		"goldAcctBuyOrRedeemGold" : "/ibd/rest/goldacct/goldAcctBuyOrRedeemGold",
		// 黄金交易明细
		"qryGoldAcctDetail" : "/ibd/rest/goldacct/qryGoldAcctDetail",
		//
		"terms_of_service_gold" : "https://ssl.pingan.com/bank/xieyi/huangjinzhanghuxieyi.html",
		//-------------------------------黄金宝-----------------------------------
		//黄金宝赎回委托撤销
		"toRevokeEntrustGold" : "/ibd/rest/finance/toRevokeEntrustGoldConfirm",
		//黄金宝交易记录
		"trustGoldTreasureInfo" : "/ibd/rest/finance/financeHistorGoldFinanceQry",
		//黄金宝预约赎回提交
		"goldTreasureRedempSubmit" : "/ibd/rest/finance/goldFinanceRedeem",
		//黄金宝追加购买请求details
		"goldAddPurchaseDetails" : "/ibd/rest/gold/goldDetail",
		//--------活动推荐--------------
		"activityDetail" : "/ibd/rest/activity/activityDetail", //活动详情+推荐码
		"qryActivityList" : "/ibd/rest/activity/qryActivityList", //推荐记录查询
		"whiteList" : "/ibd/rest/activity/whiteList", //白名单判断

		//智能定活通功能接口------------------------------------------------------
		"smartDepositProtocolManage" : "/ibd/rest/smartdeposit/smartDepositProtocolManage", //智能定活通签约、解约
		"queryAgreement" : "/ibd/rest/smartdeposit/queryAgreement", // 智能定活通签约查询
		"qrySmartDepositInfo" : "/ibd/rest/smartdeposit/qrySmartDepositInfo", // 智能定活通明细查询
		"qrySmartDepositBalance" : "/ibd/rest/smartdeposit/qrySmartDepositBalance", //智能定活通余额查询
		"qryGatheringTransferRecord" : "/ibd/rest/gathering/qryGatheringTransferRecord",

		/*我的资产,安全登录opt验证开关刘俊*/
		"loginedAccountInfo" : "/ibd/rest/capital/qryMyCapitalTotal",
		"saveOtpSwitch" : "/ibd/rest/account/saveOtpSwitch",
		//挂失，检查卡状态
		"getCardLossStatus" : "/ibd/rest/common/queryCardLossStatus",
		//智能理财查询
		"qrySmartFinancialStatus" : "/ibd/rest/noopsycheFinance/query",
		//智能理财签约
		"addSmartFinancial" : "/ibd/rest/noopsycheFinance/add",
		//智能理财修改协议
		"editSmartFinancial" : "/ibd/rest/noopsycheFinance/edit",
		//智能理财协议状态修改
		"editStatusSmartFinancial" : "/ibd/rest/noopsycheFinance/editStatus",
		//平安票持有产品
		"qryPapRemainList" : "/ibd/rest/finance/financeListPapQuery",
		//平安票委托产品
		"qryPapEntrustList" : "/ibd/rest/finance/qryPapEntrustList",
		//智能理财未确定产品查询
		"qryUnsurePrdList" : "/ibd/rest/noopsycheFinance/checkIsEntrust",
		//委托撤销
		"cancelBuySmartFinancial" : "/ibd/rest/noopsycheFinance/cancelBuy",
		//委托购买
		"confirmBuySmartFinancial" : "/ibd/rest/noopsycheFinance/confirmBuy",
		//执行记录
		"smartFinancialExecuteRecord" : "/ibd/rest/noopsycheFinance/qryJobBuyList",
		//基金委托撤销
		"fundEntrustRevoke" : "/ibd/rest/financing/entrustCommision4PAYNC",
		//分红方式设置
		"bonusTypeSettings" : "/ibd/rest/fund/fundChangeMelonCuttingStyle",
		//查询基金详情
		"queryFundDetails" : "/ibd/rest/fund/fundDetail",
		//查询基金委托页费率
		"entrustFundRateDetails" : "/ibd/rest/fund/qryRate",
		//基金赎回
		"fundRedeem" : "/ibd/rest/fund/fundRedeem",
		//基金交易明细查询
		"fundTradeDetailsInfo" : "/ibd/rest/fund/qryFundTransInfo",
		//基金定投
		"fundFix" : "/ibd/rest/fund/fundFix",
		//基金搜索开关
		"searchFundSwitch"	: "/ibd/rest/fund/searchFundSwitch",
		//基金定投协议地址
		"fixedProtocolUrl" : "https://ssl.pingan.com/bank/xieyi/zt/jijindtxy.html",

		//特色基金 --start--
		"fundItemFund" : "/ibd/rest/fund/fundItemFund",     //特色基金列表(登录区内)
		"fundItemFundOut" : "/ibd/rest/portal/fund/fundItemFund ",     //特色基金列表(登录区外)
		"qryRiskAbilityTest" : "/ibd/rest/fund/qryRiskAbilityTest",    //查询产品的风险等级与用户的风险等级是否匹配可购买
		"fundMaxProfit" : "/ibd/rest/portal/fund/fundMaxProfit",   //基金首页
		//特色基金 --end--

		//梦想 ------------------------------------------------------
		//梦想状态查询
		"qryDreamState" : "/ibd/rest/dream/checkFirstOpenDream",
		//查询梦想墙
		"qryDreamWall" : "/ibd/rest/dream/searchAllDreams",
		//查询我的梦想
		"qryMyDream" : "/ibd/rest/dream/searchMyDreams",
		//添加梦想
		"addNewDream" : "/ibd/rest/portal/uploadpic/addNewDream",
		//加签
		"addMsg" : "/ibd/rest/dream/accountDetailEncrypt",
		//梦想感言
		"dreamSpeech" : "/ibd/rest/portal/uploadpic/manageMyDream",
		//扼杀梦想
		"killDream" : "/ibd/rest/dream/strangleMyDream",
		//点赞|举报
		"praiseOrReport" : "/ibd/rest/dream/praiseAndReportOthersDream",
		//是否被禁言
		"isOrNotForbidden" : "/ibd/rest/dream/isProhibitIssuanceDream",
		//梦想频次控制
		"dreamFrequencyControl" : "/ibd/rest/dream/isFrequencyControlDream",
		//梦想立即提款
		"drawMoneyMyDream" : "/ibd/rest/dream/drawMoneyMyDream",

		//橙子2.0 主首页 产品首页 ------------------------------------------------------
		"qryFistPageProductList" : "/ibd/rest/portal/product/qryFistPageProductList", // 主首页推荐产品列表
		"qryYesterdayIncome" : "/ibd/rest/capital/qryYesterdayIncome", // 主首页我的昨日收益信息

		//搜索基金
		"searchFund" : "/ibd/rest/fund/searchFund",
		//精选基金列表查询
		"qryFundPrdInfo" : "/ibd/rest/portal/qryFundPrdInfo",
		//基金收益列表查询
		"qryFundProfitList" : "/ibd/rest/portal/qryFundProfitList",
		//基金折扣率查询
		"qryFundDiscountRate" : "/ibd/rest/portal/qryFundDiscountRate",

		//token
		"defineRepeatSubmit" : "/ibd/rest/portal/account/defineRepeatSubmit",

		//本行转入确认
		"sameBankEnterConfirm" : "/ibd/rest/transfer/transferConfirm3",
		//本贷本绑定借记卡是否符合转出条件1
		"sameBankEnterCheckOne" : "/ibd/rest/gathering/gatheringSameBankVerify",
		//本贷本绑定借记卡是否符合转出条件2
		"sameBankEnterCheckTwo" : "/ibd/rest/transfer/transferValid3",
		//本贷本查询转出方账号
		"qryPayAccListOfOwn" : "/ibd/rest/gathering/qrySameBankPayAccList",
		//本贷本转出方开户行
		"qryPaPayBankListOfOwn" : "/ibd/rest/gathering/qrySameBankPaPayBankList",
		//本贷本转入获取余额
		"qryBalanceOfOwn" : "/ibd/rest/gathering/sameBankTransInBalance",

		//-------------------------降低门槛----登录接口-------------
		"toaLogin" : "/ibd/rest/portal/toaLogin", //一账通登录
		"mobileLogin" : "/ibd/rest/portal/mobileLogin", //手机登录

		//橙子2.0 开户 激活 ------------------------------------------------------
		"qryIsCanFaceActive" : "/ibd/rest/account/qryIsCanFaceActive", //用户是否能通过人脸识别激活账户
		"faceCompareByPhoto" : "/ibd/rest/account/faceCompareByPhoto", //人脸相似度判断
		"upLoadFaceImFile" : "/ibd/rest/account/upLoadFaceImFile",

		//校验登入密码 ------------------------------------------------------
		"checkToaPwd" : "/ibd/rest/account/checkToaPwd",

		//新绑借记卡信息------------------------------------------------
		"validateDebitCard" : "/ibd/rest/account/validateDebitCard", //新绑借记卡信息
		"bindSameBankCard"  : "/ibd/rest/account/bindSameBankCard",  //新绑本行借记卡
		"cancelBindCard"    : "/ibd/rest/account/cancelBindCard",    //解绑

		//--------------------银网通-----------------
		"qryAccList"           : "/ibd/rest/transferIn/qryAccList",           //银网通是否支持该行卡
		"checkTransferIn"      : "/ibd/rest/transferIn/checkTransferIn",      //银网通转入校验
		"confirmTransferIn"    : "/ibd/rest/transferIn/confirmTransferIn",    //银网通转入确认
		"dealResultTransferIn" : "/ibd/rest/transferIn/dealResultTransferIn", //银网通转入结果查询
		"dealRecordTransferIn" : "/ibd/rest/transferIn/dealRecordTransferIn", //银网通转入记录


		// 2015-11-小票 ------------------------------------------------------
		"qryBillList" : "/ibd/rest/earnings/qryBillList", //列表
		"qryBillHistoryTrade" : "/ibd/rest/earnings/billHistoryTradeQuery", //交易记录
		"buyBillConfirm" : "/ibd/rest/earnings/toBuyBillConfirm", //购买
		"signBill" : "/ibd/rest/earnings/signBill", //签约
		"qrySignBill" : "/ibd/rest/earnings/qrySignBill", //签约查询

		// 2015-12-05日添利，净值产品收益 ------------------------------------------------------
		"qryFinanceHistoryYield" : "/ibd/rest/portal/finance/qryFinanceHistoryYield", //签约查询
		// 2015-12-18 新人脸识别 ------------------------------------------------------
		"timeStampEncrypt": "/ibd/rest/account/timeStampEncrypt", //加签
		"facePhotoUploadToServer": "/ibd/rest/portal/uploadpic/facePhotoUploadToServer", //上传人脸图片
		"faceCompareByPhotoGetResemblance": "/ibd/rest/account/faceCompareByPhotoGetResemblance", //获得相似度
		//保证金-------------------------------------------------------------
		"qryMarginsPendingOrderCount" : "/ibd/rest/margins/qryMarginsPendingOrderCount",
		"qryMarginsOrderList" : "/ibd/rest/margins/qryMarginsOrderList",
		"qryMarginsCommercialList" : "/ibd/rest/margins/qryMarginsCommercialList",
		"qryMarginsOrderDetails" : "/ibd/rest/margins/qryMarginsOrderDetails",
		"confirmMarginsOrder" : "/ibd/rest/margins/confirmMarginsOrder",
		"createMarginsOrder" : "/ibd/rest/margins/createMarginsOrder",

		//精选活动--------------------------------------------------------------
		"passwordOperate" : "/ibd/rest/lottery/passwordOperate",

		//平安彩票、平安娱乐-------------------------------------------------------------
		"passwordLottery" : "/ibd/rest/lottery/logon/passwordOperate",

		"toaLoginAuth" : "https://passport.24cp.com/pass-info/oauth2/toaLoginAuth.shtml",
		//话费充值----------------------------------------------------
		"qryRechargeRate" : "/ibd/rest/recharge/qryRechargeRate",//折扣率查询
		"recharge" : "/ibd/rest/recharge/recharge",//话费充值
		"qryRechargeList" : "/ibd/rest/recharge/qryRechargeList",//话费充值记录查询

		"shareDream" : "/ibd/rest/dream/shareDream",		//梦想分享
		"creditCard_apply" : "https://c.pingan.com/apply/mobile/apply/index.html?scc=230000983&ccp=1a2a3a4a5a8a11a12a13&showt=1",
		"byYouCard_apply" : "https://c.pingan.com/apply/mobile/apply/index.html?scc=230000980&ccp=9&showt=1",

		//抢购专区
		"qryPanicBuyList" : "/ibd/rest/product/qryRuPurchaseProductList",   //抢购产品列表查询(登录区内)
		"qryPanicBuyListOutside" : "/ibd/rest/portal/product/qryPortalRuPurchaseProductList",   //抢购产品列表查询(登录区外)
		"qryIsRuPurchaseOutside"  : "/ibd/rest/portal/product/qryPortalIsRuPurchase", //抢购开关(登录区外)
		"qryIsRuPurchase" : "/ibd/rest/product/qryIsRuPurchase",  //抢购开关(登录区内)
		"qryOrderForBuying" : "/ibd/rest/product/orderForBuyingInfo",  //购买抢购产品
		"qryPanicBuy" : "/ibd/rest/product/qryOrderForBuyingInfo",   //查询抢购结果

		//夺宝奇兵（新手专享）
		"indianaJones"  : "/ibd/rest/novice/collectTreasure",		//夺宝奇兵宝箱列表
		"openChest"     : "/ibd/rest/novice/openChest",				//宝箱打开
		"chestSwitch"   : "/ibd/rest/novice/chestSwitch",			//夺宝奇兵入口开关(登录区内)
		"outsidelogin"  : "/ibd/rest/portal/novice/outsidelogin",	//夺宝奇兵入口开关(登录区外)
		"searchListbox" : "/ibd/rest/novice/searchListbox",			//夺宝奇兵宝箱详情列表

		//理财成就（ex_huangzit 2016-05-05）
		"medalDetailHis" : "/ibd/rest/wanlitong/checkMedalDetail", //理财成就-千元户：万元户月份
		"financialAchievement" : "/ibd/rest/wanlitong/checkMedalAndWanlitong", //理财成就-勋章
		"medalAndWanlitongSwitch" : "/ibd/rest/portal/wanlitong/MedalAndWanlitongSwitch", //理财成就-开关


		//橙易贷
		"checkApplyLoan"     :"/ibd/rest/loan/checkApplyLoan",//橙易贷校验
		"searchInfo"         : "/ibd/rest/loan/searchInfo", //查询个人信息
		"submitApplyLoan"    :"/ibd/rest/loan/submitApplyLoan",  //提交贷款申请
		"borrowMoney"        :"/ibd/rest/loan/borrowMoney", //提款
		"snedLoanOTPInfo"    :"/ibd/rest/loan/snedLoanOTPInfo", //提交申请提款金额
		"loansDisplaySwitch" : "/ibd/rest/loan/menuPermissions",	//橙易贷入口显示
		"repaymentList"      : "/ibd/rest/loan/repaymentList",		//橙易贷贷款列表
		"loanDetails"        : "/ibd/rest/loan/loanDetails",		//橙易贷单笔贷款明细
		"repaymentRequest"   : "/ibd/rest/loan/repaymentRequest",	//橙易贷还款

		//红包
		"qryRedPacketList"       : "/ibd/rest/redPacket/qryRedPacketList",  //查询红包列表不分页
		"qryRedPacketListByPage" : "/ibd/rest/redPacket/qryRedPacketListByPage", //查询红包列表,分页

		//一账通
        "signBankToa"       		: "/ibd/rest/index/signBankToa",	//橙子请求登录一账通加密串
        "bankToaMaintainLogin"		: "/ibd/rest/index/bankToaMaintainLogin"	//保持橙子登录态
	});

	if (IS_RUN_IN_PRODUCTION_ENVIRONMENT == false) {
		_.extend(URLMap, {
			uploadIdPhoto : "https://ibank-ibp-wedmzupluad-stg.dmzstg.pingan.com.cn/ibp/portal/ibd/upLoadFile.do",
			toaLoginAuth : "http://passport2.stg2.24cp.com/pass-info/oauth2/toaLoginAuth.shtml"
		});
	}

	function prefixUrlRoot(url) {
		// If a colon is in the URL, it indicates a protocol is used,
		// do not add the url prefix
		if (/:\/\//.test(url))
			return url;

		return baseConfig.url_root + url;
	}


	exports.get = function(name) {
		return prefixUrlRoot(URLMap[name] || name);
	};

});
