define(function(require, exports, module){

    var AutoLoader = require("./autoLoader");
    var CustomStorage = require("./storage");
    var LocalStorage  = require("./locStorage");

    var Application = module.exports = Marionette.Application.extend({

        constructor: function(){
            this.loader = new AutoLoader();
            this.storage = new CustomStorage();
            this.locStorage = new LocalStorage();
            this.history = Backbone.history;
            this.browseList = [];

            this.listenTo(this.history, "route", function(){
                var fragment = this.history.fragment;
                if(this.browseList[0] == fragment) return;
                this.browseList.unshift(this.history.fragment);
            });

            Marionette.Application.apply(this, arguments);
        },

        back: function(pos){
            if(pos == null) pos = 1;
            if(pos >= 1 && pos < this.browseList.length){
                var url = this.browseList[pos];
                this.browseList = this.browseList.slice(pos + 1);
                this.navigate(url, true);
            }
        },

        navigate: function(fragment, options){
            return this.history.navigate(fragment, options);
        },

        reload: function(){
            this.history.loadUrl(this.history.fragment);
        }
    });
});