define(function(require, exports, module){

    exports.requestLoginTicket = function(){
        var self = this;
        var deferred = $.Deferred();

        if(!ANYDOOR_ENABLED || !ENABLE_PHONEGAP){
            return deferred.resolve({}).promise();
        }

        utils.native.getDeviceInfo().always(function(deviceInfo){

            utils.native.versionInformation(function(data){
                var version = data.version.replace(/\./g,"") * 1;
                if((IS_RUN_ON_ANDROID && version<204) || (IS_RUN_ON_IDEVICE && version<204)){

                    App.request("mamcSsoLogin", { data: deviceInfo,cancelWhenRouting:false }).complete(function(error, resp){
                        if(!resp) resp = {};
                        if(!resp.object) resp.object = {};
                        if(!resp.object.userPrincipal) resp.object.userPrincipal = {};

                        resp = resp.object.userPrincipal;

                        var data = {};
                        data.mamc_sso_once_token = resp.ssoTicket || "";
                        data.userId = resp.toaClientNo || "";
                        data.toaPatyNum = resp.toaPartyNo || "";
                        data.toaClientNo = resp.toaClientNo || "";
                        data.mobileNo = resp.toaMobileNo || "";
                        data.userType = "";
                        data.sessionSecret = resp.sessionSecret || "";
                        data.mamcId = resp.mamcId || "";
                        data.autoOpenDoor = App.storage.get("login/open-anydoor-plugin-after-login");
                        self.setLoginInfo(data);
                        deferred.resolve(data);
                    });
                }else{
                    App.request("encryption", { data: deviceInfo,cancelWhenRouting:false }).complete(function(error, response){
                        if(error) return;

                        var data = {
                            access_k : response.object.access_k,
                            access_sign : response.object.access_sign,
                            access_t : response.object.access_t
                        }

                        var url = response.object.url+"/oauth2/v2/user/ssologin?v=2.7.0&appName=PA01300000000_01_CZYH&access_type=3";
                        App.request(url,{data: data,cancelWhenRouting:false}).complete(function(error, resp){
                            resp || (resp = {});
                            resp.aes_key = response.object.aes_key;
                            self.setLoginInfo(resp);
                            deferred.resolve(resp);
                        });

                    });
                }

            });


        });

        return deferred.promise();
    };

    exports.setLoginInfo = function(ticket){
        if(ANYDOOR_ENABLED && ENABLE_PHONEGAP){
            utils.native.anydoor.setLoginInfo(ticket);
        }
    };

    exports.bankToaLogin = function () {
        var deferred = $.Deferred();
        var url = config.urls.get("signBankToa");
        App.request(url, {cancelWhenRouting: false}).complete(function (error, res) {
            if (error) {
                deferred.reject(error);
                return;
            }
            utils.native.setToaFLoginInfo(res);
            deferred.resolve(res);
        });
        return deferred.promise();
    };
});