define(function (require, exports, module) {

    var html_header = require("text!./domHeader.html");

    var Header = module.exports = ItemView.extend({
        template: html_header,

        tagName: "header",

        ui: {
            "title": ".js-header-title",
            "leftButton": ".js-header-left-btn",
            "rightButton": ".js-header-right-btn"
        },

        events: {
            "tap @ui.leftButton": "execLeftButtonHandler",
            "tap @ui.rightButton": "execRightButtonHandler"
        },

        leftButtonHandler: null,
        rightButtonHandler: null,

        defaultHandler: function (content) {
            if (content == "@exit") {
                return function () {
                    App.commands.execute("logout");
                };
            }

            if (content == "@menu") {
                return utils.native.toggleSideMenu;
            }

            if (content == "@back") {
                return function () {
                    App.back();
                };
            }

            if (content == "@share") {
                alert('原生分享!');
                //return utils.native.share;
            }
        },

        execLeftButtonHandler: function () {
            var handle = this.leftButtonHandler;
            if (!handle) handle = this.defaultHandler(this.leftButtonContent);
//            nativeBroadcast.trigger("chooseBank:left:click");
            if ($("#chooseBank_plugIn").length !== 0) {
                /*
                 * 当前是选择银行页面 不跳转 清掉选择银行页面 显示原页面
                 */
                $("#sectionDivOld").show();
                $("#chooseBank_plugIn").hide();
            } else {
                if (handle) handle();
            }
        },

        execRightButtonHandler: function () {
            var handle = this.rightButtonHandler;
            if (!handle) handle = this.defaultHandler(this.rightButtonContent);
            if (handle) handle();
        },

        reset: function (options) {
            this.title = options.title;

            this.leftButtonHandler = options.leftButtonHandler;
            this.leftButtonContent = options.leftButtonContent;

            this.rightButtonContent = options.rightButtonContent;
            this.rightButtonHandler = options.rightButtonHandler;

            this.ui.title.text(options.title || "");

            if (options.leftButtonContent == "@back") {
                this.ui.leftButton.html("<i class='iconA43'>" || "");
            } else if (options.leftButtonContent == "@notify:unlogin") {
                this.ui.leftButton.html("<i class='iconA37'></i>");
            } else if (options.leftButtonContent == "@notify:login") {
                this.ui.leftButton.html("<i class='iconA37'></i><i class='Digital'>3</i>");
            } else if (options.leftButtonContent == "@share") {
                this.ui.leftButton.html("<i class='faiCon faiCon1 m_t10'></i>");
            } else {
                this.ui.leftButton.text(options.leftButtonContent || "");
            }

            if (options.rightButtonContent == "@share") {
                this.ui.rightButton.html("<i class='faiCon faiCon1 m_t10'></i>");
            } else {
                this.ui.rightButton.html(options.rightButtonContent || "");
            }
        }
    });
});