define(function(require, exports, module) {

    var Header = module.exports = ItemView.extend({

        initialize : function() {
            this.listenTo(nativeBroadcast, "click:header:left:button", this.execLeftButtonHandler);
            this.listenTo(nativeBroadcast, "click:header:right:button", this.execRightButtonHandler);
        },

        defaultHandler : function(content) {
            if (content == "@exit") {
                return function() {
                    App.commands.execute("logout");
                };
            }

            if (content == "@menu") {
                return utils.native.toggleSideMenu;
            }

            if (content == "@share") {
                return utils.native.shareUserData;
            }

            if (content == "@back") {
                return function() {
                    App.back();
                };
            }

            if (content == "@messageCenter") {
                return utils.native.anydoor.intoMessageCenter;
            }

            if (content == "@customerCenter") {
                return utils.native.anydoor.intoCustomerService;
            }
        },

        execLeftButtonHandler : function() {
            var handle = this.leftButtonHandler;
            if (!handle)
                handle = this.defaultHandler(this.leftButtonContent);
            if (handle)
                handle();
        },

        execRightButtonHandler : function() {
            var handle = this.rightButtonHandler;
            if (!handle)
                handle = this.defaultHandler(this.rightButtonContent);
            if (handle)
                handle();
        },

        render : function() {/* pass */
        },

        leftButtonHandler : null,
        rightButtonHandler : null,

        reset : function(options) {
            var dfd = $.Deferred();
            
            this.title = options.title;
            this.leftButtonContent = options.leftButtonContent;
            this.leftButtonHandler = options.leftButtonHandler;

            this.rightButtonContent = options.rightButtonContent;
            this.rightButtonHandler = options.rightButtonHandler;
            
            utils.native.versionInformation(_.bind(function(data) {
                if (data.version.replace(/\./g, "") * 1 <= 208) {
                    if (this.rightButtonContent == "@customerCenter") {
                        options.rightButtonContent = "";
                        this.rightButtonContent = "";
                    }
                    
                    if (this.leftButtonContent == "@messageCenter") {
                        options.leftButtonContent = "";
                        this.leftButtonContent = "";
                    }
                }
                dfd.resolve();
            },this));
            
            dfd.done(function(){
                utils.native.resetHeader(options);    
            });
            
        }
    });
}); 