define(function(require,exports,module){

    var asycAccountInfo = exports.asycAccountInfo = function(options){
        if(!options) options = {};

        var settings = { type: "GET" };
        settings.success = options.callback;
        settings.error = options.errorCallback;
        settings.complete = options.complete;
        settings.silent = options.silent;
        settings.cache = options.cache;

        return App.request("currentToFixedTransferBalance", settings);
    };
    
    var qryAccountList = exports.qryAccountList = function(options){
        if(!options) options = {};

        var settings      = { type: "POST" };
        settings.silent   = options.silent || false;
        settings.success  = options.callback;
        settings.error    = options.errorCallback;
        settings.complete = options.complete;

        return App.request("qryAccountList", settings);
        
    };
    
    var querySevenIncomeRate =exports.querySevenIncomeRate = function(){
        var deferred = $.Deferred();
        if(!App.storage.get("sevenIncomeRate")){
            App.request("querySevenIncomeRate").done(function(res){
                App.storage.set("sevenIncomeRate",{
                    "nfSevenIncomeRate" : (parseFloat(res.object.nfSevenIncomeRate)*100).toFixed(2),
                    "dhSevenIncomeRate" : (parseFloat(res.object.dhSevenIncomeRate)*100).toFixed(2)
                });
                deferred.resolve();
            }).fail(function(error){
                deferred.reject();
            });
        }else{
            deferred.resolve();
        }
        
        return deferred; 
    };
    
    var goldAcctQryAsset = exports.goldAcctQryAsset = function(options){
        var options = options || {};
        return App.request("goldAcctQryAsset", {data:options});
    };
    
    //查询绑定卡状态
    var getSecurityInfo = exports.getSecurityInfo = function(){
        var options = options || {};
        return App.request("settingSecurity", {data : options});
    }; 
    
   //万里通积分开关
   var getWLTCheckRule = exports.getWLTCheckRule = function(options){
        if(!options) options = {};

        var settings      = { type: "POST" };
        settings.silent   = options.silent || false;
        settings.data     = options.data;
        settings.success  = options.callback;
        settings.error    = options.errorCallback;
        settings.complete = options.complete;
        
        if(App.storage.get("isUserLoggedIn")){
            return App.request("getWLTCheckRule", settings);
        }else{
            return App.request("checkRuleOutside", settings);
        }
    };
    
    //首次分享万里通送积分
    var wanlitongShare = exports.wanlitongShare = function(options){
        var options = options || {};
        return App.request("wanlitongShare", {data : options});
    };
});
