/**
 * WUWENJUN059
 * 支付方式公共view
 */

define(function(require, exports, module){
	var selPaymentTpl = require("text!./selPayment.html");
	var accountModel = require("mod/common/model/accountModel");
	
    var accountInfoStaView = module.exports = ItemView.extend({
        tagName : 'div',
        className : "dswkb p_10",
        template: _.template(selPaymentTpl),
        
        initialize : function() {
          this.payment = App.storage.remove("selPayBeforeData");  
          var html = this.template();
          this.$el.html(html);
          this.initSel();
        },
        
		events : {
			"tap .selPaymentMethod" : "selPayMethod"
		},
        
        initSel:function(){
            if (this.payment) {
                //添加选择样式
                this.$(".selBuyModeDiv").addClass("selPaymentMethod");
                //移除加载图标
                this.$(".loadcon").remove();
                //选择支付方式
                if (this.payment.payMentMethod == 1) {
                    this.$(".selBuyModeDiv p:last").text(utils.string.numberFormat(this.payment.balance));
                } else if (this.payment.payMentMethod == 2) {
                    this.$(".selBuyModeDiv p:last").text(utils.string.numberFormat(this.payment.dhBalance));
                } else {
                    this.$(".selBuyModeDiv p:last").text(utils.string.numberFormat(this.payment.totalBalance) + "=" + utils.string.numberFormat(this.payment.balance) + "+" + utils.string.numberFormat(this.payment.dhBalance));
                }
                this.$(".selBuyModeDiv").attr("payMethodAttr", this.payment.payMentMethod);
            }else{
                accountModel.asycAccountInfo({"silent":true}).done(_.bind(function(res){
                    //移除加载图标
                    this.$(".loadcon").remove();
                    this.payment = res.object;
                    this.$(".selBuyModeDiv p:last").text(utils.string.numberFormat(res.object.totalBalance) + "=" + utils.string.numberFormat(res.object.balance) + "+" + utils.string.numberFormat(res.object.dhBalance));
                    //添加选择样式
                    this.$(".selBuyModeDiv").addClass("selPaymentMethod");
                },this)).fail(function(err){
                    util.dialog.alert(err.message);
                    this.$(".selBuyModeDiv").removeClass("selPaymentMethod");
                });
            }
        },
        
        //智能选择支付方式
        intelligentSelect : function(num){
            //购买金额
            this.payment.amountInput = num;
            //活期余额
            var balance = parseFloat(this.payment.balance);
            //智能选择支付方式
            var dhBalance = parseFloat(this.payment.dhBalance);
            //平安盈（大华）
            var totalBalance = parseFloat(this.payment.totalBalance);
            //活期余额+平安盈（大华）
            if (num <= balance) {
                this.$(".selBuyModeDiv").attr("payMethodAttr", "1");
                this.$(".selBuyModeDiv p:first").text("活期余额");
                this.$(".selBuyModeDiv p:last").text(utils.string.numberFormat(balance));
            } else {
                this.$(".selBuyModeDiv").attr("payMethodAttr", "3");
                this.$(".selBuyModeDiv p:first").text("活期余额+平安盈(大华)");
                this.$(".selBuyModeDiv p:last").text(utils.string.numberFormat(totalBalance) + "=" + utils.string.numberFormat(balance) + "+" + utils.string.numberFormat(dhBalance));
            }
        },
        
        //选择支付方式
        selPayMethod : function(){
            //购买金额
            if(!this.payment.amountInput){
                this.payment.amountInput = 0;
            }
            //支付方式
            this.payment.payMentMethod = this.$(".selBuyModeDiv").attr("payMethodAttr");
            //返回地址
            this.payment.selPayBackUrl = App.history.fragment;
            App.storage.set("selPayBeforeData",this.payment);
            App.navigate("common/selPaymentMethod/selPaymentMethod", true);
        },
        
        //取支付方式的值
        getPayMethod : function(){
            var payMentMethody = this.$(".selBuyModeDiv").attr("payMethodAttr");
            return payMentMethody;
        },
        
        //取金额数值
        getPayAmt : function(){
            var payAmt = this.$(".selBuyModeDiv p:last").text().replace(/,/g, "").split("=")[0];
            return payAmt;
        }
    });
});