/**
 * @author SDB\ex-liangyin
 */
define(function (require, exports, module) {
    var DhtUnloginView = require("../view/dhtUnlogin");
    var DhtLoginView = require("../view/dhtLogined");
    var model = require("../model/dhtModel");
    var dhtDrawModel = require("../model/dhtDrawModel");
    var DhtDrawView = require("../view/dhtDraw");
    var DhtDrawSuccessView = require("../view/dhtDrawSuccess");
    var DhtDrawErrorView = require("../view/dhtDrawError");

    var Index = module.exports = Controller.extend({
        actions: {
            dhtDraw: "dhtDraw",
            dhtDrawSuccess: "dhtDrawSuccess",
            dhtDrawError: "dhtDrawError"
        },
        //支取
        dhtDraw: function () {
            utils.native.talkingDataTrackEvent("2.0定活通支取第一步");
            App.header.reset({
                title: "支取",
                leftButtonContent: '@back',
                leftButtonHandler: function () {
                    App.navigate("dinghuotong/index/dhtHoldAssets", true);
                }
            });
            App.footer.reset({"visible": false,selectedIndex:0});
            var params = {
                accNum: App.storage.get("UserInfo").attributes.accNumber      //账户号
            };
            dhtDrawModel.qryBalance({
                "data": params,
                "errorCallback": function (resp) {
                    utils.dialog.alert(resp.message);
                },
                "callback": function (resp) {
                    var currentNum = resp.balance;    //可用余额
                    var date = new Model({currentNum: currentNum});
                    App.container.show(new DhtDrawView({model: date}));
                }
            });
        },
        dhtDrawSuccess: function () {
            utils.native.talkingDataTrackEvent("2.0-产品-定活通购买验密");
            App.header.reset({
                title: "支取结果",
                leftButtonContent: '@back',
               leftButtonHandler: function () {
                   App.navigate("dinghuotong/index/dhtHoldAssets", true);
               }
            });
            App.footer.reset({"visible": false});
            /*
             *  从接口获取 当前可支取金额+已获得利息,存入 currentNum
             *  从接口获取 当前可支取金额,存入 currentDrawNum
             *  从接口获取 当前已获得利息，存入 currentInterestNum
             * */
            var drawData = App.storage.get("drawData");
            App.storage.remove("drawData");
            var currentDrawNum = parseFloat(drawData.transferAmount);
            var currentInterestNum = parseFloat(drawData.creditInterest);
            var date = new Model({
                currentNum: currentDrawNum + currentInterestNum,
                currentDrawNum: currentDrawNum,
                currentInterestNum: currentInterestNum
            });
            App.container.show(new DhtDrawSuccessView({model: date}));
        },
        dhtDrawError: function () {
            App.header.reset({
                title: "支付结果",
                leftButtonContent: '@back',
               leftButtonHandler: function () {
                   App.navigate("dinghuotong/index/dhtHoldAssets", true);
               }
            });
            App.footer.reset({"visible": false});
            var errorMsg = App.storage.get("errorMsg");
            App.storage.remove("errorMsg");
            var date = new Model({errorMsg: errorMsg});
            App.container.show(new DhtDrawErrorView({model: date}));
        }
    });
});
