/**
 * @author SDB\ex-liangyin
 */
define(function (require, exports, module) {
	var accountInfoStatus       = require("../../common/accountInfoStatus/accountInfoStatus");
	var DhtUnloginView          = require("../view/dhtUnlogin");
	var DhtLoginView            = require("../view/dhtLogined");
	var model                   = require("../model/dhtModel");
	var DhtHoldAssetsView       = require("../view/dhtHoldAssets");
	var DhtDepositView          = require("../view/dhtDeposit");
	var DhtDepositWaySelectView = require("../view/dhtDepositWaySelect");
	var DhtDepositedView        = require("../view/dhtDeposited");
	var DhtDepositeFailureView  = require("../view/dhtDepositFailure");

	var Index = module.exports = Controller.extend({
		actions: {
			login               : "login",    //定活通已登入界面
			dhtDeposit          : "dhtDeposit", //定活通存入界面
			dhtDepositWaySelect : "dhtDepositWaySelect",//定活通选择支付方式页面，暂时不做
			// dhtDeposited     :"dhtDeposited",//定活通选择支付方式后的页面，暂时不做
			dhtDepositSuccess   : "_dhtDepositSuccess",//存入成功的页面
			dhtDepositFailure   : "_dhtDepositFailure",
			dhtHoldAssets       : "dhtHoldAssets"// 持有资产的页面
		},

		/**
		 * 定活通已登入
		 */
		login: function () {
			utils.native.talkingDataTrackEvent("2.0定活通详情");
			App.header.reset({
				title: "产品详情",
				leftButtonContent: '@back',
				leftButtonHandler: function(){
					tempJump = App.storage.get('dinghuotong/unlog/index').get("fromPage");
					if(tempJump=="product"){
						App.navigate("products/index/index", true);
					}else{
						if(tempJump=="myProperty"){
							App.navigate("myProperty/myProperty/index", true);
						}else{
							App.navigate("products/index/index", true);
						}
					}
				},
				rightButtonContent : "@share",
				rightButtonHandler : function(){
					var intRate = this.$("#highestRate").html() || App.storage.get('dinghuotong/unlog/index').get("intRate");
					var url     = IS_RUN_IN_PRODUCTION_ENVIRONMENT == false ? "https://ibankibpu1.pingan.com.cn/ibd/page/web_for_h5/share_h5/index.html?" : "https://cz.pingan.com.cn/ibd/page/web_for_h5/share_h5/index.html?";
					url         = url+"type=5&code=5&name=定活通&num="+intRate+"&t="+new Date().getTime();
					//缓存分享信息
                    App.storage.set("shareWLTData",{"share_module":config.values.shareProducts,"share_url":encodeURIComponent(url)});
					utils.native.shareProduct({"title":"定活通","message":"随存随取","url":url});
				}
			});
			model.dhtBuyedMoneyQry({
				"param": "",
				"errorCallback": function (resp) {
					utils.dialog.alert(resp.message);
				},
				"callback": function (resp) {
					resp.longestDepositTime = "";
					resp.rate = "";
					var par = "test";
					App.container.show(new DhtLoginView({model: new Model(resp), param: par}));
				}
			});
			App.footer.reset({"visible": false});
		},


		/**
		 * 持有资产页
		 */

		dhtHoldAssets: function () {
			App.header.reset({
				title: "定活通",
				leftButtonContent: '@back',
				rightButtonContent: '交易记录',
				leftButtonHandler: function(){
					App.navigate("dinghuotong/index/login", true);
				},
				rightButtonHandler: function(){
					//  alert("跳转到支取记录页面");
					var DINGHUOTONG_CODE  = config.values.dinghuotong_code;
					//var url = 'me/tradeRecords/index/'+ DINGHUOTONG_CODE +"?"+Date.parse(new Date())
					var url = 'me/tradeRecords/tadereturn?code='+DINGHUOTONG_CODE+"&returnURL=dinghuotong/index/dhtHoldAssets&source="+Date.parse(new Date())
					App.navigate(url,true);
				}
			});
			App.footer.reset({"visible": false});
			App.container.show(new DhtHoldAssetsView());
		},

		/*
		 * 定活通存入页面
		 */

		dhtDeposit: function () {
			utils.native.talkingDataTrackEvent("2.0定活通购买第一步");
			var dfd = accountInfoStatus.getAccountInfoStatus(false,"dinghuotong/index/login");
			dfd.done(function(accountSta){
				if(accountSta){
					App.header.reset({
						title: "存入",
						leftButtonContent: '@back',
						leftButtonHandler: function () {
							App.navigate("dinghuotong/index/login", true);
						}
					});
					App.footer.reset({"visible": false});
					App.container.show(new DhtDepositView());
				}
			});
		},
		/*
		 * 定活通存入选存入方式
		 */
		dhtDepositWaySelect: function () {
			App.header.reset({
				title: "存入",
				leftButtonContent: '@back',
				leftButtonHandler: function () {
					App.navigate("dinghuotong/index/dhtDeposit", true);
				},
				rightButtonHandler: function () {
				}
			});
			App.footer.reset({"visible": false});
			App.container.show(new DhtDepositWaySelectView());
		},

		/*
		 * 定活通选择银行卡后的页面
		 */
		dhtDeposited: function () {
			App.container.show(new DhtDepositedView());
		},

		/*
		 *定活通跳转到输入密码页面
		 */
		_dhtInputPassword: function () {
			App.container.show(new DhtInputPasswordView());
		},

		/*
		 * 定活通存入失败
		 */
		_dhtDepositFailure: function () {
			App.header.reset({
				title: "存入结果",
				leftButtonContent: '@back'
			});
			App.footer.reset({"visible": false});
			App.container.show(new DhtDepositeFailureView());
		},
		/*
		 * 定活通支付成功页面
		 */
		_dhtDepositSuccess: function () {
			utils.native.talkingDataTrackEvent("2.0-产品-定活通购买成功");
			var DhtDepositSuccessView = require("../view/dhtDepositSuccess");
			App.header.reset({
				title: "存入结果",
				leftButtonContent: '@back',
				leftButtonHandler: function () {
					App.navigate("dinghuotong/index/login", true);
				}
			});
			App.footer.reset({"visible": false});
			App.container.show(new DhtDepositSuccessView());
		}
	});
});
