/**
 * @author liangyin
 */

define(function (require, exports, module) {
    var dinghuotongModel = module.exports = Model.extend({}, {
        /*
         * 定活通初始化
         */
        dhtIni: function (options) {
            var success = options.successCallback;
            var error = options.errorCallback;
            App.request("dhtIniData", {
                success: function (resp) {
                    success(resp);
                },
                error: function (resp) {
                    error(resp);
                }
            });
        },

        /**
         * 定活通统计
         */
        dhtBuyedMoneyQry: function (option) {
            var param = option.param,
                errorCallback = option.errorCallback,
                callback = option.callback;
            App.request("dhtBuyedMoneyQry", {
                data: param,
                cancelWhenRouting: true,//设置为 true, 当页面跳转的时候会自动 取消该语法 (不调用任何回调)。
                success: function (resp) {
                    callback && callback(resp.object);
                },
                error: function (resp) {
                    errorCallback && errorCallback(resp);
                }
            });
        },

        //查询定活通余额
        qryBalance: function (option) {
            var errorCallback = option.errorCallback,
                callback = option.callback;
            App.request("qrySmartDepositBalance", {
                data: option.data,
                success: function (resp) {
                    callback && callback(resp.object);
                },
                error: function (resp) {
                    errorCallback && errorCallback(resp);
                }
            });
        },

        //定转活
        trnsfrmFromDthToCrrnt: function (option) {
            var errorCallback = option.errorCallback,
                callback = option.callback;
            App.request("fixedToCurrentTransferConfirm", {
                data: option.formData,
                success: function (resp) {
                    callback && callback(resp.object);
                },
                error: function (resp) {
                    errorCallback && errorCallback(resp);
                }
            });
        },
        //查询可获利息
        qryDhtInterset: function (option) {
            var errorCallback = option.errorCallback,
                callback = option.callback;
            App.request("qryDhtRateAndInterest", {
                data: option.data,
                success: function (resp) {
                    callback && callback(resp.object);
                },
                error: function (resp) {
                    errorCallback && errorCallback(resp);
                }
            });
        },
        /**
         * 定活通列表
         * @param {Object} option
         */
        fixedToCurrentTransferList: function (option) {
            var param = option.param,
                errorCallback = option.errorCallback,
                callback = option.callback;
            App.request("fixedToCurrentTransferList", {
                data: param,
                cancelWhenRouting: true,//设置为 true, 当页面跳转的时候会自动 取消该语法 (不调用任何回调)。
                success: function (resp) {
                    callback && callback(resp.object);
                },
                error: function (resp) {
                    errorCallback && errorCallback(resp);
                }
            });
        }
    });
});