define(function (require, exports, module) {
    var CustomPwdInput = require("component/password/customPwdInput");
    var Form = require("component/form");
    var DhtDrawRecordTpl = require("text!../template/dhtDeposit.html");
    var accountModel = require("mod/common/model/accountModel");
    var safeKeyBoardHelper = require("component/customInput.helper");
    var dhtModel = require("../model/dhtModel");
    var dreamModel = require("../../dream/model/dream");

    //var safeKeyBoardHelper=require("component/customInput.helper");
    var DhtDrawRecordView = module.exports = Form.extend({

        template: _.template(DhtDrawRecordTpl),
        events: {
            "customInputFocusIn #depositSum": "customInputFocusInAmount",
            "customInputKeyup #depositSum": "customInputFocusOutAmount",
            "customInputKeydown #depositSum": "customInputFocusOutAmount",
            "tap #depositDetermine": "_depositDetermine",
            "tap #iSelect": "_changeSelect",
            "tap #dht_customer_service": "_openService", //刚加的,读协议
            "jsClearIconHandler #depositSum": "_moneyKeyUp",
            "tap #selectWay": "_toSelectWay"
        },

        onShow: function () {
            this._dhtInitAmountKeyboard();
            this._requestBalance();
        },
        //转入金额输入框获取焦点
        customInputFocusInAmount: function () {
            safeKeyBoardHelper.focusIn({
                id: "depositSum"
            });
            //var el=safeKeyBoardHelper.getSelector("depositSum");
            //el.addClass("focusBlue");
            this._moneyKeyUp();
            //判断是否激活"确定转出"

        },
        //转入金额失去焦点
        customInputFocusOutAmount: function () {
            safeKeyBoardHelper.focusOut({
                id: "depositSum"
            });
            this._moneyKeyUp();
            // $("#b2sAmount").customInput("value").replace(/,/g, "");
            //var el=safeKeyBoardHelper.getSelector("depositSum");
            //el.removeClass("focusBlue");

        },
        //初始化安全键盘
        _dhtInitAmountKeyboard: function () {
            this.$("#depositSum").customInput({
                type: "decimal",
                maxLength: 12,
                placeholder: "起存金额1000元",
                className: "safeKeyBoard"
            });
        },
        _openService: function (e) {
            var superLink = $("<a>");
            var _href = "";
            _href += "mod/dinghuotong/template/customerService.html?trueName=";
            _href += App.storage.get("UserInfo").get("trueName") + "&accNumber=";
            _href += App.storage.get("UserInfo").get("accNumber") + "&time=";
            _href += App.storage.get("Login_SysTime");
            superLink.prop("href", _href);
            utils.window.open({
                title: "协议详情",
                url: superLink.prop("href")
            });

            e.stopPropagation();
        },

        //初始化的时候获取活期余额
        _requestBalance: function () {
            accountModel.asycAccountInfo({
                silent: true,
                //cache:true,
                callback: function (response) {
                    var balance = utils.string.formatMoneyNumber(response.object.balance);
                    $("#curBalance").html(balance);
                    // _.extend(self.param,{balance:balance});//
                }
            });
        },

        //判断是否激活确定转出
        _moneyKeyUp: function () {
            this.whetherActive();
        },

        //判断是否把"确定转出"激活

        whetherActive: function () {
            var value = $("#depositSum input").val().trim();
            var right = this.$("#iSelect").hasClass('on');
            if (value != "" && value != "起存金额1000元" && right) {
                $("#depositDetermine").addClass("btn_orange").removeClass("btn_disable");
            } else {
                $("#depositDetermine").addClass("btn_disable").removeClass("btn_orange");

            }
        },

        //选择同意条款
        _changeSelect: function (events) {
            var tempThis = this.$(events.currentTarget);
            if (tempThis.hasClass('on')) {
                tempThis.removeClass("on");
            } else {
                tempThis.addClass("on");
            }
            this.whetherActive();
        },

        //确定转出
        _depositDetermine: function (events) {
            utils.native.talkingDataTrackEvent("2.0定活通购买验密");
            var tempThis = this.$(events.currentTarget);
            events.stopPropagation();
            if (tempThis.hasClass("btn_orange")) {
                if (this._validateAmount() == false) {
                    return;
                }
                CustomPwdInput.customPwdInput(_.bind(function (pwd) {
                    this._formSubmit(pwd);
                },this));
            }
        },

        //确定转入后向后台提交数据
        _formSubmit: function (pwd) {
            var self = this;
            var param = this._formData(pwd);
            dhtModel.currentToFixedTransferConfirm({
                "formData": param,
                "errorCallback": function (res) {
                    utils.dialog.alert(res.message);
                    self.submitFlag = false;
                    /*App.navigate("dinghuotong/index/dhtDepositFailure", true); */
                },
                "callback": function (res) {

                    var promise = dreamModel.qryDreamState();

                    promise.done(_.bind(function (arg1) {
                        utils.native.talkingDataTrackEvent("2.0定活通购买成功");

                        var arg1 = arg1.object.outExists;
                        App.storage.set("DHTBuyBalance", res.object.transferAmount);
                        App.storage.set("DHTDepositNumber", res.object.depositNumber);
                        App.requester.storage.remove("currentToFixedTransferBalance");
                        App.requester.storage.remove("dhtBuyedMoneyQry");
                        //0-不存在，1-存在
                        if (arg1 == 1) {
                            App.navigate("dinghuotong/index/dhtDepositSuccess", true);
                        } else {
                            utils.native.versionInformation(function (data) {
                                vs = data.version;
                                if (vs.replace(/\./g, "") * 1 >= 208) {
                                    App.navigate('dream/dream/dereamOpen', true);
                                } else {
                                    App.navigate("dinghuotong/index/dhtDepositSuccess", true);
                                }
                            });

                        }
                    }, this));

                    promise.fail(function (err) {
                        utils.dialog.toast(err.message);
                    });

                }
            });
        },
        //确定提交后向model中传递的参数
        _formData: function (pwd) {
            var buyAmt = $("#depositSum input").val().replace(/,/g, "");
            var sm2Pwd = utils.sm2.SM2Key.encrypt(pwd, config.base.sm2_public_key);
            var pwd = utils.crypto.RSAKey.encrypt(pwd, config.base.rsa_public_key);
            //这给密码加密
            return {
                accNo: App.storage.get("UserInfo").get("accNumber"), //这个是假数据
                transferAmount: buyAmt,
                password: pwd,
                sm2Pwd:sm2Pwd
            };
        },
        //点击确认时的第一步校验判断转入金额
        _validateAmount: function () {
            var buyAmt = this.$("#depositSum input").val().replace(/,/g, "");
            var balance = this.$("#curBalance").text().replace(/,/g, "");
            if (buyAmt == "" || buyAmt == "起存金额1000元") {
                utils.dialog.toast("没有输入金额");
                return false;
            }
            if (parseFloat(buyAmt) < 1000) {
                utils.dialog.toast("输入金额不能小于1000元");
                return false;
            }
            if (parseFloat(buyAmt) > parseFloat(balance)) {
                utils.dialog.toast("余额不足");

                return false;
            }
            return true;

        },

        //点击确定转入后的校验
        _validateForm: function () {
            /*     var buyAmt=$("#depositSum").val().replace(/,/g, "");
             var balance=$("#curBalance").text().replace(/,/g,"");*/
            var password = App.storage.get('dhtTempPass');

            if (password == "") {
                utils.dialog.alert("没有输入交易密码");

                return false;
            }

            return true;
        },

        //点击去选择转入方式页面
        _toSelectWay: function (events) {
            // App.navigate("dinghuotong/index/dhtDepositWaySelect", true);

        }
    })
})
