define(function (require, exports, module) {
    var CustomPwdInput = require("component/password/customPwdInput");
    var DhtDraw = require("text!../template/dhtDraw.html");
    var model = require("../model/dhtModel");
    var dhtDrawModel = require("../model/dhtDrawModel");
    var safeKeyBoardHelper = require("component/customInput.helper");

    var DhtDrawView = module.exports = ItemView.extend({
        template: _.template(DhtDraw),
        events: {
            "tap #confirmDraw": "confirmDraw",
            "tap #drawAlls": "drawAlls",
            "tap #cancelPassword": "cancelPassword",
            "tap #forgotPassword": "forgotPassword",
            "tap #reInputPassword": "reInputPassword",
            "customInputFocusIn #drawNums": "_onCustomInputFocusInDrawNums",
            "customInputFocusOut #drawNums": "_onCustomInputFocusOutDrawNums",
            "customInputKeyup #drawNums": "drawNumsKeyup",
            "tap #qryObtnIntrst": "qryObtnIntrst",
            "jsClearIconHandler #drawNums": "clearIcon"
        },
        drawNums: 0,            //支取金额
        surplusNums: 0,         //剩余金额
        isDrawAllFlag: false,  //是否全额支取
        crrtNum: 0,             //当前本金
        surplus: 0,             //剩余
        isNightTime: true,      //是否夜间时间 默认"是"(定活通不能转出)
        currtTime: "",           //当前时间
        isExecConfirmDraw: false,//是否正在执行确认按钮的事件(解决bug-没有失去聚焦点击"支取"按钮，两次弹密码框)

        onShow: function () {
            var dhtTotalIntRate = App.storage.get("dhtTotalIntRate");
            dhtTotalIntRate = dhtTotalIntRate + "%";
            this.$("#dhtTotalIntRate").text(dhtTotalIntRate);
            this._initAmountKeyboard();
        },

        cancelPassword: function () {
            $("#drawPassword").hide();
        },
        forgotPassword: function () {
            utils.dialog.alert("忘记密码");
        },
        reInputPassword: function () {
            $("#inputDrawPassword").show();
            $("#drawPasswordError").hide();
        },
        //确定支取 弹出密码组件
        confirmDraw: function (e) {
            this.isExecConfirmDraw = true;
            if ($("#confirmDraw").attr("disabled") === "disabled") {
                return;
            }
            //通过接口获取,系统当前时间,判定是否夜间00点至03点
            this.judgeIsNightTime();
        },
        drawAlls: function () {
            $("#drawNums").customInput("value", $("#crrtNum").html().trim());
            //获取数字形式的 全部金额
            this.drawNums = Number($("#drawNums").customInput("value").replace(/,/g, ""));
            $("#confirmDraw").removeClass("btn_disable");
            $("#confirmDraw").attr("disabled", false);
            $("#qryObtnIntrst").show();
            $("#showObtnIntrst").hide();
            this.isDrawAllFlag = true;
        },
        //初始化交易金额空间
        _initAmountKeyboard: function () {
            this.$("#drawNums").customInput({
                type: "decimal",
                placeholder: "支取到活期余额",
                className: "safeKeyBoard",
                maxLength: "10"
            });
            this.$("#drawNums").append("<span class='c_f60 m_r10' id='drawAlls'>全部转出</span>");
        },
        //输入框 获取聚焦
        _onCustomInputFocusInDrawNums: function () {
            safeKeyBoardHelper.focusIn({ id: "drawNums" });
        },
        //输入框 失去聚焦
        _onCustomInputFocusOutDrawNums: function () {
            if (this.isExecConfirmDraw) {  //正在执行支取事件
                return;
            }
            $("#drawAlls").show();
            if ($("#confirmDraw").attr("disabled") === "disabled" || $("#confirmDraw").attr("disabled") === true) {
                $("#qryObtnIntrst").hide();
                return;
            }
            if (Number($("#drawNums").customInput("value")) !== 0 && $("#drawNums").customInput("value") !== "") {
                if (document.getElementById("showObtnIntrst").style.display === "none") {//如果没有查过可获利息
                    $("#qryObtnIntrst").show();
                    $("#showObtnIntrst").hide();
                }
            } else { //不应该显示 查询按钮 因为支取金额不对
                $("#drawNums").customInput("value", "");
                $("#qryObtnIntrst").hide();
                $("#showObtnIntrst").hide();
            }
            this.drawNums = Number($("#drawNums").customInput("value").replace(/,/g, ""));
            this.surplusNums = Number($("#crrtNum").html().trim().replace(/,/g, "")) - this.drawNums;
            safeKeyBoardHelper.focusOut({ id: "drawNums" });
        },
        clearIcon: function () {
            $("#drawNums").customInput("value", "");  //插件自带
            $("#qryObtnIntrst").hide();
            $("#showObtnIntrst").hide();
            $("#confirmDraw").addClass("btn_disable");
            $("#confirmDraw").attr("disabled", true);
        },
        drawNumsKeyup: function () {
            this.isDrawAllFlag = false;
            if ($("#drawNums").customInput("value") === "" || $("#drawNums").customInput("value")[0] === "0") {
                $("#confirmDraw").addClass("btn_disable");
                $("#qryObtnIntrst").hide();
                $("#drawAlls").show();
                $("#confirmDraw").attr("disabled", true);
            }
            if ($("#drawNums").customInput("value") !== "") {
                $("#showObtnIntrst").hide();
            }
            if ($("#confirmDraw").attr("disabled") === "disabled" || $("#confirmDraw").attr("disabled") === true) {
                $("#qryObtnIntrst").hide();
            }
            this.drawNums = parseFloat($("#drawNums").customInput("value"));
            this.crrtNum = parseFloat($("#crrtNum").html().trim().replace(/,/g, ""));
            this.surplus = this.crrtNum - this.drawNums;
//            alert(drawNums);
            //判定支取金额会不会大于可支取金额
            if (this.drawNums !== this.crrtNum) {
//                if (surplus < 1000 || $("#drawNums").customInput("value")[0] == "0" || $("#drawNums").customInput("value") == "") {
                if (this.surplus < 1000 || !parseFloat($("#drawNums").customInput("value")) || $("#drawNums").customInput("value") == "") {
                    $("#confirmDraw").addClass("btn_disable");
                    $("#qryObtnIntrst").hide();
                    $("#confirmDraw").attr("disabled", true);
                } else {
                    $("#confirmDraw").removeClass("btn_disable");
                    $("#qryObtnIntrst").show();
                    $("#confirmDraw").attr("disabled", false);
                }
            } else {
                $("#confirmDraw").removeClass("btn_disable");
                $("#qryObtnIntrst").show();
                $("#confirmDraw").attr("disabled", false);
            }

            if (this.surplus === 0) {
                this.isDrawAllFlag = true;
            } else {
                this.isDrawAllFlag = false;
            }
        },
        qryObtnIntrst: function () {
            this.drawNums = Number($("#drawNums").customInput("value").replace(/,/g, ""));
            //定期序号
            var depSerialNo = App.storage.get("modelList").fixedDepositSN;
            var amt = this.drawNums + "";
            var param;
            //判断是否全额支取
            if (this.isDrawAllFlag) {  //全额支取
                param = {
                    "depSerialNo": depSerialNo //定期序号
                };
            } else {              //部分支取
                param = {
                    "depSerialNo": depSerialNo,   //定期序号
                    "amt": amt            //支取金额   部分支取时必传，全额支取不需要上传
                };
            }

            dhtDrawModel.qryDhtInterset({
                "data": param,
                "errorCallback": function (res) {
                    utils.dialog.toast(res.message);
                },
                "callback": function (res) {
                    $("#showObtnIntrst").find("span").html(res.penaltyInterest);
                    $("#showObtnIntrst").show();
                    $("#qryObtnIntrst").hide();
                }
            });
            return false;
        },
        //通过接口获取,系统当前时间,判定是否夜间00点至03点
        judgeIsNightTime: function () {
            App.request("timestamp", {type: "GET"}).done(function (arg) {
                //arg   2015/07/07 15:33:52
                this.currtTime = arg.object;
//                this.currtTime = "2015/07/07 01:33:52";
                var hourStr = this.currtTime.substring(11, 13) + "";
                if (hourStr === "00" || hourStr === "01" || hourStr === "02") {
                    this.isNightTime = true;
                } else {
                    this.isNightTime = false;
                }
                //----------------------------------------------------------
                if (this.isNightTime) {
                    var message = "        我行系统正在进行每日日终清算处理，如现在办理提前支取业务，可能因系统会计日期仍为前一日而带来利息损失，为避免您的利息受损，请您稍后再试。给您带来不便，敬请谅解！";
                    var title = "请注意";
                    utils.dialog.confirm(message, {title: title}, function (flag) {
                        if (flag) {
                            if ($("#confirmDraw").attr("disabled") === "disabled") {
                                return;
                            }
                            /*
                             * 再加一层验证 如果支取金额是undefined 则返回
                             * 其实是不会被执行的  因为上面已经进行一次拦截
                             * 如果还是执行，这里会有像冒泡一样的bug
                             * */
                            if (!($("#drawNums").customInput("value"))) {
                                utils.dialog.alert("支取金额不能为空");
                                return;
                            }
                            //取出缓存数据
                            var modelList = App.storage.get("modelList");
                            //取出本金
                            var tempBalance = App.storage.get("selectedTemp").selectedMoney;
                            var balance = tempBalance.replace(/,/g, "");
                            var param = {
                                "fixedDepositSN": modelList.fixedDepositSN,        //存款序号
                                "endDate": modelList.endDate,            //到期日期
                                "balance": balance,                      //当前定活通数量
                                "fromAccountNumber": modelList.accNum,  //转出账号
                                "password": "",
                                "toAccountNumber": modelList.accNum,    //转入账号?
                                "transferAmount": $("#drawNums").customInput("value").replace(/,/g, ""),        //支取金额数量
                                "currencyType": modelList.currType,
                                "accType": modelList.accType                 //类型
                            };
                            utils.native.talkingDataTrackEvent("2.0定活通支取验密");
                            CustomPwdInput.customPwdInput(function (pwd) {
                                App.storage.set("dhtTempPass", pwd);
                                param.password = utils.crypto.RSAKey.encrypt(pwd, config.base.rsa_public_key);
                                param.sm2Pwd = utils.sm2.SM2Key.encrypt(pwd, config.base.sm2_public_key);
                                dhtDrawModel.trnsfrmFromDthToCrrnt({
                                    "formData": param,
                                    "errorCallback": function (resp) {
                                        App.storage.set("errorMsg", resp.message);
                                        //跳转支付失败页面
                                        utils.dialog.alert(resp.message);
                                    },
                                    "callback": function (resp) {
                                        utils.native.talkingDataTrackEvent("2.0定活通支取成功");
                                        App.storage.set("drawData", resp);
                                        //支取成功，从返回的数据中，解析json，取值
                                        //跳转支付成功页面
                                        App.navigate("dinghuotong/draw/dhtDrawSuccess", true);
                                    }
                                });
                            });
                        } else {
                        }
                    });
                } else {
                    /*
                     * 再加一层安全验证 如果支取金额是undefined 则返回
                     * 其实是不会被执行的  因为上面已经进行一次拦截
                     * 如果还是执行，这里会有像冒泡一样的bug
                     * */
                    if (!($("#drawNums").customInput("value"))) {
                        utils.dialog.toast("支取金额不能为空");
                        return;
                    }
                    //取出缓存数据
                    var modelList = App.storage.get("modelList");
                    //取出本金
                    var tempBalance = App.storage.get("selectedTemp").selectedMoney;
                    var balance = tempBalance.replace(/,/g, "");
                    var param = {
                        "fixedDepositSN": modelList.fixedDepositSN,        //存款序号
                        "endDate": modelList.endDate,            //到期日期
                        "balance": balance,                      //当前定活通数量
                        "fromAccountNumber": modelList.accNum,  //转出账号
                        "password": "",
                        "toAccountNumber": modelList.accNum,    //转入账号?
                        "transferAmount": $("#drawNums").customInput("value").replace(/,/g, ""),        //支取金额数量
                        "currencyType": modelList.currType,
                        "accType": modelList.accType                 //类型
                    };
                    utils.native.talkingDataTrackEvent("2.0-产品-定活通购买验密");
                    CustomPwdInput.customPwdInput(function (pwd) {
                        App.storage.set("dhtTempPass", pwd);
                        param.password = utils.crypto.RSAKey.encrypt(pwd, config.base.rsa_public_key);
                        param.sm2Pwd = utils.sm2.SM2Key.encrypt(pwd, config.base.sm2_public_key);
                        dhtDrawModel.trnsfrmFromDthToCrrnt({
                            "formData": param,
                            "errorCallback": function (resp) {
                                this.isExecConfirmDraw = false;//执行支取命令 结束
                                App.storage.set("errorMsg", resp.message);
                                //跳转支付失败页面
                                utils.dialog.alert(resp.message);
                            },
                            "callback": function (resp) {
                                this.isExecConfirmDraw = false;//执行支取命令 结束
                                App.storage.set("drawData", resp);
                                //支取成功，从返回的数据中，解析json，取值
                                //跳转支付成功页面
                                App.navigate("dinghuotong/draw/dhtDrawSuccess", true);
                            }
                        });
                    });
                }
                //----------------------------------------------------------
            });
        }
    });
});