define(function (require, exports, module) {
    var PTRScroll = require('component/PTRScroll');
    var DhtAssetsTpl = require("text!../template/dhtHoldAssets.html");
    var DhtloginModel = require("../model/dhtModel");
    //var accModel  = require("mod/common/model/accountModel");
    var DhtHoldAssetsView = module.exports = ItemView.extend({
        template: _.template(DhtAssetsTpl),
        events: {
            "tap .fcyCoTp": "_slideChange",
            "tap .fzqBtn": "_withdrawal"
        },
        ui: {
            scroller: '#scrollContainer'
        },

        initialize: function () {
            _this = this;
            var userInfo = App.storage.get("UserInfo");

            _this.param = {
                "pageIndex": 1,
                "pageSize": 10,
                //"accNum"   : userInfo ? userInfo.get("accNumber") : "",
                "bussType": config.values.dinghuotong_code,
                "currType": "RMB"
            };//pageIndex表示当前第几页，pageSize：10表示显示10条，"totalRows": "12"表示总共12条，后两条就第2页显示了

            //定活通收益率查询
            DhtloginModel.dinghuotongYearsIncome({
                "errorCallback": function (res) {
                    utils.dialog.alert(res.message);
                },
                "callback": function (res) {
                    //console.log(res.intRate);
                    App.storage.set("dinghuotongYearsIncome", res.intRate + "%"); //挡板返回的定活通年化收益率在2.0里好像没有用
                }
            });


            DhtloginModel.dhtHoldAssetsList({
                "params": _this.param,
                "successCallback": function (res) {
                    _this._appendData(res);
                    _this.initPTRScroll();
                },
                "errorCallback": function (res) {
                    utils.dialog.alert(res.message);
                }

            });

        },

        //加载数据的方法

        _appendData: function (res) {

            for (i = 0; i < res.object.balancesList.length; i++) {
                $("#dhtAssetsListOutline").append('<div class="fcyColumn1 fbgc1"><div class="fcyCoTp dswkb"><span class="fwd1 dsb"><em class="fontStyle fpl_15">' + res.object.balancesList[i].fixedDepositSN + '</em></span><span class="fwd1 tac dsb">' + utils.string.formatMoneyNumber(res.object.balancesList[i].balance) + '</span><span class="fwd2 dsb fline22 c_999 f12"><em class="fr fontStyle fmr25"><span class="firstDate">' + utils.date.formatTime(res.object.balancesList[i].depositDate).format("yyyy-MM-dd") + '</span><br/>' + utils.date.formatTime(res.object.balancesList[i].endDate).format("yyyy-MM-dd") + '</em></span><i class="faiCon upIcon1"></i></div><p class="fzqBtn" style="display:none;">支取</p><span class="accNum" style="display:none;">' + res.object.balancesList[i].accNum + '</span><span class="accType" style="display:none;">' + res.object.balancesList[i].accType + '</span><span class="balance" style="display:none;">' + res.object.balancesList[i].balance + '</span><span class="currType" style="display:none;">' + res.object.balancesList[i].currType + '</span><span style="display:none;" class="subAccount">' + res.object.balancesList[i].subAccount + '</span><span style="display:none;" class="depositDate">' + res.object.balancesList[i].depositDate + '</span><span style="display:none;" class="endDate">' + res.object.balancesList[i].endDate + '</span><span style="display:none;" class="fixedDepositSN">' + res.object.balancesList[i].fixedDepositSN + '</span></div>');
            }
            var totalRow = res.object.totalRows;
            App.storage.set("totalRow", totalRow);
            this._whetherRecordsNull();

        },
        //判断是否有记录，没有记录显示没有记录，有记录，什么也不显示
        _whetherRecordsNull: function () {
            if ($("#dhtAssetsListOutline .fbgc1").length == 0) {
                $("#norecordsErrMsg").show();
            }
            else {
                $("#norecordsErrMsg").hide();
            }
        },
        //  depositDate
        initPTRScroll: function () {
            if (this.scroller) return;

            var self = this;
            var wHeight = $(window).height();
            var navHeight = App.header.$el.height();
            var secondTop = $("#secondTop").height();
            var listHeight = wHeight - navHeight - secondTop;
            var dom = this.ui.scroller.css({"height": listHeight, "position": "relative"});

            //初始化iscroller
            totalRow = parseInt(App.storage.get("totalRow"));
//			if(totalRow>10){
//				this.scroller = new PTRScroll(dom[0],{
//					"hScroll"          : false,
//					"checkDOMChanges"  : true,
//					"hideScrollbar"    : false,
//					"pullUpToLoadMore"  : true
//				});
//			}else{
//				this.scroller = new PTRScroll(dom[0],{
//					"hScroll"          : false,
//					"checkDOMChanges"  : true,
//                    "hideScrollbar"    : false,
//					"pullUpToLoadMore" : false
//				});
//			}
            this.scroller = new PTRScroll(dom[0], {
                "hScroll": false,
                "checkDOMChanges": true,
                "hideScrollbar": false,
                "pullUpToLoadMore": totalRow > 10 ? true : false
            });


            //下拉刷新
            this.scroller.options.refreshContent = function (refresh) {
                self._refreshContent(refresh);
            };

            //上拉加载
            this.scroller.options.loadMoreContent = function (refresh) {
                self._loadMoreContent(refresh);
            };
        },

        //下拉刷新
        _refreshContent: function (refresh) {
            var _this = this;
            _this.param.pageIndex = 1;
            //self.pageIndex=1;

            DhtloginModel.dhtHoldAssetsList({
                params: _this.param,
                successCallback: function (res) {
                    /*console.log(res);//返回数据在这里
                     console.log('current pageIndex is: ' + _this.pageIndex);*/
                    $("#dhtAssetsListOutline").html("");
                    _this._appendData(res);
                    // _this.initPTRScroll();
                    _this.scroller.options.pullUpToLoadMore = true;
                }

            }).complete(function () {
                refresh();
            });
        },

        //上拉加载
        _loadMoreContent: function (refresh) {
            var _this = this;
            _this.param.pageIndex = _this.param.pageIndex + 1;
            DhtloginModel.dhtHoldAssetsList({
                params: _this.param,
                successCallback: function (res) {
                    if (_this.param.pageIndex >= Math.ceil(res.object.totalRows / res.object.pageSize)) {
                        _this.scroller.options.pullUpToLoadMore = false;
                    } else {
                        _this.scroller.options.pullUpToLoadMore = true;
                    }
                    //console.log(res);//返回的数据写在这里
                    //console.log('current pageIndex is: ' + _this.pageIndex);
                    _this._appendData(res);
                }

            }).complete(function () {
                refresh();
            });
        },

        //持有资产页面上滑
        _slideChange: function (events) {
            tempThis = this.$(events.currentTarget);
            tmpUpIcon = tempThis.find(".upIcon");
            tempThisP = tempThis.siblings(".fzqBtn");
            if (tmpUpIcon.length > 0) {
                tempThis.find(".faiCon").removeClass("upIcon").addClass("upIcon1");
                tempThis.siblings(".fzqBtn").slideUp();

            } else {
                tempThis.find(".faiCon").removeClass("upIcon1").addClass("upIcon");
                tempThis.siblings(".fzqBtn").slideDown();
                $(".fcyCoTp").not(tempThis).each(function (e) {
                    $(this).find(".faiCon").removeClass("upIcon").addClass("upIcon1");
                    $(this).siblings(".fzqBtn").slideUp();
                });

            }

        },
        //获取靠档计息利率
        _totalIntRate: function (e) {

            var value = e.siblings(".dswkb").find(".fpl_15").text().trim();
            DhtloginModel.dhtTotalIntRate({
                "param": {
                    "depSerialNo": value
                },
                "errorCallback": function (res) {
                    utils.dialog.alert(res.message);
                },
                "callback": function (res) {
                    App.storage.set("dhtTotalIntRate", res.totalIntRate);
                    App.navigate("dinghuotong/draw/dhtDraw", true);
                }
            });

        },
        //跳转到支取页面
        _withdrawal: function (events) {
            var _this = this;
            var tempThis = _this.$(events.currentTarget);
            //冻结状态
            var dfd = accountInfoStatus.getAccountInfoStatus(false, "dinghuotong/index/dhtHoldAssets");
            dfd.done(function (accountSta) {
                if(!accountSta) return;
                var selectedMoney = tempThis.siblings().find(".tac").text();
                var selectedDate = tempThis.siblings().find(".firstDate").text();
                var accNum = tempThis.siblings(".accNum").text();
                var accType = tempThis.siblings(".accType").text();
                var currType = tempThis.siblings(".currType").text();
                var balance = tempThis.siblings(".balance").text();
                var subAccount = tempThis.siblings(".subAccount").text();

                var depositDate = tempThis.siblings(".depositDate").text();
                var endDate = tempThis.siblings(".endDate").text();
                var fixedDepositSN = tempThis.siblings(".fixedDepositSN").text();

                App.storage.set("modelList", {
                    "fixedDepositSN": fixedDepositSN,
                    "balance": balance,
                    "accNum": accNum,
                    "accType": accType,
                    "currType": currType,
                    "subAccount": subAccount,
                    "depositDate": depositDate,
                    "endDate": endDate
                });

                App.storage.set("selectedTemp", {
                    "selectedMoney": selectedMoney,
                    "selectedDate": selectedDate
                });

                _this._totalIntRate(tempThis); //获取传入靠档计息利率里的序号
            });

            //  events.stopPropagation();
        }
    });
});