/**
 * liujun
 * 梦想控制器
 * 2015.10.28
 */
define(function(require, exports, module) {
	var DreamWallView             = require("../view/dreamWall");
	var AddDreamView              = require("../view/addDream");
	var MyDreamView               = require("../view/myDream");
	var DreamStateProcessPageView = require("../view/dreamStateProcessPage");
	var DreamDetailsView          = require("../view/dreamDetails");
	var dreamModel                = require("../model/dream");
	var dreamCl                   = require("../view/dreamCl");
	var dreamGy                   = require("../view/dreamGy");
	var dereamOpen                = require("../view/dereamOpen");
	var index                     = require("../view/dereamOpen");

	var Index = module.exports = Controller.extend({
		actions : {
			dreamWall         : "dreamWall", //梦想墙
			addDream          : "addDream", //添加梦想
			myDream           : "myDream", //我的梦想
			dreamDetails      : "dreamDetails", //梦想墙详情
			dreamStateProcess : "dreamStateProcess", //梦想处理页
			dreamCl           : "dreamCl", //梦想策略
			dreamGy           : "dreamGy", //梦想感言
			dereamOpen        : "dereamOpen", //开启梦想
			index             : "index"
		},

		//梦想策略
		dreamcl : function(query) {
			App.header.reset({
				title : "梦想",
				leftButtonContent : "@back",
				leftButtonHandler : function() {
					App.navigate('search/search/index', true);
				}
			});
			App.container.show(new dreamcl());
		},
		//梦想感言
		dreamGy : function(query) {
			utils.native.talkingDataTrackEvent("2.0-进入梦想感言");

			App.header.reset({
				title : "梦想感言",
				leftButtonContent : "@back",
				leftButtonHandler : function() {
					App.navigate('dream/dream/dreamWall', true);
				}
			});
			App.container.show(new dreamGy());
		},
		//梦想墙
		dreamWall : function() {
			utils.native.talkingDataTrackEvent("2.0发现-梦想账户-梦想墙");
			App.header.reset({
				title : "梦想墙",
				leftButtonContent : "@back",
				leftButtonHandler : function() {
					//返回至发现页，梦想墙、添加梦想、我的梦想
					App.navigate('search/search/index', true);
				}
			});
			App.footer.reset({
				"visible" : false
			});

			App.container.show(new DreamWallView());
		},

		//添加梦想
		addDream : function(query) {
			utils.native.talkingDataTrackEvent("2.0发现-梦想账户-添加梦想");

			App.header.reset({
				title : "添加梦想",
				leftButtonContent : "@back",
				leftButtonHandler : function() {
					//返回至发现页，梦想墙、添加梦想、我的梦想
					var url = App.storage.remove("addDreamFromPage");
					if (url) {
						App.navigate(url, true);
					} else {
						App.navigate('search/search/index', true);
					}
				}
			});
			App.footer.reset({
				"visible" : false
			});
			App.container.show(new AddDreamView());
		},
		//梦想开启
		dereamOpen : function(query) {
			utils.native.talkingDataTrackEvent("2.0发现-梦想账户-广告页");

			App.header.reset({
				title : "我的梦想",
				leftButtonContent : "@back",
				leftButtonHandler : function() {
					//返回至发现页，梦想墙、添加梦想、我的梦想
					App.navigate('products/index/index/depositTake', true);
				}
			});
			App.footer.reset({
				"visible" : false
			});
			App.container.show(new dereamOpen());
		},
		//我的梦想配置参数
		_getDefaultParam : function() {
			return {
				"pageIndex" : 1,
				"pageSize" : 10
			};
		},

		//我的梦想
		myDream : function() {
			App.header.reset({
				title : "我的梦想",
				leftButtonContent : "@back",
				leftButtonHandler : function() {
					//返回至发现页，梦想墙、添加梦想、我的梦想
					App.navigate('search/search/index', true);
				}
			});
			App.footer.reset({
				"visible" : false
			});
			var param = this._getDefaultParam();
			App.container.show(new MyDreamView({
				"model" : new Model({
					'param' : param
				})
			}));
		},

		//梦想成功页统一处理
		dreamStateProcess : function() {

			App.header.reset({
				title : "我的梦想",
				leftButtonContent : "@back",
				leftButtonHandler : function() {
					//已签约页
					App.navigate('dream/dream/dreamWall', true);
				}
			});
			App.footer.reset({
				"visible" : false
			});
			App.container.show(new DreamStateProcessPageView());
		},
		//梦想详情
		dreamDetails : function() {
			utils.native.talkingDataTrackEvent("2.0发现-梦想账户-详情");

			//跳转至梦想墙(标识0)或者我的梦想(标识1)
			var id = App.storage.remove("dreamDisplayList");
			if (id == 0) {
				App.header.reset({
					title : "详情",
					leftButtonContent : "@back",
					leftButtonHandler : function() {
						App.navigate("dream/dream/dreamWall", true);
					}
				});
			} else if (id == 1) {
				App.header.reset({
					title : "详情",
					leftButtonContent : "@back",
					leftButtonHandler : function() {
						App.navigate("dream/dream/myDream", true);
					},
					rightButtonContent : "@more",
					rightButtonHandler : function() {
						if ($('.SmartF_pop').css('display') == "none") {
							$('.SmartF_pop').css('display', 'auto');
						} else {
							$('.SmartF_pop').css('display', 'none');
						}
					}
				});
			}
			App.footer.reset({
				"visible" : false
			});

			if (id == 0) {
				//点击梦想的ID
				var detailId = App.storage.get("dreamDetailId");
				//所有梦想数据
				var dreamModel = App.storage.get('myDream');
				dreamdata = [];

				for (var i = 0; i < dreamModel.length; i++) {

					if (dreamModel[i].dreamId == (detailId + "")) {

						dreamdata.push(dreamModel[i]);
						App.container.show(new DreamDetailsView({
							model : new Model(dreamdata)

						}));
						return;
					}
				}

			} else {

				//点击梦想的ID
				var detailId = App.storage.get("dreamDetailId");
				//所有梦想数据
				var dreamModel = App.storage.get('myDreames');
				dreamdata = [];

				for (var i = 0; i < dreamModel.length; i++) {

					if (dreamModel[i].dreamId == (detailId + "")) {

						dreamdata.push(dreamModel[i]);
						App.container.show(new DreamDetailsView({
							model : new Model(dreamdata)
						}));
						return;
					}

				}

			}

		}
	});
})
