define(function(require, exports, module) {
	var dreamModel = module.exports = Model.extend({}, {

		//查询梦想状态
		qryDreamState : function() {
			return App.request("qryDreamState", {
				data : {}
			});
		},

		//加签
		qryAddMsg : function(options) {
			App.request("addMsg", {
				data : options.param,
				success : function(res) {
					options.callback && options.callback(res);
				},
				error : function(err) {
					options.errorCallback && options.errorCallback(err);
				}
			});
		},

		//查询梦想墙
		qryDreamWall : function(options) {
			App.request("qryDreamWall", {
				data : options.param,
				success : function(res) {
					options.callback && options.callback(res);
				},
				error : function(err) {
					options.errorCallback && options.errorCallback(err);
				},
				complete : function() {
					options.complete && options.complete();
				}
			});
		},

		//查询我的梦想
		qryMyDream : function(options) {
			App.request("qryMyDream", {
				data : options.param,
				success : function(res) {
					options.callback && options.callback(res);
				},
				error : function(err) {
					options.errorCallback && options.errorCallback(err);
				},
				complete : function() {
					options.complete && options.complete();
				}
			});
		},

		//增加梦想
		addNewDream : function(options) {
			App.request("addNewDream", {
				data : options.param,
				success : function(res) {
					options.callback && options.callback(res);
				},
				error : function(err) {
					options.errorCallback && options.errorCallback(err);
				}
			});
		},

		//梦想感言
		dreamSpeech : function(options) {
			App.request("dreamSpeech", {
				data : options.param,
				success : function(res) {
					if (res.success) {
						options.callback(res);
					}
				},
				error : function(err) {
					options.errorCallback(err);
				}
			});
		},

		//扼杀梦想
		killDream : function(options) {
			App.request("killDream", {
				data : options.data,
				success : function(res) {
					if (res.success) {
						options.callback(res);
					}
				},
				error : function(err) {
					options.errorCallback(err);
				}
			});
		},

		//点赞举报
		praiseOrReport : function(options) {
			App.request("praiseOrReport", {
				data : options.data,
				success : function(res) {
					if (res.success) {
						options.callback(res);
					}
				},
				error : function(err) {
					options.errorCallback(err);
				}
			});
		},

		//查询是否禁言
		isOrNotForbidden : function() {
			return App.request("isOrNotForbidden", {
				data : {}
			});
		},

		//查询梦想频次是否合理
		dreamFrequencyControl : function() {
			return App.request("dreamFrequencyControl", {
				data : {}
			});
		},
		
		//梦想分享
		shareDream : function(options){
	        var options = options || {};
	        return App.request("shareDream",{
	        	data: options.data,
	            success: function(response){
	                options.callback && options.callback(response);
	            },
	            error:function(response){
	                options.errorCallback && options.errorCallback(response);
	            }
	        });
	    }    
	});
});

