/*
 *  添加梦想
 *  zhoushiwen
 *  2015.11.5
 */
define(function(require, exports, module) {
	var addDreamHtml = require("text!../template/addDream.html");
	var dreamModel = require("../model/dream");
	var num = 0;
	var IndexView = module.exports = ItemView.extend({
		template : _.template(addDreamHtml),

		events : {
			"input  #dreamtext" : "totalchar",
			"change #dreamtext" : "totalchar",
			"tap    #addimg" : "showPictureDialog",
			"tap    #okdream" : "submit",
			"tap    .delImg " : "delImg",
			"tap    #iconA57" : "open"
		},

		initialize : function(obj) {
			this.submitFlag = false;
			this.wallFlag = 0;
			App.storage.set("addDreamFromPage", "dream/dream/myDream");

		},
		onShow : function() {
			//创建输出框
			this.$("#dreaminput").customInput({
				type : "decimal",
				className : "safeKeyBoard",
				maxLength : "10",
				placeholder : "请输入梦想预算"
			});
			//判断是否又图片更样式
			var imglength = 0;
			if (imglength != 0) {

				$("#pimgs").hide();

			} else {
				$("#pimg").hide();

			}

		},
		//限制字数
		totalchar : function() {
			var el = $("#dreamtext");
			var len = el.val().length;
			var value = el.val();
			if (len > 100) {
				value = value.substring(0, 100);
				el.val(value);
			}
		},

		//选择上传图片方式
		showPictureDialog : function() {
			utils.dialog.spinner({
				"source" : [{
					text : "从手机相册选择"
				}, {
					text : "拍照"
				}],
				"callback" : _.bind(function(key, value) {
					this.getPicture(value);
				}, this)
			});
		},

		//选择拍照或从手机相册方法
		getPicture : function(source) {
			navigator.camera.getPicture(this.onSuccess, this.onFail, {
				quality : 100,
				destinationType : 0,
				sourceType : source,
				allowEdit : false,
				correctOrientation : true,
				targetWidth : 1080,
				targetHeight : 1920
			});
		},
		//获取图片信息 渲染页面
		onSuccess : function(imageData) {

			var img = new Image()
			var imgObj = new Image();
			imgObj.src = ('data:image/jpeg;base64, ' + imageData + '');

			$(imgObj).load(function() {

				if (imgObj.height < 480) {
					utils.dialog.alert('请上传大图片！');

				} else if (imgObj.width < 320) {

					utils.dialog.alert('请上传大图片!');
				} else {
					$("#pimgs").hide();
					$("#pimg").show();
					$("#addBtn").before("<li index='" + num + "'><img class='fileImg'  src='data:image/jpeg;base64," + imageData + "'  width='74' height='77' /><a index='" + num + "' class='dsb tac f16 delImg'>删除</a></li>");
					//限制图片数量
					if ($(".delImg").closest('li').length == 5) {
						$("#addBtn").hide();
					} else {
						$("#addBtn").show();

					}
					num++;
				}

			});

		},
		//提交
		submit : function(event) {
			var dreamdata = {};

			var self = this;
			event.stopPropagation();
			//梦想预算金额
			var dreaminput = this.$("#dreaminput").customInput("value").replace(/,/g, "");
			//梦想宣言
			var dreamtext = $("#dreamtext").val();
			var imglength = $(".delImg").closest('li').length;
			if (this.submitFlag) {
				return;
			}
			//验证
			if (!this.validate(dreaminput, dreamtext, imglength)) {
				return;
			}
			self.submitFlag = true;

			//是否显示
			if ($("#iconA57").hasClass('iconA57 on')) {
				self.wallFlag = 1;

			} else {
				self.wallFlag = 0;

			}
			//获取当前页面图片路径
			var consumeEditDetail = App.storage.get("consumeEditDetail");
			var imgList = $("#consumeImgUl img");
			dreamdata.dreamPhotoUrl = "";
			_.each(imgList, function(list, i) {
				var imgSrc = list.src;
				if (dreamdata.dreamPhotoUrl) {
					dreamdata.dreamPhotoUrl += "_add" + imgSrc;
				} else {
					dreamdata.dreamPhotoUrl = imgSrc;
				}
			});

			var data = {}
			data.flag = 0;
			dreamModel.qryAddMsg({
				"param" : data,
				"callback" : function(response) {
					//梦想预算
					dreamdata.dreamBudget = dreaminput;
					//梦想宣言
					dreamdata.dreamEnounce = dreamtext;
					//是否在梦想墙展示，1-显示，0-不显示
					dreamdata.wallFlag = self.wallFlag;
					//梦想类型，0-新增梦想 1-梦想达成
					dreamdata.dreamType = 0;
					//加签
					dreamdata.signkey = response.object.signInfo;
					dreamdata.timeStr = response.object.timeStr;
					//客户号
					dreamdata.partyNo = response.object.partyNo;
					//时间戳

					var params = dreamdata;

					dreamModel.addNewDream({
						"param" : params,
						"callback" : function(res) {
							App.storage.remove("myDream");
							App.storage.remove("myDreames");

							App.storage.set('dreamStateProcessArgs', 1);
							App.navigate('dream/dream/dreamStateProcess', true);
						},
						"errorCallback" : function(res) {
							utils.dialog.alert(res.message);
							self.submitFlag = false;
						}
					});

				},
				"errorCallback" : function(res) {
				}
			});

		},
		//删除图片
		delImg : function(e) {
			var num = $(e.currentTarget).attr('index');
			$(".delImg").closest('li[index=' + num + ']').remove();
			if ($(".delImg").closest('li').length == 0) {
				$("#pimg").hide();
				$("#pimgs").show();
			} else {
				$("#pimg").show();
				$("#pimgs").hide();

			}
			if ($(".delImg").closest('li').length == 5) {
				$("#addBtn").hide();
			} else {
				$("#addBtn").show();

			}
		},
		//验证
		validate : function(dreaminput, dreamtext, imglength) {

			if (dreaminput == "") {
				utils.dialog.alert("请输入梦想预算");
				return false;
			}

			if (dreamtext == "") {
				utils.dialog.alert("请输入梦想感言");
				return false;
			}

			if (imglength == 0) {
				utils.dialog.alert("请至少上传一张图片");
				return false;
			}

			if (!utils.validate.specialCharacter(dreamtext)) {
				utils.dialog.alert("梦想感言不能有特殊字符");
				return false;
			}
			return true;

		},
		open : function() {

			if ($("#iconA57").hasClass('iconA57 on')) {
				$("#iconA57").removeClass('on');
			} else {
				$("#iconA57").addClass('on');

			}

		}
	});
});
