/*
 *  梦想详情
 *  刘俊
 *  2015.10.30
 */
define(function(require, exports, module) {
	require('vendor/slick');
	var dreamDetailsHtml   = require("text!../template/dreamDetails.html");
	var dreamModel         = require("../model/dream");
	var Form               = require("component/form");
	var CustomPwdInput     = require("component/password/customPwdInput");
	var safeKeyBoardHelper = require("component/customInput.helper");
	var transferOutCom     = require("mod/common/transferOutCom/transferOutCom");

	var IndexView = module.exports = Form.extend({
		template : _.template(dreamDetailsHtml),

		events : {
			"tap #dreamWall"    : "dreamWall", //梦想墙
			"tap #addDream"     : "addDream", //添加梦想
			"tap #myDream"      : "myDream", //我的梦想
			"tap .dreamWords"   : "dreamWords", //梦想感言
			"tap .quickDraw"    : "quickDraw", //立即提款
			"tap .killDream"    : "killDream", //扼杀梦想
			"tap"               : "yingcangMenu", //隐藏右上角菜单
			"tap .iconF5"       : "pointPraise", //点赞
			"tap .iconF6"       : "pointReport", //举报
			"tap  #bigImg"      : "bigImg",    //大图
			"tap  #dreamShares" : "dreamShares"   //梦想分享

		},

		initialize : function(options) {
			var dreamState = App.storage.get('dreamState');
			data = options.model.attributes;
			data.state = dreamState;
			submitState = false;
			bigImgList = data[0].imageUrlList;
			this.pageId = this.model.get("pageId");
			App.storage.set('dreamGy', data[0].dreamId);

		},

		onRender : function() {

		},

		onShow : function() {
			var img = new Image();
			var imgObj = new Image();
			//wrapperwidth = 0;
			//wrapperheight= 0;
			var imgWidth = [];
			// for (var i = 0; i < this.$(".dreamBig").length; i++) {
			//imgObj.src = this.$(".dreamBig img[index='" + i + "']").attr('src');
			//imgWidth.push(imgObj.width);
			// }
			// for (var i = 0; i < imgWidth.length; i++) {
			// Scroolwidth += parseInt(imgWidth[i])
			// }
			imgObj.src = this.$(".dreamBig img[index='0']").attr('src');
			var Scroolwidth = imgObj.width;
			var wrapperheight = imgObj.height;
			// $("#wrapper").css({
				// "width" : Scroolwidth,
				// "height" : wrapperheight
			// });

			// $("#scroller").css({
			// "width" : Scroolwidth + 40
			// });
			//
			// var myScroll;
			// myScroll = new iScroll('wrapper', {
			// snap : true,
			// momentum : false,
			// hScrollbar : false,
			// //vScroll : false,
			//
			// onScrollEnd : function() {
			//
			// }
			// });



		},

		dreamWall : function() {
			App.navigate("dream/dream/dreamWall", true);
		},
		addDream : function() {
			App.navigate("dream/dream/addDream", true);
		},
		myDream : function() {
			App.navigate("dream/dream/myDream", true);
		},
		//梦想感言
		dreamWords : function() {

			utils.native.talkingDataTrackEvent("2.0 - 梦想 - 添加完成");

			var self = this;
			//禁言(0未禁言,1禁言)与频次(0合理,1不合理)
			var promise = $.when(dreamModel.isOrNotForbidden(), dreamModel.dreamFrequencyControl());
			promise.done(function(arg1, arg2) {
				var arg1 = arg1[0].object;
				var arg2 = arg2[0].object;
				if (arg1.chkFlag == 1) {
					utils.dialog.alert("因您多次发表违禁内容，已被禁言，不能发表梦想！");
				} else if (arg2.chkFlag == 1) {
					utils.dialog.alert("您发布梦想的频率过高，请稍候再添加");
				} else {

					App.storage.set('dreamDetails', self.model);

					App.navigate("dream/dream/dreamGy", true);
				}
			});
			promise.fail(function(err) {
				utils.dialog.toast(err.message);
			});
		},

		/**
		 * wuwenjun059
		 * 立即提款，转出流程
		 */
		quickDraw : function() {
			//未设置转账限额，“取消”返回页面地址
			App.storage.set("transferLimitBack", "dream/dream/dreamDetails");
			//缓存我的梦想数据
			App.storage.set("immediatelyTransfer", this.model.attributes[0]);
			//跳转至转出界面
			transferOutCom.assetsTransOut();
		},
		//扼杀梦想
		killDream : function() {
			utils.dialog.customDialog("你确定要扼杀梦想么", {
				title : "",
				okButtonText : "确认",
				cancelButtonText : "取消"
			}, _.bind(function(e) {
				if (e == true) {
					var data = {};
					//单个详情获取dreamId
					data.dreamId = this.model.attributes[0].dreamId;
					dreamModel.killDream({
						data : data,
						callback : function(res) {
							utils.native.talkingDataTrackEvent("2.0-梦想 - 扼杀梦想");
							App.storage.remove("myDream");
							App.storage.remove("myDreames");

							App.navigate("dream/dream/myDream", true);
						},
						errorCallback : function(err) {
							utils.dialog.toast(err.message);
						}
					});
				}
			}, this));

		},
		//隐藏右上角按钮
		yingcangMenu : function() {
			if ($('.SmartF_pop').css('display') != "none") {
				$('.SmartF_pop').css('display', 'none');
			}
		},
		//点赞和举报请求
		requestPraiseOrReport : function(data, curr, id) {
			//梦想墙进入详情缓存信息
			var dreamWallListData = App.storage.get("dreamWallListData");
			//梦想详情信息
			if(dreamWallListData){
				var dreamDetailsModel = _.findWhere(dreamWallListData.myDreamList,{"dreamId":data.dreamId});
			}
			dreamModel.praiseOrReport({
				data : data,
				callback : _.bind(function(res) {
					App.storage.remove("myDreames");

					if (id == 0) {
						var num = Number((this.$(curr).next('i').text()).replace(",", ""));
						if (data.reportFlag == 0) {
							this.$(curr).addClass("on");
							this.$(curr).next('i').text(num + 1);
							if(dreamWallListData){
								dreamDetailsModel.reportFlag = 1;
								dreamDetailsModel.reportAmt = dreamDetailsModel.reportAmt+1;
							}
						} else if (data.reportFlag == 1) {
							this.$(curr).removeClass("on");
							this.$(curr).next('i').text(num - 1);
							if(dreamWallListData){
								dreamDetailsModel.reportFlag = 0;
								dreamDetailsModel.reportAmt = dreamDetailsModel.reportAmt-1;
							}
						}
					} else if (id == 1) {
						var num = Number((this.$(curr).next('i').text()).replace(",", ""));
						if (data.praiseFlag == 0) {
							this.$(curr).addClass("on");
							this.$(curr).next('i').text(num + 1);
							if(dreamWallListData){
								dreamDetailsModel.praiseFlag = 1;
								dreamDetailsModel.praiseAmt = dreamDetailsModel.praiseAmt+1;
							}
						} else if (data.praiseFlag == 1) {
							this.$(curr).removeClass("on");
							this.$(curr).next('i').text(num - 1);
							if(dreamWallListData){
								dreamDetailsModel.praiseFlag = 0;
								dreamDetailsModel.praiseAmt = dreamDetailsModel.praiseAmt-1;
							}
						}
					}
				}, this),
				errorCallback : function(err) {
					utils.dialog.toast(err.message);
				}
			});
		},
		//点赞
		pointPraise : function(e) {
			// dreamId 梦想ID
			// flag   0-举报,1-点赞
			// praiseFlag  点赞标志 0-点赞,1-取消点赞
			// reportFlag  举报标志 0-举报,1-取消举报
			var curr = e.currentTarget;
			var data = {};
			data.dreamId = this.model.attributes[0].dreamId;
			data.flag = 1;
			if (this.$(curr).hasClass("on")) {
				data.praiseFlag = 1;
			} else {
				data.praiseFlag = 0;
			}

			this.requestPraiseOrReport(data, curr, 1);
			return false;
		},
		//举报
		pointReport : function(e) {
			var curr = e.currentTarget;
			var data = {};
			data.dreamId = this.model.attributes[0].dreamId;
			data.flag = 0;
			if (this.$(curr).hasClass("on")) {
				data.reportFlag = 1;
			} else {
				data.reportFlag = 0;
			}

			this.requestPraiseOrReport(data, curr, 0);
			return false;
		},
		//大图片
		bigImg : function(e) {
			//var imgUrlList = [];
			//var index = $(e.currentTarget).find('img').attr('index');
			//var imgurl = $(e.currentTarget).find('img[index="' + index + '"]').attr('src')
			//imgUrlOne = $(e.currentTarget).find('img').attr('src').replace(/^data:image\/jpeg;base64,/, '');
			//imgUrlList.push();
			// for (var i = 0; i < $("#scroller").find('img').length; i++) {
			//
			// if (i == index) {
			//
			// } else {
			// var imgUrl = $("#scroller").find('img[index=' + i + ']').attr('src');
			// imgUrlList.push(imgUrl);
			// }
			//
			// }


			utils.native.gallery.show({
				source : bigImgList

			});

		},

		//梦想分享
		dreamShares:function(){
			//梦想宣言
			var dreamEnounce = data[0].dreamEnounce;
			//梦想图片数组
			var imageUrlList = data[0].imageUrlList[0];
			//梦想ID
			var dreamId = data[0].dreamId;

			var img = new Image();
			img.src = imageUrlList;
			img.crossOrigin = 'Anonymous';
			// 设置canvas宽高为图片宽高
			img.onload = function(){
				// 创建一个canvas
				var c = document.createElement("canvas");
				// 定制画布的宽高
				c.width = img.width;
				c.height = img.height;
				// 将图片绘制到canvas
				var cxt = c.getContext("2d");
				cxt.drawImage(img, 0, 0);
				// 得到图片的base64编码数据
				var picData = c.toDataURL("image/jpeg", 0.8);
				//梦想图片
				var imageUrl = picData.split(',')[1];
				dreamModel.shareDream({
					data:{"dreamId":dreamId},
					callback : function(res) {
						//梦想分享URL
						var shareDreamUrl = res.object.shareDreamUrl;
						App.storage.set("shareWLTData",{"share_module":config.values.shareDream,"share_url":encodeURIComponent(shareDreamUrl)});
						utils.native.shareProduct({
							"title":"",
							"message":dreamEnounce,
							"url":shareDreamUrl,
							"type":1,
							"image":imageUrl
						});
					},
					errorCallback : function(err) {
						utils.dialog.toast(err.message);
					}
				});
			};
			img.onerror = function(){
				utils.dialog.toast("数据请求失败!");
			};
		}
	});
});
