/* global App */
/* global utils */
/* global ItemView */
// 梦想墙列表 2015-11-24
define(function(require, exports, module) {
	var dreamListHtml = require("text!../template/dreamList.html");
	var dreamModel = require("../model/dream");
	module.exports = ItemView.extend({
		template : _.template(dreamListHtml),
		events : {
			"tap .dreamColumn1" : "dreamDetails", //梦想墙详情
			"tap .praiseReport" : "praiseReport" //点赞,举报
		},

		initialize : function(options) {
		},
		
		dreamDetails : function(e) {
			e.preventDefault();
			var curr = $(e.currentTarget);
			var id = curr && curr.data('dreamid');
			if (!curr.length || !id) return;
			App.storage.set("dreamDetailId", id);
			App.storage.set("dreamDisplayList", 0);
			App.navigate("dream/dream/dreamDetails", true);
		},

		//点赞, 举报 flag 0-举报,1-点赞
		//2015-11-26 取消是自己发布的梦想不能点赞举报规则
		praiseReport : function(event) {
			event.preventDefault();
			event.stopPropagation();
			
			var curr = $(event.currentTarget);
			var id = curr.index();
			var dreamid = curr && curr.closest('.dreamColumn1').data('dreamid');
			if (!curr.length || !dreamid) return;
			
			var data = {};
			data.dreamId = dreamid;
			data.flag = !!id ? 0 : 1;
			
			dreamModel.praiseOrReport({
				data : data,
				callback : _.bind(function(res) {
					var ii = curr.find('i').eq(0),
						hasOn = ii.hasClass('on'),
						next = ii.next('i'),
						num = Number(next.text().replace(',', ''));
						
					if (hasOn) {
						ii.removeClass('on');
						next.text(num - 1);
					}else{
						ii.addClass('on');
						next.text(num + 1);
					}
				}, this),
				errorCallback : function(err) {
					utils.dialog.toast(err.message);
				}
			});
		}

	});
});
