/**
 * 橙子成就
 * ex_huangzit
 * 2016-05-03
 */
define(function (require, exports, module) {
	var Index     = require("../view/index");                 //橙子成就-首页-View
	var MedalView = require("../view/medal");                 //橙子成就-View
	var QaView    = require("../view/qa");                    //橙子成就-Q&A
	var FAModel   = require("../model/financialAchievement"); //橙子成就数据Model

	module.exports = Controller.extend({
		actions: {
			"index"         : "index",
			"qa"            : "qa",
			"medal(/:type)" : "medal"
		},

		//橙子成就首页
		index: function (){
			var self = this;
			utils.native.talkingDataTrackEvent('橙子成就');
			this.setHeaderFooter({
				title: '橙子成就',
				leftButtonHandler: function () {
					App.navigate("me/logined/index", true);
				},
				rightButtonContent:'更多',
				rightButtonHandler: function () {
					App.navigate("financialAchievement/financialAchievement/qa", true);
				},
			});

			FAModel.financialAchievement({
				url: "financialAchievement",
				callback: function (res) {
					self.financialAchievement = res.object;
					App.container.show(new Index({ model: new Model(res.object) }));
				},
				errorCallback: function (res) {
					utils.dialog.alert(res.message);
				}
			});
		},

		//Q&A问题
		qa: function (){
			utils.native.talkingDataTrackEvent('橙子成就Q&A');
			this.setHeaderFooter({ title: '橙子成就Q&A' });
			App.container.show(new QaView());
		},

		//勋章(1：初试牛刀；2：告别月光；3：万元户；4：搞基好手；5：线下风测)
		medal: function(type){
			var options = _.defaults({"type":type}, this.financialAchievement);
			switch(type){
				case "1":
					utils.native.talkingDataTrackEvent('初试牛刀');
					this.setHeaderFooter({ title: '初试牛刀' });
					App.container.show(new MedalView({model: new Model(options)}));
					break;
				case "2":
					utils.native.talkingDataTrackEvent('告别月光');
					this.setHeaderFooter({ title: '告别月光' });
					//已激活的要查历史
					if(options["medal2"] === "1"){
						FAModel.medalDetailHis({
							url: "medalDetailHis",
							data: {medalType:"02"},//02：告别月光；03：万元户
							callback: function (res) {
								options = _.extend(options, res.object);
								App.container.show(new MedalView({model: new Model(options)}));
							},
							errorCallback: function (res) {
								utils.dialog.alert(res.message);
							}
						});
					}else{
						options = _.extend(options, this.medalDetailHis);
						App.container.show(new MedalView({model: new Model(options)}));
					}
					break;
				case "3":
					utils.native.talkingDataTrackEvent('万元户');
					this.setHeaderFooter({ title: '万元户' });
					//已激活的要查历史
					if(options["medal3"] === "1"){
						FAModel.medalDetailHis({
							url: "medalDetailHis",
							data: {medalType:"03"},//02：告别月光；03：万元户
							callback: function (res) {
								options = _.extend(options, res.object);
								App.container.show(new MedalView({ model: new Model(options) }));
							},
							errorCallback: function (res) {
								utils.dialog.alert(res.message);
							}
						});
					}else{
						//options = _.extend(options, this.medalDetailHis);
						App.container.show(new MedalView({model: new Model(options)}));
					}
					break;
				case "4":
					utils.native.talkingDataTrackEvent('搞基好手');
					this.setHeaderFooter({ title: '搞基好手' });
					App.container.show(new MedalView({model: new Model(options)}));
					break;
				case "5":
					utils.native.talkingDataTrackEvent('线下风测');
					this.setHeaderFooter({ title: '线下风测' });
					App.container.show(new MedalView({model: new Model(options)}));
					break;
			}
		},

		//设置头部脚部
		setHeaderFooter: function (options) {
			var defaults = _.extend({
				showFooter: false,
				leftButtonContent: "@back",
				leftButtonHandler: function () {
					App.navigate("financialAchievement/financialAchievement/index", true);
				}
			}, options || {});
			App.header.reset(defaults);
			App.footer.reset({
				visible: false
			});
		}
	});
});