/**
 * @author zhoushiwen
 * @ date ${date}
 * @company 中国平安
 */
define(function (require, exports, module) {
	var InputView = require("../view/buy/input");
	var FinishView = require("../view/buy/finish");
	var accountModel = require("mod/common/model/accountModel");
	var BuyController = module.exports = Controller.extend({
			actions : {
				"input" : "toInputPage",
				"finish" : "toFinishPage"
			},
			/*  authorize: function(){
			return true;
			},*/
			toInputPage : function () {
				utils.native.talkingDataTrackEvent("2.0理财产品购买第一步");
				App.header.reset({
					title : "购买订单",
					leftButtonContent : '@back',
					leftButtonHandler : function () {
						var model = App.storage.get('products/detail/finace');
						App.storage.set('products/detail/finace', model);
					    App.storage.remove("financeProductData");   //产品详情
					    App.storage.remove("selPayBeforeData");   //选择支付方式缓存信息
						App.navigate("products/detail/finace", true);
					}
				});

				//判断是否存在选择支付方式缓存信息
				if(App.storage.get("selPayBeforeData")){
				    App.container.show(new InputView({
                        model : new Model(App.storage.get("financeProductData"))
                    }));
				}else{
    				var promise = $.when(
    						accountModel.qryAccountList(),
    						accountModel.asycAccountInfo());

    				promise.done(function (arg1, arg2) {

    					var model = App.storage.get('myInvestment/commendProducts/curProObj');
    					var tempData = {
    						"financeProductData" : App.storage.get("financeProductData")
    					};
    					var financeProductData = _.extend(tempData, {
    							balance : arg2[0].object.balance,
    							dhBalance : arg2[0].object.dhBalance,
    							totalBalance : arg2[0].object.totalBalance,
    							accountList : arg1[0].object.accountList
    						});
    					App.storage.set("financeProductData",financeProductData);
    					App.container.show(new InputView({
    							model : new Model(financeProductData)
    						}));
    				});

    				promise.fail(function (err) {
    					utils.dialog.alert(err.message);
    				});
				}

			},

			toFinishPage : function () {
				utils.native.talkingDataTrackEvent("2.0理财产品购买成功");
				App.header.reset({
					title : "提交成功",
					leftButtonContent : '@back',
					leftButtonHandler : function () {
					    App.storage.remove("financeProductData");   //产品详情
						App.navigate("products/index/index/finefinance", true);
					}
				});
				var tempData = {
					"financeProductData" : App.storage.get("financeProductData")
				};
				App.storage.remove("financeProductData");
				App.container.show(new FinishView({
						model : new Model(tempData)
					}));
			}
		});
});
