/**
 * @author zhoushiwen
 * @ date ${date}
 * @company 中国平安
 */
define(function (require, exports, module) {
    var Form = require("component/form");
    var safeKeyBoardHelper = require("component/customInput.helper");
    var InputTpl = require("text!../../template/buy/input.html");
    var CustomPwdInput = require("component/password/customPwdInput");
    var BuyModel = require("../../model/buy");
    var dreamModel = require("../../../dream/model/dream");

    var InputView = module.exports = Form.extend({
        template: _.template(InputTpl),
        ui: {
            "checkbox": "#checkbox",
            "booksLink": "#booksLink a"
        },
        events: {
            "tap #submitBtn": "submit",
            "click @ui.checkbox": "toggleCheckbox",
            "click @ui.booksLink": "openBookLink",
            "customInputKeyup  #amountInput": "_onCustomInputFocusSelAmount",
            "tap #selPaymentMethod": "selPaymentMethod",
            //"keyup  #amountInput" : "_onCustomInputFocusSelAmount"
        },

        initialize: function (options) {
            this.financeProductData = options.model.get("financeProductData");
            this.balance = options.model.get("balance");
            this.accountList = options.model.get("accountList");
            this.submitFlag = false;
        },

        onShow: function () {
            var prdCode = this.financeProductData.prdCode.substr(0, 3)
            var PlanRateRemark = this.financeProductData.planRateRemark;
            if (prdCode == 510 || prdCode == 310) {
                $("#day").text("每日预期收益");

                $("#prdCode").hide();
                if (prdCode == "510") {

                    $("#planRate").text(PlanRateRemark + "%");
                    $("#planRateinput").text("业绩比较基准");
                }
            }

            this.$("#amountInput").customInput({
                type: "decimal",
                placeholder: "请输入购买金额",
                className: "",
                maxLength: "10"
            });
            var selPayBeforeData = App.storage.get("selPayBeforeData");
            if (selPayBeforeData) {
                if (selPayBeforeData.amountInput != 0) {
                    this.$("#amountInput").customInput("value", utils.string.numberFormat(selPayBeforeData.amountInput));
                    //输入金额
                }
                this.$("#interest").text(selPayBeforeData.interest);
                //预期收益
                //购买协议协议
                if (selPayBeforeData.checkbox) {
                    this.toggleCheckbox();
                }
                //选择支付方式
                if (selPayBeforeData.payMentMethod == 1) {
                    this.$("#selPaymentMethod p:last").text(utils.string.numberFormat(selPayBeforeData.balance));
                } else if (selPayBeforeData.payMentMethod == 2) {
                    this.$("#selPaymentMethod p:last").text(utils.string.numberFormat(selPayBeforeData.dhBalance));
                } else {
                    this.$("#selPaymentMethod p:last").text(utils.string.numberFormat(selPayBeforeData.totalBalance) + "=" + utils.string.numberFormat(selPayBeforeData.balance) + "+" + utils.string.numberFormat(selPayBeforeData.dhBalance));
                }
                this.$("#selPaymentMethod").attr("payMethodAttr", selPayBeforeData.payMentMethod);
            }
        },

        submit: function (event) {
            event.stopPropagation();
            var self = this;
            var check = this;
            var financeProductData = {};

            var amount = this.$("#amountInput").customInput("value").replace(/,/g, "");

            var account = this.accountList[0];
            if (!this.validate(amount)) {
                return;
            }
            if (this.submitFlag) {
                return;
            }
            utils.native.talkingDataTrackEvent("2.0理财产品购买验密");
            CustomPwdInput.customPwdInput(function (password) {
                self.submitFlag = true;
                financeProductData.amt = amount;
                financeProductData.accNo = account.accountNo;
                financeProductData.password = utils.crypto.RSAKey.encrypt(password, config.base.rsa_public_key);
                financeProductData.sm2Pwd = utils.sm2.SM2Key.encrypt(password, config.base.sm2_public_key);
                financeProductData.productId = self.financeProductData.prdCode;
                financeProductData.paymentType = self.$("#selPaymentMethod").attr("payMethodAttr");
                financeProductData.productType = self.financeProductData.type;

                //选择支付方式
                var params = financeProductData;

                BuyModel.toBuyForm({
                    "params": params,
                    "callback": function (response) {
                        var promise = dreamModel.qryDreamState();

                        promise.done(_.bind(function (arg1) {
                            var arg1 = arg1.object.outExists;

                            App.storage.set("financeProductData", response.object);
                            App.storage.remove("selPayBeforeData");
                            //选择支付方式缓存信息
                            App.requester.storage.remove("lcProductMoneyQry");
                            App.requester.storage.remove("currentToFixedTransferBalance");
                            App.requester.storage.remove("loginedAccountInfo");
                            //0-不存在，1-存在
                            if (arg1 == 1) {
                                App.navigate("financialProducts/buy/finish", true);
                            } else {
                                utils.native.versionInformation(function (data) {
                                    vs = data.version;
                                    if (vs.replace(/\./g, "") * 1 >= 208) {
                                        App.navigate('dream/dream/dereamOpen', true);
                                    } else {
                                        App.navigate("financialProducts/buy/finish", true);
                                    }
                                });

                            }
                        }, this));

                        promise.fail(function (err) {
                            utils.dialog.toast(err.message);
                        });

                    },
                    "errorCallback": _.bind(function (response) {
                        self.submitFlag = false;
                        utils.dialog.alert(response.message);
                    }, this)
                });
            });

        },

        _onCustomInputFocusSelAmount: function () {
            var num = this.$("#amountInput").customInput("value");
            num = num.replace(/\D/gi, "");
            var num = this.$("#amountInput").customInput("value", num);
            var num = this.$("#amountInput").customInput("value");
            var interestBaseDays = (this.$("#interestBaseDays").val() || '').replace(/,/g, "");
            var planRate = this.financeProductData.planRate;
            var PlanRateRemark = this.financeProductData.planRateRemark;

            //年化收益率
            var plan = planRate * 0.01
            var PlanRateRemarks = PlanRateRemark * 0.01
            var year = 365;
            if (this.financeProductData.fnType == 1) {
                var interest = utils.string.numberFormat(plan * 1 / year * num)
                if (amountInput == "") {
                    this.$("#interest").text("");
                }
            } else if (this.financeProductData.fnType == 2) {
                var interest = utils.string.numberFormat(PlanRateRemarks * 1 / year * num)
                if (amountInput == "") {
                    this.$("#interest").text("");
                }

            } else {
                var interest = utils.string.numberFormat(num * plan / year * interestBaseDays)

                if (amountInput == "") {
                    this.$("#interest").text("");

                }

            }

            this.$("#interest").text(interest + "(元)");
            //智能选择支付方式
            var dhBalance = parseFloat(this.model.get("dhBalance"));
            //平安盈（大华）
            var totalBalance = parseFloat(this.model.get("totalBalance"));
            //活期余额+平安盈（大华）
            if (num <= parseFloat(this.balance)) {
                this.$("#selPaymentMethod").attr("payMethodAttr", "1");
                this.$("#selPaymentMethod p:first").text("活期余额");
                this.$("#selPaymentMethod p:last").text(utils.string.numberFormat(this.balance));
            } else {
                this.$("#selPaymentMethod").attr("payMethodAttr", "3");
                this.$("#selPaymentMethod p:first").text("活期余额+平安盈(大华)");
                this.$("#selPaymentMethod p:last").text(utils.string.numberFormat(totalBalance) + "=" + utils.string.numberFormat(this.balance) + "+" + utils.string.numberFormat(dhBalance));
            }
        },
        validate: function (amount, password) {
            var balance = this.balance, unitAmount = this.financeProductData.unitAmount, maxAmount = this.financeProductData.maxAmount, minAmount = this.financeProductData.minAmount;
            var sf = this;
            if (amount == "") {
                safeKeyBoardHelper.setCustomValidity({
                    id: "amountInput",
                    message: "请输入购买金额",
                    maxLength: 9
                });
                return false;
            }

            if (isNaN(amount)) {
                safeKeyBoardHelper.setCustomValidity({
                    id: "amountInput",
                    message: "购买金额输入不合法"

                });
                return false;
            }

            if (parseFloat(amount) > parseFloat(this.model.get("totalBalance"))) {
                safeKeyBoardHelper.setCustomValidity({
                    id: "amountInput",
                    message: "账户余额不足"
                });
                return false;
            }

            if (parseFloat(amount) < parseFloat(minAmount)) {
                safeKeyBoardHelper.setCustomValidity({
                    id: "amountInput",
                    message: "此产品投资起点为" + sf.financeProductData.minAmount + "元,请输入足够的金额"
                });
                return false;
            }

            if (parseFloat(amount) > parseFloat(maxAmount)) {
                safeKeyBoardHelper.setCustomValidity({
                    id: "amountInput",
                    message: "购买金额不能大于" + sf.financeProductData.maxAmount + "元."
                });
                return false;
            }

            if (parseFloat(amount) % parseFloat(unitAmount) != 0) {
                safeKeyBoardHelper.setCustomValidity({
                    id: "amountInput",
                    message: "购买金额必须为" + sf.financeProductData.unitAmount + "整数倍"
                });
                return false;
            }

            if (!this.ui.checkbox.eq(0).hasClass('on')) {
                utils.dialog.toast("请阅读并同意协议！");
                return false;
            }
            return true;

        },
        toggleCheckbox: function () {
            var checkbox = this.ui.checkbox.eq(0);
            checkbox.toggleClass("on");
        },
        openBookLink: function (e) {
            e.stopPropagation();
            var shortName = this.financeProductData.shortName;
            utils.window.open({
                title: "产品说明",
                url: "http://bank.pingan.com/licaichanpin/" + shortName + ".shtml"
            });
        },

        /**
         * wuwenjun059
         * 选择支付方式
         *
         */
        selPaymentMethod: function () {
            this.formInputData();
            App.navigate("common/selPaymentMethod/selPaymentMethod", true);
        },

        /**
         * wuwenjun059
         * 缓存页面数据
         *
         */
        formInputData: function () {
            var data = {};
            data.amountInput = this.$("#amountInput").customInput("value").replace(/,/g, '') * 1;
            //购买金额;
            data.interest = this.$("#interest").text();
            //预期收益
            data.payMentMethod = this.$("#selPaymentMethod").attr("payMethodAttr");
            //支付方式
            data.balance = this.model.get("balance");
            //余额
            data.dhBalance = this.model.get("dhBalance");
            //平安盈（大华）
            data.totalBalance = this.model.get("totalBalance");
            //活期余额+平安盈（大华）
            data.checkbox = this.$("#checkbox").hasClass("on");
            //是否同意协议
            data.selPayBackUrl = "financialProducts/buy/input";
            App.storage.set("selPayBeforeData", data);
        }
    });
});
