/**
 * @author EX-yangjingpeng001
 *
 * 功能描述：基金定投controller
 */
define(function (require, exports, module) {
	var IndexView = require("../view/fixedInvestment/index");
	var PaymentWayView = require("../view/fixedInvestment/paymentWay");
	var StopWayView = require("../view/fixedInvestment/stopWay");
	var PeriodsView = require("../view/fixedInvestment/periods");
	var FinishView = require("../view/fixedInvestment/finish");
	var accountModel = require("mod/common/model/accountModel");
	var FundFixedInestmentContronller = module.exports = Controller.extend({
			actions : {
			    "index" : "index",
				"index/:flag" : "index",
				"toPaymentWayPage" : "toPaymentWayPage",
				"toStopWayPage" : "toStopWayPage",
				"toPeriodsPage" : "toPeriodsPage",
				"toFinishPage" : "toFinishPage"

			},

			/*
			 * 渲染基金定投输入页
			 *
			 * 入参：flag(标志从哪进入的基金定投输入页面，1：从扣款方式，终止方式，定投周期进入基金定投输入页面)
			 *
			 * 返回：无
			 */
			index : function (flag) {
				App.header.reset({
					"title" : "基金定投",
					"leftButtonContent" : "@back",
					"leftButtonHandler" : function () {
						App.storage.remove("myInvestment/commendProducts/curProObj");
                        var fundModel = App.storage.get('products/detail/fund');
                        var backUrl = fundModel.get('backUrl');
                        if(backUrl){
                            App.navigate(backUrl, true);
                            return;
                        }else{
                            App.navigate("products/index/index/selectFund", true);
                            return;
                        }
                        
					}
				});

				App.footer.reset({
					"visible" : false
				});
				
				if(flag){
				    App.container.show(new IndexView({
                        model : App.storage.get("myInvestment/commendProducts/curProObj")
                    }));
				}else{
                    accountModel.asycAccountInfo().done(function(response){
                        App.storage.get("UserInfo").set("balance", response.object.balance);
                        App.container.show(new IndexView({
                            model : App.storage.get("myInvestment/commendProducts/curProObj")
                        }));
                    }).fail(function(error){utils.dialog.alert(error.message);});
				}
				
                
				
			},
            
            /*
             * 渲染基金定投扣款方式设置页面
             *
             * 入参：无
             *
             * 返回：无
             */
			toPaymentWayPage : function () {
				App.header.reset({
					"title" : "扣款方式设置",
					"leftButtonContent" : "@back",
					"leftButtonHandler" : function () {
						App.navigate("fund/fundFixedInvestment/index/1", true);
					}
				});

				App.container.show(new PaymentWayView({
						model : App.storage.get("myInvestment/commendProducts/curProObj")
					}));
			},

            /*
             * 渲染基金定投终止方式设置输入页面
             *
             * 入参：无
             *
             * 返回：无
             */
			toStopWayPage : function () {
				App.header.reset({
					"title" : "终止方式设置",
					"leftButtonContent" : "@back",
					"leftButtonHandler" : function () {
						App.navigate("fund/fundFixedInvestment/index/1", true);
					}
				});

				App.container.show(new StopWayView({
						model : App.storage.get("myInvestment/commendProducts/curProObj")
					}));
			},
            
            
            /*
             * 渲染基金定投投资周期设置输入页面
             *
             * 入参：无
             *
             * 返回：无
             */
			toPeriodsPage : function () {
				App.header.reset({
					"title" : "投资周期设置",
					"leftButtonContent" : "@back",
					"leftButtonHandler" : function () {
						App.navigate("fund/fundFixedInvestment/index/1", true);
					}
				});

				App.container.show(new PeriodsView({
						model : App.storage.get("myInvestment/commendProducts/curProObj")
					}));
			},
            
            /*
             * 渲染基金定投成功页面
             *
             * 入参：无
             *
             * 返回：无
             */
			toFinishPage : function () {
				App.storage.remove("myInvestment/commendProducts/curProObj");
				App.header.reset({
					"title" : "提交成功",
					"leftButtonContent" : "@back",
					"leftButtonHandler" : function () {
						App.navigate("products/index/index/selectFund", true);
					}
				});
				App.container.show(new FinishView());
			}
		});
});
