/**
 * 追加购买货币型基金
 * liujun 2015/8/25
 */
define(function (require, exports, module) {
    var Form = require("component/form");
    var safeKeyBoardHelper = require("component/customInput.helper");
    var InputTpl = require("text!../../template/addPurchase/addMonetary.html");
    var CustomPwdInput = require("component/password/customPwdInput");
    var BuyModel = require("../../model/buy");
    var InputView = module.exports = Form.extend({
        template: _.template(InputTpl),
        ui: {
            "checkbox": "#checkbox",
            "booksLink": "#booksLink a"

        },
        events: {
            "tap #submitBtn": "submit",
            // "tap #setting" : "setting",
            "click @ui.checkbox": "toggleCheckbox",
            "click @ui.booksLink": "openBookLink",
            "tap #selPaymentMethod": "selPaymentMethod",
            "customInputKeyup  #amountInput": "_onCustomInputFocusSelAmount"
        },

        initialize: function (options) {
            prdPropertyData = App.storage.get("myPropertyData");
            FundsData = options.model.get("FundsData");
            balance = options.model.get("balance");
            accountList = options.model.get("accountList");
            submitFlag = false;
        },

        onShow: function () {
            var temp = "";
            temp = FundsData.detailDTO.appAmt;
            if (!temp || temp == "") {
                temp = "请输入金额";
            } else {
                temp = parseInt(FundsData.detailDTO.appAmt, 10) + "元起追加";
            }
            this.$("#amountInput").customInput({
                type: "decimal",
                placeholder: temp,
                className: "safeKeyBoard",
                maxLength: "12"
            });

            var selPayBeforeData = App.storage.get("selPayBeforeData");
            if (selPayBeforeData) {
                if (selPayBeforeData.amountInput != 0) {
                    this.$("#amountInput").customInput("value", utils.string.numberFormat(selPayBeforeData.amountInput)); //输入金额
                }
                //选择支付方式
                if (selPayBeforeData.payMentMethod == 1) {
                    this.$("#selPaymentMethod p:last").text(utils.string.numberFormat(selPayBeforeData.balance));
                } else if (selPayBeforeData.payMentMethod == 2) {
                    this.$("#selPaymentMethod p:last").text(utils.string.numberFormat(selPayBeforeData.dhBalance));
                } else {
                    this.$("#selPaymentMethod p:last").text(utils.string.numberFormat(selPayBeforeData.totalBalance) + "=" + utils.string.numberFormat(selPayBeforeData.balance) + "+" + utils.string.numberFormat(selPayBeforeData.dhBalance));
                }
                this.$("#selPaymentMethod").attr("payMethodAttr", selPayBeforeData.payMentMethod);
            }
        },
        //货币型基金追加购买提交
        submit: function (event) {
            event.stopPropagation();
            var self = this;
            var check = this;
            var addFundsData = {};

            var amount = this.$("#amountInput").customInput("value").replace(/,/g, "");


            if (submitFlag) {
                return;
            } else {
                if (!this.validate(amount)) {
                    return;
                }
                CustomPwdInput.customPwdInput(function (password) {
                    submitFlag = true;
                    addFundsData.amt = amount;
                    addFundsData.prdCode = prdPropertyData.prdCode;   //基金代码
                    addFundsData.password = utils.crypto.RSAKey.encrypt(password, config.base.rsa_public_key);
                    addFundsData.sm2Pwd = utils.sm2.SM2Key.encrypt(password, config.base.sm2_public_key);
                    addFundsData.paymentType = self.$("#selPaymentMethod").attr("payMethodAttr");  //选择支付方式
                    var params = addFundsData;
                    BuyModel.fundBuy({
                        "params": params,
                        "callback": function (response) {
                            //删除我的资产缓存信息
                            App.requester.storage.remove("loginedAccountInfo");
                            App.storage.remove("selPayBeforeData");   //删除选择支付方式缓存信息
                            App.navigate("fund/buy/addToSuccess", true);
                            // App.requester.storage.remove("lcProductMoneyQry");
                            // App.requester.storage.remove("currentToFixedTransferBalance");
                        },
                        "errorCallback": _.bind(function (response) {
                            submitFlag = false;
                            utils.dialog.alert(response.message);
                        }, this)
                    });
                });
            }

        },

        //货币型基金追加购买校验
        validate: function (amount, password) {
            if (amount == "") {
                safeKeyBoardHelper.setCustomValidity({
                    id: "amountInput",
                    message: "请输入金额",
                    maxLength: 9
                });
                return false;
            }
            if (parseFloat(amount) > parseFloat(this.model.get("totalBalance"))) {
                safeKeyBoardHelper.setCustomValidity({
                    id: "amountInput",
                    message: "账户余额不足"
                });
                return false;
            }
            if (parseFloat(amount) < FundsData.detailDTO.appAmt) {
                safeKeyBoardHelper.setCustomValidity({
                    id: "amountInput",
                    message: "购买金额不能小于追加购买下限"
                });
                return false;
            }
            return true;
        },

        /**
         * wuwenjun059
         * 智能选择支付方式
         *
         */
        _onCustomInputFocusSelAmount: function () {
            var num = parseFloat(this.$("#amountInput").customInput("value"));
            var dhBalance = parseFloat(this.model.get("dhBalance")); //平安盈（大华）
            var totalBalance = parseFloat(this.model.get("totalBalance")); //活期余额+平安盈（大华）
            if (num <= parseFloat(balance)) {
                this.$("#selPaymentMethod").attr("payMethodAttr", "1");
                this.$("#selPaymentMethod p:first").text("活期余额");
                this.$("#selPaymentMethod p:last").text(utils.string.numberFormat(balance));
            } else {
                this.$("#selPaymentMethod").attr("payMethodAttr", "3");
                this.$("#selPaymentMethod p:first").text("活期余额+平安盈(大华)");
                this.$("#selPaymentMethod p:last").text(utils.string.numberFormat(totalBalance) + "=" + utils.string.numberFormat(balance) + "+" + utils.string.numberFormat(dhBalance));
            }
        },

        /**
         * wuwenjun059
         * 选择支付方式
         *
         */
        selPaymentMethod: function () {
            this.formInputData();
            App.navigate("common/selPaymentMethod/selPaymentMethod", true);
        },

        /**
         * wuwenjun059
         * 缓存页面数据
         *
         */
        formInputData: function () {
            var data = {};
            data.amountInput = this.$("#amountInput").customInput("value").replace(/,/g, '') * 1; //购买金额;
            data.payMentMethod = this.$("#selPaymentMethod").attr("payMethodAttr"); //支付方式
            data.balance = this.model.get("balance");  //余额
            data.dhBalance = this.model.get("dhBalance"); //平安盈（大华）
            data.totalBalance = this.model.get("totalBalance"); //活期余额+平安盈（大华）
            data.selPayBackUrl = "fund/buy/addMonetary";
            App.storage.set("selPayBeforeData", data);
        }
    });
});
