/**
 * @author zhoushiwen
 * @ date ${date}
 * @company 中国平安
 */
define(function (require, exports, module) {
    var Form = require("component/form");
    var safeKeyBoardHelper = require("component/customInput.helper");
    var InputTpl = require("text!../../template/buy/risk.html");
    var CustomPwdInput = require("component/password/customPwdInput");
    var fund_risk = config.urls.get("fund_riskexam");

    var BuyModel = require("../../model/buy");
    var InputView = module.exports = Form.extend({
        template: _.template(InputTpl),
        ui: {
            "checkbox": "#checkbox",
            "booksLink": "#booksLink a"

        },
        events: {
            "tap #submitBtn": "submit",
            "tap #setting": "setting",
            "click @ui.checkbox": "toggleCheckbox",
            "click @ui.booksLink": "openBookLink"
        },
        //短信设置
        setting: function () {
            App.navigate("fund/buy/setting", true);

        },

        onShow: function () {
            bankcode = App.storage.get('UserInfo').get('accNumber'); //获取用户银行卡号
            mob = App.storage.get('UserInfo').get('telephoneNum'); //获取用户手机号码
            email = App.storage.get('UserInfo').get('email'); //获取用户邮箱

            $("#code").text(bankcode); //将卡号渲染页面
            $("#mob").val(mob);		   //将手机号码渲染页面
            $("#email").text(email);   //将邮箱渲染页面
        },
        submit: function (event) {
            event.stopPropagation();
            var self = this;
            var check = this;
            var riskdata = {};
            styledata = App.storage.get("styledata"); //获取短信设置信息
            styledatas = App.storage.get("styledatas"); //获取用户原有短信设置信息
            //如果用户重新设置了短信styledata就不为空 重新请求接口 若为空则不操作
            if (styledata != undefined && styledata != null && styledata != []) {
                //获取当前短信设置的状态发送给后台
                alert("用户操作了短信设置");

            } else {
                //请求接口将用户新选择的设置传入后台

            }

            var addinput = $("#addinput").val(); //获取用户输入的地址
            var mobinput = $("#mob").val(); 	//获取用户输入的手机号码

            if (!this.validate(addinput, mobinput)) {
                return;
            }
            CustomPwdInput.customPwdInput(function (password) {
                riskdata.adrDet = addinput;
                riskdata.password = utils.crypto.RSAKey.encrypt(password, config.base.rsa_public_key);
                riskdata.sm2Pwd = utils.sm2.SM2Key.encrypt(password, config.base.sm2_public_key);
                riskdata.mobile = mob;
                riskdata.email = email;

                var params = riskdata;

                BuyModel.fundSign({
                    "params": params,
                    "callback": function (response) {
                        App.navigate("fund/buy/successful	", true);
                        App.requester.storage.remove("lcProductMoneyQry");
                        App.requester.storage.remove("currentToFixedTransferBalance");
                    },
                    "errorCallback": _.bind(function (response) {
                        utils.dialog.alert(response.message);
                    }, this)
                });
            });

        },

        /*
         amount 地址
         * 	 tel 电话号码
         * */



        validate: function (amount, tel) {
            var sf = this;
            if (amount == "") {
                safeKeyBoardHelper.setCustomValidity({
                    id: "amountInput",
                    message: "请输入地址信息",
                    maxLength: 9
                });
                return false;
            }

            if (!utils.validate.specialCharacter(amount)) {
                utils.dialog.alert("地址不能有特殊字符");
                return false;
            }
            var len = amount.length;
            if (len < 4) {
                utils.dialog.alert("地址长度不符合");

                return false;

            }
            if (tel == "") {
                safeKeyBoardHelper.setCustomValidity({
                    id: "amountInput",
                    message: "请输入手机号码"
                });
                return false;
            }
            mob = App.storage.get('UserInfo').get('telephoneNum'); //获取用户手机号码

            if (mob == tel) {
                if (!this.ui.checkbox.eq(0).hasClass('on')) {
                    utils.dialog.toast("请阅读并同意协议！");
                    return false;
                }
                return true;


            } else {

                var telReg = !!tel.match(/^(0|86|17951)?(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/);
                if (telReg == false) {
                    utils.dialog.alert("请输入正确手机号码");
                    return false;

                }

            }

            if (!this.ui.checkbox.eq(0).hasClass('on')) {
                utils.dialog.toast("请阅读并同意协议！");
                return false;
            }
            return true;

        },
        toggleCheckbox: function () {
            var checkbox = this.ui.checkbox.eq(0);
            checkbox.toggleClass("on");
        },
        openBookLink: function (e) {
            e.stopPropagation();
            utils.window.open({
                title: "产品说明",
                url: fund_risk
            });
        }


    });
});
