/**
 * @author EX-yangjingpeng001
 *
 * 功能描述：基金定投view
 */

define(function(require, exports, module){
	var Form = require("component/form");
	var safeKeyBoardHelper = require("component/customInput.helper");
	var IndexTpl = require("text!../../template/fixedInvestment/index.html");
	var FundFixedInvestmentView = module.exports = Form.extend({
		template: _.template(IndexTpl),

		events:{
			"customInputFocusIn #paymentAmtInput":"_onCustomInputFocusInAmount",
			"customInputFocusOut #paymentAmtInput":"_onCustomInputFocusOutAmount",
			"tap .payment_way_container" : "toPaymentWayPage",
			"datepicker:dateSelect .payment_date_container" : "selectDate",
			"tap .stop_way_container" : "toStopWayPage",
			"tap .periods_container" : "toPeriodsPage",
			"tap .fund_fixed_protocol" : "checkFixedProtocol",
			"tap .fund_fixed_prorocol_url" : "toFixedProtocolPage",
			"tap #submitBtn" : "submit"
		},

		templateHelpers : {
			evalMarkup : function (val) {
				var monthMarkup = Number(val);
				if( -1 == monthMarkup || !monthMarkup ){
					monthMarkup = '---';
				}else{
					monthMarkup = ((monthMarkup - 1)*100).toFixed(2);
				}
				return monthMarkup;
			}
		},

		initialize : function(){
			this.fundFixedInvestment = this.model;
		},

		onRender : function(){
			// //首次扣款金额框组件初始化
			// this.$("#firstPaymentAmtInput").customInput({
			//     type: "decimal",
			//     placeholder: "请输入金额(元)",
			//     maxLength: 11
			// });
			// //为首次扣款金额框赋值
			// this.$("#firstPaymentAmtInput").customInput("value",this.fundFixedInvestment.get("fistDeductAmt"));

			//定投金额
			var minInvestAmt = this.fundFixedInvestment.get("minInvestAmt");
			var firstAmt = this.fundFixedInvestment.get("firstAmt");
			var investAmt = Number(minInvestAmt) > Number(firstAmt) ? minInvestAmt : firstAmt;
			var amtTip = '请输入金额(元)';
				amtTip = '最低定投金额' + utils.string.formatMoneyNumber(investAmt) + '元';
			this.$("#paymentAmtInput").customInput({
				type: "decimal",
				placeholder: amtTip,
				maxLength: 11
			});
			//为定投金额框赋值
			this.$("#paymentAmtInput").customInput("value",this.fundFixedInvestment.get("amt"));
		},

		/*
		 * 日历选择
		 *
		 * 入参：event(dom对象)，_this(datepicker对象),value(所选择的日期)
		 *
		 * 返回：无
		 */
		selectDate : function(event, _this, value){
			this.$("#firstPaymentDate").text(value);
			this.$(event.currentTarget).attr("data-initDate",value);
			this.fundFixedInvestment.set("startInvestDate",value);
		},

		/*
		 * 跳转扣款方式设置页面
		 *
		 * 入参：无
		 *
		 * 返回：无
		 */
		toPaymentWayPage : function(){
			this.formData();
			App.navigate("fund/fundFixedInvestment/toPaymentWayPage",true);
		},

		/*
		 * 跳转终止方式设置页面
		 *
		 * 入参：无
		 *
		 * 返回：无
		 */
		toStopWayPage : function(){
			this.formData();
			App.navigate("fund/fundFixedInvestment/toStopWayPage",true);
		},

		/*
		 * 跳转定投周期设置页面
		 *
		 * 入参：无
		 *
		 * 返回：无
		 */
		toPeriodsPage : function(){
			this.formData();
			App.navigate("fund/fundFixedInvestment/toPeriodsPage",true);
		},

		/*
		 * 确定按钮提交事件
		 *
		 * 入参：无
		 *
		 * 返回：无
		 */
		submit : function(){
			if(!this.validate()) return;
			var data = {};
			// var reduceWay = this.fundFixedInvestment.get("reduceWay");
			// var reduceWayValue = this.fundFixedInvestment.get("reduceWayValue").replace(/,/g,"");
			// switch(reduceWay){
			//     case "0": data.amt = reduceWayValue; break;//固定金额
			//     case "1": data.reductRate = reduceWayValue; break;//扣款比例
			//     case "2": data.increaseAmt = reduceWayValue; break;//递增金额
			// }
			// data.reduceWay = reduceWay;//扣款方式
			data.reduceWay = '0';//扣款方式:按固定金额扣款
			data.amt = this.$("#paymentAmtInput").customInput("value").replace(/,/g, ""); //固定金额
			data.startInvestDate = this.fundFixedInvestment.get("startInvestDate");
			//data.fistDeductAmt = this.$("#firstPaymentAmtInput").customInput("value").replace(/,/g,"");
			//data.fistDeductAmt = '100';//首次扣款金额
			var overFlag = this.fundFixedInvestment.get("overFlag");
			var overWayValue = this.fundFixedInvestment.get("overWayValue").replace(/,/g,"");
			data.overFlag = overFlag;//终止模式
			switch(overFlag){
				case "0" :
					data.investTimes = overWayValue;
					break;//投资期数
				case "1" :
					data.endDate = overWayValue;
					break;//结束日期
				case "2" :
					data.endTotAmt = overWayValue;
					break;//累计扣款金额
			}
			data.period = '0';//投资周期，‘每月’
			data.span = '1';
			// var period = this.fundFixedInvestment.get("period");
			// var periodValue = this.fundFixedInvestment.get("periodValue");
			// data.period = period;//投资周期
			// if(period == "0"){
			//     data.span = "1";//投资间隔(每月)
			// }else{
			//     data.span = periodValue;//投资间隔(周，天)
			// }
			data.prdKind = this.fundFixedInvestment.get("prdAttr");//产品类型
			data.prdCode = this.fundFixedInvestment.get("prdCode");//基金代码
			var CustomPwdInput = require("component/password/customPwdInput");
			CustomPwdInput.customPwdInput(function(pwd){
				data.password = utils.crypto.RSAKey.encrypt(pwd, config.base.rsa_public_key);
				//基金定投接口
				App.request("fundFix", {
					data : data,
					success:function(){
						App.navigate("fund/fundFixedInvestment/toFinishPage", true);
					},
					error:function(error){
						utils.dialog.toast(error.message);
					}
				});
			});
		},

		/*
		 * 页面数据组装
		 *
		 * 入参：无
		 *
		 * 返回：无
		 */
		formData : function(){
			// var fistDeductAmt = this.$("#firstPaymentAmtInput").customInput("value");
			// this.fundFixedInvestment.set("fistDeductAmt",fistDeductAmt);
			var amt = this.$("#paymentAmtInput").customInput("value");
			this.fundFixedInvestment.set("amt", amt);
			App.storage.set("myInvestment/commendProducts/curProObj", this.fundFixedInvestment);
		},

		/*
		 * 页面数据校验
		 *
		 * 入参：无
		 *
		 * 返回：无
		 */
		validate : function(){
			// if(!this.fundFixedInvestment.get("reduceWay")){
			//     utils.dialog.toast("请选择扣款方式");
			//     return false;
			// }

			// if(!this.fundFixedInvestment.get("startInvestDate")){
			//     utils.dialog.toast("请选择定投日期");
			//     return false;
			// }

			// var day = this.fundFixedInvestment.get("startInvestDate").split("-")[2];
			// if(day<1 || day>28){
			//     utils.dialog.toast("请在每月1日至28日间选择定投日期");
			//     return false;
			// }

			// var firstPaymentAmt = this.$("#firstPaymentAmtInput").customInput("value").replace(/,/g,"");

			// if(!firstPaymentAmt){
			//     utils.dialog.toast("请输入首次扣款金额");
			//     return false;
			// }

			// if(parseFloat(firstPaymentAmt)<this.fundFixedInvestment.get("firstAmt")){
			//     utils.dialog.toast("首次扣款金额不能少于首次购买下限");
			//     return false;
			// }

			// if(parseFloat(firstPaymentAmt)>App.storage.get("UserInfo").get("balance")){
			//     utils.dialog.toast("首次扣款金额不能大于可用余额");
			//     return false;
			// }

			//this.reduceWayValue = this.$("#fixedAmtInput").customInput("value").replace(/,/g,"");

			var amt = this.$("#paymentAmtInput").customInput("value").replace(/,/g,"");
			if(!amt || amt <=0){
				utils.dialog.toast("请输入定投金额");
				return false;
			}
			if(isNaN(amt)){
				utils.dialog.toast("定投金额输入有误");
				return false;
			}
			var minInvestAmt = Number(this.fundFixedInvestment.get("minInvestAmt")||0);
			var firstAmt = Number(this.fundFixedInvestment.get("firstAmt") || 0);
			var investAmt = minInvestAmt > firstAmt ? minInvestAmt : firstAmt;
			if(Number(amt) < investAmt){
				utils.dialog.toast("定投金额不能少于最低定投金额");
				return false;
			}

			if(!this.fundFixedInvestment.get("startInvestDate")){
				utils.dialog.toast("请选择定投日期");
				return false;
			}

			var day = this.fundFixedInvestment.get("startInvestDate").split("-")[2];
			if(day<1 || day>28){
				utils.dialog.toast("请在每月1日至28日间选择定投日期");
				return false;
			}

			// if(parseFloat(amt)>App.storage.get("UserInfo").get("balance")){
			//     utils.dialog.toast("首次扣款金额不能大于可用余额");
			//     return false;
			// }

			if(!this.fundFixedInvestment.get("overFlag")){
				utils.dialog.toast("请选择终止方式");
				return false;
			}

			if(this.fundFixedInvestment.get("overFlag")=="1"){
				var temp1 = this.fundFixedInvestment.get("startInvestDate");
				var temp2 = this.fundFixedInvestment.get("overWayValue");
				if(utils.date.diffDate(temp1,temp2)<=0){
					utils.dialog.toast("结束日期要大于首次扣款日期");
					return false;
				}
			}


			// if(!this.fundFixedInvestment.get("period")){
			//     utils.dialog.toast("请选择定投周期");
			//     return false;
			// }

			if(!this.$(".fund_fixed_protocol").hasClass("on")){
				utils.dialog.toast("请阅读并同意基金定投协议");
				return false;
			}

			return true;
		},

		/*
		 * checkbox选择
		 *
		 * 入参：无
		 *
		 * 返回：无
		 */
		checkFixedProtocol : function(event){
			this.$(event.currentTarget).toggleClass("on");
		},

		/*
		 * 跳转定投类业务协议页面
		 *
		 * 入参：无
		 *
		 * 返回：无
		 */
		toFixedProtocolPage : function(){
			utils.window.open({
				title: "定投类业务协议",
				url: config.urls.get("fixedProtocolUrl")
			});
		},

		/*
		 * 首次扣款金额框获取焦点事件
		 *
		 * 入参：无
		 *
		 * 返回：无
		 */
		_onCustomInputFocusInAmount: function(){
			safeKeyBoardHelper.focusIn({ id:"paymentAmtInput" });
		},

		/*
		 * 首次扣款金额框失去焦点事件
		 *
		 * 入参：无
		 *
		 * 返回：无
		 */
		_onCustomInputFocusOutAmount: function(){
			safeKeyBoardHelper.focusOut({ id:"paymentAmtInput" });
		}
	});
});
