define(function(require, exports, module){
    var Form = require("component/form");
    var PeriodsTpl = require("text!../../template/fixedInvestment/periods.html");
    var PeriodsView = module.exports = Form.extend({
        template : _.template(PeriodsTpl),
        
        events : {
            "tap .periods_choose" : "periodsChoose",
            "tap #submitBtn" : "submit"
            
        },
        
        period : "0",
        
        periodValue : "",
        
        initialize : function(options){
            this.fundFixedInvestment = options.model;
        },
        
        
        periodsChoose : function(event){
            this.$(".periods_choose").find("i").removeClass("iconA59");
            this.$(".periods_choose").next().hide();
            var event = this.$(event.currentTarget);
            this.period = event.attr("periodsValue");
            event.find("i").addClass("iconA59");
            if(event.find("i").hasClass("iconA59")) event.next().show();
            else event.next().hide();
        },
        
        submit : function(){
            if(!this.validate()) return;
            
            this.fundFixedInvestment.set("period",this.period);
            this.fundFixedInvestment.set("periodValue",parseInt(this.periodValue));
            
            App.storage.set("myInvestment/commendProducts/curProObj",this.fundFixedInvestment);
            App.navigate("fund/fundFixedInvestment/index/1",true);
              
        },
        
        validate : function(){
            if(this.period == "0"){
                this.periodValue = "1";
                return true;
            }else if(this.period == "1"){
                this.periodValue = this.$("#periodsWeeksInput").val();
                if(!this.periodValue || this.periodValue<=0){
                    utils.dialog.toast("请输入周数");
                    return false; 
                }
                
                if(!/^[0-9]*[1-9][0-9]*$/.test(this.periodValue) || this.periodValue >52){
                    utils.dialog.toast("N必须为正整数，同时小于52(含)");
                    return false;
                }
               
            }else{
                this.periodValue = this.$("#periodsDayInput").val();
                if(!this.periodValue || this.periodValue <=0){
                    utils.dialog.toast("请输入天数");
                    return false; 
                }
                if(!/^[0-9]*[1-9][0-9]*$/.test(this.periodValue) || this.periodValue >365){
                    utils.dialog.toast("N必须为正整数，同时小于365(含)");
                    return false;
                }
            }
            
            return true;
        }
        
    });
});
