define(function(require, exports, module){
    var Form = require("component/form");
    var safeKeyBoardHelper = require("component/customInput.helper");
    var StopWayTpl = require("text!../../template/fixedInvestment/stopWay.html");
    var StopWayView = module.exports = Form.extend({
        template : _.template(StopWayTpl),
        
        events : {
            "customInputFocusIn #paymentAmtInput":"_onCustomInputFocusInAmount",
            "customInputFocusOut #paymentAmtInput":"_onCustomInputFocusOutAmount",
            "tap .stop_way_choose" : "stopWayChoose",
            "datepicker:dateSelect #stop_date_choose" : "selectDate",
            "tap #submitBtn" : "submit"            
            
        },
        
        
        overFlag : "0",
        
        overWayText : ["投资期数","结束日期","累积扣款金额"],
        
        overWayValue : "",
        
        initialize:function(options){
            this.fundFixedInvestment = options.model;
        },
        
        onRender : function(){
            this.$("#paymentAmtInput").customInput({
                type: "decimal",
                placeholder: "请输入金额(元)",
                maxLength: 11
            });
        },
        
        stopWayChoose : function(event){
            this.$(".stop_way_choose").find("i").removeClass("iconA59");
            this.$(".stop_way_choose").next().hide();
            var event = this.$(event.currentTarget);
            this.overFlag = event.attr("stopWayValue");
            event.find("i").addClass("iconA59");
            
            if(this.overFlag == "1") return;
            
            if(event.find("i").hasClass("iconA59")) event.next().show();
            else event.next().hide();
        },
        
        submit : function(){
            if(!this.validate()) return;
            
            this._toFixedInvestmentPage();
        },
        
        _toFixedInvestmentPage : function(){
            this.fundFixedInvestment.set("overFlag",this.overFlag);
            this.fundFixedInvestment.set("overWayValue",this.overWayValue);
            this.fundFixedInvestment.set("overWayText",this.overWayText[this.overFlag]);
            
            App.storage.set("myInvestment/commendProducts/curProObj",this.fundFixedInvestment);
            
            App.navigate("fund/fundFixedInvestment/index/1",true);  
        },
        
        selectDate : function(event, _this, value){
            this.overWayValue = value;
            this.$(event.currentTarget).attr("data-initDate",value);
            this._toFixedInvestmentPage();
        },
        
        _onCustomInputFocusInAmount: function(){
            safeKeyBoardHelper.focusIn({ id:"paymentAmtInput" });
        },
        
        _onCustomInputFocusOutAmount: function(){
            safeKeyBoardHelper.focusOut({ id:"paymentAmtInput" });
        },
        
        validate : function(){
            if(this.overFlag == "0"){
                this.overWayValue = this.$("#investTimesInput").val();
                if(!this.overWayValue || this.overWayValue<=0){
                    utils.dialog.toast("请输入投资期数");
                    return false;
                }
                
                if(!/^[0-9]*[1-9][0-9]*$/.test(this.overWayValue)){
                    utils.dialog.toast("投资期数只能为正整数");
                    return false;
                }
                
                if(this.overWayValue.length>14){
                    utils.dialog.toast("投资期数输入位数过多");
                    return false;
                }
                
                this.overWayValue = parseInt(this.overWayValue)+"";
                
            }else if(this.overFlag == "1"){
                utils.dialog.toast("请选择结束日期");
                return false; 
            }else if(this.overFlag == "2"){
                this.overWayValue = this.$("#paymentAmtInput").customInput("value").replace(/,/g,"");
                if(!this.overWayValue){
                    utils.dialog.toast("请输入累积扣款金额");
                    return false;
                }
                if(isNaN(this.overWayValue) || this.overWayValue<=0){
                    utils.dialog.toast("累积扣款金额输入有误");
                    return false;
                }
            }
            
            return true;
        }
        
        
    });   
});
