/**
 * WUWENJUN059
 * 我的定投View
 * 
 */
define(function(require, exports, module){
    var FormComponent      = require("component/form");
    var PTRScroll = require("component/PTRScroll");
    var fundModel = require("../../model/fundDetails");
    var fundFixTools  = require("../../common/fundFixTools");
    var IndexTpl          = require("text!../../template/fundFixedManage/fundFixedList.html");
    
    var IndexView = module.exports = FormComponent.extend({
        template : _.template(IndexTpl),

        events: {
            "tap #fundFixList li"     : "fundFixedDetails"
        },
        
        onShow : function(){
            var self = this;
            var fundOption = {
                pageIndex:1,
                pageSize:10,
                finishFlag:0
            };
            setTimeout(function(){
                self._initPTRScroll(fundOption);
                self._qryfundListShow(fundOption);
            },300);
            
        },
        
        //初始化上下拉
        _initPTRScroll : function(options){
            var self = this;
            if (this.scroller) {
                this.scroller.destroy();
                delete this.scroller;
            };
            var wHeight=$(window).outerHeight(true);
            var navHeight=this.$("#fundFixTitle").outerHeight(true);
            var listHeight = wHeight-navHeight;
            var dom = $("#scrollContainer").css({"height":listHeight-15,"position":"relative"});
            
            //初始化iscroller
            this.scroller = new PTRScroll(dom[0],{"checkDOMChanges": true,"hideScrollbar":true});
            
            //下拉刷新
            this.pageIndex = 1;
            this.scroller.options.refreshContent = function(refresh){
                self._refreshContent(refresh, 1);
            };

            //上拉加载
            this.scroller.options.loadMoreContent = function(refresh){
                self._loadMoreContent(refresh, self.pageIndex+1);
            };

        },

        //下拉请求数据
        _refreshContent:function(refresh, pageIndex){
            //请求数据
            var fundOption = {
                pageIndex:pageIndex,
                pageSize:10,
                finishFlag:0
            };

            this._qryfundListShow(fundOption);
            refresh();
        },

        //上拉请求数据
        _loadMoreContent:function(refresh, pageIndex){
            //请求数据
            var fundOption = {
                pageIndex:pageIndex,
                pageSize:10,
                finishFlag:0
            };

            this._qryfundListShow(fundOption);
            refresh();
        },

        //展示累计数据
        _qryfundListShow:function(options){
            var self = this;
            //请求数据
            fundModel.qryFundFix({
                url:"qryFundFix",
                data:options,
                callback:function(res){
                    if(res.object.list.length <= 0){
                        self.$("#noFundFixList").show();
                        self.$("#scrollContainer").hide();
                    }else{
                        self._showFundFixList(res, options);
                        self.$("#scrollContainer").show();
                        if(options.pageIndex == 1){
                            App.storage.set("fundFixAllList",res.object.list);
                        }else{
                            var fundFixUpPageList = App.storage.get("fundFixAllList");
                            App.storage.set("fundFixAllList",$.merge(fundFixUpPageList,res.object.list));
                        }
                    }
                    self.scroller && self.scroller.refresh();
                },
                complete: function(){
                    refresh();
                },
                errorCallback:function(res){
                    utils.dialog.alert(res.message);
                }
            });
        },
        
        //刷新数据
        _showFundFixList : function(res,data){
            var self = this;
            var fundHtml = "";
            if(data.pageIndex == 1){
                self.$("#fundFixList>li").remove();
            }
            for(var i=0;i < res.object.list.length;i++){
                var index = self.$("#fundFixList>li").length+i;
                fundHtml += "<li class='dswkb' data-index="+index+">"
                                +"<span class='tac w50 c_999'>"+res.object.list[i].prdName+"</span>"
                                +"<div class='tac w50 c_999 p_r30'>"+fundFixTools.getMyFundFixStatus(res.object.list[i].status)+"</div>"
                                +"<i class='iconA34'></i>"
                            +"</li>";
            }
            this.$("#fundFixList").append(fundHtml);
            if(data.pageIndex * data.pageSize >= res.object.totalRows){
                self.scroller.disablePullUpToLoadMore();
            }else{
                self.scroller.enablePullUpToLoadMore();
            }
        },
        
        //定投详情
        fundFixedDetails : function(e){
            var fundFixData = App.storage.get("fundFixAllList")[$(e.currentTarget).attr("data-index")];
            App.storage.set("fundFixData",fundFixData);
            App.navigate("fund/fundFixedIndex/fixedDetails",true);
        }
        
    });
});
