/**
 * WUWENJUN059
 * 投资周期设置View
 * 
 */
define(function(require, exports, module){
    var IndexTpl          = require("text!../../template/fundFixedManage/fundFixedCycle.html");
    var FormComponent = require("component/form"); 
    
    var IndexView = module.exports = FormComponent.extend({
        template : _.template(IndexTpl),

        events: {
            "tap #monthly,#everyWeek,#daily"     : "selectFixedCycle",
            "input #everyWeekInput,#dailyInput" : "inputCycle",
            "tap #submitBtn" : "getFixedCycle"
        },
        
        onShow : function(){
            //投资周期 cycleNum日/周数、 cycleType周期类型(0月 1周 2日)
            var cycleNum = App.storage.get("cycleNumber");
            var cycleType = App.storage.get("cycleType");
            if(cycleType == "1"){
                this.$("#everyWeek").append("<i class='iconA59'></i>");
                this.$("#everyWeek").next().show();
                this.$("#everyWeekInput").val(cycleNum);
            }else if(cycleType == "2"){
                this.$("#daily").append("<i class='iconA59'></i>");
                this.$("#daily").next().show();
                this.$("#dailyInput").val(cycleNum);
            }else if(cycleType == "0"){
                this.$("#monthly").append("<i class='iconA59'></i>");
            }
        },
        
        //选择定投周期
        selectFixedCycle : function(e){
            this.$("#selectCycle li i").remove();
            $(e.currentTarget).append("<i class='iconA59'></i>");
            if($(e.currentTarget).attr("id") == "everyWeek"){
                $(e.currentTarget).next().show();
                this.$("#daily").next().hide();
                this.$("#dailyInput").val("");
            }else if($(e.currentTarget).attr("id") == "daily"){
                $(e.currentTarget).next().show();
                this.$("#everyWeek").next().hide();
                this.$("#everyWeekInput").val("");
            }else{
                this.$("#daily").next().hide();
                this.$("#everyWeek").next().hide();
            }
        },
        
        //输入周期
        inputCycle : function(e){
           var targetId = $(e.currentTarget).attr("id");
           if(targetId == "everyWeekInput"){
                if(e.currentTarget.validity.valid) {
                    if(e.currentTarget.value > 52){
                        utils.dialog.toast("N必须为正整数，同时小于52(含)");
                        $(e.currentTarget).val(52);
                    }
                }else{
                    $(e.currentTarget).val("");
                }
           }else if(targetId == "dailyInput"){
              if(e.currentTarget.validity.valid) {
                    if(e.currentTarget.value > 365){
                        utils.dialog.toast("N必须为正整数，同时小于365(含)");
                        $(e.currentTarget).val(365);
                    }
                }else{
                    $(e.currentTarget).val("");
                }
           } 
        },
        
        //获取投资周期
        getFixedCycle : function(){
            var cycleObj = this.$("#selectCycle i[class='iconA59']").parents("li").attr("id");
            var $cycleObj = $("#"+cycleObj);
            if(cycleObj == "everyWeek"){
                var weekNum = this.$("#everyWeekInput").val();
                if(weekNum == ""){
                    utils.dialog.toast("请输入周数");
                    return;
                }else{
                    App.storage.set("cycleNumber",weekNum);
                    App.storage.set("cycleType","1");
                }
            }else if(cycleObj == "daily"){
                 var dailyNum = this.$("#dailyInput").val();
                if(dailyNum == ""){
                    utils.dialog.toast("请输入天数");
                    return;
                }else{
                    App.storage.set("cycleNumber",dailyNum);
                    App.storage.set("cycleType","2");
                }
            }else{
               App.storage.set("cycleNumber","1"); 
               App.storage.set("cycleType","0");
            }
            App.navigate("fund/fundFixedIndex/fixedModify", true);
        }
        
    });
});
