/**
 * WUWENJUN059
 * 定投详情
 *
 */
define(function (require, exports, module) {
    var fundFixedDetails = require("text!../../template/fundFixedManage/fundFixedDetails.html");
    var CustomPwdInput = require("component/password/customPwdInput");
    var IScroll = require("component/PTRScroll");
    var fundModel = require("../../model/fundDetails");
    var fundFixTools = require("../../common/fundFixTools");
    var accountInfoSta = require("mod/common/accountInfoStatus/accountInfoStatus");

    var IndexView = module.exports = ItemView.extend({
        template: _.template(fundFixedDetails),

        events: {
            "tap #fundFixedModify": "fundFixedModify",
            "tap #fundFixedPause": "fundFixedPause",
            "tap #fundFixedRecovery": "fundFixedRecovery",
            "tap #fundFixedStop": "fundFixedStop",
            "tap #openFundMore": "openFundMore"
        },

        initialize: function (options) {
            this.model = options.model;
        },

        onShow: function () {
            //定投状态 0正常 1关闭 2暂停
            this.$("#status").text(fundFixTools.getMyFundFixStatus(this.model.get("status")));
            //定投周期 0月 1周 2日
            if (this.model.attributes.period == 0) {
                this.$("#period").text("每月");
            } else {
                this.$("#period").text("每" + this.model.attributes.span + fundFixTools.getMyFundFixPeriod(this.model.get("period")));
            }
            //扣款方式 0固定金额 1余额比例 2递增金额
            var reduceWay = this.model.get("reduceWay");
            if (reduceWay == 0) {
                this.$("#reduceWay").text("按" + fundFixTools.getMyFundFixReduceWay(reduceWay) + "扣款" + utils.string.formatMoneyNumber(this.model.get("amt")) + "元");
            } else if (reduceWay == 1) {
                this.$("#reduceWay").text("按" + fundFixTools.getMyFundFixReduceWay(reduceWay) + "扣款" + new Number(this.model.get("reductRate")).toFixed(2) + "%");
            } else if (reduceWay == 2) {
                this.$("#reduceWay").text("按" + fundFixTools.getMyFundFixReduceWay(reduceWay) + "扣款" + utils.string.formatMoneyNumber(this.model.get("increaseAmt")) + "元");
            }
            //终止模式 0投资期数 1结束日期 2累计投资金额
            var overFlag = this.model.get("overFlag");
            if (overFlag == 0) {
                this.$("#overFlag").text("按" + fundFixTools.getMyFundFixOverFlag(overFlag) + this.model.get("investTimes") + "期");
            } else if (overFlag == 1) {
                this.$("#overFlag").text("按" + fundFixTools.getMyFundFixOverFlag(overFlag) + utils.date.formatTime(this.model.get("endDate")).format("yyyy-MM-dd"));
            } else if (overFlag == 2) {
                this.$("#overFlag").text("按" + fundFixTools.getMyFundFixOverFlag(overFlag) + utils.string.formatMoneyNumber(this.model.get("endTotAmt")) + "元");
            }

            //计算详情层的高度
            var wHeight = $(window).outerHeight(true) - 15;
            $("#fundDetailsDiv").css({"height": wHeight, "position": "relative", "overflow": "auto"});
        },

        //定投修改
        fundFixedModify: function () {
            var flag = accountInfoSta.getAccountInfoLossStatus("me/logined/index");
            if (flag) {
                //基金详情查询
                fundModel.queryFundDetails({
                    url: "queryFundDetails",
                    data: {
                        "prdCode": self.$("#prdCode").text()
                    },
                    callback: function (resp) {
                        App.storage.get("fundFixData").firstAmt = resp.object.detailDTO.firstAmt;
                        App.navigate("fund/fundFixedIndex/fixedModify", true);
                    },
                    errorCallback: function (resp) {
                        utils.dialog.alert(resp.message);
                    }
                });
            }
        },

        //定投暂停
        fundFixedPause: function () {
            var self = this;
            var flag = accountInfoSta.getAccountInfoLossStatus("me/logined/index");
            if (flag) {
                CustomPwdInput.customPwdInput(function (password) {
                    fundModel.qryFundFixOpera({
                        url: "qryFundFixOpera",
                        data: {
                            "operationFlag": 1,
                            "password": utils.crypto.RSAKey.encrypt(password, config.base.rsa_public_key),
                            "sm2Pwd": utils.sm2.SM2Key.encrypt(password, config.base.sm2_public_key),
                            "serialNo": self.$("#serialNo").text(),
                            "prdCode": self.$("#prdCode").text()
                        },
                        callback: function (resp) {
                            utils.dialog.toast("定投暂停成功！");
                            self.$("#fundFixedPause").hide();
                            self.$("#fundFixedRecovery").show();
                            self.$("#status").text("暂停");
                            App.storage.get("fundFixData").status = "2";
                        },
                        errorCallback: function (resp) {
                            utils.dialog.alert(resp.message);
                        }
                    });
                });
            }
        },

        //定投恢复
        fundFixedRecovery: function () {
            var self = this;
            var flag = accountInfoSta.getAccountInfoLossStatus("me/logined/index");
            if (flag) {
                CustomPwdInput.customPwdInput(function (password) {
                    fundModel.qryFundFixOpera({
                        url: "qryFundFixOpera",
                        data: {
                            "operationFlag": 2,
                            "password": utils.crypto.RSAKey.encrypt(password, config.base.rsa_public_key),
                            "sm2Pwd": utils.sm2.SM2Key.encrypt(password, config.base.sm2_public_key),
                            "serialNo": self.$("#serialNo").text(),
                            "prdCode": self.$("#prdCode").text()
                        },
                        callback: function (resp) {
                            utils.dialog.toast("定投恢复成功！");
                            self.$("#fundFixedPause").show();
                            self.$("#fundFixedRecovery").hide();
                            self.$("#status").text("正常");
                            App.storage.get("fundFixData").status = "0";
                        },
                        errorCallback: function (resp) {
                            utils.dialog.alert(resp.message);
                        }
                    });
                });
            }
        },

        //定投终止
        fundFixedStop: function () {
            var self = this;
            var flag = accountInfoSta.getAccountInfoLossStatus("me/logined/index");
            if (flag) {
                CustomPwdInput.customPwdInput(function (password) {
                    fundModel.qryFundFixOpera({
                        url: "qryFundFixOpera",
                        data: {
                            "operationFlag": 0,
                            "password": utils.crypto.RSAKey.encrypt(password, config.base.rsa_public_key),
                            "sm2Pwd": utils.sm2.SM2Key.encrypt(password, config.base.sm2_public_key),
                            "serialNo": self.$("#serialNo").text(),
                            "prdCode": self.$("#prdCode").text()
                        },
                        callback: function (resp) {
                            utils.dialog.toast("定投终止成功！");
                            App.navigate("fund/fundFixedIndex/index", true);
                        },
                        errorCallback: function (resp) {
                            utils.dialog.alert(resp.message);
                        }
                    });
                });
            }
        },

        //展开查看更多
        openFundMore: function () {
            var wHeight = $(window).outerHeight(true) - 15;
            $("#fundDetailsDiv").css({"height": wHeight, "position": "relative", "overflow": "auto"});
            if ($("#openFundMore").text() == "收起") {
                $("#fundDetails tr").slice(6, 18).hide(300);
                $("#openFundMore").text("展开查看更多");

            } else {
                $("#fundDetails tr").slice(6, 18).show(300);
                $("#openFundMore").text("收起");
            }

        }

    });
});
