/**
 * WUWENJUN059
 * 基金定投修改View
 *
 */
define(function (require, exports, module) {
    var IndexTpl = require("text!../../template/fundFixedManage/fundFixedModify.html");
    var CustomPwdInput = require("component/password/customPwdInput");
    var FormComponent = require("component/form");
    var safeKeyBoardHelper = require("component/customInput.helper");
    var fundModel = require("../../model/fundDetails");
    var fundFixTools = require("../../common/fundFixTools");

    var IndexView = module.exports = FormComponent.extend({
        template: _.template(IndexTpl),

        ui: {
            "fixedDteText": "#fixedDteText"
        },

        events: {
            "datepicker:dateSelect @ui.fixedDteText": "selectFixedDate",
            "tap #fixedCycleLi": "selectFixedCycle",
            "tap #submmitModify": "comfirmSubmmit",
            "customInputFocusIn #firstDebit": "_onCustomInputFocusInAmount",
            "customInputFocusOut #firstDebit": "_onCustomInputFocusOutAmount"
        },

        onShow: function () {
            var fundFixData = App.storage.get("fundFixData");
            //totTimes > 0 或 tolFailTimes > 0 为协议发起状态，只允许修改定投周期
            //反之为协议开通状态
            if (fundFixData.totTimes > 0 || fundFixData.tolFailTimes > 0) {
                this.$("#firstDebit,#firstFixedDate").remove("i");
                this.$("#firstDebit").append("<span class='c_999 f16'>" + utils.string.formatMoneyNumber(fundFixData.fistDeductAmt) + "元</span>");
            } else {
                //投资金额
                this.$("#firstDebit").customInput({
                    type: "decimal",
                    placeholder: utils.string.formatMoneyNumber(fundFixData.firstAmt) + "元起购",
                    className: "safeKeyBoard",
                    maxLength: "10"
                });
                this.$("#firstFixedDate").append("<i class='iconA34'></i>");
                this.$("#firstDebit input").css("margin-left", "0");
                if (App.storage.get("firstAmtInput")) {
                    this.$("#firstDebit").customInput("value", utils.string.formatMoneyNumber(App.storage.get("firstAmtInput")));
                } else {
                    this.$("#firstDebit").customInput("value", utils.string.formatMoneyNumber(fundFixData.fistDeductAmt));
                }
            }

            //投资周期 cycleNum日/周数、 cycleType周期类型
            var cycleNum = App.storage.get("cycleNumber");
            var cycleType = App.storage.get("cycleType");
            if (cycleType == "1" || cycleType == "2") {
                this.$("#fixedCycleLi div span").text("每" + cycleNum + fundFixTools.getMyFundFixPeriod(cycleType));
            } else if (cycleType == "0") {
                this.$("#fixedCycleLi div span").text("每月");
            } else {
                if (fundFixData.period == 0) {
                    this.$("#fixedCycleLi div span").text("每月");
                } else {
                    this.$("#fixedCycleLi div span").text("每" + fundFixData.span + fundFixTools.getMyFundFixPeriod(fundFixData.period));
                }
                App.storage.set("cycleNumber", fundFixData.span);
                App.storage.set("cycleType", fundFixData.period);
            }
        },

        _onCustomInputFocusInAmount: function () {
            safeKeyBoardHelper.focusIn({ id: "firstDebit" });
        },

        _onCustomInputFocusOutAmount: function () {
            safeKeyBoardHelper.focusOut({ id: "firstDebit" });
        },

        //首次定投日期
        selectFixedDate: function (eve, _this, value) {
            var fundFixData = App.storage.get("fundFixData");
            var date = new Date(value).getDate();
            //终止方式为“结束日期”时，比较首次扣款日期与终止日期的大小
            if (fundFixData.overFlag == "1") {
                var formatDate1 = utils.date.formatTime(value).format("yyyy.MM.dd");
                var formatDate2 = utils.date.formatTime(fundFixData.endDate).format("yyyy.MM.dd");
                var flag = utils.date.diffDate(formatDate1, formatDate2);
                if (flag <= 0) {
                    utils.dialog.toast("首次扣款日期需要早于终止日期，请重新选择！");
                    return;
                }
            }
            if (date >= 1 && date <= 28) {
                this.$("#fixedDteText").attr("data-initDate", value);
                this.$("#fixedDteText span").text(value);
                App.storage.set("firstDateInput", value);
            } else {
                utils.dialog.toast("请在每月1日至28日间选择首次扣款日期!");
            }
        },

        //定投周期
        selectFixedCycle: function () {
            if (this.$("#firstDebit input").length > 0) {
                //缓存金额
                App.storage.set("firstAmtInput", this.$("#firstDebit").customInput("value"));
            }
            App.navigate("fund/fundFixedIndex/fixedCycle", true);
        },

        //确认修改
        comfirmSubmmit: function () {
            var self = this;
            var fundFixData = App.storage.get("fundFixData");
            //定投周期
            var cycleNum = App.storage.get("cycleNumber");
            var cycleType = App.storage.get("cycleType");
            var data = {
                "serialNo": fundFixData.serialNo,
                "prdCode": fundFixData.prdCode,
                "reduceWay": fundFixData.reduceWay,
                "overFlag": fundFixData.overFlag
            };

            //扣款方式
            if (data.reduceWay == 0) {
                data.amt = fundFixData.amt;
            } else if (data.reduceWay == 1) {
                data.reductRate = fundFixData.reductRate;
            } else if (data.reduceWay == 2) {
                data.increaseAmt = fundFixData.increaseAmt;
            }

            //终止方式
            if (data.overFlag == 0) {
                data.investTimes = fundFixData.investTimes;
            } else if (data.overFlag == 1) {
                data.endDate = fundFixData.endDate;
            } else if (data.overFlag == 2) {
                data.endTotAmt = fundFixData.endTotAmt;
            }

            //totTimes > 0 或 tolFailTimes > 0 为协议发起状态，只允许修改定投周期
            //反之为协议开通状态
            if (fundFixData.totTimes > 0 || fundFixData.tolFailTimes > 0) {
                data.period = cycleType;
                data.span = cycleNum;
                data.startInvestDate = fundFixData.startInvestDate;
                data.fistDeductAmt = fundFixData.fistDeductAmt;
            } else {
                //首次定投金额
                var firstDebit = this.$("#firstDebit").customInput("value").replace(/,/g, '') * 1;
                if (firstDebit < fundFixData.firstAmt) {
                    utils.dialog.toast("首次扣款金额不能小于最低定投金额");
                    return;
                }
                data.startInvestDate = this.$("#fixedDteText span").text();
                data.fistDeductAmt = firstDebit;
                data.period = cycleType;
                data.span = cycleNum;
            }
            CustomPwdInput.customPwdInput(function (password) {
                data.password = utils.crypto.RSAKey.encrypt(password, config.base.rsa_public_key);
                data.sm2Pwd = utils.sm2.SM2Key.encrypt(password, config.base.sm2_public_key);
                fundModel.qryFundFixModify({
                    url: "qryFundFixModify",
                    data: data,
                    callback: function (resp) {
                        //更改缓存数据
                        if (fundFixData.totTimes > 0 || fundFixData.tolFailTimes > 0) {
                            fundFixData.period = resp.object.period;
                            fundFixData.span = resp.object.span;
                            fundFixData.nextInvertDate = resp.object.nextInvertDate;
                        } else {
                            fundFixData.startInvestDate = resp.object.startInvestDate;
                            fundFixData.fistDeductAmt = resp.object.fistDeductAmt;
                            fundFixData.period = resp.object.period;
                            fundFixData.span = resp.object.span;
                            fundFixData.nextInvertDate = resp.object.nextInvertDate;
                        }
                        utils.dialog.toast("定投修改成功!");
                    },
                    errorCallback: function (resp) {
                        utils.dialog.alert(resp.message);
                    }
                });
            });
        }

    });
});
