/**
 * liujun
 * 基金赎回
 */
define(function (require, exports, module) {
    var Component = require("component/form");
    var fundRedemptionHtml = require("text!../../template/redemption/fundRedemption.html");
    var safeKeyBoardHelper = require("component/customInput.helper");
    var CustomPwdInput = require("component/password/customPwdInput");
    var fundDetailsModel = require("../../model/fundDetails");
    var fundRedemptionView = module.exports = Component.extend({
        template: _.template(fundRedemptionHtml),
        events: {
            'tap #redemptionType': 'redemptionType',
            'customInputFocusOut #redemptionIpt': 'redemptionIptFocuOut',
            'tap #allRedemption': 'allRedemption',
            'tap #redemptionConfirm': 'redemptionConfirm'
        },

        templateHelpers: {
            evalMarkup: function (val) {
                var monthMarkup = Number(val);
                if (-1 == monthMarkup || !monthMarkup) {
                    monthMarkup = '---';
                } else {
                    monthMarkup = ((monthMarkup - 1) * 100).toFixed(2);
                }
                return monthMarkup;
            }
        },

        initialize: function () {
            submitStates = false;
            minRedempTips = "";
            if (App.storage.get("redempFundDetailsData")) {
                var detailsObj = App.storage.get("redempFundDetailsData");
                minRedempTips = detailsObj.detailDTO.minRed;
            }

        },

        //初始化keyboard,保留原页数据
        onShow: function () {
            this._InitRedemptionKeyboard();
            this._backPageInit();
        },

        _InitRedemptionKeyboard: function () {
            var temp = "";
            temp = minRedempTips;
            if (temp == "" || !temp) {
                temp = "请输入赎回份额";
            } else {
                temp = parseInt(minRedempTips, 10) + "起";
            }
            this.$("#redemptionIpt").customInput({
                type: "decimal",
                placeholder: temp,
                className: "safeKeyBoard",
                maxLength: "14"
            });
            $("#redemptionIpt").addClass('flex1 dsb');
        },

        //处理页回退初始化数据(方式id与赎回份额)
        _backPageInit: function () {
            var id = "0";
            var typeContent = ["顺延", "取消"];
            var redempNum = "";
            if (App.storage.get("fundHoldRedempProcessId")) {
                id = App.storage.remove("fundHoldRedempProcessId");
                $('#process').attr("data-id", id);
                $('#process').text(typeContent[id]);
            }
            if (App.storage.get("fundHoldRedempNum")) {
                redempNum = App.storage.remove("fundHoldRedempNum");
                $("#redemptionIpt").customInput("value", redempNum);
                // $("#redemptionIpt input").val(redempNum);
            }

        },

        //基金处理方式页set data 方式id与赎回份额
        redemptionType: function () {
            setTimeout(function () {
                var processId = $('#process').attr("data-id");
                App.storage.set("fundHoldRedempProcessId", processId);
                App.storage.set("fundHoldRedempNum", $("#redemptionIpt").customInput("value").replace(/,/g, ""));
                App.navigate('fund/redemption/redemptionType', true);
            }, 160);
        },

        //赎回失去焦点校验
        redemptionIptFocuOut: function () {
            var mypropertyData = App.storage.get("myPropertyData");
            var detailsObj = App.storage.get("redempFundDetailsData");
            var currRed = $("#redemptionIpt").customInput("value").replace(/,/g, "");
            if ((Number(mypropertyData.useVol) - Number(currRed)) < Number(detailsObj.detailDTO.minHold) || Number(currRed) < Number(detailsObj.detailDTO.minRed)) {
                if ((Number(mypropertyData.useVol) - Number(currRed)) == 0) {
                } else {
                    if ((Number(mypropertyData.useVol) - Number(currRed)) < Number(detailsObj.detailDTO.minHold)) {
                        utils.dialog.toast("剩余份额不能小于最低持有份额");
                    } else if (Number(currRed) < Number(detailsObj.detailDTO.minRed)) {
                        utils.dialog.toast("赎回份额不能小于最低赎回份额");
                    }
                }
            } else if (!Number($("#redemptionIpt").customInput("value").replace(/,/g, ""))) {
                utils.dialog.toast("请输入赎回份额");
            }
        },

        //赎回全部可用份额
        allRedemption: function () {
            var mypropertyData = App.storage.get("myPropertyData");
            $("#redemptionIpt").customInput("value", mypropertyData.useVol);
        },

        //赎回请求
        redemptionRequester: function (currRed) {
            var redempData = {};
            redempData.prdCode = App.storage.get("myPropertyData").prdCode;
            redempData.largRedFlag = $('#process').attr('data-id');
            redempData.amt = parseFloat(currRed);
            CustomPwdInput.customPwdInput(
                function (pwd) {
                    redempData.password = utils.crypto.RSAKey.encrypt(pwd, config.base.rsa_public_key);
                    redempData.sm2Pwd = utils.sm2.SM2Key.encrypt(pwd, config.base.sm2_public_key);
                    fundDetailsModel.fundRedemption({
                        url: "fundRedeem",
                        data: redempData,
                        callback: function (res) {
                            submitStates = true;
                            //删除我的资产缓存信息
                            App.requester.storage.remove("loginedAccountInfo");
                            App.navigate('fund/redemption/redemptionSuccess', true);
                        },
                        errorCallback: function (err) {
                            utils.dialog.alert(err.message);
                        }
                    });
                }
            );
        },

        //赎回提交
        redemptionConfirm: function () {
            //channelType\amt\password\prdCode\largRedFlag

            if (submitStates == true) {
                utils.dialog.toast("请勿重复提交");
            } else {
                var mypropertyData = App.storage.get("myPropertyData");
                var detailsObj = App.storage.get("redempFundDetailsData");
                var currRed = $("#redemptionIpt").customInput("value").replace(/,/g, "");
                if (!Number($("#redemptionIpt").customInput("value").replace(/,/g, ""))) {
                    utils.dialog.toast("请输入赎回份额");
                } else {
                    if ((Number(mypropertyData.useVol) - Number(currRed)) < Number(detailsObj.detailDTO.minHold) || Number(currRed) < Number(detailsObj.detailDTO.minRed)) {
                        if ((Number(mypropertyData.useVol) - Number(currRed)) == 0) {
                            this.redemptionRequester(currRed);
                        } else {
                            if ((Number(mypropertyData.useVol) - Number(currRed)) < Number(detailsObj.detailDTO.minHold)) {
                                utils.dialog.toast("剩余份额不能小于最低持有份额");
                            } else if (Number(currRed) < Number(detailsObj.detailDTO.minRed)) {
                                utils.dialog.toast("赎回份额不能小于最低赎回份额");
                            }
                        }
                    } else {
                        this.redemptionRequester(currRed);
                    }
                }
            }
        }

    });
});