/**
 * 通用工具类
 * @Author: WANGQIANG873
 * @Date:   2015-12-25 11:29:01
 * @Last Modified by:   WANGQIANG873
 * @Last Modified time: 2016-04-22 10:33:34
 */
define(function(require, exports, module){
	var fundStrongTools = module.exports = {

		/**
		 *
		 * 收益到达时间推算
		 * 返回：
		 *     收益到达时间：yyyy年MM月dd日(周*)
		 */

		incomeArrivalTime: function(date) {
			var time = (date && utils.date.formatTime(date).format("yyyy/MM/dd hh:mm:ss")) || App.storage.set("fundStrong_buy_sysTime") || new Date().format("yyyy/MM/dd hh:mm:ss");
			var week = new Date(time).getDay();     //0：星期天，1：星期一
			var hh   = new Date(time).format("hh"); //时间的小时数(24小时制)
			var text = "";
			switch(week){
				case 0:
					text = utils.date.diffDateAdd(new Date(time),3,"d").format("yyyy年MM月dd日")+"(下周三)";
					break;
				case 1:
					if(hh>=15){
						text = utils.date.diffDateAdd(new Date(time),3,"d").format("yyyy年MM月dd日")+"(周四)";
					}else{
						text = utils.date.diffDateAdd(new Date(time),2,"d").format("yyyy年MM月dd日")+"(周三)";
					}
					break;
				case 2:
					if(hh>=15){
						text = utils.date.diffDateAdd(new Date(time),3,"d").format("yyyy年MM月dd日")+"(周五)";
					}else{
						text = utils.date.diffDateAdd(new Date(time),2,"d").format("yyyy年MM月dd日")+"(周四)";
					}
					break;
				case 3:
					if(hh>=15){
						text = utils.date.diffDateAdd(new Date(time),3,"d").format("yyyy年MM月dd日")+"(周六)";
					}else{
						text = utils.date.diffDateAdd(new Date(time),2,"d").format("yyyy年MM月dd日")+"(周五)";
					}
					break;
				case 4:
					if(hh>=15){
						text = utils.date.diffDateAdd(new Date(time),5,"d").format("yyyy年MM月dd日")+"(下周二)";
					}else{
						text = utils.date.diffDateAdd(new Date(time),2,"d").format("yyyy年MM月dd日")+"(周六)";
					}
					break;
				case 5:
					if(hh>=15){
						text = utils.date.diffDateAdd(new Date(time),5,"d").format("yyyy年MM月dd日")+"(下周三)";
					}else{
						text = utils.date.diffDateAdd(new Date(time),4,"d").format("yyyy年MM月dd日")+"(下周二)";
					}
					break;
				case 6:
					text = utils.date.diffDateAdd(new Date(time),4,"d").format("yyyy年MM月dd日")+"(下周三)";
					break;
			}
			return text;
		},

		/**
		 * 赎回到账日期
		 * @return 到达时间：yyyy年MM月dd日 24:00前
		 */
		ransomArrivalTime: function(date) {
			var time = (date && utils.date.formatTime(date).format("yyyy/MM/dd hh:mm:ss")) || App.storage.set("fundStrong_redeem_sysTime") || new Date().format("yyyy/MM/dd hh:mm:ss");
			var week = new Date(time).getDay();     //0：星期天，1：星期一
			var hh   = new Date(time).format("hh"); //时间的小时数(24小时制)
			var text = "";
			switch(week){
				case 0:
					text = utils.date.diffDateAdd(new Date(time),2,"d").format("yyyy年MM月dd日")+"24:00前，";
					break;
				case 1:
					if(hh>=15){
						text = utils.date.diffDateAdd(new Date(time),2,"d").format("yyyy年MM月dd日")+"24:00前，";
					}else{
						text = utils.date.diffDateAdd(new Date(time),1,"d").format("yyyy年MM月dd日")+"24:00前，";
					}
					break;
				case 2:
					if(hh>=15){
						text = utils.date.diffDateAdd(new Date(time),2,"d").format("yyyy年MM月dd日")+"24:00前，";
					}else{
						text = utils.date.diffDateAdd(new Date(time),1,"d").format("yyyy年MM月dd日")+"24:00前，";
					}
					break;
				case 3:
					if(hh>=15){
						text = utils.date.diffDateAdd(new Date(time),2,"d").format("yyyy年MM月dd日")+"24:00前，";
					}else{
						text = utils.date.diffDateAdd(new Date(time),1,"d").format("yyyy年MM月dd日")+"24:00前，";
					}
					break;
				case 4:
					if(hh>=15){
						text = utils.date.diffDateAdd(new Date(time),4,"d").format("yyyy年MM月dd日")+"24:00前，";
					}else{
						text = utils.date.diffDateAdd(new Date(time),1,"d").format("yyyy年MM月dd日")+"24:00前，";
					}
					break;
				case 5:
					if(hh>=15){
						text = utils.date.diffDateAdd(new Date(time),5,"d").format("yyyy年MM月dd日")+"24:00前，";
					}else{
						text = utils.date.diffDateAdd(new Date(time),4,"d").format("yyyy年MM月dd日")+"24:00前，";
					}
					break;
				case 6:
					text = utils.date.diffDateAdd(new Date(time),3,"d").format("yyyy年MM月dd日")+"24:00前，";
					break;
			}
			return text;
		}
	};

});

