/*
* @Author: WANGQIANG873
* @Date:   2016-04-12 17:11:37
* @Last Modified by:   WANGQIANG873
* @Last Modified time: 2016-04-25 19:56:23
* 高收益基金（每日盈）
* 登录区内
*/
define(function(require, exports, module){
	var IndexView         = require("../view/indexLogin");
	var BuyView           = require("../view/buy");
	var BuySuccessView    = require("../view/buySuccess");
	var BuyFailView       = require("../view/buyFail");
	var RedeemView        = require("../view/redeem");
	var RedeemSuccessView = require("../view/redeemSuccess");
	var RedeemFailView    = require("../view/redeemFail");
	var BuyRuleView       = require("../view/buyRule");
	var GainView          = require("../view/gain");
	var accountModel      = require("mod/common/model/accountModel");
	var fundStrongModel   = require("../model/model");
	var accountInfoStatus = require("mod/common/accountInfoStatus/accountInfoStatus");
	var fundStrong = module.exports = Controller.extend({
		actions : {
			"index"         : "index",
			"buy"           : "buy",
			"buySuccess"    : "buySuccess",
			"buyFail"       : "buyFail",
			"redeem"        : "redeem",
			"redeemSuccess" : "redeemSuccess",
			"redeemFail"    : "redeemFail",
			"rule"          : "rule",  //规则
			"gain(/:tab)"   : "gain"   //收益详情
		},

		index: function(){
			utils.native.anydoor.hide();
			utils.native.talkingDataTrackEvent("每日盈-产品详情");
			App.header.reset({
				title : "产品详情",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.navigate('index/index/index', true);
				}

				// rightButtonContent : "登录",
				// rightButtonHandler : function(){
					// App.navigate("login/login/toaIndex",true);
				// }
			});

			App.footer.reset({"visible":false});

			fundStrongModel.any({
				"url" : "qryFundStrongIncome",
				"callback": function(res){
					var total={
						totalIncome     : res.totalIncome || 0,     //累计收益
						yesterdayIncome : res.yesterdayIncome || 0, //昨日收益
						totalLot        : res.totalLot || 0,        //持有资产
						availLot        : res.availLot || 0         //可用余额
					};
					App.storage.set("fundStrong_income_and_assets",total);
					App.container.show(new IndexView({model:new Model(total)}));
				},
				"errorCallback": function(err){
					utils.dialog.alert(err.message,function(){
						App.navigate('index/index/index', true);
					});
				}
			});
		},

		buy: function(){
			var self = this;
			var dfd = accountInfoStatus.getAccountInfoStatus(false,"fundStrong/fundStrongLogin/index");
			dfd.done(function(status){
				if(status){
					self._buy();
					// 风险评测
					// fundStrongModel.any({
						// "url" : "riskAbilityTestQry",
						// "callback": function(res){
							// if(res.otherRiskStatus==2){
								// utils.dialog.confirm("未做风险评测",{"okButtonText" : "立即测评", "cancelButtonText" : "暂不测评"},function(ok){
									// if(ok){
										// App.navigate("riskExam/riskExam/riskExam/7", true);
									// }else{
										// App.back();
									// }
								// });
							// }else if(res.otherRiskStatus==3){
								// utils.dialog.confirm("风险评测已过期",{"okButtonText" : "重新测评", "cancelButtonText" : "暂不测评"},function(ok){
									// if(ok){
										// App.navigate("riskExam/riskExam/riskExam/7", true);
									// }else{
										// App.back();
									// }
								// });
							// }else{
								// self._buy();
							// }
						// },
						// "errorCallback": function(err){
							// utils.dialog.alert(err.message,function(){
								// App.back();
							// });
						// }
					// });
				}
			});
		},

		_buy: function(){
			utils.native.anydoor.hide();
			utils.native.talkingDataTrackEvent("每日盈购买");

			App.header.reset({
				title : "每日盈购买",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.storage.remove("selPayBeforeData"); //选择支付方式缓存信息
					App.navigate('fundStrong/fundStrongLogin/index', true);
				},
				rightButtonContent : "规则",
				rightButtonHandler : function(){
					App.container.currentView.formData();
					App.navigate("fundStrong/fundStrongLogin/rule",true);
				}
			});

			App.footer.reset({"visible":false});

			accountModel.asycAccountInfo({
				"callback": function(res){

					fundStrongModel.any({
						"url" : "qryFundStrongIncome",
						"callback": function(resp){
							App.request("timestamp",{type:"GET"}).done(function(arg){
								App.storage.set("fundStrong_buy_sysTime", arg.object);
							});
							var balance={
								balance      : res.object.balance,
								dhBalance    : res.object.dhBalance,
								totalBalance : res.object.totalBalance,
								minAmt       : resp.minAmt
							};
							App.container.show(new BuyView({model:new Model(balance)}));
						},
						"errorCallback": function(err){
							utils.dialog.alert(err.message,function(){
								App.navigate('index/index/index', true);
							});
						}
					});

				},
				"errorCallback": function(err){
					utils.dialog.alert(err.message,function(){
						App.back();
					});
				}
			});
		},

		rule: function(){
			utils.native.talkingDataTrackEvent("每日盈购买-规则");
			App.header.reset({
				title : "规则",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.navigate('fundStrong/fundStrongLogin/buy', true);
				}
			});

			App.footer.reset({"visible":false});
			App.container.show(new BuyRuleView());
		},

		buySuccess: function(){
			utils.native.talkingDataTrackEvent("每日盈购买成功");
			App.header.reset({
				title : "每日盈购买成功",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.storage.remove("selPayBeforeData"); //选择支付方式缓存信息
					App.navigate('fundStrong/fundStrongLogin/index', true);
				}
			});

			App.footer.reset({"visible":false});
			App.container.show(new BuySuccessView());
		},

		buyFail: function(){
			utils.native.talkingDataTrackEvent("每日盈购买失败");
			App.header.reset({
				title : "每日盈购买失败",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.storage.remove("selPayBeforeData"); //选择支付方式缓存信息
					App.navigate('fundStrong/fundStrongLogin/index', true);
				}
			});

			App.footer.reset({"visible":false});
			App.container.show(new BuyFailView());
		},
		redeem: function(){
			utils.native.talkingDataTrackEvent("每日盈赎回");
			App.header.reset({
				title : "每日盈赎回",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.navigate('fundStrong/fundStrongLogin/index', true);
				}
			});

			App.footer.reset({"visible":false});
			App.request("timestamp",{type:"GET"}).done(function(arg){
				App.storage.set("fundStrong_redeem_sysTime", arg.object);
			});
			App.container.show(new RedeemView());
		},
		redeemSuccess: function(){
			utils.native.talkingDataTrackEvent("每日盈赎回成功");
			App.header.reset({
				title : "每日盈赎回成功",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.storage.remove("selPayBeforeData"); //选择支付方式缓存信息
					App.navigate('fundStrong/fundStrongLogin/index', true);
				}
			});

			App.footer.reset({"visible":false});
			App.container.show(new RedeemSuccessView());
		},
		redeemFail: function(){
			utils.native.talkingDataTrackEvent("每日盈赎回失败");
			App.header.reset({
				title : "每日盈赎回失败",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.storage.remove("selPayBeforeData"); //选择支付方式缓存信息
					App.navigate('fundStrong/fundStrongLogin/index', true);
				}
			});

			App.footer.reset({"visible":false});
			App.container.show(new RedeemFailView());
		},
		gain: function(tab){
			utils.native.talkingDataTrackEvent("每日盈-查看收益");
			App.header.reset({
				title : "查看收益",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.navigate('fundStrong/fundStrongLogin/index', true);
				}
			});

			App.footer.reset({"visible":false});
			App.container.show(new GainView({model:new Model({"tab":tab})}));
		}
	});
});