/*
* @Author: WANGQIANG873
* @Date:   2016-04-20 17:44:10
* @Last Modified by:   WANGQIANG873
* @Last Modified time: 2016-04-26 17:29:53
*/

define(function(require, exports, module){
	var Tpl             = require("text!../template/gain.html");
	var fundStrongModel = require("../model/model");

	var incomeView = module.exports = ItemView.extend({
		template : _.template(Tpl),
		events:{
			"tap #gainTab" : "gainTab"
		},
		initialize:function(){
			this.tab = this.model.get("tab");
			//var data = _.defaults({}, { tab: this.model.get("tab") });
		},
		onShow: function(){
			$("#gainTab span").css({"transition": "all ease-in-out 0.2s"});
			if(this.tab == 1){ //万份收益
				$("#gainTab span").eq(0).addClass('current');
				this.getData({qryType:1});
			}else if(this.tab == 2){ //七日收益
				$("#gainTab span").eq(1).addClass('current');
				this.getData({qryType:1});
			}else if(this.tab == 3){ //累计收益
				$("#gainTab span").eq(2).addClass('current');
				this.getData({qryType:0});
			}
		},
		gainTab: function(e){
			var t = $(e.target);
			$("#gainTab span").removeClass('current');
			t.addClass('current');
			if(t.index() == 0){
				this.tab=1;
				this.getData({qryType:1});
			}else if(t.index() == 1){
				this.tab=2;
				this.getData({qryType:1});
			}else if(t.index() == 2){
				this.tab=3;
				this.getData({qryType:0});
			}
		},
		getData: function(param){
			var self = this;
			fundStrongModel.any({
				"url" : "qryFundStrongInfo",
				"data": param,
				"callback": function(res){
					self.updata(res);
				},
				"errorCallback": function(err){
					utils.dialog.alert(err.message,function(){
						App.back();
					});
				}
			});
		},
		updata: function(data){
			var self = this;
			var list=this.percentCalc(data);
			var html="";

			if(self.tab == 1){//万份收益
				this.$("#tabText").html("昨日万份收益(元)");
				this.$("#tabGain").html(App.storage.get("fundStrong_recent_gain").wfGain);
				this.$("#tabContent").html("万份收益（元）");
			}else if(self.tab == 2){
				this.$("#tabText").html("昨日七日年华收益率");
				this.$("#tabGain").html(App.storage.get("fundStrong_recent_gain").sevenGain+"%");
				this.$("#tabContent").html("七日年华收益率");
			}else if(self.tab == 3){
				this.$("#tabText").html("累计收益（元）");
				this.$("#tabGain").html(utils.string.numberFormat(data.totalIncome)||"0.00");
				this.$("#tabContent").html("每日收益（元）");
			}
			_.each(list,function(item,i){
				var gainDate = "";
				var gainNum  = "";
				if(self.tab == 1){//万份收益
					gainDate = utils.date.formatTime(item.marketDate).format("MM-dd");
					gainNum  = utils.string.numberFormat(item.productUnitIncome, 4);
				}else if(self.tab == 2){
					gainDate = utils.date.formatTime(item.marketDate).format("MM-dd");
					gainNum  = utils.string.numberFormat(item.sevenYield, 3)+"%";
				}else if(self.tab == 3){
					gainDate = utils.date.formatTime(item.incomeDate).format("MM-dd");
					gainNum  = utils.string.numberFormat(item.income, 2);
				}
				if(i==0){
					html+='<li class="dswkb">'+
						'<span class="day">'+gainDate+'</span>'+
						'<span class="dayEarning" style="display:-webkit-box;">'+
							'<i style="width:'+item.percent+'%;background:#ff6634"></i>'+
							'<span class="dsib por c_f60 m_l5" style="top:15px;">'+gainNum+'</span>'+
						'</span>'+
					'</li>';
				}else{
					html+='<li class="dswkb ">'+
						'<span class="day">'+gainDate+'</span>'+
						'<span class="dayEarning" style="display:-webkit-box;">'+
							'<i style="width:'+item.percent+'%;background:#e79e40"></i>'+
							'<span class="dsib por m_l5 c_e79e40" style="top:15px;">'+gainNum+'</span>'+
						'</span>'+
					'</li>';
				}
			});
			$("#gainList").html(html);
		},
		percentCalc: function(data){
			var d = [];
			var list = [];
			var maxData=0;
			if(this.tab ==1){//万份收益
				list = data.currentSevenList || [];
				for(var i=0; i<list.length; i++){
					d.push(list[i].productUnitIncome);
				}
				maxData = Math.max.apply(null,d)||1;
				for(var j=0; j<list.length;j++){
					list[j].percent = ((list[j].productUnitIncome/maxData)*70).toFixed(2);
				}
			}else if(this.tab == 2){//七日年化
				list = data.currentSevenList || [];
				for(var i=0; i<list.length; i++){
					d.push(list[i].sevenYield);
				}
				maxData = Math.max.apply(null,d)||1;
				for(var j=0; j<list.length;j++){
					list[j].percent = ((list[j].sevenYield/maxData)*70).toFixed(2);
				}
			}else if(this.tab == 3){//累计收益
				list = data.currentList || [];
				for(var i=0; i<list.length; i++){
					d.push(list[i].income);
				}
				maxData = Math.max.apply(null,d)||1;
				for(var j=0; j<list.length;j++){
					list[j].percent = ((list[j].income/maxData)*70).toFixed(2);
				}
			}
			return list;
		}

	});
});