/*
* @Author: WANGQIANG873
* @Date:   2016-04-12 17:44:06
* @Last Modified by:   WANGQIANG873
* @Last Modified time: 2016-04-25 19:57:14
*/

define(function(require, exports, module){
	var Tpl               = require("text!../template/indexLogin.html");
	var fundStrongModel   = require("../model/model");
	var IScroll           = require("component/PTRScroll");
	var accountInfoStatus = require("mod/common/accountInfoStatus/accountInfoStatus");
	require("highcharts");

	var indexView = module.exports = ItemView.extend({
		template : _.template(Tpl),
		events:{
			"tap #buyBtn"             : "buy",
			"tap #redeemBtn"          : "redeem",
			"tap .instructions"       : "showInstructions",
			"tap #sevenYieldBtn"      : "showYield",
			"tap #oneMonthYieldBtn"   : "showYield",
			"tap #threeMonthYieldBtn" : "showYield",
			"tap #yesterdayGain,#gainTotal,#sevenGainBox,#wfGainBox" : "gain"
		},
		initialize: function(){
		},
		onShow: function(){
			var self = this;
			this.$('#chartsContainer').css({"height":180});

			if(this.model.get("totalLot")>0){
				// this.$("#assetsShow").show();
				this.$("#btn2").show();
			}else{
				this.$("#btn2").hide();
				this.$("#btn1").show();
			}

			this.getGainData();

			setTimeout(function(){
				self._scroll();
			}, 200);
		},
		_scroll: function(){
			var self      = this;
			if(this.scroller) {
				this.scroller.destroy();
				//delete this.scroller;
			}
			var wHeight   = $(window).outerHeight(true);
			var btnHeight = $(".pop_btn").outerHeight(true);
			var dom = $("#scrollContainer").css({"height":wHeight-btnHeight,"position":"relative"});
			this.scroller = new IScroll(dom[0],{"hideScrollbar":true,"pullDownToRefresh": false,"pullUpToLoadMore": false});
		},
		buy: function(){
			var dfd = accountInfoStatus.getAccountInfoStatus(false,"fundStrong/fundStrongLogin/index");
			dfd.done(function(status){
				if(status){
					App.navigate('fundStrong/fundStrongLogin/buy', true);
				}
			});
		},
		redeem: function(){
			App.navigate('fundStrong/fundStrongLogin/redeem', true);
		},
		// 累计收益
		gain: function(e){
			var t = $(e.target);
			if("gainTotal" == t.attr('id') || "yesterdayGain" == t.attr('id')){
				App.navigate('fundStrong/fundStrongLogin/gain/3', true); //累计收益
			}else if("sevenGain" == t.attr('id')){
				App.navigate('fundStrong/fundStrongLogin/gain/2', true); //七日年化收益
			}else if("wfGain" == t.attr('id')){
				App.navigate('fundStrong/fundStrongLogin/gain/1', true); //万份收益
			}
		},
		showInstructions:function(e){
			if(this.$(e.currentTarget).find("i").hasClass("on")){
				//隐藏
				this.$(e.currentTarget).find("i").removeClass("on");
				this.$(e.currentTarget).find(".con").hide();
				this.scroller.refresh();
			}else{
				//展示
				this.$(e.currentTarget).find("i").addClass("on");
				this.$(e.currentTarget).find(".con").show();

				this.scroller.refresh();
				this.scroller.scrollToElement(e.currentTarget,200);
			}
		},
		showYield: function(e){
			var t  = $(e.target);
			if(t.hasClass('on'))return;

			$(".showYield").removeClass('on');
			t.addClass('on');

			var id = t.attr('id');
			var defaultDate = [];
			if(id=="sevenYieldBtn"){
				this.getGainData({qryType:"7"});
			}else if(id=="oneMonthYieldBtn"){
				this.getGainData({qryType:"1"});
			}else if(id=="threeMonthYieldBtn"){
				this.getGainData({qryType:"3"});
			}
		},

		getGainData: function(param){
			var self = this;
			!param? param={qryType:7}:"";
			fundStrongModel.any({
				"url" : "qryFundStrongIncomeList",
				"data": param,
				"callback": function(res){
					if(param.qryType==7){
						//填入7日年化和万份收益
						var sevenGain = utils.string.numberFormat(res.sevenYieldToday, 3);
						var wfGain    = utils.string.numberFormat(res.unitIncomeToday, 4);
						$("#sevenGain").html(sevenGain);
						$("#wfGain").html(wfGain);
						App.storage.set("fundStrong_recent_gain",{sevenGain:sevenGain,wfGain:wfGain});
					}
					var list = res.incomeList || res.servenIncomeList;
					var date = [];  //行情日期
					var price = []; //行情(七日年化)
					for(var i = list.length-1; i > -1; i--){
						date.push(utils.date.formatTime(list[i].issDate).format("MM-dd"));
						price.push(parseFloat(list[i].sevenIncomeRate));
					}
					self.doCharts(date, price);
				},
				"errorCallback": function(err){
					utils.dialog.alert(err.message,function(){});
				}
			});
		},

		doCharts: function(categories, data){
			this.$('#chartsContainer').highcharts({
				chart: {
					type: 'area'
				},
				title: {
					text: ''
				},
				legend: {
					enabled:false
				},
				xAxis: {
					gridLineColor: '#ccc', //'#ffdf7f',
					lineWidth:0, //轴宽度
					tickWidth:0, //刻度宽度
					showEmpty:false, //是否显示轴线和标题，当轴不包含数据时
					showLastLabel:true, //是否显示最后一个刻度标签
					gridLineWidth: data.length>7?false:true, //如果数据大于7不显示网格线
					offset: 5,
					// tickmarkPlacement: 'on', // label对齐tick
					categories: categories, //类别(x轴文字)
					title: {
						enabled: false
					},
					labels:{
						enabled: data.length>7?false:true
					}
				},
				yAxis: {
					// max:10,
					min:0,
					gridLineWidth:1,
					gridLineColor: '#ccc',
					tickPixelInterval: 20,
					title: {
						enabled: false
					},
					labels: {
						enabled: true
					}
				},
				plotOptions: {
					area: {
						lineWidth   : 2,
						lineColor   : '#FE6601',
						color       : '#FE6601',
						fillOpacity : 0.2,
						marker: {
							enabled:data.length>7?false:true, //如果数据大于7不显示点
							radius:5,
							fillColor: '#FE6601',
							lineWidth: 3,
							lineColor: "#FFFFFF"
						}
					},
					series: {
						marker: {
							states: {
								hover: {
									lineWidth: 3,
									radius: 8
								}
							}
						}
					}
				},
				tooltip: {
					enabled         : true,
					shared          : false,
					crosshairs      : true, //当前
					useHTML         : true,
					headerFormat    : '',
					footerFormat    : '',
					backgroundColor : "#FE6601",
					// pointFormat     : '<div style="font-size:14px;">{point.y:.2f}</div>'
					style:{
						fontSize: "14px"
					},
					formatter: function(){
						return this.x+"<br>"+utils.string.numberFormat(this.y, 3);
					}
				},
				series: [{
					data: data
				}]
			});
		}
	});
});