/**
 * @author zhoushiwen
 * @ date ${date}
 * @company 中国平安
 */
define(function (require, exports, module) {
	var InputView = require("../view/buy/buy");
	var FinishView = require("../view/buy/finisht");
	var risk = require("../view/buy/risk");
	var successful = require("../view/buy/successful");
	var accountModel = require("mod/common/model/accountModel");
	var rule = require("../view/buy/rule")
		var BuyModel = require("mod/goldtreasure/model/buy");

	var BuyController = module.exports = Controller.extend({
			actions : {
				"input" : "toInputPage",
				"finish" : "toFinishPage",
				"riskexam" : "riskexam",
				"setting" : "setting",
				"successful" : "successful",
				"rule" : "rule"
			},

			//购买页面规则入口
			rule : function () {
				App.header.reset({
					title : "规则",
					leftButtonContent : '@back',
					leftButtonHandler : function () {
						fundModel = App.storage.get('goldtreasure');

						App.navigate("goldtreasure/buy/input", true);

					}
				});
				App.container.show(new rule());
			},

			//黄金开户
			riskexam : function () {
				App.header.reset({
					title : "黄金账户开户",
					leftButtonContent : '@back',
					leftButtonHandler : function () {
						fundModel = App.storage.get('products/detail/fund');
						App.navigate("products/index/index/finefinance", true);

					}
				});
				App.container.show(new risk());
			},
			//开户成功页面
			successful : function () {
				App.header.reset({
					title : "开户结果",
					leftButtonContent : '@back',
					leftButtonHandler : function () {
						var model = App.storage.get('products/index/index/finefinance');

						App.navigate("products/index/index/finefinance", true);
					}
				});
				App.container.show(new successful());
			},
			//黄金购买
			toInputPage : function () {
				utils.native.talkingDataTrackEvent("2.0-产品-理财产品购买第一步");
				App.header.reset({
					title : "填写信息",
					leftButtonContent : '@back',
					leftButtonHandler : function () {
						var model = App.storage.get('products/index/index/selectFund');
						App.storage.set('products/index/index/selectFund', model);
						App.storage.remove("goldTreasureData");   //产品详情
                        App.storage.remove("selPayBeforeData");   //选择支付方式缓存信息
						App.navigate("products/index/index/finefinance", true);
					},
					rightButtonContent : "规则",
					rightButtonHandler : function () {
						App.navigate("goldtreasure/buy/rule", true);
					}
				});
				
				//判断是否存在选择支付方式缓存信息
                if(App.storage.get("selPayBeforeData")){
                    App.container.show(new InputView({
                        model : new Model(App.storage.get("goldTreasureData"))
                    }));
                }else{
    				//查询黄金账户
    				BuyModel.goldAcctQryAsset({
    					"callback" : function (response) {
    						App.storage.set("appToBuyGoldConfirm", response.object);
    					},
    					"errorCallback" : _.bind(function (response) {
    						utils.dialog.alert(response.message);
    					}, this)
    				});
    				var promise = $.when(accountModel.qryAccountList(), accountModel.asycAccountInfo());
    
    				promise.done(function (arg1, arg2) {
    
    					var model = App.storage.get('myInvestment/commendProducts/curProObj');
    					var tempData = {
    						"goldtreasure" : App.storage.get("goldtreasure")
    					};
    					//App.storage.remove("goldtreasure");
    					var goldtreasure = _.extend(tempData, {
    							balance : arg2[0].object.balance,
    							dhBalance : arg2[0].object.dhBalance,
                                totalBalance : arg2[0].object.totalBalance,
    							accountList : arg1[0].object.accountList
    						});
    					App.storage.set("goldTreasureData",goldtreasure);
    					App.container.show(new InputView({
    							model : new Model(goldtreasure)
    						}));
    				});
    
    				promise.fail(function (err) {
    					utils.dialog.alert(err.message);
    				});
                }
			},

			//购买成功页面
			toFinishPage : function () {
				utils.native.talkingDataTrackEvent("2.0-基金购买-购买成功");
				App.header.reset({
					title : "提交成功",
					leftButtonContent : '@back',
					leftButtonHandler : function () {
						App.navigate("products/index/index/finefinance", true);
					}
				});
				var tempData = {
					"goldtreasure" : App.storage.get("goldtreasure")
				};
				App.storage.remove("goldtreasure");
				App.container.show(new FinishView({
						model : new Model(tempData)
					}));
			},
		});
});
