/**
 * liujun
 * 黄金宝追加购买
 * 15.9.25
 */
define(function (require, exports, module) {
    var Form = require("component/form");
    var safeKeyBoardHelper = require("component/customInput.helper");
    var InputTpl = require("text!../../template/addPurchase/addPurchase.html");
    var CustomPwdInput = require("component/password/customPwdInput");
    var BuyModel = require("../../model/buy");
    var InputView = module.exports = Form.extend({
        template: _.template(InputTpl),
        ui: {
            "checkbox": "#checkbox",
            "booksLink": "#booksLink a"

        },
        events: {
            "tap #submitBtn": "submit",
            "click @ui.checkbox": "toggleCheckbox",
            "click @ui.booksLink": "openBookLink",
            "tap #selPaymentMethod": "selPaymentMethod",
            "customInputKeyup  #amountInput": "_onCustomInputFocusSelAmount"
        },
        initialize: function (options) {
            //获取黄金账号
            BuyModel.goldAcctQryAsset({
                "callback": function (response) {
                    App.storage.set("appToBuyGoldConfirm", response.object);
                },
                "errorCallback": _.bind(function (response) {
                    utils.dialog.alert(response.message);
                }, this)
            });
            this.GoldTreasureAddData = options.model.get("GoldTreasureAddData");
            this.balance = options.model.get("balance");
            this.accountList = options.model.get("accountList");
            this.submitFlag = false;
            this.prdCode = this.GoldTreasureAddData.prdCode;
            // this.firstAmt = this.GoldTreasureAddData.firstAmt;
            // this.appAmt = this.GoldTreasureAddData.appAmt;

        },

        onShow: function () {
            var self = this;

            //创建输入购买金额框
            //appAmt 起购金额
            this.$("#amountInput").customInput({
                type: "decimal",
                placeholder: "请输入购买克数",
                className: "safeKeyBoard",
                maxLength: "10"
            });

            var selPayBeforeData = App.storage.get("selPayBeforeData");
            if (selPayBeforeData) {
                if (selPayBeforeData.amountInput != 0) {
                    this.$("#amountInput").customInput("value", utils.string.numberFormat(parseInt(selPayBeforeData.amountInput / this.GoldTreasureAddData.price))); //输入金额
                }
                //选择支付方式
                if (selPayBeforeData.payMentMethod == 1) {
                    this.$("#selPaymentMethod p:last").text(utils.string.numberFormat(selPayBeforeData.balance));
                } else if (selPayBeforeData.payMentMethod == 2) {
                    this.$("#selPaymentMethod p:last").text(utils.string.numberFormat(selPayBeforeData.dhBalance));
                } else {
                    this.$("#selPaymentMethod p:last").text(utils.string.numberFormat(selPayBeforeData.totalBalance) + "=" + utils.string.numberFormat(selPayBeforeData.balance) + "+" + utils.string.numberFormat(selPayBeforeData.dhBalance));
                }
                this.$("#selPaymentMethod").attr("payMethodAttr", selPayBeforeData.payMentMethod);
            }
        },
        submit: function (event) {
            event.stopPropagation();
            var self = this;
            var check = this;
            var goldAddData = {};

            var amount = this.$("#amountInput").customInput("value").replace(/,/g, "");
            var prdCode = this.prdCode;

            if (!this.validate(amount)) {
                return;
            }
            if (this.submitFlag) {
                return;
            }
            CustomPwdInput.customPwdInput(function (password) {
                self.submitFlag = true;
                goldAddData.goldAmount = amount; //购买份额
                goldAddData.password = utils.crypto.RSAKey.encrypt(password, config.base.rsa_public_key); //密码加密
                goldAddData.sm2Pwd = utils.sm2.SM2Key.encrypt(password, config.base.sm2_public_key);
                goldAddData.productId = self.GoldTreasureAddData.prdCode; //产品号
                goldAddData.goldPrice = self.GoldTreasureAddData.price; //黄金实时价格
                goldAddData.sourceAmount = amount * self.GoldTreasureAddData.price; //买入金额
                goldAddData.productName = self.GoldTreasureAddData.prdName; //中文全称
                goldAddData.cnShortName = self.GoldTreasureAddData.cnShortName; //中文简称
                goldAddData.interestBaseDays = self.GoldTreasureAddData.cycleDays; //计息天数
                goldAddData.customizeType = self.GoldTreasureAddData.customizeType; //客户类型
                goldAddData.riskLevel = self.GoldTreasureAddData.riskLevel; //风险等级
                goldAddData.riskName = self.GoldTreasureAddData.riskLevelName; //内部风险评估
                goldAddData.currencyId = self.GoldTreasureAddData.currencyId; //币种
                goldAddData.startDate = self.GoldTreasureAddData.saleStartDate1; //产品成立日
                goldAddData.endDate = self.GoldTreasureAddData.saleEndDate1; //产品到期日
                goldAddData.maxAmount = self.GoldTreasureAddData.maxAmount; //单笔上限
                goldAddData.minAmount = self.GoldTreasureAddData.minAmount; //单笔下限
                // goldAddData.seqNo = self.GoldTreasureAddData.seqNo; //优惠劵号码
                goldAddData.unitAmount = self.GoldTreasureAddData.unitAmount; //基数、单位
                goldAddData.goldAcctNo = App.storage.get("appToBuyGoldConfirm").goldAcctNo;
                //goldtreasure.wishEndDate=self.goldtreasure//许愿到期日(yyyyMMdd)
                goldAddData.balance = self.balance; //账户余额
                goldAddData.paymentType = self.$("#selPaymentMethod").attr("payMethodAttr");  //选择支付方式
                var params = goldAddData;
                //黄金宝购买接口
                BuyModel.appToBuyGoldConfirm({
                    "params": params,
                    "callback": function (response) {
                        App.requester.storage.remove("loginedAccountInfo");
                        App.storage.remove("selPayBeforeData");   //删除选择支付方式缓存信息
                        //移出追加购买请求detailsData
                        App.storage.remove("goldTreasureAddDetailData");
                        App.navigate("goldtreasure/addPurchase/addPurchaseFinish", true);
                    },
                    "errorCallback": _.bind(function (response) {
                        self.submitFlag = false;
                        utils.dialog.alert(response.message);
                    }, this)
                });
            });

        },
        /*amount  用户输入的金额
         * password  用户输入的密码
         * balance  用户余额
         * appAmt   追加购买下限
         * */
        validate: function (amount) {
            var balance = this.balance;

            if (amount == "") {
                safeKeyBoardHelper.setCustomValidity({
                    id: "amountInput",
                    message: "请输入克数",
                    maxLength: 9
                });
                return false;
            }

            if (parseFloat(amount) % parseFloat(this.GoldTreasureAddData.unitAmount) != 0) {
                safeKeyBoardHelper.setCustomValidity({
                    id: "amountInput",
                    message: "购买克数必须为" + this.GoldTreasureAddData.unitAmount + "整数倍"
                });
                return false;
            }
            var amounts = amount * this.GoldTreasureAddData.price;
            if (parseFloat(amounts) > parseFloat(this.model.get("totalBalance"))) {
                safeKeyBoardHelper.setCustomValidity({
                    id: "amountInput",
                    message: "账户余额不足"
                });
                return false;
            }
            if (parseFloat(amount) < 1) {
                safeKeyBoardHelper.setCustomValidity({
                    id: "amountInput",
                    message: "此产品追加起点为1克"
                });
                return false;
            }

            return true;

        },

        /**
         * wuwenjun059
         * 智能选择支付方式
         *
         */
        _onCustomInputFocusSelAmount: function () {
            var num = parseFloat(this.$("#amountInput").customInput("value")) * this.GoldTreasureAddData.price;
            var dhBalance = parseFloat(this.model.get("dhBalance")); //平安盈（大华）
            var totalBalance = parseFloat(this.model.get("totalBalance")); //活期余额+平安盈（大华）
            if (num <= parseFloat(this.balance)) {
                this.$("#selPaymentMethod").attr("payMethodAttr", "1");
                this.$("#selPaymentMethod p:first").text("活期余额");
                this.$("#selPaymentMethod p:last").text(utils.string.numberFormat(this.balance));
            } else {
                this.$("#selPaymentMethod").attr("payMethodAttr", "3");
                this.$("#selPaymentMethod p:first").text("活期余额+平安盈(大华)");
                this.$("#selPaymentMethod p:last").text(utils.string.numberFormat(totalBalance) + "=" + utils.string.numberFormat(this.balance) + "+" + utils.string.numberFormat(dhBalance));
            }
        },

        /**
         * wuwenjun059
         * 选择支付方式
         *
         */
        selPaymentMethod: function () {
            this.formInputData();
            App.navigate("common/selPaymentMethod/selPaymentMethod", true);
        },

        /**
         * wuwenjun059
         * 缓存页面数据
         *
         */
        formInputData: function () {
            var data = {};
            data.amountInput = (this.$("#amountInput").customInput("value").replace(/,/g, '') * 1) * this.GoldTreasureAddData.price; //购买金额;
            data.payMentMethod = this.$("#selPaymentMethod").attr("payMethodAttr"); //支付方式
            data.balance = this.model.get("balance");  //余额
            data.dhBalance = this.model.get("dhBalance"); //平安盈（大华）
            data.totalBalance = this.model.get("totalBalance"); //活期余额+平安盈（大华）
            data.selPayBackUrl = "goldtreasure/addPurchase/addPurchase";
            App.storage.set("selPayBeforeData", data);
        }

    });
});
