/**
 * @author zhoushiwen
 * @ date ${date}
 * @company 中国平安
 */
define(function (require, exports, module) {
    var Form = require("component/form");
    var safeKeyBoardHelper = require("component/customInput.helper");
    var InputTpl = require("text!../../template/buy/buy.html");
    var CustomPwdInput = require("component/password/customPwdInput");
    var BuyModel = require("../../model/buy");
    var dreamModel = require("../../../dream/model/dream");

    var InputView = module.exports = Form.extend({
        template: _.template(InputTpl),
        ui: {
            "checkbox": "#checkbox",
            "booksLink": "#booksLink a"

        },
        events: {
            "tap #submitBtn": "submit",
            "click @ui.checkbox": "toggleCheckbox",
            "click @ui.booksLink": "openBookLink",
            "tap #selPaymentMethod": "selPaymentMethod",
            "customInputKeyup  #amountInput": "_onCustomInputFocusSelAmount"

        },

        initialize: function (options) {

            //获取所以黄金宝数据
            this.goldtreasure = options.model.get("goldtreasure");
            //得到余额
            this.balance = options.model.get("balance");
            //提交按钮判断
            this.submitFlag = false;
            //黄金宝产品产品编号
            this.prdCode = this.goldtreasure.prdCode;
            //黄金宝购买首够金额
            this.firstAmt = this.goldtreasure.firstAmt;
            //
            this.appAmt = this.goldtreasure.appAmt;

        },
        //根据客户余额与当前黄金价格算出可购买克数显示页面
        onShow: function () {
            var price = this.goldtreasure.price;

            var balance = this.balance;
            this.$("#amountInput").customInput({
                type: "decimal",
                className: "safeKeyBoard",
                maxLength: "10"
            });

            var gs = "按照参考金价，可用余额最多可购买" + parseInt(this.model.get("totalBalance") / price) + "克";
            $("#pric").text(gs);

            var selPayBeforeData = App.storage.get("selPayBeforeData");
            if (selPayBeforeData) {
                if (selPayBeforeData.amountInput != 0) {
                    this.$("#amountInput").customInput("value", utils.string.numberFormat(parseInt(selPayBeforeData.amountInput / price)));
                    //输入金额
                }
                //选择支付方式
                if (selPayBeforeData.payMentMethod == 1) {
                    this.$("#selPaymentMethod p:last").text(utils.string.numberFormat(selPayBeforeData.balance));
                } else if (selPayBeforeData.payMentMethod == 2) {
                    this.$("#selPaymentMethod p:last").text(utils.string.numberFormat(selPayBeforeData.dhBalance));
                } else {
                    this.$("#selPaymentMethod p:last").text(utils.string.numberFormat(selPayBeforeData.totalBalance) + "=" + utils.string.numberFormat(selPayBeforeData.balance) + "+" + utils.string.numberFormat(selPayBeforeData.dhBalance));
                }
                this.$("#selPaymentMethod").attr("payMethodAttr", selPayBeforeData.payMentMethod);
            }

        },

        submit: function (event) {
            event.stopPropagation();
            var self = this;
            var check = this;
            var goldtreasure = {};

            var amount = this.$("#amountInput").customInput("value").replace(/,/g, "");

            if (!this.validate(amount)) {
                return;
            }
            if (this.submitFlag) {
                return;
            }
            CustomPwdInput.customPwdInput(function (password) {
                self.submitFlag = true;
                goldtreasure.goldAmount = amount;
                //购买份额
                goldtreasure.password = utils.crypto.RSAKey.encrypt(password, config.base.rsa_public_key);
                goldtreasure.sm2Pwd = utils.sm2.SM2Key.encrypt(password, config.base.sm2_public_key);
                //密码加密
                goldtreasure.productId = self.goldtreasure.prdCode;
                //产品号
                goldtreasure.goldPrice = self.goldtreasure.price;
                //黄金实时价格
                goldtreasure.sourceAmount = amount * self.goldtreasure.price;
                //买入金额
                goldtreasure.productName = self.goldtreasure.prdName;
                //中文全称
                goldtreasure.cnShortName = self.goldtreasure.cnShortName;
                //中文简称
                goldtreasure.interestBaseDays = self.goldtreasure.cycleDays;
                //计息天数
                goldtreasure.customizeType = self.goldtreasure.customizeType;
                //客户类型
                goldtreasure.riskLevel = self.goldtreasure.riskLevel;
                //风险等级
                goldtreasure.riskName = self.goldtreasure.riskName;
                //内部风险评估
                goldtreasure.currencyId = self.goldtreasure.currencyId;
                //币种
                goldtreasure.startDate = self.goldtreasure.saleStartDate1;
                //产品成立日
                goldtreasure.endDate = self.goldtreasure.saleEndDate1;
                //产品到期日
                goldtreasure.maxAmount = self.goldtreasure.maxAmount;
                //单笔上限
                goldtreasure.minAmount = self.goldtreasure.minAmount;
                //单笔下限
                goldtreasure.seqNo = self.goldtreasure.seqNo;
                //优惠劵号码
                goldtreasure.unitAmount = self.goldtreasure.unitAmount;
                //基数、单位
                goldtreasure.goldAcctNo = App.storage.get("appToBuyGoldConfirm").goldAcctNo;
                //	goldtreasure.GoldType	=self.goldtreasure.rateType;//黄金宝类型
                //	goldtreasure.wishEndDate=self.goldtreasure//许愿到期日(yyyyMMdd)
                goldtreasure.balance = self.balance;
                //账户余额
                //选择支付方式
                goldtreasure.paymentType = self.$("#selPaymentMethod").attr("payMethodAttr");
                var params = goldtreasure;
                BuyModel.appToBuyGoldConfirm({
                    "params": params,
                    callback: function (response) {

                        var promise = dreamModel.qryDreamState();

                        promise.done(_.bind(function (arg1) {
                            var arg1 = arg1.object.outExists;
                            App.storage.set("appToBuyGoldConfirm", response.object);
                            App.storage.remove("selPayBeforeData");
                            //删除选择支付方式缓存信息
                            App.storage.remove("goldTreasureData");
                            //产品详情
                            App.requester.storage.remove("lcProductMoneyQry");
                            App.requester.storage.remove("currentToFixedTransferBalance");
                            App.requester.storage.remove("loginedAccountInfo");
                            App.storage.remove("goldtreasure");
                            //0-不存在，1-存在
                            if (arg1 == 1) {
                                App.navigate("goldtreasure/buy/finish", true);
                            } else {
                                utils.native.versionInformation(function (data) {
                                    vs = data.version;
                                    if (vs.replace(/\./g, "") * 1 >= 208) {
                                        App.navigate('dream/dream/dereamOpen', true);
                                    } else {
                                        App.navigate("goldtreasure/buy/finish", true);
                                    }
                                });

                            }
                        }, this));

                        promise.fail(function (err) {
                            utils.dialog.toast(err.message);
                        });

                    },
                    errorCallback: function (response) {
                        self.submitFlag = false;
                        //提交失败
                        utils.dialog.alert(response.message);
                    }
                });
            });

        },
        /*amount  用户输入的金额
         password  用户输入的密码
         balance  用户余额
         firstAmt 购买起点
         * */
        validate: function (amount) {
            var balance = this.balance;

            if (amount == "") {
                safeKeyBoardHelper.setCustomValidity({
                    id: "amountInput",
                    message: "请输入克数",
                    maxLength: 9
                });
                return false;
            }

            if (parseFloat(amount) % parseFloat(this.goldtreasure.unitAmount) != 0) {
                safeKeyBoardHelper.setCustomValidity({
                    id: "amountInput",
                    message: "购买克数必须为" + this.goldtreasure.unitAmount + "整数倍"
                });
                return false;
            }
            var amounts = amount * this.goldtreasure.price;
            if (parseFloat(amounts) > parseFloat(this.model.get("totalBalance"))) {
                safeKeyBoardHelper.setCustomValidity({
                    id: "amountInput",
                    message: "账户余额不足"
                });
                return false;
            }
            if (parseFloat(amount) < this.goldtreasure.minAmount) {
                safeKeyBoardHelper.setCustomValidity({
                    id: "amountInput",
                    message: "此产品投资起点为" + this.goldtreasure.minAmount + "克."
                });
                return false;
            }

            return true;

        },

        /**
         * wuwenjun059
         * 智能选择支付方式
         *
         */
        _onCustomInputFocusSelAmount: function () {
            var num = parseFloat(this.$("#amountInput").customInput("value")) * this.goldtreasure.price;
            var dhBalance = parseFloat(this.model.get("dhBalance"));
            //平安盈（大华）
            var totalBalance = parseFloat(this.model.get("totalBalance"));
            //活期余额+平安盈（大华）
            if (num <= parseFloat(this.balance)) {
                this.$("#selPaymentMethod").attr("payMethodAttr", "1");
                this.$("#selPaymentMethod p:first").text("活期余额");
                this.$("#selPaymentMethod p:last").text(utils.string.numberFormat(this.balance));
            } else {
                this.$("#selPaymentMethod").attr("payMethodAttr", "3");
                this.$("#selPaymentMethod p:first").text("活期余额+平安盈(大华)");
                this.$("#selPaymentMethod p:last").text(utils.string.numberFormat(totalBalance) + "=" + utils.string.numberFormat(this.balance) + "+" + utils.string.numberFormat(dhBalance));
            }
        },

        /**
         * wuwenjun059
         * 选择支付方式
         *
         */
        selPaymentMethod: function () {
            this.formInputData();
            App.navigate("common/selPaymentMethod/selPaymentMethod", true);
        },

        /**
         * wuwenjun059
         * 缓存页面数据
         *
         */
        formInputData: function () {
            var data = {};
            data.amountInput = (this.$("#amountInput").customInput("value").replace(/,/g, '') * 1) * this.goldtreasure.price;
            //购买金额;
            data.payMentMethod = this.$("#selPaymentMethod").attr("payMethodAttr");
            //支付方式
            data.balance = this.model.get("balance");
            //余额
            data.dhBalance = this.model.get("dhBalance");
            //平安盈（大华）
            data.totalBalance = this.model.get("totalBalance");
            //活期余额+平安盈（大华）
            data.selPayBackUrl = "goldtreasure/buy/input";
            App.storage.set("selPayBeforeData", data);
        }
    });
});
