/**
 * @author zhoushiwen
 * @ date ${date}
 * @company 中国平安
 */
define(function (require, exports, module) {
    var Form = require("component/form");
    var safeKeyBoardHelper = require("component/customInput.helper");
    var InputTpl = require("text!../../template/buy/risk.html");
    var CustomPwdInput = require("component/password/customPwdInput");
    var goldtreasure = config.urls.get("goldtreasure");
    var CustomPwdOtpInput = require("component/password/customPwdOtpInput");

    var BuyModel = require("../../model/buy");
    var InputView = module.exports = Form.extend({
        template: _.template(InputTpl),
        ui: {
            "checkbox": "#checkbox",
            "booksLink": "#booksLink a"

        },
        events: {
            "tap #submitBtn": "submit",
            "tap #setting": "setting",
            "click @ui.checkbox": "toggleCheckbox",
            "click @ui.booksLink": "openBookLink"
        },

        onShow: function () {
            bankcode = App.storage.get('UserInfo').get('accNumber');
            //获取用户银行卡号
            mob = App.storage.get('UserInfo').get('telephoneNum');
            //获取用户手机号码
            email = App.storage.get('UserInfo').get('email');
            //获取用户邮箱

            $("#code").text(bankcode);
            //将卡号渲染页面
            $("#mob").val(mob);
            //将手机号码渲染页面
            $("#email").val(email);
            //将邮箱渲染页面
        },
        submit: function (event) {
            event.stopPropagation();
            var self = this;
            var check = this;
            var email = $("#email").val(); //获取邮箱
            var mobinput = $("#mob").val(); //获取电话
            var accountNo = $("#code").text(); //获取卡号
            var custManagerId = $("#custManagerId").val(); //推荐客户经理UM号
            var recommenderAcctNo = $("#recommenderAcctNo").val(); //推荐人黄金账户号

            this.email = email;
            this.mobinput = mobinput;
            this.custManagerId = custManagerId;
            this.recommenderAcctNo = recommenderAcctNo;
            this.accountNo = accountNo;

            if (!this.validate(email, mobinput)) {
                return;
            }
            CustomPwdOtpInput.customPwdOtpInput({
                isSendOtp: false,
                isNeedSendOtpValidate: false,
                cat: config.values.GOLD_OPEN, //cat
                callback: function (pwd, otp) {
                    var rsaPwd = utils.crypto.RSAKey.encrypt(pwd, config.base.rsa_public_key);
                    var sm2Pwd = utils.sm2.SM2Key.encrypt(pwd, config.base.sm2_public_key);
                    mob = App.storage.get('UserInfo').get('telephoneNum');
                    email = App.storage.get('UserInfo').get('email');
                    if (self.mobinput == mob) {
                        self.mobinput = "";
                    }
                    if (self.email == email) {
                        self.email = "";
                    }
                    var data = {
                        "password": rsaPwd,
                        "sm2Pwd": sm2Pwd,
                        "otp": otp,
                        "mobilePhone": self.mobinput,
                        "email": self.email,
                        "custManagerId": self.custManagerId,
                        "recommenderAcctNo": self.recommenderAcctNo
                    };
                    BuyModel.openGoldAcct({
                        "params": data,
                        "callback": function (response) {
                            App.storage.set("goldtreasure", response.object);
                            App.navigate("goldtreasure/buy/successful", true);
                        },
                        "errorCallback": _.bind(function (response) {
                            utils.dialog.alert(response.message);
                        }, this)
                    });

                }
            });

        },

        /*
         amount 邮箱
         * 	 tel 电话号码
         * */
        validate: function (amount, tel) {
            var sf = this;
            if (tel == "") {
                safeKeyBoardHelper.setCustomValidity({
                    id: "amountInput",
                    message: "请输入手机号码"
                });
                return false;
            }
            mob = App.storage.get('UserInfo').get('telephoneNum');
            //获取用户手机号码

            if (mob == tel) {
                if (!this.ui.checkbox.eq(0).hasClass('on')) {
                    utils.dialog.toast("请阅读并同意协议！");
                    return false;
                }
                return true;

            } else {

                var telReg = !!tel.match(/^(0|86|17951)?(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/);
                if (telReg == false) {
                    utils.dialog.alert("请输入正确手机号码");
                    return false;

                }

            }
            if (amount == "") {
                safeKeyBoardHelper.setCustomValidity({
                    id: "amountInput",
                    message: "请输入邮箱"
                });
                return false;
            }

            var szReg_email = !!amount.match(/^(\w-*\.*)+@(\w-?)+(\.\w{2,})+$/);

            if (szReg_email == false) {
                utils.dialog.alert("请输入正确的电子邮箱");
                return false;
            }

            if (!this.ui.checkbox.eq(0).hasClass('on')) {
                utils.dialog.toast("请阅读并同意协议！");
                return false;
            }
            return true;

        },
        toggleCheckbox: function () {
            var checkbox = this.ui.checkbox.eq(0);
            checkbox.toggleClass("on");
        },
        openBookLink: function (e) {
            e.stopPropagation();
            utils.window.open({
                title: "产品说明",
                url: goldtreasure
            });
        }
    });
});
