/**
 * ex-wuyongsheng001 首页控制器
 */
define(function(require, exports, module) {
    var IndexView = require("../view/index");
    var IndexQryModel = require('../model/IndexQryModel');

    var Index = module.exports = Controller.extend({
        actions: {
            "index": "index" //未登陆状态首页
        },

        authorize: function() {
            return true;
        },

        /**
         * 未登陆
         */
        index: function() {
            if (App.storage.get('isUserLoggedIn')) {
                App.navigate('index/indexLogined/index', true);
                return;
            }
            utils.native.talkingDataTrackEvent("2.0首页-登陆前");
            App.header.reset({
                title: "平安橙子",
                rightButtonContent: "登录",
                rightButtonHandler: function() {
                    App.navigate("login/login/toaIndex", true);
                },
                leftButtonContent: "@messageCenter"
            });
            App.footer.reset({
                visible: true,
                selectedIndex: 0
            });

            utils.native.pawsFinish();
            /**
             * 判断是否有js缓存 -> 是 -> 用js缓存填充页面
             *                  -> 否 -> 请求native缓存 -> 填充页面 -> 模拟下拉 -> 请求接口刷新页面 -> 存入缓存
             */
            var _this = this,
                lastRefreshGT5min = false,
                lastRefresh = App.storage.get('indexPrdLastRefresh');

            if (lastRefresh) {
                lastRefreshGT5min = 5 < ((Date.now() - lastRefresh) / (1000 * 60));
            }

            if (IS_RUN_ON_DEVICE) {

                IndexQryModel.queryNativeProduct().done(function(result) {
                    _this._showIndexView(result);

                    // // 加个5min 时间判断， 如果上次缓存时间距离现在大于5分钟，
                    // // 就拉服务器数据刷新页面
                    if (lastRefreshGT5min) _this._queryProduct(false);

                }).fail(function() {
                    _this._queryProduct();
                });

            } else {
                _this._queryProduct();
            }

        },

        _queryProduct: function() {
            var _this = this;
            IndexQryModel.queryProduct({
                customType: 1
            }).done(function(result) {
                _this._showIndexView(result);
            }).fail(function(e) {
                utils.dialog.toast(e.message);
            });
        },

        _showIndexView: function(prdInfo) {
            App.container.show(new IndexView({
                prdInfo: prdInfo
            }));
        }

    });
});
