/**
 * ex-wuyongsheng001 首页控制器 已登录
 */
define(function(require, exports, module) {
    var IndexLoginedView = require("../view/indexLogined");
    var BenefitsView = require("../view/benefits");

    var IndexQryModel = require('../model/IndexQryModel');
    var Index = module.exports = Controller.extend({
        actions: {
            "index": "index", //登陆状态首页
            "benefits": "benefits"
        },

        index: function() {
            utils.native.talkingDataTrackEvent("2.0首页-登录后");
            App.header.reset({
                title: "平安橙子",
                leftButtonContent: "@messageCenter",
                rightButtonContent: "@exit"

            });
            App.footer.reset({
                visible: true,
                selectedIndex: 0
            });

            utils.native.pawsFinish();
            /**
             * 判断是否有js缓存 -> 是 -> 用js缓存填充页面
             *                  -> 否 -> 请求native缓存 -> 填充页面 -> 模拟下拉 -> 请求接口刷新页面 -> 存入缓存
             */
            var _this = this,
                lastRefreshGT5min = false,
                lastRefresh = App.storage.get('indexPrdLastRefresh');

            if (lastRefresh) {
                lastRefreshGT5min = 5 < ((Date.now() - lastRefresh) / (1000 * 60));
            }

            if (IS_RUN_ON_DEVICE) {

                IndexQryModel.queryNativeProduct().done(function(result) {
                    _this._showIndexView(result);

                    // // 加个5min 时间判断， 如果上次缓存时间距离现在大于5分钟，
                    // // 就拉服务器数据刷新页面
                    if (lastRefreshGT5min) _this._queryProduct();

                }).fail(function() {
                    _this._queryProduct();
                });

            } else {
                _this._queryProduct();
            }

        },

        _queryProduct: function() {
            var _this = this;
            IndexQryModel.queryProduct({
                customType: 1
            }).done(function(result) {
                _this._showIndexView(result);
            }).fail(function(e) {
                utils.dialog.toast(e.message);
            });
        },

        _showIndexView: function(prdInfo) {
            App.container.show(new IndexLoginedView({
                prdInfo: prdInfo
            }));
        },

        benefits: function() {
            var benefits = App.storage.get('index/indexLogined/benefits');
            if (!benefits) return;

            App.header.reset({
                title: "收益分析",
                leftButtonContent: "@back",
                leftButtonHandler: function() {
                    App.navigate('index/indexLogined/index', true);
                },
                rightButtonContent: null
            });
            App.footer.reset({
                visible: false
            });

            App.container.show(new BenefitsView({
                model: new Model(benefits)
            }));
        }

    });
});
