define(function(require, exports, module){
    
    exports.getBannerList = function(){
        return utils.native.readConfigAsXMLDoc().then(function(xml){
            var banners = $(xml).find("bannerList banner").map(function(idx, item){
                var $item = $(item);
                
                return {
                    url: $item.attr("url"),
                    img: $item.attr("img"),
                    title: $item.attr("title")
                };
            });
            
            return banners.get();
        });
    };
    
    // 查询平安盈万份收益和定活通年化收益率
    exports.qryInitDataBeforeLogin = function(data, success, error){
    	App.request("qryInitDataBeforeLogin", {
            data: data,
            silent : true,
            success: function(response){
                success(response);
            },
            error:function(response){
                error(response);
            }
        });
    };
    
    // 查询平安盈万份收益
    exports.get_pinganying_dahua_wanfenshouyi = function(){
        if(exports.get_pinganying_dahua_wanfenshouyi._cache)
            return exports.get_pinganying_dahua_wanfenshouyi._cache;
        
        var settings = {};
        settings.silent = true;
        settings.data = { fundCode: config.values.fund_code_dahua };
        
        var promise = App.request("qryProfitMillionIncome", settings).then(function(resp){
            return resp.object && resp.object.millionIncome;
        });
        
        promise.done(function(){
            exports.get_pinganying_dahua_wanfenshouyi._cache = promise;
        });
        
        return promise;
    };
    
    // 查询定活通年化收益率

    exports.get_dinghuotong_nianhuashouyi = function(){
          if(exports.get_dinghuotong_nianhuashouyi._cache)
              return exports.get_dinghuotong_nianhuashouyi._cache;
              var settings = {};
              settings.silent = true;
              settings.data = { fundCode: config.values.dinghuotong_code };
                            var promise = App.request("qryDepositInterestRate", settings).then(function(resp){
              //console.log(resp.object.intRate);
              return resp.object.intRate;
          });       
          promise.done(function(){
              exports.get_dinghuotong_nianhuashouyi._cache = promise;
          });       
          return promise;
      };
  
  
    //ocr身份证识别开关
	exports.getOcrSwitch = function(){
		var dfd = this.getOcrVersion();
		dfd.progress(function(ocrSwitch){
			if(ocrSwitch == "1"){
				utils.native.readConfigAsXMLDoc().then(function(xml){
		            var isOpened = $(xml).find("PlugsAppList OCR IsOpened").map(function(idx, item){
		                var $item = $(item);
		                return $item.text();
		            });
		            dfd.resolve(isOpened.get());
		        });
			}else{
				dfd.reject();
			}
		});
		return dfd;
    };
    
    //ocr的版本号
	exports.getOcrVersion = function(){
		var ocrSwitch = "";
		var dfd = $.Deferred();
		if(!IS_RUN_ON_DEVICE){
			dfd.notify("");
		}else{
			utils.native.versionInformation(function(data){
	            var version = data.version.replace(/\./g,"") * 1; 
	            if(IS_RUN_ON_ANDROID){
	            	if(version > 108){
		                ocrSwitch = "1";
		            }
	            }else{
	            	if(version > 109){
		                ocrSwitch = "1";
		            }
	            }
	        	dfd.notify(ocrSwitch);
	        });
		}
        return dfd;
    };
    
    //人脸识别开关、试点城市开关
    exports.RemoteRegister = function(){
        return utils.native.readConfigAsXMLDoc().then(function(xml){
        	var remoteIsOpened,OpenAllCity,TestCity;
            remoteIsOpened = $(xml).find("PlugsAppList RemoteRegister IsOpened").map(function(idx, item){
                var $item = $(item);
                return $item.text();
            });
            OpenAllCity = $(xml).find("PlugsAppList RemoteRegister OpenAllCity").map(function(idx, item){
                var $item = $(item);
                return $item.text();
            });
			var cityList = [];
            TestCity = $(xml).find("PlugsAppList RemoteRegister TestCity").map(function(idx, item){
                var $item = $(item);
				var strs = $item.text().split("|");
				for(var i in strs) {
					cityList[i]=strs[i];
				}
                return cityList;
            });
            var remoteObj = {remoteIsOpened:remoteIsOpened[0], OpenAllCity:OpenAllCity[0], TestCity:cityList};
            return remoteObj;
        });
    };
});