/**
 * wuyongsheng560 收益分析
 */
define(function(require, exports, module){
    require('highcharts');

    var tpl = _.template(require("text!../template/benefits.html"));
    module.exports = ItemView.extend({
        template : tpl,
        events: {
            "tap #toDaHua" : "toDaHua",
            "tap #toNanFang" : "toNanFang",
            "tap tr" : "togglePrdName"
        },
        initialize: function (options) {
            var colors = this.colors = ['#ff6633', '#ff9900', '#7ecef4', '#cc66cc', '#cfa972', '#8FC320'];
            options.model.set('colors', colors);

            this.yesterdayIncomeList = _.map(options.model.get('prdIncomeList'), function (item) {
                return parseFloat(item.yesterdayIncome);
            }) || [];

            this.yesterdayTotalIncome = parseFloat(options.model.get('yesterdayTotalIncome')) || 0.00;
        },

        onShow: function () {
            // console.log(this.model);
            if (this.yesterdayTotalIncome) {
                this._renderBenefitsTotal();
                this._renderRatioremark();
            }
        },

        _renderBenefitsTotal: function () {
            var _this = this,
                benefitsTotal = this.$('#benefitsTotal'),
                yesterdayTotalIncome = parseFloat(this.yesterdayTotalIncome.toFixed(2));
            if (!yesterdayTotalIncome || benefitsTotal.length < 1) return;
            var stepFun = _.throttle(function (step) {
                benefitsTotal.text(parseFloat(step).toFixed(2));
            }, 100);

            _this.tmp = { t: 0 };
            $(_this.tmp).stop().animate({ t: yesterdayTotalIncome }, {
                duration: 2000,
                step: function(now) {
                    stepFun(now);
                }
            });
        },

        _renderRatioremark: function () {
            var _this = this, ratios = _this.yesterdayIncomeList,
                ratioremarkEl = this.$('#ratioremark');
            if (ratioremarkEl.length < 1 || ratios.length < 1) return;

            if(this.highchart) {
                this.highchart.destroy();
                delete this.highchart;
            };

            this.highchart =  new Highcharts.Chart({
                chart: {
                    renderTo: ratioremarkEl[0],
                    height: 145,
                    width: 145,
                    style: {left: '-13px', top: '-39px'}
                },
                title: { text: ''},
                tooltip: { enabled: false },
                colors : _this.colors,
                plotOptions: {
                    pie: {
                        states:{
                            hover:{
                                enabled:false
                            }
                        },
                        borderWidth: 0,
                        dataLabels: {
                            enabled: false
                        },
                        size: 140,
                        innerSize: 120,
                        startAngle : -135,
                        center: ['50%', '55%']
                    },
                    series: {
                        animation: {
                            duration: 2000,
                        }
                    }
                },
                series: [{
                    type: 'pie',
                    data: ratios
                }]
            });

        },

        toDaHua : function () {
            var FUND_CODE_DAHUA   = config.values.fund_code_dahua;
            App.storage.set('pinganying/payIndex/index', new Model({prdCode : FUND_CODE_DAHUA, fromPage : 'benefits'}));
            App.navigate('pinganying/payIndex/index', true);
        },

        toNanFang : function () {
            var FUND_CODE_NANFANG = config.values.fund_code_nanfang;
            App.storage.set('pinganying/payIndex/index', new Model({prdCode : FUND_CODE_NANFANG, fromPage : 'benefits'}));
            App.navigate('pinganying/payIndex/index', true);
        },

        togglePrdName : function (e) {
            e.stopPropagation();
            $(e.currentTarget).find('.tals').toggleClass('ellipsis');
        }

    });

});
