/**
 * ex-wuyongsheng001 首页未登陆视图
 */
define(function(require, exports, module) {
	require('vendor/slick');
	var PTRScroll        = require('component/PTRScroll');
	var ListProductsView = require('./listProducts');
	var IndexTpl         = _.template(require('text!../template/index.html'));
	var TplBanner        = _.template(require('text!../template/banner.html'));
	var IndexQryModel    = require('../model/IndexQryModel');

	module.exports = Layout.extend({
		template: IndexTpl,
		regions: {
			indexProductsRegion: '#indexProductsRegion'
		},
		ui: {
			ADimg: '#ADimg',
			panicBuyEntrance : "#panicBuyEntrance",   //抢购专区
			indianaJones : "#indianaJones"   //夺宝奇兵（新手专享）
		},
		events: {
			'tap @ui.ADimg [banner-index]': 'toBanner', //跳转广告页
			'tap @ui.panicBuyEntrance' : 'panicBuyEntrance',
			'tap @ui.indianaJones' : 'indianaJones'		//夺宝奇兵（新手专享）入口
		},
		toBanner: function(e) {
			var index = parseInt($(e.currentTarget).attr('banner-index'), 10);
			var banner = this.bannerList[index];
			if (!banner || !banner.url) return;

			if (banner.url.charAt(0) === '#') App.navigate(banner.url, true);
			else utils.window.open(_.pick(banner, 'title', 'url'));
		},
		initialize: function(options) {
			this.prdInfo = options.prdInfo;
			this.firstTime = (App.APPHASOPENED === void 0);
			App.APPHASOPENED = 1;
		},
		onShow: function() {
			var _this = this;
			//抢购开关
			this.panicBuySwitch();
			//夺宝奇兵（新手专享）开关
			this.indianaJonesSwitch();

			this._initPTRScroll();

			this.renderBanner();

			this.initListProductsView().always(function() {
				_this._refreshPTRScroll();
				if (_this.firstTime) {
					_this._refreshData();

					_this.scroller.scrollTo(0, 50, 750);
				}
			});
		},
		onClose: function() {
			if (this.refreshTimer) clearTimeout(this.refreshTimer);
		},

		renderBanner: function() {
			utils.native.talkingDataTrackEvent("2.0首页-登陆前-启动页面广告");
			var _this = this;
			var container = _this.ui.ADimg;
			var height = container.width() / (640 / 200);
			container.height(height);

			IndexQryModel.getBannerList().done(function(result) {
				_this.bannerList = result;
				container.html(TplBanner({
					bannerList: _this.bannerList
				}));

				container.slick({
					fade: true,
					prevArrow: null,
					nextArrow: null,
					autoplay: true,
					autoplaySpeed: 8000,
					arrows: false,
					dotsClass: 'point',
					dots: true
				});
				container.find('[banner-img]').each(function() {
					var banner = $(this).height(height);
					var image = $('<img style="display:none;" />');
					image.on('load', function() {
						image.show();
					});
					image.appendTo(banner);
					image.prop('src', banner.attr('banner-img'));
				});
			});
		},

		initListProductsView: function() {
			var dfd = $.Deferred();
			var prdInfo = this.prdInfo || {};
			if (!prdInfo.params || !prdInfo.productList) return dfd.reject();

			this.listProductsView = new ListProductsView({
				collection: new Collection(prdInfo.productList),
				model: new Model(prdInfo.params)
			});
			this.listProductsView.on('show', function() {
				dfd.resolve();
			});

			this.indexProductsRegion.show(this.listProductsView);
			return dfd;
		},

		_initPTRScroll: function() {
			var _this = this,
				PTRScroller = this.$('#PTRScroller'),
				webviewHeight = (App.locStorage.get('webviewHeight') ||
					document.documentElement.clientHeight || window.innerHeight);
			if (PTRScroller.length !== 1) return;
			if (this.scroller) {
				this.scroller.destroy();
				delete this.scroller;
			}

			if (IS_RUN_ON_DEVICE) {
				webviewHeight = webviewHeight - 30;
			} else {
				webviewHeight = webviewHeight - App.footer.$el.height() - PTRScroller.offset().top;
			}

			PTRScroller.css({
				height: webviewHeight,
				position: 'relative'
			});

			_this.scroller = new PTRScroll(PTRScroller[0], {
				'hScroll': false,
				'hideScrollbar': true,
				'vScrollbar': false,
				'pullDownToRefresh': true,
				'pullUpToLoadMore': false,
				'refreshContent': function(refresh) {
					_this._refresher = refresh;
					_this._refreshData();
				}
				//, onBeforeScrollStart : function (e) {}
			});
		},

		_refreshData: function() {
			var _this = this;
			//抢购开关
			this.panicBuySwitch();

			IndexQryModel.queryProduct({
				customType: 1
			}).done(function(result) {

				if (_this.listProductsView && result.productList.length > 0) {
					_this.listProductsView.collection.reset(result.productList);
					_this.listProductsView.model.set(result.params);
				}

			}).always(function() {
				_this._refreshPTRScroll();
			});
		},

		_refreshPTRScroll: function() {
			var _this = this;
			if (_this.refreshTimer) clearTimeout(_this.refreshTimer);
			_this.refreshTimer = setTimeout(function() {
				if (_this._refresher) {
					_this._refresher();
				} else {
					_this.scroller && _this.scroller.refresh();
				}
			}, 500);
		},

		//抢购开关  ex-wuwenjun001
		panicBuySwitch : function(){
			var self = this;
			IndexQryModel.qryIsRuPurchase().done(function(res){
				if(res.object.swtch == 1){
					self.$("#panicBuyEntrance").text(res.object.document);
					self.$("#panicBuyEntrance").show();
				}
			}).always(function() {
				self._refreshPTRScroll();
			});
		},

		//抢购专区入口  ex-wuwenjun001
		panicBuyEntrance : function(){
			utils.native.talkingDataTrackEvent("2.0首页-抢购专区");
			App.navigate("products/index/panicBuy",true);
		},

		//夺宝奇兵（新手专享）开关 ex-chenfuhua001
		indianaJonesSwitch : function(){
			var self = this;
			IndexQryModel.chestSwitch({
				url:"outsidelogin",
				callback: function(res){
					//on开  off关
					if(res.object.chestSwitch == "on"){
						self.$("#indianaJones").removeClass("dsn");
					}
				},
				errorCallback: function(res){
					console.log(res.message);
				}
			});
		},

		//夺宝奇兵（新手专享）入口  ex-chenfuhua001
		indianaJones : function(){
			App.navigate(config.base.login_url + "?returnURL=" + "index/indexLogined/index", true);
		}
	});
});
