/**
 * ex-wuyongsheng001 首页 登陆视图
 */
define(function (require, exports, module) {
	var PTRScroll           = require('component/PTRScroll');
	var ListProductsView    = require('./listProducts');

	var activeStatus        = require('component/bindCardTip');

	var IndexTpl            = _.template(require('text!../template/indexLogined.html'));
	var IndexQryModel       = require('../model/IndexQryModel');
	var accountInfoSta      = require("mod/common/accountInfoStatus/accountInfoStatus"); //liujun add 认证
	var smartFinancialModel = require("../../smartFinancial/model/smartFinancial"); //liujun add 智能理财

	module.exports = Layout.extend({
		template: IndexTpl,
		regions: {
			indexProductsRegion: '#indexProductsRegion'
		},
		ui: {
			yesterdayEarning: '#yesterdayEarning',
			PTRScroller: '#PTRScroller',
			activate: '#activate',
			panicBuyEntrance : "#panicBuyEntrance",   //抢购专区
			indianaJones : "#indianaJones"   //夺宝奇兵（新手专享）
		},
		events: {
			//'tap @ui.yesterdayEarning .Earnings': 'toMyEarningDetail', //昨日收益详情页
			//'tap @ui.yesterdayEarning #showTips': 'showTipsDialog',
			//'tap @ui.yesterdayEarning .Nav > li': 'toMyAccountOrEarnPoint', //账户信息页或者赚取积分
			'tap @ui.activate': 'toActivate',
			'tap #myProperty'                    : 'toMyProperty',
			'tap @ui.panicBuyEntrance' : 'panicBuyEntrance',	//抢购专区入口
			'tap @ui.indianaJones' : 'indianaJones'		//夺宝奇兵（新手专享）入口
		},

		initialize: function (options) {
			this.prdInfo = options.prdInfo;
			this.firstTime = (App.APPHASOPENED === void 0);
			App.APPHASOPENED = 1;
		},
		onShow: function () {
			var _this = this,
				UserInfo = App.storage.get('UserInfo'),
				cardState = UserInfo.get('cardState'),
				activeState = UserInfo.get('activeState'),
				bindState = UserInfo.get('bindState');
			var bindCardFlag = App.storage.get('UserInfo').get('bindCardFlag');
			var firstActive = App.storage.get('bindCardFlag_first');
			//抢购开关
			this.panicBuySwitch();
			//夺宝奇兵（新手专享）开关
			this.indianaJonesSwitch();
			//初始化上下拉
			this._initPTRScroll();
			//渲染昨日收益
			this.renderYesterdayEarning();
			// 2015-10-30 登录后显示总资产
			//this.renderMyTotalAmt();
			//渲染首页产品列表
			this.initListProductsView().always(function () {
				_this._refreshPTRScroll();
				/**
				 * 针对生产产生的脏数据BUG
				 * 没有注册一账通或没有绑定一账通，橙子账户认证成功：
				 * 前端跳转路径错误，没有经过认证校验，直接认证身份
				 *
				 * 增加条件：
				 * activeState 0，未激活；1，已激活
				 * (cardState == '1' && activeState == '0')
				 *  bindState :已激活未绑卡，需提示绑卡
				 * (cardState == '1' && activeState == '1' && bindState == '0')
				 */
				if (cardState == '0' || cardState == '2' || (cardState == '1' && activeState == '0') ) {
					//延时3秒展开 激活提示
					var cradLossStatus = App.storage.get("cradLossStatus"); //挂失标识，挂失情况下不弹框提示
					//1）开关，2）完善信息，3）绑卡
					if (bindCardFlag == 1) {
						if (!cradLossStatus) {
							if (!firstActive) activeStatus.activeSwitch();
						}
					} else {
						clearTimeout(_this.slideDownTimer);
						_this.slideDownTimer = setTimeout(function () {
							_this.ui.activate.slideDown(500, function () {
								_this._refreshPTRScroll();
								if (_this.firstTime) {
									_this._refreshData();
									_this.scroller.scrollTo(0, 50, 750);
								}
							});
						}, 2500);
					}

				} else if(cardState == '1' && activeState == '1' && bindState == '0' && bindCardFlag == '1'){
					if (!firstActive) activeStatus.activeSwitch();
				}else {
					if (_this.firstTime) {
						_this._refreshData();
						_this.scroller.scrollTo(0, 50, 750);
					}
				}
			});

			//liujun add 智能理财
			if (App.storage.get('smartFinancialRisk')) {
				App.storage.remove('smartFinancialRisk');
			}
		},
		onClose: function () {
			if (this.refreshTimer) clearTimeout(this.refreshTimer);
			if (this.slideDownTimer) clearTimeout(this.slideDownTimer);
			if (this.showTips) this.showTips.remove();
		},
		// 2015-11-02 显示资产提示
		showTipsDialog: function (event) {
			event.stopPropagation(); event.preventDefault();
			if (this.showTips) return;
			var self = this,
				str = '<div class="Mask" style="top:0;background:rgba(0,0,0,0.80)">' +
					'<div class="center">' +
					'<div class="zgcMain ">' +
					'<span class="f22 dsb tac">总资产</span>' +
					'<p>总资产=（活期余额）+（黄金投资，市值）+（平安盈余额）+（非货币基金，持有市值）+（理财产品本金）；理财产品预期收益以到期实际收益为准，到期前收益不计入总资产</p>' +
					'<div class="p_10">' +
					'<input type="button" value="知道了" class="btn_orange m_t5"/>' +
					'</div>' +
					'</div>' +
					'</div>' +
					'</div>';
			this.showTips = $(str).appendTo('body');

			this.showTips.find('input.btn_orange').on('click', function (e) {
				self.showTips.remove();
				delete self.showTips;
			});
		},

		toActivate: function () {
			var accountSta = accountInfoSta.getAccountInfoLossStatus('index/indexLogined/index');
			if (accountSta) {
				App.navigate('verifyAccount/main/verify', true);
			}
		},

		toMyProperty: function(){
			App.storage.set('myProperty/myProperty/index/fromPageIndex', true);
			App.navigate('myProperty/myProperty/index', true);
		},

		toMyEarningDetail: function (e) {
			App.navigate('myProperty/myProperty/index', true);
			//App.navigate('pinganying/payIndex/index', true);
			// var benefits = App.storage.get('index/indexLogined/benefits');
			// if (!benefits) return;
			// App.navigate('index/indexLogined/benefits', true);
		},
		toMyAccountOrEarnPoint: function (e) {
			var id = $(e.currentTarget).index();
			switch (id) {
				case 0:
					App.storage.set('myProperty/myProperty/index/fromPageIndex', true);
					App.navigate('myProperty/myProperty/index', true);
					break;
				case 1:
					App.storage.set('me/accoutAndSecurity/index/fromPageIndex', true);
					App.navigate('me/accoutAndSecurity/index', true);
					break;
				case 2:
					this.smartFinancial();
					break;
			}
		},
		renderYesterdayEarning: function () {
			var yesterday = this.$('#yesterdayEarningTotal');
			IndexQryModel.queryYesterdayEarning().done(function (res) {
				yesterday.text(res.yesterdayTotalIncome ? utils.string.numberFormat(res.yesterdayTotalIncome) : '--');
			}).fail(function () {
				yesterday.text('--');
			});
		},

		renderMyTotalAmt: function () {
			var myTotalAmtEl = this.$('#myTotalAmt');
			myTotalAmtEl.html('<i class="loadcon"></i>');

			IndexQryModel.queryAccountInfo().done(function (result) {
				var totalAmt = result.totalAmt;
				myTotalAmtEl.text(totalAmt ? utils.string.numberFormat(totalAmt) : '--');
			}).fail(function () {
				myTotalAmtEl.text('--');
			});
		},

		initListProductsView: function () {
			var dfd = $.Deferred();
			var prdInfo = this.prdInfo || {};
			if (!prdInfo.params || !prdInfo.productList) return dfd.reject();

			this.listProductsView = new ListProductsView({
				collection: new Collection(prdInfo.productList),
				model: new Model(prdInfo.params)
			});
			this.listProductsView.on('show', function () {
				dfd.resolve();
			});

			this.indexProductsRegion.show(this.listProductsView);
			return dfd;
		},

		_initPTRScroll: function () {
			var _this = this,
				PTRScroller = this.$('#PTRScroller'),
				webviewHeight = (App.locStorage.get('webviewHeight') ||
					document.documentElement.clientHeight || window.innerHeight);
			if (PTRScroller.length !== 1) return;
			if (this.scroller) {
				this.scroller.destroy();
				delete this.scroller;
			}

			if (IS_RUN_ON_DEVICE) {
				webviewHeight = webviewHeight - 30;
			} else {
				webviewHeight = webviewHeight - App.footer.$el.height() - PTRScroller.offset().top;
			}

			PTRScroller.css({
				height: webviewHeight,
				position: 'relative'
			});

			_this.scroller = new PTRScroll(PTRScroller[0], {
				'hScroll': false,
				'hideScrollbar': true,
				'vScrollbar': false,
				'pullDownToRefresh': true,
				'pullUpToLoadMore': false,
				'refreshContent': function (refresh) {
					_this._refresher = refresh;
					_this._refreshData(true);
				}
				//, onBeforeScrollStart : function (e) {}
			});
		},

		_refreshData: function (force) {
			var _this = this;
			if (force) {
				this.renderYesterdayEarning();
				//this.renderMyTotalAmt();
			}
			//抢购开关
			this.panicBuySwitch();

			IndexQryModel.queryProduct({
				customType: 1
			}).done(function (result) {
				if (_this.listProductsView && result.productList.length > 0) {
					_this.listProductsView.collection.reset(result.productList);
					_this.listProductsView.model.set(result.params);
				}
			}).always(function () {
				_this._refreshPTRScroll();
			});
		},

		_refreshPTRScroll: function () {
			var _this = this;
			if (_this.refreshTimer) clearTimeout(_this.refreshTimer);
			_this.refreshTimer = setTimeout(function () {
				if (_this._refresher) {
					_this._refresher();
				} else {
					_this.scroller && _this.scroller.refresh();
				}
			}, 500);
		},

		//liujun add 智能理财
		smartFinancial: function () {
			//查询数据，判断是否签约、是否评测
			//评测状态
			var dfd = window.accountInfoStatus.getAccountInfoStatus(false, "index/indexLogined/index");
			dfd.done(function (status) {
				if (status) {
					var promise = $.when(
						smartFinancialModel.qrySmartFinancialState(),
						smartFinancialModel.riskAbilityTestQry()
						);
					promise.done(_.bind(function (arg1, arg2) {
						arg1 = arg1[0].object;
						arg2 = arg2[0].object;
						//签约状态
						// console.log(obj1);
						var smartStatus = arg1;
						var riskState = arg2.otherRiskStatus;
						if (!smartStatus || smartStatus.status == "1") {
							//未签约
							if (riskState == "2" || riskState == "3") {
								//未评测及过期,广告、评测->结果->签约页
								App.storage.set("smartFinancialRisk", "1");
								App.storage.set("smartFinancial/smartFinancial/fromPage", 2);
								App.navigate("smartFinancial/smartFinancial/index", true);
							} else if (riskState == "1") {
								App.storage.set("smartFinancialRisk", "1");
								App.storage.set("smartFinancial/smartFinancial/fromPage", 2);
								App.storage.set("smartFinancialLevel", arg2.riskLevel);
								App.navigate("smartFinancial/smartFinancial/evaluated", true);
								//是否重评+签约点击->签约页
							} else { }
						} else {
							App.storage.set("smartFinancial/smartFinancial/fromPage", 2);
							App.storage.set("smartFinancialLevel", arg2.riskLevel);
							App.navigate("smartFinancial/smartFinancial/signed", true);
						}
					}, this));

					promise.fail(function (err) {
						utils.dialog.toast(err.message);
					});
				} else { }
			});
		},

		//抢购开关 ex-wuwenjun001
		panicBuySwitch : function(){
			var self = this;
			IndexQryModel.qryIsRuPurchase().done(function(res){
				if(res.object.swtch == 1){
					self.$("#panicBuyEntrance").text(res.object.document);
					self.$("#panicBuyEntrance").show();
				}
			}).always(function() {
				self._refreshPTRScroll();
			});
		},

		//抢购专区入口  ex-wuwenjun001
		panicBuyEntrance : function(){
			utils.native.talkingDataTrackEvent("2.0首页-抢购专区");
			App.navigate("products/index/panicBuy",true);
		},

		//夺宝奇兵（新手专享）开关 ex-chenfuhua001
		indianaJonesSwitch : function(){
			var self = this;
			IndexQryModel.chestSwitch({
				url:"chestSwitch",
				callback: function(res){
					//on开  off关
					if(res.object.chestSwitch == "on"){
						self.$("#indianaJones").removeClass("dsn");
					}
				},
				errorCallback: function(res){
					console.log(res.message);
				}
			});
		},

		//夺宝奇兵（新手专享）入口  ex-chenfuhua001
		indianaJones : function(){
			utils.native.talkingDataTrackEvent("2.0首页-夺宝奇兵");
			App.navigate("indianaJones/indianaJones/index",true);
		}
	});
});
