/**
 * ex-chenfuhua001
 * 功能描述：夺宝奇兵（新手专享）
 */

define(function (require, exports, module) {
	var IndianaJonesView         = require("../view/indianaJonesView");
	var NewOrangeChestView       = require("../view/newOrangeChestView");
	var NewFinancialDatabaseView = require("../view/newFinancialDatabaseView");
	var PopularDatabaseView      = require("../view/popularDatabaseView");
	var RevenueDetailsView       = require("../view/revenueDetailsView");
	var RevenueErrorView         = require("../view/revenueErrorView");
	var indianaJonesModel        = require("../model/indianaJonesModel");
	var Index = module.exports = Controller.extend({
		actions: {
			index                : "index",
			newOrangeChest       : "newOrangeChest",
			newFinancialDatabase : "newFinancialDatabase",
			popularDatabase      : "popularDatabase",
			revenueDetails       : "revenueDetails",
			revenueError         : "revenueError"
		},

		//宝箱列表页
		index : function(){
			App.header.reset({
				title: "夺宝奇兵",
				leftButtonContent: "@back",
				leftButtonHandler: function () {
					App.navigate("search/search/index", true);
				}
			});
			App.footer.reset({visible:false});
			//请求宝箱列表数据
			indianaJonesModel.indianaJones({
				callback: function(res){
					var list = res.object.list;
					//var indianaJonesOption = {newOrange:"",newFinancial:"",popularity:""};
					var indianaJonesOption = {databaseList:["","",""]};
					for(var i in list){
						if(list[i].boxType == "01"){
							indianaJonesOption.databaseList[0] = list[i];
						}else if(list[i].boxType == "02"){
							indianaJonesOption.databaseList[1] = list[i];
						}else if(list[i].boxType == "03"){
							indianaJonesOption.databaseList[2] = list[i];
						}
					};
					if(list.length == 2){
						indianaJonesOption.databaseList[0] = indianaJonesOption.databaseList[2];
						indianaJonesOption.databaseList.pop();
					}
					App.storage.set('indianaJonesOption',indianaJonesOption);
					App.container.show(new IndianaJonesView({model: new Model(indianaJonesOption)}));
				},
				errorCallback: function(res){
					utils.dialog.alert(res.message);
				}
			});
		},

		//新橙宝箱详情页
		newOrangeChest : function(){
			App.header.reset({
				title: "夺宝奇兵",
				leftButtonContent: "@back",
				leftButtonHandler: function () {
					App.navigate("indianaJones/indianaJones/index", true);
				}
			});
			var newOrangeOption = App.storage.get('indianaJonesOption').databaseList[0];
			App.container.show(new NewOrangeChestView({model: new Model(newOrangeOption)}));
		},

		//新人理财宝箱详情页
		newFinancialDatabase : function(){
			App.header.reset({
				title: "夺宝奇兵",
				leftButtonContent: "@back",
				leftButtonHandler: function () {
					App.navigate("indianaJones/indianaJones/index", true);
				}
			});
			var newFinancialOption = App.storage.get('indianaJonesOption').databaseList[1];
			App.container.show(new NewFinancialDatabaseView({model: new Model(newFinancialOption)}));
		},

		//人气宝箱详情页
		popularDatabase : function(){
			App.header.reset({
				title: "夺宝奇兵",
				leftButtonContent: "@back",
				leftButtonHandler: function () {
					App.navigate("indianaJones/indianaJones/index", true);
				}
			});
			var indianaJonesOption = App.storage.get('indianaJonesOption');
			var popularityOption = indianaJonesOption.databaseList[2] || indianaJonesOption.databaseList[0]
			App.container.show(new PopularDatabaseView({model: new Model(popularityOption)}));
		},

		//宝箱列表详情页
		revenueDetails : function(){
			App.header.reset({
				title: "夺宝奇兵",
				leftButtonContent: "@back",
				leftButtonHandler: function () {
					App.back();
				}
			});
			//请求宝箱列表数据
			indianaJonesModel.searchListbox({
				callback: function(res){
					var list = res.object.list;
					var indianaJonesOption = {newOrange:"",newFinancial:"",popularity:""};
					for(var i in list){
						if(list[i].boxType == "01"){
							indianaJonesOption.newOrange = list[i];
						}else if(list[i].boxType == "02"){
							indianaJonesOption.newFinancial = list[i];
						}else if(list[i].boxType == "03"){
							indianaJonesOption.popularity = list[i];
						}
					};
					App.storage.set('indianaJonesOption',indianaJonesOption);
					var newOrange    = indianaJonesOption.newOrange;
					var newFinancial = indianaJonesOption.newFinancial;
					var popularity   = indianaJonesOption.popularity;
					//如果新橙宝箱存在则去判断3个宝箱有宝箱已打开
					if(newOrange && (newOrange.boxStatus != 0 || newFinancial.boxStatus != 0 || popularity.boxStatus != 0)){
						if(newOrange.boxStatus == 3 || newFinancial.boxStatus == 3 || popularity.boxStatus == 3){
							App.container.show(new RevenueErrorView());
						}else{
							App.container.show(new RevenueDetailsView({model: new Model(indianaJonesOption)}));
						}
					//如果新橙宝箱不存在则判断2个宝箱有宝箱已打开
					}else if(!newOrange && (newFinancial.boxStatus != 0 || popularity.boxStatus != 0)){
						if(newFinancial.boxStatus == 3 || popularity.boxStatus == 3){
							App.container.show(new RevenueErrorView());
						}else{
							App.container.show(new RevenueDetailsView({model: new Model(indianaJonesOption)}));
						}
					//如果三个宝箱都不存在，跳到错误页面
					}else{
						App.container.show(new RevenueErrorView());
					}
				},
				errorCallback: function(res){
					utils.dialog.alert(res.message);
				}
			});
		},

		//宝箱列表详情错误页
		revenueError : function(){
			App.header.reset({
				title: "夺宝奇兵",
				leftButtonContent: "@back",
				leftButtonHandler: function () {
					App.back();
				}
			});
			App.container.show(new RevenueErrorView());
		}
	});
});
