/*
 * 橙易贷申请控制器
 * ex-maningjie001
 */
define(function(require,exports,module){
	var ApplyLoanView   = require("../view/apply/applyLoan");
	var SelfBankView    = require("../view/apply/selfBank");
	var BasicInfoView   = require("../view/apply/applyBasicInfo");
	var ApplyIDCardView = require("../view/apply/applyIDCard");
	var ApplyWaitView   = require("../view/apply/applyWait");
	var ApplyFailView   = require("../view/apply/applyFail");
	var loanModel       = require("../model/loanModel");
	module.exports = Controller.extend({

		actions:{
			"index"     : "index",
			"selfBank"  : "selfBank",
			"basicInfo" : "basicInfo",
			"IDcard"    : "IDcard",
			"applyWait" : "applyWait",
			"applyFail" : "applyFail"
		},

		index:function(){
			App.header.reset({
				title : "橙e贷",
				leftButtonContent : "@back",
				leftButtonHandler : function() {
					App.back();
				}
			});
			App.footer.reset({
				visible: false,
				selectedIndex: 0
			});
			App.container.show(new ApplyLoanView());
		},

		//本行员工
		selfBank:function(){
			App.header.reset({
				title : "橙e贷",
				leftButtonContent : "@back",
				leftButtonHandler : function() {
					App.back();
				}
			});
			App.footer.reset({
				visible: false,
				selectedIndex: 0
			});
			App.container.show(new SelfBankView());
		},

		//填写个人信息
		basicInfo:function(){
			App.header.reset({
				title : "申请",
				leftButtonContent : "@back",
				leftButtonHandler : function() {
					App.back();
				}
			});
			loanModel.searchInfo({
				callback:function(res){
					var obj=res.object;
					App.storage.set("basicInfo",obj);
					App.container.show(new BasicInfoView({model:new Model(obj)}));
				},
				errorCallback:function(res){
					utils.dialog.toast(res.message);
				}
			});
		},

		//征信授权
		IDcard:function(){
			App.container.show(new ApplyIDCardView());
		},

		//等待审核
		applyWait:function(){
			App.header.reset({
				title : "",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.navigate("me/logined/index",true);
				}
			});
			App.footer.reset({
				visible: false,
				selectedIndex: 0
			});
			App.container.show(new ApplyWaitView());
		},

		//申请失败
		applyFail:function(){
			App.header.reset({
				title : "",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.navigate("me/logined/index",true);
				}
			});
			App.footer.reset({
				visible: false,
				selectedIndex: 0
			});
			App.container.show(new ApplyFailView());
		}
	});
});
