/**
 * EX-chenfuhua001
 * 功能描述：橙易贷还款
 */

define(function(require, exports, module){
	var IndexView          = require("../view/indexView");
	var RepaymentListView  = require("../view/repayment/repaymentListView");
	var RepaymentView      = require("../view/repayment/repaymentView");
	var PrepaymentView     = require("../view/repayment/prepaymentView");
	var RepaymentStateView = require("../view/repayment/repaymentStateView");
	var RepaymentModel     = require("../model/repaymentModel");
	var Index = module.exports = Controller.extend({
		actions : {
			index          : "index",
			repaymentList  : "repaymentList",
			repayment      : "repayment",
			prepayment     : "prepayment",
			repaymentState : "repaymentState"
		},

		//提款列表
		index: function(){
			App.header.reset({
				title: "橙e贷",
				leftButtonContent : '@back',
				leftButtonHandler : function() {
					App.navigate("me/logined/index", true);
				}
			});
			App.footer.reset({visible:false});
			RepaymentModel.repaymentList({
				data : {"pageIndex":"1","pageSize":"10" },
				callback: function(res){
					var withdrawalList = res.object;
					App.container.show(new IndexView({model: new Model(withdrawalList)}));
				},
				errorCallback: function(res){
					utils.dialog.alert(res.message);
				}
			});
		},

		//还款列表
		repaymentList:function(){
			App.header.reset({
				title: "橙e贷",
				leftButtonContent : '@back',
				leftButtonHandler : function() {
					App.navigate("loan/loan/index", true);
				}
			});
			App.footer.reset({visible:false});
			var loanAcctNo =  App.storage.get('loan_list').loanAcctNo;
			RepaymentModel.loanDetails({
				data : {"loanAcctNo":loanAcctNo},
				callback: function(res){
					var repaymentList = res.object;
					App.container.show(new RepaymentListView({model: new Model(repaymentList)}));
				},
				errorCallback: function(res){
					utils.dialog.alert(res.message);
				}
			});
		},

		//一般还款（分期还款）
		repayment:function(){
			App.header.reset({
				title: "橙e贷",
				leftButtonContent : '@back',
				leftButtonHandler : function() {
					App.navigate("loan/loan/repaymentList", true);
				}
			});
			App.footer.reset({visible:false});
			var orangeEasyLoanList = App.storage.get('orangeEasyLoanList');
			App.container.show(new RepaymentView({model: new Model(orangeEasyLoanList)}));
		},

		//提前还款
		prepayment:function(){
			App.header.reset({
				title: "橙e贷",
				leftButtonContent : '@back',
				leftButtonHandler : function() {
					App.navigate("loan/loan/repaymentList", true);
				}
			});
			App.footer.reset({visible:false});
			App.container.show(new PrepaymentView());
		},

		//提款成功页
		repaymentState : function(){
			App.header.reset({
				title: "橙e贷",
				leftButtonContent : '@back',
				leftButtonHandler : function() {
					App.navigate("loan/loan/index", true);
				}
			});
			App.footer.reset({visible:false});
			App.container.show(new RepaymentStateView());
		}
	});
});