/*
 * 征信授权视图
 * ex-maningjie001
 */
define(function(require,exports,module){
	var ApplyIDcardTpl  = require("text!../../template/apply/applyIDCard.html");
	var CustomPwdInput  = require("component/password/customPwdInput");
	var FormLayout      = require("component/form");
	var loanModel       = require("../../model/loanModel");
	var faceRecognition = require("component/faceRecognition");
	var LoadingLayer    = require("app/renderDuringRequest/loadingLayer");

	module.exports = FormLayout.extend({
		template: _.template(ApplyIDcardTpl),

		events: {
			"tap #btnSubmit"        : "toSubmit",
			"tap #thirdUse"         : "showThirdUse",
			"tap #selfAuthorize"    : "showSelfAuthorize",
			"tap #agreement"        : "setAgreement",
			"tap #uploadPhotoBtn"   : "uploadPhoto",
			"tap .showImg"          : "showImg"
		},

		initialize: function () {
		    this.passFlag = false;
			this.formData = {};
			this.submitFlag = false;
			this.uploadphotoURL = "";//base64码
			this.file = false; //身份证正反面是否上传
			this.load = new LoadingLayer();
			this.subFlag = false; //点击放大图片防重复
		},

		//个人征信授权书转为图片
		getAgreement:function(idNo){
			var canvas = document.getElementById("canvas");
			var ctx = canvas.getContext("2d");
			var idNum ="身份证号码："+idNo;
			var telNo ="手机号码："+App.storage.get("UserInfo").get("telephoneNum");
			var userName ="授权人："+App.storage.get("basicInfo").userName;
			var date = utils.date.formatTime(App.storage.get("Login_SysTime")).format("yyyy年MM月dd日");
			ctx.fillStyle="#FFF";
			ctx.fillRect(0,0,400,800);
			ctx.font = "20px 黑体";
			ctx.textAlign = "center";
			ctx.fillStyle = "#000";
			ctx.fillText("个人征信授权书", 200, 40);
			ctx.font = "14px 黑体";
			ctx.textAlign = "left";
			ctx.fillText("重要提示:", 40, 85);
			ctx.fillText("尊敬的客户，为了维护您的权益，请在签署本", 70, 110);
			ctx.fillText("授权书前，仔细阅读本授权书各条款（特别是黑体", 40, 135);
			ctx.fillText("字条款）,关注您在授权书中的权利、义务。如有", 40, 160);
			ctx.fillText("任何疑问，请向经办行咨询。", 40, 185);
			ctx.font = "14px 宋体";
			ctx.fillStyle = "#666";
			ctx.fillText("借款人授权", 40, 230);
			ctx.fillText("本人因向平安银行申请信贷业务，", 70, 255);
			ctx.font = "14px 黑体";
			ctx.fillStyle = "#000";
			ctx.fillText("特授权平", 280, 255);
			ctx.fillText("安银行在本人信贷业务申请阶段及业务存续期间，", 40, 280);
			ctx.fillText("向金融信用信息基础数据库和其他经国务院征信业", 40, 305);
			ctx.fillText("监督管理部门批准设立的征信机构查询本人个人信", 40, 330);
			ctx.fillText("息及信用信息，用于本人信贷业务申请与后续管", 40, 355);
			ctx.fillText("理，", 40, 380);
			ctx.font = "14px 宋体";
			ctx.fillStyle = "#666";
			ctx.fillText("超出上述授权查询的一切后果及法律责任由平", 70, 380);
			ctx.fillText("安银行承担。", 40, 405);
			ctx.fillText("本人特授权平安银行依据《征信业管理条", 70, 430);
			ctx.fillText("例》的规定，", 40, 455);
			ctx.font = "14px 黑体";
			ctx.fillStyle = "#000";
			ctx.fillText("将本人个人信息和信用信息,包括但", 124, 455);
			ctx.fillText("不限于信贷信息及对信息主体信用状况构成负面影", 40, 480);
			ctx.fillText("响的信息，报送金融信用信息基础数据库和其他经", 40, 505);
			ctx.fillText("国务院征信业监督管理部门批准设立的征信机构。", 40, 530);
			ctx.font = "14px 宋体";
			ctx.fillStyle = "#666";
			ctx.fillText("本人在此声明已知悉并理解上述授权条款。", 70,555);
			ctx.fillText(idNum, 40, 600);
			ctx.fillText(telNo, 40, 625);
			ctx.fillText(userName, 40, 670);
			ctx.fillText(date, 40, 715);
			this.uploadphotoURL += "_add"+canvas.toDataURL("image/jpg", 0.8);
		},

		//上传身份证
		uploadPhoto:function(e){
			var self = this;
			utils.native.idCardScan(function(data){
				var IDCardInfo = self.IDCardInfo = JSON.parse(data);
				self.IDCardInfo.VALID_PERIOD = self.IDCardInfo.VALID_PERIOD || "";
				var effectDate = self.IDCardInfo.VALID_PERIOD.substr(0, 10).replace(/\./g, '') || (self.IDCardInfo.effectDate || '').replace(/\-/g, '');
				var expireDate = self.IDCardInfo.VALID_PERIOD.substr(11, 10).replace(/\./g, '') || (self.IDCardInfo.expireDate || '').replace(/\-/g, '');
				var birthday = (self.IDCardInfo.cardno || self.IDCardInfo.cardNumber || '').substr(6, 8);

				//是否符合公安机关对证件有效期的规则
				if(!!effectDate && !!expireDate && !!birthday) {
					if(!self._IDCardValidity(effectDate, expireDate, birthday)) {
						utils.dialog.confirm('不符合公安机关证件有效期规则，是否重新扫描身份证？', function (flag) {
							if(flag){
								self.uploadPhoto();
								return;
							}
						});
					}else{
						var cardno = IDCardInfo.cardno;
						if(cardno && !self.file){
							self.formData.idNo = IDCardInfo.cardno;
							self.formData.globalExpiryDate = expireDate;
							utils.native.versionInformation(function(data) {
								vs = data.version;
								if (vs.replace(/\./g, "") * 1 >= 212) {
									self.getOcrCode();
								} else {
									self.load.show();
									setTimeout(function(){
										self.load.hide();
										self.getOcrCode();
									},1500);
								}
							});
						}else{
							utils.dialog.confirm("您的身份证识别未通过，请重新上传。",function(ok){
								if(ok){
									self.uploadPhoto();
									return;
								}
							});
						}
					}
				}else{
					utils.dialog.confirm("您的身份证识别未通过，请重新上传。",function(ok){
						if(ok){
							self.uploadPhoto();
							return;
						}
					});
				}
			});
		},

		//获取ocr  base64码
		getOcrCode: function(){
			var self = this;
			utils.native.getIDCardImage(function(param){
				var param = JSON.parse(param);
				if(param.idCard1 && param.idCard2){
					self.file = true;
					$("#uploadPhoto").hide();
					$("#imgPhoto").show();
					$("#fileAShow img").attr("src", "data:image/jpg;base64,"+param.idCard1);
					$("#fileBShow img").attr("src", "data:image/jpg;base64,"+param.idCard2);
					self.uploadphotoURL += $("#fileAShow img").attr("src")+"_add"+$("#fileBShow img").attr("src");
					if($("#agreement").hasClass("on")){
						$("#btnSubmit").removeClass("btn_disable");
					}
					self.getAgreement(self.formData.idNo);
				}else{
					utils.dialog.confirm("您的身份证识别未通过，请重新上传。",function(ok){
						if(ok){
							self.uploadPhoto();
							return;
						}
					});
				}
			})
		},


		 /*
		 * 计算身份证的有效期
		 *
		 * 检查规则：
		 * 十六周岁以上公民的居民身份证的有效期为十年、二十年、长期。
		 * 十六周岁至二十五周岁的，发给有效期十年的居民身份证；
		 * 二十六周岁至四十五周岁的，发给有效期二十年的居民身份证；
		 * 四十六周岁以上的，发给长期有效的居民身份证。
		 * 未满十六周岁的公民，自愿申请领取居民身份证的，发给有效期五年的居民身份证。
		 */
		_IDCardValidity: function (effectDate, expireDate, birthday) {
			if (!effectDate || !expireDate || !birthday) return;
			var age = utils.date.diffDate(birthday, effectDate) / 365;        //领证年龄
			if (expireDate == "长期") {
				if (46 <= age) {
					return true;
				} else {
					return false;
				}
			}
			var idValidity = utils.date.diffDate(effectDate, expireDate) / 365;
			var validity;
			switch (true) {
				case age < 16:
					validity = 5;
					break;
				case 16 <= age && age <= 25:
					validity = 10;
					break;
				case 26 <= age && age <= 45:
					validity = 20;
					break;
			}
			if (parseInt(idValidity) == validity || Math.round(idValidity)) {
				return true;
			} else {
				return false;
			}
		},

		//点击显示身份证照片
		showImg:function(e){
			var self = this;
			if(this.subFlag){
				return;
			}
			this.subFlag = true;
			//e.stopPropagation();e.preventdefault();
			var fileA = $(e.currentTarget).children("img").attr("src").replace(/^data:image\/jpg;base64,/, '');
			var fileB = "";
			if(e.currentTarget.id == "fileAShow"){
				fileB = $("#fileBShow img").attr("src").replace(/^data:image\/jpg;base64,/, '');
			}else{
				fileB = $("#fileAShow img").attr("src").replace(/^data:image\/jpg;base64,/, '');
			}
			var fileURL = [fileA, fileB];
			var callback = function(){
				self.subFlag = false
			};
			// 调用native方法展示照片墙
			utils.native.gallery.show({
				source:fileURL
			}, callback);
		},

		//同意协议勾选框
		setAgreement:function(){
			if($("#agreement").hasClass("on")){
				$("#agreement").removeClass("on");
				$("#btnSubmit").addClass("btn_disable");
			}else{
				$("#agreement").addClass("on");
				if(this.file){
					$("#btnSubmit").removeClass("btn_disable");
				}
			}
		},

		//《人行征信报告及第三方账户授权使用协议》
		showThirdUse:function(e){
			e.stopPropagation(); e.preventDefault();
			utils.window.open({
				title: "协议详情",
				url: "https://ssl.pingan.com/bank/xieyi/wy/xhsx.shtml"
			});
		},

		//人行征信授权协议
		showSelfAuthorize:function(e){
			e.stopPropagation(); e.preventDefault();
			var superLink = $("<a>");
			var _href = "";
			_href += "mod/loan/template/apply/customerService.html?trueName=";
			_href += App.storage.get("basicInfo").userName + "&telNo=";
			_href += App.storage.get("basicInfo").mobileNo + "&idNo=";
			_href += App.storage.get("basicInfo").idNo + "&time=";
			_href += App.storage.get("Login_SysTime");
			superLink.prop("href", _href);
			utils.window.open({
				title : "申请",
				url : superLink.prop("href")
			});
		},

		//提交
		toSubmit: function(){
			if($("#btnSubmit").hasClass('btn_disable')){
				return;
			}
			var self = this;
			if(this.submitFlag){
				return;
			}
			if(!this.passFlag){
				CustomPwdInput.customPwdInput(function(password){
					self.formData.password = utils.crypto.RSAKey.encrypt(password, config.base.rsa_public_key);
					self.formData.sm2Pwd = utils.sm2.SM2Key.encrypt(password, config.base.sm2_public_key);
					self.formData.photo = self.uploadphotoURL;
					self.formData.email = App.storage.get("verifyEmail");
					self.formData.lng = App.storage.get("locate").longitude;
					self.formData.lat = App.storage.get("locate").latitude;
					self.submitFlag = true;
					loanModel.submitApplyLoan({
						params:self.formData,
						callback:function(resp){
							self.passFlag = true;
							self.submitFlag = false;
							utils.dialog.confirm("为了您的资金安全，需要您先通过人脸验证。", function (ok) {
								if(ok){
									self.faceRecognite();
								}
							});
						},
						errorCallback:function(resp){
							self.submitFlag = false;
							utils.dialog.alert(resp.message);
						}
					});
				});
			}else{
				utils.dialog.confirm("为了您的资金安全，需要您先通过人脸验证。", function (ok) {
					if(ok){
						self.faceRecognite();
					}
				});
			}

		},

		//人脸识别
		faceRecognite:function(){
			var self = this;
			faceRecognition(function(err, isSamePerson){
				if(err){
					utils.dialog.confirm('抱歉，您的验证失败，可以尝试通过以下方式：保持光线充足与均匀、确保人脸出现在方框内、避免戴帽子或眼睛', function(ok){
						if(ok){
							self.faceRecognition();
							return;
						}
					});
				}
				//是否是同一个人：true为同一人，false为不为同一人
				if(isSamePerson){
					loanModel.checkApplyLoan({
						callback:function(res){
							var obj = res.object;
							App.storage.set("checkApplyLoan",obj);
							if(obj.applyFlag=="0" || obj.applyFlag =="4"){
								App.navigate('loan/applyLoan/applyWait', true);
							}else if(obj.applyFlag == "1"){
								App.navigate("loan/loan/index",true);
							}else if(obj.applyFlag == "2"){
								App.navigate("loan/applyLoan/applyFail",true);
							}
						},
						errorCallback:function(res){
							utils.dialog.alert(res.message);
						}
					});
				}else{
					utils.dialog.alert('抱歉，您的验证失败，可以尝试通过以下方式：保持光线充足与均匀、确保人脸出现在方框内、避免戴帽子或眼睛');
					self.faceRecognition();
				}
			},{sceneNum: 'L003'});
		}
	});
});