/*
 * 申请审核页面视图
 * ex-maingjie001
 */
define(function(require,exports,module){
	var ApplyWaitTpl = require("text!../../template/apply/applyWait.html");
	var PTRScroll    = require("component/PTRScroll");
	var loanModel    = require("../../model/loanModel");
	module.exports = ItemView.extend({
		template:_.template(ApplyWaitTpl),

		initialize:function(){
			this.submitFlag = false;
		},

		onShow:function(){
			this._pullDown();
		},

		//下拉刷新页面
		_pullDown:function(){
			var self      = this;
			var wHeight   = App.locStorage.get("webviewHeight") || $(window).outerHeight(true);
			var dom       = $("#scrollContainer").css({"height":wHeight,"position":"relative"});
			this.scroller = new PTRScroll(dom[0],{"hideScrollbar":true});

			this.scroller.options.refreshContent = function(refresh){
				if(self.submitFlag){
					return;
				}
				self.submitFlag=true;
				loanModel.checkApplyLoan({
					callback:function(res){
						self.submitFlag=false;
						var data = res.object;
						App.storage.set("checkApplyLoan",data);
						if(data.applyFlag=="1" ){//1申请通过 0申请中 4生疑 2否决 3未申请
							if(data.isSelf == "1"){//1本人 2未做 0非本人
								App.navigate("loan/loan/index", true);
							}else{
								utils.dialog.confirm("为了您的资金安全，需要您先通过人脸验证。", function (ok) {
									if(ok){
										self.faceRecognite();
									}
								});
							}
						}else if(data.applyFlag=="0" || data.applyFlag =="4"){
							App.reload();
						}else if(data.applyFlag=="2"){
							App.navigate("loan/applyLoan/applyFail", true);
						}
					},
					errorCallback:function(res){
						self.submitFlag=false;
						utils.dialog.toast(res.message);
					}
				});
			};
			this.scroller.disablePullUpToLoadMore();
		},

		//人脸识别
		faceRecognite:function(){
			var self = this;
			faceRecognition(function(err, isSamePerson){
				if(err){
					utils.dialog.confirm('抱歉，您的验证失败，可以尝试通过以下方式：保持光线充足与均匀、确保人脸出现在方框内、避免戴帽子或眼睛', function(ok){
						if(ok){
							self.faceRecognition();
							return;
						}
					});
				}
				//是否是同一个人：true为同一人，false为不为同一人
				if(isSamePerson){
					loanModel.checkApplyLoan({
						callback:function(res){
							var obj = res.object;
							App.storage.set("checkApplyLoan",obj);
							if(obj.applyFlag=="0" || obj.applyFlag =="4"){
								App.navigate('loan/applyLoan/applyWait', true);
							}else if(obj.applyFlag == "1"){
								App.navigate("loan/loan/index",true);
							}else if(obj.applyFlag == "2"){
								App.navigate("loan/applyLoan/applyFail",true);
							}
						},
						errorCallback:function(res){
							utils.dialog.alert(res.message);
						}
					});
				}else{
					utils.dialog.alert('抱歉，您的验证失败，可以尝试通过以下方式：保持光线充足与均匀、确保人脸出现在方框内、避免戴帽子或眼睛');
					self.faceRecognition();
				}
			},{sceneNum: 'L003'});
		}
	});
});
