/**
 * Created by EX-LIUJINMAN001 on 2016-04-11.
 * 补充信息
 */
define(function (require, exports, module) {
	var Form              = require("component/form");
	var addInfoTmp        = require("text!../../template/borrow/addInfo.html");
	var CustomPwdOtpInput = require("component/password/customPwdOtpInput");
	var monIncomeModeView = require("../borrow/monIncomeModeView");
	var loanModel         = require("../../model/loanModel");
	var addInfo = module.exports = Form.extend({
		template : _.template(addInfoTmp),
		events : {
			"tap #familyRelationship span" : "familyRelationship",
			"tap #employmentType span"     : "employmentType",
			"tap .monIncView"              : "monIncomeModeView",
			"tap .btn_orange"              : "submit"
		},
		onShow : function () {
			this.familyRelationshipVal = '';  // 亲属关系
			this.employmentVal = '';  // 雇佣关系
			this.monInc_val = "";  // 月收入区间
		},

		//亲属关系
		familyRelationship: function (event) {
			var $current = this.$(event.currentTarget).find("i");
			if ($current.hasClass("iconA107small")) {
				return;
			}
			$("#familyRelationship .flex1 i").removeClass("iconA107small");
			$current.addClass("iconA107small");
			this.familyRelationshipVal = $current.data("value");
		},

		// 雇佣关系
		employmentType: function (event) {
			var $current = this.$(event.currentTarget).find("i");
			if ($current.hasClass("iconA107small")) {
				return;
			}
			$("#employmentType .flex1 i").removeClass("iconA107small");
			$current.addClass("iconA107small");
			this.employmentVal = $current.data("value");
		},

		//月收入区间
		monIncomeModeView : function () {
			var self = this;
			monIncomeModeView.monIncomeModeView(function (code,res) {
				if (code == true) {
					return;
				}
				$("#monInc").text(code);
				self.monInc_val = res;
			});
		},

		//立即提款
		submit: function () {
			var familyMobile = $("#familyMobile").val();
			var familyName = $("#familyName").val();
			var data = {
				"familyMobile": familyMobile,
				"familyRelationship": this.familyRelationshipVal,
				"employmentType": this.employmentVal,
				"familyName": familyName,
				"monInc_val": this.monInc_val
				}
			if (!this.validateContact(data)) {
				return;
			}
			var self = this;
			var checkApply = App.storage.get("checkApplyLoan");
			var borrowMoneyInfo = App.storage.get("borrowMoneyInfo");
			var data = {
				"applyLoanAmt": borrowMoneyInfo.applyLoanAmt  //贷款申请金额
			};
			loanModel.snedLoanOTPInfo({
				params: data,
				callback: function () {
					//确定按钮回调函数（param：pwd（交易密码），otp（otp密码））
					CustomPwdOtpInput.customPwdOtpInput({
						isSendOtp: false,
						isNeedSendOtpValidate: false,
						cat: config.values.CAT_ORANGE_LOAN_BORROW,//cat
						callback: function (pwd, otp) {
							var rsaPwd = utils.crypto.RSAKey.encrypt(pwd, config.base.rsa_public_key);
							var data = {
								"password": rsaPwd,//交易密码
								"sm2Pwd": utils.sm2.SM2Key.encrypt(pwd, config.base.sm2_public_key),
								"otp": otp,//动态密码
								"familyName": familyName, //亲属联系人姓名	首次提款必输
								"familyRelationship": self.familyRelationshipVal,//亲属联系人关系
								"familyMobile": familyMobile,//亲属联系人手机
								"employmentType": self.employmentVal,//雇佣类型
								"monInc": self.monInc_val,//月收入
								"purposeCode": borrowMoneyInfo.purposeCode  //用途代码
							};
							loanModel.borrowMoney({
								params: data,
								callback: function (res) {
									if (res.object && res.object.retCode && res.object.retCode == "0") {
										App.navigate("loan/borrow/borrowMoneySuccess", true);
									} else {
										App.storage.set("borrowMoneyFail", res);
										App.navigate("loan/borrow/borrowMoneyFail", true);
									}
								},
								errorCallback: function (res) {
									utils.dialog.toast(res.message);
								}
							});
						}
					});
				},
				errorCallback: function () {
					utils.dialog.toast('网络请求失败,请稍后重试!');
				}
			});
		},

		//验证联系人电话输入是否正确
		validateContact : function(options){
			var familyMobile       = options.familyMobile;
			var employmentType     = options.employmentType;
			var familyRelationship = options.familyRelationship;
			var monInc             = options.monInc_val;
			var familyName         = options.familyName;
			if(!employmentType || employmentType == ""){
				utils.dialog.toast("请选择雇佣类型!");
				return false;
			}
			if(monInc == ""){
				utils.dialog.toast("请选择月收入区间!");
				return false;
			}
			if(familyName == ""){
				utils.dialog.toast("请输入亲友姓名!");
				return false;
			}
			if(!familyRelationship && familyRelationship == ""){
				utils.dialog.toast("请选择亲友关系!");
				return false;
			}
			if(familyMobile == ""){
				utils.dialog.toast("请输入亲友电话!");
				return false;
			}
			if(familyMobile.length < 11 || !utils.validate.telephone(familyMobile)){
				utils.dialog.toast("请输入正确的手机号码!");
				return false;
			}
			return true;
		}
	});
});