/**
 * Created by EX-LIUJINMAN001 on 2016-04-11.
 * 提款首页
 */
define(function (require, exports, module) {
	var safeKeyBoardHelper = require("component/customInput.helper");
	var drawingsTml        = require("text!../../template/borrow/borrowMoney.html");
	var CustomPwdOtpInput  = require("component/password/customPwdOtpInput");
	var loanModel          = require("../../model/loanModel");
	var Form               = require("component/form");
	var Index = module.exports = Form.extend({
		template: _.template(drawingsTml),
		events: {
			"tap .btn_orange"                   : "submit",  //立即提款
			"tap .purposeCode"                : "purposeCode", //贷款用途
			"customInputFocusIn #applyLoanAmt"  : "_focusInAmount",
			"customInputFocusOut #applyLoanAmt" : "_focusOutAmount",
			"customInputKeyup #applyLoanAmt"    : "applyLoanAmtKeyup"
		},

		onRender: function () {
			this._initAmountKeyboard();
		},

		onShow: function () {
			//设置金额输入框的字体大小
			$("#editMoney input").addClass("f20");
			this.purposeCode = "302";
		},

		_initAmountKeyboard: function () {
			this.$("#applyLoanAmt").customInput({
				type: "decimal",
				placeholder: "起提金额500元",
				className: "safeKeyBoard",
				maxLength: "7"
			});
		},

		_focusInAmount: function () {
			safeKeyBoardHelper.focusIn({ id: "applyLoanAmt" });
		},

		_focusOutAmount: function () {
			safeKeyBoardHelper.focusOut({ id: "applyLoanAmt" });
		},

		applyLoanAmtKeyup: function () {
			this.setRepayMoney();
		},

		//计算每月要还的钱
		setRepayMoney: function () {
			var checkApply = App.storage.get("checkApplyLoan");
			var applyLoanAmt = this.$("#applyLoanAmt input").val().replace(/,/g, "");
			$("#lixi").text("");
			var lixi = "每月固定还款<span class='c_f60' id='repayMoney'></span>元";
			$("#lixi").append(lixi);
			var drawRate = checkApply.drawRate;
			var mon = drawRate / 100 * 30;
			var repayMoney = (applyLoanAmt * mon * Math.pow((1 + mon), 12)) / (Math.pow((1 + mon), 12) - 1);
			$("#repayMoney").text(repayMoney.toFixed(2));
		},

		checkNum: function () {
			var checkApply = App.storage.get("checkApplyLoan");
			var applyLoanAmt = parseInt(this.$("#applyLoanAmt input").val().replace(/,/g, ""));
			var availAmt = parseInt(checkApply.availAmt.replace(/,/g, ""));
			if (applyLoanAmt == "" || applyLoanAmt == "起提金额500元") {
				utils.dialog.toast("请输入金额");
				return false;
			}
			if (applyLoanAmt > availAmt) {
				utils.dialog.toast(" 您输入的提款金额大于当前可贷款额度，请重新输入");
				return false;
			} else if (applyLoanAmt < 500) {
				utils.dialog.toast("您输入的提款金额小于500元起点金额");
				return false;
			} else if (applyLoanAmt % 100 != 0) {
				utils.dialog.toast("您输入的提款金额须为100元的整数倍，请重新输入");
				return false;
			}
			return true;
		},

		purposeCode: function (e) {
			var purposeCode = $(e.currentTarget).data("value");
			if(purposeCode != this.purposeCode){
				$(".purposeCode").removeClass("on");
				$(e.currentTarget).addClass("on");
				this.purposeCode = purposeCode;
			}
		},

		addInfo: function () {
			App.navigate("loan/borrow/addInfo", true);
		},

		submit: function () {
			var self = this;
			var checkApply = App.storage.get("checkApplyLoan");
			if (this.checkNum() == false) {
				return;
			}
			var applyLoanAmt = this.$("#applyLoanAmt input").val();
			var applyLoanAmt_val = applyLoanAmt.replace(/,/g, "");
			App.storage.set("borrowMoneyInfo", {"purposeCode": self.purposeCode, "applyLoanAmt": applyLoanAmt_val});
			if (checkApply.isFirstDraw == "0") {
				App.navigate("loan/borrow/addInfo", true);
			}
			else {
				var data = {
					"applyLoanAmt": applyLoanAmt_val  //贷款申请金额
				};
				loanModel.snedLoanOTPInfo({
					params: data,
					callback: function () {
						// 确定按钮回调函数（param：pwd（交易密码），otp（otp密码））
						CustomPwdOtpInput.customPwdOtpInput({
							isSendOtp: false,
							isNeedSendOtpValidate: false,
							cat: config.values.CAT_ORANGE_LOAN_BORROW,//cat
							callback: function (pwd, otp) {
								var rsaPwd = utils.crypto.RSAKey.encrypt(pwd, config.base.rsa_public_key);
								var data = {
									"password": rsaPwd,//交易密码
									"sm2Pwd": utils.sm2.SM2Key.encrypt(pwd, config.base.sm2_public_key),
									"otp": otp,//动态密码
									"purposeCode": purposeCode //用途代码
								};
								loanModel.borrowMoney({
									params: data,
									callback: function (res) {
										if (res.object && res.object.retCode && res.object.retCode == "0") {
											App.navigate("loan/borrow/borrowMoneySuccess", true);
										} else {
											App.storage.set("borrowMoneyFail", res);
											App.navigate("loan/borrow/borrowMoneyFail", true);
										}
									},
									errorCallback: function (res) {
										utils.dialog.toast(res.message);
									}
								});
							}
						});
					},
					errorCallback: function () {
						utils.dialog.toast('网络请求失败,请稍后重试!');
					}
				});

			}
		}
	});
});