/**
 * ex-chenfuhua001
 * 橙易贷提款列表
 *
 */
define(function(require, exports, module){
	var indexTpl          = require("text!../template/index.html");
	var RepaymentModel    = require("../model/repaymentModel");
	var WithdrawalListTpl = require("text!../template/repayment/withdrawalList.html");
	var PTRScroll         = require("component/PTRScroll");
	var Index = module.exports = ItemView.extend({
		template: _.template(indexTpl),
		events: {
			"tap .loanacctno" : "repaymentList",
			"tap #withdrawal" : "borrowMoney"
		},

		initialize: function(options){
			this.param = {pageIndex:1,pageSize:10};
		},

		onShow: function(){
			this.list = this.model.get("list") || 0;
				this._pullDown(this.model.attributes);
		},

		repaymentList:function(e){
			var self       = this;
			var loan_list  = {};
			var loanAcctNo = $(e.currentTarget).data("no");
			for(var i in self.list){
				if(self.list[i].loanAcctNo == loanAcctNo){
					loan_list = self.list[i];
					break;
				}
			}
			App.storage.set('loan_list',loan_list);
			App.navigate("loan/loan/repaymentList", true);
		},

		borrowMoney : function () {
			App.navigate("loan/borrow/borrowMoney",true);
		},

		_pullDown : function(data){
			var self=this;
			if(data.totalNum == null || data.totalNum == ""){
				data.totalNum=0;
			}
			var wHeight    = $(window).outerHeight(true);
			var topHeight  = self.$(".Earnings").outerHeight(true) + self.$(".used_amount").outerHeight(true);
			var listHeight = wHeight - topHeight;
			var dom        = $("#scrollContainer").css({"height":listHeight,"position":"relative"});
			self.scroller  = new PTRScroll(dom[0],{"hideScrollbar":true});
			//禁止下拉刷新
			this.scroller.disablePullDownToRefresh();
			var pageCount = Math.ceil(parseInt(data.total)/self.param.pageSize);
			this.scroller.options.loadMoreContent = function(refresh){
				self.param.pageIndex+=1;
				if(self.param.pageIndex > pageCount){
					refresh();
					self.scroller.disablePullUpToLoadMore();
					return false;
				}
				RepaymentModel.repaymentList({
					data : self.param,
					callback: function(res){
						var withdrawalList = res.object.list;
						self.list          = self.list.concat(withdrawalList);
						var tr             = _.template(WithdrawalListTpl)(res.object);
						$(".loanacctno:last").after(tr);
						refresh();
					},
					errorCallback: function(res){
						utils.dialog.alert(res.message);
						refresh();
					}
				});
			};
			//如果页数小于等于1，禁止下拉刷新
			if(pageCount <= 1){
				self.scroller.disablePullUpToLoadMore();
			}
		}
	});
});