/**
 * ex-chenfuhua001
 * 橙易贷提前还款
 *
 */
define(function(require, exports, module){
	var Form               = require("component/form");
	var safeKeyBoardHelper = require("component/customInput.helper");
	var CustomPwdInput     = require("component/password/customPwdInput");
	var RepaymentModel     = require("../../model/repaymentModel");
	var prepaymentTpl      = require("text!../../template/repayment/prepayment.html");
	var Index = module.exports = Form.extend({
		template: _.template(prepaymentTpl),
		events: {
			"tap #nowRepayment"                    : "nowRepayment",
			"customInputFocusIn #repaymentAmount"  :"_focusInAmount",
			"customInputFocusOut #repaymentAmount" :"_focusOutAmount"
		},

		onRender : function() {
			this._initAmountKeyboard();
		},

		initialize: function(options){
			this.params = {};
			//01：提前还款 02：一般还款
			this.params.replymenttype = "01";
			this.params.loanAcctNo = App.storage.get('loan_list').loanAcctNo;
		},

		onShow: function(){
			var loan_list     = App.storage.get('loan_list');
			this.arrearsAmount = Number(loan_list.remainCorpus);
			$("#repaymentAmount input").addClass("f20");
			$("#repaymentAmount").customInput('value',this.arrearsAmount.toFixed(2));
		},

		_initAmountKeyboard:function(){
			this.$("#repaymentAmount").customInput({
				type: "decimal",
				className:"safeKeyBoard",
				maxLength:"10"
			});
		},

		_focusInAmount: function(){
			safeKeyBoardHelper.focusIn({ id:"repaymentAmount" });
		},

		_focusOutAmount: function(){
			safeKeyBoardHelper.focusOut({ id:"repaymentAmount" });
		},

		nowRepayment:function(){
			var self            = this;
			var repaymentAmount = $("#repaymentAmount").customInput('value');
			if(!repaymentAmount){
				utils.dialog.toast("请输入还款金额");
			}else if(repaymentAmount <= 0){
				utils.dialog.toast("您输入的还款金额小于最低还款金额，请重新输入");
			}else if(repaymentAmount > this.arrearsAmount){
				utils.dialog.toast("您输入的金额大于本期应还本金，请重新输入");
			}else{
				CustomPwdInput.customPwdInput(function (password) {
					submitFlag           = true;
					self.params.amt      = repaymentAmount;
					self.params.password = utils.crypto.RSAKey.encrypt(password, config.base.rsa_public_key);
					self.params.sm2Pwd   = utils.sm2.SM2Key.encrypt(password, config.base.sm2_public_key);
					RepaymentModel.repaymentRequest({
						data : self.params,
						callback: function(res){
							if(res.object.recode == "001"){
								App.navigate("loan/loan/repaymentState", true);
							}else{
								utils.dialog.alert(res.object.reMessage);
							}
						},
						errorCallback: function(res){
							utils.dialog.alert(res.message);
						}
					});
				});
			}
		}
	});
});