/**
 * EX-yangjingpeng001
 *
 * 功能描述：登录控制器
 */

define(function (require, exports, module) {
	var LoginView = require("../view/login");
	var MobileLoginView = require("../view/mobileLogin");
	var LoginOtpView = require("../view/loginOtp");
	var LoginTermsView = require("../view/loginTerms");
	var LoginModel = require("../model/login");
	var anydoorServices = require("mod/common/anydoor/anydoor");
	var Login = module.exports = Controller.extend({
		actions: {
			toaIndex     : "toaIndex",//账号登录
			mobileIndex  : "mobileIndex",//手机号登录
			toLoginTerms : "toLoginTerms",//登录验证otp
			gestureLogin : "gestureLogin"//手势密码登录
		},

		authorize: function () {
			return true;
		},

		/*
		 * 渲染手机号登录界面
		 *
		 * 入参：query（native调用登录所传标示）
		 *
		 * 返回：无
		 */
		mobileIndex: function (query) {
			App.header.reset({
				title: "平安橙子",
				rightButtonContent: "注册",
				rightButtonHandler: function () {
					App.navigate("openAccount/main/openMain", true);
				},

				leftButtonContent: "@back",
				leftButtonHandler: function () {
					App.navigate("login/login/toaIndex", true);
				}
			});
			App.footer.reset({
				"visible": false
			});
			utils.native.pawsFinish();
			App.container.show(new MobileLoginView());
			App.storage.set("login/returnURL", query && query.returnURL);

			App.container.currentView.on("form:submit", _.bind(function (options) {
				LoginModel.mobileLogin(options).done(_.bind(function (arg) {
					if (arg.object.errorCode == "100") {
						utils.dialog.confirm("你还不是平安橙子用户，简单一步即可开户，快来体验吧！", {
							"okButtonText": "立即开户",
							"cancelButtonText": "取消"
						}, function (ok) {
							if (ok) {
								App.navigate("openAccount/main/openMain", true);
							}
						});
					} else if (arg.object.errorCode == "101") {
						utils.dialog.alert("请使用一账通登录");
						App.navigate("login/login/toaIndex", true);
					} else {
						utils.native.talkingDataTrackEvent("2.0登录-手机号码登录");
						//判断是否是低门槛用户
						App.storage.get("UserInfo").set({
							"isTelephoneLogin": true
						});
						App.storage.get("UserInfo").set({
							"telephoneNum": arg.object.mobile
						});
						this.loginSuccess(arg.object.otpSwitch, options.userName);
						//trackUserLoggedInStatus({ loginStatus: "success", userName: loginData.userName });
					}
				}, this)).fail(function (error) {
					App.container.currentView.submitFlag = false;
					utils.dialog.toast(error.message);
				});
			}, this));
		},

		/*
		 * 渲染账号登录界面
		 *
		 * 入参：query（native调用登录所传标示）
		 *
		 * 返回：无
		 */
		toaIndex: function (query) {
			if (query && (query["open-anydoor-plugin-after-login"] || query["clean-anydoor-login-status"])) {
				App.commands.execute("logout", { isReqTimeout: true, needCleanAnydoor: query["clean-anydoor-login-status"] });
			}
			App.header.reset({
				title: "平安橙子",
				rightButtonContent: "注册",
				rightButtonHandler: function () {
					App.navigate("openAccount/main/openMain", true);
				},

				leftButtonContent: "@back",
				leftButtonHandler: function () {
					App.navigate("index/index/index", true);
				}
			});
			App.footer.reset({
				"visible": false
			});
			utils.native.pawsFinish();
			App.container.show(new LoginView());
			App.storage.set("login/returnURL", query && query.returnURL);
			App.storage.set("login/open-anydoor-plugin-after-login", !!(query && query["open-anydoor-plugin-after-login"]));
			App.container.currentView.on("form:submit", _.bind(function (options) {
				LoginModel.toaLogin(options).done(_.bind(function (arg) {
					if (arg.object.errorCode == "100") {
						utils.dialog.confirm("你还不是平安橙子用户，简单一步即可开户，快来体验吧！", {
							"okButtonText": "立即开户",
							"cancelButtonText": "取消"
						}, function (ok) {
							if (ok) {
								App.navigate("openAccount/main/openMain", true);
							}
						});
					} else if (arg.object.errorCode == "101") {
						utils.dialog.alert("请使用手机号登录!!!");
					} else if (arg.object.errorCode == "102") {
						utils.dialog.alert("尊敬的客户您好，您输入的账户未绑定平安橙子，详询95511转4转8");
						App.navigate("login/login/toaIndex", true);
					} else {
						utils.native.talkingDataTrackEvent("2.0登录-一账通登录");

						App.container.currentView.writeInUserName();
						App.storage.get("UserInfo").set({
							"telephoneNum": arg.object.mobile
						});
						this.loginSuccess(arg.object.otpSwitch, options.userName);
						//trackUserLoggedInStatus({ loginStatus: "success", userName: loginData.userName });
					}
				}, this)).fail(function (error) {
					App.container.currentView.submitFlag = false;
					App.container.currentView._showCode();
					utils.dialog.toast(error.message);
				});
			}, this));
		},

		/*
		 * 渲染财富E用户协议界面
		 *
		 * 入参：无
		 *
		 * 返回：无
		 */
		toLoginTerms: function () {
			App.header.reset({
				title: "登录"
			});
			App.container.show(new LoginTermsView());
			App.footer.reset({
				visible: false,
				selectedIndex: 0
			});
		},

		/*
		 * 登录成功之后适配器
		 *
		 * 入参：otpSwitch（1：验证otp，其它不需要。userName：用户名）
		 *
		 * 返回：无
		 */
		loginSuccess: function (otpSwitch, userName) {
			App.storage.get("security/otpSwitch").set({
				"otpSwitch": otpSwitch
			});
			if (otpSwitch == "1") {
				this.toLoginOtpPage();
			} else {
				this.indexRequest();
			}
		},

		/*
		 * 渲染验证otp界面
		 *
		 * 入参：无
		 *
		 * 返回：无
		 */
		toLoginOtpPage: function () {
			utils.native.talkingDataTrackEvent("2.0登录-手势密码-登录安全验证");
			App.header.reset({
				title: "平安橙子",
				leftButtonContent: "@back",
				leftButtonHandler: function () {
					App.navigate("index/index/index", true);
				}
			});
			App.container.show(new LoginOtpView({
				controller: this
			}));
		},

		/*
		 * 手势登录
		 *
		 * 入参：无
		 *
		 * 返回：无
		 */
		gestureLogin: function () {
			utils.native.talkingDataTrackEvent("2.0登录-手势密码-手势登录");
			this.indexRequest();
		},

		/*
		 * 登录成功之后用户数据接口请求以及跳转界面
		 *
		 * 入参：无
		 *
		 * 返回：无
		 */
		indexRequest: function () {
			var promise = $.when(
				LoginModel.indexData(),
				LoginModel.getSecurityInfo()
			);
			promise.done(_.bind(function (arg1, arg2) {
				var arg1 = arg1[0], arg2 = arg2[0], accCfeList = arg1.object.accCfeList[0], userInfo = {}, securityLevel = 1;
				var mobile = App.storage.get("UserInfo").get("telephoneNum");
				userInfo.status = accCfeList.accStatus == "0" ? "active" : "unknown";
				userInfo.accNumber = accCfeList.accNum;
				// userInfo.balance = accCfeList.accBalance || "895.65";
				userInfo.cityName = accCfeList.cityName;
				userInfo.openAccBank = accCfeList.openAccBank;
				userInfo.telephoneNum = mobile || arg1.object.telephoneNum;
				userInfo.email = arg1.object.email;
				userInfo.customerMsg = arg1.object.customerMsg;
				userInfo.trueName = arg1.object.trueName;
				userInfo.userName = arg1.object.userName;
				userInfo.accBindList = arg1.object.accBindList || [];
				// userInfo.register = arg1.object.register;
				// userInfo.contact = arg1.object.contact;
				// userInfo.specific = arg1.object.specific;
				userInfo.lastLogined = arg1.object.lastLogined;
				userInfo.loginType = arg1.object.loginType;

				userInfo.whiteSwitch = arg1.object.whiteSwitch;
				//2015-11-07 该账户是否是E企盈（小票）白名单标志
				userInfo.billSwitch = arg2.object.billSwitch;
				//安全层级
				userInfo.activeState = arg2.object.activeState;
				userInfo.cardState = arg2.object.cardState;
				userInfo.bindState = arg2.object.bindState;
				userInfo.mailState = arg2.object.mailState;
				userInfo.partyNo = arg2.object.partyNo;
				userInfo.ecifNo = arg1.object.ecifNo;
				userInfo.bindCardFlag = arg2.object.bindCardFlag;//激活绑定借记卡开关


				/**
				 * ex-huangzt(2016-04-05)
				 * 1-个人网银高级用户，2-身份证，3-借记卡，4-信用卡，5-CFE迁移过来的数据， 在CFE时验证方式为同名户验证。
				 * 6-历史数据修改， 迁移时存在一部分用户，他们的卡在卡管， FCR都已经激活，但在CFE为未激活状态。针对这类诡异数据，
				 * 	  无法给出相对应的激活方式，所以修改这些历史数据时激活方式置为6
				 * 7-汽融，8-人脸识别，9-柜面核身
				*/
				userInfo.verifyMode = arg1.object.verifyMode; //账户激活方式

				if (arg2.object.activeState == "1") {
					//是否设置一账通，是否设置交易密码 by 7iang(wangqiang873)
					securityLevel += 1;
				}
				if (arg2.object.cardState == "1") {
					securityLevel += 1;
				}
				if (arg2.object.bindState == "1") {
					securityLevel += 1;
				}
				if (arg2.object.mailState == "1") {
					securityLevel += 1;
				}
				userInfo.securityLevel = securityLevel;

				var user = App.storage.get("UserInfo");
				user.set(userInfo);

				var lossStatus = arg1.object.lossStatus;
				App.storage.set("cradLossStatus", lossStatus == "1" ? true : false);

				if (App.storage.get("register/inputBindCard")) App.storage.remove("register/inputBindCard");//清掉激活入口缓存 ex_huangzt

				//ex_huangzit 未绑卡且新绑卡标识开启情况下不弹手势
				//1.开关开启没有设置安全信息、没有绑卡，需要提示绑卡提示，没有手势，如果已经激活且绑卡，则这弹手势
				//2.开关关闭，原来流程
				var gesture = 0;
				if (arg2.object.bindCardFlag == '0') {
					gesture = 1;
				} else {
					if (arg2.object.cardState == 1 && arg2.object.bindState == 1 && arg2.object.activeState == 1) {
						gesture = 1;
					}
				}

				LoginModel.getHeadPhotoUrl().always(function (res) {
					//手势密码保存用户名
					utils.native.saveGestureLoginData([arg1.object.userName, arg1.object.trueName, encodeURIComponent(res.object.headImagePath)]);
					//用户登录后引导用户设置手势密码弹框
					if (arg2.object.activeState == "1" && App.storage.get("security/otpSwitch").get("otpSwitch") != "1" && lossStatus != "1") {
						if (gesture == 1) {
							utils.native.showGestureAlert();
						}
					}
				});


				// 强制关闭安全键盘，避免打开任意门豆子时，安全键盘还是打开状态
				// $("input:focus").blur();
				utils.native.isLogin(true);

				//创建sso登录态
				anydoorServices.requestLoginTicket();
				//一账通登录
				anydoorServices.bankToaLogin();
				App.storage.set("isUserLoggedIn", true);
				utils.native.closeGestureView();
				if (arg1.object.isPasswordReset == "5") {//一账通财富E用户升级
					App.navigate("login/login/toLoginTerms", true);
					return;
				}
				var returnURL = App.storage.remove("login/returnURL");
				if (!returnURL)
					returnURL = "index/indexLogined/index";
				App.navigate(returnURL, true);

			}, this));

			promise.fail(function (error) {
				utils.dialog.alert(error.message);
			});
		}
	});
});
