define(function(require, exports, module){
    var LoginModel = module.exports = Model.extend();

    //登录最新接口（一账通登录）
    LoginModel.toaLogin = function(options){
        var options = options || {};
        return App.request("toaLogin", {data : options});
    };

    //登录最新接口（手机号登录）
    LoginModel.mobileLogin = function(options){
        var options = options || {};
        return App.request("mobileLogin", {data : options});
    };

    LoginModel.showCheckCode = function(options){
        var options = options || {};
        return App.request("showCheckCode", {data : options,cancelWhenRouting:false});
    };

    LoginModel.vCode = function(options){
        var options = options || {};
        return App.request("vCode", {type:"GET",data : options});
    };

    LoginModel.indexData = function(options){
        var options = options || {};
        this.getSysTime();
        this.getTime();
        return App.request("index", {data : options});
    };

    LoginModel.getSysTime = function(callback){
        App.request("timestamp",{type:"GET"}).complete(function(error,arg){
            App.storage.set("Login_SysTime", arg.object);
        });
    };

    LoginModel.getTime = function(callback){
        if(App.storage.get("timeDifference")){
            callback && callback(); return;
        }
        App.request("getTime",{type:"GET"}).complete(function(error,arg){
            if(error){
                callback && callback(error);
                return;
            }
            var time = parseInt(arg.object) - new Date().valueOf();
            App.storage.set("timeDifference",time);//服务器时间与本地时间差
            callback && callback();
        });
    };

    LoginModel.agreementChecking = function(options){
        var options = options || {};
        return App.request("agreementChecking", {data:options});
    };

    LoginModel.getSecurityInfo = function(){
        var options = options || {};
        return App.request("settingSecurity", {data : options});
    };

    LoginModel.getHeadPhotoUrl = function(){
        return App.request("getImagePath",{
            silent:true,
            cancelWhenRouting:false,
            success:function(response){
                App.storage.get("UserInfo").set("headPhotoUrl",response.object.headImagePath);
            }
        });
    };

    LoginModel.saveOtpSwitch = function(options){
        var options = options || {};
        return App.request("saveOtpSwitch", {silent:true, data:options});
    };
});