/**
 * EX-yangjingpeng001
 *
 * 功能描述：登录视图
 */

define(function(require, exports, module) {
	var safeKeyBoardHelper = require("component/customInput.helper");
	var Form = require("component/form");
	var LoginModel = require("../model/login");
	var LoginTpl = require("text!../template/login.html");
	var LoginView = module.exports = Form.extend({
		template : _.template(LoginTpl),

		events : {
			"tap #submitBtn" : "submit",
			"tap #login-code-span" : "getCaptcha",
			"tap .remember_uName_radio" : "rememberUserName",
			"tap .to-mobile-login-page" : "toMobileLoginPage",
			"tap #find_yzt_uerName" : "findYztUserName",
			"tap #forget_yzt_password" : "forgetYztPassword",
			"customInputFocusIn #login_password" : "loginPasswordIn",
			"customInputFocusOut #login_password" : "loginPasswordOut",
			"focus #userName" : "userNameIn",
			"blur #userName" : "userNameOut",
			"tap #agreement" : 'showAgreement',
			"tap  #iconA46  ": 'toggleCheckbox'


		},

		uName : "", //用户名
		onRender : function() {
			this.$("#login_password").customInput({
				type : "password-ascii",
				placeholder : "一账通登录密码",
				maxLength : 16
			});

			this.renderUserInput();
		},

		onShow : function() {
			LoginModel.showCheckCode().done(_.bind(function(arg) {
				if (arg.object.codecheck != 0) {
					this._showCode();
				}
			}, this)).fail(_.bind(function() {
				this._showCode();
			}, this));

			this.setMobileLoginTop();
		},

		/*
		 * 设置手机登录按钮top值
		 *
		 * 入参：value(top值)
		 *
		 * 返回：无
		 */
		setMobileLoginTop : function(value) {
			value = value || 0;
			var mobileLoginContainerTop = parseInt(App.locStorage.get('webviewHeight')) - this.$(".login-container").outerHeight() - $("header").outerHeight() - this.$(".otherwayon").outerHeight() + 30 + value;

			mobileLoginContainerTop = Math.abs(mobileLoginContainerTop);

			this.$(".otherwayon").css({
				"margin-top" : mobileLoginContainerTop + "px"
			});
		},

		/*
		 * 登录密码输入框获取焦点事件
		 *
		 * 入参：无
		 *
		 * 返回：无
		 */
		loginPasswordIn : function() {
			safeKeyBoardHelper.focusIn({
				id : "login_password"
			});
			this.$("#login_password").children().eq(0).removeClass("iconA41").addClass("iconA42");
		},

		/*
		 * 登录密码输入框失去焦点事件
		 *
		 * 入参：无
		 *
		 * 返回：无
		 */
		loginPasswordOut : function() {
			safeKeyBoardHelper.focusOut({
				id : "login_password"
			});
			this.$("#login_password").children().eq(0).removeClass("iconA42").addClass("iconA41");
		},

		/*
		 * 用户名输入框获取焦点事件
		 *
		 * 入参：无
		 *
		 * 返回：无
		 */
		userNameIn : function(e) {
			this.$(e.currentTarget).attr("placeholder", "");
			this.$(e.currentTarget).prev().removeClass("iconA39").addClass("iconA40");
		},

		/*
		 * 用户名输入框失去焦点事件
		 *
		 * 入参：无
		 *
		 * 返回：无
		 */
		userNameOut : function(e) {
			this.$(e.currentTarget).attr("placeholder", "一账通用户名、身份证号");
			this.$(e.currentTarget).prev().removeClass("iconA40").addClass("iconA39");
		},

		/*
		 * 初始化用户名输入框值
		 *
		 * 入参：无
		 *
		 * 返回：无
		 */
		renderUserInput : function() {
			if (ENABLE_PHONEGAP) {
				utils.native.getUserName(_.bind(function(uName) {
					this.uName = uName || "";
					this.tempName = uName ? uName.substr(0, 1) + "*****" + uName.substr(uName.length - 1, 1) : "";
					this.$("#userName").val(this.tempName);
				}, this));
			} else {
				var uName = localStorage.getItem("uName");
				this.uName = uName || "";
				this.tempName = uName ? uName.substr(0, 1) + "*****" + uName.substr(uName.length - 1, 1) : "";
				this.$("#userName").val(this.tempName);
			}
		},

		/*
		 * 用户名写入缓存
		 *
		 * 入参：无
		 *
		 * 返回：无
		 */
		writeInUserName : function() {
			if (this.$(".remember_uName_radio").find(".iconA46").hasClass("on")) {
				if (IS_RUN_ON_DEVICE) {
					if (this.tempName != this.$("#userName").val()) {
						utils.native.saveUserName(this.$("#userName").val().replace(/\s/g, ""));
					}
				} else {
					if (this.tempName != this.$("#userName").val()) {
						localStorage.setItem("uName", this.$("#userName").val().replace(/\s/g, ""));
					}
				}
			} else {
				localStorage.removeItem("uName");
				utils.native.saveUserName("");
			}

		},

		/*
		 * 记住用户名复选框样式更改
		 *
		 * 入参：event（事件对象）
		 *
		 * 返回：无
		 */
		rememberUserName : function(event) {
			this.$(event.currentTarget).find(".iconA46").toggleClass("on");
		},

		_showCode : function() {
			var img = $("<img style='width:105px;height:40px;'/>");
			img[0].onload = _.bind(function() {
				img.show();
				this.$("#login-code-span").html(img);
				this.$(".login-code-container").show();
				this.setMobileLoginTop();
			}, this);
			this.getCaptcha(img);
		},

		/*
		 * 加载验证码
		 *
		 * 入参：img（img对象）
		 *
		 * 返回：无
		 */
		getCaptcha : function(img) {
			var image = img.attr ? img : this.$("#login-code-span").children();
			image.hide();
			image.prop("src", "");
			image.parent().html("<i class='loadcon' style='left:auto;right:20px;'></i>");
			this.$("#login_vcode").val("");
			if (ENABLE_PHONEGAP) {
				utils.native.HTTPRequest({
					type : "GET",
					isDownloadImg : true,
					url : config.urls.get("vCode")
				}).done(function(response) {
					image.prop("src", response);
				});
			} else {
				image.prop("src", config.urls.get("vCode") + "?" + Date.parse(new Date()));
			}
		},

		/*
		 * 提交
		 *
		 * 入参：无
		 *
		 * 返回：无
		 */
		submit: function (e) {
			var userName = this.$("#userName").val().replace(/\s/g, "");
			var password = this.$("#login_password").customInput("value");
			var vCode = this.$("#login_vcode").val().replace(/\s/g, "");

			if (userName == this.tempName) {
				userName = this.uName;
			}

			if (!this._validate({
				userName: userName,
				password: password,
				vCode: vCode
			}))
				return false;

			LoginModel.getTime(_.bind(function (error) {
				if (error) return utils.dialog.toast("系统错误，请重新登录");
				var options = {
					userName: userName,
					password: utils.crypto.RSAKey.encrypt(password, config.base.rsa_public_key),
					sm2Pwd: utils.sm2.SM2Key.encrypt(password, config.base.sm2_public_key),
					validCode: this.$(".login-code-container").css("display") != "none" ? vCode : "1234"
				};

				if (IS_RUN_ON_IDEVICE) {
					utils.native.getTokenID(_.bind(function (tokenID) {
						options.deviceId = utils.native.getIDeviceID();
						options.tokenId = tokenID || "TOKENID_10987654321iphone";
						this.trigger("form:submit", options);
					}, this));
				} else if (IS_RUN_ON_ANDROID) {
					utils.native.getDeviceID(_.bind(function (deviceID) {
						options.deviceId = deviceID || "AUUID_12345678910aa";
						this.trigger("form:submit", options);
					}, this));
				} else {
					this.trigger("form:submit", options);
				}
			},this));


		},

		/*
		 * 跳转至手机号登录界面
		 *
		 * 入参：无
		 *
		 * 返回：无
		 */
		toMobileLoginPage : function() {
			App.navigate("login/login/mobileIndex", true);
		},

		/*
		 * 跳转至找回用户名界面
		 *
		 * 入参：无
		 *
		 * 返回：无
		 */
		findYztUserName : function() {
			utils.window.open({
				title : "忘记用户名",
				url : "https://www.pingan.com.cn/pinganone/pa/retrieveVerify.do?isPS="
			});
		},

		/*
		 * 跳转至找回密码界面
		 *
		 * 入参：无
		 *
		 * 返回：无
		 */
		forgetYztPassword : function() {
			utils.window.open({
				title : "忘记密码",
				url : "https://member.pingan.com.cn/pinganone/pa/paResetIndexMobileH5.screen"
			});
		},

		/*
		 * 页面数据校验
		 *
		 * 入参：option（校验所需的数据）
		 *
		 * 返回：无
		 */
		_validate : function(options) {
			if (!options.userName) {
				utils.dialog.toast("请输入用户名");
				return false
			}

			if (!options.password) {
				utils.dialog.toast("请输入密码");
				return false
			}

			if (this.$(".login-code-container").css("display") != "none" && !options.vCode) {
				utils.dialog.toast("请输入验证码");
				return false;
			}
			if(!this.$("#iconA46").hasClass('on')){
				utils.dialog.toast("请阅读并同意协议！");
				return false;
			}
			return true;
		},
		showAgreement : function(e) {
			e.stopPropagation();
			e.preventDefault();
			utils.window.open({
				title : "《平安直通银行服务协议》",
				url : config.urls.get("terms_of_service")
			});
		},
		toggleCheckbox : function() {
			this.$("#iconA46").toggleClass("on");
		}
	});

})
