define(function(require, exports, module){
    var LoginOtpTpl = require("text!../template/loginOtp.html");
    var OtpView=require("component/otp/OtpView");
    var LoginModel = require("../model/login");
    var LoginOtpView = module.exports = ItemView.extend({
        template : _.template(LoginOtpTpl),
        
        events : {
            "tap #submitBtn" : "submit",
            "tap #loginSecuritySwitch": "loginSecuritySwitch"
        },
        
        initialize : function(options){
            this.controller = options.controller;
        },
        
        onRender : function(){
            var options = {
                   isOtpSended : false,
                    isNeedSendOtpValidate : true,
                    isQryOtpPhoneNo : true,
                    otpEnable : null,
                    isMobilePhoneByUser : false,
                    callbackError : _.bind(this.callbackError, this),
                    callbackSubmit : _.bind(this.callbackSubmit, this),
                    cat:config.values.login
            };
            this.otpView = new OtpView();
            this.otpView.initOtp(options);
            this.$("#login_otp_container").empty().append($(this.otpView.$el[0]));
        	
        },
        
        submit:function(e){
            if("1"==this.submitFlag)return;
            if(!this.otpView.getValue()){
                this.otpView.setCustomValidity("请输入动态密码！");
                return false;
            }
            $("#loginOtp_errorMsg").hide();
            this.otpView.submit();
            this.submitFlag="1";
        },
        callbackSubmit:function(){
           this.btnSecurityConfirm();
           this.controller.indexRequest();
           // trackUserLoggedInStatus({ loginStatus: "success", otpStatus: "success", userName: this.options.userName || "" });
        },
        callbackError:function(response){
            this.submitFlag="0";
            utils.dialog.toast(response.message);
            // trackUserLoggedInStatus({ loginStatus: "success", otpStatus: "fail", userName: this.options.userName || "" });
        },
        
        loginSecuritySwitch: function(e){
            var curr = e.currentTarget;
            if($(curr).hasClass("on")){
                $(curr).removeClass("on");
            }else{
                $(curr).addClass("on");
            }
        },
        
        btnSecurityConfirm: function(){
            var currState = "";
            if($('#loginSecuritySwitch').hasClass("on")){
                currState = "0";
            }else{
                currState = "1";
            }
            App.storage.get("security/otpSwitch").set({"otpSwitch":currState});
            //判断当前开关状态与已以往状态是否改变判断是否触发事件
            LoginModel.saveOtpSwitch({otpSwitch:currState}).done(function(res){
                // App.storage.get("security/otpSwitch").set({"otpSwitch":currState});
            })
        }
    }); 
});
