define(function(require, exports, module){
    var Form = require("component/form");
    var LoginTermsTpl = require("text!../template/loginTerms.html");
    var LoginModel = require("../model/login");
    var LoginTermsView = module.exports = Form.extend({
        template : _.template(LoginTermsTpl),
        
        events : {
            "tap #reg_checkBox"     : "checkBox",    //勾选协议
            "tap #reg_checkBoxText" : "checkBox",  //勾选协议
            "tap #to_index_page_btn" : "toIndexPage",
            "tap #reg_fAgree" : "showTerms",
            "tap #link-about-secret" : "openAboutSecretWindow",
            "tap #link-about-caifu"  : "openAboutCaifuWindow"
        },
        
        /**
         *勾选协议 
         */
        checkBox : function() {
            this.$("#reg_checkBox").toggleClass("on");
        },
        
        showTerms : function(){
            utils.window.open({
                title:  "《平安直通银行服务协议》",
                url: config.urls.get("terms_of_service")
            });
        },
        
        openAboutSecretWindow: function(){
            var url = location.href;
            url = url.replace(/\?.*/, ""); // strip search and hash
            url = url.replace(/[^/]*$/, ""); // strip filename (index.html)
            url = url + "mod/login/template/ke_hu_xin_xi_bao_mi_gao_zhi.html";            
            utils.window.open({
                title:  "《客户信息保密告知》",
                url: url
            });
        },
        
        openAboutCaifuWindow : function(){
            utils.window.open({
                title:  "《财富e账户升级为平安直通账户业务服务责任条款》",
                url: config.urls.get("terms_of_service_caifu")
            });  
        },
        
        toIndexPage : function(){
            if(!this.$("#reg_checkBox").hasClass("on")){
                utils.dialog.toast("请阅读并同意协议！");
                return;
            }
            
           LoginModel.agreementChecking().done(_.bind(function(){
               App.navigate("index/indexLogined/index", true);
           },this)).fail(function(error){
               utils.dialog.alert(error.message);
           });
        }
    }); 
});