define(function(require, exports, module) {
	var safeKeyBoardHelper = require("component/customInput.helper");
	var Form = require("component/form");
	var LoginModel = require("../model/login");
	var LoginTpl = require("text!../template/mobileLogin.html");
	var OtpView = require("component/otp/OtpView");
	var LoginView = module.exports = Form.extend({
		template : _.template(LoginTpl),

		events : {
			"tap #submitBtn" : "submit",
			"tap #login-code-span" : "getCaptcha",
			"tap .remember_uName_radio" : "rememberUserName",
			"tap #agreement" : 'showAgreement',
			"tap  #iconA46  " : 'toggleCheckbox'

		},

		submitFlag : false,

		onRender : function() {

		},

		onShow : function() {
			var options = {
				isOtpSended : true,
				isNeedSendOtpValidate : false,
				isQryOtpPhoneNo : false, //不调用接口查询手机号码
				otpEnable : null,
				isMobilePhoneByUser : true, //手机号码是用户输入的
				resendBtnHandler : _.bind(this.resendBtnHandler, this), //点击“立即获取”按钮调用方法
				isOutLogin : true
			};
			this.otpView = new OtpView();
			this.otpView.initOtp(options);

			$(".login-mobile-otp-container").empty();
			$(".login-mobile-otp-container").append($(this.otpView.$el[0]));
		},

		/**
		 * otp校验手机号码
		 */
		validMobile : function(mobile) {
			//手机号码
			if (!mobile) {
				utils.dialog.toast("手机号码不能为空");
				return false;
			}
			if (mobile && !utils.validate.phone(mobile)) {
				utils.dialog.toast("手机号码输入不正确");
				return false;
			}
			return true;
		},

		resendBtnHandler : function() {
			var mobile = this.$("#userMobile").val();
			if (!this.validMobile(mobile))
				return;
			this.sentOtp(mobile);
		},

		/**
		 *发送otp
		 */
		sentOtp : function(mobile) {
			var param = {
				"mobileNo" : mobile,
				"cat" : config.values.login
			};
			this.otpView.sendSmsOTP('vToken', param, this);
		},

		submit : function(e) {
			var userMobile = this.$("#userMobile").val();
			var mobileOtp = this.otpView.getValue();

			if (!this.validMobile(userMobile))
				return;
			if (!this._validate(mobileOtp))
				return;
			var options = {
				mobile : userMobile,
				otp : mobileOtp
			};

			if (IS_RUN_ON_IDEVICE) {
				utils.native.getTokenID(_.bind(function(tokenID) {
					options.deviceId = utils.native.getIDeviceID();
					options.tokenId = tokenID || "TOKENID_10987654321iphone";
					this.trigger("form:submit", options);
				}, this));
			} else if (IS_RUN_ON_ANDROID) {
				utils.native.getDeviceID(_.bind(function(deviceID) {
					options.deviceId = deviceID || "AUUID_12345678910aa";
					this.trigger("form:submit", options);
				}, this));
			} else {
				this.trigger("form:submit", options);
			}

		},

		_validate : function(mobileOtp) {
			if (!mobileOtp) {
				utils.dialog.toast("请输入动态密码");
				return false
			}
			if (!this.$("#iconA46").hasClass('on')) {
				utils.dialog.toast("请阅读并同意协议！");
				return false;
			}
			return true;
		},
		showAgreement : function(e) {
			e.stopPropagation();
			e.preventDefault();
			utils.window.open({
				title : "《平安直通银行服务协议》",
				url : config.urls.get("terms_of_service")
			});
		},
		toggleCheckbox : function() {
			this.$("#iconA46").toggleClass("on");
		}
	});

})
