/**
 * liujun
 * 我的账户与安全
 *
 */
define(function(require, exports, module){
    var accoutAndSecurityView    = require("../view/accoutAndSecurity/accoutAndSecurity");
    var securitySetView          = require("../view/accoutAndSecurity/securitySet");
    var bankManageView           = require("../view/accoutAndSecurity/bankManage");
    var SecurityOrangeView       = require("../view/accoutAndSecurity/securityOrange");
    var LearnOrangeView          = require("../view/accoutAndSecurity/learnOrange");
    var transferLimitView        = require("../view/accoutAndSecurity/transferLimit");
    var transferLimitSuccessView = require("../view/accoutAndSecurity/transferLimitSuccess");
    var loginSecurityConfirmView = require("../view/accoutAndSecurity/loginSecurityConfirm");
    var loginSecurityOtpView = require("../view/accoutAndSecurity/loginSecurityOtp");
    var loginSecurityFinishView  = require("../view/accoutAndSecurity/loginSecurityFinish");
    var accountInfoSta = require("mod/common/accountInfoStatus/accountInfoStatus");
    var bankManage               = require("../model/bankManage");
    var Index = module.exports = Controller.extend({
        actions : {
            index                : "index",
            securityOrange       : "securityOrange",
            learnOrange          : "learnOrange",
            securitySet          : "securitySet",
            "bankManage/:code"   : "bankManage",
            transferLimit        : "transferLimit",
            transferLimitSuccess : "transferLimitSuccess",
            loginSecurityConfirm : "loginSecurityConfirm",
            loginSecurityOtp: "loginSecurityOtp",
            loginSecurityFinish  : "loginSecurityFinish"
        },

        // authorize: function(){
        //  return true;
        // },
        //账户与安全
        index: function(){
            utils.native.talkingDataTrackEvent("2.0-我-账户与安全");
            App.header.reset({
                title: "账户与安全",
                leftButtonContent: "@back",
                leftButtonHandler: function(){
                    if(App.storage.get("me/accoutAndSecurity/index/fromPageIndex")){
                        App.storage.remove("me/accoutAndSecurity/index/fromPageIndex");
                        App.navigate("index/indexLogined/index",true);
                    }else{
                        App.navigate("me/logined/index",true);
                    }

                }
            });

            App.footer.reset({
                visible: false,
                selectedIndex: 3
            });
            var accNumber = App.storage.get("UserInfo").attributes.accNumber;
            var openAccBank = App.storage.get("UserInfo").attributes.openAccBank;
            var data = {accNumber: accNumber,openAccBank: openAccBank};
            App.container.show(new accoutAndSecurityView({model: new Model(data)}));
        },

        //安全橙级
        securityOrange: function(){
            utils.native.talkingDataTrackEvent("2.0账户与安全-安全设置-安全橙级");
            App.header.reset({
                title: "安全橙级",
                leftButtonContent : "@back",
                leftButtonHandler : function(){
                    App.navigate("me/accoutAndSecurity/securitySet",true);
                }
            });

            App.footer.reset({
                visible: false
            });

            App.container.show(new SecurityOrangeView());
        },

        //了解安全橙级
        learnOrange: function(){
            App.header.reset({
                title: "了解安全橙级",
                leftButtonContent : "@back",
                leftButtonHandler : function(){
                    App.navigate("me/accoutAndSecurity/securityOrange",true);
                }
            });

            App.footer.reset({
                visible: false
            });

            App.container.show(new LearnOrangeView());
        },
        //银行卡管理
        bankManage: function(code){
            utils.native.talkingDataTrackEvent("2.0-我-账户与安全-银行卡管理");
            App.footer.reset({
                visible: false
            });
            App.container.show(new bankManageView({code: code}));
        },
        //安全设置
        securitySet: function(){
            utils.native.talkingDataTrackEvent("2.0账户与安全-安全设置");
            App.header.reset({
                title: "安全设置",
                leftButtonContent : "@back",
                leftButtonHandler : function(){
                    App.navigate("me/accoutAndSecurity/index",true);
                }
            });

            App.footer.reset({
                visible: false
            });

            App.container.show(new securitySetView());
        },
        //转账限额
        transferLimit: function(){
            utils.native.talkingDataTrackEvent("2.0账户与安全-安全设置-转账限额");
            App.header.reset({
                title: "转账限额",
                leftButtonContent : "@back",
                leftButtonHandler : function(){
                    if(App.storage.get("me/accoutAndSecurity/transferLimit/fromPage")){
                        var url = App.storage.remove("me/accoutAndSecurity/transferLimit/fromPage");
                        App.navigate(url,true);
                    }else{
                        App.navigate("me/accoutAndSecurity/securitySet",true);
                    }
                }
            });

            App.footer.reset({
                visible: false
            });
            // if(App.storage.get("UserInfo").get("cardState") == "1" && App.storage.get("UserInfo").get("bindState") == "1"){
            if(App.storage.get("me/accoutAndSecurity/transferLimit/fromPage")){
                var dfd = accountInfoSta.getAccountInfoStatus(true,App.storage.get("me/accoutAndSecurity/transferLimit/fromPage"));
                var getIsTelephone = accountInfoSta.getIsTelephoneLogin(App.storage.get("me/accoutAndSecurity/transferLimit/fromPage"));
            }else{
                var dfd = accountInfoSta.getAccountInfoStatus(true,"me/accoutAndSecurity/securitySet");
                var getIsTelephone = accountInfoSta.getIsTelephoneLogin("me/accoutAndSecurity/securitySet");
            }
            if(getIsTelephone){}else{
                dfd.done(function(accountSta){
                    if(accountSta){
                        bankManage.qryTransLimit({
                            data: {},
                            callback: function(res){
                                var data = {};
                                if(res.success){
                                    if(res.object.inUseFlag == "1"){
                                        App.storage.set("previousLimitData","1");
                                        data = res.object;
                                        App.container.show(new transferLimitView(data));
                                    }else{
                                        App.storage.set("previousLimitData","0");
                                        data = res.object;
                                        App.container.show(new transferLimitView(data));
                                    }
                                }
                            },
                            errorCallback: function(err){
                                utils.dialog.toast(err.message);
                            }
                        });
                    }
                });
            }
        },
        //转账限额
        transferLimitSuccess: function(){
            App.header.reset({
                title: "转账限额",
                leftButtonContent : "@back",
                leftButtonHandler : function(){
                    if(App.storage.get("me/accoutAndSecurity/transferLimit/fromPage")){
                        var url = App.storage.remove("me/accoutAndSecurity/transferLimit/fromPage");
                        App.navigate(url,true);
                    }else{
                        App.navigate("me/accoutAndSecurity/securitySet",true);
                    }
                }
            });

            App.footer.reset({
                visible: false
            });
            App.container.show(new transferLimitSuccessView());
        },
        //登录安全验证
        loginSecurityConfirm: function(){
            utils.native.talkingDataTrackEvent("2.0账户与安全-安全设置-登录安全验证");
            App.header.reset({
                title: "登录安全验证",
                leftButtonContent : "@back",
                leftButtonHandler : function(){
                    App.navigate("me/accoutAndSecurity/securitySet",true);
                }
            });

            App.footer.reset({
                visible: false
            });

            //查询历史安全验证设置记录，无接口

            bankManage.qryLoginSecurityOty({
                data: {},
                callback: function(res){
                    if(res.success){
                        var previous = res.object.otpSwitch;
                        var data = {};
                        data.previous = previous;
                        App.container.show(new loginSecurityConfirmView(data));
                    }
                },
                errorCallback: function(err){
                    App.container.show(new loginSecurityConfirmView());
                }
            });
        },

        //登录安全验证
        loginSecurityOtp: function(){
            App.header.reset({
                title: "登录安全验证",
                leftButtonContent : "@back",
                leftButtonHandler : function(){
                    App.navigate("me/accoutAndSecurity/loginSecurityConfirm",true);
                }
            });

            App.footer.reset({
                visible: false
            });
            App.container.show(new loginSecurityOtpView());
        },
        //登录安全验证完成
        loginSecurityFinish: function(state){
            App.header.reset({
                title: "登录安全验证",
                leftButtonContent : "@back",
                leftButtonHandler : function(){
                    App.navigate("me/accoutAndSecurity/securitySet",true);
                }
            });

            App.footer.reset({
                visible: false
            });
            App.container.show(new loginSecurityFinishView(state));
        }
    });
})