/*
* liujun
* 活期余额
*/
define(function(require, exports, module){
	var indexView          = require('../view/balance');
	var problemsView       = require('../view/problems');
	var problemDetailsView = require('../view/problemDetails');
	var transModel         = require("../model/transferModel");

	var balance = module.exports = Controller.extend({
		actions: {
			index          : "index",
			problems       : "problems",
			problemDetails : "problemDetails"
		},

		index: function(option){
			utils.native.talkingDataTrackEvent("2.0活期余额");
			App.header.reset({
				title: "活期余额",
				leftButtonContent: "@back",
				leftButtonHandler: function(){
					App.navigate("me/logined/index",true);
				},
				rightButtonContent: "转账记录",
				rightButtonHandler: function(){
					App.navigate('me/tradeRecords/index/'+config.values.zhaunZhang+"?"+Date.parse(new Date()),true);
				}
			});
			App.footer.reset({
				visible: false,
				selectedIndex: 3
			});

			var data = {
				money : ""
			};
			if(option){
				data.money = option.money;
				App.container.show(new indexView({model: new Model(data)}));
			}else{
				transModel.currentToFixedTransferBalance({
					url  : "currentToFixedTransferBalance",
					type : "GET",
					callback : function(resp) {
						data.money = resp.object.balance;
						App.container.show(new indexView({model: new Model(data)}));
					},
					errorCallback : function(resp) {
						App.container.show(new indexView({model: new Model(data)}));
					}
				});
			}
		},

		//常见问题
		problems: function(){
			var money = "0";
			money = App.storage.get("balanceMoney");
			App.header.reset({
				title: "常见问题",
				leftButtonContent: "@back",
				leftButtonHandler: function(){
					App.navigate("me/balance/index?money="+money,true);
				}
			});
			App.footer.reset({
				visible: false,
				selectedIndex: 3
			});
			App.container.show(new problemsView());
		},

		//问题详情
		problemDetails: function(options){
			App.header.reset({
				title: "问题详情",
				leftButtonContent: "@back",
				leftButtonHandler: function(){
					App.navigate("me/balance/problems",true);
				}
			});
			App.footer.reset({
				visible: false,
				selectedIndex: 3
			});
			var data = {};
			data.code = options.code;
			App.container.show(new problemDetailsView(data));
		}
	});
});