/**
 * 信用卡还款
 * by 7iang
 * 2015-06-17
 */
define(function(require, exports, module) {
    var openCreditView = require("../view/creditCard/openCreditCard");
    var payBackResultView = require("../view/creditCard/payBackResult");
    var creditCardView = require("../view/creditCard/payBack");
    var CreditPaymentModel = require("../model/creditCard");
    var accountInfoStatus = require("mod/common/accountInfoStatus/accountInfoStatus");
    var CreditCardController = module.exports = Controller.extend({
        actions : {
            "payBack" : "payback",
            "payBackResult" : "payBackResult"
        },

        //跳转到信用卡还款结果页面
        payBackResult : function() {
            utils.native.talkingDataTrackEvent("2.0信用卡还款成功");
            App.header.reset({
                leftButtonContent : "@back",
                title : "信用卡还款结果"
            });

            App.footer.reset({
                visible : false
            });
            App.container.show(new payBackResultView());
        },

        //信用卡还款页面

        payback : function(query) {
            var returnURL = query && query.returnURL;
            var cardState = App.storage.get("UserInfo").get("cardState");

            if (cardState == "1") {
                utils.native.talkingDataTrackEvent("2.0信用卡还款第一步");
                var promise = $.when(CreditPaymentModel.relatingCreditCard());
                //获取关联的信用卡列表，以及是否设置自动还款
                promise.done(function(arg) {
                    if (arg.object.cardList && arg.object.cardList.length > 0) {
                        var promise = $.when(CreditPaymentModel.qryTransferLimit(), //查询转账交易限额
                        CreditPaymentModel.queryCreditCardInfo(), //查询信用卡相关信息
                        App.request("qrySmartDepositBalance") //定活通余额
                        );

                        promise.done(function(arg1, arg2, arg3) {
                            if (!App.storage.get("creditPayment/returnURL")) {
                                App.storage.set("creditPayment/returnURL", returnURL);
                            }
                            var obj = {};
                            obj.transferLimit = arg1[0].object;
                            obj.creditCardInfo = arg2[0].object;
                            obj.zndhtBalance = parseFloat(arg3[0].object.balance || 0);

                            App.header.reset({
                                title : "信用卡还款",
//                                leftButtonHandler : function() {
//                                    App.navigate("me/logined/index", true);
//                                },
                                leftButtonContent : "@back",
                                rightButtonContent : "设置",
                                rightButtonHandler : function() {
                                    if(arg.object.status>=1 && arg.object.status <=3 ){
                                        utils.dialog.toast("自动还款设置审核中");
                                        return;
                                    }
                                    App.navigate("me/autoReply/index", true);
                                }
                            });
                            App.footer.reset({
                                visible : false
                            });
                            App.container.show(new creditCardView({
                                model : new Model(obj)
                            }));
                        });

                        promise.fail(function(error) {
                            utils.dialog.alert(error.message, function() {
                                App.navigate("me/logined/index", true);
                            });
                        });
                    } else {
                        App.header.reset({
                            title : "信用卡还款",
                            leftButtonContent : "@back"
//                            leftButtonHandler : function() {
//                                App.navigate("me/logined/index", true);
//                                /*App.storage.remove("creditPayment/returnURL");*/
//                            }
                        });
                        App.footer.reset({
                            visible : false
                        });
                        App.container.show(new openCreditView());
                    }
                });

                promise.fail(function(error) {
                    utils.dialog.alert(error.message, function() {
                        App.navigate("me/logined/index", true);
                    });
                });
            } else {
                accountInfoStatus.getAccountInfoCardStateStatus("me/logined/index");
            }
        }
    });
});
