/*
* liujun	
* 个性化信息
*/
define(function(require, exports, module){
	var indexView = require('../view/individual/individualList');
	var individualData = require('../model/individualData');
	var familyIncomeView = require("../view/individual/familyIncome");
	var marryView = require("../view/individual/marry");
	var childrenView = require("../view/individual/children");
	var carView = require("../view/individual/car");
	var loanView = require("../view/individual/loan");
	var industryView = require("../view/individual/industry");

	var individual = module.exports = Controller.extend({
		actions: {
			index: "index",      //个性化信息主页面
			familyIncome: "familyIncome",
			marry: "marry",
			children: "children",
			car: "car",
			loan: "loan",
			industry: "industry"
		},

		individualInfoData: function(){
				individualData.queryIndividual({
						url: "qryAccountBaseInfo",
						data: {},
						callback: function(res){
							App.container.show(new indexView(res));
						},
						errorCallback: function(err){
							utils.dialog.alert(err.message);
						}
				});
		},
		//个性化信息
		index: function(){
			App.header.reset({
				title: "个性化信息",
				leftButtonContent: "@back",
				leftButtonHandler: function(){
					App.navigate("me/meInfoIndex/index",true);
				}
			});
			App.footer.reset({
				visible: false,
				selectedIndex: 3
			});
			this.individualInfoData();
		},
		//家庭收入
		familyIncome: function(query){
			App.header.reset({
				title: "家庭收入",
				leftButtonContent: "@back",
				leftButtonHandler: function(){
					App.navigate("me/individualInfo/index",true);
				}
			});
			App.footer.reset({
				visible: false,
				selectedIndex: 3
			});
			var data = {familyIncomeFlag: query.familyIncomeFlag};
			App.container.show(new familyIncomeView({model: new Model(data)}));
		},
		//婚姻状况
		marry: function(query){
			App.header.reset({
				title: "婚姻状况",
				leftButtonContent: "@back",
				leftButtonHandler: function(){
					App.navigate("me/individualInfo/index",true);
				}
			});
			App.footer.reset({
				visible: false,
				selectedIndex: 3
			});
			var data = {marryFlag: query.marryFlag};
			App.container.show(new marryView({model: new Model(data)}));
		},
		//子女情况
		children: function(query){
			App.header.reset({
				title: "子女情况",
				leftButtonContent: "@back",
				leftButtonHandler: function(){
					App.navigate("me/individualInfo/index",true);
				}
			});
			App.footer.reset({
				visible: false,
				selectedIndex: 3
			});
			var data = {childFlag: query.childFlag};
			App.container.show(new childrenView({model: new Model(data)}));
		},
		//私家车情况
		car: function(query){
			App.header.reset({
				title: "私家车情况",
				leftButtonContent: "@back",
				leftButtonHandler: function(){
					App.navigate("me/individualInfo/index",true);
				}
			});
			App.footer.reset({
				visible: false,
				selectedIndex: 3
			});
			var data = {carFlag: query.carFlag};
			App.container.show(new carView({model: new Model(data)}));
		},
		//房贷情况
		loan: function(query){
			App.header.reset({
				title: "房贷情况",
				leftButtonContent: "@back",
				leftButtonHandler: function(){
					App.navigate("me/individualInfo/index",true);
				}
			});
			App.footer.reset({
				visible: false,
				selectedIndex: 3
			});
			var data = {loanFlag: query.loanFlag};
			App.container.show(new loanView({model: new Model(data)}));
		},
		//从事行业
		industry: function(){
			App.header.reset({
				title: "从事行业",
				leftButtonContent: "@back",
				leftButtonHandler: function(){
					App.navigate("me/individualInfo/index",true);
				}
			});
			App.footer.reset({
				visible: false,
				selectedIndex: 3
			});
			var data = App.storage.get("individual_industry");
			App.container.show(new industryView({model: new Model(data)}));
		}
	});
});