/**
 * EX-WUWENJUN
 * 修改手机、修改邮箱、修改预留信息
 *  
 */

define(function(require,exports,module){
   var MeInfoModel = require("../model/meInfo");
   var ModifyIphonePage =require("../view/meInfo/modifyIphonePage");
   var ModifyIphoneStep1 =require("../view/meInfo/modifyIphoneStep1");
   var ModifyIphoneStep2 =require("../view/meInfo/modifyIphoneStep2");
   var ModifyIphoneStep3 =require("../view/meInfo/modifyIphoneStep3");
   var ModifyEmailView =require("../view/meInfo/modifyEmail");
   var ModifyEmailSuccess =require("../view/meInfo/modifyEmailConfirm");
   var ResetIphoneStep1 =require("../view/meInfo/resetIphoneStep1");
   var ResetIphoneStep2 =require("../view/meInfo/resetIphoneStep2");
   var ResetIphoneStep3 =require("../view/meInfo/resetIphoneStep3");
   var ResetIphoneStep4 =require("../view/meInfo/resetIphoneStep4");
   var ModifyAuthMessage =require("../view/meInfo/authMessage");
   
   var PersonalInfoController = module.exports = Controller.extend({
       actions : {
           "modifyIphonePage" : "toModifyIphonePage",
           "modifyIphoneStep1" : "toModifyIphoneStep1Page",
           "modifyIphoneStep2" : "toModifyIphoneStep2Page",
           "modifyIphoneStep3" : "toModifyIphoneStep3Page",
           "modifyEmailPage" : "toModifyEmailPage",
           "modifyEmailSuccess" : "toModifyEmailSuccess",
           "resetIphoneStep1" : "toResetIphoneStep1Page",
           "resetIphoneStep2" : "toResetIphoneStep2Page",
           "resetIphoneStep3" : "toResetIphoneStep3Page",
           "resetIphoneStep4" : "toResetIphoneStep4Page",
           "modifyAuthMessage" : "toModifyAuthMessage"
       },
       
       //手机更改
       toModifyIphonePage : function(){
          utils.native.talkingDataTrackEvent("2.0-我-账户与安全-修改手机号码");
          App.header.reset({
                title:"手机号码",
                leftButtonHandler : function() {
                    App.navigate("me/meInfoIndex/index", true);
                },
                  
                leftButtonContent:"@back"
            });
            App.container.show(new ModifyIphonePage()); 
       },
       
       //修改手机号码第一步
       toModifyIphoneStep1Page : function(){
           utils.native.talkingDataTrackEvent("2.0-我-账户与安全-修改手机号码第一步");
           App.header.reset({
                title:"修改手机号码",
                leftButtonHandler : function() {
                    App.navigate("me/meInfo/modifyIphonePage", true);
                },
                  
                leftButtonContent:"@back"
            });
            App.container.show(new ModifyIphoneStep1());
       },
       
       //修改手机号码第二步
       toModifyIphoneStep2Page : function(){
           utils.native.talkingDataTrackEvent("2.0-我-账户与安全-修改手机号码第二步");
           App.header.reset({
                title:"修改手机号码",
                leftButtonHandler : function() {
                    App.navigate("me/meInfo/modifyIphonePage", true);
                },
                  
                leftButtonContent:"@back"
            });
            App.container.show(new ModifyIphoneStep2());
       },
       
       //修改手机号码第三步
       toModifyIphoneStep3Page : function(){
           utils.native.talkingDataTrackEvent("2.0-我-账户与安全-修改手机号码第三步");
           App.header.reset({
                title:"修改手机号码",
                leftButtonHandler : function() {
                    App.navigate("me/meInfoIndex/index", true);
                },
                  
                leftButtonContent:"@back"
            });
            App.container.show(new ModifyIphoneStep3());
       },
       
       //修改邮箱(第一步)
       toModifyEmailPage : function(){
           utils.native.talkingDataTrackEvent("2.0-我-账户与安全-修改电子邮箱第一步");
           App.header.reset({
                title:"修改电子邮箱",
                leftButtonHandler : function() {
                    App.navigate("me/meInfoIndex/index", true);
                },
                  
                leftButtonContent:"@back"
            });
            
            var emailData = App.storage.get("modifyEmailPage/email");
            App.storage.remove("modifyEmailPage/email");
            var emailView = new ModifyEmailView({model:new Model(emailData)});
            emailView.on("form:submit",function(formData){
                MeInfoModel.checkEmail({
                    params:{email:formData.email},
                    complete:function(err,response){
                        if(err) return utils.dialog.alert(err.message);
                        if(response.object.procFlag == "1")return utils.dialog.alert("邮箱已被注册，请更换邮箱");
                        App.storage.set("modifyEmailPage/email",formData);
                        emailView.toModifyEmailConfirm(); 
                    }
                });
                             
            });
            App.container.show(emailView);
       },
       
       //修改邮箱成功
       toModifyEmailSuccess : function(){
           utils.native.talkingDataTrackEvent("2.0-我-账户与安全-修改电子邮箱成功");
           App.header.reset({
                title:"修改电子邮箱",
                leftButtonHandler : function() {
                    App.navigate("me/meInfoIndex/index", true);
                },
                  
                leftButtonContent:"@back"
            });
           App.container.show(new ModifyEmailSuccess()); 
       },
       
       //重置手机号码第一步
       toResetIphoneStep1Page : function(){
           utils.native.talkingDataTrackEvent("2.0-我-账户与安全-重置手机号码第一步");
           App.header.reset({
                title:"重置手机号码",
                leftButtonHandler : function() {
                    App.navigate("me/meInfo/modifyIphonePage", true);
                },
                  
                leftButtonContent:"@back"
            });
            App.container.show(new ResetIphoneStep1());
       },
       
       //重置手机号码第二步
       toResetIphoneStep2Page : function(){
           utils.native.talkingDataTrackEvent("2.0-我-账户与安全-重置手机号码第二步");
           App.header.reset({
                title:"重置手机号码",
                leftButtonHandler : function() {
                    App.navigate("me/meInfo/resetIphoneStep1", true);
                },
                  
                leftButtonContent:"@back"
            });
            App.container.show(new ResetIphoneStep2());
       },
       
       //重置手机号码第三步
       toResetIphoneStep3Page : function(){
           utils.native.talkingDataTrackEvent("2.0-我-账户与安全-重置手机号码第三步");
           App.header.reset({
                title:"重置手机号码",
                leftButtonHandler : function() {
                    App.navigate("me/meInfo/resetIphoneStep2", true);
                },
                  
                leftButtonContent:"@back"
            });
            App.container.show(new ResetIphoneStep3());
       },
       
       //重置手机号码第四步
       toResetIphoneStep4Page : function(){
           utils.native.talkingDataTrackEvent("2.0-我-账户与安全-重置手机号码第四步");
           App.header.reset({
                title:"重置手机号码",
                leftButtonHandler : function() {
                    App.navigate("me/meInfoIndex/index", true);
                },
                  
                leftButtonContent:"@back"
            });
            App.container.show(new ResetIphoneStep4());
       },
       
       //修改预留信息
       toModifyAuthMessage : function(){
           utils.native.talkingDataTrackEvent("2.0-我-账户与安全-修改手预留信息");
            App.header.reset({
                title:"预留验证信息",
                leftButtonHandler : function() {
                    App.navigate("me/meInfoIndex/index", true);
                },
                  
                leftButtonContent:"@back"
            });
            App.container.show(new ModifyAuthMessage());
       }
       
   });  
});
