/**
 * EX-WUWENJUN
 * 账户详情
 *
 */
define(function(require, exports, module) {
    var meInfoIndexView = require("../view/meInfo/meInfoIndex");
    var meContactInfoView = require("../view/meInfo/meContactInfo");
    var meContactInfoAddressView = require("../view/meInfo/meContactInfoAddress");
    var meContactInfoZipcodeView = require("../view/meInfo/meContactInfoZipcode");
    var meContactInfoMergNameView = require("../view/meInfo/meContactInfoMergName");
    var meContactInfoMergPhoneView = require("../view/meInfo/meContactInfoMergPhone");

    var meInfoModel = require("../model/meInfo");  //个人信息model
	var securitySetModel = require("../model/securitySet");

    var index = module.exports = Controller.extend({
        actions : {
            'index' : 'index',
            // 修改联系人信息
            'contactInfo' : 'contactInfo',
            "contactInfo/:type"  : "contactInfo"
        },

        index : function(code) {
            utils.native.talkingDataTrackEvent("2.0账户与安全-账户详情");
            App.header.reset({
                title : "账户详情",
                leftButtonContent : '@back',
                leftButtonHandler : function() {
                    App.navigate("me/accoutAndSecurity/index", true);
                }
            });
			App.footer.reset({
                visible : false
            });
            this.toMeInfo();
        },

         /**
         *
         * 个人信息
         * @param {Object} data
         *
         */

        toMeInfo : function(data) {
            var self = this;
          	if(data) {
                App.container.show(new meInfoIndexView({model : new Model(data)}));
            }else{
	            var promise = $.when(
	                meInfoModel.getPersonalInfo(),
	                meInfoModel.getImagePath(),
	                securitySetModel.settingSecurity()
	            );
	            promise.done(function(arg1,arg2,arg3){
	               self.toMeInfo({arg1:arg1[0],arg2:arg2[0],arg3:arg3[0]});
				   App.storage.set('MeSecuritySet', arg3[0].object);
                   //保存账户个人信息
                   App.storage.set('UserPersonalInfo', arg1[0].object);
                   self.UserPersonalInfo = new Model(arg1[0].object);
	           });
	            promise.fail(function(err){
	                utils.dialog.alert(err.message);
	            });
            }
        },

        /**
         * ex-wuyongsheng001 联系信息
         */
        meInfoUrl: 'me/meInfoIndex/',
        UserPersonalInfo: null,
        contactInfo : function (type) {
          if (!this.UserPersonalInfo) return;
          switch(type) {
            case 'address':
              this._setHead('家庭地址', this.meInfoUrl + 'contactInfo');
              App.container.show(new meContactInfoAddressView({model: this.UserPersonalInfo}));
              break;
            case 'zipcode':
              this._setHead('联系邮编', this.meInfoUrl + 'contactInfo');
              App.container.show(new meContactInfoZipcodeView());
              break;
            case 'mergName':
              this._setHead('紧急联系人姓名', this.meInfoUrl + 'contactInfo');
              App.container.show(new meContactInfoMergNameView());
              break;
            case 'mergPhone':
              this._setHead('紧急联系人号码', this.meInfoUrl + 'contactInfo');
              App.container.show(new meContactInfoMergPhoneView());
              break;
            default:
              this._setHead('联系信息', this.meInfoUrl + 'index');
              App.container.show(new meContactInfoView({model: this.UserPersonalInfo}));
              break;
          }
        },

        /**
         * ex-wuyongsheng001 设置头部 url
         */
        _setHead: function (title, url) {
          App.header.reset({
              title : title || null,
              leftButtonContent : '@back',
              leftButtonHandler : function() {
                  App.navigate(url || "me/accoutAndSecurity/index", true);
              }
          });
        }

    });
});
