/**
 * EX-WUWENJUN
 * 转账(转出)主控制器
 *
 */
define(function(require, exports, module){
    var transferLang       = require("../common/transferLang");
    var transferTools      = require("../common/transferTools");
    var transferView      = require("../view/transfer/transfer");
    var bindAccSelView      = require("../view/transfer/bindAccSelect");
    var openBankSelView      = require("../view/transfer/openBankSelect");
    var transferModeView     = require("../view/transfer/transferMode");
    var ProListView        = require("../view/transfer/transferProList");
    var CityListView       = require("../view/transfer/transferCityList");
    var BranchBankView     = require("../view/transfer/transferBranchBank");
    var transferRealFinishView     = require("../view/transfer/transferRealFinish");
    var transferCommonFinishView     = require("../view/transfer/transferCommonFinish");
    var assetsTransInUnbindAccView = require("../view/transfer/assetsTransInUnbindAcc");

    var securitySetModel = require("../model/securitySet");
    var transModel          = require("../model/transferModel");
    var accountModel        = require("mod/common/model/accountModel");
    var accountInfoSta     = require("mod/common/accountInfoStatus/accountInfoStatus");

    var transferController = module.exports = Controller.extend({
        actions: {
            "index"            : "index",
            "bindAccSelect" : "toBindAccSelect",  //绑定的银行卡
            "openBankSel" : "toOpenBankSelect", //开户行
            "transferMode" : "toTransferMode",   //到账时间
            "showProPage" : "showProPage",   //显示县城
            "showCityPage" : "showCityPage",  //显示城市
            "showBranchBank"   : "showBranchBank",//选择开户网点
            "transferFinish" : "transferFinish",  //转出成功
            "assetsTransInUnbindAcc":"_toUnbindAccView", //未绑定账户
            "transferView" : "transferView"
        },

        /*
         * 进入转账输入页
         *
         *
         */
        index: function(){
            utils.native.talkingDataTrackEvent("2.0转出第一步");
            //转出跳转
            this._transferOut();
        },

        /**
         * 选择开户城市、开户行等的跳转页面
         */
        transferView : function(){
            App.header.reset({
                title:"转出",
                leftButtonHandler : function() {
                    App.storage.remove("selectedAccount");
                    App.storage.remove("transferData");
                    App.storage.remove("openBankList");
                    App.storage.remove("bindAccount");
                    App.storage.remove("selectedBankInfo");
                    App.storage.remove("transfer_cityData");
                    App.storage.remove("transfer_bankBinItem");
                    //梦想立即提款返回梦想页面
                    if(App.storage.get("immediatelyTransfer")){
                        App.storage.remove("immediatelyTransfer");
                        App.navigate("dream/dream/myDream",true);
                    }else{
                        App.navigate("me/logined/index",true);
                    }
                },

                leftButtonContent:"@back"
            });

            App.footer.reset({
                visible : false
            });
            var transferInAccNo = App.storage.get('UserInfo').attributes.accNumber;
            App.container.show(new transferView({"transferInAccNo":transferInAccNo}));
        },

        //展示未绑定列表
        _toUnbindAccView:function(){
             App.header.reset({
                title : "转出",
                leftButtonContent : "@back",
                leftButtonHandler : function(){
                    App.navigate("me/logined/transferView",true);
                }
            });
            App.footer.reset({visible:false, selectedIndex:0});
            App.container.show(new assetsTransInUnbindAccView());
        },

        //选择收款账号
        toBindAccSelect : function(){
            App.header.reset({
                title:"选择收款账号",
                leftButtonHandler : function() {
                    App.navigate("me/transfer/transferView",true);
                },

                leftButtonContent:"@back"
            });
            var bindAccList = App.storage.get("bindAccount");
            App.container.show(new bindAccSelView({model:new Model(bindAccList)}));
        },

        //选择开户行
        toOpenBankSelect : function(bindAcc,openBankList){
            var openBankList = App.storage.get("openBankList");
            var bindAcc = App.storage.get("selectedAccount");
            App.header.reset({
                title:"选择开户行",
                leftButtonHandler : function() {
                    var cacheData = App.storage.get("transferData");
                    //返回时实时联行号与大行号都不存在时清除所有缓存
                    if(!cacheData.realBankId && !cacheData.bankId){
                        cacheData.toAccNo     = "";   //选择的银行卡账号
                        cacheData.toAccountText     = "";   //选择的银行卡
                        cacheData.bankName       = "";
                        cacheData.realBankId     = "";
                        cacheData.branchBankName = "";
                        cacheData.cityName = "";
                        cacheData.provinceName = "";
                        App.storage.remove("selectedAccount");
                        App.storage.remove("selectedBankInfo");
                        App.storage.remove("transfer_cityData");
                    }
                    App.navigate("me/transfer/transferView",true);
                },

                leftButtonContent:"@back"
            });
            App.container.show(new openBankSelView({model:new Model({"bindAcc":bindAcc,"openBankList":openBankList})}));
        },

        //到账时间
        toTransferMode : function(){
            App.header.reset({
                title:"到账时间",
                leftButtonHandler : function() {
                    App.navigate("me/transfer/transferView",true);
                },

                leftButtonContent:"@back"
            });
            App.container.show(new transferModeView());
        },

        //选择省份
        showProPage : function(){
            App.header.reset({
                title:"开户城市",
                leftButtonHandler : function() {
                    App.navigate("me/transfer/transferView",true);
                },

                leftButtonContent:"@back"
            });
            var cacheData = App.storage.get("transferData");
            var toAccNo = cacheData.toAccNo;    //转入账号
            var toAccountText = cacheData.toAccountText;  //转入账号名称
            App.container.show(new ProListView({model:new Model({"proList" : transferTools.assCityData(transferTools.getProvinceInfo),"toAccNo":toAccNo,"toAccountText":toAccountText})}));
        },

        //选择城市
        showCityPage : function(){
            App.header.reset({
                title:"开户城市",
                leftButtonHandler : function() {
                    App.storage.remove("transfer_cityData");
                    App.navigate("me/transfer/showProPage",true);
                },

                leftButtonContent:"@back"
            });
            App.container.show(new CityListView({model : new Model({"cityList" : transferTools.assCityData(App.storage.get("transfer_cityData").list)})}));
        },

        //选择开户网点
        showBranchBank: function(){
            App.header.reset({
                title:"开户网点",
                leftButtonHandler : function() {
                    App.navigate("me/transfer/transferView",true);
                },

                leftButtonContent:"@back"
            });
            var toAccountInfo = App.storage.get("selectedAccount");
            App.container.show(new BranchBankView({
                model : new Model({"bindAcc":toAccountInfo,"branchBankList" : App.storage.get("branchBankList")})
            }));
        },

        /**
         *转出成功
         *
         */
        transferFinish : function(){
            utils.native.talkingDataTrackEvent("2.0转出成功");
             App.header.reset({
                title:"转出结果",
                leftButtonHandler : function() {
                    App.storage.remove("selectedAccount");
                    App.storage.remove("transferData");
                    App.storage.remove("openBankList");
                    App.storage.remove("bindAccount");
                    App.storage.remove("selectedBankInfo");
                    App.storage.remove("transfer_cityData");
                    App.storage.remove("transfer_bankBinItem");
                    //梦想立即提款成功之后，转出成功返回到梦想页面
                    if(App.storage.get("immediatelyTransfer")){
                        App.storage.remove("immediatelyTransfer");
                        App.navigate("dream/dream/myDream",true);
                    }else{
                        App.navigate("me/logined/index",true);
                    }
                },

                leftButtonContent:"@back"
            });
            var transferData = App.storage.get("transferData");
            //是否同行
            if(transferData.isSameBank){
                App.container.show(new transferRealFinishView({model:new Model(transferData)}));
            }else{
                //是否是实时转出
                if(transferData.executeType==2){
                    App.container.show(new transferRealFinishView({model:new Model(transferData)}));
                }else{
                    App.container.show(new transferCommonFinishView({model:new Model(transferData)}));
                }
            }

        },

        /**
         *卡Bin匹配银行
         */
        qryBankBinSel : function(){
            transModel.qryBankBinInfo({
               "url" : "qryBankBinInfo",
               "data" : {},
               "callback" : function(response){
                    var bankBinList = response.object.bankBinList;
                    App.storage.set("bankBinList",bankBinList);
                },
                "errorCallback" : function(response){
                    utils.dialog.toast(response.message);
                }
            });
        },

        /**
         * 查询转账限额
         *
         */
        transLimmit : function(){
            transModel.qryTransferLimit({
                "url":"qryTransferLimit",
                "data":{},
                "callback": function(response){
                    App.storage.set("transferLimit",response.object);
                },
                "errorCallback":function(response){
                    utils.dialog.alert(response.message);
                }
             });
        },

         /**
         *
         * 转出查询出所需数据
         *
         */
        _transferOut : function(){
            var transferInAccNo = App.storage.get('UserInfo').attributes.accNumber;
            var self = this;

            // 缓存省份列表
            App.storage.set("provinceList", transferTools.getProvinceInfo);
            //查询卡Bin信息
            this.qryBankBinSel();
            //查询转账限额
            if(!App.storage.get("transferLimit")){
                this.transLimmit();
            }
            // 查询所有银行信息
            transModel.queryAllBankList({
                "url" : "queryAllBankList",
                "data" : {},
                "callback" : function(response){
                    // 缓存所有银行信息
                    App.storage.set("allBankList", response.object.bankList);
                    transModel.queryRealBankList({
                        "url" : "queryRealBankList",
                        "data" : {},
                        "callback" : function(response){
                            // 缓存所有支持实时转账的银行信息
                            App.storage.set("realBankList", response.object.bankList);
                            /**
                             * 新绑定借记卡来帐开关：1：开，不支持来帐，调用qryBindAccount;
                             *                     0：关，支持来帐，调用autoBindAccount
                             * ex_huanzit 2015-10-21
                             * */
                            var bindCardFlag = App.storage.get('UserInfo').get('bindCardFlag');
                            var url = '';
                            if(bindCardFlag && bindCardFlag == 1) url = 'qryBindAccount';
                            else url = 'autoBindAccount';

                            // 查询当前绑定的账户
                            transModel.qryBindAccount({
                                "url":url,
                                "data":{"channelType":"0"},
                                "callback": function(response){
                                    if(response.object.list==null || response.object.list.length==0){
                                        var accNo = App.storage.get("UserInfo").get("accNumber");
                                        App.navigate("me/transfer/assetsTransInUnbindAcc",true);
                                        return;
                                    }
                                    App.storage.set("bindAccount",response.object);
                                    // 查询余额
                                    accountModel.asycAccountInfo({
                                        "callback" :  function(response){
                                            App.storage.get("UserInfo").set("balance", response.object.balance);
                                            // 加载转账输入页面
                                            App.header.reset({
                                                title:"转出",
                                                leftButtonHandler : function() {
                                                    App.storage.remove("selectedAccount");
                                                    App.storage.remove("transferData");
                                                    App.storage.remove("openBankList");
                                                    App.storage.remove("bindAccount");
                                                    App.storage.remove("selectedBankInfo");
                                                    App.storage.remove("transfer_cityData");
                                                    App.storage.remove("transfer_bankBinItem");
                                                    //梦想立即提款返回梦想页面
                                                    if(App.storage.get("immediatelyTransfer")){
                                                        App.storage.remove("immediatelyTransfer");
                                                        App.navigate("dream/dream/myDream",true);
                                                    }else{
                                                        App.navigate("me/logined/index",true);
                                                    }
                                                },

                                                leftButtonContent:"@back"
                                            });

                                            App.footer.reset({
                                                visible : false
                                            });
                                            App.container.show(new transferView({"transferInAccNo":transferInAccNo}));

                                        },
                                        "errorCallback" : function(response){
                                            utils.dialog.alert(response.message);
                                        }
                                    });
                                },
                                "errorCallback":function(response){
                                    utils.dialog.alert(response.message);
                                }
                            });
                        },
                        "errorCallback" : function(response){
                            utils.dialog.alert(response.message);
                        }
                    });
                },
                "errorCallback" : function(response){
                    utils.dialog.alert(response.message);
                }
            });
        }

    });
});