/**
 * @ex_huangzit
 * 转账(转出)主控制器
 *
 */
define(function(require, exports, module){

	var assetsTransInView            = require("../view/transfer/assetsTransIn");
	var assetsTransInPattern         = require("../view/transfer/assetsTransInPattern");
	var assetsTransInSucc            = require("../view/transfer/assetsTransInSucc");
	var noCardCashView               = require("../view/noCardCash/noCardCashIndex");
	var noCardCashSuccView           = require("../view/noCardCash/noCardCashSucc");
	var assetsTransInUnbindAccView   = require("../view/transfer/assetsTransInUnbindAcc");
	var autheticationView            = require("../view/transfer/authetication");
	var autheticationForCFEView      = require("../view/transfer/autheticationForCFE");
	var autheticationForCFEFailView  = require("../view/transfer/autheticationForCFEFail");
	var autheticationForCFEOnWayView = require("../view/transfer/autheticationForCFEOnWay");
	var transModel                   = require("../model/transferModel");
	var noSurpportPayView            = require("../view/transfer/noSurpportPay");
	var nextTransInView              = require("../view/transfer/nextTransIn");
	var transInByYWT                 = require("../view/transfer/transInByYWT");
	var transInByYWTResult           = require("../view/transfer/transInByYWTResult");
	var accountInfoSta               = require("mod/common/accountInfoStatus/accountInfoStatus");
	var noCardCashValidateView       = require("../view/noCardCash/noCardCashValidate");

	var bindCardTip = require('component/bindCardTip');

	var transferController = module.exports = Controller.extend({
		actions: {
			"assetsTransIn"            :"_assetsTransIn",
			"toTransInPettern"         :"_toTransInPettern",
			"toTransInSucc"            :"_toTransInSucc",
			"noCardCashIndex"          :"_noCardCashIndex",
			"toNoCardCashSucc"         :"_toNoCardCashSucc",
			"assetsTransInUnbindAcc"   :"_toUnbindAccView",
			"authetication"            :"_authetication",
			"autheticationForCFE"      :"_autheticationForCFE",
			"noSurpportPay"            :"_noSurpportPay",
			"transferInNext"           :"_transferInNext",
			"transInByYWT"             :"_transInByYWT",
			"transInByYWTResult"       :"_transInByYWTResult",
			"toTransInPetternLossNet"  :"_toTransInPetternLossNet",
			"autheticationForCFEFail"  :"_autheticationForCFEFail",
			"autheticationForCFEOnWay" :"_autheticationForCFEOnWay"
		},

		/**
		 * @ex_huangzit 银网通代扣 2016-02-26
		 * 目前取消了平安付开关，查询绑定卡列表
		 */
		_assetsTransIn: function () {
			var self = this;
			transModel.qryAccList({
				url: "qryAccList",
				callback: function (resp) {
					var payAcclist = resp.object.payAcclist;
					// var bindAccLst = App.storage.get("transBindAccList");
					if (!payAcclist.length) {
						App.navigate('me/transferIn/noSurpportPay', true); //无数据这跳转到转入提示页中
						return;
					}
					//if (!bindAccLst) App.storage.set("transBindAccList", payAcclist);   //为展示绑定银行卡列表准备数据
					App.storage.set("transBindAccList", payAcclist)
					var bindCard = App.storage.get("payBankOptions");
					//if(!bindCard) bindCard = bindCard;
					self._setHeaderFooter({
						leftButtonHandler: function(){
							self._removeTempData();
							App.navigate("me/logined/index", true);
						}
					});
					utils.native.talkingDataTrackEvent("2.0转入第一步");
					App.container.show(new assetsTransInView({model:new Model({'bindCard':bindCard})}));
				},
				errorCallback: function (resp) {
					self.stateBackCall(resp);
				}
			});
		},

		//设置头部脚部
		_setHeaderFooter: function(options) {
			var defaults = _.extend({
				showFooter: false,
				title: '转入',
				leftButtonContent: "@back"
			}, options || {});
			App.header.reset(defaults);
			App.footer.reset({
				visible: defaults.showFooter,
				selectedIndex: 0
			});
		},

		//清空数据
		_removeTempData: function(){
			App.storage.remove("payBankOptions");
			App.storage.remove("transBindAccList");
		},

		//抛出异常错误信息
		stateBackCall: function (response) {
			var errorCode = response.code;
			if (errorCode == "01") { //未身份认证
				App.navigate("me/transferIn/authetication", true);
			} else if (errorCode == "02") { //同名来账激活
				App.navigate("me/transferIn/autheticationForCFE", true);
			} else if (errorCode == "03") { //无绑定账户
				var UserInfo = App.storage.get('UserInfo'),
					bindState = UserInfo.get('bindState'),
					cardState = UserInfo.get('cardState'),
					activeState = UserInfo.get('activeState');
				var bindCardFlag = App.storage.get('UserInfo').get('bindCardFlag');
				if (bindCardFlag === '1' && bindState === '0' && cardState === '1' && activeState === '1') {
					bindCardTip.activeSwitch();
				} else {
					App.navigate("me/transferIn/assetsTransInUnbindAcc", true);
				}
			} else if (errorCode == "04") { //绑定账户不支持代扣
				App.navigate('me/transferIn/noSurpportPay', true);
			} else if (errorCode == "05") { //验证方式是同名来账激活:待验证
				App.navigate("me/transferIn/autheticationForCFEOnWay", true);
			} else if (errorCode == "06") { //验证方式是同名来账激活:身份验证失败
				App.navigate("me/transferIn/autheticationForCFEFail", true);
			} else if (errorCode == "09") { //已挂失
				accountInfoSta.getAccountInfoLossStatus("me/logined/index");
			} else {
				utils.dialog.alert(response.message);
				App.navigate("me/logined/index", true);
			}
		},

		/**
		 * @ex_huangzit(2015-05-26)
		 * 转入方式
		 */
		_toTransInPettern:function(){
			App.header.reset({
				title : "选择支付方式",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					//App.storage.remove("payBankOptions");
					App.navigate('me/transferIn/assetsTransIn', true);
				}
			});
			App.footer.reset({visible:false, selectedIndex:0});
			var bindCard = App.storage.get("payBankOptions");
			var bindAccList = App.storage.get("transBindAccList");
			App.container.show(new assetsTransInPattern({model:new Model({"bindAccList":bindAccList, "bindCard":bindCard})}));
		},

		_toTransInPetternLossNet:function(){
			var self = this;
			App.header.reset({
				title : "转入",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					self._removeTempData();
					App.navigate("me/logined/index",true);
				}
			});
			App.footer.reset({visible:false, selectedIndex:0});
			App.container.show(new assetsTransInView());
		},

		/**
		 * @ex_huangzit(2015-06-03)
		 * 转入成功
		 */
		_toTransInSucc:function(){
			var self = this;
			var backUrl = App.storage.remove('transInSuccBackUrl') || 'me/logined/index';
			utils.native.talkingDataTrackEvent("2.0转入成功");
			App.header.reset({
				title : "转入结果",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					self._removeTempData();
					App.navigate(backUrl, true);
				}
			});
			App.footer.reset({visible:false, selectedIndex:0});
			App.container.show(new assetsTransInSucc());
		},

		/**
		 * @ex_huangzit(2015-06-04)
		 * 无卡取现
		 */
		_noCardCashIndex:function(){
			utils.native.talkingDataTrackEvent("2.0-我-无卡取现第一步");
			var dfd = accountInfoSta.getAccountInfoStatus(false,"me/logined/index");
			dfd.done(function(accountSta){
				if(accountSta){
					transModel.userVerifyMode({
						"url" : "userVerifyMode",
						"data" : {},
						"callback" : function(response) {
							App.header.reset({
								title : "无卡取现",
								leftButtonContent : "@back",
								leftButtonHandler : function(){
								   App.navigate("me/logined/index",true);
								}
							});
							App.footer.reset({visible:false, selectedIndex:0});
							/**
							 * 1-个人网银高级用户
							 * 2-身份证
							 * 3-借记卡
							 * 4-信用卡
							 * 5-CFE迁移过来的数据， 在CFE时验证方式为同名户验证。
							 * 6-历史数据修改， 迁移时存在一部分用户，他们的卡在卡管， FCR都已经激活，但在CFE为未激活状态。针对这类诡异数据，
							 * 	  无法给出相对应的激活方式，所以修改这些历史数据时激活方式置为6
							 * 7-汽融
							 * 8-人脸识别
							 * 9-柜面核身
							 */
							var verifyMode = response.object.verifyMode;
							if(verifyMode && verifyMode == "3"){
								App.container.show(new noCardCashView());
							}else{
								App.container.show(new noCardCashValidateView());
							}
						},
						"errorCallback" : function(response) {
							utils.dialog.alert(response.message);
						}
					});
				}
			});
		},

		//无卡取现成功页面
		_toNoCardCashSucc:function(){
			utils.native.talkingDataTrackEvent("2.0-我-无卡取现成功");
			App.header.reset({
				title : "无卡取现",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
				   App.navigate("me/logined/index",true);
				}
			});
			App.footer.reset({visible:false, selectedIndex:0});
			App.container.show(new noCardCashSuccView());
		},

		//展示未绑定列表
		_toUnbindAccView:function(){
			 App.header.reset({
				title : "转入",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.navigate('me/logined/index', true);
				}
			});
			App.footer.reset({visible:false, selectedIndex:0});
			App.container.show(new assetsTransInUnbindAccView());
		},

		//身份验证
		_authetication:function(){
			App.header.reset({
				title : "转入",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.navigate('me/logined/index', true);
				}
			});
			App.footer.reset({visible:false, selectedIndex:0});
			App.container.show(new autheticationView());
		},

		//不支持平安付提示页面
		_noSurpportPay:function(){
			App.header.reset({
				title : "转入",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.navigate('me/logined/index', true);
				}
			});
			App.footer.reset({visible:false, selectedIndex:0});
			App.container.show(new noSurpportPayView());
		},

		//本贷本输入密码页面
		_transferInNext:function(){
			App.header.reset({
				title : "转入",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.navigate('me/transferIn/assetsTransIn', true);
				}
			});
			var transferInData = App.storage.get("transferInData");
			App.footer.reset({visible:false, selectedIndex:0});
			App.container.show(new nextTransInView({model:new Model({"transferInData":transferInData})}));
		},

		//银网通代扣
		_transInByYWT : function(){
			this._setHeaderFooter({
				leftButtonHandler: function(){
					App.navigate('me/transferIn/assetsTransIn', true);
				}
			});
			var transferInData = App.storage.get("payBankOptions");
			App.container.show(new transInByYWT({model:new Model({"transferInData":transferInData})}));
		},

		//银网通代扣倒计时10S
		_transInByYWTResult:function(){
			var self = this;
			this._setHeaderFooter({
				leftButtonHandler: function(){
					self._removeTempData();
					App.navigate('me/transferIn/assetsTransIn', true);
				}
			});
			var result = App.storage.get("transYWT/dealStatus");
			App.container.show(new transInByYWTResult({model:new Model(result)}));
		},

		//财富E身份认证
		_autheticationForCFE : function(){
			var title = App.storage.remove("transOut_caifuE") ? '转出':'转入';
			App.header.reset({
				title : title,
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.navigate('me/logined/index', true);
				}
			});
			App.footer.reset({visible:false, selectedIndex:0});
			App.container.show(new autheticationForCFEView());
		},

		//财富E身份认证失败
		_autheticationForCFEFail : function(){
			App.header.reset({
				title : "转入",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.navigate('me/logined/index', true);
				}
			});
			App.footer.reset({visible:false, selectedIndex:0});
			App.container.show(new autheticationForCFEFailView());
		},

		//财富E身份认证在审核
		_autheticationForCFEOnWay : function(){
			App.header.reset({
				title : "转入",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.navigate('me/logined/index', true);
				}
			});
			App.footer.reset({visible:false, selectedIndex:0});
			App.container.show(new autheticationForCFEOnWayView());
		}
	});
});