define(function(require, exports, module) {

    var CreditPaymentModel = module.exports = Model.extend({});
    /**
     * 获取关联的信用卡列表，以及是否设置自动还款
     */
    CreditPaymentModel.relatingCreditCard = function() {
        return App.request("relatingCreditCard");
    };
    /**
     * 查询信用卡相关信息
     */
    CreditPaymentModel.queryCreditCardInfo = function(params) {
        return App.request('queryCreditCardInfo', {
            data: params
        });
    };

    /**
     * 查询转账交易限额
     */
    CreditPaymentModel.qryTransferLimit = function(params) {
        return App.request('qryTransferLimit', {
            data: params
        });
    };

    /**
     * 信用卡还款确认
     */
    CreditPaymentModel.creditCardRepayConfirm = function(params, callback) {
        App.request('creditCardRepayConfirm', {
            data: params,
            success: function(res) {
                callback && callback(res);
            },
            error: function(error) {
                utils.dialog.alert(error.message);
            }
        });
    };
    /**
     * 信用卡还款校验
     */
    CreditPaymentModel.creditCardRepayInput = function(options) {
        var params = options.params,
            callback = options.callback,
            errorCallback = options.errorCallback;
        
        App.request('creditCardRepayInput', {
            data: params,
            success: function(res) {
                callback && callback(res);
            },
            error: function(res) {
                errorCallback && errorCallback(res);
            }
        });
    };
});