define(function (require, exports, module) {

    var getErrorMessage = require("mod/me/common/lang");

    exports.otpVerifyEmail = function(password, callback){

        App.request("otpVerifyEmail", {
            data: { flag: "2", password: password },

            complete: function(err, rawResp){
                if(err) return callback(err);

                var response = rawResp.object, message;

                if(response.reFlag == "1") message = getErrorMessage("reset_trading_password:email_code_invalid");
                if(response.reFlag == "2") message = getErrorMessage("reset_trading_password:email_code_nonexistent");
                if(response.reFlag == "3") message = getErrorMessage("reset_trading_password:email_code_fail_time_overflow");

                if(message) return callback({ message: message });
                else callback(null, response);
            }
        });
    };

    exports.resetPassword = function(data, callback){

        App.request("rersetPassword", {
            data: data,
            complete: function(rawErr, rawResp){
                if(rawErr || rawResp.object.retCode != "0")
                    var err = { message: "重置密码失败，请重试" };
                callback(err);
            }
        });
    };
    
    exports.isExistHandPwd = function(options){
        return App.request("isExistHandPwd", {data: options});
    };
    
    exports.delHandPassWord = function(options){
        return App.request("delHandPassWord", {data: options});
    };
});