
define(function(require,exports,module){

    var PersonalModel = module.exports = Model.extend({
        
        modifyAccountGXInfo : function(params,callback){
           App.request('updateAccountGXInfo',{
                data : params,
                success : function(res){
                    callback(res);
                },
                error : function(error){
                    utils.dialog.alert(error.message);
                }               
           }); 
        },
        
        modifyAccountContactInfo : function(params,callback){
            App.request('updateAccountContactInfo',{
                data : params,
                success : function(res){
                    callback && callback(res);
                },
                error : function(error){
                    utils.dialog.alert(error.message);
                }                  
            });
        }
    });


    PersonalModel.getImagePath = function(options){
        if(!options) options = {};
        var settings      = {  };
        settings.silent   = options.silent || false;
        settings.success  = options.callback;
        settings.error    = options.errorCallback;
        settings.complete = options.complete;

        return App.request("getImagePath", settings);
    };

    PersonalModel.uploadConfirm = function(options){
        App.request("uploadPhotoConfirm", {
            data:options.param,
            success:function(response){
                options.success(response);
            },
            error:function(response){
                options.error(response);
            }
        });
    };

    PersonalModel.getIdentityCardNumber = function(callback){
        App.request("getIdentityCardNumber", {
            complete: function(err, resp){
                if(err) callback(err);
                else callback(null, resp.object.cardNo);
            }
        });
    };

    PersonalModel.cancelUpload=function(options){
        App.request("cancelUpload",{
            silent:true
        });
    };
    
    PersonalModel.getPersonalInfo = function(options){
        if(!options) options = {};

        var settings      = {  };
        settings.silent   = options.silent || false;
        settings.success  = options.callback;
        settings.error    = options.errorCallback;
        settings.complete = options.complete;

        return App.request("qryAccountBaseInfo", settings);
         
    };
    
    PersonalModel.checkEmail = function(options){
        if(!options) options = {};

        var settings      = {  };
        settings.silent   = options.silent || false;
        settings.success  = options.callback;
        settings.error    = options.errorCallback;
        settings.data     = options.params;
        settings.complete = options.complete;

        return App.request("checkEmailNo", settings);
    };
    
    PersonalModel.editEmailNo = function(option){
        var param         = option.param,
            errorCallback = option.errorCallback,
            callback      = option.callback;
            
        App.request("editEmailNo", {
            type    : "post",
            silent  : false,//true 不显示loading
            data    : param,
            success : function(resp){
                callback && callback(resp);
            },
            error   : function(resp){
                errorCallback && errorCallback(resp);
            }
        });
     };
    
    PersonalModel.uploadHeadPhotoApp = function(options){
        if(!options) options = {};

        var settings      = {  };
        settings.silent   = options.silent || false;
        settings.success  = options.callback;
        settings.error    = options.errorCallback;
        settings.data     = options.params;
        settings.complete = options.complete;

        return App.request("uploadHeadPhotoApp", settings);
    };
    
    PersonalModel.modifyMobCheckPassword = function(params,callback){
        App.request('modifyMobCheckPassword',{
            data : params,
            success : function(res){
                callback && callback(res);
            },
            error : function(error){
                utils.dialog.alert(error.message);
            }                  
        });
    };
    
    PersonalModel.verifyByPhoneNo=function(options){
        var url=config.urls.get("verifyByPhoneNo")+"/"+options.params.code+"/"+options.params.cat;
        App.request(url,{
            data:options.params,
            success:function(response){
                options.success(response);
            },
            error:function(){
                options.error();
            }
        });
    };
    
    PersonalModel.modifyMobCheckNewOtp=function(options){
       App.request("modifyMobCheckNewOtp",{
           data:options.params,
           success:function(response){
               options.success(response);
           },
           error:function(response){
               options.error(response);
           }
       });  
    };
    
    PersonalModel.resetMobCheckEmailCode=function(options){
       App.request("resetMobCheckEmailCode",{
           data:options.params,
           success:function(response){
               options.success(response);
           },
           error:function(response){
               options.error(response);
           }
       });  
    };
    
    PersonalModel.resetMobSubmit=function(options){
       App.request("resetMobSubmit",{
           data:options.params,
           success:function(response){
               options.success(response);
           },
           error:function(response){
               options.error(response);
           }
       });  
    };
    
    PersonalModel.checkUniqeMobile=function(options){
       App.request("checkUniqeMobile",{
           data:options.params,
           success:function(response){
               options.success(response);
           },
           error:function(response){
               options.error(response);
           }
       });  
    };
    
    PersonalModel.verifyByPhoneNo=function(options){
        var url=config.urls.get("verifyByPhoneNo")+"/"+options.params.code+"/"+options.params.cat;
        App.request(url,{
            data:options.params,
            success:function(response){
                options.success(response);
            },
            error:function(){
                options.error();
            }
        });
    };
    
    //预留信息
    PersonalModel.saveCustomerMessage = function(message, callback){
        return App.request("saveCustomerMessage",{
            data: { customerMsg: message },
            complete: callback
        });
    }
});

