 /**
 * @author zhoushiwen
 * @ date ${date}
 * @company 中国平安
 */ 
define(function (require, exports, module) {
    var securitySetModel = module.exports = Model.extend({}, {
        
        /**
         * 
         * 检查邮箱是否被占用
         * 
         */
        checkEmail: function(option){
            var param         = option.param,
                errorCallback = option.errorCallback,
                callback      = option.callback;
                
            App.request("checkEmailNo", {
                type    : "post",
                silent  : false,//true 不显示loading
                data    : param,
                success : function(resp){
                    callback && callback(resp);
                },
                error   : function(resp){
                    errorCallback && errorCallback(resp);
                }
            });
        },
        /**
         * 
         * 修改邮箱
         * 
         */
        editEmailNo: function(option){
            var param         = option.param,
                errorCallback = option.errorCallback,
                callback      = option.callback;
                
            App.request("editEmailNo", {
                type    : "post",
                silent  : false,//true 不显示loading
                data    : param,
                success : function(resp){
                    callback && callback(resp);
                },
                error   : function(resp){
                    errorCallback && errorCallback(resp);
                }
            });
        },
        
        /**
         * 
         * 验证邮箱-发送email到用户邮箱
         * 返回：email
         * 
         */
        mailVerificationSend: function(option){
            var param         = option.param,
                errorCallback = option.errorCallback,
                callback      = option.callback;
                
            App.request("mailVerificationSend", {
                type    : "post",
                silent  : false,//true 不显示loading
                data    : param,
                success : function(resp){
                    callback && callback(resp.object);
                },
                error   : function(resp){
                    errorCallback && errorCallback(resp);
                }
            });
        },
        /**
         * 
         * 验证邮箱-验证身份证后四位
         * 传入：
         *  randomNum   ：随机值
         *  identityFour：身份证后四位
         * 返回：
         *  email
         *  accNum
         * 
         */
        mailVerification: function(option){
            var param         = option.param,
                errorCallback = option.errorCallback,
                callback      = option.callback;
                
            App.request("mailVerification", {
                type    : "post",
                silent  : false,//true 不显示loading
                data    : param,
                success : function(resp){
                    callback && callback(resp);
                },
                error   : function(resp){
                    errorCallback && errorCallback(resp);
                }
            });
        },
        
        /**
         * 
         * 获取安全设置信息
         * 
         */
        settingSecurity: function(option){
            if(!option) option = {};
            
            var param         = option.param,
                silent        = option.silent || false,
                errorCallback = option.errorCallback,
                callback      = option.callback,
                complete      = option.complete;
                
            return App.request("settingSecurity", {
                type    : "post",
                silent  : silent,//true 不显示loading
                data    : param,
                success : function(resp){
                    callback && callback(resp);
                },
                error:function(resp){
                    errorCallback && errorCallback(resp);
                },
                complete: function(err, resp){
                    complete && complete(err, resp);
                }

            });
        },
        
        /**
         * 修改交易密码 
         */
        modifyTransferPwd: function(options){
            var params = options.params,
            callback = options.callback,
            errorCallback = options.errorCallback, 
            url = "modifyTransferPwd";
            
            App.request(url,{
                data : params,
                success : function(response){
                    callback(response);
                },
                error : function(response){
                    errorCallback(response);
                }
            });
        },
        
        /*
         * 
         * 重置交易密码
         * 
         */
        rersetPassword: function(options){
            var params = options.params,
            callback = options.callback,
            errorCallback = options.errorCallback, 
            url = "rersetPassword";
            
            App.request(url,{
                data : params,
                success : function(response){
                    callback(response);
                },
                error : function(response){
                    errorCallback(response);
                }
            });
        },
        
        
        
        
        /**
         * 可疑名单
         */
        checkAccountSuspicious: function(options){
            var callback = options.callback,
            errorCallback = options.errorCallback, 
            url = "checkAccountSuspicious";
            
            App.request(url,{
                success : function(response){
                    callback(response);
                },
                error : function(response){
                    errorCallback(response);
                }
            });
        }
        
    });

});