define(function (require, exports, module) {
    var TransModel = module.exports = Backbone.Model.extend({
        /**
         * 信托黄金宝,缺交易记录接口及详情数据
         */
        trustGoldTreasureInfo: function (options) {
            App.request("trustGoldTreasureInfo", {
                data: options.param,
                success: function (res) {
                    options.callback && options.callback(res);
                },
                error: function (error) {
                    utils.dialog.alert(error.message || error);
                    options.errCallback && options.errCallback(error);
                },
                complete: function () {
                    options.complete && options.complete();
                }
            });
        },

        /**
         * 基金成交记录（基金交易明细接口）
         */
        getFundTransactionInfo: function (options) {
            App.request("fundTradeDetailsInfo", {
                data: options.param,
                success: function (res) {
                    options.callback && options.callback(res);
                },
                error: function (error) {
                    utils.dialog.alert(error.message || error);
                    options.errCallback && options.errCallback(error);
                },
                complete: function () {
                    options.complete && options.complete();
                }
            });
        },

        /**
         * 获取平安盈交易记录
         */
        getPingAnYingInfo: function (options) {
            App.request("profitTransferQry", {
                data: options.param,
                success: function (res) {
                    options.callback && options.callback(res);
                },
                error: function (error) {
                    utils.dialog.alert(error.message || error);
                    options.errCallback && options.errCallback(error);
                },
                complete: function () {
                    options.complete && options.complete();
                }
            });
        },

        /**
         * 获取定活通交易记录
         */
        getDingHuoTongInfo: function (options) {
            App.request("precontractFixedCurrentTransferResultList", {
                data: options.param,
                success: function (res) {
                    options.callback && options.callback(res);
                },
                error: function (error) {
                    utils.dialog.alert(error.message || error);
                    options.errCallback && options.errCallback(error);
                },
                complete: function () {
                    options.complete && options.complete();
                }
            });
        },

        /**
         * 获取理财产品交易记录
         */
        getFinancialProInfo: function (options) {
            App.request("financeHistoryTradeQuery", {
                data: options.param,
                success: function (res) {
                    options.callback && options.callback(res);
                },
                error: function (error) {
                    utils.dialog.alert(error.message || error);
                    options.errCallback && options.errCallback(error);
                },
                complete: function () {
                    options.complete && options.complete();
                }
            });
        },

        /**
         * 获取平安票交易记录
         */
        getPanPiaoProInfo: function (options) {
            App.request("financeHistorPapiaoQry", {
                data: options.param,
                success: function (res) {
                    options.callback && options.callback(res);
                },
                error: function (error) {
                    utils.dialog.alert(error.message || error);
                    options.errCallback && options.errCallback(error);
                },
                complete: function () {
                    options.complete && options.complete();
                }
            });
        },

        /**
         * 获取养老产品交易记录
         */
        getYangLaoProInfo: function (options) {
            App.request("financeHistorPension", {
                data: options.param,
                success: function (res) {
                    options.callback && options.callback(res);
                },
                error: function (error) {
                    utils.dialog.alert(error.message || error);
                    options.errCallback && options.errCallback(error);
                },
                complete: function () {
                    options.complete && options.complete();
                }
            });
        },
        /**
        * 获取黄金产品交易记录
        */
        getGoldInfo: function (options) {
            App.request("qryGoldAcctDetail", {
                data: options.param,
                success: function (res) {
                    options.callback && options.callback(res);
                },
                error: function (error) {
                    utils.dialog.alert(error.message || error);
                    options.errCallback && options.errCallback(error);
                },
                complete: function () {
                    options.complete && options.complete();
                }
            });
        },
        /**
        * 获取智能定活通产品交易记录
        */
        getAutoDingHuoTong: function (options) {
            App.request("searchAccountDetail", {
                data: options.param,
                success: function (res) {
                    options.callback && options.callback(res);
                },
                error: function (error) {
                    utils.dialog.alert(error.message || error);
                    options.errCallback && options.errCallback(error);
                },
                complete: function () {
                    options.complete && options.complete();
                }
            });
        },
        /**
        * 获取基金品交易记录
        */
        getJiJinInfo: function (options) {
            App.request("qryGoldAcctDetail", {
                data: options.param,
                success: function (res) {
                    options.callback && options.callback(res);
                },
                error: function (error) {
                    utils.dialog.alert(error.message || error);
                    options.errCallback && options.errCallback(error);
                },
                complete: function () {
                    options.complete && options.complete();
                }
            });
        },

        /**
         * 获取E企盈交易记录
         */
        getBillInfo: function (options) {
            App.request("qryBillHistoryTrade", {
                data: options.param,
                success: function (res) {
                    options.callback && options.callback(res);
                },
                error: function (error) {
                    utils.dialog.alert(error.message || error);
                    options.errCallback && options.errCallback(error);
                },
                complete: function () {
                    options.complete && options.complete();
                }
            });
        },
        /**
        * 获取万里通交易记录
        */
        getWanlitong: function (options) {
            App.request("qryWanlitong", {
                data: options.param,
                success: function (res) {
                    options.callback && options.callback(res);
                },
                error: function (error) {
                    utils.dialog.alert(error.message || error);
                    options.errCallback && options.errCallback(error);
                },
                complete: function () {
                    options.complete && options.complete();
                }
            });
        },

        /**
        * 获取每日盈交易记录
        */
        fundStrong: function (options) {
            App.request("qryFundStrongRecord", {
                data: options.param,
                success: function (res) {
                    options.callback && options.callback(res);
                },
                error: function (error) {
                    utils.dialog.alert(error.message || error);
                    options.errCallback && options.errCallback(error);
                },
                complete: function () {
                    options.complete && options.complete();
                }
            });
        },
        //交易记录
        getTransferDetail: function (options) {
            App.request("queryTransferDetail", {
                data: options.param,
                success: function (res) {
                    options.callback && options.callback(res);
                },
                error: function (error) {
                    utils.dialog.alert(error.message || error);
                    options.errCallback && options.errCallback(error);
                },
                complete: function () {
                    options.complete && options.complete();
                }
            });
        },
        /**
         * 获取转账记录
         */
        getZhuanZhangInfo: function (options) {
            App.request("queryTransferResultOrder", {
                data: options.param,
                success: function (res) {
                    options.callback && options.callback(res);
                },
                error: function (error) {
                    utils.dialog.alert(error.message || error);
                    options.errCallback && options.errCallback(error);
                },
                complete: function () {
                    options.complete && options.complete();
                }
            });
        },

        getTransInInfo: function (options) {
            App.request("", {
                data: options.param,
                success: function (res) {
                    options.callback && options.callback(res);
                },
                error: function (error) {
                    utils.dialog.alert(error.message || error);
                    options.errCallback && options.errCallback(error);
                },
                complete: function () {
                    options.complete && options.complete();
                }
            });
        },

        /**
        * 无卡取现交易记录
        */
        qryBookingNocardRecordList: function (options) {
            App.request("qryBookingNocardRecordList", {
                data: options.param,
                success: function (res) {
                    options.callback && options.callback(res);
                },
                error: function (error) {
                    utils.dialog.alert(error.message || error);
                    options.errCallback && options.errCallback(error);
                },
                complete: function () {
                    options.complete && options.complete();
                }
            });
        },

        //银网通转入记录
        dealRecordTransferIn: function (options) {
            App.request("dealRecordTransferIn", {
                data: options.param,
                success: function (res) {
                    options.callback && options.callback(res);
                },
                error: function (error) {
                    utils.dialog.alert(error.message || error);
                    options.errCallback && options.errCallback(error);
                },
                complete: function () {
                    options.complete && options.complete();
                }
            });
        },
    });
});