/*
 * liujun
 * 自动还款设置头底
 */
define(function (require, exports, module) {
	var autoReplyHtml = require("text!../../template/accoutAndSecurity/autoReply.html");
	var bankManageModel = require("../../model/bankManage");
	var FormComponent = require("component/form");
	var CustomPwdInput = require("component/password/customPwdInput");
	module.exports = FormComponent.extend({
		template: _.template(autoReplyHtml),
		events: {
			"tap .autoReplyBtn": "autoReplyBtnChange",
			"tap .autoReply_btn": "autoReplyBtn",
			"tap .autoReplyType span": "selectedAutoReplyType",
			"tap .itemSwitch": "itemSwitch",
			"tap #creditAutoReplyAgreement": "creditAutoReplyAgreement",
			"tap #selectCreditCard": "selectCreditCard",
			"tap .creditCardList ul li": "creditCardListHandler"
		},

		autoReplyType: 0,
		selectedAutoReplyType: function (e) {
			var selectIndex = this.$(e.currentTarget).index();
			if (this.autoReplyType == selectIndex)
				return;
			this.$(".autoReplyType").find("i").eq(this.autoReplyType).removeClass("iconA107").addClass("iconA106");
			this.$(e.currentTarget).find("i").removeClass("iconA106").addClass("iconA107");
			this.autoReplyType = selectIndex;
		},

		itemSwitch: function (e) {
			var curr = e.currentTarget;
			var ele = this.$(curr).find("i").toggleClass("on");
			if (ele.hasClass("on")) {
				$('.autoReply_btn').children("input").removeClass("btn_disable").addClass("btn_orange");
			} else {
				$('.autoReply_btn').children("input").removeClass("btn_orange").addClass("btn_disable");
			}
		},

		//选择信用卡
		selectCreditCard: function (events) {
			this.$(".creditCardList").slideToggle(300);
		},

		creditCardListHandler: function (event) {
			this.$(".creditCardList").find("i").remove();
			this.$(event.target).append("<i class='iconA59'>");
			this.$(".creditCardList").slideUp(300, _.bind(function () {
				var cardNum = this.$(event.target).attr("data-acct");
				this.$("#cardNum").attr("data-acct", cardNum).text(utils.string.dealTheAccNo(cardNum));
			}, this));
		},

		//自动还款按钮开关
		autoReplyBtnChange: function (e) {
			var curr = e.currentTarget;
			this.$(curr).toggleClass("on");
			var status = this.model.get("status");
			if (!$(curr).hasClass("on") && status && status != 0 && status != 4 && status != 6) {
				utils.dialog.customDialog("请确认是否取消自动还款设置？", {
					title: "",
					okButtonText: "确认",
					cancelButtonText: "取消"
				}, _.bind(function (isOk) {
					if (isOk) {
						bankManageModel.autoReplySettingSwitch().done(_.bind(function () {
							utils.dialog.toast("取消自动还款设置成功！", function () {
								App.storage.remove("bankManageObj");
								App.navigate("me/logined/index", true);
							});
						}, this)).fail(function (error) {
							utils.dialog.toast(error.message);
						});
					} else {
						this.$(curr).addClass("on");
					}
				}, this));
			} else {
				this.$(curr).addClass("on");
			}
		},

		//自动还款按钮
		autoReplyBtn: function () {
			var _this = this;
			if ($(".autoReply_btn").children("input").hasClass("btn_orange")) {
				CustomPwdInput.customPwdInput(function (pwd, otp) {
					var dataArg = {};
					dataArg.repayType = _this.autoReplyType;
					if (_this.model.get("status") == "5") {
						dataArg.typeFlag = "1";
					} else {
						dataArg.typeFlag = "0";
					}
					dataArg.passwd = utils.crypto.RSAKey.encrypt(pwd, config.base.rsa_public_key);
					dataArg.sm2Pwd = utils.sm2.SM2Key.encrypt(pwd, config.base.sm2_public_key);
					bankManageModel.autoReplySetSubmit({
						data: dataArg,
						callback: function (res) {
							App.navigate("me/autoReply/autoReplySetSuccess", true);
						},
						errorCallback: function (err) {
							utils.dialog.toast(err.message);
						}
					});
				});
			}
		},

		creditAutoReplyAgreement: function () {
			//自动还款设置协议
			option = {
				title: '《自动还款业务服务责任条款》',
				url: config.urls.get("terms_of_service_creditCardPaymentBinding")
			};
			utils.window.open(option);
		}
	});
});