/*
*   银行卡管理
*   liujun
*/
define(function(require, exports, module){
    var bankManageHtml = require("text!../../template/accoutAndSecurity/bankManage.html");
    var bindCardView = require("../accoutAndSecurity/bindCard");
    var creditCardView = require("../accoutAndSecurity/creditCard");
    var bankManageModel = require("../../model/bankManage");
    var bankListModel = require("mod/me/model/transferModel");
    var fastAuthBindCardModel= require('mod/me/model/fastAuthBindCard');
    var FormComponent = require("component/form");

    var bindCardTip = require('component/bindCardTip');

    module.exports = FormComponent.extend({
        template: _.template(bankManageHtml),
        events: {
            "tap #bindCardTag": "bindCardTag",
            "tap #creditCardTag": "creditCardTag"
        },

        regions: {
            "bankManage": "#bankManage"
        },

        initialize: function(options){
            cardCode = options.code;
        },
        /*
        *  银行卡缓存不存在时候请求
        */
        onRender: function(){
            this.resetHeader();

            if(App.storage.get("bankManageObj")){
                if(cardCode == "bindCard"){
                    var bdata = App.storage.get("bankManageObj");
                    utils.native.talkingDataTrackEvent("2.0-我-账户与安全-银行卡管理-绑定借记卡");
                    this.bankManage.show(new bindCardView(bdata));
                }
                else if(cardCode == "creditCard"){
                    utils.native.talkingDataTrackEvent("2.0-我-账户与安全-银行卡管理-平安信用卡");
                    var cdata = App.storage.get("bankManageObj");
                    this.bankManage.show(new creditCardView(cdata));
                }
            }else{
                this.bankManageData();
            }
        },

        /*
        *  银行卡页面(借记卡、信用卡)
        */
        onShow: function(){
            var bindCardFlag = App.storage.get('UserInfo').get('bindCardFlag'); //新绑定借记卡开关 ex_huangzit 2015-12-21
            var accountNum = 3;
            var creditCardNum = '';
            if(bindCardFlag == 1) {
                accountNum = 5;
                creditCardNum = '/3';
            }

            if(App.storage.get("bankManageObj")){
                if(App.storage.get("bankManageObj").bindCardSum > accountNum){
                    $('#bindCardTag').html("绑定借记卡（"+ accountNum + "/" + accountNum +"）");
                }else{
                    $('#bindCardTag').html("绑定借记卡（"+ App.storage.get("bankManageObj").bindCardSum + "/" + accountNum + "）");
                }
                $('#creditCardTag').html("平安信用卡（"+ App.storage.get("bankManageObj").creditCardSum + creditCardNum + "）");
            }
            this._swipe();
        },

        /*
        *  swipe事件左右滑动切换页面块
        */
        _swipe: function(){
            $(document).swipe(function(){
                var lis = $('#bankManageSwipe > li');
                var id = lis.filter('.on').index();
                if(this.direction == 'left'){
                    if(id == 0){
                        lis.eq(1).trigger('tap');
                    }else{
                        lis.eq(0).trigger('tap');
                    }
                }else if(this.direction == 'right'){
                    if(id == 1){
                        lis.eq(0).trigger('tap');
                    }else{
                        lis.eq(1).trigger('tap');
                    }
                }
            });
        },

        onClose: function(){
            $(document)[0].swipe.destroy();
        },
        /*
        *  借记卡页面
        */
        bindCardTag: function(){
            App.navigate("me/accoutAndSecurity/bankManage/bindCard",true);
        },
        /*
        *  信用卡页面
        */
        creditCardTag: function(){
            App.navigate("me/accoutAndSecurity/bankManage/creditCard",true);
        },

        resetHeader: function () {
            var self = this;
            if(cardCode == "bindCard"){
                var bindCardFlag = App.storage.get('UserInfo').get('bindCardFlag');//新绑定借记卡开关 ex_huangzit 2015-12-21
                var options = {
                    title: "银行卡管理",
                    leftButtonContent : "@back",
                    leftButtonHandler : function(){
                        if(App.storage.get("bankManageObj")) App.storage.remove("bankManageObj");
                        App.navigate("me/accoutAndSecurity/index",true);
                    }
                };

                if(bindCardFlag == '1'){
                    utils.native.versionInformation(function(data) {
                        if (data.version.replace(/\./g, "") * 1 >= 209) {
                            options = _.extend(options, {rightButtonContent : "绑卡",
                                rightButtonHandler : function(){
                                    utils.native.talkingDataTrackEvent("2.0账户与安全-银行卡管理-新增绑卡");
                                    self.addBindCard();
                                }
                            });
                        } else {
                            options = _.extend(options, {rightButtonContent : "绑卡",
                                rightButtonHandler : function(){
                                    self.addBindCard();
                                }
                             });
                        }
                        App.header.reset(options);
                    });
                }
            }else if(cardCode == "creditCard"){
                App.header.reset({
                    title: "银行卡管理",
                    leftButtonContent : "@back",
                    leftButtonHandler : function(){
                        if(App.storage.get("bankManageObj")){
                            App.storage.remove("bankManageObj");
                        }
                        App.navigate("me/accoutAndSecurity/index",true);
                    },
                    rightButtonContent: null,
                    rightButtonHandler: null
                });
            }
        },

        addBindCard:function(){
            var bindCardList = App.storage.get("bankManageObj").bindCardList;

            App.storage.set("addBindCard/addMain", true);
            if (bindCardTip.newBindFlag()) {
                bindCardTip.activeSwitch();
                return;
            }

            var cardState = App.storage.get('UserInfo').get("cardState"); //审核中
            if(cardState === '3'){
                App.navigate("common/accountInfoCon/accountNoCard", true);
                return;
            }

            if(bindCardList.length >= 5){
                utils.dialog.toast('最多只能绑定5张借记卡');
                return;
            }

            App.navigate("verifyAccount/bindCard/inputBindCard",true);
        },

        bankManageData: function(){
            bObj = {};

            /**
             * 功能：银联鉴权-查询用户激活方式--userVerifyMode
	         * author:ex_huangzit
	         * time:2015-09-06
             */
            var promiseArr = [bankManageModel.creditCardData(),fastAuthBindCardModel.userVerifyMode()];
            var bindCardFlag = App.storage.get('UserInfo').get('bindCardFlag');//新绑定借记卡开关 ex_huangzit 2015-12-21
            var accountNum = 3;
            var creditCardNum = '';
            if(bindCardFlag == 1){//绑定借记卡开启
                //拼接函数(索引位置, 要删除元素的数量, 元素)
                promiseArr.splice(0, 0, bankManageModel.qryBindAccount()); //调用qryBindAccount
                accountNum = 5;
                creditCardNum = '/3';
            }else{
                promiseArr.splice(0, 0, bankManageModel.bindCardData()); //调用autoBindAccount
            }

            var promise = $.when.apply(0, promiseArr);

            promise.done(_.bind(function(arg1, arg2, arg3){
                bObj.bindCardSum    = arg1[0].object.list.length;
                bObj.bindCardList   = arg1[0].object.list;
                bObj.creditCardSum  = arg2[0].object.cardList.length;
                bObj.creditCardList = arg2[0].object.cardList;
                bObj.autoRepayNo    = arg2[0].object.autoRepayCardNo;
                bObj.status         = arg2[0].object.status;
                bObj.verifyMode     = arg3[0].object.verifyMode; //ex_huangzit:VerifyMode

                App.storage.set("changeBindCard_verifyMode", bObj.verifyMode);
                App.storage.set("bankManageObj", bObj);

                if(arg1[0].object.list.length > 0){
                    App.storage.get("UserInfo").set("bindState",1);
                }

                if(cardCode == "bindCard"){
                    this.bankManage.show(new bindCardView(bObj));
                }else if(cardCode == "creditCard"){
                    this.bankManage.show(new creditCardView(bObj));
                }

                if(bObj.bindCardSum > accountNum){
                    $('#bindCardTag').html("绑定借记卡（"+ accountNum +"/"+ accountNum +"）");
                }else{
                    $('#bindCardTag').html("绑定借记卡（"+bObj.bindCardSum + "/" + accountNum +"）");
                }

                $('#creditCardTag').html("平安信用卡（"+bObj.creditCardSum + creditCardNum + "）");

            },this));

            promise.fail(function(err){
                utils.dialog.alert(err.message);
            });
        }
    });
});