/*
*   银行卡管理-借记卡
*   liujun
*/
define(function(require, exports, module){
    var bindCardHtml  = require("text!../../template/accoutAndSecurity/bindCard.html");
    var bankManage    = require("../../model/bankManage");
    var transModel    = require("../../model/transferModel");
    var fastAuthBindCardModel = require('mod/me/model/fastAuthBindCard');
    var modifyBindCardPrompt  = require('../accoutAndSecurity/modifyBindCardPrompt');
    var IdentityModel = require("mod/verifyAccount/model/identityModel");
    //var CustomPwdOtpInput     = require("component/password/customPwdOtpInput");
    var CustomPwdInput = require("component/password/customPwdInput");
    var PTRScroll     = require('component/PTRScroll');
    var transferOutCom     = require("mod/common/transferOutCom/transferOutCom");

    var bindCardTip = require('component/bindCardTip');

    module.exports = ItemView.extend({
        template: _.template(bindCardHtml),
        events: {
            "tap .cancelBindCard": "cancelBindCard",
            "tap .transferIn" : "transferIn",
            "tap .transferOut" : "transferOut",
            "tap #CheckStatus": "CheckStatus",
            "tap .changeBindCard" : "modifyBindCard",
            "tap #faq":"bankfaq",
            'tap .unBindCard' : 'bindDecreditCard'
        },

        initialize: function(options){
            data = options;
            // console.log(options.bindCardSum);
            // this.displayHtml(options);
        },

        onRender: function(){

        },

        onShow: function(){
            var statusState = App.storage.get("UserInfo").get("cardState");
            var bindcardState = App.storage.get("UserInfo").get("bindState");
            var bindCardLen = data.bindCardSum;
            if(statusState == "1"){
                if(bindcardState == "1"){
                    if(bindCardLen >= 0){
                        this.initPTRScroll();
                    }
                }
            }
        },

        initPTRScroll: function(){
            // var self = this;
            var wHeight = $(window).height();
            var navHeight = App.header.$el.height();
            var listHeight = wHeight - navHeight;
            var dom = this.$('#bindCardScroll').css({"height": wHeight - 42,"position":"relative"});
            //初始化iscroller
            this.scroller = new PTRScroll(dom[0],{
                "hScroll"          : false,
                "vScrollbar"        : false,
                "checkDOMChanges"  : true,
                "hideScrollbar"    : true,
                "pullDownToRefresh" : false,
                "pullUpToLoadMore" : false
            });
        },

        CheckStatus: function(){
            App.navigate("verifyAccount/main/verify",true);
        },

        //新增绑定借记卡
        bindDecreditCard:function(){
            App.storage.set("addBindCard/addMain", true); //判断从‘我-银行卡管理’入口进入，不需要弹绑定提示框
            if (bindCardTip.newBindFlag()) {
                bindCardTip.activeSwitch();
                return;
            }

            //审核中的跳转到
            var cardState = App.storage.get('UserInfo').get('cardState');
            if(cardState === '3'){
                App.navigate("common/accountInfoCon/accountNoCard",true);
                return;
            }
            utils.native.talkingDataTrackEvent("2.0账户与安全-银行卡管理-新增绑卡");
            App.navigate("verifyAccount/bindCard/inputBindCard",true);
        },

        //取消绑定
        cancelBindCard: function(e){
            var bindCardFlag = App.storage.get('UserInfo').get('bindCardFlag');
            if(bindCardFlag === '1'){
                this.newCancelBind(e);
            }else{
                this.oldCancelBind(e)
            }
        },
        //老流程解绑
        oldCancelBind:function(e){
            var curr = e.currentTarget;
            var data = {};
            var orangeAccount = "";
            orangeAccount = App.storage.get("UserInfo").get("accNumber");
            var lastId = "";
            lastId = $(curr).attr("data-account").substring($(curr).attr("data-account").length - 4 );
            data.account = $(curr).attr("data-account");
            data.partyNo = $(curr).attr("data-partyno");
            //取消绑定借记卡入参，channelType渠道标识，partyNo客户号，account借记卡号
            utils.dialog.confirm(
                "您正在取消尾号"+lastId+"的平安银行借记卡与橙子账户（"+utils.string.formatAccount(orangeAccount)+"）的绑定。取消后平安橙子账户不能使用该借记卡进行交易。",
                function(e){
                    if(e == true){
                        bankManage.cancelBindCard({
                            data: data,
                            callback: function(res){
                                if(res.success){
                                    if(App.storage.get("bankManageObj")){
                                       App.storage.remove("bankManageObj");
                                    }
                                    App.reload();
                                }
                            },
                            errorCallback: function(err){
                                utils.dialog.alert(err.message);
                            }
                        });
                    }
                }
            );
        },

        //新流程解绑 ex_huangzit 2015-12-30
        newCancelBind:function(e){
            var account = $(e.currentTarget).attr("data-account");
            var bankName = $(e.currentTarget).attr("data-bankName");
            var message = "<div class='cardNo'>"+utils.string.formatAccount(account) +"</div><div class='cardCate'>"+ bankName +" 借记卡</div>";
            utils.dialog.customDialog(message, {okButtonText:'解绑借记卡', cancelButtonText:'取消', className:'cDialog', title:'解绑卡号'},
                function(ok){
                    if(ok){
                        IdentityModel.cancelBindCard({
                            "url" : "cancelBindCard",
                            "data": {account: account},
                            "callback": function(response){
                                if(App.storage.get("bankManageObj")) App.storage.remove("bankManageObj");
                                App.reload();
                            },
                            "errorCallback": function(response){
                                utils.dialog.alert(response.message);
                            }
                        });
                    }
             });

        },

        //转入
        transferIn: function(e){
            App.navigate("me/transferIn/assetsTransIn",true);
        },
        //转出
        transferOut: function(e){
            var curr = e.currentTarget;
            App.storage.set("me/accoutAndSecurity/bankManage/transferOut",$(curr).attr("data-account"));
        	App.storage.set("me/accoutAndSecurity/transferLimit/fromPage","me/accoutAndSecurity/bankManage/bindCard");
        	App.storage.set("transferLimitBack","me/accoutAndSecurity/bankManage/bindCard");
            //转出限额判断
            transferOutCom.assetsTransOut();
        },

        /**
         * 功能：银联鉴权-更换绑定卡
         * 1.先判断核版本号：203版本以上将该功能打开
         * 2.判断开关：isUse：1-前后台开启， 2-前台关闭后台开启， 0-前后台关闭
         * author:ex_huangzit
 		 * @param {Object} e:事件
         */
        modifyBindCard : function(e){
        	//var self = this;
            var curr = e.currentTarget;
            App.storage.set("changeOldAccNo",$(curr).attr("data-account"));
			this.qryBalanceForUnionPay();

            // utils.native.versionInformation(function(data){
                // var version = data.version.replace(/\./g,"") * 1;
                // if((IS_RUN_ON_ANDROID && version>203) || (IS_RUN_ON_IDEVICE && version>203)){
                    //银联鉴权开关
		            // IdentityModel.qryUseSwitch({
		            // 	url : "qryUseSwitch",
		            // 	data : {},
		            //     callback : function(res){
		            //     	if(res.object.isUse == '1'){
					//             App.storage.set("changeOldAccNo",$(curr).attr("data-account"));
					//             self.qryBalanceForUnionPay();
		            //     	}else{
		            //     		utils.dialog.toast("变更借记卡功能开关未开启！");//银联鉴权开关未开启
		            //     	}
		            //     },
		            //     errorCallback : function(res){
		            //         utils.dialog.alert(res.message);
		            //     }
		            // });
                // }else{
                	// utils.dialog.toast("变更借记卡功能开关未开启！");//银联鉴权开关未开启
                // }
            // });
        },


        /**
         * 功能：银联鉴权-查询资产
         * 查询当前余额和产品余额是否都为零，是这可以做银联鉴权-更换绑定卡操作，否则提示用户现有的金额等转到绑定的借记卡中
         * author:ex_huangzit
         */
        qryBalanceForUnionPay:function(){
        	var self = this;
        	var statusState = App.storage.get("UserInfo").get("cardState");
        	//激活
			if(statusState == "1"){
				//查询金额是否为0
				fastAuthBindCardModel.qryBalanceForUnionPay({
					url : "qryBalanceForUnionPay",
				    data: {},
	                callback: function(res){
	                	var currentAmount = res.object.currentAmount;//当前余额
	                	var totalInvestAmount = res.object.totalInvestAmount;//产品余额
	                	if(currentAmount == 0 && totalInvestAmount == 0){
	                		var options = {fastAuth:'changeBindCard'};//变卡标识
	                		App.storage.set('fastAuthBindCard/changeBindCard', options);
	                		//弹出密码和OTP框进行验密
	                		self.sendOTPandValidataPassOTP();

	                	}else{
	                	    App.header.reset({
                                title:"提示",
                                leftButtonHandler : function() {
                                    //App.navigate("me/accoutAndSecurity/bankManage/bindCard", true);
                                    App.reload();
                                },
                                leftButtonContent:"@back"
                            });
                            App.container.show(new modifyBindCardPrompt());
	                	}
	                },
	                errorCallback : function(res){
	                    utils.dialog.alert(res.message);
	                }
	           });
            }
       },

	    /**
	     * 功能：银联鉴权变更绑定卡-校验橙子密码和OTP
	     * author:ex_huangzit
	     */
       sendOTPandValidataPassOTP:function(){
       		//弹出密码框进行验密
             CustomPwdInput.customPwdInput(function (password) {
				var rsaPwd = utils.crypto.RSAKey.encrypt(password,config.base.rsa_public_key);
                var data = {"password":rsaPwd};
            	//调生成订单接口，该接口返回订单信息给前端
       			fastAuthBindCardModel.checkPassword({
	                "url" : "checkPassword",
	                "data": data,
	                "callback" : function(response){
	                    //跳到选择银行信息页面
	                     App.navigate('verifyAccount/main/toFastAuthView', true);
	                },
	                "errorCallback" : function(response){
	                    utils.dialog.alert(response.message);
	                }
	            });
			 });
       },
		//bankfaq
	   bankfaq:function(){
     		App.navigate('czFaq/faqIndex/czFaq/bankfaq', true);
       }
    });
});