define(function(require, exports, module){
	var securityOrangeHtml = require("text!../../template/accoutAndSecurity/securityOrange.html");
	var IdentityModel      = require("mod/verifyAccount/model/identityModel");
	var securitySetModel   = require("../../model/securitySet");
	module.exports = ItemView.extend({
		template: _.template(securityOrangeHtml),
		events: {
			"tap #immediately" : "jump",
			"tap #learn"       : "learn"
		},

		onShow: function(){
			this.orangeLevelWay();
		},
		orangeLevelWay: function(){
			var orangeLevel = 1;
			var activeState = App.storage.get("UserInfo").get("activeState");
			var cardState   = App.storage.get("UserInfo").get("cardState");
			var bindState   = App.storage.get("UserInfo").get("bindState");
			var mailState   = App.storage.get("UserInfo").get("mailState");
            var bindCardFlag   = App.storage.get("UserInfo").get("bindCardFlag");
			var activation  = 0;

			if(activeState == 1){
				orangeLevel+=1;
			}
			if(cardState == 1){
				orangeLevel+=1;
			}
			if(bindState == 1){
				orangeLevel+=1;
			}
			if(mailState == 1){
				orangeLevel+=1;
			}
			var accId = utils.string.formatAccount(App.storage.get("UserInfo").get("accNumber"));
			switch(orangeLevel){
				case 1:
					$("#lvText").html("为了您的账户安全，请尽快提升安全橙级");
					$("#immediately").val("立即升级");
					break;
				case 2:
					$("#lvText").html("完成身份认证即可升级，升级后可转入资金购买产品，体验精彩橙子！");
					$("#immediately").val("立即升级");
					break;
				case 3:
                    if(bindCardFlag == "1"){
                        $("#lvText").html("绑定本人实体借记卡即可升级。");
                    }else{
                        $("#lvText").html("绑定本人实体借记卡即可升级。请从你本人的其他任意银行账户向你的平安橙子账户（"+accId+"）转入任意金额资金，转入款项到账后并于90天内登录你的橙子账户，系统即可自动实现绑定。");
                    }
					$("#immediately").hide();
					break;
				case 4:
					if(bindState == 1){
						$("#lvText").html("验证邮箱即可升级，升级后可重置交易密码、重置手机号码。请先点击“立即验证邮箱”然后进入你的邮箱进行验证。");
						$("#immediately").val("立即验证邮箱");
					}else{
						if(bindCardFlag == "1"){
                            $("#lvText").html("绑定本人实体借记卡即可升级。");
                        }else{
                            $("#lvText").html("绑定本人实体借记卡即可升级。请从你本人的其他任意银行账户向你的平安橙子账户（"+accId+"）转入任意金额资金，转入款项到账后并于90天内登录你的橙子账户，系统即可自动实现绑定。");
                        }
						$("#immediately").hide();
					}
					break;
				case 5:
					$("#lvText").html("恭喜你，你已集齐5个橙子啦！请尽情体验吧！");
					$("#immediately").hide();
					break;
			}

			var html = document.createDocumentFragment();
			for(var i=0;i < orangeLevel;++i){
				var el = document.createElement("i");
				el.className = "iconA61 m_r10";
				html.appendChild(el);
			}
			$("#orangeLevel").html(html);
		},
		jump: function(){
			//进入身份认证流程页
			var activeState = App.storage.get("UserInfo").get("activeState");
			var cardState   = App.storage.get("UserInfo").get("cardState");
			var bindState   = App.storage.get("UserInfo").get("bindState");
			var mailState   = App.storage.get("UserInfo").get("mailState");
			if(mailState == 0 && activeState == 1 && cardState == 1 && bindState == 1){
				securitySetModel.mailVerificationSend({
					"param" : "",
					"errorCallback" : function(res){
						utils.dialog.alert(res.message);
					},
					"callback" : function(res){
						//var email = App.storage.get("UserInfo").get("email");
						utils.dialog.alert("验证邮件已发送到你的邮箱"+res.email+"，请在7天内验证。");
					}
				});
			}else{
				App.navigate("verifyAccount/main/verify",true);
			}
		},

		/**
		 * 了解安全橙级
		 */
		learn: function(){
			App.navigate("me/accoutAndSecurity/learnOrange",true);
		}
	});
});