/*
 *  转账限额
 *  liujun
 */
define(function (require, exports, module) {
    var transferLimitHtml = require("text!../../template/accoutAndSecurity/transferLimit.html");
    var CustomPwdOtpInput = require("component/password/customPwdOtpInput");
    var CustomPwdInput = require("component/password/customPwdInput");
    var safeKeyBoardHelper = require("component/customInput.helper");
    var bankManage = require("../../model/bankManage");
    module.exports = ItemView.extend({
        template: _.template(transferLimitHtml),
        events: {
            "tap #tranSwitch": "tranSwitchChange",
            // "tap .clearIpt": "clearIpt",
            "tap #LimitConfirm": "LimitConfirm",
            // "focus #limitIpt": "limitIpt",
            "customInputFocusIn #limitIpt input": "limitIpt",
            "input #limitIpt input": "limitIptKeyup",
            // "focusout #limitIpt": "limitIptFocusOut",
            "customInputFocusOut #limitIpt input": "limitIptFocusOut",
            "customInputFocusIn #limitIpt": "customInputFocusInLimitIpt",
            "customInputFocusOut #limitIpt": "customInputFocusOutLimitIpt"
        },
        initialize: function (options) {
            limitData = options;
        },
        onRender: function () {

        },
        onShow: function () {
            this._dhtInitAmountKeyboard();
            if (limitData.inUseFlag == "1") {
                listDataTemp = parseFloat(limitData.dailyLimit);
                listDataValue = parseFloat(limitData.dailyLimit);
                $("#limitIpt input").attr("data-temp", listDataTemp);
                $("#limitIpt input").val(listDataValue);
            }
        },
        //初始化键盘
        _dhtInitAmountKeyboard: function () {
            this.$("#limitIpt").customInput({
                type: "decimal",
                placeholder: "请输入转账限额",
                className: "safeKeyBoard",
                maxLength: "15"
            });
        },

        _delChange: function () {
            if ($("#limitIpt input").val() == "") {
                $("#limitIpt").find(".js-clear-icon").css({"visibility": "hidden"});
                $("#LimitConfirm").removeClass("btn_orange");
                $("#LimitConfirm").addClass("btn_disable");
            } else {
                $("#limitIpt").find(".js-clear-icon").css({"visibility": "visible"});
                $("#limitIpt").find(".js-clear-icon").css({"position": "absolute", "right": "10px", "top": "10px", "margin-right": "0px"});
            }
        },

        customInputFocusInLimitIpt: function () {
            safeKeyBoardHelper.focusIn({
                id: "limitIpt"
            });
            this._delChange();
        },

        _btnChange: function(){
            if($("#tranSwitch").hasClass("on")){
                if($("#limitIpt input").val() == "请输入转账限额"){
                    $("#LimitConfirm").removeClass("btn_orange");
                    $("#LimitConfirm").addClass("btn_disable");
                } else {
                    $("#LimitConfirm").removeClass("btn_disable");
                    $("#LimitConfirm").addClass("btn_orange");
                }
             }else{
                 $("#LimitConfirm").removeClass("btn_orange").addClass("btn_disable");
             } 
        },

        customInputFocusOutLimitIpt: function () {
            safeKeyBoardHelper.focusOut({
                id: "limitIpt"
            });
            this._btnChange();
        },
        //限额开关
        tranSwitchChange: function (e) {
            var curr = e.currentTarget;
            var switchState = null;
            if (App.storage.get("UserInfo").get("cardState") != "1") {
                utils.dialog.alert(
                    "请先完成身份认证，身份认证成功后再绑定本人实体借记卡即可设置转账限额。"
                );
            } else if (App.storage.get("UserInfo").get("bindState") != "1") {
                utils.dialog.alert(
                        "你未设置绑定账户，暂时无法修改转账限额。请用你的任意同名银行账户向你的平安橙子账户（" + utils.string.formatAccount(App.storage.get("UserInfo").get("accNumber")) + "）转一笔钱，资金到账且90天内登录平安橙子，即可完成绑定账户设置。"
                );
            } else {
                if ($(curr).hasClass("on")) {
                    switchState = "0";
                    if (App.storage.get("previousLimitData") != switchState) {
                        if ($('#limitIpt input').val().replace(/,/g, "") != "" && $('#limitIpt input').val().replace(/,/g, "") != "请输入转账限额" && $('#limitIpt input').val().replace(/,/g, "") != 0) {
                            if ($('#limitIpt input').val().replace(/,/g, "") > 5000000) {
                                utils.dialog.toast("每日限额不能大于系统限额！");
                            } else {
                                var data = {};
                                data.inUseFlag = "0";
                                data.dailyLimit = $('#limitIpt input').attr('data-temp');
                                data.commandType = "valid";
                                App.request("setTransferLimit", {
                                    data: data,
                                    success: function (res) {
                                        CustomPwdOtpInput.customPwdOtpInput({
                                            isSendOtp: true,
                                            isNeedSendOtpValidate: false,//是否调用otp接口校验otp密码（true：是，false：否）
                                            cat: config.values.transferLimit,
                                            callback: function (pwd, otp) {

                                                //密码成功，提交数据，跳转至成功页
                                                var dataArg = {};
                                                var type = "confirm";       //提交类型
                                                dataArg.inUseFlag = "0";
                                                dataArg.dailyLimit = $('#limitIpt input').attr('data-temp');
                                                dataArg.commandType = type;
                                                dataArg.password = utils.crypto.RSAKey.encrypt(pwd, config.base.rsa_public_key);
                                                dataArg.sm2Pwd = utils.sm2.SM2Key.encrypt(pwd, config.base.sm2.publicId);
                                                dataArg.otp = otp;
                                                bankManage.setTransLimit({
                                                    data: dataArg,
                                                    callback: function (res) {
                                                        App.storage.remove("previousLimitData");
                                                        utils.dialog.toast("转账限额成功关闭");
                                                        App.reload();
                                                    },
                                                    errorCallback: function (err) {
                                                        //提交失败
                                                        utils.dialog.alert(err.message);
                                                    }
                                                });
                                            }
                                        });
                                    },
                                    error: function (err) {
                                        utils.dialog.alert(err.message);
                                    }
                                });
                            }
                        } else {
                            utils.dialog.toast("请输入转账限额");
                        }
                    } else {
                        $('#tranNumber').css("border-bottom", "none");
                        $('#tranSwitch').removeClass("on");
                        $('#dayLimit').css("display", "none");
                        $('#LimitConfirm').removeClass("btn_orange").addClass("btn_disable");
                    }

                } else {
                    $(curr).addClass("on");
                    $('#dayLimit').css("display", "auto");
                    $('#tranNumber').css("border", "auto");
                    if ($("#limitIpt input").val()) {
                        $('#LimitConfirm').removeClass("btn_disable").addClass("btn_orange");
                    } else {
                        $('#LimitConfirm').removeClass("btn_orange").addClass("btn_disable");
                    }
                }
            }
        },

        //限额输入框
        limitIpt: function (e) {
            var curr = e.currentTarget;
            var reg = /^[0-9]+(\.)?[0-9]{0,2}$/;
            // if($(curr).val() != "" && reg.test($(curr).val())){
            // $(curr).val($(curr).attr("data-temp"));
            // } 
            if ($(curr).attr("data-temp") != "") {
                $(curr).val(parseFloat($(curr).attr("data-temp")));
                // $(".clearIpt").css("visibility","visible");
                $("#LimitConfirm").removeClass("btn_disable");
                $("#LimitConfirm").addClass("btn_orange");
            } else {
                $(curr).val(null);
            }
        },
        limitIptKeyup: function (e) {
            var curr = e.currentTarget;
            var reg = /^[0-9]+(\.)?[0-9]{0,2}$/;
            var reg0 = /^(0){2,}$/;
            if (reg.test($(curr).val().replace(/,/g, ""))) {
                if (reg0.test($(curr).val().replace(/,/g, ""))) {
                    utils.dialog.toast("请正确输入限额");
                    $(curr).val(null);
                    // $(".clearIpt").css("visibility","hidden");
                    $("#LimitConfirm").removeClass("btn_orange");
                    $("#LimitConfirm").addClass("btn_disable");
                    // console.log(0);
                } else {
                    // $(".clearIpt").css("visibility","visible");
                    $("#LimitConfirm").removeClass("btn_disable");
                    $("#LimitConfirm").addClass("btn_orange");
                    $(curr).attr("data-temp", parseFloat($(curr).val().replace(/,/g, "")).toFixed(2));
                    // console.log(1);
                }
                // $(curr).val(utils.string.formatMoneyNumber($(curr).val()));      
            } else if ($(curr).val().replace(/,/g, "") != null) {
                if ($(curr).val().replace(/,/g, "")) {
                    utils.dialog.toast("请正确输入限额");
                    $(curr).val(null);
                    // $(".clearIpt").css("visibility","hidden");
                    $("#LimitConfirm").removeClass("btn_orange");
                    $("#LimitConfirm").addClass("btn_disable");
                } else {
                    $(curr).attr("data-temp", "");
                    // $(".clearIpt").css("visibility","hidden");
                    $("#LimitConfirm").removeClass("btn_orange");
                    $("#LimitConfirm").addClass("btn_disable");
                }

            }
            else {
                // console.log(4);
            }

        },
        limitIptFocusOut: function (e) {
            var curr = e.currentTarget;
            var reg = /^[0-9]+(\.)?[0-9]{0,2}$/;
            if ($(curr).val().replace(/,/g, "") != "" && reg.test($(curr).val().replace(/,/g, ""))) {
                if ($(curr).val().replace(/,/g, "") > 5000000) {
                    utils.dialog.toast("每日限额不能大于系统限额！");
                } else {
                    $(curr).attr("data-temp", parseFloat($(curr).val().replace(/,/g, "")).toFixed(2));
                }
            }

        },
        //限额提交
        LimitConfirm: function (e) {
            var curr = e.currentTarget;
            var data = {};
            if ($(curr).hasClass("btn_orange")) {
                setTimeout(function () {
                    if ($('#limitIpt input').val().replace(/,/g, "") != "" && $('#limitIpt input').val().replace(/,/g, "") != 0 && $('#limitIpt input').val().replace(/,/g, "") != "请输入转账限额") {
                        if ($('#limitIpt input').val().replace(/,/g, "") > 5000000) {
                            utils.dialog.toast("每日限额不能大于系统限额！");
                        } else {
                            data.inUseFlag = "1";
                            data.dailyLimit = parseFloat($('#limitIpt input').attr('data-temp')).toFixed(2);
                            data.commandType = "valid";
                            App.request("setTransferLimit", {
                                data: data,
                                success: function (res) {
                                    CustomPwdOtpInput.customPwdOtpInput({
                                        isSendOtp: true,
                                        isNeedSendOtpValidate: false,//是否调用otp接口校验otp密码（true：是，false：否）
                                        cat: config.values.transferLimit,//cat
                                        callback: function (pwd, otp) {
                                            //密码成功，提交数据，跳转至成功页
                                            var dataArg = {};
                                            var type = "confirm";       //提交类型
                                            dataArg.inUseFlag = "1";
                                            dataArg.dailyLimit = parseFloat($('#limitIpt input').attr('data-temp'));
                                            dataArg.password = utils.crypto.RSAKey.encrypt(pwd, config.base.rsa_public_key);
                                            dataArg.sm2Pwd = utils.sm2.SM2Key.encrypt(pwd, config.base.sm2_public_key);
                                            dataArg.otp = otp;
                                            dataArg.commandType = type;
                                            bankManage.setTransLimit({
                                                data: dataArg,
                                                callback: function (res) {
                                                    App.storage.remove("previousLimitData");
                                                    App.navigate("me/accoutAndSecurity/transferLimitSuccess", true);
                                                },
                                                errorCallback: function (err) {
                                                    //提交失败
                                                    utils.dialog.alert(err.message);
                                                }
                                            });
                                        }
                                    });
                                },
                                error: function (err) {
                                    utils.dialog.alert(err.message);
                                }
                            });
                        }
                    } else {
                        utils.dialog.toast("输入限额为空");
                    }
                }, 220);
            }
        }
    });
});