define(function(require, exports, module) {
	var selectpayBackTypeTpl = require("text!../../template/creditCard/selectPayBackType.html");
	var FormComponent        = require("component/form");
	var safeKeyBoardHelper   = require("component/customInput.helper");
	module.exports = FormComponent.extend({
		template: _.template(selectpayBackTypeTpl),
		events: {
			"tap #fullAmount"   : "fullAmount",
			"tap #customAmount" : "customAmount",
			"tap #minAmount"    : "minAmount"
		},
		initialize: function(options) {

		},
		onShow: function() {
			this.showSafeKeyBoardAmount();

			tempPayBackMark = App.storage.get("payBackType");
			if(tempPayBackMark == 1) {
				$("#fullAmount").append('<i class="iconA59"></i>');
			}else if (tempPayBackMark == 3) {
				$("#customAmount").append('<i class="iconA59"></i>');
				$("#customAmo").show();
				var amt = App.storage.get("customPaybackAmount");
                if(amt){
                    this.$("#repayAmount").customInput("setValue",amt);
                }
			}else if (tempPayBackMark == 2) {
				$("#minAmount").append('<i class="iconA59"></i>');
			}else if (tempPayBackMark == undefined) {
				alert("还款类型未定义");
			}
		},

		showSafeKeyBoardAmount:function(){
            this.$("#repayAmount").customInput({
               type: "decimal",
               placeholder: "请输入还款金额",
               maxLength: 12,
               className:"safeKeyBoard"
            });
        },

        customInputFocusInAmount:function(){
            safeKeyBoardHelper.focusIn({
                id:"repayAmount"
            });
            // var el=safeKeyBoardHelper.getSelector("repayAmount");
            // el.addClass("focusBlue");
        },
        customInputFocusOutAmount:function(){
            safeKeyBoardHelper.focusOut({
                id:"repayAmount"
            });
            // var el=safeKeyBoardHelper.getSelector("repayAmount");
            // el.removeClass("focusBlue");
        },

		//全额还款
		fullAmount: function() {
			App.storage.set("payBackType", "1");
			// App.storage.set("payBackName","全额还款:");
			App.navigate('me/creditCard/payBack', true);
		},
		//最低还款
		minAmount: function() {
			App.storage.set("payBackType", "2");
			// App.storage.set("payBackName","最低还款:");
			App.navigate('me/creditCard/payBack', true);
		},
		//自定义还款
		customAmount: function() {
			App.storage.set("payBackType", "3");
			// App.storage.set("payBackName","自定义:");
			$(".iconA59").remove();
			$("#customAmount").append('<i class="iconA59"></i>');
			$("#customAmo").show();
		}
	});
});