define(function(require, exports, module){
	var PTRScroll = require("component/PTRScroll");
	var indexTpl = require("text!../../template/friendsRecommend/friendsRecommendList.html");
	var RecommendItemTpl = require("text!../../template/friendsRecommend/recommendItem.html");
	var friendsRecommendModel = require("../../model/friendsRecommend");
	
	module.exports = ItemView.extend({
		template: _.template(indexTpl),
		initialize:function(){
			this.pageIndex = 1;
		},
		onShow : function() {
			var options = {
        		activityId:App.storage.get("friendsRecommend/activityId"),
        		activityFlag:0, 
        		pageSize:10, 
        		pageIndex:1
        	};
			friendsRecommendModel.qryActivityList(options).done(_.bind(function(res){
                this.totalPage = Math.ceil(res.object.totalRows/res.object.pageSize);
                var html = _.template(RecommendItemTpl,res.object.recommendList);
                this.$("#recommendList").html(html);
                var recommendNum = res.object.totalRows || "0";
                this.$("#friendsNum").text(recommendNum);
                var authenFriend = res.object.verifyRows || "0";
                this.$("#authenFriend").text(authenFriend);
                this._initPTRScroll();
            },this)).fail(function(error){
                utisl.dialog.alert(error.message);
            });

		},
		
		//查询活动数据
		_qryActivityList:function(options, refresh){
			 friendsRecommendModel.qryActivityList(options).done(_.bind(function(res){
                this.totalPage = Math.ceil(res.object.totalRows/res.object.pageSize);
                if(options.pageIndex == 1){
                	this.$("#recommendList").html("");
                }
                var html = _.template(RecommendItemTpl,res.object.recommendList);
                this.$("#recommendList").append(html);
                
                //最后一页禁用上拉刷新
                if (this.pageIndex >= this.totalPage) {
                    this.scroller.disablePullUpToLoadMore();
                }else {
                    this.scroller.enablePullUpToLoadMore();
                }
                //第一页禁用下拉刷新
                if (this.totalPage == "1" || this.totalPage == "0") {
                    this.scroller.disablePullUpToLoadMore();
                }else {
                    this.scroller.enablePullUpToLoadMore();
                }
                refresh();
                
            },this)).fail(function(error){
                utisl.dialog.alert(error.message);
            });
		},
		
		 //初始化上下拉
        _initPTRScroll : function(){
        	var self = this;
            if (this.scroller) {
            	this.scroller.destroy();
            	delete this.scroller;
            };
            
            var listHeight = $(window).height() - 140;
            var dom = this.$("#drawalRecords").css({"height":listHeight,"position":"relative"});

            //初始化iscroller
            this.scroller = new PTRScroll(dom[0],{
                "hScroll"           : false,
                "hideScrollbar"     : false,
                "vScrollbar"        : true,
                "pullDownToRefresh" : true,
                "pullUpToLoadMore"  : true
            });

			if (this.totalPage == "1" || this.totalPage == "0") {
                this.scroller.disablePullUpToLoadMore();
            }else {
                this.scroller.enablePullUpToLoadMore();
            }
            
            //下拉刷新
            self.scroller.options.refreshContent = function(refresh){
            	self.pageIndex = 1;
                self._refreshContent(refresh, self.pageIndex);
            };

            //上拉加载
            this.scroller.options.loadMoreContent = function(refresh){
            	self.pageIndex++;
                self._loadMoreContent(refresh, self.pageIndex);
            };
        },
        
        //下拉请求数据
        _refreshContent:function(refresh, pageIndex){
        	//请求数据
        	var options = {
        		activityId:App.storage.get("friendsRecommend/activityId"),
        		activityFlag:0, 
        		pageSize:10, 
        		pageIndex:pageIndex
        	};
        	this._qryActivityList(options, refresh);
        },
        
        //上拉请求数据
        _loadMoreContent:function(refresh, pageIndex){
        	//请求数据
        	var options = {
        		activityId:App.storage.get("friendsRecommend/activityId"),
        		activityFlag:0, 
        		pageSize:10, 
        		pageIndex:pageIndex
        	};
        	this._qryActivityList(options, refresh);
        }
	});
});