define(function(require, exports, module){
	var indexTpl = require("text!../../template/friendsRecommend/index.html");
	var friendsRecommendModel = require("../../model/friendsRecommend");
	
	module.exports = ItemView.extend({
		template: _.template(indexTpl),
		events: {
			"tap [share]" : "_toIosApp",
            "tap #android-share-btn" : "_toAndroidApp",
            "tap #showFriendsNum" : "_friendsRecommendList"
		},
		onShow : function() {
			var self = this;
            var promise=$.when(
            	friendsRecommendModel.activityDetail(),//查询活动信息
            	friendsRecommendModel.qryActivityList() //查询好友列表
            );
            promise.done(function(arg1, arg2){
            	//图像信息
            	self._showImageInfo(arg1[0].object);
            	//好友信息
            	self._showFriendInfo(arg2[0].object);
            	
            	//andriod和IOS分享方式不同
            	if(IS_RUN_ON_ANDROID){
            		self.$('#android-share-btn-div').show();
        			self.$('#iosShare').hide();
            	}else if(IS_RUN_ON_IDEVICE){
            		self.$('#iosShare').show();
        			self.$('#android-share-btn-div').hide();
            	}
            });
            promise.fail(function(err){
                utils.dialog.alert(err.message);
            });
		},
		
		//好友信息
		_showFriendInfo:function(object){
			var friendNum = object.totalRows;//好友个数
			var authenFriend = object.verifyRows || "0" ;//认证好友个数
        	var recommendList = object.recommendList;//好友列表
        	App.storage.set("friendsRecommend/qryActivityList", object);
        	
        	if(friendNum && friendNum > 0){
        		this.$('#showFriendsNum').show();
        		this.$('#notFriendsNum').hide();
        		this.$('#friendsNum').text(friendNum);
        		this.$('#authenFriend').text(authenFriend);
        	}else{
        		this.$('#showFriendsNum').hide();
        		this.$('#notFriendsNum').show();
        	}
		},
		
		//图像信息
		_showImageInfo:function(object){
            this.mobileRecommendUrl = object.mobileRecommendUrl+"?groomCode="+ object.groomCode || "";
			this.containLinksText = object.containLinksText || "";
            //this.mobileRecommendUrl = encodeURIComponent(mobileRecommendUrl);
            this.computerImgUrl = object.computerImgUrl || "";
            this.groomCodeImgUrl = object.groomCodeImgUrl || "";
            this.message = this.containLinksText + this.mobileRecommendUrl;
            var activityId = object.activityId;
            App.storage.set("friendsRecommend/activityId", activityId);
            
            this.$('#groomCode').text(object.groomCode);//推荐码
            var img = $("<img style='width:100px;'/>");
            img.on("load",_.bind(function(){
                this.$("#groomCodeImg").html(img);
                this.$("#groomCodeImg").append('<i class="faiCon fytjIcons" style="bottom: 10px;"></i>')
            },this));
            img.attr("src",this.groomCodeImgUrl);    
		},
		
		//IOS
		_toIosApp : function(eve){
            var type = this.$(eve.currentTarget).attr("share");
            //缓存分享信息
            App.storage.set("shareWLTData",{"share_module":config.values.shareFriends,"share_url":encodeURIComponent(this.mobileRecommendUrl)});
            utils.native.SharePlugin({"type":type,"message":this.message});
            
        },
        
        //Android
        _toAndroidApp : function(){
            var self = this;
            //缓存分享信息
            App.storage.set("shareWLTData",{"share_module":config.values.shareFriends,"share_url":encodeURIComponent(this.mobileRecommendUrl)});
            utils.native.versionInformation(function(data){
                var version = data.version.replace(/\./g,"") * 1;
                if(IS_RUN_ON_ANDROID && version >= 210){
                    utils.native.shareProduct({
                        "title" : "平安橙子",
                        "message": self.containLinksText,
                        "type" : 1,
                        "url": self.mobileRecommendUrl
                    });
                }else{
                    utils.native.SharePlugin({"type":0,"message":self.message});
                }
            });
            
        },
        
        //
        getBase64 : function(url){
            var deferred = $.Deferred();
            if(!url){
                deferred.reject();  
            }else{
                var img = new Image();
                img.src = url;
                img.onload=function(){
                    var canvas = document.createElement("canvas");
                    canvas.width=img.width;
                    canvas.height=img.height;
                    var context = canvas.getContext("2d");
                    context.drawImage(img,0,0);
                    deferred.resolve(canvas.toDataURL());
                };
                img.onerror = function(){
                    img.src="";
                    img.onerror = null;
                    deferred.resolve(""); 
                };                 
            }
            return deferred;
        },
        
        //好友列表
        _friendsRecommendList:function(){
        	App.navigate("me/friendsRecommend/friendsRecommendList",true);
        }
	});
});