define(function(require, exports, module){
	var unlogin = require("text!../template/unlogin.html");
	var financialAchievement = require("mod/financialAchievement/model/financialAchievement");
	module.exports = ItemView.extend({
		template: _.template(unlogin),
		events: {
			"tap #creditCardBill"                  :"_creditCardBill",
			"tap #wanlitong"                       :"wanlitong",
			"tap #unlogin"                         : "unloginProcess",
			"tap #unlogin_balance"                 : "unlogin_balance",
			"tap #tradeecordsinfo"                 : "_tradeRecords",
			"tap .unlogin_my_orange .transfer_in"  : "unloginTransferIn",
			"tap .unlogin_my_orange .transfer_out" : "unloginTransferOut",
			"tap .unlogin_my_orange .NoCard_Cash"  : "unloginNoCardCash",
			"tap .unlogin_my_orange .my_property"  : "unloginMyProperty",
			"tap .unlogin_my_orange .expect_earn"  : "unloginExpectEarn",
			"tap #friendsRecommend"                : "unloginFriendsRecommend",
			"tap #financialAchievement"            : "_financialAchievement",   //理财成就（ex_huangzit 2016-05-05）
			"tap #fundManage"                      : "unFundManage"             //基金定投管理
		},

		onShow: function(){
			this._medalAndWanlitongSwitch();
			this._showFriendCommend();//根据IOS版本号是否展示"好友推荐"
		},

		/**
		 *根据IOS版本号是否展示"好友推荐"
		 */
		_showFriendCommend:function(){
			var self = this;
			//根据版本号判断是否显示隐藏好友推荐
			utils.native.versionInformation(function(data){
				var version = data.version.replace(/\./g,"") * 1;
				if(IS_RUN_ON_IDEVICE){
					if(version <= 201){
						//隐藏‘好友推荐’
						self.$("#friendsRecommend").hide();
					}else{
						//显示‘好友推荐’
						self.$("#friendsRecommend").show();
					}
				}
			});
		},

		_medalAndWanlitongSwitch: function(){
            var _this = this;
			financialAchievement.medalAndWanlitongSwitch({
				url: "medalAndWanlitongSwitch",
				silent : true,
				callback: function(res){
					if(res.object.fundSwitch === 'on') _this.$('#financialAchievement').show();
				},
				errorCallback: function(res){
					utils.dialog.alert(res.message);
				}
			});
		},

		//未登录去向url
		//未登录，点击之后进行登录，登录完在已登录
		unloginProcess: function(){
			// App.navigate("login/login/toaIndex",true);
			App.navigate("me/logined/index",true);
		},
		unlogin_balance: function(){
			App.navigate('me/balance/index',true);
		},

		/**
		 *@ex_huangzit
		 * me首页中单击转入按钮跳转到转入首页
		 */
		unloginTransferIn: function(){
			App.navigate('me/transferIn/assetsTransIn',true);
		},
		unloginTransferOut: function(){
			//转账限额弹框‘取消’返回页面
			App.storage.set("transferLimitBack","me/logined/index");
			if (!App.storage.get("isUserLoggedIn")) {
				App.navigate(config.base.login_url + "?returnURL=" + "me/logined/index", true);
				return;
			}
		},

		/**
		 *@ex_huangzit
		 * me首页中单击转入按钮跳转到无卡取现
		 */
		unloginNoCardCash: function(){
			App.navigate('me/transferIn/noCardCashIndex',true);
		},

		unloginMyProperty: function(){
			App.navigate('myProperty/myProperty/index',{
				trigger: true,
				replace: true
			});
		},

		unloginFriendsRecommend: function(){
			App.navigate('me/friendsRecommend/index',{
				trigger: true,
				replace: true
			});
		},
		//跳转到信用卡还款
		_creditCardBill : function(){
			App.navigate('me/creditCard/payBack',true);
		},
		/**
		 * 获取万里通积分
		 */
		wanlitong: function(){
			App.navigate('wanlitong/wanlitong/index', true);
		},
		//交易记录
		_tradeRecords:function() {
			App.navigate('me/tradeRecords/index/'+config.values.jiaoYiJiLu+"?"+Date.parse(new Date()),{
				trigger: true,
				replace: true
			});
		},

		//我的定投
		unFundManage : function(){
			App.navigate("fund/fundFixedIndex/index",true);
		},

		//理财成就（ex_huangzit 2016-05-05）
		_financialAchievement : function(){
			App.navigate("financialAchievement/financialAchievement/index",true);
		}
	});
});