define(function(require, exports, module){
	var logined            = require("text!../template/logined.html");
	var loginedAccountInfo = require("../model/loginedAccountInfo");
	var transModel         = require("../model/transferModel");
	var accountInfoSta     = require("mod/common/accountInfoStatus/accountInfoStatus");
	var transferOutCom     = require("mod/common/transferOutCom/transferOutCom");
	var bindCardTip        = require('component/bindCardTip');
	var PTRScroll          = require("component/PTRScroll");
	var faceRecognition    = require("component/faceRecognition");
	var loanModel          = require("mod/loan/model/loanModel");
	var financialAchievement = require("mod/financialAchievement/model/financialAchievement");
	module.exports = ItemView.extend({
		template: _.template(logined),
		events: {
			"tap #creditCardBill"       : "_creditCardBill",
			"tap #logined"              : "loginedProcess",
			"tap .my_balance"           : "balance",                 //进入活期余额页
			"tap .my_assets"            : "myProperty",              //进入我的资产
			"tap #wanlitong"            : "wanlitong",               //万里通积分 getPointsLeft
			"tap #activate"             : "toActivate",              //去激活
			"tap #logined_transfer_out" : "transferOut",
			"tap #assetsTransIn"        : "_assetsTransIn",
			"tap #logined_NoCard_Cash"  : "_toNoCardCash",
			"tap #tradeecordsinfo"      : "_tradeRecords",
			"tap #friendsRecommend"     : "_toFriendsRecommend",     //去好友推荐
			"tap #applyLoan"            : "applyLoan",               //橙易贷
			"tap #financialAchievement" : "_financialAchievement",   //理财成就（ex_huangzit 2016-05-05）
			"tap #fundManage"           : "fundManage",               //基金定投管理
			"tap #redPacket"            : "toRedPacket"
		},
		initialize: function(options){
			var firstEntered = false;
		},
        onRender : function(){
            this._medalAndWanlitongSwitch();
        },
		onShow: function(){
			this._showAccountMoney(); //显示我的资产
			this._showAccountInfo();
			this._showFriendCommend();//根据IOS版本号是否展示"好友推荐"
			this.loansDisplaySwitch();
			var cardState = App.storage.get('UserInfo').get('cardState');
			var bindCardFlag = App.storage.get('UserInfo').get('bindCardFlag');
			if (cardState == 0 || cardState == 2) {
				if (bindCardFlag == 0) {//1）开关，2）完善信息，3）绑卡
					$("#activate").slideDown(500);
					$(".space").hide();
				}
			}
		},

		/**
		 *根据IOS版本号是否展示"好友推荐"
		 */
		_showFriendCommend:function(){
			var self = this;
			//根据版本号判断是否显示隐藏好友推荐
			utils.native.versionInformation(function(data){
				var version = data.version.replace(/\./g,"") * 1;
				if(IS_RUN_ON_IDEVICE){
					if(version <= 201){
						//隐藏‘好友推荐’
						self.$("#friendsRecommend").hide();
					}else{
						//显示‘好友推荐’
						self.$("#friendsRecommend").show();
					}
				}
			});
		},

		_medalAndWanlitongSwitch: function(){
            var _this = this;
			financialAchievement.medalAndWanlitongSwitch({
				url: "medalAndWanlitongSwitch",
				silent : true,
				callback: function(res){
					if(res.object.fundSwitch == 'on') {
                        _this.$('#financialAchievement').show();
					}
                    _this._pullDown();
				},
				errorCallback: function(res){
					utils.dialog.alert(res.message);
				}
			});
		},

		toActivate: function(){
			var lossStatus = App.storage.get("cradLossStatus");  //是否挂失
			if(lossStatus){
				App.storage.set("backUrl","me/logined/index");
				App.navigate("common/accountInfoCon/accountLoss", true);
			}else{
				App.navigate('verifyAccount/main/verify', true);
			}
		},

		/**
		 * 显示账号信息
		 */
		_showAccountInfo: function(){
			// 获取登录信息
			//账户信息，在登录之后已有，取数据即可，（待定）
			var UserInfo     = App.storage.get('UserInfo'),
				level        = UserInfo.get("securityLevel"),
				headPhotoUrl = UserInfo.get("headPhotoUrl"),
				frag         = document.createDocumentFragment(),
				img          = "";

			for(var i = 0 ;i < level;++i){
				var child = document.createElement('i');
				child.className = "iconA28";
				frag.appendChild(child);
			}

			//填充头像
			if(headPhotoUrl){
				img = '<i class="iconA36"></i><i class="face" id="logined_face" style="background: url('+headPhotoUrl+') no-repeat;background-size: 100% 100%"></i>';
			}else{
				if(!_.has(UserInfo.attributes, "headPhotoUrl")){  // 判断缓存中是存在headPhotoUrl
					loginedAccountInfo.getImagePath({
						url : "getImagePath",
						data : {},
						silent : true,
						callback : function(response){
							headPhotoUrl = response.object.headImagePath;
							App.storage.get("UserInfo").set("headPhotoUrl", headPhotoUrl);
							img = '<i class="iconA36"></i><i class="face" id="logined_face" style="background: url('+headPhotoUrl+') no-repeat;background-size: 100% 100%"></i>';
							$("#headPortrait").html(img);
						}
					});
				}else{
					img = '<i class="iconA35"></i>';
				}
			}
			$("#headPortrait").html(img);
			$("#logined_orange_level").html(frag);
		},

		/**
		 * 显示我的资产
		 */
		_showAccountMoney: function(refresh){
			//utils.dialog.alert(location.href);
			loginedAccountInfo.queryAccountInfo({
				url    : "loginedAccountInfo",
				silent : true,
				cache  : true,//App.requester.storage.remove("loginedAccountInfo");
				data   : {},
				callback: function(res){
					var obj = res.object;
					if(obj){
						//余额、我的资产、预期收益
						$("#logined_account_balance").text(utils.string.formatMoneyNumber(obj.currBalance));
						$("#logined_account_balance").attr("data-money",obj.currBalance);
						$("#logined_my_property").text(utils.string.formatMoneyNumber(obj.totalAmt));

						//给我的资产添加绑定
						$("#myAssets").addClass("my_assets");
						$("#balance").addClass("my_balance");
					}else{
						utils.dialog.alert("数据异常，请重试");
						$("#logined_account_balance").html("");
						$("#logined_my_property").html("");

						$("#myAssets").removeClass("my_assets");
						$("#balance").removeClass("my_balance");
					}
					refresh && refresh();
				},
				errorCallback: function(res){
					utils.dialog.alert(res.message);
					$("#logined_account_balance").html("");
					$("#logined_my_property").html("");

					$("#myAssets").removeClass("my_assets");
					$("#balance").removeClass("my_balance");
					refresh && refresh();
				}
			});
		},

		/**
		 * 获取万里通积分
		 */
		wanlitong: function(){
			App.navigate('wanlitong/wanlitong/index', true);
		},

		loginedProcess: function(){
			//转向账户与安全
			App.navigate("me/accoutAndSecurity/index",true);
		},
		balance: function(){
			var money = 0;
			money = $("#logined_account_balance").attr("data-money");
			if(money){
				App.storage.set("balanceMoney",money);
			}else{
				money = App.storage.get("UserInfo").get("balance");
				App.storage.set("balanceMoney",money);
			}
			App.navigate("me/balance/index?money="+money,true);
		},

		transferOut: function(){
			App.storage.set("me/accoutAndSecurity/transferLimit/fromPage","me/logined/index");
			App.storage.set("transferLimitBack","me/logined/index");
			var bindCardFlag = App.storage.get('UserInfo').get('bindCardFlag');

			//转出限额判断
			var state = App.storage.get("UserInfo").get("cardState");
			var activeState = App.storage.get("UserInfo").get("activeState");
			var bindState = App.storage.get("UserInfo").get("bindState");

			//新增邦卡开关开启：则进行弹窗提示 ex_huangzit 2015-12-26
			if (bindCardFlag == '1' && state == '1' && activeState == '1' && bindState == '0') {
				bindCardTip.activeSwitch();
				return;
			}
			transferOutCom.assetsTransOut();
		},

		myProperty: function(){
			App.navigate('myProperty/myProperty/index',true);
		},

		/**
		 *@ex_huangzit
		 * me首页中单击转入按钮，先调用平安付开关判断开关是否已开启，是：跳转到转入首页，否：提示 "暂不支持平安付扣款"
		 */
		_assetsTransIn:function(){
			App.navigate('me/transferIn/assetsTransIn',true);
		},

		/**
		 *@ex_huangzit
		 * me首页中单击转入按钮跳转到无卡取现
		 */
		_toNoCardCash:function(){
			App.navigate('me/transferIn/noCardCashIndex',true);
		},

		//交易记录
		_tradeRecords:function() {
			App.navigate('me/tradeRecords/index/'+config.values.jiaoYiJiLu+"?"+Date.parse(new Date()),{
				trigger: true,
				replace: true
			});
		},
		//跳转到信用卡还款
		_creditCardBill : function(){
			App.navigate('me/creditCard/payBack',true);
		},
		_pullDown : function(data){
			var self      = this;
			var wHeight   = App.locStorage.get("webviewHeight") || $(window).outerHeight(true);
			var dom       = $("#scrollContainer").css({"height":wHeight,"position":"relative"});
			this.scroller = new PTRScroll(dom[0],{"hideScrollbar":true});

			this.scroller.options.refreshContent = function(refresh){
				$("#logined_account_balance").html('<i class="loadcon" style="left:auto;right:30px;"></i>');
				$("#logined_my_property").html('<i class="loadcon" style="left:auto;right:30px;"></i>');

				$("#myAssets").removeClass("my_assets");
				$("#balance").removeClass("my_balance");
				//先删除接口缓存再查询
				App.requester.storage.remove("loginedAccountInfo");
				self._showAccountMoney(refresh);
				//refresh(); //在接口返回前就刷新不会显示正在刷新
			};
			this.scroller.disablePullUpToLoadMore();
			// if(!this.firstEntered){
				// this.firstEntered = true;
				// this.scroller.scrollTo(0, 100, 500);
			// }
		},

		//好友推荐
		_toFriendsRecommend:function(){
			App.navigate('me/friendsRecommend/index',true);
		},

		//橙易贷
		//
		/*
		*
		*接口返回applyFlag（申请状态）：0-处理中,1-同意,2-否决，3-未申请，4-可疑
		*接口返回isSelf（人脸识别）：0-非本人，1-本人，2-未做人脸识别
		*接口返回staffFlag（员工）：1 银行，2集团，0其他
		*接口返回isFirstDraw（首次提款）：0-首次，1-非首次
		*接口返回updatedDate（建额日期）
		*接口返回availAmt(可用额度) usedLimit（已使用额度）
		*
		* availAmt(可用额度) usedLimit（已使用额度）均不存在：
		* (applyFlag(1)&&isSelf(0||2) ==>人脸识别页面
		* applyFlag(0||4) ==>申请等待页
		* applyFlag（3）&& staffFlag（2||0）==>申请页面
		* applyFlag（3）&& staffFlag（1）==>员工失败页面
		* applyFlag（2）==>申请失败页面
		*
		*
		* availAmt(可用额度) usedLimit（已使用额度）存在：
		* isFirstDraw（0）&&距updatedDate大于180天 ==>申请
		* 其他 ==>提款首页
		*/
		applyLoan:function(){
			utils.native.talkingDataTrackEvent("2.0-我-橙e贷");
			var self = this;
			transModel.checkApplyLoan({
				callback:function(res){
					var obj = res.object;
					App.storage.set("checkApplyLoan",obj);
					if(!obj.availAmt && !obj.usedLimit){
						if(obj.applyFlag=="0"||obj.applyFlag=="4"){
							App.navigate("loan/applyLoan/applyWait",true);
						}else if(obj.applyFlag=="2"){
							App.navigate("loan/applyLoan/applyFail",true);
						}else if(obj.applyFlag=="1"){
							if(obj.isSelf== "1"){
								App.navigate("loan/loan/index",true);
							}else{
								utils.dialog.confirm("为了您的资金安全，需要您先通过人脸识别。", function (ok) {
									if(ok){
										self.faceRecognite();
									}
								});
							}
						}else{
							if(obj.staffFlag == "1"){
								App.navigate("loan/applyLoan/selfBank",true);
							}else{
								App.navigate("loan/applyLoan/index",true);
							}
						}
					}else{
						var getDate = utils.date.formatTime(obj.updatedDate).format("yyyy.MM.dd");
						var toDate = utils.date.diffDateAdd(getDate,"180","d").format("yyyy.MM.dd");
						var theDay = utils.date.formatTime(App.storage.get("Login_SysTime")).format("yyyy.MM.dd");
						if(obj.isFirstDraw == "0" && (utils.date.compareDate(toDate,theDay)=="-1")){
							App.navigate("loan/applyLoan/index",true);
						}else{
							App.navigate("loan/loan/index",true);
						}
					}
				},
				errorCallback:function(res){
					utils.dialog.alert(res.message);
				}
			});
		},

		//人脸识别
		faceRecognite:function(){
			var self = this;
			faceRecognition(function(err, isSamePerson){
				if(err){
					utils.dialog.confirm('抱歉，您的验证失败，可以尝试通过以下方式：保持光线充足与均匀、确保人脸出现在方框内、避免戴帽子或眼睛', function(ok){
						if(ok){
							self.faceRecognition();
							return;
						}
					});
				}
				//是否是同一个人：true为同一人，false为不为同一人
				if(isSamePerson){
					loanModel.checkApplyLoan({
						callback:function(res){
							var obj = res.object;
							App.storage.set("checkApplyLoan",obj);
							if(obj.applyFlag == "0" || obj.applyFlag=="4"){
								App.navigate('loan/applyLoan/applyWait', true);
							}else if(obj.applyFlag == "1"){
								App.navigate("loan/loan/index",true);
							}else if(obj.applyFlag == "2"){
								App.navigate("loan/applyLoan/applyFail",true);
							}
						},
						errorCallback:function(res){
							utils.dialog.alert(res.message);
						}
					});
				}else{
					utils.dialog.alert('抱歉，您的验证失败，可以尝试通过以下方式：保持光线充足与均匀、确保人脸出现在方框内、避免戴帽子或眼睛');
					self.faceRecognition();
				}
			},{sceneNum: 'L003'});
		},

		//我的定投
		fundManage : function(){
			App.navigate("fund/fundFixedIndex/index",true);
		},

		loansDisplaySwitch : function(){
			loginedAccountInfo.loansDisplaySwitch({
				url    : "loansDisplaySwitch",
				silent : true,
				callback: function(res){
					if(res.object.reCode == "1"){
						$("#applyLoan").removeClass("dsn");
						$("#applyLoanDemo").addClass("dsn");
					}
				},
				errorCallback: function(res){
					console.log(res.message);
				}
			})
		},

		//理财成就（ex_huangzit 2016-05-05）
		_financialAchievement : function(){
			App.navigate("financialAchievement/financialAchievement/index",true);
		},

		//红包
		toRedPacket: function(){
			App.navigate("redPacket/redPacket/index",true);
		}

	});
});