/**
 * EX-WUWENJUN
 * 预留验证信息
 *  
 */

define(function (require, exports, module) {
    var Form = require("component/form");
    var template = require("text!../../template/meInfo/authMessagePage.html");
	var meInfoModel = require('../../model/meInfo');
	
    var AuthMessageForm = module.exports = Form.extend({
		template: _.template(template),
		
        events: {
            "tap #nextBtn": "submit"
        },

        initialize: function(){
            
        },

        submit: function(){
            if(this.submited) return;

            var message = this.messageInput.getValue();
            if(this.validate(message) === false) return;
            //‘+’号转化为‘%2B’
            message = message.replace(/\+/g,"%2B");

            this.submited = true;
            meInfoModel.saveCustomerMessage(message, _.bind(function(err, resp){
                this.submited = false;
                if(err){
                	utils.dialog.confirm(
		               	err.message+",再进行修改一次！",
		               	{title : "修改失败"},
		                function(e){
		                 	if(e == false){
		                 		App.navigate("me/meInfoIndex/index", true);
		                 	}
		                }
		            );
               		return;
                } 
                App.storage.get("UserInfo").set("customerMsg", _.escape(decodeURIComponent(message)));
            	App.navigate("me/meInfoIndex/index", true);
            }, this));
        },

        validate: function(message){
            if(message.length == 0){
                utils.dialog.toast("请输入预留验证信息");
                return false;
            }

            if(message.length < 3 || message.length > 15){
                utils.dialog.toast("请输入3-15个字符");
                return false;
            }
            
            if(!utils.validate.specialCharacter(message)){
            	//预留信息不能为特殊字符
            	utils.dialog.toast("你输入的预留信息不符合规范");
                return false;
            }
        }
    });
});