/**
 * EX-WUWENJUN
 * 账户详情View
 *
 */

define(function(require, exports, module){
   var bindCardTip = require('component/bindCardTip');

   var FormComponent = require("component/form");
   var meInfoIndex = require("text!../../template/meInfo/meInfoIndex.html");
   var MeInfoModel = require("../../model/meInfo");
   var accountInfoSta = require("mod/common/accountInfoStatus/accountInfoStatus");

   var IndexView =  module.exports =  FormComponent.extend({
        template : _.template(meInfoIndex),

        regions : {

        },

        events : {
            "tap #changeHeadImgDiv" : "showPictureDialog",
            "tap #modifyIphonePage" : "toModifyIphone",
            "tap #emailText" : "toModifyEmail",
            "tap #authMessageBtn" : "toModifyAuthMessage",
            "tap #contactInfoBtn" : "toContactInfoBtn",
            "tap #individualInfo" : "toIndividualInfo"

        },

        initialize:function(options){
        },

        //选择以某种方式上传图片弹出框
        showPictureDialog : function(){
            utils.dialog.spinner({"source":[{ text: "从手机相册选择"},{text:"拍照"}],"callback":_.bind(function(key,value){
                this.getPicture(value);
            },this)});
        },

        //选择拍照或从手机相册方法
        getPicture : function(source){
            navigator.camera.getPicture(this.onSuccess, this.onFail, {
                quality: 100,
                destinationType:0,
                sourceType:source,
                allowEdit:true,
                correctOrientation: true,
                targetWidth: 80,
                targetHeight: 80
            });
        },

        //成功的方法
        onSuccess : function(imageData) {
            utils.native.talkingDataTrackEvent("2.0-设置头像-修改头像");
            var image = document.getElementById('changeHeadImg');
            var imageName = "head_img.jpg";
            var xml = "<images><element><name>" + imageName + "</name><width>" + 84 + "</width><height>" + 84 + "</height><content>"+ imageData +"</content><dataType>BASE64</dataType></element></images>";
            MeInfoModel.uploadHeadPhotoApp({
                params:{"xml":xml,type:"0"},
                complete : function(err,response){
                    setTimeout(function(){
                        if(err) return utils.dialog.alert(response.message);
                        App.storage.get("UserInfo").set("headPhotoUrl", response.object.headImagePath);
                        if ($(image).hasClass("iconA35")) {
                                 $(image).removeClass("iconA35").addClass("face").before('<i class="iconA36" ></i>');
                        }
                        image.style.backgroundImage = "url(" + response.object.headImagePath + ")";
                        document.getElementById("changeHeadImg").style.backgroundPosition = "center center";
                     }, 500);
                }
            });
        },

        //手机号码
        toModifyIphone : function(){
            //1.低门槛登陆需要提示弹窗
            var isTeleLogin = App.storage.get("UserInfo").get("isTelephoneLogin");
            var registerIn = App.storage.get("openAccount/securitySet");  //从免登入口进，为设置安全信息
            var newBindFlag = bindCardTip.newBindFlag();
            if((newBindFlag && isTeleLogin) || (newBindFlag && !registerIn)){
                bindCardTip.activeSwitch({susFlag: true, back: false});
                return;
            }
            var isTelephoneLogin = accountInfoSta.getIsTelephoneLogin("me/meInfoIndex/index");
            if(!isTelephoneLogin){
                var accountSta = accountInfoSta.getAccountInfoLossStatus("me/meInfoIndex/index");
                if(accountSta){
                    App.navigate('me/meInfo/modifyIphonePage',true);
                }
            }
        },

        //修改邮箱
        toModifyEmail : function(){
            //激活未绑卡情况下提示取绑卡
            var UserInfo  =  App.storage.get('UserInfo'),
                bindState = UserInfo.get('bindState'),
                cardState = UserInfo.get('cardState'),
                activeState = UserInfo.get('activeState');
            var bindCardFlag = App.storage.get('UserInfo').get('bindCardFlag');
                
            //审核中的跳转到
            if(cardState === '3'){
                App.storage.set("backUrl", "me/meInfoIndex/index");
                App.navigate("common/accountInfoCon/accountNoCard",true);
                return;
            }
            
            if (bindCardTip.newBindFlag() || (bindCardFlag =='1' && bindState === '0' && cardState === '1' && activeState === '1')) {
                bindCardTip.activeSwitch();
                return;
            }
               
            var isTelephoneLogin = accountInfoSta.getIsTelephoneLogin("me/meInfoIndex/index");
            if(!isTelephoneLogin){
                var accountSta = accountInfoSta.getAccountInfoLossStatus("me/meInfoIndex/index");
                App.storage.set("modifyEmailPage/email",{"email":this.$("#emailText").find(".tar").text()});
                if(accountSta){
                    var dfd = accountInfoSta.getAccountInfoBindCardStatus("me/meInfoIndex/index");
                    dfd.done(function(bindCardStatus){
                        if(bindCardStatus){
                            App.navigate('me/meInfo/modifyEmailPage',true);
                        }
                    });
                }
            }
        },

        //修改预留信息
        toModifyAuthMessage : function(){
            var accountSta = accountInfoSta.getAccountInfoLossStatus("me/meInfoIndex/index");
            if(accountSta){
                App.navigate('me/meInfo/modifyAuthMessage',true);
            }
        },

        //修改联系信息
        toContactInfoBtn : function () {
            var accountSta = accountInfoSta.getAccountInfoLossStatus("me/meInfoIndex/index");
            if(accountSta){
                App.navigate("me/meInfoIndex/contactInfo", true);
            }
        },

        //个性化信息
        toIndividualInfo : function(){
            var accountSta = accountInfoSta.getAccountInfoLossStatus("me/meInfoIndex/index");
            if(accountSta){
                 App.navigate("me/individualInfo/index", true);
            }
        }

  });
});
