/**
 * EX-WUWENJUN
 * 修改手机号码第一步
 */

define(function (require, exports, module) {
    var OtpView = require("component/otp/OtpView");
    var safeKeyBoardHelper = require("component/customInput.helper");
    var MeInfoModel = require("../../model/meInfo");
    var Step1Tpl = require("text!../../template/meInfo/modifyIphoneStep1.html");

    var Step1View = module.exports = ItemView.extend({
        template: _.template(Step1Tpl),

        events: {
            "customInputFocusIn #passInput": "_onCustomInputFocusInPass",
            "customInputFocusOut #passInput": "_onCustomInputFocusOutPass",
            "jsClearIconHandler #passInput": "_onCustomInputFocusOutPwd",
            "customInputKeyup #passInput": "_onCustomInputFocusOutPwd",
            "input #otp_passWord": "_onCustomInputFocusOutPwd",
            "tap #otpView .js-clear-input": "_onCustomInputFocusOutPwd",
            "tap #nextBtn": "submit"
        },

        onRender: function () {

            this._initPasswordInputKeyBoard();

            var options = {
                isOtpSended: false,
                isNeedSendOtpValidate: true,
                isQryOtpPhoneNo: true,
                otpEnable: null,
                isMobilePhoneByUser: false,
                callbackError: _.bind(this._callbackError, this),
                callbackSubmit: _.bind(this._callbackSubmit, this),
                cat: config.values.modifyPhone_cat
            };
            this.otpView = new OtpView();
            this.otpView.initOtp(options);
            this.$("#modifyPhone_otp_container").empty();
            this.$("#modifyPhone_otp_container").append($(this.otpView.$el[0]));
        },

        _onCustomInputFocusInPass: function () {
            safeKeyBoardHelper.focusIn({ id: "passInput" });
        },

        _onCustomInputFocusOutPass: function () {
            safeKeyBoardHelper.focusOut({ id: "passInput" });
        },

        //下一步提交事件
        submit: function () {
            if (this.$("#nextBtn").hasClass("btn_disable")) {
                return;
            }
            if (!this.validate()) {
                return;
            }
            this.otpView.submit();

        },

        _initPasswordInputKeyBoard: function () {
            this.$("#passInput").customInput({
                type: "password-number",
                placeholder: "请输入您的交易密码",
                maxLength: 6,
                className: "safeKeyBoard"
            });
        },

        //改变下一步按钮
        _onCustomInputFocusOutPwd: function () {
            var passInput = this.$("#passInput").customInput("value");   //获取交易密码
            var otpValue = this.$("#otp_passWord").val();  //获取动态密码
            if (passInput != "" && otpValue != "") {
                this.$("#nextBtn").removeClass("btn_disable").addClass("btn_orange");
            } else {
                this.$("#nextBtn").removeClass("btn_orange").addClass("btn_disable");
            }
        },

        _callbackSubmit: function () {
            this.toStepTwo();
        },
        _callbackError: function () {
            this.otpView.setCustomValidity("动态密码错误！");
        },


        toStepTwo: function () {
            var data = {};
            var password = this.$("#passInput").customInput("value");
            data.password = utils.crypto.RSAKey.encrypt(password, config.base.rsa_public_key);
            data.sm2Pwd = utils.sm2.SM2Key.encrypt(password, config.base.sm2_public_key);
            MeInfoModel.modifyMobCheckPassword(data, function (res) {
                App.navigate("me/meInfo/modifyIphoneStep2", true);
            });
        },

        validate: function () {
            var password = this.$("#passInput").customInput("value");
            var otp = this.otpView.getValue();
            if (!password) {
                utils.dialog.toast("请输入交易密码！");
                return false;
            }

            if (!otp) {
                this.otpView.setCustomValidity("请输入动态密码！");
                return false;
            }
            return true;
        }
    });
});
