/**
 * EX-WUWENJUN
 * 修改手机号码第二步
 */

define(function(require, exports, module){
    var OtpView=require("component/otp/OtpView");
    var Form = require("component/form");
    var meInfoModel = require("../../model/meInfo");
    var Step2Tpl = require("text!../../template/meInfo/modifyIphoneStep2.html");
    var Step2View= module.exports = Form.extend({
        template : _.template(Step2Tpl),
        
        events : {
            "tap #submitBtn" : "submit",
            "input #newIphoneInput,#otp_passWord" : "changeSubBtn"
        },
        
        onRender : function(){
            var options = {
                    isOtpSended : true,
                    isNeedSendOtpValidate : false,
                    isQryOtpPhoneNo : false,
                    isMobilePhoneByUser : true,
                    callbackError : _.bind(this.callbackError, this),
                    callbackSubmit : _.bind(this.callbackSubmit, this),
                    resendBtnHandler : _.bind(this.resendBtnHandler, this),
                    cat:config.values.newPhone_cat
            };
            this.otpView = new OtpView();
            this.otpView.initOtp(options);
            
            this.$("#stepTwo_otpContainer").empty();
            this.$("#stepTwo_otpContainer").append($(this.otpView.$el[0]));
        },
        
        submit : function(){
        	if(this.$("#submitBtn").hasClass("btn_disable")){
            	return;
            }
            if(this.validate()){
                meInfoModel.verifyByPhoneNo({
                    params:{
                        mobileNo:this.newIphoneInput.$el.val(),
                        code:this.otpView.getValue(),
                        cat:config.values.newPhone_cat
                    },
                    success:_.bind(function(){
                        this.otpView.submit();
                    },this),
                    error:_.bind(function(){
                        this.otpView.setCustomValidity("动态密码校验失败！");
                    },this)
                });
            }  
        },
        
        validate : function(){
            var mobile = this.newIphoneInput.$el.val().replace(/\s/g,"");
            //手机号码
            if(!mobile) {
                this.newIphoneInput.setCustomValidity("请输入手机号");
                return false;
            }
            if(mobile && !utils.validate.phone(mobile)){
                this.newIphoneInput.setCustomValidity("手机号错误");
                return false;
            }
            
            //校验otp
            if(!this.otpView.isSendedOTP()&& $("#btn_resend").text() != "重新获取") {
                this.otpView.setCustomValidity("请获取动态密码！");
                return false;
            }
            if(!this.otpView.isSendedOTP() && $("#otp_passWord").attr("disabled") == "disabled") {
                this.otpView.setCustomValidity("请获取动态密码！");
                return false;
            }
            if(this.otpView.getValue()===""){
                this.otpView.setCustomValidity("请输入动态密码！");
                return false;
            }
            return true;
        },
        
        
        callbackSubmit:function(){
            this._resetPhoneResult();
        },
        
        callbackError:function(){
            this.otpView.setCustomValidity("动态密码校验失败！");
        },
        
        
        _resetPhoneResult : function(){
            var tel= this.newIphoneInput.$el.val().replace(/\s/g,"");
            var data={};
            data.tel=tel;
            
            if (this.submitFlag === "1") return;
            this.submitFlag = "1";
            meInfoModel.modifyMobCheckNewOtp({
                params:data,
                success:function(res){
                	this.submitFlag = "0";
                    App.storage.get("UserInfo").set("telephoneNum",res.object.tel);
                    App.navigate("me/meInfo/modifyIphoneStep3",true);
                },
                error:_.bind(function(response){
                	this.submitFlag = "0";
                    this.otpView.stopService();
                    utils.dialog.alert(response.message);
                },this)
            });
        },
        
        resendBtnHandler:function(){
            var mobile = this.newIphoneInput.$el.val().replace(/\s/g,"");
            //手机号码
            if(!mobile) {
                this.newIphoneInput.setCustomValidity("请输入手机号");
                return false;
            }
            if(mobile && !utils.validate.phone(mobile)){
                this.newIphoneInput.setCustomValidity("手机号错误");
                return false;
            }
            
            this.otpView.sendSmsOTP("sendByPhoneNo",{
                "mobileNo":mobile,
                 cat:config.values.newPhone_cat
            });
        },
        
        //改变提交按钮
        changeSubBtn:function(){
        	var emailVal = this.$("#newIphoneInput").val();
        	var otp_passWord = this.$("#otp_passWord").val(); 
        	if(emailVal != "" && otp_passWord != ""){
        		this.$("#submitBtn").removeClass("btn_disable").addClass("btn_orange");
        	}else{
        		this.$("#submitBtn").removeClass("btn_orange").addClass("btn_disable");
        	}
        } 
    });                
});
