/**
 * @author zhoushiwen
 * @ date ${date}
 * @company 中国平安
 * @param name  渲染检查邮箱页面
 * @checkemail  重置交易密码动态密码邮箱验证
 *
 */
define(function (require, exports, module) {
	var safeKeyBoardHelper = require("component/customInput.helper");
	var dataAccess = require("../../model/dataAccess");
	var Form = require("component/form");
	var FinishTpl = require("text!../../template/passmanagement/checkmail.html")
		var FinishView = module.exports = Form.extend({
			template : _.template(FinishTpl),
			events : {
				"tap #checkemail" : "checkemail",
				"input #emailinput" : "changeBtn"

			},

			changeBtn : function () {
				var emailOtp = this.$("#emailinput").val();
				if (emailOtp != "") {
					this.$("#checkemail").removeClass("btn_disable").addClass("btn_orange");
				} else {
					this.$("#checkemail").removeClass("btn_orange").addClass("btn_disable");
				}
			},

			checkemail : function () {
				if (this.$("#checkemail").hasClass("btn_disable")) {
					return;
				}
				var emailinput = this.$("#emailinput").val();
				if (this._validate()) {
					this._checkEmailCode(emailinput);
				}
			},
			_validate : function () {
				var emailinput = this.$("#emailinput").val();
				if (!emailinput) {
					safeKeyBoardHelper.setCustomValidity("请输入动态密码！");
					return false;
				}
				return true;
			},
			_checkEmailCode : function (emailinput) {
				if (this._submitted || !this.reportValidity())
					return;
				this._submitted = true;
				dataAccess.otpVerifyEmail(emailinput, _.bind(function (err) {
						this._submitted = false;
						if (err) {
							utils.dialog.alert(err.message);
							return
						} else {
							App.navigate("me/passmanagement/showreset", true);
						}
					}, this));
			}

		});
});
