/**
 * @author ex-yangjingpeng001
 * @ date ${date}
 * @company 中国平安
 *
 */
define(function(require, exports, module) {
    var safeKeyBoardHelper = require("component/customInput.helper");
    var dataAccess = require("../../model/dataAccess");
    var Form = require("component/form");
    var HandShapePassTpl = require("text!../../template/passmanagement/gesturepass.html")
    var HandShapePassView = module.exports = Form.extend({
        template : _.template(HandShapePassTpl),
        events : {
            "tap #gesturepassBtn" : "gesturepassHandle",
            "tap #updateGesturepass" : "setGesturepassHandle"
        },

        onRender : function() {
            var _this = this;
            utils.native.getDeviceInfo().always(function(deviceInfo) {
                _this.tokenId = deviceInfo.deviceId;
                dataAccess.isExistHandPwd({
                    tokenId : _this.tokenId
                }).done(function(res) {
                    if (res.object.isExistHandPwd == "1") {
                        _this.$("#gesturepassBtn").addClass("on");
                        _this.$("#updateGesturepass").show();
                    }
                }).fail(function() {
                    utils.dialog.toast("获取数据异常");
                });
            });

        },

        gesturepassHandle : function(event) {
            var _this = this;
            if (_this.$(event.currentTarget).hasClass("on")) {
                App.commands.execute("removeGestrueLogin", {
                    data : {
                        tokenId : this.tokenId
                    },
                    callback : function() {
                        _this.$("#gesturepassBtn").removeClass("on");
                        _this.$("#updateGesturepass").hide();
                    },
                    errorCallback : function() {
                        utils.dialog.toast("关闭手势密码异常");
                    }
                });
            } else {
                this.setGesturepassHandle();
            }
        },

        setGesturepassHandle : function() {
            var _this = this;
            utils.native.showGestureLoginSetupView({
                callback : function() {
                    _this.$("#gesturepassBtn").addClass("on");
                    _this.$("#updateGesturepass").show();
                },
                errorCallback : function() {
                    _this.$("#gesturepassBtn").removeClass("on");
                }
            });
        }
    });
});
