define(function(require, exports, module) {
    var FormComponent = require("component/form");
    var PTRScroll = require("component/PTRScroll");
    var trans_Model = require("../../model/tradeRecordsInfo");
    var transModel = new trans_Model();
    var listView = require("../tradeRecordsInfo/tradeRecordsList");
    var tradeRecordsInfo = require("text!../../template/tradeRecordsInfo/tradeRecordsInfo.html");

    //产品code

    var indexView = module.exports = FormComponent.extend({
        template : _.template(tradeRecordsInfo),
        regions : {
            'transListRegion' : '#transRecordListContainer'
        },
        ui : {
            "startDateBtn" : "#startDate",
            "endDateBtn" : "#endDate",
            "startDateText" : "#start-date-text",
            "endDateText" : "#end-date-text"
        },
        events : {
            "tap #chageTab" : "_chageTab",
            "tap #FilterOptions li" : "_selectePro",
            "tap #choseDate" : "_showDate",
            "datepicker:dateSelect @ui.startDateBtn" : "selectStartDate", //选择开始日期
            "datepicker:dateSelect @ui.endDateBtn" : "selectEndDate" //选择结束日期
        },
        initialize : function(options) {
            that = this;
            ctrProCaption = null;
            dateFormat = "yyyyMMdd";
            returnURL = options.returnURL;
            this.param = this.model.get('param');
            this.initProSettings(this.param.prdCode);
            var date = App.storage.remove('me/transRecords/startDate');
            if (date) {
                this.model.get("param").startDate = date.startDate;
                this.model.get("param").endDate = date.endDate;
            }
        },
        onRender : function() {
            this._rendHear();
        },
        _rendHear : function() {
            var url = this.returnURL || "me/logined/index";
            App.header.reset({
                title : "交易记录",
                leftButtonContent : '@back',
                leftButtonHandler : function() {
                    App.navigate(url, true);
                }
            });
        },
        templateHelpers : {
            //根据不同的产品展示表头
            showCption : function() {
                return ctrProCaption;
            }
        },
        onShow : function() {
            if (!this.model.get('tempDataList')) {
                this.qryFirstPageData();
            } else {
                this.showTempPageData();
            }
            if ($("li[selected='"+this.param.prdCode+"']")[0]) {
                $("#FilterOptions li").removeClass("on");
                $("li[selected='" + this.param.prdCode + "']").addClass("on");
            }
            this.$("#secTab").text(this.title);
        },
        showTempPageData : function() {
            var model = this.model;
            var list = model.get('tempDataList');
            var responseData = model.get('responseData');

            this.initPTRScroll();
            this.listViewCollectionChange(list);
            this.initPullUpToLoadMore(responseData.object);
        },
        // 根据不同产品编码展示不同的列表头和获取相应的接口名
        initProSettings : function(proCode) {
            App.storage.remove('tradeRecordsInfo/returnURL');
            App.storage.remove('tradeRecordsInfo/prdCode');
            switch(proCode) {
                case config.values.zhaunZhang:
                    //转账记录
                    ctrProCaption = '<div class="f16 tac w33">交易日期</div>' + '<div class="f16 tac w33">状态</div>' + '<div class="f16 tar w33 p_r30">金额(元)</div>';
                    this.title = "转出详情";
                    //头部title
                    this.detailTitle = "转账详情";
                    //详情界面title
                    this.modelMethod = 'getZhuanZhangInfo';
                    //后台查询方法
                    this.respListName = 'list';
                    //结果集
                    dateFormat = "yyyy-MM-dd";
                    break;
                case config.values.transInInfo://转入记录
                    ctrProCaption = '<div class="f16 tac w33">交易日期</div>' + '<div class="f16 tac w33">状态</div>' + '<div class="f16 tar w33 p_r30">金额(元)</div>';
                    this.title = "转入记录";
                    //头部title
                    this.detailTitle = "转入详情";
                    //详情界面title
                    this.modelMethod = 'dealRecordTransferIn';
                    //后台查询方法
                    this.respListName = 'dealrecordList';
                    //结果集
                    dateFormat = "yyyy-MM-dd";
                    break;
                case config.values.jiaoYiJiLu:
                    //交易明细
                    ctrProCaption = '<div class="f16 tac w50">交易日期</div>' + '<div class="f16 tar w50 p_r30">金额(元)</div>';
                    this.modelMethod = 'getTransferDetail';
                    this.title = "交易明细";
                    this.detailTitle = "交易详情";
                    this.respListName = 'list';
                    //结果集
                    dateFormat = "yyyyMMdd";
                    break;
                case config.values.fund_code_dahua:
                    //平安盈 大华
                    ctrProCaption = '<div class="f16 tac w33">交易日期</div>' + '<div class="f16 tac w33">交易类型</div>' + '<div class="f16 tar w33 p_r30">金额(元)</div>';
                    proCode == config.values.fund_code_dahua ? this.title = '平安盈（大华）' : this.title = '平安盈（南方）';
                    this.detailTitle = "投资详情";
                    this.modelMethod = 'getPingAnYingInfo';
                    this.respListName = 'transferRecordList';
                    dateFormat = "yyyy-MM-dd";
                    this.param.account = App.storage.get("UserInfo").get("accNumber");
                    break;
                case config.values.fund_code_nanfang:
                    //平安盈南方
                    ctrProCaption = '<div class="f16 tac w33">交易日期</div>' + '<div class="f16 tac w33">交易类型</div>' + '<div class="f16 tar w33 p_r30">金额(元)</div>';
                    proCode == config.values.fund_code_dahua ? this.title = '平安盈（大华）' : this.title = '平安盈（南方）';
                    this.detailTitle = "投资详情";
                    this.modelMethod = 'getPingAnYingInfo';
                    this.respListName = 'transferRecordList';
                    dateFormat = "yyyy-MM-dd";
                    this.param.account = App.storage.get("UserInfo").get("accNumber");
                    break;
                case config.values.dinghuotong_code:
                    //定活通
                    ctrProCaption = '<div class="f16 tac w33">交易日期</div>' + '<div class="f16 tac w33">交易类型</div>' + '<div class="f16 tar w33 p_r30">金额(元)</div>';
                    this.title = "定活通";
                    this.detailTitle = "投资详情";
                    this.modelMethod = 'getDingHuoTongInfo';
                    this.respListName = 'qryTransferQueryOutDTOs';
                    dateFormat = "yyyy-MM-dd";
                    break;
                case config.values.financial_code:
                    //理财产品
                    ctrProCaption = '<div class="f16 tac w33">交易日期</div>' + '<div class="f16 tac w33">产品简称</div>' + '<div class="f16 tar w33 p_r30">金额(元)</div>';
                    this.modelMethod = 'getFinancialProInfo';
                    this.title = "理财产品";
                    this.detailTitle = "投资详情";
                    this.respListName = 'list';
                    dateFormat = "yyyyMMdd";
                    break;
                case config.values.provide_code:
                    //养老产品
                    ctrProCaption = '<div class="f16 tac w33">交易日期</div>' + '<div class="f16 tac w33">产品简称</div>' + '<div class="f16 tar w33 p_r30">金额(元)</div>';
                    this.modelMethod = 'getYangLaoProInfo';
                    this.title = "养老保障产品";
                    this.detailTitle = "投资详情";
                    this.respListName = 'list';
                    dateFormat = "yyyy-MM-dd";
                    this.param.account = App.storage.get("UserInfo").get("accNumber");
                    break;
                case config.values.auto_dinghuotong:
                    //智能定活通
                    ctrProCaption = '<div class="f16 tac w50">交易日期</div>' + '<div class="f16 tar w50 p_r30">金额(元)</div>';
                    this.modelMethod = 'getAutoDingHuoTong';
                    this.title = "智能定活通";
                    this.detailTitle = "投资详情";
                    this.respListName = 'list';
                    dateFormat = "yyyyMMdd";
                    break;
                case config.values.gold_code:
                    //黄金
                    ctrProCaption = '<div class="f16 tac w33">交易日期</div>' + '<div class="f16 tac w33">交易类型</div>' + '<div class="f16 tar w33 p_r30">金额(元)</div>';
                    break;
                case config.values.foundtion_code:
                    //基金
                    ctrProCaption = '<div class="f16 tac w33">交易日期</div>' + '<div class="f16 tac w33">基金简称</div>' + '<div class="f16 tar w33 p_r30">金额(元)</div>';
                    break;
                case config.values.nocardcash_code:
                    //取现记录
                    ctrProCaption = '<div class="f16 tac w33">预约时间</div>' + '<div class="f16 tar w33">预约金额(元)</div>' + '<div class="f16 tac w33 p_r30">状态</div>';
                    this.title = "无卡取现";
                    //头部title
                    this.isNocardCash = true;
                    this.detailTitle = "无卡取现";
                    //详情界面title
                    this.modelMethod = 'qryBookingNocardRecordList';
                    //后台查询方法
                    this.respListName = 'resultList';
                    //结果集
                    dateFormat = "yyyyMMdd";
                    this.param.account = App.storage.get("UserInfo").get("accNumber");
                    break;
                case config.values.pianganpiao :
                    //平安票
                    ctrProCaption = '<div class="f16 tac w33">交易日期</div>' + '<div class="f16 tac w33">产品简称</div>' + '<div class="f16 tar w33 p_r30">金额(元)</div>';
                    this.modelMethod = 'getPanPiaoProInfo';
                    this.title = "快E盈";
                    this.detailTitle = "快E盈详情";
                    this.respListName = 'list';
                    dateFormat = "yyyy-MM-dd";
                    this.param.account = App.storage.get("UserInfo").get("accNumber");
                    //returnURL?returnURL:returnURL="me/logined/index";
                    //returnURL = "me/logined/index";
                    break;
                case config.values.fundTransaction_code:
                    //基金成交记录
                    ctrProCaption = '<div class="f16 tac w33">交易日期</div>' + '<div class="f16 tac w33">产品简称</div>' + '<div class="f16 tar w33 p_r30">金额(元)</div>';
                    this.modelMethod = 'getFundTransactionInfo';
                    this.title = "基金";
                    this.detailTitle = "成交记录";
                    this.respListName = 'list';
                    dateFormat = "yyyy-MM-dd";
                    break;
                case config.values.trustGoldTreasure_code:
                    //信托黄金宝
                    ctrProCaption = '<div class="f16 tac w33">交易日期</div>' + '<div class="f16 tac w33">产品简称</div>' + '<div class="f16 tar w33 p_r30">金额(元)</div>';
                    this.modelMethod = 'trustGoldTreasureInfo';
                    this.title = "信托黄金宝";
                    this.detailTitle = "投资详情";
                    this.respListName = 'list';
                    dateFormat = "yyyy-MM-dd";
                    break;
                case config.values.bill_code:
                    //E企盈
                    ctrProCaption = '<div class="f16 tac w33">交易日期</div>' + '<div class="f16 tac w33">产品名称</div>' + '<div class="f16 tar w33 p_r30">金额(元)</div>';
                    this.modelMethod = 'getBillInfo';
                    this.title = "E企盈";
                    this.detailTitle = "投资详情";
                    this.respListName = 'list';
                    dateFormat = "yyyy-MM-dd";
                    break;
                case config.values.wanlitong_code:
                    //万里通
                    ctrProCaption = '<div class="f16 tac w33">积分类型</div>' + '<div class="f16 tac w33">日期</div>' + '<div class="f16 tar w33 p_r30">积分数量</div>';
                    this.modelMethod = 'getWanlitong';
                    this.title = "万里通积分";
                    this.respListName = 'accArrayList';
                    dateFormat = "yyyy-MM-dd";
                    break;
                case config.values.fundStrong:
                    //万里通
                    ctrProCaption = '<div class="f16 tac w33">交易日期</div>' + '<div class="f16 tac w33">交易类型</div>' + '<div class="f16 tar w33 p_r30">金额(元)</div>';
                    this.modelMethod = 'fundStrong';
                    this.title = "每日盈";
                    this.respListName = 'list';
                    dateFormat = "yyyy-MM-dd";
                    break;
            }
            this.listViewInstance = null;
            //同一产品下，结果集累加
        },
        // 准备查询（当首次进入页面 或 变更查询参数时）
        qryFirstPageData : function() {
            this.param.startDate = utils.date.formatTime($("#startDate").attr("data-initDate")).format(dateFormat);
            this.param.endDate = utils.date.formatTime($("#endDate").attr("data-initDate")).format(dateFormat);
            var param = this.param;
            param.pageIndex = 1;
            this.doQryFirstPageData(param);
        },
        // 执行查询（当首次进入页面 或 变更查询参数时）
        doQryFirstPageData : function(param) {
            this.qryData({
                param : param,
                callback : _.bind(function(response) {
                    this.model.set('responseData', response);
                    var list = this.getResultList(response);
                    if (!list || list.length == 0) {
                        $("#scrollContainer").hide();
                        $("#norecordsErrMsg").show();
                        //this.scroller && this.scroller.destroy();
                        //this.listViewCollectionChange([]);
                    } else {
                        $("#norecordsErrMsg").hide();
                        $("#scrollContainer").show();
                        this.initPTRScroll();
                        this.listViewCollectionChange(list);
                        this.initPullUpToLoadMore(response.object);
                    }
                    $("#chageTab i").removeClass("on");
                    $("#choseDate i").removeClass("on");
                }, this)
            });
        },
        //执行请求数据
        qryData : function(options) {
            var self = this;
            // 防重复提交
            if (self.submitFlag === 1)
                return;
            self.submitFlag = 1;

            transModel[this.modelMethod]({
                param : options.param,
                callback : function(response) {
                    options.callback && options.callback(response);
                },
                complete : function() {
                    options.complete && options.complete();
                    self.submitFlag = 0;
                }
            });
        },
        //根据不同的产品编号，取不同的列表数据
        getResultList : function(response) {
            return response.object[this.respListName];
            //[this.respListName];
        },
        //初始化上下拉
        initPTRScroll : function() {
            if (this.scroller)
                this.scroller.destroy();
            var self = this;
            var wHeight = $(window).outerHeight(true);
            var navHeight = this.$("#selectionArea").outerHeight(true) + this.$("#tableCption").outerHeight(true);
            var listHeight = wHeight - navHeight;
            var dom = $("#scrollContainer").css({
                "height" : listHeight,
                "position" : "relative"
            });

            //初始化iscroller
            this.scroller = new PTRScroll(dom[0], {
                "checkDOMChanges" : true,
                "hideScrollbar" : true
            });
            //下拉刷新
            this.scroller.options.refreshContent = function(refresh) {
                self.scrollerLoadData(refresh, 1);
            };
            //上拉加载
            this.scroller.options.loadMoreContent = function(refresh) {
                self.scrollerLoadData(refresh, self.param.pageIndex + 1);
            };
        },
        // 上下拉时加载数据
        scrollerLoadData : function(refresh, pageIndex) {
            var self = this;
            // 重置页码参数
            var param = this.param;
            var tempParam = _.defaults({
                pageIndex : pageIndex
            }, param);
            // 请求数据
            this.qryData({
                param : tempParam,
                callback : function(response) {
                    param.pageIndex = pageIndex;
                    var list = self.getResultList(response);
                    if (pageIndex == 1) {
                        self.listViewCollectionChange(list);
                    } else {
                        self.listViewCollectionAdd(list);
                    }
                    self.initPullUpToLoadMore(response.object);
                },
                complete : function() {
                    refresh();
                }
            });
        },
        //初始化上下拉标签
        initPullUpToLoadMore : function(object) {
            if (!object.pageSize)
                object.pageSize = this.param.pageSize || 10;
            if ((object.totalRows || object.total) > 1 * this.param.pageIndex * object.pageSize) {
                this.scroller.enablePullUpToLoadMore();
            } else {
                this.scroller.disablePullUpToLoadMore();
            }
        },
        // 更改collectionView中的collection，并渲染该view
        listViewCollectionChange : function(list) {
            this.model.set('tempDataList', list);
            App.storage.set('tradeRecordsInfo/returnURL', returnURL);
            App.storage.set('tradeRecordsInfo/prdCode', this.param.prdCode);
            if (this.listViewInstance) {
                this.listViewInstance.collection.reset(list);
            } else {
                this.showRecordsListView(new Collection(list));
            }
        },
        // 增加collectionView中的collection，并渲染该view
        listViewCollectionAdd : function(list) {
            var tempDataList = this.model.get('tempDataList');
            App.storage.set('tradeRecordsInfo/returnURL', returnURL);
            App.storage.set('tradeRecordsInfo/prdCode', this.param.prdCode);
            this.model.set('tempDataList', tempDataList.concat(list));

            if (this.listViewInstance) {
                this.listViewInstance.collection.add(list);
            }
        },
        // 显示列表view
        showRecordsListView : function(collection) {
            var thisView = this;
            var detailTitle = this.detailTitle;
            var view = this.listViewInstance = new listView({
                collection : collection
            });

            view.on('gotoDetailPage', function() {
                App.storage.set('me/transRecords/detailTitle', detailTitle);
                App.navigate('me/transRecords/detail', false);
            });

            this.transListRegion.show(view);
        },
        //展示选择界面
        _chageTab : function() {
            //计算展示界面的高度
            var selHeight = this.$("#FilterOptions li").length * 40 + 10;
            if ($("#selectPro").height() < selHeight) {
                selHeight = $("#selectPro").height() - 40;
            }
            $("#FilterOptions").height(selHeight);
            $("#choseDate i").removeClass("on");
            $("#selectDate").hide();
            $("#chageTab i").toggleClass("on");
            $("#selectPro").toggle();
        },
        //展示日期
        _showDate : function() {
            $("#chageTab i").removeClass("on");
            $("#selectPro").hide();
            $("#choseDate i").toggleClass("on");
            $("#selectDate").toggle();
        },
        //选择一个产品
        _selectePro : function(e) {
            var self = this;
            var el = e.currentTarget;
            $(el).addClass("on").siblings().removeClass("on").parents("#selectPro").hide();
            var proCode = el.getAttribute("selected");
            if (proCode) {
                var param = that._getDefaultParam(proCode);
                //重新渲染有页面
                that.param = param;
                that.initProSettings(proCode);
                this.$("#secTab").text(this.title);
                returnURL = "";
                that._rendHear();
                var _html = that.templateHelpers.showCption(proCode);
                $("#tableCption_cont").html(_html);

                //如果是交易记录不含今天，不是查询含今天
                var sysTime = App.storage.get("Login_SysTime") || new Date();
                var today = new Date(sysTime).format("yyyy-MM-dd");
                var startDate = utils.date.diffDateAdd(today, -7, 'd').format("yyyy-MM-dd");
                var endDate = utils.date.diffDateAdd(today, -1, 'd').format("yyyy-MM-dd");
                if (proCode == config.values.jiaoYiJiLu) {
                    //that.param.startDate = startDate;
                    //that.param.endDate   = endDate;
                    that._resetTime(startDate, endDate);
                } else {
                    startDate = utils.date.diffDateAdd(today, -6, 'd').format("yyyy-MM-dd");
                    endDate = today;

                    that._resetTime(startDate, endDate);
                }

                that.qryFirstPageData();
            }
        },

        _resetTime : function(startTime, endTime) {
            that.model.set("startDate", startTime);
            $("#startDay").text(startTime);
            that.ui.startDateText.text(utils.date.formatTime(startTime).format("MM-dd"));
            $("#startDate").attr("data-initDate", startTime);

            that.model.set("endDate", endTime);
            $("#endDay").text(endTime);
            that.ui.endDateText.text(utils.date.formatTime(endTime).format("MM-dd"));
            $("#endDate").attr("data-initDate", endTime);
        },
        //获取默认查询条件
        _getDefaultParam : function(code) {
            return {
                "pageIndex" : 1,
                "pageSize" : 10,
                "prdCode" : code
                // ,"account"  : App.storage.get("UserInfo").get("accNumber")
            };
        },
        // 选择开始日期
        selectStartDate : function(eve, _this, value) {
            this.dateSelect = "START";
            var consumeView = this;
            var sysTime = App.storage.get("Login_SysTime");
            var now = new Date();
            var today = new Date(sysTime || now).format("yyyy-MM-dd");
            var yesToday = new Date(utils.date.diffDateAdd(sysTime || now, -1, "d")).format("yyyy-MM-dd");
            if (value == today && this.param.prdCode == config.values.jiaoYiJiLu) {
                consumeView.model.set("endDate", today);
                $("#endDay").text(value);
                this.ui.endDateText.text(utils.date.formatTime(today).format("MM-dd"));
                $("#endDate").attr("data-initDate", today);

            } else if (value != today && this.param.prdCode == config.values.jiaoYiJiLu) {
                consumeView.model.set("endDate", yesToday);
                $("#endDay").text(yesToday);
                this.ui.endDateText.text(utils.date.formatTime(yesToday).format("MM-dd"));
                $("#endDate").attr("data-initDate", yesToday);
            }
            if (!this._validateDateSlct(value, this.ui.endDateBtn.attr("data-initDate")))
                return;
            this.ui.startDateBtn.attr("data-initDate", value)
            $("#startDay").text(value);

            this.ui.startDateText.text(utils.date.formatTime(value).format("MM-dd"));
            this._validateDateThreeMotn(value, this.ui.endDateBtn.attr("data-initDate"));
        },
        // 选择结束日期
        selectEndDate : function(eve, _this, value) {
            this.dateSelect = "END";
            var consumeView = this;
            var sysTime = App.storage.get("Login_SysTime");
            var now = new Date();
            var today = new Date(sysTime || now).format("yyyy-MM-dd");
            if (value == today && this.param.prdCode == config.values.jiaoYiJiLu) {
                consumeView.model.set("startDate", today);
                $("#startDay").text(value);
                this.ui.startDateText.text(utils.date.formatTime(today).format("MM-dd"));
                $("#startDate").attr("data-initDate", today);
                //$("#startDate").attr("data-startDate", today);
                //$("#startDate").attr("data-endDate", today);

                //非无卡取现
                //if(!this.isNocardCash) return;
            }
            if (!this._validateDateSlct(this.ui.startDateBtn.attr("data-initDate"), value))
                return;
            this.ui.endDateBtn.attr("data-initDate", value);
            $("#endDay").text(value);
            this.ui.endDateText.text(utils.date.formatTime(value).format("MM-dd"));
            this._validateDateThreeMotn(this.ui.startDateBtn.attr("data-initDate"), value);
            //$("#selectDate").hide();
            //this.qryFirstPageData();
        },
        _validateDateThreeMotn : function(startDate, endDate) {
            var pdate = utils.date.diffDateAdd(endDate, -1, "y");
            if (utils.date.diffDate(startDate, pdate) > 0) {
                utils.dialog.alert("查询时间间隔不能大于1年", function() {
                    if (that.dateSelect && that.dateSelect == "START") {
                        var sdate = utils.date.diffDateAdd(startDate, 1, "y");
                        var formatDate1 = utils.date.formatTime(sdate).format("yyyy-MM-dd");
                        var formatDate2 = utils.date.formatTime(sdate).format("MM-dd");
                        that.ui.endDateBtn.attr("data-initDate", formatDate1);
                        $("#endDay").text(formatDate1);
                        that.ui.endDateText.text(formatDate2);
                    } else if (that.dateSelect && that.dateSelect == "END") {
                        var sdate = utils.date.diffDateAdd(endDate, -1, "y");
                        var formatDate1 = utils.date.formatTime(sdate).format("yyyy-MM-dd");
                        var formatDate2 = utils.date.formatTime(sdate).format("MM-dd");
                        that.ui.startDateBtn.attr("data-initDate", formatDate1)
                        $("#startDay").text(formatDate1);
                        that.ui.startDateText.text(formatDate2);
                    }
                    $("#selectDate").hide();
                    that.qryFirstPageData();
                });
            } else {
                $("#selectDate").hide();
                that.qryFirstPageData();
            }
        },
        _validateDateSlct : function(startDate, endDate) {
            if (utils.date.compareDate(startDate, endDate) == 1) {
                utils.dialog.toast("开始日期不能大于结束日期");
                return false;
            }
            return true;
        }
    });
});

