define(function(require,exports,module){
	var itemTemp = require("text!../../template/tradeRecordsInfo/tradeRecordsList.html");
	var detailsView = require("../tradeRecordsInfo/tradeRecordDetail");
	//var TransferTools = require("../tradeRecordsInfo/transferTools");


	var itemView = ItemView.extend({
		template: _.template(itemTemp),
		tagName: 'li',
		className: '',
		curProCode : null,
		hasDetail : true,
		initialize:function(){
			this.prdCode = App.storage.get('tradeRecordsInfo/prdCode');
			curProCode = this.prdCode;
			this.showCption();
		},
		showCption : function() {
			var prdCode = this.prdCode;
			switch(prdCode) {
				case config.values.zhaunZhang:
					itemTemp = require("text!../../template/tradeRecordsInfo/zhuanZhang.html");
					hasDetail = true;
					break;
				case config.values.transInInfo:
					itemTemp = require("text!../../template/tradeRecordsInfo/transInRecords.html");
					hasDetail = true;
					break;
				case config.values.jiaoYiJiLu:
					itemTemp = require("text!../../template/tradeRecordsInfo/tradeDetail.html");
					hasDetail = true;
					break;
				case config.values.fund_code_nanfang://平安盈南方
					itemTemp = require("text!../../template/tradeRecordsInfo/tradePay.html");
					hasDetail =false;
					break;
				case config.values.fund_code_dahua://平安盈大华
					itemTemp = require("text!../../template/tradeRecordsInfo/tradePay.html");
					hasDetail =false;
					break;
				case config.values.dinghuotong_code://定活通
					itemTemp = require("text!../../template/tradeRecordsInfo/tradeDinghuotong.html");
					hasDetail =false;
					break;
				case config.values.financial_code://理财产品
					itemTemp = require("text!../../template/tradeRecordsInfo/tradeLicai.html");
					hasDetail = true;
					break;
				case config.values.provide_code://养老产品
					itemTemp = require("text!../../template/tradeRecordsInfo/tradeYanglao.html");
					hasDetail = true;
					break;
				case config.values.auto_dinghuotong://智能定活通
					itemTemp = require("text!../../template/tradeRecordsInfo/tradeAutoDinghuotong.html");
					hasDetail = true;
					break;
				case config.values.nocardcash_code://无卡取现
					itemTemp = require("text!../../template/tradeRecordsInfo/noCardCashList.html");
					hasDetail = true;
					break;
				case config.values.pianganpiao://平安票
					itemTemp = require("text!../../template/tradeRecordsInfo/pinganpiao.html");
					hasDetail = true;
					break;
				case config.values.fundTransaction_code://基金成交记录
					itemTemp = require("text!../../template/tradeRecordsInfo/fundTransaction.html");
					hasDetail = true;
					break;
				case config.values.trustGoldTreasure_code://信托黄金宝
					itemTemp = require("text!../../template/tradeRecordsInfo/trustGoldTreasure.html");
					hasDetail = true;
					break;
				case config.values.bill_code://E企盈
					itemTemp = require("text!../../template/tradeRecordsInfo/tradeBill.html");
					hasDetail = true;
					break;
				case config.values.wanlitong_code://万里通
					itemTemp = require("text!../../template/tradeRecordsInfo/wanlitong.html");
					hasDetail = false;
					break;
				case config.values.fundStrong://每日盈
					itemTemp = require("text!../../template/tradeRecordsInfo/fundStrong.html");
					hasDetail = false;
					break;
				// case FUNDFIXEDINVEST://基金定投记录
				//     itemTemp = require("text!../../template/tradeRecordsInfo/fundFixedInvest.html");
				//     hasDetail = true;
				//     break;
			}
			this.template = _.template(itemTemp);
		},
		events : {
			"tap": "itemClick"
		},
		itemClick: function(e){
			this.triggerMethod('clicked');
		}
	});

	var emptyView = ItemView.extend({
		tagName: 'li',
		template: '<div class="w100 ma tac">查无记录</div>'
	});

	module.exports = CollectionView.extend({
		tagName: 'ul',
		itemView: itemView,
		//emptyView: emptyView,
		initialize:function(){
		},
		_setHead : function(url,headTitle) {
			App.header.reset({
				title : headTitle,
				leftButtonContent:"@back",
				leftButtonHandler : function(){
					App.navigate(url, true);
				}
			});

		},
		onItemviewClicked: function(itemView){
			if(!hasDetail) return;
			this.trigger('gotoDetailPage');
			var detailTitle = App.storage.get('me/transRecords/detailTitle');
			//var url = "me/tradeRecords/index/"+curProCode+'?'+Date.parse(new Date());
			var returnURL = App.storage.get('tradeRecordsInfo/returnURL');
			var url = null;
			if(returnURL&&returnURL.length>0) {
				url = 'me/tradeRecords/tadereturn?code='+curProCode+'&returnURL='+returnURL+'&now='+Date.parse(new Date());
			}else{
				url = "me/tradeRecords/index/"+curProCode+'?'+Date.parse(new Date());
			}
			var startDate = $("#startDate").attr("data-initDate");
			var endDate = $("#endDate").attr("data-initDate");
			App.storage.set('me/transRecords/startDate',{"startDate":startDate,"endDate":endDate});
			this._setHead(url,detailTitle);
			App.storage.remove('me/transRecords/detailTitle');
			$.extend(itemView.model, {"proCode":curProCode});
			App.container.show(new detailsView({
				model: itemView.model
			}));
		}
	});

});
