/**
 * @ex_huangzit
 * 资金转入
 */
define(function(require, exports, module) {
	var FormLayout = require("component/form");
	var transModel = require("../../model/transferModel");
	var safeKeyBoardHelper = require("component/customInput.helper");
	var transferInTpl = require("text!../../template/transfer/assetsTransIn.html");

	var transferInView = module.exports = FormLayout.extend({
		template : _.template(transferInTpl),
		events : {
			"focus #mobile"                   : "_showMobile",
			"input #mobile"                   : "_setFullFill",
			"tap #gotoBindCard"               : "_gotoBindCard",
			"tap #nextSubmit"                 : "_assetsTransInSmt",
			"tap #transInPattern"             : "_toTransOutPattern",
			"tap #supportBankLst"             : "_showSupportBankList",
			"tap #lastSuccBankInfo"           : "_toTransOutPattern",
			"jsClearIconHandler #mobile"      : "_clearMobileKP",
			"customInputKeyup #transInAmt"    : "_setFullFill",
			"customInputFocusIn #transInAmt"  : "_focusInAmount",
			"customInputFocusOut #transInAmt" : "_focusOutAmount"
		},

		initialize: function (options) {
			this.model = options.model;
		},

		onRender : function() {
			this._initAmountKeyboard();
			this._showDetial();
		},

		_showSupportBankList: function () {
			utils.window.open({
				title:"资金转入支持银行说明",
				url: 'https://ssl.pingan.com/bank/xieyi/pinganfu-xiane.html'
			});
		},

		_gotoBindCard:function(){
			App.navigate("me/accoutAndSecurity/bankManage/bindCard", true);
		},

		//初始化银行信息数据
		_showDetial:function(){
			var transferInData = App.storage.get("transferInData");
			if(transferInData && transferInData.amt){
				this.$("#transInAmt").customInput("value", utils.string.formatMoneyNumber(transferInData.amt));
			}
			if(this.model.get("bindCard")){
				var self = this,
					index = this.model.get("bindCard").index,
					sameBankFlag = this.model.get("bindCard").sameBankFlag,
					mobileNumber = this.model.get("bindCard").mobileNumber;

				if(mobileNumber) this.mobileNumber = mobileNumber;

				if(sameBankFlag == '1') { //本贷本展示借记卡余额
					transModel.qryBalanceOfOwn({
						"url": "qryBalanceOfOwn",
						"data": { index:index },
						"callback": function (resp) {
							var sameBankMoney = self.sameBankMoney = resp.object.balance;
							self.$("#sameBankMoney").text(utils.string.formatMoneyNumber(sameBankMoney));
						},
						"errorCallback": function (resp) {
							utils.dialog.alert(resp.message);
						}
					});
				}
				this._setFullFill();
			}

			//校验‘下一步’按钮是否置灰
			// var bindCard = App.storage.get("payBankOptions");
			// if(bindCard) this._setFullFill();
		},

		// //展示手机号
		_showMobile:function(){
			var mobile = this.$("#mobile").val();
			if(!mobile)
				this.mobileNumber = '';
			else
				this.$("#mobile").val(this.mobileNumber.replace(/\s/g, ""));
		},

		_clearMobileKP: function(){
			this.mobileNumber = '';
			this._setFullFill();
		},

		//初始化交易金额控件
		_initAmountKeyboard:function(){
			this.$("#transInAmt").customInput({
				type: "decimal",
				placeholder: "输入你的转入金额",
				className:"safeKeyBoard",
				maxLength:"10"
			});
		},

		_focusInAmount: function(){
			safeKeyBoardHelper.focusIn({ id:"transInAmt" });
		},

		_focusOutAmount: function(){
			safeKeyBoardHelper.focusOut({ id:"transInAmt" });
		},

		_toTransOutPattern:function(){
			//到绑定账号页面
			var transInAmt = this.$("#transInAmt").customInput("value");
			if(App.storage.get("transBindAccList").length != 0){
				App.storage.set("transferInData", {amt: transInAmt});
				App.navigate("me/transferIn/toTransInPettern", true);
			}else{
				//绑定账号为空时，转到提示页面
				App.navigate("me/transferIn/assetsTransInUnbindAcc",true);
			}
		},

		_setFullFill: function () {
			var options = this._formData();
			var btnFun = _.bind(function (btnFlag) {
				if (btnFlag) {
					this.enabledBtn();
				} else {
					this.disabledBtn();
				}
			}, this);

			if(options.sameBankFlag == '0'){
				btnFun(options.amt && options.mobileNumber);
			}else{
				btnFun(options.amt);
			}
		},

		disabledBtn: function () {
			if (this.$('#nextSubmit').hasClass("btn_orange")) this.$('#nextSubmit').removeClass('btn_orange');
			this.$('#nextSubmit').addClass("btn_disable");
		},

		enabledBtn: function () {
			if (this.$('#nextSubmit').hasClass("btn_disable")) this.$('#nextSubmit').removeClass('btn_disable');
			this.$('#nextSubmit').addClass("btn_orange");
		},

		//转入提交(修改ex_huangzit 2015-03-19)
		_assetsTransInSmt:function(){
			if(this.$("#nextSubmit").hasClass("btn_disable")) return;
			var formData = this._formData();
			if(this._validateData(formData)){
				if(formData.sameBankFlag == "1"){
					this.sameBankNextCheck(formData);
				}else{
					if(formData.supportFlag == '0'){
						utils.dialog.alert("此卡暂不支持转入，我们正在加急开发支持中...");
						return;
					}
					this._toTransByYWT(formData);
				}
			}
		},

		//获取数据
		_formData: function () {
			var bindCard = this.model.get("bindCard"),
				userInfo = App.storage.get("UserInfo").toJSON(),
				amt = (this.$("#transInAmt").customInput("value").replace(/,/g, "")) * 1, //获取金额
				userRemark = '橙子银行资金转入';
			var fromData = {
				index : bindCard.index,
				amt : amt,
				userRemark : userRemark,
				trueName : userInfo.trueName,
				toAccNum : userInfo.accNumber,
				supportFlag : bindCard.supportFlag,
				sameBankFlag : bindCard.sameBankFlag,
				fromAccNum : bindCard.accNum || bindCard.fromAccNum,
				fromBankName : bindCard.bankName || bindCard.fromBankName,
				fromBankCode : bindCard.bankCode || bindCard.fromBankCode
			};
			//0-未接入，1-接入银网通，2-接入银联
			if(bindCard.supportFlag == '1' || bindCard.supportFlag == '2'){
				var mobileNumber = this.$("#mobile").val();
				if(mobileNumber) mobileNumber = mobileNumber.replace(/\s/g, ""); //手机号
				_.extend(fromData, {mobileNumber : mobileNumber});
			}
			return fromData;
		},

		//校验数据
		_validateData: function(options){
			//校验金额
			if(options.amt === 0){
				utils.dialog.toast("请输入转入金额");
				return false;
			}

			//银网通
			if(options.sameBankFlag == 0){
				if (!options.mobileNumber) {
					utils.dialog.toast("请输入手机号。");
					return false;
				}

				if (!utils.validate.phone(options.mobileNumber)) {
					utils.dialog.toast("你输入的手机号不符合规范。");
					return false;
				}
			}else{
				if(this.sameBankMoney && options.amt > this.sameBankMoney.replace(/,/g,'')){
					utils.dialog.toast("您的账户可用余额不足!");
					return false;
				}
			}
			return true;
		},

		//银网通代扣
		submitFlag : false,
		_toTransByYWT:function(options){
			var data = {
				"index"        : options.index,
				"amt"          : options.amt,
				"mobileNumber" : options.mobileNumber,
				"remark"       : options.userRemark
			};
			var self = this;
			self.submitFlag = true;
			transModel.checkTransferIn({
				"url": "checkTransferIn",
				"data": data,
				"callback": function (response) {
					options.transToken = response.object.transToken;
					App.storage.set("payBankOptions", options);
					self.submitFlag = false;
					App.navigate("me/transferIn/transInByYWT", true);
				},
				"errorCallback": function (response) {
					//重置重复提交标识
					self.submitFlag = false;
					utils.dialog.alert(response.message);
				}
			});
		},

		//本行转账校验（wuwenjun059）
		sameBankNextCheck:function(transferInData){
			transModel.sameBankEnterCheckTwo({
				"url" : "sameBankEnterCheckTwo",
				"data" : {
					index : transferInData.index,
					transferPriority:"2",
					transferAmount : transferInData.amt
				},
				"callback" : function(resp) {
					App.storage.set("transferInData",
					$.extend({whichWay:"sameBank"}, transferInData, resp.object));
					App.navigate("me/transferIn/transferInNext", true);
				},
				"errorCallback" : function(resp) {
					utils.dialog.alert(resp.message);
				}
			});
		}
	});
});