/**
 * EX-WUWENJUN
 * 确定同行转入View
 *
 */
define(function(require, exports, module){
	var FormComponent      = require("component/form");
	var template           = require("text!../../template/transfer/nextSameTransIn.html");
	var OtpView            = require("component/otp/OtpView");
	var safeKeyBoardHelper = require("component/customInput.helper");
	var transModel         = require("../../model/transferModel");

	var IndexView = module.exports = FormComponent.extend({
		template : _.template(template),

		events: {
			"customInputFocusIn #passInput"  : "_onCustomInputFocusInPass",
			"customInputFocusOut #passInput" : "_onCustomInputFocusOutPass",
			"input #otp_passWord"            : "_onCustomInputInputPwd",
			"customInputKeyup #passInput"    : "_onCustomInputInputPwd",
			"jsClearIconHandler #passInput"  : "_onCustomInputInputPwd",
			"tap #transInSubmit"             : "transInSubmit",
			"tap #otpView .js-clear-input"   : "_onCustomInputInputPwd"
		},

		onRender : function(){
			//银行卡交易密码框
			this.$("#passInput").customInput({
				type: "password-number",
				placeholder: "输入银行卡交易密码",
				maxLength: 6,
				className: "safeKeyBoard"
			});
			var transferAmt = App.storage.get("transferInData").amt;
			var trueName = App.storage.get("UserInfo").get("trueName");
			//发送otp到银行卡绑定的手机号码
			var options = {
				isOtpSended: true,
				otpSendFlag: "0",
				isNeedSendOtpValidate: false,
				isQryOtpPhoneNo: true,
				isMobilePhoneByUser: false,
				callbackError: function () {
				},
				callbackSubmit: function () {
				},
				cat : config.values.transferInConfirmOfOwn,
				values : transferAmt + "|" + trueName
			};
			this.otpView = new OtpView();
			this.otpView.initOtp(options);
			this.$("#transOtp").empty();
			var $el = $(this.otpView.$el[0]);
			this.$("#transOtp").append($(this.otpView.$el[0]));
			$el.find('div[class="f16"]').width(64);
		},

		_onCustomInputFocusInPass: function(){
			safeKeyBoardHelper.focusIn({ id:"passInput" });
		},

		_onCustomInputFocusOutPass: function(){
			safeKeyBoardHelper.focusOut({ id:"passInput" });
		},

		//改变确认转出按钮
		_onCustomInputInputPwd: function () {
			var passInput = this.$("#passInput").customInput("value");   //获取交易密码
			var otpValue = this.$("#otp_passWord").val();  //获取动态密码
			if(passInput!="" && otpValue!=""){
				this.$("#transInSubmit").removeClass("btn_disable").addClass("btn_orange");
			}else{
				this.$("#transInSubmit").removeClass("btn_orange").addClass("btn_disable");
			}
		},

		//确定转入
		transInSubmit: function () {
			if (this.$("#transInSubmit").hasClass("btn_orange") && this.validate()) {
				var data = {};
				var password = this.$("#passInput").customInput("value");
				var otp = this.otpView.getValue();
				data.password = utils.crypto.RSAKey.encrypt(password, config.base.rsa_public_key);
				data.sm2Pwd = utils.sm2.SM2Key.encrypt(password, config.base.sm2_public_key);
				data.otp = this.otpView.getValue();
				// 调用同行转账确认提交接口
				transModel.sameBankEnterConfirm({
					"url": "sameBankEnterConfirm",
					"data": data,
					"callback": function (response) {
						// 缓存转账成功返回数据
						//App.storage.set("transferSuccessData",response.object);
						App.storage.set("transInSuccAmt", App.storage.get("transferInData").amt);
						App.storage.remove("payBankOptions");
						App.storage.remove("transferInData");
						App.storage.remove("gatheringSwitch");
						App.storage.remove("transBindAccList");
						//删除我的资产缓存信息
						App.requester.storage.remove("loginedAccountInfo");
						// 跳转到转账成功页
						App.navigate("me/transferIn/toTransInSucc", true);
					},
					"errorCallback": function (response) {
						// 重置重复提交标识
						//transConfirmView.isSubmited = "0";
						utils.dialog.alert(response.message);
					}
				});
			}
		},

		validate : function(){
			var password = this.$("#passInput").customInput("value");
			var otp = this.otpView.getValue();
			if (!password) {
				utils.dialog.toast("请输入银行卡交易密码！");
				return false;
			}
			if(!otp){
				this.otpView.setCustomValidity("请输入动态密码！");
				return false;
			}
			return true;
		}
	});
});