/**
 * EX-WUWENJUN
 * 选择开户行View
 * 
 */

define(function(require, exports, module){
    
   var FormComponent = require("component/form"); 
   var template = require("text!../../template/transfer/openBankSelect.html");
   var transferLang   = require("../../common/transferLang");
   var transferTools  = require("../../common/transferTools");
   var transModel     = require("../../model/transferModel");
   var initPTRScroll = require('mod/common/widget/initPTRScroll');
   
   var IndexView =  module.exports =  FormComponent.extend({
        template : _.template(template),
          
        regions : {
              
        },

        events : {
        	"input #OpenBankInput"     : "filterOpenBank",     //筛选开户行
            "tap #OpenBankBox li"  : "writeOpenBank"  //写入开户行

        },

        initialize:function(options){
        	this.model = options.model;
        },
        
        onShow : function(){
            var gap = 40;
            if (IS_RUN_ON_DEVICE)
                gap = 44;
            initPTRScroll.call(this, {
                gap : gap,
                pullDownToRefresh : false
            });
        	var openBankList = this.model.get("openBankList");
        	var cacheData = App.storage.get("transferData");
        	if(cacheData.executeType == "2"){
        		if(cacheData.realBankId){
                	this.$("#OpenBankBox li[data-recBankId="+cacheData.realBankId+"]").append("<i class='iconA59'></i>");
	        	}
        	}else{
        		if(cacheData.bankId){
        			this.$("#OpenBankBox li[data-recBankId="+cacheData.bankId.substr(0,3)+"]").append("<i class='iconA59'></i>");
	        	}
        	}
        },
        
        /**
         *
         * 筛选开户行
         *
         */
        filterOpenBank : function(e) {
            
            var keyWord = $(e.currentTarget).val().replace(/\s/g,"").toUpperCase();
            //分组排序后的数组
            var openBankList = this.model.get("openBankList");
             //根据拼音匹配
            var filterList = [];

            // 关键字为空时显示所有
            if(keyWord == "") {
            	$("#selRecBankInfo,hr").show();
            	$("#searchBank,#searchNoResult").hide();
                filterList = openBankList;
                App.storage.set("filterOpenBankList",filterList);
            }else {
            	$("#selRecBankInfo,hr").hide();
            	$("#searchBank").show();
                _.each(openBankList,function(item,i){
                    if(item.recBankName.indexOf(keyWord) >= 0) {
                        filterList.push(item);
                    }
                });
                App.storage.set("filterOpenBankList",filterList);
            }

            // 重新生成城市列表选项
            if(filterList.length == 0) {
                 // 清空所有城市列表
                $("#OpenBankBox").html("");
                $("#searchNoResult").show();
            }else{
            	$("#searchNoResult").hide();
                var OpenBankListHtml = "<div class='Columns b_t0'><ul class='ulStyle1 fannyulStyle1'>";
                _.each(filterList,function(item,i) {
                    OpenBankListHtml+='<li class="dswkb" data-recBankId="'+item.recBankId+'" data-index="'+i+'">'
					                    +'<p class="tac ibank_daf ibank_'+item.recBankId.substr(0,3)+'"></p>'
				                	    +'<div class="m_l10 flex1">'
									   		+'<p class="c_333">'+item.recBankName+'</span></p>'
								    	+'</div>'
				                       +'</li>';
                });
                OpenBankListHtml+="</ul></div>";
                $("#OpenBankBox").html(OpenBankListHtml);
            }
            this.scroller && this.scroller.refresh();
        },

        /**
         * 写入开户行
         */
        writeOpenBank : function(e) {
            if(this.submitFlag){
                return;
            }
            var self = this;
            self.submitFlag = true;
        	var bindAcc = self.model.attributes.bindAcc;
            var cacheData = App.storage.get("transferData");
            var list  = App.storage.get("filterOpenBankList") || self.model.get("openBankList");
            var index = $(e.currentTarget).attr("data-index");
            $("#OpenBankBox li i").remove();
            $(e.currentTarget).append("<i class='iconA59'></i>");
            var data  = list[index];
            data.bindAccountSel = bindAcc.bindAccount;   //选择的银行卡
            cacheData.toAccNo     = bindAcc.bindAccount;   //选择的银行卡账号
            cacheData.toAccountText     = bindAcc.bankName;   //选择的银行卡
            cacheData.bankName       = data.recBankName;
            //实时时改变实时联行号缓存否则改变普通/加急开户行缓存
            if(cacheData.executeType == 2){
                cacheData.realBankId     = data.recBankId;
            }else{
                cacheData.bankId     = data.recBankId;
            }
            cacheData.isSameBank   = bindAcc.sameBankFlag==1;  //收否是同行转账
            cacheData.branchBankName = "";
            cacheData.cityName = "";
            cacheData.provinceName = "";
            App.storage.remove("filterOpenBankList");
            App.storage.remove("transfer_cityData");
            App.storage.remove("selectedBranchBankInfo");
            App.storage.remove("transfer_bankBinItem")
            App.storage.set("selectedBankInfo",data);
            setTimeout(function(){
                App.navigate("me/transfer/transferView",true);
            },300);
            //App.navigate("me/transfer/bindAccSelect",true);
            //utils.dialog.toast("为保证转账成功，请您确认，银行卡号（"+bindAcc.bindAccount+"）开户银行为“"+data.recBankName+"”");
            //App.navigate("transfer/transfer/index/1", true);
        }
		
		
  });
});
