/**
 * ex_huangzit 2016-02-29
 * 银网通代扣方式
 */
define(function (require, exports, module) {
	var OtpView            = require("component/otp/OtpView");
	var FormComponent      = require("component/form");
	var transModel         = require("../../model/transferModel");
	var safeKeyBoardHelper = require("component/customInput.helper");
	var template           = require("text!../../template/transfer/transInByYWT.html");

	module.exports = FormComponent.extend({
		template: _.template(template),
		events: {
			"input #mobile"                  : "_setFullFill",
			"input #otp_passWord"            : "_setFullFill",
			"tap #transInSubmit"             : "transInSubmit",
			"customInputKeyup #passInput"    : "_setFullFill",
			"jsClearIconHandler #passInput"  : "_onCustomInputInputPwd",
			"tap #otpView .js-clear-input"   : "_onCustomInputInputPwd",
			"customInputFocusIn #passInput"  : "_onCustomInputFocusInPass",
			"customInputFocusOut #passInput" : "_onCustomInputFocusOutPass"
		},

		initialize: function (options) {
			this.model = options.model;
			this.submitFlag = false;  // 防重复提交标志
		},

		onRender: function () {
			this._showPwd();//银行卡交易密码框
			this._showOTP();//发送otp到银行卡绑定的手机号码
		},

		//银行卡交易密码框
		_showPwd: function () {
			this.$("#passInput").customInput({
				type: "password-number",
				placeholder: "请输入橙子账户交易密码",
				maxLength: 6,
				className: "safeKeyBoard"
			});
			//this.$("#passInput").find('input[type="password"]').css('padding-top', '0px');//调整密码框的placeholder样式
		},

		//OTP展示
		_showOTP: function () {
			//发送otp到银行卡绑定的手机号码
			var options = {
				isOtpSended: true,
				otpSendFlag: "0",
				isNeedSendOtpValidate: false,
				isQryOtpPhoneNo: true,
				isMobilePhoneByUser: false,
				callbackError: function () { },
				callbackSubmit: function () { },
				resendBtnHandler: _.bind(this.resendBtnHandler, this),
				cat: config.values.transInCat,
				phone: this.model.get('transferInData').mobileNumber
			};
			this.otpView = new OtpView();
			this.otpView.initOtp(options);
			this.$("#transOtp").empty();
			var $el = $(this.otpView.$el[0]);
			this.$("#transOtp").append($el);
			$el.find('div[class="f16"]').width(64);
		},

		resendBtnHandler: function () {
			var mobile = this.model.get('transferInData').mobileNumber;
			//手机号码
			if (!mobile) {
				this.newIphoneInput.setCustomValidity("请输入手机号");
				return false;
			}
			if (mobile && !utils.validate.phone(mobile)) {
				this.newIphoneInput.setCustomValidity("手机号错误");
				return false;
			}
			this.otpView.sendSmsOTP("sendByPhoneNo", {
				"mobileNo": mobile,
				cat: config.values.transInCat
			});
		},

		_onCustomInputFocusInPass: function () {
			safeKeyBoardHelper.focusIn({ id: "passInput" });
		},

		_onCustomInputFocusOutPass: function () {
			safeKeyBoardHelper.focusOut({ id: "passInput" });
		},

		//input事件控制提交按钮是否disabled
		_setFullFill: function () {
			var options = this._transData();
			var btnFun = _.bind(function (btnFlag) {
				if (btnFlag) {
					this.enabledBtn();
				} else {
					this.disabledBtn();
				}
			}, this);
			btnFun(options.otp && options.password);
		},

		disabledBtn: function () {
			if (this.$('#transInSubmit').hasClass("btn_orange")) this.$('#transInSubmit').removeClass('btn_orange');
			this.$('#transInSubmit').addClass("btn_disable");
		},

		enabledBtn: function () {
			if (this.$('#transInSubmit').hasClass("btn_disable")) this.$('#transInSubmit').removeClass('btn_disable');
			this.$('#transInSubmit').addClass("btn_orange");
		},

		//银网通代扣转入
		transInSubmit: function () {
			var self = this;
			var options = this._transData();
			if (!this.submitFlag && this.$("#transInSubmit").hasClass("btn_orange") && this._validate(options)) {
				options.sm2Pwd = utils.sm2.SM2Key.encrypt(options.password,config.base.sm2_public_key);
				options.password = utils.crypto.RSAKey.encrypt(options.password, config.base.rsa_public_key);
				var payBankOptions = App.storage.get("payBankOptions");
				var data = _.pick(_.defaults(options, payBankOptions),
					'password', 'otp', 'transToken','sm2Pwd');
				this.submitFlag = true;
				//银网通代扣校验接口
				transModel.confirmTransferIn({
					"url": "confirmTransferIn",
					"data": data,
					"callback": function (response) {
						//缓存转账成功返回数据
						self.submitFlag = false;
						self._clearTempData();
						//跳转到10S倒计时页
						self._resultComfirmTime(payBankOptions.amt);
					},
					"errorCallback": function (response) {
						self.submitFlag = false;
						var payBankOptions = App.storage.get("payBankOptions");
						if(response.object){
							payBankOptions.transToken = response.object;
							App.storage.set("payBankOptions", payBankOptions);
						}
						//重置重复提交标识
						utils.dialog.alert(response.message);
					}
				});
			}
		},

		//十秒倒计时
		_resultComfirmTime: function (transInAmt) {
			var self = this;
			self.$("#mask").show();
			var countTime = 9;
			var cInterval = setInterval(function () {
				if (countTime <= 0) {
					clearInterval(cInterval);
					transModel.dealResultTransferIn({
						"url": "dealResultTransferIn",
						"callback": function (response) {
							self.submitFlag = false;
							self.$("#mask").hide();
							var dealStatus = response.object.dealStatus;
							if (dealStatus) App.storage.set("transYWT/dealStatus", { 'dealStatus': dealStatus, 'transInAmt': transInAmt });
							App.navigate("me/transferIn/transInByYWTResult", true);
						},
						"errorCallback": function (response) {
							self.submitFlag = false;
							self.$("#mask").hide();
							utils.dialog.alert(response.message);
						}
					});
				}
				self.$('#countTime').html(countTime);
				countTime--;
			}, 1000);
		},

		_clearTempData: function () {
			App.storage.remove("payBankOptions");
			App.storage.remove("transferInData");
			App.storage.remove("transBindAccList");
		},

		//数据
		_transData: function () {
			var options = {};
			options.otp = this.otpView.getValue();
			options.password = this.$("#passInput").customInput("value");
			// options.mobileNumber = this.model.get('mobileNumber') ?
			//     this.model.get('mobileNumber') : this.$("#mobile").val();
			return options;
		},

		//校验数据
		_validate: function (options) {
			//校验密码
			if (!options.password) {
				utils.dialog.toast("请输入银行卡交易密码！");
				return false;
			}
			//校验动态码
			if (!options.otp) {
				this.otpView.setCustomValidity("请输入动态密码！");
				return false;
			}
			return true;
		}
	});
});