/**
 * EX-WUWENJUN
 * 转出View
 *
 */

define(function (require, exports, module) {

    var FormComponent = require("component/form");
    var template = require("text!../../template/transfer/transfer.html");
    var transferLang = require("../../common/transferLang");
    var safeKeyBoardHelper = require("component/customInput.helper");
    var transferTools = require("../../common/transferTools");
    var transModel = require("../../model/transferModel");
    var OtpView = require("component/otp/OtpView");
    var CustomPwdOtpInput = require("component/password/customPwdOtpInput");

    var IndexView = module.exports = FormComponent.extend({
        template: _.template(template),

        regions: {

        },

        events: {
            "tap #bindAccSelect": "toAccSelect",    //选择账号
            "tap #transferModeSel": "toTransferModeSel",  //选择转账模式
            "tap #cityInfo": "toCityInfo",  //选择城市
            "tap #branchBankInfo": "changeBranchBank", //选择开户网点
            "customInputFocusIn #transferAmt": "_onCustomInputFocusInAmount",
            "customInputFocusOut #transferAmt": "_onCustomInputFocusOutAmount",
            "tap #comfirmSubmmit": "comfirmSubmmit"   //确定转出

        },

        initialize: function (options) {
            this.isSubmited = "0";
            //银行卡绑定入口(默认选中收款账号)
            var selAccNoDaf = App.storage.get("me/accoutAndSecurity/bankManage/transferOut");
            App.storage.remove("me/accoutAndSecurity/bankManage/transferOut");
            if (selAccNoDaf) {
                var bindAccList = App.storage.get("bindAccount").list;
                _.each(bindAccList, function (item, i) {
                    if (item.bindAccount == selAccNoDaf) {
                        App.storage.set("selectedAccount", item);
                    }
                });
            }
        },

        onRender: function () {

        },

        onShow: function () {
            var transView = this;
            var placaholderAtm = "";

            //获取当前转出账号信息
            var toAccountInfo = App.storage.get("selectedAccount");
            //开户城市
            var provinceAndCity = App.storage.get("transfer_cityData");
            //获取开户网点
            var selectedBranchBankInfo = App.storage.get("selectedBranchBankInfo");
            //转账限额
            var transferLimit = App.storage.get("transferLimit");
            var dailyRemain = parseFloat(transferLimit.dailyLimit) - parseFloat(transferLimit.dailySum);
            //梦想立即提款
            var immediatelyTransfer = App.storage.get("immediatelyTransfer");

            // 获取转账缓存数据
            var cacheData = App.storage.get("transferData");
            if (cacheData) {
                // 转入账户（账号【名字】银行名称）
                var toAccountText = cacheData.toAccountText;
                //尾号
                var toAccNo = "尾号" + cacheData.toAccNo.substring(cacheData.toAccNo.length - 4, cacheData.toAccNo.length);
                //是否同行
                var isSameBank = cacheData.isSameBank;
                //获取转账模式
                var transferMode = cacheData.executeType;
                //转出金额
                var transferAmt = utils.string.formatMoneyNumber(cacheData.transAmt);
                //var userRemark     = cacheData.userRemark;
                var bankName = cacheData.bankName;
                //城市名称
                var provinceName = cacheData.provinceName;
                var cityName = cacheData.cityName;
                //开户网点
                var branchBankName = cacheData.branchBankName;
                //实时联行号
                var realBankId = cacheData.realBankId;
                var bankId = cacheData.bankId;
                //活期余额
                var balance = cacheData.balance;
                //旧的转账模式
                var oldTransferMode = cacheData.oldExecuteType;


                //切换到账时间  如果已选择收款账号切换与未选择收款账号切换到账时间（2实时 1普通 0加急）
                if (toAccountInfo) {
                    if (oldTransferMode && oldTransferMode != transferMode) {
                        App.storage.remove("transfer_cityData");
                        App.storage.remove("selectedBranchBankInfo");
                        App.storage.remove("selectedBankInfo");
                        provinceAndCity = "";
                        selectedBranchBankInfo = "";
                        if (transferMode == 2) {
                            var realId = toAccountInfo.ibpsBankId;
                            if (realId) {
                                this.$("#toAccountInput").attr("data-realBankId", realId);
                                $("#toAccountInput p:first").text(toAccountText);
                                $("#toAccountInput p:last").text(toAccNo);
                                $("#firstToAcc").hide();
                                $("#accImg,#toAccountInput").show();
                            } else {
                                //卡Bin匹配开户行
                                var bankBinList = App.storage.get("bankBinList");
                                var bankBinItem = "";
                                var accNumber = cacheData.toAccNo.substr(0, 6);
                                _.each(bankBinList, function (item, i) {
                                    if (item.cardBin == accNumber) {
                                        bankBinItem = item;
                                        App.storage.set("transfer_bankBinItem", bankBinItem);
                                    }
                                });
                                if (bankBinItem) {
                                    realBankId = bankBinItem.bankCode;
                                    $("#toAccountInput p:first").text(toAccountText);
                                    $("#toAccountInput p:last").text(toAccNo);
                                    $("#firstToAcc").hide();
                                    $("#accImg,#toAccountInput").show();
                                } else {
                                    $("#toAccountInput p:first").text("");
                                    $("#toAccountInput p:last").text("");
                                    App.storage.remove("selectedAccount");
                                    App.storage.remove("selectedBankInfo");
                                    $("#firstToAcc").show();
                                    $("#accImg,#toAccountInput").hide();
                                }

                            }
                        } else {
                            bankId = toAccountInfo.bankid;
                            if (bankId) {
                                $("#toAccountInput p:first").text(toAccountText);
                                $("#toAccountInput p:last").text(toAccNo);
                                this.$("#toAccountInput").attr("data-bankId", bankId);
                                $("#firstToAcc").hide();
                                $("#accImg,#toAccountInput").show();
                            } else {
                                //卡Bin匹配开户行
                                var bankBinList = App.storage.get("bankBinList");
                                var bankBinItem = "";
                                var accNumber = cacheData.toAccNo.substr(0, 6);
                                _.each(bankBinList, function (item, i) {
                                    if (item.cardBin == accNumber) {
                                        bankBinItem = item
                                    }
                                });
                                if (bankBinItem) {
                                    $("#toAccountInput p:first").text(toAccountText);
                                    $("#toAccountInput p:last").text(toAccNo);
                                    $("#toAccountInput").attr("data-bankId", bankBinItem.bankCode);
                                    $("#firstToAcc").hide();
                                    $("#accImg,#toAccountInput").show();
                                    App.storage.set("transfer_bankBinItem", bankBinItem);
                                } else {
                                    $("#toAccountInput p:first").text("");
                                    $("#toAccountInput p:last").text("");
                                    App.storage.remove("selectedAccount");
                                    App.storage.remove("selectedBankInfo");
                                    $("#firstToAcc").show();
                                    $("#accImg,#toAccountInput").hide();
                                }
                            }
                        }
                    } else {
                        var transferBankBin = App.storage.get("transfer_bankBinItem");
                        //卡Bin存在 到账时间为2实时或1普通 0加急时页面属性赋值
                        if (transferBankBin) {
                            if (transferMode == 2) {
                                this.$("#toAccountInput").attr("data-realBankId", transferBankBin.bankCode);
                            } else {
                                this.$("#toAccountInput").attr("data-bankId", transferBankBin.bankCode);
                            }
                            bankName = transferBankBin.bankName;
                        } else {
                            this.$("#toAccountInput").attr("data-bankId", bankId);
                        }
                        $("#toAccountInput p:first").text(toAccountText);
                        $("#toAccountInput p:last").text(toAccNo);
                        // 还原转入账户
                        if (toAccNo != "") {
                            $("#firstToAcc").hide();
                            $("#accImg,#toAccountInput").show();
                        }
                    }
                } else {
                    $("#toAccountInput p:first").text("");
                    $("#toAccountInput p:last").text("");
                    // 还原转入账户
                    if (cacheData.toAccNo != "") {
                        $("#firstToAcc").hide();
                        $("#accImg,#toAccountInput").show();
                    }
                }


                var bindAccount = App.storage.get("bindAccount").list;
                _.each(bindAccount, function (item, i) {
                    if (item.bindAccount == cacheData.toAccNo) {
                        $("#toAccountInput").attr({"data-index": i});
                    }
                });
                // 如果选择是平安银行账号，则隐藏转账模式行，否则显示
                if (isSameBank) {
                    $("#cityInfo").hide();
                    $("#branchBankInfo").hide();
                    cacheData.executeType = "2";
                    transferMode = "2";
                } else {
                    // 实时转账模式
                    if (transferMode == 2) {
                        if (transferLimit.dailyLimit > 50000) {
                            dailyRemain = 50000 - parseFloat(transferLimit.dailySum);
                        }
                        //实时联行号
                        $("#toAccountInput").attr("data-realBankId", realBankId);

                        if (bankName) {
                            // 还原选择的开户行
                            $("#cityInfo").hide();
                            $("#branchBankInfo").hide();
                        } else {
                            $("#cityInfo").hide();
                            $("#branchBankInfo").hide();
                        }
                    } else {
                        if (toAccountInfo) {
                            if (!provinceAndCity && !selectedBranchBankInfo) {
                                if (toAccountInfo.provinceName && toAccountInfo.cityName && toAccountInfo.cityCode && toAccountInfo.provinceCode) {
                                    $("#citySelect span").html(toAccountInfo.provinceName + '，' + toAccountInfo.cityName).removeClass("c_ccc");
                                } else {
                                    $("#citySelect span").html('请选择开户城市').addClass("c_ccc");
                                }
                                //如果开户网点存在
                                if (toAccountInfo.provinceCode && toAccountInfo.cityCode) {
                                    // 根据开户行、省份和城市重新查询支行信息
                                    transModel.queryBranchBankList({
                                        "url": "queryBranchBankList",
                                        "data": {
                                            "openAccBankSortCode": bankId.substr(0, 3),
                                            "openAccBankSort": toAccountInfo.bankName,
                                            "province": toAccountInfo.provinceCode,
                                            "cityId": toAccountInfo.cityCode,
                                            "cityName": toAccountInfo.cityName
                                        },
                                        "callback": function (response) {
                                            //填充开户网点信息
                                            $.each(response.object.branchBankList, function (i, item) {
                                                if (item.branchBankId == bankId) {
                                                    transView.$("#branchBankInput").text(item.branchBankName).removeClass("c_ccc");
                                                    return false;
                                                }
                                            });
                                        },
                                        "errorCallback": function () {
                                            utils.dialog.alert("查询支行信息出错！");
                                        }
                                    });
                                }
                            } else if (provinceAndCity && !selectedBranchBankInfo) {
                                if (provinceName && cityName) {
                                    $("#citySelect span").html(provinceName + '，' + cityName).removeClass("c_ccc");
                                } else {
                                    $("#citySelect span").html('请选择开户城市').addClass("c_ccc");
                                }
                                $("#branchBankInput").text("请选择开户网点").addClass("c_ccc");
                            } else if (provinceAndCity && selectedBranchBankInfo) {
                                if (provinceName && cityName) {
                                    $("#citySelect span").html(provinceName + '，' + cityName).removeClass("c_ccc");
                                } else {
                                    $("#citySelect span").html('请选择开户城市').addClass("c_ccc");
                                }
                                $("#branchBankInput").text(branchBankName).removeClass("c_ccc");
                            } else if (!provinceAndCity && selectedBranchBankInfo) {
                                if (toAccountInfo.provinceName && toAccountInfo.cityName) {
                                    $("#citySelect span").html(toAccountInfo.provinceName + '，' + toAccountInfo.cityName).removeClass("c_ccc");
                                } else {
                                    $("#citySelect span").html('请选择开户城市').addClass("c_ccc");
                                }
                                $("#branchBankInput").text(branchBankName).removeClass("c_ccc");
                            }
                        } else {
                            // 跨行转账模式，如果有选择过补充开户信息，则还原开户行、省份、城市和开户支行
                            if (bankName) {

                                if (provinceName && cityName) {
                                    $("#citySelect span").html(provinceName + '，' + cityName).removeClass("c_ccc");
                                } else {
                                    $("#citySelect span").html('请选择开户城市').addClass("c_ccc");
                                }
                                if (branchBankName != "") {
                                    $("#branchBankInput").text(branchBankName).removeClass("c_ccc");
                                }
                            }
                        }

                    }
                }
                if (dailyRemain < 0) {
                    dailyRemain = 0;
                }
                //placaholderAtm = "最多可转出"+utils.string.formatMoneyNumber(dailyRemain);
                if (immediatelyTransfer) {
                    this.$("#transferAmt").append('<div class="flex1"><input type="text" class="spaninput" maxlength="10" placeholder="请输入转出金额" disabled="disabled"><i class="twinkling"></i></div>');
                    this.$("#transferAmt input").val(immediatelyTransfer.dreamBudget);
                } else {
                    this.$("#transferAmt").customInput({
                        type: "decimal",
                        placeholder: "请输入转出金额",
                        className: "safeKeyBoard",
                        maxLength: "10"
                    });
                    // 还原转账金额
                    if (transferAmt != 0) {
                        this.$("#transferAmt").customInput("value", transferAmt);
                    }
                }
                // 还原转账模式
                $("#transferMode span").attr("transferMode", transferMode);
                var transferModeText = transferTools.getTransferModeDesc(transferMode);
                $("#transferMode span").text(transferModeText);
            } else {
                $("#cityInfo").hide();
                $("#branchBankInfo").hide();
                if (dailyRemain < 0) {
                    dailyRemain = 0;
                }
                //梦想立即提款
                if (immediatelyTransfer) {
                    this.$("#transferAmt").append('<div class="flex1"><input type="text" class="spaninput" maxlength="10" placeholder="请输入转出金额" disabled="disabled"><i class="twinkling"></i></div>');
                    this.$("#transferAmt input").val(immediatelyTransfer.dreamBudget);
                } else {
                    //placaholderAtm = "最多可转出"+utils.string.formatMoneyNumber(dailyRemain);
                    this.$("#transferAmt").customInput({
                        type: "decimal",
                        placeholder: "请输入转出金额",
                        className: "safeKeyBoard",
                        maxLength: "10"
                    });
                }
                if (toAccountInfo) {
                    if (toAccountInfo.ibpsBankId || (toAccountInfo.sameBankFlag == 1)) {
                        var toAccNo = "尾号" + toAccountInfo.bindAccount.substring(toAccountInfo.bindAccount.length - 4, toAccountInfo.bindAccount.length);
                        var toAccountText = toAccountInfo.bankName;
                        this.$("#toAccountInput").attr("data-realBankId", toAccountInfo.ibpsBankId);
                        $("#toAccountInput p:first").text(toAccountText);
                        $("#toAccountInput p:last").text(toAccNo);
                        $("#firstToAcc").hide();
                        $("#accImg,#toAccountInput").show();
                    } else {
                        App.storage.remove("selectedAccount");
                    }
                }

            }

            // 清空缓存数据
            App.storage.remove("transferData");
        },

        //填写金额
        _onCustomInputFocusInAmount: function () {
            safeKeyBoardHelper.focusIn({ id: "transferAmt" });
        },

        _onCustomInputFocusOutAmount: function () {
            safeKeyBoardHelper.focusOut({ id: "transferAmt" });
        },

        //选择收款账号
        toAccSelect: function () {
            this._setCache();
            App.navigate("me/transfer/bindAccSelect", true);
        },

        //选择到账时间
        toTransferModeSel: function () {
            this._setCache();
            App.navigate("me/transfer/transferMode", true);
        },

        //选择城市
        toCityInfo: function () {
            this._setCache();
            var toAccountInfo = App.storage.get("selectedAccount");
            if (!toAccountInfo) {
                utils.dialog.toast("请先选择收款账号");
                return;
            }
            App.navigate("me/transfer/showProPage", true);
        },

        //转账数据
        _setCache: function () {
            // 获取当前转出账户信息
            var toAccountInfo = App.storage.get("selectedAccount");
            // 是否同行
            var isSameBank = false;
            // 转入账号
            var toAccNo = "";
            if (toAccountInfo) {
                // 如果用户没有选择转入账户，则取第一个绑定账户
                //toAccountInfo = App.storage.get("bindAccount").list[0];
                isSameBank = toAccountInfo.sameBankFlag == 1;
                toAccNo = toAccountInfo.bindAccount;
            }

            // 获取活期余额
            var balance = $("#toAccountInput").attr("data-balance");
            // 获取转账模式（2：实时，1：普通，0：加急）
            var transferMode = $("#transferMode span").attr("transferMode");
            // 获取转账金额
            var transferAmt = this.$("#transferAmt").customInput("value");
            //var transferAmt  = this.$("#transferAmt").val();
            // 获取用户备注
            //var userRemark   = $("#userRemark").val();

            // 封装转账数据
            var transferData = {
                // 转出账号
                "fromAccNo": $("#toAccountInput").attr("data-fromAccNo"),
                //可用余额
                balance: balance,
                // 转账模式（2：实时，1：普通，0：加急）
                "executeType": transferMode,
                // 是否进行重复指令校验
                "duplicateOrderConfirm": "1",
                // 转入账号
                "toAccNo": toAccNo,
                // 转入账户（账号【名字】银行名称）
                "toAccountText": $("#toAccountInput p:first").text(),
                // 转存金额
                "transAmt": transferAmt.replace(/\,/g, ""),
                // 用户备注
                //"userRemark"            : userRemark,
                // 是否同行
                "isSameBank": isSameBank,
                // 实时联行号
                "realBankId": $("#toAccountInput").attr("data-realBankId"),
                // 联行号
                "bankId": $("#toAccountInput").attr("data-bankId")
            };

            // 获取选中的开户银行、省份、城市、支行信息
            var selectedBankInfo = App.storage.get("selectedBankInfo");
            var provinceAndCity = App.storage.get("transfer_cityData");
            var selectedBranchBankInfo = App.storage.get("selectedBranchBankInfo");

            //var selectedProvinceInfo = App.storage.get("selectedProvinceInfo");
            //var selectedCityInfo = App.storage.get("selectedCityInfo");


            if (selectedBankInfo) {
                transferData.bankName = selectedBankInfo.recBankName;
            }
            if (provinceAndCity && provinceAndCity.provinceValue) {
                transferData.provinceName = provinceAndCity.provinceValue;
            }
            if (provinceAndCity && provinceAndCity.cityValue) {
                transferData.cityName = provinceAndCity.cityValue;
            }
            if (selectedBranchBankInfo) {
                transferData.branchBankName = selectedBranchBankInfo.branchBankName;
            }

            // 存储转账数据，以便于确认页返回的时候可以记住
            App.storage.set("transferData", transferData);
        },

        /*
         * 切换开户支行
         */
        changeBranchBank: function (e) {

            this._setCache();

            var self = this;
            var selectedBankInfo = App.storage.get("selectedBankInfo");  //开户银行
            var toAccountInfo = App.storage.get("selectedAccount");
            var provinceAndCity = App.storage.get("transfer_cityData"); //开户城市
            var transferBankBin = App.storage.get("transfer_bankBinItem");  //卡Bin匹配的开户行
            if (!toAccountInfo) {
                utils.dialog.toast("请先选择收款账号");
                return;
            }

            if (!selectedBankInfo && !toAccountInfo.bankid && !transferBankBin) {
                utils.dialog.toast("请先选择开户银行");
                return;
            }
            if ((!provinceAndCity || !provinceAndCity.cityId) && (!toAccountInfo || !toAccountInfo.cityName)) {
                utils.dialog.toast("请先选择开户城市");
                return;
            }

            var recBankId, recBankName, provinceId, cityId, cityValue = "";

            if (selectedBankInfo) {
                //重新选择开户行
                recBankId = selectedBankInfo.recBankId;
                recBankName = selectedBankInfo.recBankName;
                provinceId = (provinceAndCity) ? provinceAndCity.provinceId : toAccountInfo.provinceCode;
                cityId = (provinceAndCity) ? provinceAndCity.cityId : toAccountInfo.cityCode;
                cityValue = (provinceAndCity) ? provinceAndCity.cityValue : toAccountInfo.cityName;
            } else if (transferBankBin) {
                //卡Bin存在
                recBankId = transferBankBin.bankCode;
                recBankName = transferBankBin.bankName;
                provinceId = provinceAndCity.provinceId;
                cityId = provinceAndCity.cityId;
                cityValue = provinceAndCity.cityValue;
            } else {
                //开户行存在重新选择城市的情况
                $.each(App.storage.get("allBankList"), _.bind(function (i, bank) {
                    if (toAccountInfo.bankid) {
                        if (bank.recBankId == toAccountInfo.bankid.substr(0, 3)) {
                            recBankId = bank.recBankId;
                            return;
                        }
                    }

                }, this));

                recBankName = toAccountInfo.bankName;
                if (provinceAndCity) {
                    provinceId = provinceAndCity.provinceId;
                    cityId = provinceAndCity.cityId;
                    cityValue = provinceAndCity.cityValue;
                } else {
                    provinceId = toAccountInfo.provinceCode;
                    cityId = toAccountInfo.cityCode;
                    cityValue = toAccountInfo.cityName;
                }

            }

            // 根据开户行、省份和城市重新查询支行信息
            transModel.queryBranchBankList({
                "url": "queryBranchBankList",
                "data": {
                    "openAccBankSortCode": recBankId,
                    "openAccBankSort": recBankName,
                    "province": provinceId,
                    "cityId": cityId,
                    "cityName": cityValue
                },
                "callback": function (response) {
                    // 缓存支行信息
                    App.storage.set("branchBankList", response.object.branchBankList);
                    var branchBankList = response.object.branchBankList;
                    App.navigate("me/transfer/showBranchBank", true);
                },
                "errorCallback": function () {
                    utils.dialog.alert("查询支行信息出错！");
                }
            });

        },

        //确定转出
        comfirmSubmmit: function () {
            var transView = this;
            if (this.isSubmited == "1") {
                return;
            }
            //梦想立即提款
            var immediatelyTransfer = App.storage.get("immediatelyTransfer");
            // 获取当前转出账户信息
            var toAccountInfo = App.storage.get("selectedAccount");
            if (!toAccountInfo) {
                //如果用户没有选择转入账户，则取第一个绑定账户
                //toAccountInfo = App.storage.get("bindAccount").list[0];
                utils.dialog.toast("请选择收款账号");
                return;
            }

            // 是否同行
            var isSameBank = toAccountInfo.sameBankFlag == 1;

            // 获取活期余额
            var balance = $("#toAccountInput").attr("data-balance");
            // 获取转账模式（2：实时，1：普通，0：加急）
            var transferMode = $("#transferMode span").attr("transferMode");
            // 获取转账金额
            var transferAmt = "";
            if (immediatelyTransfer) {
                transferAmt = this.$("#transferAmt input").val();
            } else {
                transferAmt = this.$("#transferAmt").customInput("value");
            }
            // 获取用户备注
            //var userRemark = $("#userRemark").val();

            if (isSameBank) {
                // 同行转账
                transferMode = "2";
            } else {
                // 跨行转账需要校验转入账户的开户行、开户地址、支行信息
                if (transferMode == "2") {
                    // 获取选择的开户行
                    var selectedBank = App.storage.get("selectedBankInfo");
                    // 实时转账模式
                    if (!$("#toAccountInput").attr("data-realBankId")) {
                        // 请选择开户银行
                        utils.dialog.toast("请选择开户银行");
                        return;
                    }
                } else {
                    // 绑定账户信息无联行号，则取界面选择的支行、省份和城市信息（普通/加急转账模式下的校验）
                    if (!toAccountInfo.bankid || toAccountInfo.bankid == "null") {
                        // 校验是否选择开户行
                        var transferBankBin = App.storage.get("transfer_bankBinItem");
                        var selectedBank = App.storage.get("selectedBankInfo");
                        if (!selectedBank && !transferBankBin) {
                            utils.dialog.toast("请选择开户银行");
                            return;
                        }

                        // 校验是否选择开户省份城市
                        var provinceAndCity = App.storage.get("transfer_cityData");
                        if (!provinceAndCity || !provinceAndCity.cityId) {
                            utils.dialog.toast("请选择开户城市");
                            return;
                        }

                        // 校验是否选择了开户支行
                        var selectedBranchBank = App.storage.get("selectedBranchBankInfo");
                        if (!selectedBranchBank || selectedBranchBank.branchBankName != $.trim($("#branchBankInput").text())) {
                            utils.dialog.toast("请选择开户支行");
                            return;
                        }
                    } else {
                        var provinceAndCity = App.storage.get("transfer_cityData");
                        if (!toAccountInfo.cityCode && !provinceAndCity) {
                            utils.dialog.toast("请选择开户城市");
                            return;
                        }
                        // 校验是否选择了开户支行
                        var selectedBranchBank = App.storage.get("selectedBranchBankInfo");
                        if (!selectedBranchBank || selectedBranchBank.branchBankName != $.trim($("#branchBankInput").text())) {
                            utils.dialog.toast("请选择开户支行");
                            return;
                        }
                    }
                }
            }

            // 获取当前转账限额数据
            var transferLimit = App.storage.get("transferLimit");
            var inUseFlag = transferLimit.inUseFlag;   // 是否开通了转账限额设置
            var dailyRemain = parseFloat(transferLimit.dailyLimit) - parseFloat(transferLimit.dailySum);

            if (transferAmt == "") {
                // 请输入转账金额
                //this.transferAmt.setCustomValidity(transferLang("pleaseInputTransferMoney"));
                utils.dialog.toast(transferLang("pleaseInputTransferMoney"));
                return;
            }
            if (transferAmt == "0.00" || transferAmt == 0) {
                // 转账金额不能为0
                //this.transferAmt.setCustomValidity(transferLang("transferMoneyCanNotBeZero"));
                utils.dialog.toast(transferLang("transferMoneyCanNotBeZero"));
                return;
            }

            var transAmount = parseFloat(transferAmt.replace(/\,/g, ""));
            // 转账限额校验
            if (inUseFlag == 1) {
                if (transAmount > dailyRemain) {
                    // 转账金额大于当日可用额度
                    //this.transferAmt.setCustomValidity(transferLang("transferMoneyGreaterThanLimit"));
                    //utils.dialog.toast(transferLang("transferMoneyGreaterThanLimit"));
                    utils.dialog.confirm("转出金额大于转账限额，请修改金额或转账限额。",
                        {title: "提示", okButtonText: "修改转账限额", cancelButtonText: "确定"},
                        function (e) {
                            if (e == true) {
                                //移除缓存数据
                                App.storage.remove("selectedAccount");
                                App.storage.remove("transferData");
                                App.storage.remove("openBankList");
                                App.storage.remove("bindAccount");
                                App.storage.remove("selectedBankInfo");
                                App.storage.remove("transfer_cityData");
                                App.storage.remove("transfer_bankBinItem");
                                App.storage.remove("transferLimit");
                                App.storage.remove("immediatelyTransfer");
                                App.navigate("me/accoutAndSecurity/transferLimit", true);
                            }
                        }
                    );
                    return;
                }
            } else {
                // 没有开通转账限额，直接提示用户先进行限额设置
                utils.dialog.toast(transferLang("noSetTransferLimit"));
                //$("#transferLimitLi").show();

                // 点击对话框的“设置交易限额”自动打开设置限额对话框
                // $("#setLimitAnchor").click(function(){
                // transView.modifyTransferLimit();
                // });
                return;
            }

            // 获取当前选中的转账模式（2：实时，1：普通，0：加急）
            if (transferMode == "2") {
                // 是跨行实时转账，且金额大于5万
                if (!isSameBank && transAmount > 50000) {
                    //this.transferAmt.setCustomValidity(transferLang("transferMoneyGreaterThan5w"));
                    utils.dialog.toast(transferLang("transferMoneyGreaterThan5w"));
                    return;
                }
            }

            if (transAmount > balance) {
                // 余额不足
                //this.transferAmt.setCustomValidity(transferLang("balanceNotEnough"));
                utils.dialog.toast(transferLang("balanceNotEnough"));
                return;
            }

            // 封装转账数据
            var transferData = {
                // 转出账号
                "fromAccNo": $("#toAccountInput").attr("data-fromAccNo"),
                // 转账模式（2：实时，1：普通，0：加急）
                "executeType": transferMode,
                // 是否进行重复指令校验
                "duplicateOrderConfirm": "1",
                // 转入账号
                "toAccNo": toAccountInfo.bindAccount,
                // 转入账户（账号【名字】银行名称）
                "toAccountText": $("#toAccountInput p:first").text(),
                // 转存金额
                "transAmt": transferAmt.replace(/\,/g, ""),
                // 用户备注
                //"userRemark" : userRemark,
                // 是否同行
                "isSameBank": isSameBank,
                // 实时联行号
                "realBankId": $("#toAccountInput").attr("data-realBankId")
            };

            // 获取选中的开户银行、省份、城市、支行信息
            var selectedBankInfo = App.storage.get("selectedBankInfo");
            var provinceAndCity = App.storage.get("transfer_cityData");
            var selectedBranchBankInfo = App.storage.get("selectedBranchBankInfo");

            if (selectedBankInfo) {
                transferData.bankName = selectedBankInfo.recBankName;
            }

            if (toAccountInfo.bankid) {
                if (provinceAndCity && provinceAndCity.provinceValue) {
                    transferData.provinceName = provinceAndCity.provinceValue;
                } else {
                    transferData.provinceName = toAccountInfo.provinceName;
                }
            } else {
                if (provinceAndCity && provinceAndCity.provinceValue) {
                    transferData.provinceName = provinceAndCity.provinceValue;
                }
            }

            if (toAccountInfo.bankid) {
                if (provinceAndCity && provinceAndCity.cityValue) {
                    transferData.cityName = provinceAndCity.cityValue;
                } else {
                    transferData.cityName = toAccountInfo.cityName;
                }
            } else {
                if (provinceAndCity && provinceAndCity.cityValue) {
                    transferData.cityName = provinceAndCity.cityValue;
                }
            }

            if (toAccountInfo.bankid) {
                if (selectedBranchBankInfo) {
                    transferData.branchBankName = selectedBranchBankInfo.branchBankName;
                } else {
                    transferData.branchBankName = toAccountInfo.registBank;
                }
            } else {
                if (selectedBranchBankInfo) {
                    transferData.branchBankName = selectedBranchBankInfo.branchBankName;
                }
            }

            // 存储转账数据，以便于确认页返回的时候可以记住
            App.storage.set("transferData", transferData);

            // 获取转账数据
            var fromAccountNumber = $("#toAccountInput").attr("data-fromAccNo");
            var toAccountNumber = toAccountInfo.bindAccount;
            var currencyType = "RMB";
            var transferAmount = transferAmt.replace(/\,/g, "");

            // 修改提交标识，防止重复提交
            this.isSubmited = "1";

            // 调用判断是否重复转账接口
            transModel.isDuplicatedOrder(
                {
                    "url": "isDuplicatedOrder",
                    "data": {
                        //"fromAccNo":fromAccountNumber,
                        "toAccNo": toAccountNumber,
                        "currencyType": currencyType,
                        "transferAmount": transferAmount
                    },
                    "callback": _.bind(function (response) {
                        var duplicatedOrderList = response.object.list;
                        if (duplicatedOrderList.length > 0) {
                            // 当日出现过相同转账交易
                            utils.dialog.confirm(
                                transferLang("duplicateTransfer"),
                                {},
                                function (e) {
                                    if (e == true) {
                                        // 继续转账，调用转账校验接口
                                        transView._doTransfer(toAccountInfo);
                                    }
                                }
                            );
                            // 不继续转账，重置重复提交标识
                            transView.isSubmited = "0";
                        } else {
                            // 当日没有进行过相同转账交易，直接调用转账校验接口
                            transView._doTransfer(toAccountInfo);
                        }
                    }, this),
                    "errorCallback": function (response) {
                        // 重置重复提交标识
                        transView.isSubmited = "0";
                        utils.dialog.alert(response.message);
                    }
                });
        },

        /*
         * 调用（同行/跨行）转账校验接口
         */
        _doTransfer: function (toAccountInfo) {
            var transView = this;
            // 获取转账表单数据
            var transferData = App.storage.get("transferData");
            // 转账上送数据
            var transData = {
                "channelType": "0",
                "fromAccountNumber": transferData.fromAccNo,
                "toAccountNumber": transferData.toAccNo,
                "transferPriority": transferData.executeType,
                "transferAmount": transferData.transAmt,
                "duplicateOrderConfirm": transferData.duplicateOrderConfirm
            };


            // 判断是同行转账还是跨行转账
            if (transferData.isSameBank) {
                // 同行转账方式默认设置为2实时
                transData.transferPriority = "2";
                // 调用同行转账校验接口
                transModel.sameBankTransferCheck(
                    {
                        "url": "sameBankTransferCheck",
                        "data": transData,
                        "callback": function (res) {
                            //同行转账确认成功
                            // 存储转账校验返回数据
                            App.storage.set("transferConfirmData", res.object);
                            //App.navigate("#transfer/transfer/transferNext", true);
                            transView.isSubmited = "0";
                            transView.inputPass();
                        },
                        "errorCallback": function (response) {
                            // 重置重复提交标识
                            transView.isSubmited = "0";
                            utils.dialog.alert(response.message);
                        }
                    });
            } else {
                if (transData.transferPriority == 2) {
                    // 选择的是实时转账，需要传实时联行号
                    transData["receivingAccountInfo.unionBankCode"] = $("#toAccountInput").attr("data-realBankId");
                } else {
                    // 选择的是普通或加急转账，获取联行号、省份编号、城市编号
                    var selectedBranchBankInfo = App.storage.get("selectedBranchBankInfo");
                    var provinceAndCity = App.storage.get("transfer_cityData");
                    // 绑定账户信息无联行号，则取界面选择的支行、省份和城市信息
                    if (!toAccountInfo.bankid || toAccountInfo.bankid == "null") {
                        var provinceCode = provinceAndCity.provinceId;
                        var cityCode = provinceAndCity.cityId;
                        transData["receivingAccountInfo.unionBankCode"] = selectedBranchBankInfo.branchBankId;
                        transData["receivingAccountInfo.provinceCode"] = provinceCode;
                        transData["receivingAccountInfo.cityCode"] = cityCode;
                    } else {
                        if (provinceAndCity) {
                            transData["receivingAccountInfo.unionBankCode"] = selectedBranchBankInfo.branchBankId;
                            transData["receivingAccountInfo.provinceCode"] = provinceAndCity.provinceId;
                            transData["receivingAccountInfo.cityCode"] = provinceAndCity.cityId;
                        } else {
                            transData["receivingAccountInfo.unionBankCode"] = toAccountInfo.bankid;
                            transData["receivingAccountInfo.provinceCode"] = toAccountInfo.provinceCode;
                            transData["receivingAccountInfo.cityCode"] = toAccountInfo.cityCode;
                        }
                    }
                }
                // 调用跨行转账校验接口
                transModel.otherBankTransferCheck(
                    {
                        "url": "otherBankTransferCheck",
                        "data": transData,
                        "callback": function (res) {
                            // 存储转账校验返回数据
                            App.storage.set("transferConfirmData", res.object);
                            //App.navigate("#transfer/transfer/transferNext", true);
                            transView.isSubmited = "0";
                            transView.inputPass();
                        },
                        "errorCallback": function (response) {
                            // 重置重复提交标识
                            transView.isSubmited = "0";
                            utils.dialog.alert(response.message);
                        }
                    }
                );
            }
        },

        //输入密码
        inputPass: function () {
            var transView = this;
            var cacheTransData = App.storage.get("transferData");
            utils.native.talkingDataTrackEvent("2.0转出验密");
            CustomPwdOtpInput.customPwdOtpInput({
                isSendOtp: true,
                isNeedSendOtpValidate: false,
                cat: config.values.transferConfirm,//cat
                values: cacheTransData.transAmt + "|" + App.storage.get("UserInfo").get("trueName"),
                callback: function (pwd, otp) {
                    var rsaPwd = utils.crypto.RSAKey.encrypt(pwd, config.base.rsa_public_key);
                    var sm2Pwd = utils.sm2.SM2Key.encrypt(pwd, config.base.sm2_public_key);
                    var data = {
                        "password": rsaPwd,
                        "otp": otp,
                        "transToken": App.storage.get("transferConfirmData").transToken,
                        "sm2Pwd":sm2Pwd
                    };
                    transView.transferConfirm(data);
                }//确定按钮回调函数（param：pwd（交易密码），otp（otp密码））
            });
        },

        /*
         * 提交转账请求
         */
        transferConfirm: function (data) {
            var self = this;
            if (self.isSubmited == "1") {
                return;
            }
            var immediatelyTransfer = App.storage.get("immediatelyTransfer");
            if (data) {
                self.isSubmited = "0";
                var transferData = App.storage.get("transferData");
                if (transferData.isSameBank) {
                    // 调用同行转账确认提交接口
                    transModel.sameBankTransferConfirm(
                        {
                            "url": "sameBankTransferConfirm",
                            "data": data,
                            "callback": function (response) {
                                if (immediatelyTransfer) {
                                    self.drawMoneyMyDream();
                                }
                                // 缓存转账成功返回数据
                                App.storage.set("transferSuccessData", response.object);
                                //清除余额接口缓存
                                App.requester.storage.remove("currentToFixedTransferBalance");
                                // 跳转到转账成功页
                                App.navigate("me/transfer/transferFinish", true);
                            },
                            "errorCallback": function (response) {
                                // 重置重复提交标识
                                self.isSubmited = "0";
                                utils.dialog.alert(response.message);
                            }
                        });
                } else {
                    // 调用跨行转账确认提交接口
                    transModel.otherBankTransferConfirm(
                        {
                            "url": "otherBankTransferConfirm",
                            "data": data,
                            "callback": function (response) {
                                if (immediatelyTransfer) {
                                    self.drawMoneyMyDream();
                                }
                                // 缓存转账成功返回数据
                                App.storage.set("transferSuccessData", response.object);
                                //清除余额接口缓存
                                App.requester.storage.remove("currentToFixedTransferBalance");
                                // 跳转到转账成功页
                                App.navigate("me/transfer/transferFinish", true);
                            },
                            "errorCallback": function (response) {
                                // 重置重复提交标识
                                self.isSubmited = "0";
                                utils.dialog.alert(response.message);
                            }
                        });
                }
            }
        },

        /**
         * 梦想立即提款
         */
        drawMoneyMyDream: function () {
            var dreamId = App.storage.get("immediatelyTransfer").dreamId;
            transModel.drawMoneyMyDream(
                {
                    "url": "drawMoneyMyDream",
                    "data": {dreamId: dreamId, transferCode: 0},
                    "callback": function (response) {
                        //清除梦想缓存
                        //App.storage.remove("immediatelyTransfer");
                    },
                    "errorCallback": function (response) {
                        //清除梦想缓存
                        //App.storage.remove("immediatelyTransfer");
                        utils.dialog.alert(response.message);
                    }
                });
        }

    });
});
