/**
 * WUWENJUN059
 * 选择开户银行View
 */
define(function(require, exports, module){

    var template       = require("text!../../template/transfer/transferBranchBank.html");
    var transferLang   = require("../../common/transferLang");
    var transferTools  = require("../../common/transferTools");
    var transModel     = require("../../model/transferModel");
    var initPTRScroll = require('mod/common/widget/initPTRScroll');

    var transferBranchBankView = module.exports = Layout.extend({
        template:  _.template(template),
        events: {
            "input #BranchBankInput"     : "filterBranchBank",     //筛选开户支行
            "tap #BranchBankBox li"      : "writeBranchBank"       //写入开户支行
        },
        
        onShow : function(){
            var gap = 40;
            if (IS_RUN_ON_DEVICE)
                gap = 44;
            initPTRScroll.call(this, {
                gap : gap,
                pullDownToRefresh : false
            });
        },
        
        /**
         *
         * 筛选开户行
         *
         */
        filterBranchBank : function(e) {
            var keyWord = $(e.currentTarget).val().replace(/\s/g,"").toUpperCase();
            //分组排序后的数组
            var branchBankList = this.model.get("branchBankList");
             //根据拼音匹配
            var filterList = [];

            // 关键字为空时显示所有
            if(keyWord == "") {
            	$("#searchBank,#searchNoResult").hide();
            	$("#selRecBankInfo,hr").show();
                filterList = branchBankList;
                App.storage.set("filterBranchBankList",filterList);
            }else {
            	$("#searchBank").show();
            	$("#selRecBankInfo,hr").hide();
                _.each(branchBankList,function(item,i){
                    if(item.branchBankName.indexOf(keyWord) >= 0) {
                       filterList.push(item);
                    }
                });
                App.storage.set("filterBranchBankList",filterList);
            }

            // 重新生成列表选项
            if(filterList.length == 0) {
                 // 清空所有列表
                $("#BranchBankBox").html("");
                $("#searchNoResult").show();
            }else{
            	$("#searchNoResult").hide();
                var OpenBankListHtml = "<div class='Columns b_t0'><ul class='ulStyle1 fannyulStyle1'>";
                _.each(filterList,function(item,i) {
                	OpenBankListHtml+='<li class="dswkb" data-recBankId="'+item.branchBankId+'" data-index="'+i+'">'
				                	    +'<div class="m_l10 flex1">'
									   		+'<p class="c_333">'+item.branchBankName+'</span></p>'
								    	+'</div>'
				                       +'</li>';
                });
                OpenBankListHtml+="</ul></div>";
                $("#BranchBankBox").html(OpenBankListHtml);
            }
            this.scroller && this.scroller.refresh();
        },

        /**
         * 写入开户行
         */
        writeBranchBank : function(e) {
            if(this.submitFlag){
                return;
            }
            this.submitFlag = true;
            var cacheData = App.storage.get("transferData");
            var list  = App.storage.get("filterBranchBankList") || this.model.get("branchBankList");
            var index = $(e.currentTarget).attr("data-index");
            $(e.currentTarget).append("<i class='iconA59'></i>");
            var data  = list[index];
            cacheData.branchBankName = data.branchBankName;
            App.storage.remove("filterBranchBankList");
            App.storage.set("selectedBranchBankInfo",data);
            setTimeout(function(){
                App.navigate("me/transfer/transferView", true);
            },300);
        }
    });
});