/**
 * WUWENJUN059
 * 省份View
 */
define(function(require, exports, module){

    var template       = require("text!../../template/transfer/transferProList.html");
    var transferLang   = require("../../common/transferLang");
    var transferTools  = require("../../common/transferTools");
    var transModel   = require("../../model/transferModel");
    var initPTRScroll = require('mod/common/widget/initPTRScroll');

    var transferProListView = module.exports = Layout.extend({
        template:  _.template(template),
        events: {
            "input #reg_pro"     : "filterPro",  //筛选省份
            "tap #reg_proDiv li,#reg_topPro a" : "showCityList"  //显示城市列表
        },
		
		onShow : function(){
			initPTRScroll.call(this, {
                pullDownToRefresh : false
            });
			
		},
		
        /**
         * 筛选省份
         */
        filterPro : function(e) {
            var keyWord = $(e.currentTarget).val().replace(/[ ]/g,"").toUpperCase();
            //分组排序后的数组
            var proList = transferTools.getProvinceInfo;
             //根据拼音匹配
            var filterList = [];

            // 关键字为空时，过滤出所有省份
            if(keyWord == "") {
                filterList = proList;
            }else {
                 _.each(proList,function(pro,i){
                     if(pro.cityPy.indexOf(keyWord) == 0) {
                        filterList.push(pro);
                     }
                 });

                 //根据中文匹配
                 _.each(proList,function(pro,j) {
                     if(pro.name.indexOf(keyWord) == 0) {
                        filterList.push(pro);
                     }
                 });
            }

            // 重新生成城市列表选项
            if(filterList.length == 0) {
                 // 清空所有城市列表
                $("#reg_proDiv").html("");
                $("#searchPro,#searchProRes").show();
            }else{
            	$("#searchPro,#searchProRes").hide();
            	var hotCity = "";
            	if(!$("#reg_pro").val() || $("#reg_pro").val() == ""){
	        		 hotCity = '<p class="c_999 f14  m_l10 p_t10_b10" id="reg_tip">国内热门城市 </p>' +
							  '<div class="newsCity c" id="reg_topPro">' +
								  '<a href="javascript:;" proKey="31" proValue="上海" cityKey="2900" cityValue="上海市">上海</a>' +
								  '<a href="javascript:;" proKey="11" proValue="北京" cityKey="1000" cityValue="北京市">北京</a>' +
								  '<a href="javascript:;" proKey="44" proValue="广东" cityKey="5810" cityValue="广州市">广州</a>' +
								  '<a href="javascript:;" proKey="44" proValue="广东" cityKey="5840" cityValue="深圳市" class="noborbot">深圳</a>' +
							  '</div>';
            	}
            	
                var newFilterList = transferTools.assCityData(filterList);

                var proDivList = "";
                var newProDivList = "<div class='qyMain'>";
                _.each(newFilterList,function(newList,j) {
                    proDivList = '<p class="c_999 f14  m_l10 p_t10_b10">'+newList.Ab+'</p><div class="Columns b_t0"><ul class="ulStyle1 fannyulStyle2">';
                    _.each(newList.lists,function(list,i) {
                        proDivList+="<li class='dswkb' proKey='"+list.key+"' proValue='"+list.name+"'>"+list.name+"</li>";
                    });
                    proDivList=proDivList+'</ul></div>'
                    newProDivList += proDivList;
                });
                newProDivList += "</div>";
                $("#reg_proDiv").html(hotCity+newProDivList);

            }
            this.scroller && this.scroller.refresh();
        },

        /**
         *显示城市列表
         */
        showCityList : function(e) {
            var provinceId = $(e.currentTarget).attr("proKey");
            var option = {
                "provinceId" : provinceId,
                "provinceValue" : $(e.currentTarget).text()
            };

            //过滤，如果是热门城市：北京 11、上海 31、广东 44则不需要选择城市
            if($(e.currentTarget).parent().attr("id") == "reg_topPro") {
                if(provinceId == "44" || provinceId == "11" || provinceId == "31") {
                    option.cityId        = $(e.currentTarget).attr("cityKey");
                    option.cityValue     = $(e.currentTarget).attr("cityValue");
                    option.provinceValue = $(e.currentTarget).attr("proValue");

                    var cacheData          = App.storage.get("transferData");
                    cacheData.cityName     = option.cityValue;
                    cacheData.provinceName = option.provinceValue;
                    
					App.storage.remove("selectedBranchBankInfo");
                    App.storage.set("transfer_cityData", option);
                    App.navigate("me/transfer/transferView", true);
                }
             }else {
                 if(this.submitFlag == "1") {
                    return;
                }
                this.submitFlag = "1";
                transModel.qryCityRegInfo({
                    "url" : "qryCityRegInfo",
                    data : {
                        "provinceId" : provinceId
                    },
                    callback : _.bind(function(resp) {
                        this.submitFlag = "0";
                        option.list = resp.object.cityList;
                        App.storage.set("transfer_cityData", option);
                        App.navigate("me/transfer/showCityPage", true);

                    },this),
                    errorCallback : _.bind(function(resp) {
                        this.submitFlag = "0";
                        utils.dialog.alert(resp.message);
                    },this)
                });
            }

        }
    });
});