/**
 * 产品推荐控制器
 */
define(function(require, exports, module) {
	var CommendProductsView = require("../view/commendProducts/commendProducts");
	var commProductsModel   = require("../model/commendProducts");
	var commProductLang     = require("../../myInvestment/common/commProductLang");
	var scard               = require("../view/commendProducts/scard");
	var bscard              = require("../view/commendProducts/bscard");
	var fail                = require("../view/commendProducts/fail");
	var cradLossStatus      = require("../view/commendProducts/cradLossStatus");
	var tipPage             = require("../view/commendProducts/tipPage");
	var ca                  = require("../view/commendProducts/ca");
	var lingui              = require("../view/commendProducts/lingui");
	var tipPageold          = require("../view/commendProducts/tipPageold");
	var tipPages            = require("../view/commendProducts/tipPages");
	var noAgeInfo           = require("../view/commendProducts/noAgeInfo");
	var ageTooBig           = require("../view/commendProducts/ageTooBig");
	var fnoAgeInfo          = require("../view/commendProducts/funds");
	var fageTooBig          = require("../view/commendProducts/fundage");
	var BuyModel            = require("../../fund/model/buy");

	var commProductsController = module.exports = Controller.extend({
		actions : {
			"proDetail"       : "proDetail",
			"goBuyProduct"    : "goBuyProduct",
			"scard"           : "scard",
			"bscard"          : "bscard",
			"lingui"          : "lingui",
			"cradLossStatus"  : "cradLossStatus",
			"fail"            : "fail",
			"BuyFund"         : "BuyFund",
			"Buygoldtreasure" : "Buygoldtreasure",
			"ca/:code" : "ca",
			"tipPage/:code" : "tipPage",
			"riskBook/:code" : "riskBook",
			"riskAbilityTestQry/:code" : "riskAbilityTestQry",
			"riskfund/:code" : "riskfund",
			"doRiskTest/:code" : "doRiskTest",
			"addPurchaseRiskfund/:code" : "addPurchaseRiskfund", //liujun add 追加购买过期风测
			"riskgoldtreasure/:code" : "riskgoldtreasure",
			"appGoldTreasureRisk/:code" : "appGoldTreasureRisk" //liujun黄金宝追加购买风测

		},
		proDetail : function() {
			var proModel = App.storage.get('myInvestment/commendProducts/curProObj');
			if (!proModel) {
				App.navigate("products/index/index/finefinance", true);
				return;
			}

			var ProDetailView = require("../view/commendProducts/proDetail");

			App.container.show(new ProDetailView({
				model : proModel
			}));
			var productType = proModel.get("type");
			var proTypeText = this._getProTypeText(productType);
			utils.native.talkingDataTrackEvent("2.0-新产品推荐-" + proTypeText + "详情");
			App.header.reset({
				title : proTypeText,
				leftButtonContent : '@back',
				leftButtonHandler : function() {
					var model = App.storage.get('myInvestment/commendProducts/curProObj');
					var productType = model.get('type');

					if (productType == "fund") {
						App.navigate('products/index/index/selectFund', true);
					} else {
						App.navigate("products/index/index/finefinance", true);
					}
				}
			});
		},

		_getProTypeText : function(productType) {
			if (productType == 'finance'){
				return "理财产品";
			} else if (productType == '1' || productType == '3') {
				return "养老保障产品";
			}
		},

		// 风险评测提示页面
		tipPage : function(code) {
			var tipPageOptions = App.storage.remove('myInestment/tipPageOptions');
			if (!tipPageOptions) {
				App.navigate("products/index/index/finefinance", true);
				return;
			}

			var tipPageView = require("../view/commendProducts/tipPage");

			App.container.show(new tipPageView(tipPageOptions));

			utils.native.talkingDataTrackEvent("2.0-新产品推荐-提示风险测评-理财/养老");
			App.header.reset({
				title : "智能风险偏好评测",
				leftButtonContent : '@back',
				leftButtonHandler : function() {
					var model = App.storage.get('products/detail/finace');
					App.storage.set('products/detail/finace', model);
					//                    App.navigate("products/index/index/finefinance", true);
					App.navigate("products/detail/finace", true);
				}
			});
		},

		// 风险确认函w
		riskBook : function(code) {
			var proModel = App.storage.get('myInvestment/commendProducts/curProObj');
			var productType = proModel.get("type");

			if (productType == "fund") {
				if (!proModel) {
					App.navigate("products/index/index/selectFund", true);
					return;
				} else {

					var RiskBookView = require("../view/commendProducts/riskBook");

					var riskBookView = new RiskBookView({
						model : model
					});

					riskBookView.on('confirm', function() {
						commProductsModel.confirmProductRiskBook({
							"url" : "confirmProductRiskBook",
							"data" : {
								"productId" : productType,
								"passFlag" : "1"
							},
							"callback" : function(res) {
								if (code == "0") {

									//直接购买
									App.navigate('myInvestment/commendProducts/BuyFund', true);
									return;

								} else {
									//定投
									App.navigate("fund/fundFixedInvestment/index", true);
									return;

								}

							},
							"errorCallback" : function(res) {
								utils.dialog.toast(res.message);
							}
						});
					});

					App.container.show(riskBookView);

					App.header.reset({
						title : "风险确认",
						leftButtonContent : '@back',
						leftButtonHandler : function() {
							App.navigate("products/index/index/selectFund", true);
						}
					});

				}

				return;
			}
			if (productType == "goldbao") {
				if (!proModel) {
					App.navigate("products/index/index/selectFund", true);
					return;
				} else {

					var RiskBookView = require("../view/commendProducts/riskBook");

					var riskBookView = new RiskBookView({
						model : model
					});

					riskBookView.on('confirm', function() {
						commProductsModel.confirmProductRiskBook({
							"url" : "confirmProductRiskBook",
							"data" : {
								"productId" : productType,
								"passFlag" : "1"
							},
							"callback" : function(res) {
								if (code == "4") {
									//直接购买
									App.navigate('myInvestment/commendProducts/Buygoldtreasure', true);
									return;
								}
							},
							"errorCallback" : function(res) {
								utils.dialog.toast(res.message);
							}
						});
					});

					App.container.show(riskBookView);

					App.header.reset({
						title : "风险确认",
						leftButtonContent : '@back',
						leftButtonHandler : function() {
							App.navigate("products/index/index/finefinance", true);
						}
					});

				}

				return;
			}
			var model = App.storage.get('myInvestment/commendProducts/curProObj');
			if (!model) {
				App.navigate("products/index/index/finefinance", true);
				return;
			}

			var RiskBookView = require("../view/commendProducts/riskBook");
			var productId = model.get("type");

			if (productId == "finance") {
				var riskBookView = new RiskBookView({
					model : model
				});
				riskBookView.on('confirm', function() {
					commProductsModel.confirmProductRiskBook({
						"url" : "confirmProductRiskBook",
						"data" : {
							"productId" : productId,
							"passFlag" : "1"
						},
						"callback" : function(res) {
							App.navigate('myInvestment/commendProducts/goBuyProduct', true);
						},
						"errorCallback" : function(res) {
							utils.dialog.toast(res.message);
						}
					});
				});
				App.container.show(riskBookView);

				App.header.reset({
					title : "风险确认",
					leftButtonContent : '@back',
					leftButtonHandler : function() {
						var model = App.storage.get('myInvestment/commendProducts/curProObj');
						var productType = model.get('type');

						if (productType == "fund") {
							App.navigate('products/index/index/selectFund', true);
						} else {
							App.navigate("products/index/index/finefinance", true);

						}
					}
				});
			} else if (productId == "pap" || 'bill' === productId) {
				var riskBookView = new RiskBookView({
					model : model
				});

				riskBookView.on('confirm', function() {
					commProductsModel.confirmProductRiskBook({
						"url" : "confirmProductRiskBook",
						"data" : {
							"productId" : productId,
							"passFlag" : "1"
						},
						"callback" : function(res) {
							if ('bill' === productId)
								return App.navigate('products/buy/index/bill', true);

							App.navigate('myInvestment/commendProducts/goBuyProduct', true);
						},
						"errorCallback" : function(res) {
							utils.dialog.toast(res.message);
						}
					});
				});

				App.container.show(riskBookView);

				App.header.reset({
					title : "风险确认",
					leftButtonContent : '@back',
					leftButtonHandler : function() {
						var model = App.storage.get('myInvestment/commendProducts/curProObj');
						var productType = model.get('type');

						if (productType == "fund") {
							App.navigate('products/index/index/selectFund', true);
						} else {
							App.navigate("products/index/index/finefinance", true);
						}
					}
				});
			} else if (productId == "pension") {
				utils.dialog.alert("本期不上线，尽请期待", function(){
					App.navigate('products/index/index/finefinance', true);
				});
			} else if ( productId == "goldbao") {
				//to do?
			}
		},

		// 购买理财、
		goBuyProduct : function() {
			var model = App.storage.get('myInvestment/commendProducts/curProObj');
			//var piaomodel= App.storage.remove('myInvestment/commendProducts/curProObj');
			if (!model) {
				App.navigate("products/index/index/finefinance", true);
				return;
			}
			var productType = model.get('type');

			if (productType == "finance") {
				App.storage.set("financeProductData", model.attributes);
				App.navigate("financialProducts/buy/input", true);
			} else if (productType == "pension") {
				utils.dialog.alert("本期不上线，尽请期待", function(){
					App.navigate('products/index/index/finefinance', true);
				});
			} else {
				App.storage.set("pinganpiaoData", model.attributes);
				App.navigate("pinganpiao/buy/input", true);
			}
		},

		//基金产品购买
		BuyFund : function() {
			//获取当前选取基金产品的信息
			var model = App.storage.get('myInvestment/commendProducts/curProObj');
			if (!model) {
				App.navigate("products/index/index/finefinance", true);
				return;
			}
			var productType = model.get('type');
			//获取产品代码判断购买什么产品
			var prdAttr = model.get('prdAttr');

			if (productType == "fund") {

				if (prdAttr == "4") {//prdAttr基金产品属性 4-货币性基金
					App.storage.set("FundsData", model.attributes);
					App.navigate("fund/buy/inputs", true);

				} else {//其他为购买股票基金流程
					App.storage.set("FundsData", model.attributes);
					App.navigate("fund/buy/input", true);

				}

			}
		},
		//黄金宝购买
		Buygoldtreasure : function() {
			//获取当前选取基金产品的信息
			var model = App.storage.get('myInvestment/commendProducts/curProObj');
			if (!model) {
				App.navigate("products/index/index/finefinance", true);
				return;
			}
			//将黄金宝数据 保存
			App.storage.set("goldtreasure", model.attributes);
			App.navigate("goldtreasure/buy/input", true);

		},
		//购买基金账号签约风险测评状态
		/*
		 code 0 为基金购买  1为基金定投
		 *
		 * */
		riskfund : function(code) {
			var thisView = this;
			var proModel = App.storage.get('myInvestment/commendProducts/curProObj');
			// if (proModel == undefined && proModel == null && proModel == []) {
			// /*
			// 查询 qryFundPrdList 接口
			// 输入queryFlag 0-筛选 1-排序 2-搜索
			// prdCode 基金代码
			// *
			// * */
			// //var prdCode="1";
			// BuyModel.qryFundPrdList({
			// "url" : "qryFundPrdList",
			// "data" : {
			// "queryFlag" : "2",
			// "prdCode" : prdCode	//基金代码
			// },
			// "callback" : function(res) {
			// var fundindex=res.obj;
			// App.storage.set("fundindex",fundindex );
			//
			// },
			// "errorCallback" : function(res) {
			// utils.dialog.toast(res.message);
			// }
			// });
			//
			// }

			var productType = proModel.get("type");
			//获取产品代码
			var cradLossStatus = App.storage.get("cradLossStatus");
			//冻结状态
			var cardState = App.storage.get("UserInfo").get("cardState");
			//身份认证状态
			// var code = code;

			if (cradLossStatus == true) {

				App.navigate("myInvestment/commendProducts/cradLossStatus", true);
				return;
			}
			if (cardState == "1") {

				if (productType == "fund") {

					commProductsModel.fundstate({
						"url" : "isFundSign",
						"data" : {},
						"callback" : function(res) {
							var obj = res.object;
							var fundC = obj.retCode;
							//基金签约状态
							if (fundC == "004") {//004为签约状态003未签约
								// 请求风险评估
								commProductsModel.riskAbilityTestQry({
									"url" : "riskAbilityTestQry",
									"data" : {},
									"callback" : function(res) {
										var obj = res.object;
										var fundStatus = obj.otherRiskStatus;
										//基金风险状态

										// 如果购买基金产品
										if (fundStatus == '1') {
											// 有效的风险评测状态
											thisView.fundAgeAndRiskLevel(obj, proModel, code);
											//传入基金信息
										} else if (fundStatus == '2') {
											// 未做理财风险评测，请测评
											thisView.sipRiskExpired(code);
										} else if (fundStatus == '3') {
											// 风险评测过期，请重新评测
											thisView.tipRiskExpired(code);
										}
									},
									"errorCallback" : function(res) {
										utils.dialog.toast(res.message);
									}
								});

							} else {
								App.navigate("fund/buy/riskexam", true);

							}
						},
						"errorCallback" : function(res) {
							utils.dialog.toast(res.message);
						}
					});

				}

			} else {
				// 身份未认证，请先完成身份认证
				if (cardState == 0) {
					App.navigate("myInvestment/commendProducts/scard", true);
				}else if (cardState == 2) {
					App.navigate("myInvestment/commendProducts/fail", true);
				} else {
					App.navigate("myInvestment/commendProducts/bscard", true);
				}

			}

		},

		//购买黄金宝贝账号开户风险测评状态
		/*
		 code 0 为基金购买
		 1为基金定投
		 4为黄金宝
		 5理财快E赢
		 *
		 * */
		riskgoldtreasure : function(code) {
			var thisView = this;
			var proModel = App.storage.get('myInvestment/commendProducts/curProObj');
			var productType = proModel.get("type");
			//获取产品代码
			var cradLossStatus = App.storage.get("cradLossStatus");
			//冻结状态
			var cardState = App.storage.get("UserInfo").get("cardState");
			//身份认证状态
			// var code = code;

			if (cradLossStatus == true) {

				App.navigate("myInvestment/commendProducts/cradLossStatus", true);
				return;
			}
			if (cardState == "1") {

				if (productType == "goldbao") {

					commProductsModel.qryGoldAcctInfo({
						"url" : "qryGoldAcctInfo",
						"callback" : function(res) {
							var obj = res.object;
							var goldAcctType = obj.goldAcctType;
							//黄金账户签约状态
							if (goldAcctType == "1") {//1开户0没有开户2在其他渠道开户
								// 请求风险评估
								commProductsModel.riskAbilityTestQry({
									"url" : "riskAbilityTestQry",
									"data" : {},
									"callback" : function(res) {
										var obj = res.object;
										var fundStatus = obj.otherRiskStatus;
										//黄金风险状态

										// 如果购买黄金产品
										if (fundStatus == '1') {
											// 有效的风险评测状态
											thisView.fundAgeAndRiskLevel(obj, proModel, code);
											//传入黄金信息
										} else if (fundStatus == '2') {
											// 未做理财风险评测，请测评
											thisView.sipRiskExpired(code);
										} else if (fundStatus == '3') {
											// 风险评测过期，请重新评测
											thisView.tipRiskExpired(code);
										}
									},
									"errorCallback" : function(res) {
										utils.dialog.toast(res.message);
									}
								});

							} else if (goldAcctType == "2") {
								utils.dialog.toast("您已经在其他渠道开立黄金账户，需解约后才可在橙子签约黄金账户。");
								App.navigate("products/detail/goldbao", true);

							} else {
								App.navigate("goldtreasure/buy/riskexam", true);
								return;
							}
						},
						"errorCallback" : function(res) {
							utils.dialog.toast(res.message);
						}
					});

				}

			} else {
				// 身份未认证，请先完成身份认证
				if (cardState == 0) {
					App.navigate("myInvestment/commendProducts/scard", true);
				}else if (cardState == 2) {
					App.navigate("myInvestment/commendProducts/fail", true);
				} else {
					App.navigate("myInvestment/commendProducts/bscard", true);
				}
			}

		},

		//养老，理财，快E赢风险测评
		riskAbilityTestQry : function(code) {
			var thisView = this;
			var proModel = App.storage.get('myInvestment/commendProducts/curProObj');
			var productType = proModel.get("type");
			//获取产品代码
			var cradLossStatus = App.storage.get("cradLossStatus");
			//冻结状态
			var cardState = App.storage.get("UserInfo").get("cardState");
			//身份认证状态

			if (cradLossStatus == true) {

				App.navigate("myInvestment/commendProducts/cradLossStatus", true);
				return;
			}
			if (cardState == "1") {
				// 请求风险评估
				commProductsModel.riskAbilityTestQry({
					"url" : "riskAbilityTestQry",
					"data" : {},
					"callback" : function(res) {
						var obj = res.object;
						var riskStatus = obj.riskStatus;
						// 理财产品风险评测状态
						var otherRiskStatus = obj.otherRiskStatus;
						//平安票的风险测评状态
						if (productType == "pension") {
							utils.dialog.alert("本期不上线，尽请期待", function(){
								App.navigate('products/index/index/finefinance', true);
							});
						}
						if (productType == "finance") {
							// 如果购买理财产品
							if (riskStatus == '1') {
								// 有效的风险评测状态
								thisView.judgeAgeAndRiskLevel(obj, proModel, code);
							} else if (riskStatus == '3') {
								// 风险评测过期，请重新评测
								thisView.tipRiskExpired(code);
							} else if (riskStatus == '2') {
								// 未做理财风险评测，请临柜评测
								thisView.tipRiskAtAgency();
							}
						}
						if (productType == "pap" || 'bill' == productType) {
							// 如果购买理财产品
							if (otherRiskStatus == '1') {
								// 有效的风险评测状态
								thisView.fundAgeAndRiskLevel(obj, proModel, code);
							} else if (otherRiskStatus == '2') {
								// 未做理财风险评测，请测评
								thisView.sipRiskExpired(code);
							} else if (otherRiskStatus == '3') {
								// 风险评测过期，请重新评测
								thisView.tipRiskExpired(code);
							}
						}
					},
					"errorCallback" : function(res) {
						utils.dialog.toast(res.message);
					}
				});
			} else {

				// 身份未认证，请先完成身份认证
				if (cardState == 0) {
					App.navigate("myInvestment/commendProducts/scard", true);
				}else if (cardState == 2) {
					App.navigate("myInvestment/commendProducts/fail", true);
				} else {
					App.navigate("myInvestment/commendProducts/bscard", true);
				}

			}
		},

		// 理财产品判断客户年龄与风险等级
		judgeAgeAndRiskLevel : function(riskObj, proModel, code) {
			var thisView = this;
			var productRiskLevel = proModel.get('riskLevel');
			// 产品风险等级
			var age = riskObj.age;
			// 年龄信息
			var riskLevel = riskObj.riskLevel;
			// 客户风险等级

			if (!age) {
				// 提示年龄信息不完整
				this.noAgeInfo();
			} else if (parseInt(age) > 65) {
				// 提示用户年龄超过65
				this.ageTooBig();
			} else if (parseInt(age) < 18) {
				this.fageTooBig();

			} else {
				// 有效的年龄信息
				if (parseInt(riskLevel) < parseInt(productRiskLevel)) {
					// 客户风险等级低于当前产品风险等级
					// 提示客户取重新评测
					this.riskLevelLow(riskLevel, productRiskLevel, code);
				} else {
					// 客户风险等级高于当前产品风险等级
					// 查询理财产品购买风险确认函
					thisView.productRiskBook(riskObj, proModel, code);
				}
			}
		},

		//理财产品购买年龄与风险4等级
		fundAgeAndRiskLevel : function(riskObj, proModel, code) {
			var thisView = this;
			var productRiskLevel = proModel.get('riskLevel');
            var prdCode = proModel.get('prdCode');
            
			// 产品风险等级
			var age = riskObj.age;
			// 年龄信息
			var riskLevel = riskObj.riskLevel;
			// 客户风险等级
			var modle = {
				"productRiskLevel" : productRiskLevel,
				"riskLevel" : riskLevel
			};

			App.storage.set('golddata', modle);

			if (!age) {
				// 提示年龄信息不完整
				this.fnoAgeInfo();
			} else {
                //修改基金的风险等级中文的BUG，基金的调用接口判断是否符合风险等级，其他产品用level比较判断
                if(proModel.get('type') === 'fund'){
                    commProductsModel.qryRiskAbilityTest({
                        "url" : "qryRiskAbilityTest",
                        "data" : {"fundCode": prdCode},
                        "callback" : function(res){
                            var userRiskThanPrd = res.object.userRiskThanPrd;   //用户风险等级是否低于产品等级
                            if (userRiskThanPrd == "0") {//用户风险等级高于产品
                                thisView.productRiskBook(riskObj, proModel, code);
                            } else if (userRiskThanPrd == "1") {
                                thisView.riskLevelLow(riskLevel, productRiskLevel, code);
                            }
                        },
                        "errorCallback" : function(res) {
                            utils.dialog.toast(res.message);
                        }
                    });
                }else{
                    // 有效的年龄信息
                    if (parseInt(riskLevel) < parseInt(productRiskLevel)) {
                        // 客户风险等级低于当前产品风险等级
                        // 提示客户取重新评测
                        this.riskLevelLow(riskLevel, productRiskLevel, code);
                    } else {
                        // 客户风险等级高于当前产品风险等级
                        // 查询理财产品购买风险确认函
                        thisView.productRiskBook(riskObj, proModel, code);
                    }
                }
			}
		},

		// 查询理财产品购买风险确认函
		productRiskBook : function(riskObj, proModel, code) {
			var thisView = this;
			var productId = proModel.get('type');
			var riskLevel = riskObj.riskLevel;
			// 客户风险等级

			commProductsModel.qryProductRiskBook({
				"url" : "qryProductRiskBook",
				"data" : {
					"productId" : productId,
					"riskLevel" : riskLevel
				},
				"callback" : function(res) {
					var outPassFlag = res.object.outPassFlag;
					if (code == "0") {//code:0为购买 1为定投
						if (outPassFlag == 0 || outPassFlag == 2) {
							App.navigate('myInvestment/commendProducts/riskBook/0', true);
						} else {
							// 所有校验通过，执行购买流程
							//
							if (productId == "fund") {
								App.navigate('myInvestment/commendProducts/BuyFund', true);

							} else {
								App.navigate('myInvestment/commendProducts/goBuyProduct', true);
							}

						}
					} else if (code == "1") {
						if (outPassFlag == 0 || outPassFlag == 2) {
							App.navigate('myInvestment/commendProducts/riskBook/1', true);
						} else {
							// 所有校验通过，执行购买流程
							//
							if (productId == "fund") {
								//进行定投
								App.navigate("fund/fundFixedInvestment/index", true);

							} else {
								App.navigate('myInvestment/commendProducts/goBuyProduct', true);
							}

						}

					} else if (code == "4") {
						if (outPassFlag == 0 || outPassFlag == 2) {
							App.navigate('myInvestment/commendProducts/riskBook/4', true);
						} else {
							// 所有校验通过，执行购买黄金宝流程
							App.navigate('myInvestment/commendProducts/Buygoldtreasure', true);

						}

					} else {
						if (outPassFlag == 0 || outPassFlag == 2) {
							App.navigate('myInvestment/commendProducts/riskBook/5', true);
						} else {
							// 所有校验通过，执行购买流程

							if (productId == "fund") {
								App.navigate('myInvestment/commendProducts/BuyFund', true);
							} else if (productId == 'bill') {
								App.navigate('products/buy/index/bill', true);
							} else {
								App.navigate('myInvestment/commendProducts/goBuyProduct', true);
							}

						}

					}
				},
				"errorCallback" : function(resp) {
					utils.dialog.toast(resp.message);
				}
			});
		},

		// 提示未做理财风险评测，请临柜评测
		tipRiskAtAgency : function() {
			var thisView = this;
			var tipMessage = '<p>' + commProductLang('toBankDoRiskTest') + '</p>';

			App.storage.set('myInestment/tipPageOptions', {
				tipTitle : '你未进行过风险测评',
				tipMessage : tipMessage,
				tipButtonText : '确定',
				tipButtonCallback : function() {
					var model = App.storage.get('myInvestment/commendProducts/curProObj');

					if (!model) {
						App.navigate("products/index/index/finefinance", true);
					} else {
						var model = App.storage.get('products/detail/finace');
						App.storage.set('products/detail/finace', model);
						// App.navigate("products/index/index/finefinance", true);
						App.navigate("products/detail/finace", true);
					}

				}
			});
			App.navigate('myInvestment/commendProducts/lingui', true);
		},

		// 提示未做理财风险评测，请在线评测
		tipRiskOnline : function() {
			var thisView = this;
			var tipMessage = '<p>' + commProductLang('notDoRiskTest') + '</p>';

			App.storage.set('myInestment/tipPageOptions', {
				tipTitle : '你未进行过风险测评',
				tipMessage : tipMessage,
				tipButtonText : '立即测试',
				tipButtonCallback : function() {
					thisView.doRiskTest();
				}
			});
			App.navigate('myInvestment/commendProducts/tipPage', true);
		},

		// 提示风险评测过期，请重新评测
		tipRiskExpired : function(code) {
			App.header.reset({
				title : "智能风险偏好测评",
				leftButtonContent : '@back',
				leftButtonHandler : function() {
					var model = App.storage.get('myInvestment/commendProducts/curProObj');
					var productType = model.get('type');

					if (productType == "fund") {
						App.navigate('products/index/index/selectFund', true);
					} else if (productType == "bill") {
						App.navigate("products/detail/bill", {
							replace : true,
							trigger : true
						});
					} else {
						App.navigate("products/index/index/finefinance", true);
					}
				}
			});
			App.container.show(new tipPageold({
				code : code
			}));

			App.footer.reset({
				visible : false
			});

		},
		sipRiskExpired : function(code) {
			App.header.reset({
				title : "智能风险偏好测评",
				leftButtonContent : '@back',
				leftButtonHandler : function() {
					var model = App.storage.get('myInvestment/commendProducts/curProObj');
					var productType = model.get('type');

					if (productType == "fund") {
						App.navigate('products/index/index/selectFund', true);
					} else {
						App.navigate("products/index/index/finefinance", true);
					}
				}
			});

			App.container.show(new tipPage({
				code : code
			}));

			App.footer.reset({
				visible : false
			});

		},

		// 客户风险等级低于当前产品风险等级，提示客户取重新评测
		riskLevelLow : function(riskLevel, productRiskLevel, code) {
			var model = riskLevel;

			App.storage.set('myInvestment/commendProducts/ca', model);
			App.navigate("myInvestment/commendProducts/ca/" + code, true);
		},

		// 做风险评测
		doRiskTest : function(code) {
			App.navigate("riskExam/riskExam/riskExam/" + code, true);
		},

		// 提示无年龄信息
		noAgeInfo : function() {
			App.header.reset({
				title : "理财产品",
				leftButtonContent : '@back',
				leftButtonHandler : function() {
					var model = App.storage.get('myInvestment/commendProducts/curProObj');
					var productType = model.get('type');

					if (productType == "fund") {
						App.navigate('products/index/index/selectFund', true);
					} else {
						App.navigate("products/index/index/finefinance", true);
					}
				}
			});
			App.container.show(new noAgeInfo());
			App.footer.reset({
				visible : false
			});
		},

		// 提示用户年龄超限
		ageTooBig : function() {
			App.header.reset({
				title : "理财产品",
				leftButtonContent : '@back',
				leftButtonHandler : function() {
					var model = App.storage.get('myInvestment/commendProducts/curProObj');
					var productType = model.get('type');

					if (productType == "fund") {
						App.navigate('products/index/index/selectFund', true);
					} else {
						App.navigate("products/index/index/finefinance", true);
					}
				}
			});
			App.container.show(new ageTooBig());
			App.footer.reset({
				visible : false
			});

		},

		// 提示无年龄信息
		fnoAgeInfo : function() {
			App.header.reset({
				title : "理财产品",
				leftButtonContent : '@back',
				leftButtonHandler : function() {
					var model = App.storage.get('myInvestment/commendProducts/curProObj');
					var productType = model.get('type');

					if (productType == "fund") {
						App.navigate('products/index/index/selectFund', true);
					} else {
						App.navigate("products/index/index/finefinance", true);
					}
				}
			});
			App.container.show(new fnoAgeInfo());
			App.footer.reset({
				visible : false
			});
		},

		// 提示用户年龄超限
		fageTooBig : function() {
			App.header.reset({
				title : "理财产品",
				leftButtonContent : '@back',
				leftButtonHandler : function() {
					var model = App.storage.get('myInvestment/commendProducts/curProObj');
					var productType = model.get('type');

					if (productType == "fund") {
						App.navigate('products/index/index/selectFund', true);
					} else {
						App.navigate("products/index/index/finefinance", true);
					}
				}
			});
			App.container.show(new fageTooBig());
			App.footer.reset({
				visible : false
			});

		},

		ageToosamll : function() {
			var thisView = this;
			var tipMessage = '<p>' + commProductLang('agelimit') + '</p>';

			App.storage.set('myInestment/tipPageOptions', {
				tipTitle : '年龄提示',
				tipMessage : tipMessage,
				tipButtonText : '确定',
				tipButtonCallback : function() {
					App.navigate('myInvestment/commendProducts/proDetail', true);
				}
			});
			App.navigate('myInvestment/commendProducts/tipPage', true);
		},

		scard : function() {
			App.header.reset({
				title : "理财产品",
				leftButtonContent : '@back',
				leftButtonHandler : function() {
					var model = App.storage.get('myInvestment/commendProducts/curProObj');
					var productType = model.get('type');

					if (productType == "fund") {
						App.navigate('products/index/index/selectFund', true);
					} else {
						App.navigate("products/index/index/finefinance", true);
					}
				}
			});
			App.container.show(new scard());
			App.footer.reset({
				visible : false
			});
		},
		bscard : function() {
			App.header.reset({
				title : "理财产品",
				leftButtonContent : '@back',
				leftButtonHandler : function() {
					var model = App.storage.get('myInvestment/commendProducts/curProObj');
					var productType = model.get('type');

					if (productType == "fund") {
						App.navigate('products/index/index/selectFund', true);
					} else {
						App.navigate("products/index/index/finefinance", true);
					}
				}
			});
			App.container.show(new bscard());
			App.footer.reset({
				visible : false
			});
		},
		ca : function(code) {
			App.header.reset({
				title : "智能风险偏好测评",
				leftButtonContent : '@back',
				leftButtonHandler : function() {
					var model = App.storage.get('myInvestment/commendProducts/curProObj');
					var productType = model.get('type');

					if (productType == "fund") {
						App.navigate('products/index/index/selectFund', true);
					} else {
						App.navigate("products/index/index/finefinance", true);
					}
				}
			});
			var risk = {};
			risk.riskLevel = App.storage.get('myInvestment/commendProducts/ca');
			risk.code = code;
			App.container.show(new ca({
				model : new Model(risk)
			}));
			App.footer.reset({
				visible : false
			});
		},
		lingui : function() {
			App.header.reset({
				title : "理财产品",
				leftButtonContent : '@back',
				leftButtonHandler : function() {
					var model = App.storage.get('myInvestment/commendProducts/curProObj');
					var productType = model.get('type');

					if (productType == "fund") {
						App.navigate('products/index/index/selectFund', true);
					} else {
						App.navigate("products/index/index/finefinance", true);
					}
				}
			});
			App.container.show(new lingui());
			App.footer.reset({
				visible : false
			});
		},
		cradLossStatus : function() {
			App.header.reset({
				title : "理财产品",
				leftButtonContent : '@back',
				leftButtonHandler : function() {
					var model = App.storage.get('myInvestment/commendProducts/curProObj');
					var productType = model.get('type');

					if (productType == "fund") {
						App.navigate('products/index/index/selectFund', true);
					} else {
						App.navigate("products/index/index/finefinance", true);
					}
				}
			});
			App.container.show(new cradLossStatus());
			App.footer.reset({
				visible : false
			});
		},
		fail : function() {
			App.header.reset({
				title : "理财产品",
				leftButtonContent : '@back',
				leftButtonHandler : function() {
					var model = App.storage.get('myInvestment/commendProducts/curProObj');
					var productType = model.get('type');

					if (productType == "fund") {
						App.navigate('products/index/index/selectFund', true);
					} else {
						App.navigate("products/index/index/finefinance", true);
					}
				}
			});
			App.container.show(new fail());
			App.footer.reset({
				visible : false
			});
		},

		//liujun add 2015/9/11 追加购买风测过期判断
		// 提示风险评测过期，请重新评测
		addFundTipRiskExpired : function(code) {
			App.header.reset({
				title : "智能风险偏好测评",
				leftButtonContent : '@back',
				leftButtonHandler : function() {
					App.navigate("myProperty/holdDetailsInfo/index", true);
				}
			});
			App.container.show(new tipPageold({
				code : code
			}));

			App.footer.reset({
				visible : false
			});

		},
		//liujun add 2015/9/11 追加购买风测过期判断
		addPurchaseRiskfund : function(code) {
			var thisView = this;
			commProductsModel.riskAbilityTestQry({
				"url" : "riskAbilityTestQry",
				"data" : {},
				"callback" : function(res) {
					var obj = res.object;
					var fundStatus = obj.otherRiskStatus;

					if (fundStatus == '3') {
						// 风险评测过期，请重新评测
						thisView.addFundTipRiskExpired(code);
					} else {
						var addFundData = App.storage.get("addPurchaseFundsData");
						if (addFundData.detailDTO.prdAttr == "4") {
							App.navigate('fund/buy/addMonetary', true);
						} else {
							App.navigate('fund/buy/addNoMonetary', true);
						}
					}
				},
				"errorCallback" : function(res) {
					utils.dialog.alert(res.message);
				}
			});
		},
		//liujun add 15.9.25 黄金宝追加购买风测过期判断
		// 提示风险评测过期，请重新评测
		appGoldTreasureRiskExpired : function(code) {
			App.header.reset({
				title : "智能风险偏好测评",
				leftButtonContent : '@back',
				leftButtonHandler : function() {
					App.navigate("myProperty/holdDetailsInfo/index", true);
				}
			});
			App.container.show(new tipPageold({
				code : code
			}));

			App.footer.reset({
				visible : false
			});

		},
		//liujun add 15.9.25  黄金宝追加购买风测过期判断
		appGoldTreasureRisk : function(code) {
			var thisView = this;
			// var proModel = App.storage.get('myInvestment/commendProducts/curProObj');
			// var productType = proModel.get("type");
			//获取产品代码

			// 请求风险评估
			commProductsModel.riskAbilityTestQry({
				"url" : "riskAbilityTestQry",
				"data" : {},
				"callback" : function(res) {
					var obj = res.object;
					var fundStatus = obj.otherRiskStatus;
					//需修正黄金宝基金风险状态字段
					// 如果购买基金产品
					// if (fundStatus == '1') {
						// // 有效的风险评测状态
						// thisView.fundAgeAndRiskLevel(obj, proModel, code);
						// //传入基金信息
					// } else if (fundStatus == '2') {
						// // 未做理财风险评测，请测评
						// thisView.sipRiskExpired(code);
					// } else
					if (fundStatus == '3') {
						// 风险评测过期，请重新评测
						thisView.appGoldTreasureRiskExpired(code);
					} else {
						App.navigate("goldtreasure/addPurchase/addPurchase", true);
					}
				},
				"errorCallback" : function(res) {
					utils.dialog.toast(res.message);
				}
			});
		}
	});
});
