/**
 * 产品精选 
 */
define(function(require, exports, module) {   
     var commProductsModel = module.exports = Model.extend({}, {
         /*
          * 从CMS上获取配置的推荐理财产品信息
          */
         qryProductsByCMS : function(){
            var deferred;
    
            return function(){
                if(deferred) return deferred;
    
                deferred = $.Deferred();
                window.JSONP_commendatoryProductList = function(data){
                    deferred.resolve(data);
                };
    
                var script = document.createElement("script");
                script.type = "text/javascript";
                if(IS_RUN_IN_PRODUCTION_ENVIRONMENT){
                    // 生产环境读CMS上的配置
                    script.src = config.urls.get("qryProductsByCMS")+"?"+new Date().getTime();
                }else{
                    // stg环境读本机的配置
                    script.src = "mod/myInvestment/common/commendatoryProductList.js";
                }
                document.getElementsByTagName("head")[0].appendChild(script);
    
                return deferred;
            };
        }(),
        
        /*
        * 查询专属理财产品
        */
        qryFinanceRecommendList: function (options){
            this._callInterface(options);
        },
        
         /*
          * 查询专属理财产品
          */
        qryExclusiveFinanceList: function (options){
            this._callInterface(options);
        },
        
         /*
          * 查询专属养老保障产品
          */
        qryExclusivePensionList: function (options){
            this._callInterface(options);
        },
        
         /*
          * 查询确认函标志及信息
          */
        qryProductRiskBook: function (options){
            this._callInterface(options);
        },
        
         /*
          * 确认风险确认函
          */
        confirmProductRiskBook: function (options){
            this._callInterface(options);
        },
        
         /*
          * 查询风险评估信息
          */
        riskAbilityTestQry: function (options){
            this._callInterface(options);
        },
        
        
        
        
        /*
         *查询基金签约状态 
         */
         fundstate: function(options){
 	            this._callInterface(options);

         	
         },
        
         /*
         *查询黄金开户
         */
         qryGoldAcctInfo: function(options){
 	            this._callInterface(options);

         	
         },
         
         //查询产品的风险等级与用户的风险等级是否匹配可购买
         qryRiskAbilityTest: function(options){
 	            this._callInterface(options);
         },
        
        /*
         * 调用接口的公共方法
         * 
         * 入参：
         *      options : 请求参数
         *          url：接口路径
         *          data：接口入参
         *          callback：接口成功回调函数
         *          errorCallback：接口错误回调函数
         * 
         * 返回：无
         */
        _callInterface: function (options){
            App.request(options.url,{
                data    : options.data,
                success : function(res){   
                    if(res.success) {
                        options.callback(res);                        
                    }else{
                        options.errorCallback(res);
                    }                
                },
                error : function(res){
                    options.errorCallback(res);
                }               
            });
        }
     });
     
});