define(function(require, exports, module){

    var myInvestmentModel = module.exports = Model.extend({}, {
        
        /**
         * 
         * 历史累计收益
         * @param {Object} option
         * 
         */
        currentTotalProfit: function(option){
            var param         = option.param,
                silent        = option.silent || false,
                errorCallback = option.errorCallback,
                callback      = option.callback;
            return App.request("currentTotalProfit", {
                data    : param,
                silent  : silent,//true 不显示loading
                success : function(resp){
                    callback && callback(resp.object);
                },
                error : function(resp){
                    errorCallback && errorCallback(resp);
                }
            });
        },
        /**
         * 
         * 平安盈(南方)统计
         * @param {Object} option
         * 
         */
        paynfProductMoneyQry: function(option){
            var param         = option.param,
                silent        = option.silent || false,
                errorCallback = option.errorCallback,
                callback      = option.callback;
            return App.request("paynfProductMoneyQry", {
                data    : param,
                silent  : silent,//true 不显示loading
                success : function(resp){
                    callback && callback(resp.object);
                },
                error : function(resp){
                    errorCallback && errorCallback(resp);
                }
            });
        },
        /**
         * 
         * 平安盈(大华)统计
         * @param {Object} option
         * 
         */
        paydhProductMoneyQry: function(option){
            var param         = option.param,
                silent        = option.silent || false,
                errorCallback = option.errorCallback,
                callback      = option.callback;
            return App.request("paydhProductMoneyQry", {
                data    : param,
                silent  : silent,//true 不显示loading
                success : function(resp){
                    callback && callback(resp.object);
                },
                error : function(resp){
                    errorCallback && errorCallback(resp);
                }
            });
        },
        /**
         * 
         * 定活通统计
         * @param {Object} option
         * 
         */
        dhtBuyedMoneyQry: function(option){
            var param         = option.param,
                silent        = option.silent || false,
                errorCallback = option.errorCallback,
                callback      = option.callback;
            return App.request("dhtBuyedMoneyQry", {
                data    : param,
                silent  : silent,//true 不显示loading
                success : function(resp){
                    callback && callback(resp.object);
                },
                error : function(resp){
                    errorCallback && errorCallback(resp);
                }
            });
        },
        /**
         * 
         * 理财产品统计
         * @param {Object} option
         * 
         */
        lcProductMoneyQry: function(option){
            var param         = option.param,
                silent        = option.silent || false,
                errorCallback = option.errorCallback,
                callback      = option.callback;
            return App.request("lcProductMoneyQry", {
                data    : param,
                silent  : silent,//true 不显示loading
                success : function(resp){
                    callback && callback(resp.object);
                },
                error : function(resp){
                    errorCallback && errorCallback(resp);
                }
            });
        },
        /**
         * 
         * 养老产品统计统计
         * @param {Object} option
         * 
         */
        ylProductMoneyQry: function(option){
            var param         = option.param,
                silent        = option.silent || false,
                errorCallback = option.errorCallback,
                callback      = option.callback;
            return App.request("ylProductMoneyQry", {
                data    : param,
                silent  : silent,//true 不显示loading
                success : function(resp){
                    callback && callback(resp.object);
                },
                error : function(resp){
                    errorCallback && errorCallback(resp);
                }
            });
        },
        
        /***
         *
         * 平安盈历史收益
         *  
         */
        profitHistoricalYieldsQry : function(option){
            var param = option.param,
                errorCallback = option.errorCallback,
                callback = option.callback;
            App.request("profitHistoricalYieldsQry", {
                data    : param,
                success : function(resp){
                    callback && callback(resp.object);
                },
                error : function(resp){
                    errorCallback && errorCallback(resp);
                }
            });
        },
        
        /**
         * 
         * 定活通列表
         * @param {Object} option
         * 
         */
        fixedToCurrentTransferList: function(option){
            var param = option.param,
                errorCallback = option.errorCallback,
                callback = option.callback;
            App.request("fixedToCurrentTransferList", {
                data    : param,
                success : function(resp){
                    callback && callback(resp.object);
                },
                error : function(resp){
                    errorCallback && errorCallback(resp);
                }
            });
        },
        /**
         * 
         * 定活通支取详情
         * @param {Object} option
         */
        profitTransferQry: function(option){
            var param = option.param,
                errorCallback = option.errorCallback,
                callback = option.callback;
            App.request("profitTransferQry", {
                data    : param,
                success : function(resp){
                    callback && callback(resp.object);
                },
                error : function(resp){
                    errorCallback && errorCallback(resp);
                }
            });
        },
        
        /**
         *查询我的委托详情 
         * @param {Object} option
         */
        qryBuyEntrustList : function(option) {
            var param = option.param,
                errorCallback = option.errorCallback,
                callback = option.callback;
            App.request("qryBuyEntrustList", {
                data    : param,
                success : function(resp){
                    callback && callback(resp.object);
                },
                error : function(resp){
                    errorCallback && errorCallback(resp);
                }
            });
        },

        /**
         * 
         * 理财产品-待清算资金
         * @param {Object} option
         */
        tranAmountQry: function(option){
            var param = option.param,
                errorCallback = option.errorCallback,
                callback = option.callback;
            App.request("tranAmountQry", {
                data    : param,
                success : function(resp){
                    callback && callback(resp.object);
                },
                error : function(resp){
                    errorCallback && errorCallback(resp);
                }
            });
        },
        /**
         * 
         * 理财产品-我的持仓
         * @param {Object} option
         */
        myFinanceListQuery: function(option){
            var param = option.param,
                errorCallback = option.errorCallback,
                callback = option.callback;
            App.request("myFinanceListQuery", {
                data    : param,
                success : function(resp){
                    callback && callback(resp.object);
                },
                error : function(resp){
                    errorCallback && errorCallback(resp);
                }
            });
        },
        
        /**
         * 养老保障-我的委托 
         * @param {Object} options
         */
        qryPensionEntrustList : function(options){
            var params = options.params, callback = options.callback,errorCallback = options.errorCallback, url = "qryPensionEntrustList";
            App.request(url,{
                data : params,
                success : function(response){
                    callback && callback(response);
                },
                error : function(response){
                    errorCallback && errorCallback(response);
                }
            })
        },
        
        /**
         * 养老保障-我的持仓
         * @param {Object} option
         */
        financeListPersonQuery : function(option) {
            var param = option.param,
                errorCallback = option.errorCallback,
                callback = option.callback;
            App.request("financeListPersonQuery", {
                data    : param,
                success : function(resp){
                    callback && callback(resp.object);
                },
                error : function(resp){
                    errorCallback && errorCallback(resp);
                }
            });
        },
        
        /**
         * 养老保障-待清算的资金 
         * @param {Object} params
         * @param {Object} callback
         */
        getWaitClearAmt : function(callback){
            App.request("pensionTranAmountQry", {
                data    : {"pageIndex" : 1, "pageSize":50},
                success : function(res){
                    callback(res.object);
                },
                error : function(error){
                    utils.dialog.alert(error.message);
                }
            });            
        },
        
        /**
         * 智能定活通明细查询
         */
        qrySmartDepositInfo: function(options){
            return App.request("qrySmartDepositInfo", options);    
        },
        
        /***
         *
         * 基金统计
         *  
         */
        queryMyFundTotal : function(options){
            var options = options || {};
            return App.request("queryMyFundTotal",{data : options}); 
            
        }
        
    });
});