define(function (require, exports, module) {
	var FormComponent = require("component/form");
	var PTRScroll = require("component/PTRScroll");
	var ProListView = require('./commendProductsList');
	var temp = require("text!../../template/commendProducts/commendProducts.html");

	module.exports = FormComponent.extend({

			template : _.template(temp),

			regions : {
				"commProListContainer" : "#commProListContainer",
				"exclusiveProListContainer" : "#exclusiveProListContainer"
			},

			onShow : function () {
				var proListView = new ProListView({
						collection : new Collection(this.model.get('list'))
					});

				this.commProListContainer.show(proListView);
			},

			events : {
				"tap #serachBtn" : "doSearch"
			},

			doSearch : function () {
				var seqNo = $.trim(this.$("#js-seq-no").val());
				if (!this._checkSeqNo(seqNo))
					return;

				this.trigger('doSearch', seqNo);
			},

			_checkSeqNo : function (seqNo) {
				if (seqNo === '') {
					utils.dialog.toast('请输入序列号');
					return false;
				}
				return true;
			},

			showExclusiveProList : function (list) {
				var proListView = new ProListView({
						collection : new Collection(list)
					});

				this.exclusiveProListContainer.show(proListView);
			}
		});

});
