define(function(require, exports, module){
    
    var indexTpl            = require("text!../template/index.html");
    var FormComponent       = require("component/form");
    
    var MyInvestmentView    = require("./myInvestment/myInvestment");
    
    var model               = require("../model/model");                   //All model
    var accountModel        = require("mod/common/model/accountModel");
    
    var myInvestmentView = module.exports = FormComponent.extend({
        template: indexTpl,

        regions : {
            myInvestmentRegion: "#myInvestmentBox"
        },
        events    : {
            "tap #myInvestmentTab .half" : "selectTitle"
        },
       
        selectTitle : function(e){
            if(this.$(e.currentTarget).hasClass("sel")){
                return;
            }
            this.$(".half").removeClass("sel");
            this.$(e.currentTarget).addClass("sel");
            switch (this.$(e.currentTarget).text()){
                case "我的投资":
                    this.toMyInvestment();
                break;
                case "我的许愿":
                    
                break;
                case "产品精选":
                    this.toCommendProducts();
                break;
            }
        },
        
        /**
         * 
         * 初始化
         * 
         */
        initialize: function(options){
            this.nav      = options.nav; //菜单编号
        },
        
        onRender : function(){
            if(!this.nav){
                this.toMyInvestment();
            }else{
                this.$(".half").removeClass("sel");
                if(this.nav == 1){
                    this.$(".half").eq(1).addClass("sel");
                    this.toCommendProducts();//产品精选
                }else if(this.nav == 2){
                    this.$(".half").eq(2).addClass("sel");
                    this.toCommendProducts();//产品精选
                }
            }
        },
        
        toCommendProducts: function(){
            // var CommendProductsView = require("./commendProducts/commendProducts");
            // this.myInvestmentRegion.show(new CommendProductsView());
            App.storage.set('investmentContentRegion', this.myInvestmentRegion);
            App.navigate('myInvestment/commendProducts/index', true);
        },
        
        /**
         *
         * 我的投资
         * @param {Object} data
         * 
         */
        toMyInvestment : function(data){
            var self = this;
            if(data){
                App.navigate('myInvestment/index/index', false);
                this.myInvestmentRegion.show(new MyInvestmentView({ownerView: this,model:data}));
            }else{
                var promise = $.when(
                    accountModel.asycAccountInfo(),               //活期余额
                    model.paynfProductMoneyQry({"param":{}}),  //平安盈南方
                    model.paydhProductMoneyQry({"param":{}}),  //平安盈大华
                    model.dhtBuyedMoneyQry({"param":{}}),      //定活通
                    model.lcProductMoneyQry({"param":{}}),     //理财产品
                    model.ylProductMoneyQry({"param":{}}),     //养老保障
                    model.currentTotalProfit({"param":{}}),      //历史累计收益
                    accountModel.goldAcctQryAsset(),     //黄金
                    model.qrySmartDepositInfo(),
                    model.queryMyFundTotal()//基金     
                ); 
                promise.done(function(cur,arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9){
                    var current = cur[0].object;
                    var nfObj   = arg1[0].object;
                    var dhObj   = arg2[0].object;
                    var dhtObj  = arg3[0].object;
                    var lcObj   = arg4[0].object;
                    var ylObj   = arg5[0].object;
                    var earObj  = arg6[0].object;
                    var goldObj = arg7[0].object;
                    var zndhtObj = arg8[0].object;
                    var fundObj = arg9[0].object;
                    
                    
                    var availableAssets = (parseFloat(current.balance));//可用余额
                    var totalInvestment = (parseFloat(dhtObj.dhtSun)
                                            +parseFloat(nfObj.paynfDeposit)+parseFloat(dhObj.paydhDeposit)
                                            +parseFloat(lcObj.buyLced)+parseFloat(lcObj.buylcWted)+parseFloat(lcObj.buylcDqs)
                                            +parseFloat(ylObj.buyYlced)+parseFloat(ylObj.buyylWted)+parseFloat(ylObj.buyYldqs)+parseFloat(goldObj.totalPrice)+parseFloat(fundObj.totalVend));//投资总额
                    var totalAssets     = (parseFloat(availableAssets)+parseFloat(totalInvestment)); //总资产
                    var earnings        = parseFloat(earObj.allprodiftAmt); //历史累计收益
                    
                    var assets ={
                        totalAssets     : totalAssets,      //总资产
                        availableAssets : availableAssets,  //可用余额
                        totalInvestment : totalInvestment,  //投资总额
                        earnings        : earnings          //历史累计收益
                    };
                    var data = {
                        assets          : assets,
                        nfList          : arg1[0].object,
                        dhList          : arg2[0].object,
                        dhtList         : arg3[0].object,
                        lcList          : arg4[0].object,
                        ylList          : arg5[0].object,
                        goldList        : arg7[0].object,
                        zndhtList       : arg8[0].object
                    };                      
                    App.storage.set("myAssets",data);
                    self.toMyInvestment(new Model(data));
                }).fail(function(error){
                    utils.dialog.alert(error.message);
                });
            }
        }
        
    });
});