define(function(require, exports, module){
    
    var myInvestmentTpl     = require("text!../../template/myInvestment/index.html");
    var FormComponent       = require("component/form");
    
    var Model               = require("../../model/model");                   //All model
    var accountModel        = require("mod/common/model/accountModel");
    
    var myInvestmentView = module.exports = FormComponent.extend({
        template: myInvestmentTpl,

        events    : {
            "tap #myInvestment_DHT"   : "toDHT",
            "tap #myInvestment_ZNDHT" : "toZNDHT",
            "tap #myInvestment_paydh" : "toProfitIndex",
            "tap #myInvestment_paynf" : "toProfitIndex",
            "tap #toTransRecordsInfo" : "toTransRecordsInfo",
            "tap #yl_hold_details"    : "toYlHoldDetails",
            "tap #yl_my_entrust"      : "toYlMyEntrust",
            "tap #yl_wait_clear_amt"  : "toYlWaitClearAmt",
            "tap .financial-products-hold-details" : "financialProductsHoldDetails",
            "tap .financial-products-clear-money"  : "financialProductsClearMoney",
            "tap #lc_myCommission"     : "toLcCommission",
            "tap #myInvestment_glod" : "toGoldPage"
            
        },
       
        /**
         * 
         * 初始化
         * 
         */
        initialize: function(){
        },
        
        onRender : function(){
            this.$(".showNum").each(_.bind(function(idx, elem){  this.showNum(elem, 0.5); }, this));
        },
        /**
         * 养老持有详情
         */
        toYlHoldDetails : function(){
            var buyYlced = this.model.get("ylList").buyYlced;
            if(buyYlced>0){
                App.navigate("pensionProducts/index/index",true);
            }else{
                App.navigate("myInvestment/commendProducts/index",true);
            }
        },
        /**
         * 养老我的委托
         */
        toYlMyEntrust : function(){
            App.navigate("pensionProducts/index/index/1",true);
        },
        /**
         * 养老待清算资金
         */
        toYlWaitClearAmt : function(){
            App.navigate("pensionProducts/index/index/2",true);
        },
        
        /**
         *黄金 
         */
        toGoldPage : function(){
            utils.dialog.alert("手机端此功能暂未上线，可先通过电脑登录平安橙子使用。");
        },
        
        /**
         *
         * 理财持有详情
         *  
         */
        financialProductsHoldDetails : function(){
            var buyLced = this.model.get("lcList").buyLced;
            if(buyLced>0){
                App.navigate("financialProducts/index/index",true);
            }else{
                App.navigate("myInvestment/commendProducts/index",true);
            }
        },
        
        /**
         *理财我的持有 
         */
        toLcCommission : function() {
            App.navigate("financialProducts/index/index/1",true);
        },
        
        /**
         *
         * 理财待清算资金
         *  
         */
        financialProductsClearMoney : function(){
            App.navigate("financialProducts/index/index/2",true); 
        },
        
        /**
         *
         * 投资记录
         *  
         */
        toTransRecordsInfo: function(){
            App.navigate("myInvestment/transRecordsInfo/index", true);
        },
        
        /**
         *
         * 平安盈
         *  
         */
        toProfitIndex:function(e){
            var target=e.currentTarget;
            if(target.id=="myInvestment_paydh"){
                App.storage.set("profitProduct","dh");
            }else{
                App.storage.set("profitProduct","nf");
            }
            App.navigate("pinganying/profitIndex/index/"+Date.parse(new Date()),true);
        },
        
        /**
         *
         * 定活通
         *  
         */
        toDHT : function(){
            App.navigate("dinghuotong/index/index/"+Date.parse(new Date()),true);
        },
        
        toZNDHT: function(){
            App.navigate("zhinengDinghuotong/asset/list?" + Date.parse(new Date()), true);    
        },
        
        /**
         * 动画显示数值
         * @param {Object} element
         * @param {Object} time
         * 
         */
        showNum : function(element, time){
            var i=0;
            var num = $(element).text();
            time = time ? time*1000 : 5000;
            
            if((num+"").indexOf(",")!= -1){
                num=num.replace(/,/g, "");
            }
            var iTimer = setInterval(function(){
                i=(parseFloat(i)+parseFloat(num/(time/25.01)));
                //$(element).html(utils.string.formatMoneyNumber(i));
                $(element).children(".js-b").html(utils.string.formatMoneyNumber(i).split(".")[0]+'.');
                $(element).children(".js-a").html(utils.string.formatMoneyNumber(i).split(".")[1]);
                if(parseFloat(i)>=parseFloat(num)){
                    clearInterval(iTimer);
                    $(element).children(".js-b").html(utils.string.formatMoneyNumber(num).split(".")[0]+'.');
                    $(element).children(".js-a").html(utils.string.formatMoneyNumber(num).split(".")[1]);
                }
            },25.01);
        }
        
    });
});