define(function(require,exports,module){
    var itemTemp          = require("text!../../template/myInvestment/transRecordsDhtListItem.html");
    var DetailsView       = require("./details/detailsDht");
    var DINGHUOTONG_CODE  = config.values.dinghuotong_code;
    
    var itemView = ItemView.extend({
        tagName: 'li',
        className: function(){
            if (this.model.get('orderType') === '02') {
                return 'green';
            } else {
                return 'red';
            }
        },
        template: _.template(itemTemp),
        events : {
            "tap": "itemClick"
        },
        templateHelpers: {
            transAmtHtml: function(){
                return utils.string.moneyFormatHTML({
                    bigFontClass:"f14",
                    smallFontClass:"f12",
                    money:this.transAmt
                });
            },
            transDateHtml: function(){
                return utils.date.formatTime(this.transTime).format("yyyy-MM-dd");
            },
            transTypeHtml: function(){
                if (this.orderType === '02') {
                    return '支取';
                } else {
                    return '存入';
                }
            }
        },
        itemClick: function(e){
            this.triggerMethod('clicked');
        }
    });
    
    var emptyView = ItemView.extend({
        tagName: 'li',
        template: '<div class="w100 ma tac">查无记录</div>'
    });
    
    module.exports = CollectionView.extend({
        tagName: 'ul',
        itemView: itemView,
        emptyView: emptyView,
        _setHead : function(url, headTitle) {
            App.header.reset({
                title : headTitle,
                leftButtonContent:"@back",
                leftButtonHandler : function(){
                    App.navigate(url, true);
                }
            });
        },
        onItemviewClicked: function(itemView){
            console.log(itemView.model);
            if(itemView.model.get('orderType') ==="02"){
                this._setHead('myInvestment/transRecordsInfo/index', '支取详情');
            }else{
                this._setHead('myInvestment/transRecordsInfo/index', '投资记录');
            }
            
            this.trigger('gotoDetailPage');
            
            App.container.show(new DetailsView({
                model: itemView.model
            }));
            
        }
    });
    
});
