define(function(require,exports,module){
    var temp = require("text!../../template/myInvestment/transRecordsInfo.html");
    var PayListView = require("./transRecordsList");
    var DhtListView = require("./transRecordsDhtList");
    var LcListView = require("./transRecordsLcList");
    var YlListView = require("./transRecordsYlList");
    var TransModel = require("../../model/transRecordsInfo");
    var transModel = new TransModel();
    var FormComponent        = require("component/form");
    
    var PTRScroll = require("component/PTRScroll");
    
    var FUND_CODE_NANFANG = config.values.fund_code_nanfang;
    var FUND_CODE_DAHUA   = config.values.fund_code_dahua;
    var DINGHUOTONG_CODE  = config.values.dinghuotong_code;
    var FINANCIAL_CODE    = config.values.financial_code;
    var PROVIDE_CODE      = config.values.provide_code;
    
    module.exports = FormComponent.extend({
        
        template: _.template(temp),
        
        templateHelpers: {
            showProductName: function(){
                var prdCode = this.param.prdCode;
                if (prdCode == FUND_CODE_DAHUA) {
                    return '平安盈（大华）';
                }else if (prdCode == FUND_CODE_NANFANG) {
                    return '平安盈（南方）';
                }else if(prdCode == DINGHUOTONG_CODE){  //定活通
                    return '定活通';
                }else if(prdCode == FINANCIAL_CODE){  //理财产品
                    return '理财产品';
                }else if(prdCode == PROVIDE_CODE){  //养老产品
                    return '养老产品';
                }
            }
        },
        
        ui: {
            "prdSelection": "#prdSelection",
            "startDateBtn": "#startDate",
            "endDateBtn": "#endDate"
        },
        
        regions: {
            'transListRegion': '#transRecordListContainer'
        },
        
        events: {
            "tap @ui.prdSelection": "prdSelection", // 选择产品类别
            "datepicker:dateSelect @ui.startDateBtn" : "selectStartDate",   //选择开始日期
            "datepicker:dateSelect @ui.endDateBtn"   : "selectEndDate"     //选择结束日期
        },
        
        initialize: function(){
            this.param = this.model.get('param');
            this.param.prdCode = this.param.prdCode || FUND_CODE_DAHUA;
            this.initProSettings(this.param.prdCode);
        },
        
        onShow: function(){
            if (!this.model.get('tempDataList')) {
                this.qryFirstPageData();
            	this.setDateTime();
            } else {
                this.showTempPageData();
            }
        },
        
        showTempPageData: function(){
            var model = this.model;
            var list = model.get('tempDataList');
            var responseData = model.get('responseData');
            
            this.initPTRScroll();
            this.listViewCollectionChange(list);
            this.initPullUpToLoadMore(responseData.object);
        },
        
        // 根据不同产品编码获取相应的接口名(in model)
        initProSettings: function(prdCode){
            if(prdCode == FUND_CODE_DAHUA || prdCode == FUND_CODE_NANFANG){ //平安盈
                this.modelMethod = 'getPingAnYingInfo';
                this.respListName = 'transferRecordList';
                this.listView = PayListView;
            }else if(prdCode == DINGHUOTONG_CODE){  //定活通
                this.modelMethod = 'getDingHuoTongInfo';
                this.respListName = 'qryTransferQueryOutDTOs';
                this.listView = DhtListView;
            }else if(prdCode == FINANCIAL_CODE){  //理财产品
                this.modelMethod = 'getFinancialProInfo';
                this.respListName = 'list';
                this.listView = LcListView;
            }else if(prdCode == PROVIDE_CODE){  //养老产品
                this.modelMethod = 'getYangLaoProInfo';
                this.respListName = 'list';
                this.listView = YlListView;
            }
        },
        
        prdSelection : function(e){
            var self  = this;
            var index = parseInt($(e.currentTarget).attr("data-index"));
            utils.dialog.spinner({
                eventObj : e,
                title : "产品类型",
                source : [
                    {"text":"平安盈（南方）", "value":FUND_CODE_NANFANG},
                    {"text":"平安盈（大华）", "value":FUND_CODE_DAHUA},
                    {"text":"定活通", "value":DINGHUOTONG_CODE},
                    {"text":"理财产品", "value":FINANCIAL_CODE},
                    {"text":"养老产品", "value":PROVIDE_CODE}
                ],
                selectedIndex : index,
                //textField : string, // which field to be presented
                callback : function(selectedItem, selectedIndex) {
                    self.listViewInstance = null;
                    self.ui.prdSelection.attr({"data-value":selectedItem.value,"data-index":selectedIndex}).html('<p class="fl m_l20 p_10">'+selectedItem.text+'</p><p class="fr p_10"><i class="iconA16"></i></p>');
                    self.param.prdCode = selectedItem.value;
                    self.initProSettings(selectedItem.value);
                    self.qryFirstPageData();
                }
            }); 
        },
        
        // 选择开始日期
        selectStartDate : function(eve,_this,value){
        	var consumeView = this;
        	var taday = new Date(App.storage.get("Login_SysTime") || new Date()).format("yyyy-MM-dd");
        	var yesToday = new Date(utils.date.diffDateAdd(App.storage.get("Login_SysTime") || new Date(),-1,"d")).format("yyyy-MM-dd");
            if(value == taday){
        		consumeView.model.set("endDate", taday);
        		$("#endDate .js-date-text").text(taday);
        		$("#endDate").attr("data-initDate", taday);
    			$("#endDate").attr("data-startDate", taday);
    			$("#endDate").attr("data-endDate", taday);
        	}else{
    			$("#endDate").attr("data-startDate", value);
    			$("#endDate").attr("data-endDate", yesToday);
    			if($("#endDate .js-date-text").text() == taday){
            		consumeView.model.set("endDate", yesToday);
            		$("#endDate .js-date-text").text(yesToday);
        			$("#endDate").attr("data-initDate", yesToday);
    			}
        	}
            if (!this._validateDateSlct(value, this.ui.endDateBtn.attr("data-initDate"))) return;
            this.ui.startDateBtn.attr("data-initDate",value).find("span.js-date-text").html(value);
            this.qryFirstPageData();
        },
        
        // 选择结束日期
        selectEndDate : function(eve,_this,value){
            if (!this._validateDateSlct(this.ui.startDateBtn.attr("data-initDate"), value)) return;
            this.ui.endDateBtn.attr("data-initDate",value).find("span.js-date-text").html(value);
            this.qryFirstPageData();
        },
        
        _validateDateSlct: function(startDate, endDate){
            if(utils.date.compareDate(startDate, endDate) == 1){
                utils.dialog.toast("开始日期不能大于结束日期");
                return false;
            }
            var sdate = utils.date.diffDateAdd(endDate,-3,"m"); 
            if(utils.date.diffDate(startDate, sdate) >0){
                utils.dialog.toast("查询时间段不能超过3个月");
                return false;
            }
            return true;
        },
        
        // 准备查询（当首次进入页面 或 变更查询参数时）
        qryFirstPageData: function(){
            this.param.startDate = this.$("#startDate").find(".js-date-text").text();
            this.param.endDate = this.$("#endDate").find(".js-date-text").text();
            var param = this.param;
            param.pageIndex = 1;
            if (this.validate(param)) {
                this.doQryFirstPageData(param);
            }
        },
        
        // 执行查询（当首次进入页面 或 变更查询参数时）
        doQryFirstPageData: function(param){
            this.qryData({
                param: param,
                callback: _.bind(function(response){
                    this.model.set('responseData', response);
                    var list = this.getResultList(response);
                    if (!list || list.length == 0) {
                        this.scroller && this.scroller.destroy();
                        this.listViewCollectionChange([]);
                    } else {
                        this.initPTRScroll();
                        this.listViewCollectionChange(list);
                        this.initPullUpToLoadMore(response.object);
                    }
                }, this)
            });
        },
        
        //根据不同的产品编号，取不同的列表数据
        getResultList: function(response){
            return response.object[this.respListName];
        },
        
        // 查询前校验参数
        validate : function(param){
            return true;
        },
        
        //初始化上下拉
        initPTRScroll : function(){
            if (this.scroller) return;
            
            var self = this;
            var wHeight=$(window).outerHeight(true);
            var navHeight=this.$(".content2").outerHeight(true);
            var listHeight = wHeight-navHeight;
            var dom = $("#scrollContainer").css({"height":listHeight,"position":"relative"});
            
            //初始化iscroller
            this.scroller = new PTRScroll(dom[0],{
                "hScroll"          : false,
                "checkDOMChanges"  : true,
                "hideScrollbar"    : false
            });
            
            //下拉刷新 
            this.scroller.options.refreshContent = function(refresh){
                self.scrollerLoadData(refresh, 1);
            };
            
            //上拉加载 
            this.scroller.options.loadMoreContent = function(refresh){
                self.scrollerLoadData(refresh, self.param.pageIndex + 1);
            };
        },
        
        // 上下拉时加载数据
        scrollerLoadData: function(refresh, pageIndex){
            var self = this;
            
            // 重置页码参数
            var param = this.param;
            var tempParam = _.defaults({pageIndex: pageIndex}, param);
            
            // 请求数据
            this.qryData({
                param: tempParam,
                callback: function(response){
                    param.pageIndex = pageIndex;
                    var list = self.getResultList(response);
                    if (pageIndex == 1) {
                        self.listViewCollectionChange(list);
                    } else {
                        self.listViewCollectionAdd(list);
                    }
                    self.initPullUpToLoadMore(response.object);
                },
                complete: function(){
                    refresh();
                }
            });
        },
        
        //初始化上下拉标签
        initPullUpToLoadMore : function(object){
            if (+object.totalRows > 1 * this.param.pageIndex * object.pageSize) {
                this.scroller.enablePullUpToLoadMore();
            } else {
                this.scroller.disabledPullUpToLoadMore();
            }            
        },
        
        //执行请求数据
        qryData : function(options){
            var self = this;
            // 防重复提交
            if(self.submitFlag === 1) return;
            self.submitFlag = 1;
            
            transModel[this.modelMethod]({
                param: options.param,
                callback: function(response){
                    options.callback && options.callback(response);
                },
                complete: function(){
                    options.complete && options.complete();
                    self.submitFlag = 0;
                }
            });
        },
        
        // 更改collectionView中的collection，并渲染该view
        listViewCollectionChange: function(list){
            this.model.set('tempDataList', list);
            
            if (this.listViewInstance) {
                this.listViewInstance.collection.reset(list);
            } else {
                this.showRecordsListView(new Collection(list));
            }
        },
        
        // 增加collectionView中的collection，并渲染该view
        listViewCollectionAdd: function(list){
            var tempDataList = this.model.get('tempDataList');
            this.model.set('tempDataList', tempDataList.concat(list));
            
            if (this.listViewInstance) {
                this.listViewInstance.collection.add(list);
            }
        },
        
        // 显示列表view
        showRecordsListView: function(collection){
            var thisView = this;
            
            var view = this.listViewInstance = new this.listView({
                collection: collection
            });
            
            view.on('gotoDetailPage', function(){
                App.storage.set('myInvestment/transRecordsInfoData', thisView.model);
                App.navigate('myInvestment/transRecordsInfo/detail', false);
                App.footer.reset({
                    visible : false
                });
            });
            
            this.transListRegion.show(view);
        },
        
        setDateTime: function(){
        	$("#startDate").attr("data-endDate", new Date(utils.date.diffDateAdd(App.storage.get("Login_SysTime") || new Date(),0,"d")).format("yyyy-MM-dd"));
        	$("#endDate").attr("data-startDate", this.model.get("startDate"));
        	$("#endDate").attr("data-endDate", new Date(utils.date.diffDateAdd(App.storage.get("Login_SysTime") || new Date(),-1,"d")).format("yyyy-MM-dd"));
        }
        
    });
});
