define(function(require,exports,module){
    var itemTemp = require("text!../../template/myInvestment/transRecordsYlListItem.html");
    var DetailsView       = require("./details/detailsYl");
    var PROVIDE_CODE      = config.values.provide_code;
    
    var itemView = ItemView.extend({
        tagName: 'li',
        className: function(){
            if (this.model.get('transName') === '撤销预约买入') {
                return 'green';
            } else {
                return 'red';
            }
        },
        template: _.template(itemTemp),
        events : {
            "tap": "itemClick"
        },
        templateHelpers: {
            transAmtHtml: function(){
                return utils.string.moneyFormatHTML({
                    bigFontClass:"f14",
                    smallFontClass:"f12",
                    money:this.tranAmount
                });
            },
            transDateHtml: function(){
                return utils.date.formatTime(this.tranDateFormat).format("yyyy-MM-dd")
            }
        },
        itemClick: function(e){
            this.triggerMethod('clicked');
        }
    });
    
    var emptyView = ItemView.extend({
        tagName: 'li',
        template: '<div class="w100 ma tac">查无记录</div>'
    });
    
    module.exports = CollectionView.extend({
        tagName: 'ul',
        itemView: itemView,
        emptyView: emptyView,
        _setHead : function(url, headTitle) {
            App.header.reset({
                title : headTitle,
                leftButtonContent:"@back",
                leftButtonHandler : function(){
                    App.navigate(url, true);
                }
            });
        },
        onItemviewClicked: function(itemView){
            console.log(itemView.model);
            this._setHead('myInvestment/transRecordsInfo/index', '委托详情');
            
            this.trigger('gotoDetailPage');
            
            App.container.show(new DetailsView({
                model: itemView.model
            }));
        }
    });
    
});
