/**
 * EX-WUWENJUN
 * 投资详情
 */
define(function(require, exports, module) {
	var HoldDetailsInfo                    = require("../view/holdDetailsInfo");
	var MyCommissionModel                  = require("../model/myCommission");
	var MyCommissionView                   = require("../view/myCommissionDetail");
	var pensionModel                       = require("../model/pensionModel");
	var MyClearingMoneyView                = require("../view/myClearingMoney");
	var fundHoldDetailsView                = require("../view/fundHoldDetailsInfo");
	var fundEntrustDetailsView             = require("../view/fundEntrustDetailsInfo");
	var bonusSettingsView                  = require('../view/bonusSettings');
	var bonusSettingsSuccessView           = require('../view/bonusSettingsSuccess');
	var fundRateDetailsView                = require('../view/fundRateDetails');
	var fundDetailsModel                   = require("../../fund/model/fundDetails");
	var goldAppointmentReturnView          = require("../view/goldAppointmentReturn");
	var goldAppointmentRuleView            = require("../view/goldAppointmentRule");
	var goldAppointmentReturnSucView       = require("../view/goldAppointmentReturnSuc");
	var myPropertyModel                    = require("../model/myPropertyAccountInfo");   //理财model接口
	var financialPartRedemptionView        = require("../view/financialPartRedemption");
	var financialPartRedemptionSuccessView = require("../view/financialPartRedemptionSuccess");
	var billHoldDetailsView                = require("../view/bill/billHoldDetailsInfo");
	var billEntrustDetailsView             = require("../view/bill/billEntrustDetailsInfo");
	var FundStrongRedeemDetailView         = require("../view/fundStrongRedeemDetail");

	var index = module.exports = Controller.extend({
		actions : {
			'index'         : 'index',
			'bonusSettings' : 'bonusSettings',          //liujun add fundDetails 15/8.13
			'bonusSettings/:code' : 'bonusSettings',
			'fundRateDetails' : 'fundRateDetails',
			'goldAppointmentReturn' : 'goldAppointmentReturn',   //黄金宝预约赎回
			'goldAppointmentRule' : 'goldAppointmentRule',    //黄金宝预约赎回规则
			'goldAppointmentReturnSucess' : 'goldAppointmentReturnSucess', //黄金宝赎回成功
			'financialPartRedemption' : 'financialPartRedemption',  //liujun add 15.9.25理财产品赎回
			'financialPartRedemptionSuccess' : 'financialPartRedemptionSuccess' //liujun add 15.9.25理财产品赎回成功
		},

		index : function() {
			App.header.reset({
				title : "投资详情",
				leftButtonContent : '@back',
				leftButtonHandler : function() {
					App.navigate("myProperty/myProperty/index", true);
				}
			});

			var myPropertyInfo = App.storage.get("myPropertyData");
			//isProType产品类型 0定活通、1智能定活通、2黄金、3平安盈、4基金、5理财、6养老、7快E盈、8黄金宝 9、定期 10、E企盈
			var isProType = myPropertyInfo.isProType;
			//prdStatus产品状态  1持有 2委托   3待清算
			var prdStatus = myPropertyInfo.prdStatus;

			if(isProType == 5 || isProType == 6 || isProType == 7){
				if(prdStatus == 1){
					this.toHoldDetailsFinancia(myPropertyInfo);
				}else if(prdStatus == 2){
					this.myCommission(myPropertyInfo);
				}else if(prdStatus == 3){
					this.myClearingMoney(myPropertyInfo);
				}
			}else if(isProType == 4){
				if(prdStatus == 1){
					this.fundHold(myPropertyInfo);
				}else if(prdStatus == 2){
					this.fundEntrust(myPropertyInfo);
				}
			}else if(isProType == 8){
				//黄金宝需要另外写持有、委托、带清算页面
				if(prdStatus == 1){
					this.toHoldDetailsFinancia(myPropertyInfo);
				}else if(prdStatus == 2){
					this.myCommission(myPropertyInfo);
				}else if(prdStatus == 3){
					this.myClearingMoney(myPropertyInfo);
				}
			}else if(isProType == 10){
				//E企盈持有、委托中（1、持有 2、委托中）
				if(prdStatus == 1){
					this.toHoldDetailsBill(myPropertyInfo);
				}else if(prdStatus == 2){
					this.toEntrustDetailsBill(myPropertyInfo);
				}
			}else if(isProType == 11){
				//每日盈赎回列表
				this.toFundStrongRedeemDetail(myPropertyInfo.fundStrongRedeemDetail);
			}


		},

		bonusSettings : function(code){
			App.header.reset({
				title : '分红方式设置',
				leftButtonContent : '@back',
				leftButtonHandler : function(){
					App.navigate('myProperty/holdDetailsInfo/index',true);
				}
			});
			if(code && code == 'success')
			{
				App.container.show(new bonusSettingsSuccessView());
			}else{
				App.container.show(new bonusSettingsView());
			}
		},

		fundRateDetails : function(){
			App.header.reset({
				title : '费率详情',
				leftButtonContent : '@back',
				leftButtonHandler : function(){
					App.navigate('myProperty/holdDetailsInfo/index',true);
				}
			});
			var rateData = {};
			rateData.prdCode = App.storage.get("myPropertyData").prdCode;
			//App.storage.get("myPropertyData")   set 入参
			var promise = fundDetailsModel.fundRateDetails({data : rateData });
			promise.done(_.bind(function(arg1){
				arg1 = arg1.object;
				if(arg1){
					App.container.show(new fundRateDetailsView({model : new Model(arg1)}));
				}else{
					App.container.show(new fundRateDetailsView());
				}
			},this));
			promise.fail(function(res){
				utils.dialog.toast(res.message);
			});

		},

		/**
		*  liujun add 理财(净值、日添利、滚动)赎回
		*
		*/
		financialPartRedemption : function(){
			App.header.reset({
				title : '产品赎回',
				leftButtonContent : '@back',
				leftButtonHandler : function(){
					App.navigate('myProperty/holdDetailsInfo/index',true);
				}
			});
			App.container.show(new financialPartRedemptionView({model : new Model(App.storage.get("myPropertyData"))}));
		},

		/**
		*  liujun add 理财(净值、日添利、滚动)赎回成功页
		*
		*/
		financialPartRedemptionSuccess : function(){
			App.header.reset({
				title : '赎回成功',
				leftButtonContent : '@back',
				leftButtonHandler : function(){
					App.navigate('myProperty/myProperty/index',true);
				}
			})
			App.container.show(new financialPartRedemptionSuccessView());
		},

		/**
		 * wuwenjun059
		 * 黄金宝预约赎回
		 *
		 */
		goldAppointmentReturn : function(){
			App.header.reset({
				title : '预约赎回',
				leftButtonContent : '@back',
				leftButtonHandler : function(){
					App.navigate('myProperty/holdDetailsInfo/index',true);
				},
				rightButtonContent : '规则',
				rightButtonHandler : function(){
					App.navigate('myProperty/holdDetailsInfo/goldAppointmentRule',true);
				}
			});

			var myPropertyInfo = App.storage.get("myPropertyData");
			App.container.show(new goldAppointmentReturnView({model : new Model(myPropertyInfo)}));

		},

		/**
		 * wuwenjun059
		 * 预约赎回规则
		 */
		goldAppointmentRule : function(){
			App.header.reset({
				title : '规则',
				leftButtonContent : '@back',
				leftButtonHandler : function(){
					App.navigate('myProperty/holdDetailsInfo/goldAppointmentReturn',true);
				}
			});

			App.container.show(new goldAppointmentRuleView());
		},

		/**
		 * wuwenjun059
		 * 预约赎回成功
		 */
		goldAppointmentReturnSucess : function(){
			App.header.reset({
				title : '预约赎回成功',
				leftButtonContent : '@back',
				leftButtonHandler : function(){
					App.navigate('myProperty/myProperty/index',true);
				}
			});

			App.container.show(new goldAppointmentReturnSucView());
		},

		/**
		 * 持有详情(理财、养老、快E盈)
		 *
		 */
		toHoldDetailsFinancia : function(myPropertyInfo){
		   App.container.show(new HoldDetailsInfo({model:new Model(myPropertyInfo)}));
		},

		/**
		 * 我的委托详情(理财、养老、快E盈)
		 *
		 */
		 myCommission : function(myPropertyInfo) {
			App.container.show(new MyCommissionView({model:new Model(myPropertyInfo)}));
		},

		/**
		 *待清算(理财、养老、基金、快E盈)
		 *
		 */
		 myClearingMoney : function(myPropertyInfo){
			App.container.show(new MyClearingMoneyView({model:new Model(myPropertyInfo)}));
		 },

		 /**
		  * liujun add
		  * 基金持有
		  */
		fundHold: function(myPropertyInfo){
			App.container.show(new fundHoldDetailsView({model:new Model(myPropertyInfo)}));
		},
		 /**
		  * liujun add
		  * 基金委托
		  */
		fundEntrust: function(myPropertyInfo){
			App.container.show(new fundEntrustDetailsView({model:new Model(myPropertyInfo)}));
		},

		/**
		 * wuwenjun059
		 * E企盈持有详情
		 */
		toHoldDetailsBill : function(myPropertyInfo){
			App.container.show(new billHoldDetailsView({model:new Model(myPropertyInfo)}));
		},

		/**
		 * wuwenjun059
		 * E企盈委托中详情
		 */
		toEntrustDetailsBill : function(myPropertyInfo){
			App.container.show(new billEntrustDetailsView({model:new Model(myPropertyInfo)}));
		},

		/**
		 * 每日盈赎回详情
		 */
		toFundStrongRedeemDetail: function(detail){
			App.header.reset({
				title : "详情",
				leftButtonContent : '@back',
				leftButtonHandler : function() {
					App.navigate("myProperty/myProperty/index", true);
				}
			});
			App.container.show(new FundStrongRedeemDetailView({model:new Model(detail)}));
		}
	});
});