/**
 * liujun 15.9.25
 * 理财(日添利系列、净值型产品、滚动型产品赎回)
 */
define(function (require, exports, module) {
    var Component = require("component/form");
    var financialPartRedemptionHtml = require("text!../template/financialPartRedemption.html");
    var myPropertyModel = require("../model/myPropertyAccountInfo");
    var safeKeyBoardHelper = require("component/customInput.helper");
    var CustomPwdInput = require("component/password/customPwdInput");
    var financialPartRedemptionView = module.exports = ItemView.extend({
        template: _.template(financialPartRedemptionHtml),
        initialize: function (options) {
            this.model = options.model;
            submitStates = false;
            this.minHold = App.storage.get("myPropertyData").accMinAmount1;
            this.byStepAmt = App.storage.get("myPropertyData").tranUnitAmount1;
        },
        onShow: function () {
            this._InitRedemptionKeyboard();
            this._redemptionDone();
        },
        events: {
            "tap #allRedemption": "allRedemption",   //全部赎回
            "tap #confirmRedemp": "confirmRedemp",  //赎回确认
            "customInputFocusOut #focusOutRedemptions": "focusOutRedemptions", //失去焦点
            "tap #iptParent span": "redemptionsTypeOption"   //单选方式
        },
        _InitRedemptionKeyboard: function () {
            this.$('#redemptions').customInput({
                type: "decimal",
                placeholder: "最低赎回" + Number(this.byStepAmt),
                className: "safeKeyBoard",
                maxLength: "10"
            });
            this.$("#redemptions").addClass('flex1 dsb');
        },
        _redemptionDone: function () {
            this.$('#cancelRedempt').prop("checked", true);
        },
        //赎回全部可用金额
        allRedemption: function () {
            //controller传过的data或者App.storage.get("myPropertyData");中取数据
            var holdAmt = this.model.get("sourceAmount");
            this.$("#redemptions").customInput("value", holdAmt);
        },
        focusOutRedemptions: function () {
            safeKeyBoardHelper.focusOut({ id: "redemptions" });
        },
        //赎回方式选项
        redemptionsTypeOption: function (e) {
            var curr = e.currentTarget;
            if (this.$(curr).children('i').hasClass('iconA107')) {
            } else {
                this.$(curr).siblings('span').children('i').removeClass('iconA107').addClass('iconA106');
                this.$(curr).children('i').removeClass('iconA106').addClass('iconA107');
                this.$(curr).find('input').prop('checked', true);
            }
        },
        //赎回请求
        redemptionRequester: function (currRed) {

            var redempData = {};
            redempData.accountId = App.storage.get("myPropertyData").accountId;
            redempData.orderId = App.storage.get("myPropertyData").orderId;
            redempData.currentAmtDouble = App.storage.get("myPropertyData").sourceAmount;
            redempData.drawAmount = parseFloat(currRed);
            redempData.largeAmountFlag = this.$('#iptParent input:checked').attr('data-id');
            CustomPwdInput.customPwdInput(
                function (pwd) {
                    submitStates = true;
                    redempData.password = utils.crypto.RSAKey.encrypt(pwd, config.base.rsa_public_key);
                    redempData.sm2Pwd = utils.sm2.SM2Key.encrypt(pwd, config.base.sm2_public_key);
                    myPropertyModel.financialRedemption({
                        url: "financialRedemption",
                        data: redempData,
                        callback: function (res) {
                            submitStates = false;
                            //删除我的资产缓存信息
                            App.requester.storage.remove("loginedAccountInfo");
                            //理财产品返回时间等东西
                            App.storage.set("financialRedempSuccess", res.object);
                            App.navigate('myProperty/holdDetailsInfo/financialPartRedemptionSuccess', true);
                        },
                        errorCallback: function (err) {
                            submitStates = false;
                            utils.dialog.alert(err.message);
                        }
                    });
                }
            );
        },
        //赎回提交
        confirmRedemp: function () {
            if (submitStates) {
                return;
            } else {
                var currRed = this.$("#redemptions").customInput("value").replace(/,/g, "");
                if (!Number(this.$("#redemptions").customInput("value").replace(/,/g, ""))) {
                    utils.dialog.toast("请输入赎回份额");
                } else {
                    if ((Number(this.model.get("sourceAmount")) - Number(currRed)) == 0) {
                        this.redemptionRequester(currRed);
                    } else {
                        if (Number(currRed) % Number(this.byStepAmt) != 0) {
                            utils.dialog.toast("请输入" + Number(this.model.get("tranUnitAmount1")) + "元的正整数倍");
                        } else {
                            if ((Number(this.model.get("sourceAmount")) - Number(currRed)) < Number(this.model.get("accMinAmount1"))) {
                                utils.dialog.toast("最低剩余" + Number(this.model.get("accMinAmount1")) + "元或者全部赎回");
                            } else {
                                this.redemptionRequester(currRed);
                            }
                        }
                    }
                }
            }
        }

    });
});