/**
 * liujun
 * 基金委托详情View 
 */
define(function(require,exports,module){
    var Component = require("component/form"); 
    var fundEntrustDetailsHtml = require("text!../template/fundEntrustDetailsInfo.html");
    var fundDetailsModel = require("../../fund/model/fundDetails");
    var accountInfoSta = require("mod/common/accountInfoStatus/accountInfoStatus");
    var safeKeyBoardHelper = require("component/customInput.helper");
    
    var fundEntrustDetailsView = module.exports = Component.extend({
        template : _.template(fundEntrustDetailsHtml),
        events : {
            "tap #trustRevocation" : "trustRevocation",   //委托撤销
            "tap #inquiryRate" : "inquiryRate"
        },
       
        initialize: function(options){
       		  this.model = options.model;
            submitFlag = false;
        },
       
        //查询费率
        inquiryRate : function(){
            //set data
            App.navigate('myProperty/holdDetailsInfo/fundRateDetails',true);
        },
        /**
        * 委托撤销
        * 
        */
        trustRevocation : function() {
       	    var self = this;
       	    var dfd = accountInfoSta.getAccountInfoStatus(false,"myProperty/holdDetailsInfo/index");
    			  dfd.done(function(accountSta){
                if(accountSta){

      				    utils.dialog.confirm(
      	           		"确定要撤销委托吗？",
      	           		function(e){
      	           			if(e == true){
      	           				self.submit();
                        }
      	           		}
      	           );

      			    }
            });
           
        },
       
       
       /**
        * 委托撤销(提交事件)
        * 
        */
       submit : function(){
       		//产品类型4为基金
       		var isProType = this.model.attributes.isProType;
       		if(isProType == 4){
       			this.revoteSubmit();
       		}
       },

       /**
        *委托撤销 (理财)
        * 
        */
       revoteSubmit : function() {
            var formData = {
                // channelType: 0,
                assoSerial : this.model.get("seqNo"),
                yebFlag: "0"
            };
            if(submitFlag){
           		  return;
            }
           
            fundDetailsModel.entrustRevote({
                url: "fundEntrustRevoke",
                data : formData,
                callback : function(resp){
                	  submitFlag = true;
                    //删除我的资产缓存信息
                    App.requester.storage.remove("loginedAccountInfo");
                    utils.dialog.toast("撤销成功",function(){    
                        App.navigate("myProperty/myProperty/index", true);
                    });
                },
                errorCallback : function(resp) {
                    utils.dialog.alert(resp.message);
                }
            });
         },
         
    });
});