/**
 * liujun
 * 基金持有详情
 */
define(function(require,exports,module){
    var Component = require("component/form"); 
    var fundHoldDetailsInfoHtml = require("text!../template/fundHoldDetailsInfo.html");
    var fundDetailsModel = require("../../fund/model/fundDetails");
    var accountInfoSta = require("mod/common/accountInfoStatus/accountInfoStatus");
    var fundHoldDetailsInfo = module.exports = Component.extend({
      template  : _.template(fundHoldDetailsInfoHtml),
      initialize : function (options){
          this.model  = options.model;
      },
      onShow : function(){

      },
      events : {
          "tap #redemption"  : "redemptionHandle",
          "tap #addPurchase"  : "addPurchase",
          "tap #bonusTypeSettings" : "bonusTypeSettings"
      },
      
      //赎回身份认证
      redemptionHandle: function(){
          var _this = this;
          var dfd = accountInfoSta.getAccountInfoStatus(false,"myProperty/holdDetailsInfo/index");
            dfd.done(function(accountSta){
                if(accountSta){
                
                    _this.redemption();
                
                }
            });
      },

      //请求基金详情data->赎回
      redemption : function(){
          // set data
          var DetailsData = App.storage.get("myPropertyData");
          var redempData = {};
          redempData.prdCode = DetailsData.prdCode;
          fundDetailsModel.queryFundDetails({
              url: "queryFundDetails",
              data: redempData,
              callback: function(res){
                  App.storage.set("redempFundDetailsData",res.object);
                  //查询基金详情返回对象，set data到赎回页
                  App.navigate('fund/redemption/fundRedemption',true);
              },
              errorCallback: function(err){
                  utils.dialog.alert(err.message);
              }
          });
      },

      //追加购买
      addPurchase : function(){
          //购买页，页面接口改动
          var dfd = accountInfoSta.getAccountInfoStatus(false,"myProperty/holdDetailsInfo/index");
          dfd.done(function(accountSta){
              if(accountSta){

                    var DetailsData = App.storage.get("myPropertyData");
                    var redempData = {};
                    redempData.prdCode = DetailsData.prdCode;               
                    fundDetailsModel.queryFundDetails({
                        url: "queryFundDetails",
                        data: redempData,
                        callback: function(res){
                            App.storage.set("addPurchaseFundsData",res.object);
                            //prdAttr为4货币型，4之外非货币型
                            App.navigate('myInvestment/commendProducts/addPurchaseRiskfund/3',true);
                            
                        },
                        errorCallback: function(err){
                            utils.dialog.alert(err.message);
                        }
                    });

                }
            });
      },

      //分红设置
      bonusTypeSettings : function(e){
          var dfd = accountInfoSta.getAccountInfoStatus(false,"myProperty/holdDetailsInfo/index");
          dfd.done(function(accountSta){
              if(accountSta){     
                  
                  App.navigate('myProperty/holdDetailsInfo/bonusSettings',true);

              }
          });
      } 
    });
});