/**
 * EX-WUWENJUN
 * 黄金宝预约赎回View
 */
define(function (require, exports, module) {
    var Component = require("component/form");
    var temp = require("text!../template/goldAppointmentReturn.html");
    var safeKeyBoardHelper = require("component/customInput.helper");
    var CustomPwdInput = require("component/password/customPwdInput");
    var myPropertyModel = require("../model/myPropertyAccountInfo");
    var myCommissionDetailView = module.exports = Component.extend({
        template: _.template(temp),
        events: {
            "tap #confirmRet": "confirmRet",
            "tap #allRedeem": "allRedeem",
            "tap #nextDayRe,#cancelRe": "selReDay"   //选择是否延续赎回
        },

        initialize: function (options) {
            this.model = options.model;
            submitStates = false;
        },

        onShow: function () {
            this.$("#redeemAmt").customInput({
                type: "decimal",
                placeholder: this.model.get("accMinAmount1") + "元起赎回," + this.model.get("accMinAmount1") + "元递增",
                className: "safeKeyBoard",
                maxLength: "10"
            });
            //this.$("#redeemAmt").append('<span id="allRedeem" class="c_f60 m_r10">全部赎回</span>');    
        },

        /**
         * 选择是否延续赎回
         *
         */
        selReDay: function (e) {
            var $obj = this.$(e.currentTarget);
            $obj.find("input").prop("checked", true);
            $obj.find("i").removeClass().addClass("iconA107");
            if ($obj.attr("id") == "nextDayRe") {
                this.$("#cancelRe i").removeClass().addClass("iconA106");
            } else {
                this.$("#nextDayRe i").removeClass().addClass("iconA106");
            }
        },

        /**
         * 全部赎回
         *
         */
        allRedeem: function () {
            var sourceAmount = this.model.get("sourceAmount");
            this.$("#redeemAmt").customInput("value", sourceAmount);
        },

        /**
         * 确认赎回请求
         *
         */
        redemptionRequester: function (redeemAmt) {
            //入参currentAmt持有金额、accountId理财台账Id、amt赎回金额、password交易密码、orderId单号、largRedFlag巨额赎回处理标志0:否,1:是

            var goldTreasureData = {};
            var sourceAmount = this.model.get("sourceAmount");  //本金
            goldTreasureData.currentAmt = sourceAmount;
            goldTreasureData.amt = redeemAmt;
            goldTreasureData.accountId = this.model.get("accountId");
            goldTreasureData.orderId = this.model.get("ordId");
            goldTreasureData.largRedFlag = this.$('#selRedeemWay input:checked').val();
            CustomPwdInput.customPwdInput(function (pwd) {
                submitStates = true;
                goldTreasureData.password = utils.crypto.RSAKey.encrypt(pwd, config.base.rsa_public_key);
                goldTreasureData.sm2Pwd = utils.sm2.SM2Key.encrypt(pwd, config.base.sm2_public_key);
                myPropertyModel.goldTreasureRedempSubmit({
                    url: "goldTreasureRedempSubmit",
                    data: goldTreasureData,
                    callback: function (res) {
                        submitStates = false;
                        //删除我的资产缓存信息
                        App.requester.storage.remove("loginedAccountInfo");
                        App.navigate("myProperty/holdDetailsInfo/goldAppointmentReturnSucess", true);
                    },
                    errorCallback: function (err) {
                        submitStates = false;
                        utils.dialog.alert(err.message);
                    }
                });
            });
        },

        /**
         * 确认赎回
         *
         */
        confirmRet: function () {
            if (submitStates) {
                return;
            }
            var redeemAmt = this.$("#redeemAmt").customInput("value").replace(/,/g, '') * 1; //赎回金额
            if (!redeemAmt) {
                utils.dialog.toast("请输入赎回金额");
            } else {
                if ((Number(this.model.get("sourceAmount")) - redeemAmt) < Number(this.model.get("accMinAmount1")) || redeemAmt < Number(this.model.get("accMinAmount1")) || redeemAmt % Number(this.model.get("accMinAmount1")) != 0) {
                    if (Number(this.model.get("sourceAmount")) - redeemAmt == 0) {
                        this.redemptionRequester(redeemAmt);
                    } else {
                        if ((Number(this.model.get("sourceAmount")) - redeemAmt) < Number(this.model.get("accMinAmount1"))) {
                            utils.dialog.toast("您的本金余额小于" + utils.string.formatMoneyNumber(this.model.get("accMinAmount1")) + "元，请全额赎回您的本金");
                        } else if (redeemAmt < Number(this.model.get("accMinAmount1"))) {
                            utils.dialog.toast("您的输入金额未达到最低赎回要求，请重新输入");
                        } else if (redeemAmt % Number(this.model.get("accMinAmount1")) != 0) {
                            utils.dialog.toast("请输入" + utils.string.formatMoneyNumber(this.model.get("accMinAmount1")) + "元的整数倍");
                        }
                    }
                } else {
                    this.redemptionRequester(redeemAmt);
                }
            }
        }
    });
});