/**
 * EX-WUWENJUN 
 * 我的委托详情View 
 */
define(function(require,exports,module){
		var Component = require("component/form"); 
		var temp = require("text!../template/myTrustDetail.html");
		var goldEntrustsDetailHtml = require("text!../template/goldEntrustDetailsInfo.html");
		var safeKeyBoardHelper = require("component/customInput.helper");
		var MyCommissionModel = require("../model/myCommission");
		var pensionModel = require("../model/pensionModel");
		var accountInfoSta = require("mod/common/accountInfoStatus/accountInfoStatus");
		
		var myCommissionDetailView = module.exports = Component.extend({
			 //template  : _.template(temp),
			 events    : {
					"tap #trustRevocation" : "trustRevocation",   //委托撤销
					"tap #goldEntrust" : "goldEntrust"   //黄金宝赎回委托撤销
			 },
			 
			 initialize: function(options){
					this.model = options.model;
			 },
			 
			 /**
				* wuwenjun059
				* 渲染页面
				*/
			 getTemplate : function(){
					 var isProType = this.model.get("isProType");
					 if(isProType == 8){
							 return _.template(goldEntrustsDetailHtml);
					 }else{
							 return _.template(temp);
					 }
			 },
			 
			 /**
				* 委托撤销
				* 
				*/
			 trustRevocation : function() {
						var self = this;
						var dfd = accountInfoSta.getAccountInfoStatus(false,"myProperty/myProperty/index");
						dfd.done(function(accountSta){
								if(accountSta){
									utils.dialog.confirm(
										"您确定撤销将转出吗？",
										function(e){
											if(e == true){
													self.submit();
											}
											
										}
									);
								}
						});
					 
			 },
			 
			 
			 /**
				* 委托撤销(提交事件)
				* 
				*/
				submit : function(){
						//产品类型
						var isProType = this.model.attributes.isProType;
						if(isProType == 5){
								if(this.model.get('isRedeem') == 1){
										this.financialRedempRevoke();
								}else{
										this.revoteSubmit();
								}
						}else if(isProType == 6){
								this.persionSubmit();
						}else if(isProType == 7){
								this.pingAnPiaoSubmit();
						}
				},
			 
			 submitFlag : false,
			 
			 /**
				*委托撤销 (理财)
				* 
				*/
			 revoteSubmit : function() {
					 var self=this;
					 var formData = {
							 tranSysNo : this.model.get("transSeqNo")
					 };
					 if(self.submitFlag){
							return;
					 }
					 
					 this.submitFlag = true;
					 MyCommissionModel.buyEntrustRevocation({
								"param" : formData,
								"callback" : _.bind(function(resp){
									self.submitFlag = false;
									utils.dialog.toast("撤销成功",function(){
										//删除我的资产缓存信息
										App.requester.storage.remove("loginedAccountInfo");
										App.navigate("myProperty/myProperty/index", true);
									});
									
								},this),
								"errorCallback" : function(resp) {
										self.submitFlag = false;
										utils.dialog.alert(resp.message);
								}
						});
				 },
				 
				 /**
					*委托撤销(养老) 
					* 
					*/
				 persionSubmit:function(){
						var self=this;
						var formData = {
								tranSysNo:this.model.get("transSeqNo")
						}
						if(self.submitFlag){
							return;
						}
						
					self.submitFlag = true;
						pensionModel.pensionRevocation({
								param:formData,
								success:function(response){
									self.submitFlag = false;
									utils.dialog.toast("撤销成功",function(){
										//删除我的资产缓存信息
										App.requester.storage.remove("loginedAccountInfo");
										App.navigate("myProperty/myProperty/index", true);
									});
									 
								},
								error:function(response){
									self.submitFlag = false;
										utils.dialog.alert(response.message);
								}
						});
				},
				
				/**
				 * 委托撤销(快E盈)
				 *  
				 */
				pingAnPiaoSubmit : function(){
						var self=this;
						var formData = {
								tranSysNo:this.model.get("transSeqNo"),
								amount:this.model.get("sourceAmount"),
								prdId:this.model.get("prdId")
						}
						if(self.submitFlag){
							return;
						}
						
						self.submitFlag = true;
						pensionModel.pingAnPRevocation({
								param:formData,
								success:function(response){
									self.submitFlag = false;
									utils.dialog.toast("撤销成功",function(){
										//删除我的资产缓存信息
										App.requester.storage.remove("loginedAccountInfo");
										App.navigate("myProperty/myProperty/index", true);
									}); 
									
									
								},
								error:function(response){
									self.submitFlag = false;
										utils.dialog.alert(response.message);
								}
						});
				},
				
				/**
				 * wuenjun059
				 * 黄金宝赎回委托撤销 
				 */
				goldEntrust : function(){
						var self = this;
						var dfd = accountInfoSta.getAccountInfoStatus(false,"myProperty/myProperty/index");
						dfd.done(function(accountSta){
								if(accountSta){
										utils.dialog.confirm(
												"您确定撤销赎回吗？" ,
												function(e){
														if(e == true){
																//撤销赎回
																var formData = {
																		tranSysNo: self.model.get("transSeqNo")
																}
																if(self.submitFlag){
																		return;
																}
																
																self.submitFlag = true;
																pensionModel.toRevokeEntrustGold({
																		param:formData,
																		success:function(response){
																				self.submitFlag = false;
																				utils.dialog.toast("撤销成功",function(){
																						//删除我的资产缓存信息
																						App.requester.storage.remove("loginedAccountInfo");
																						App.navigate("myProperty/myProperty/index", true);
																				});
																				 
																		},
																		error:function(response){
																				self.submitFlag = false;
																				utils.dialog.alert(response.message);
																		}
																});
														}
														
												}
									 );
								}
						});
				},

				/**
				 * liujun
				 * 理财三种产品赎回委托撤销 
				 */
				financialRedempRevoke : function() {
						var self = this;
						var formData = {
								tranSysNo : self.model.get("transSeqNo")
						};
						if(self.submitFlag){
								return;
						}
															 
						this.submitFlag = true;
						MyCommissionModel.financialEntrustRevocation({
								"param" : formData,
								"callback" : _.bind(function(resp){
										self.submitFlag = false;
										utils.dialog.toast("撤销成功",function(){
												//删除我的资产缓存信息
												App.requester.storage.remove("loginedAccountInfo");
												App.navigate("myProperty/myProperty/index", true);
										});
								},this),
								"errorCallback" : function(resp) {
										self.submitFlag = false;
										utils.dialog.alert(resp.message);
								}
						});
						
				}
		});
});