define(function(require, exports, module){
    
    // 用于统计文本域第一次获得焦点和最后一次失去焦点之间的时间
    var UserInputTracker = module.exports = function(){
        window.tracker = this;
        this.data = {};
    };
    
    UserInputTracker.prototype.listen = function(name, input){
        var data = this.data;
        var $input = $(input);
        
        if(!data[name]) data[name] = { inputName: name };
        
        $input.on("focusin.userInputTracker", function(){
            if(!data[name].focusTime){
                data[name].focusTime = new Date().getTime();
            }
        });
        
        $input.on("focusout.userInputTracker", function(){
            data[name].blurTime = new Date().getTime();
        });
        
        if($input.is(document.activeElement)){
            $input.triggerHandler("focusin.userInputTracker");
        }
    };
    
    UserInputTracker.prototype.send = function(){
        // 在设备上，点击按钮提交表单时，文本域并没有丢失焦点
        // 所以以发送数据的时间点作为持有焦点的文本域的最后丢失焦点时间
        $(document.activeElement).triggerHandler("focusout.userInputTracker");

        App.request("focusAndBlurMonitoring", {
            silent: true,
            cancelWhenRouting: false,
            data: { monitorData: JSON.stringify(_.values(this.data)) }
        });
    };
    
});