/**
 * ex-wuyongsheng001 一账通开户 主流程控制器
 */
define(function(require, exports, module){
    var services                    = require("mod/index/services/services");
    var registerModel               = require("../model/registerModel");
    // var registerOcrPrompt           = require("../view/registerOcrPrompt");

    var OpenMainView                = require("../view/openMain");
    var UpgradeView                 = require("../view/upgrade");
    var UpgradeCheckPhoneView       = require("../view/upgradeCheckPhone");
    var OpenSuccessView             = require("../view/openSuccess");
    var SecuritySetView             = require("../view/securitySet");
    var SecuritySetByToaView        = require("../view/securitySetByToa");
    var BindToaView                 = require("../view/bindToa");

    module.exports = Controller.extend({
        actions: {
            /**
             * 开户 流程
             * -------------------------------------------------------
             */
            "openMain"              : "openMain",            // 开户第一步
            "upgrade"               : "upgrade",             // 财富e账户升级
            "upgradeCheckPhone"     : "upgradeCheckPhone",   // 财富e账户激活
            "openSuccess"           : "openSuccess",          // 开户成功
            "securitySet"           : "securitySet",           //设置安全信息
            "bindToa"               : "bindToa",              //绑定一账通
            "securitySetByToa"      : "securitySetByToa"      //设置安全信息by一账通

            //"registerOcrPrompt"     : "registerOcrPrompt"    // Ocr身份证识别

        },

        initialize: function () {
            App.footer.reset({ visible : false });
        },

        authorize: function(){
            return true;
        },

        /**
         * 橙子2.0， 开户 流程
         * -------------------------------------------------------
         *
         * 是否橙子用户 -> 否 -> 是否财富e用户 -> 是 -> 验证一账通 -> 验证OTP -> 开户成功
         *                                     -> 否 -> 开户成功
         *              -> 是 -> 是否绑定一账通 -> 是 -> 提示已是橙子用户用一账通用户名登录
         *                                      -> 否 -> 是否同一手机号码 -> 是 -> 提示已是橙子用户用手机号登录
         *                                                                -> 否 -> 更新手机号并开户成功
         * -------------------------------------------------------
         */
        openMain: function(){
            utils.native.talkingDataTrackEvent("2.0注册-成功第一步");
            this._setHead({title : '注册'});
            /*
             * 获取版本号及ocr开关
             */
            App.ocrSwitch = false;
            services.getOcrSwitch().done(_.bind(function(ocrIsOpened){
                if(ocrIsOpened == "true"){
                    App.ocrSwitch = true;
                }
            }, this)).always(function () {
                App.container.show(new OpenMainView());
            });
        },

        /*
         *  财富e账户升级
         */
        upgrade: function () {
            this._setHead({ title : '登录验证' });

            App.container.show(new UpgradeView());
        },

        /*
         *  财富e账户激活
         */
        upgradeCheckPhone: function () {
            this._setHead({ title : '账户升级' });

            App.container.show(new UpgradeCheckPhoneView());
        },

        /**
         *设置安全信息
         */
        securitySet : function(){
            utils.native.talkingDataTrackEvent("2.0注册-设置安全信息");
            this._setHead({
                title : '设置安全信息',
                leftButtonContent : ""
            });

            App.container.show(new SecuritySetView());
        },

        /**
         *绑定一账通
         */
        bindToa : function(){
            utils.native.talkingDataTrackEvent("2.0注册-绑定一账通");
            this._setHead({
                title : '绑定一账通',
                leftButtonContent : ""
            });

            App.container.show(new BindToaView());
        },


        /**
         *设置安全信息BY一账通
         */
        securitySetByToa : function(){
            utils.native.talkingDataTrackEvent("2.0注册-绑定一账通-设置安全信息");
            this._setHead({
                title : '设置安全信息',
                leftButtonHandler : function () {
                    App.navigate('openAccount/main/bindToa', true);
                }
            });

            App.container.show(new SecuritySetByToaView());
        },

        /*
         *  开户成功
         */
        openSuccess: function () {
            utils.native.talkingDataTrackEvent("2.0-注册-注册成功");
            this._setHead({
                title : '完成注册',
                leftButtonContent : ""
            });

            App.container.show(new OpenSuccessView());
        },

        // //OCR身份证识别
        // registerOcrPrompt: function(){
        //     this._setHead({ title : '温馨提示' });

        //     var Data = App.storage.get("openAccount/main/openMain") || {};
        //     var formData = Data.formData;
        //     var ocrProView = new registerOcrPrompt({model: new Model(formData)});
        //     App.container.show(ocrProView);
        // },

        _setHead: function (options) {
            var defaults = {
                title             : '注册',
                leftButtonContent : '@back'
            };
            defaults = _.extend(defaults, options || {});
            App.header.reset(defaults);
        }
    });
})
