/**
 *注册Model
 */
define(function (require, exports, module) {
    var registerModel = module.exports = Model.extend({}, {

        /**
         *  2015-06-13 增加一步注册接口
         */
        registerOfLowThreshold: function (option) {
            var url = this.validOnSafari("registerOfLowThreshold");
            this._callInterface(url, option);
        },

        /**
         *填写身份信息[第一步]
         * @param {Object} option
         */
        getBasicInfo: function (option) {
            var url = this.validOnSafari("basicInfo");
            this._callInterface(url, option);
        },

        /**
         * 第二步 设置账户信息
         * @param {Object} option
         */
        getAccountInfo: function (option) {
            var url = this.validOnSafari("accountInfo");
            this._callInterface(url, option);
        },

        /**
         *设置安全信息
         * @param {Object} option
         */
        getSecurityInfo: function (option) {
            var url = this.validOnSafari("securityInfo");
            this._callInterface(url, option);
        },

        /**
         *设置信用卡自动还款
         * @param {Object} option
         */
        repayment: function (option) {
            var url = this.validOnSafari("repayment");
            this._callInterface(url, option);
        },

        /**
         * 设置账户信息(录入邮箱、手机号)
         * @param {Object} option
         */
        getCreditCardAccountInfo: function (option) {
            var url = this.validOnSafari("creditCardAccountInfo");
            this._callInterface(url, option);
        },

        /**
         * 验证手机号是否被使用
         * @param {Object} option
         */
        checkMobile: function (option) {
            var url = this.validOnSafari("checkMobile");
            this._callInterface(url, option);
        },

        /**
         *发送动态密码
         * @param {Object} option
         */
        sendOtp: function (option) {
            this._callInterface(sendSMJson, option);
        },

        /**
         *验证动态密码
         * @param {Object} option
         */
        verifyOtp: function (option) {
            var url = this.validOnSafari("validateSMJson");
            this._callInterface(url, option);
        },

        /**
         *根据省份联动城市
         */
        getCityList: function (option) {
            var url = this.validOnSafari("qryCityRegInfo");
            this._callInterface(url, option);
        },

        /**
         *填写一账通信息
         */
        getBasicInfo4WhiteList: function (option) {
            var url = this.validOnSafari("basicInfo4WhiteList");
            this._callInterface(url, option);
        },

        /**
         *验证otp
         */
        getSecurityInfo4WhiteList: function (option) {
            var url = this.validOnSafari("securityInfo4WhiteList");
            this._callInterface(url, option);
        },

        /**
         * 校验邮箱是否可用
         * @param {Object} option
         */
        checkEmail: function (option) {
            var url = this.validOnSafari("checkEmail");
            this._callInterface(url, option);
        },

        /**
         *校验用户名唯一性
         */
        checkToaName: function (option) {
            var url = this.validOnSafari("checkToaName");
            this._callInterface(url, option);
        },

        /**
         *注册免图形验证码
         */
        registerIndex: function (option) {
            var url = this.validOnSafari("registerIndex");
            this._callInterface(url, option);
        },

        //校验一账通或则设置一账通信息
        settingUserInfo: function (options) {
            App.request("settingUserInfo", {
                data: options.formData,
                success: function (response) {
                    options.callback(response);
                },
                error: function (response) {
                    options.errorCallback(response);
                }
            });
        },

        //免登录接口
        autoMobileLogin: function (option) {
            var option = option || {};
            this.getSysTime();
            this.getTime();
            return App.request("autoMobileLogin", {data: option});
        },

        //校验用户类型
        validateUserInfo: function (option) {
            var option = option || {};
            return App.request("validateUserInfo", {data: option});
        },

        //校验一账通信息
        activateLoginVerify: function (option) {
            var option = option || {};
            return App.request("activateLoginVerify", {data: option});
        },

        /**
         *获取cookie
         * @param {Object} option
         */
        jSessoinId: function (option) {
            var callback = option.callback;

            App.request("jSessoinId", {
                type: "Get",
                success: function (resp) {
                    callback && callback(resp.object);
                },
                error: function (resp) {
                    utils.dialog.alert(resp.message);
                }
            });
        },

        /*
         * 调用接口的公共方法
         *
         * 入参：
         *      url：接口路径
         *      options : 请求参数
         *          data：接口入参
         *          callback：接口成功回调函数
         *          errorCallback：接口错误回调函数
         *
         * 返回：无
         */
        _callInterface: function (url, option) {
            App.request(url, {
                data: option.formData,
                success: function (resp) {
                    option.callback && option.callback(resp.object);
                },
                error: function (resp) {
                    if (resp.code == "600") {
                        utils.dialog.alert(resp.message, "确定", function () {
                            App.navigate("applyAccount/main/openAccountStepOne", true);
                        });
                    } else {
                        option.errorCallback && option.errorCallback(resp);
                    }

                }
            });
        },

        /**
         *判断是否在safari浏览器，如果是则接口需要加sessionId
         * @param {Object} url 接口名
         */
        validOnSafari: function (url) {
            if (!ENABLE_PHONEGAP && !config.base.mock_server) {
                var registerSession = App.storage.get("register_sessionId");
                url = config.urls.get(url) + ";JSESSIONID=" + registerSession;
            }
            return url;
        },

        /**
         * 快速登陆
         * @param {Object} callback
         */
        quickLogin: function () {
            return App.request("autoLogin", {});
        },

        /**
         * 获取系统时间
         */
        getSysTime: function (callback) {
            return App.request("timestamp", {type: "GET"}).complete(function (error, arg) {
                App.storage.set("Login_SysTime", arg.object);
            });
        },

        getTime: function (callback) {
            App.request("getTime", {type: "GET"}).complete(function (error, arg) {
                if (error) {
                    callback && callback(error);
                    return;
                }
                var time = parseInt(arg.object) - new Date().valueOf();
                App.storage.set("timeDifference", time);//服务器时间与本地时间差
                callback && callback();
            });
        }
    });
});