/**
 * ex-wuyongsheng001 财富e账户升级为一账通
 */
define(function (require, exports, module) {
    var FormLayout = require("component/form");
    var safeKeyBoardHelper = require("component/customInput.helper");

    var registerModel = require("../model/registerModel");
    var registerLang = require("../common/registerLang");
    var registerTools = require("../common/registerTools");
    var Tpl = _.template(require("text!../template/upgrade.html"));

    module.exports = FormLayout.extend({
        template: Tpl,
        events: {
            "tap #nextStepBtn": "toNextStep",
            "input #toaName": "_setFullFill",
            "customInputKeyup #toaPassword": "_setFullFill",
            "customInputFocusIn #toaPassword": "_customInputFocusIn", //登录密码
            "customInputFocusOut #toaPassword": "_customInputFocusOut",
            "tap #find_yzt_uerName": "findYztUserName",
            "tap #forget_yzt_password": "forgetYztPassword"
        },

        _fullFill: false,
        _submitFlag: 0,
        _setFullFill: function () {
            this._fullFill = false;
            this.$('#nextStepBtn').addClass('btn_disable');
            var toaName = this.$("#toaName").val().trim();
            var loginToaPwd = this.$("#toaPassword").customInput('value');
            if (!toaName || !loginToaPwd) return;
            this._fullFill = true;
            this.$('#nextStepBtn').removeClass('btn_disable');
            return true;
        },

        onRender: function () {
            this._showSafeKeyBoard();
        },

        _showSafeKeyBoard: function () {
            this.$("#toaPassword").customInput({
                type: "password-ascii",
                placeholder: "一账通用户密码",
                className: "safeKeyBoard"
            });
        },

        _customInputFocusIn: function () {
            safeKeyBoardHelper.focusIn({
                id: "toaPassword"
            });
        },

        _customInputFocusOut: function () {
            safeKeyBoardHelper.focusOut({
                id: "toaPassword"
            });
        },

        toNextStep: function () {
            if (!this._fullFill || (this._submitFlag != 0)) return;
            var formData = {
                toaName: this.$("#toaName").val().trim(),
                loginToaPwd: this.$("#toaPassword").customInput('value')
            };
            if (this._validInput(formData)) {
                registerModel.getTime(_.bind(function(error){
                    if (error) return utils.dialog.toast("系统错误，请重试");
                    formData.sm2Pwd = utils.sm2.SM2Key.encrypt(formData.loginToaPwd, config.base.sm2_public_key);
                    formData.loginToaPwd = utils.crypto.RSAKey.encrypt(formData.loginToaPwd, config.base.rsa_public_key);

                    this._submit(formData);
                },this));

            }
        },

        _validInput: function (formData) {
            var toaName = formData.toaName;
            var loginToaPwd = formData.loginToaPwd;

            if (!toaName) {
                this.toaName.setCustomValidity(registerLang("registerUserNameEmpty"));
                return false;
            }
            if (!loginToaPwd) {
                safeKeyBoardHelper.setCustomValidity({
                    id: "toaPassword",
                    message: registerLang("registerLoginPwdEmpty")
                });
                return false;
            }
            return true;
        },

        _submit: function (formData) {
            if (this._submitFlag) return;
            var _this = this;
            _this._submitFlag = 1;
            registerModel.getAccountInfo({
                formData: formData,
                callback: function (resp) {
                    _this._submitFlag = 0;
                    App.storage.set('openAccount/main/upgrade', resp);
                    App.navigate("openAccount/main/upgradeCheckPhone", true);
                },
                errorCallback: function (resp) {
                    _this._submitFlag = 0;
                    utils.dialog.alert(resp.message);
                }
            });
        },

        findYztUserName: function () {
            utils.window.open({
                title: "忘记用户名",
                url: "https://www.pingan.com.cn/pinganone/pa/retrieveVerify.do?isPS="
            });
        },

        forgetYztPassword: function () {
            utils.window.open({
                title: "忘记密码",
                url: "https://member.pingan.com.cn/pinganone/pa/paResetIndexMobileH5.screen"
            });
        }

    });
});