/**
 * ex-wuyongsheng001 财富e账户升级为一账通
 */
define(function(require, exports, module){
    var OtpView       = require("component/otp/OtpView");

    var registerModel = require("../model/registerModel");
    var registerLang  = require("../common/registerLang");
    var registerTools = require("../common/registerTools");
    var Tpl           = _.template(require("text!../template/upgradeCheckPhone.html"));

    module.exports = ItemView.extend({
        template: Tpl,
        events: {
            "tap #nextStepBtn"      : "toNextStep",
            "input #otp_passWord"   : "_setFullFill",
            "tap #agreeBtn"         : '_setAgree',
            "tap #agreement"        : 'showAgreement'
        },
        _agree: true,
        _fullFill : false,
        _submitFlag : 0,
        _setFullFill : function () {
            this._fullFill = false;
            this.$('#nextStepBtn').addClass('btn_disable');
            var otp_passWord = this.$('#otp_passWord').val().trim();
            if (!otp_passWord || !this._agree) return;
            this._fullFill = true;
            this.$('#nextStepBtn').removeClass('btn_disable');
            return true;
        },
        _setAgree: function (e) {
            this._agree = !this._agree;
            if (this._agree) {
                this.$('#agreeBtn').addClass('on');
            }else{
                this.$('#agreeBtn').removeClass('on');
            }
            this._setFullFill();
        },

        showAgreement : function (e) {
            e.stopPropagation();e.preventDefault();
            utils.window.open({
                title:  "《财富e账户升级为平安直通账户业务服务责任条款》",
                url: "https://ssl.pingan.com/bank/xieyi/zt-cfesj.html"
            });
        },

        onShow:function(){
            var _this = this;
            var options = {
                isOtpSended : true,
                isNeedSendOtpValidate : false,
                isQryOtpPhoneNo : false, //不调用接口查询手机号码
                otpEnable : null,

                isMobilePhoneByUser : true, //手机号码是用户输入的
                resendBtnHandler : _.bind(this.resendBtnHandler, this),  //点击“立即获取”按钮调用方法
                isOutLogin : true
            };
            this.otpView = new OtpView();
            this.otpView.initOtp(options);

            this.$('#otpWrap').empty().append(this.otpView.$el);

            this.otpTimer = setTimeout(function () {
                _this.$('#btn_resend').trigger('click');
            }, 1500);
        },

        onClose: function () {
            var _this = this;
            if(_this.otpTimer) clearTimeout(_this.otpTimer);
        },

        resendBtnHandler : function() {
            var _this = this;
            var mobile, upgradeCache = App.storage.get('openAccount/main/upgrade');
            mobile = upgradeCache.mobile || '';

            if(this._submitFlag != 0 || !mobile) return;

            this.otpView.sendSmsOTP('vToken', {
                mobileNo : mobile,
                cat : config.values.register,
                successFunction : _.bind(_this.successFunction, _this),
                errorFunction : _.bind(_this.errorFunction, _this)
            }, this);
        },

        successFunction : function () {
            this.$('#otpLine').addClass('m_b30');
            this.$('#otp_passWord').prop('disabled', false);
        },

        errorFunction : function () {
            if (this.$('#otp_label').text().indexOf('动态密码') < 0) {
                this.$('#otpLine').removeClass('m_b30');
            }
        },

        toNextStep : function() {
            if (!this._fullFill || (this._submitFlag != 0)) return;
            var _this = this;
            var mobile, email, upgradeCache = App.storage.get('openAccount/main/upgrade');
            mobile = upgradeCache.mobile || '';
            email  = upgradeCache.email || '';

            if (!mobile) return;
            var formData = {
                email : email,
                mobile : mobile,
                bankPwd : _this.$('#otp_passWord').val().trim()
            };

            if(this._submitFlag != 0) return;
            registerModel.verifyOtp({
                formData : {
                    mobileNo : formData.mobile,
                    code : formData.bankPwd,
                    cat : config.values.register
                },
                callback : function(resp) {
                    _this._submitFlag = 0;
                    _this._submit(formData);
                },
                errorCallback : function(resp) {
                    this._submitFlag = 0;
                    utils.dialog.alert(registerLang("registerVerityOTPError"));
                }
            });
        },

        _submit: function (formData) {
            if(this._submitFlag != 0) return;
            var _this = this;
            _this._submitFlag = 1;
            registerModel.getAccountInfo({
                formData : formData,
                callback : function(resp) {
                    _this._submitFlag = 0;
                    resp.formData = formData;
                    App.storage.set("openAccount/main/upgradeCheckPhone",resp);
                    App.navigate("openAccount/main/openSuccess", true);
                },
                errorCallback : function(resp) {
                    _this._submitFlag = 0;
                    utils.dialog.alert(resp.message);
                }
            });
        }

    });
});