/**
 * ex-wuwenjun001
 * 抢购专区购买
 */
define(function (require, exports, module) {
	var InputView = require("../view/buy/input");
	var FinishView = require("../view/buy/finish");
	var accountModel = require("mod/common/model/accountModel");
	var BuyController = module.exports = Controller.extend({
		actions : {
			"input" : "toInputPage",
			"finish" : "toFinishPage"
		},
			
		//购买
		toInputPage : function () {
            utils.native.talkingDataTrackEvent("2.0抢购专区购买第一步");
            App.header.reset({
                title : "购买订单",
                leftButtonContent : '@back',
                leftButtonHandler : function () {
                    App.storage.remove("panicBuySelData");   //产品详情信息
                    App.storage.remove("formData");   //清除页面缓存信息
                    App.navigate("products/index/panicBuy", true);
                }
            });
            App.footer.reset({
                visible: false
            });

            var promise = $.when(
                accountModel.qryAccountList()
            );

            promise.done(function (arg1) {
                var tempData = {
                    "panicBuySelData" : App.storage.get("panicBuySelData")
                };
                var panicBuySelData = _.extend(tempData, {
                    accountList : arg1.object.accountList
                });
                App.container.show(new InputView({
                    model : new Model(panicBuySelData)
                }));
            });

            promise.fail(function (err) {
                utils.dialog.alert(err.message);
            });

        },
        
        //购买成功
        toFinishPage : function () {
            utils.native.talkingDataTrackEvent("2.0抢购专区购买成功");
            App.header.reset({
                title : "购买成功",
                leftButtonContent : '@back',
                leftButtonHandler : function () {
                    App.storage.remove("panicBuySelData");   //产品详情
                    App.navigate("products/index/panicBuy", true);
                }
            });
            App.storage.remove("financeProductData");
            App.container.show(new FinishView());
        }
    });
});
