/**
 * @author zhoushiwen
 * @ date ${date}
 * @company 中国平安
 */
define(function (require, exports, module) {
    var Form = require("component/form");
    var safeKeyBoardHelper = require("component/customInput.helper");
    var InputTpl = require("text!../../template/buy/input.html");
    var CustomPwdInput = require("component/password/customPwdInput");
    var BuyModel = require("../../model/buy");
    var dreamModel = require("../../../dream/model/dream");

    var InputView = module.exports = Form.extend({
        template: _.template(InputTpl),
        ui: {
            "checkbox": "#checkbox",
            "booksLink": "#booksLink a"
        },
        events: {
            "tap #submitBtn": "submit",
            "click @ui.checkbox": "toggleCheckbox",
            "click @ui.booksLink": "openBookLink",
            "tap #selPaymentMethod": "selPaymentMethod",
            "customInputKeyup  #amountInput": "_onCustomInputFocusSelAmount"
            //"keyup  #amountInput":"_onCustomInputFocusSelAmount"

        },

        initialize: function (options) {
            this.pinganpiaoData = options.model.get("pinganpiaoData");
            this.balance = options.model.get("balance");
            var minAmount = this.pinganpiaoData.minAmount;

            this.accountList = options.model.get("accountList");
            this.submitFlag = false;
        },

        onShow: function () {

            this.$("#amountInput").customInput({
                type: "decimal",
                placeholder: "请输入购买金额",
                className: "",
                maxLength: "10"
            });

            var selPayBeforeData = App.storage.get("selPayBeforeData");
            if (selPayBeforeData) {
                if (selPayBeforeData.amountInput != 0) {
                    this.$("#amountInput").customInput("value", utils.string.numberFormat(selPayBeforeData.amountInput));
                    //输入金额
                }
                this.$("#interest").text(selPayBeforeData.interest);
                //预期收益
                //购买协议协议
                if (selPayBeforeData.checkbox) {
                    this.toggleCheckbox();
                }
                //选择支付方式
                if (selPayBeforeData.payMentMethod == 1) {
                    this.$("#selPaymentMethod p:last").text(utils.string.numberFormat(selPayBeforeData.balance));
                } else if (selPayBeforeData.payMentMethod == 2) {
                    this.$("#selPaymentMethod p:last").text(utils.string.numberFormat(selPayBeforeData.dhBalance));
                } else {
                    this.$("#selPaymentMethod p:last").text(utils.string.numberFormat(selPayBeforeData.totalBalance) + "=" + utils.string.numberFormat(selPayBeforeData.balance) + "+" + utils.string.numberFormat(selPayBeforeData.dhBalance));
                }
                this.$("#selPaymentMethod").attr("payMethodAttr", selPayBeforeData.payMentMethod);
            }

        },

        submit: function (event) {
            event.stopPropagation();
            var self = this;
            var check = this;
            var papData = {};

            var amount = this.$("#amountInput").customInput("value").replace(/,/g, "");
            var account = this.accountList[0];

            if (!this.validate(amount)) {
                return;
            }
            if (this.submitFlag) {
                return;
            }
            utils.native.talkingDataTrackEvent("2.0快E盈购买验密");
            CustomPwdInput.customPwdInput(function (password) {
                self.submitFlag = true;
                papData.amt = amount;
                papData.accNo = account.accountNo;
                papData.password = utils.crypto.RSAKey.encrypt(password, config.base.rsa_public_key);
                papData.sm2Pwd = utils.sm2.SM2Key.encrypt(password, config.base.sm2_public_key);
                papData.productId = self.pinganpiaoData.prdCode;
                papData.interestBaseDays = self.pinganpiaoData.cycleDays;
                papData.minAmount = self.pinganpiaoData.minAmount;
                papData.startDate = self.pinganpiaoData.saleStartDate1;
                papData.endDate = self.pinganpiaoData.saleEndDate1;
                papData.riskLevel = self.pinganpiaoData.riskLevel;
                papData.riskName = self.pinganpiaoData.riskLevelName;
                papData.maxAmount = self.pinganpiaoData.maxAmount;
                papData.productName = self.pinganpiaoData.prdName;
                papData.minAmount = self.pinganpiaoData.minAmount;
                papData.unitAmount = self.pinganpiaoData.unitAmount;
                papData.cnShortName = self.pinganpiaoData.cnShortName;
                papData.customizeType = self.pinganpiaoData.customizeType;
                papData.currencyId = self.pinganpiaoData.currencyId;
                papData.seqNo = self.pinganpiaoData.seqNo;
                //选择支付方式
                papData.paymentType = self.$("#selPaymentMethod").attr("payMethodAttr");

                var params = papData;
                BuyModel.toBuyForm({
                    "formData": params,
                    "errorCallback": function (res) {
                        utils.dialog.alert(res.message);
                        self.submitFlag = false;
                    },
                    "callback": function (res) {
                        utils.native.talkingDataTrackEvent("2.0快E盈购买成功");

                        var promise = dreamModel.qryDreamState();
                        promise.done(_.bind(function (arg1) {
                            var arg1 = arg1.object.outExists;

                            App.storage.set("pinganpiaoData", res.object);
                            App.storage.remove("selPayBeforeData");
                            //删除选择支付方式缓存信息
                            App.requester.storage.remove("lcProductMoneyQry");
                            App.requester.storage.remove("currentToFixedTransferBalance");
                            App.requester.storage.remove("loginedAccountInfo");
                            //0-不存在，1-存在
                            if (arg1 == 1) {
                                App.navigate("pinganpiao/buy/finish", true);
                            } else {
                                utils.native.versionInformation(function (data) {
                                    vs = data.version;
                                    if (vs.replace(/\./g, "") * 1 >= 208) {
                                        App.navigate('dream/dream/dereamOpen', true);
                                    } else {
                                        App.navigate("pinganpiao/buy/finish", true);
                                    }
                                });

                            }
                        }, this));

                    }
                });

            });

        },

        _onCustomInputFocusSelAmount: function () {
            var num = this.$("#amountInput").customInput("value");
            num = num.replace(/\D/gi, "");
            var num = this.$("#amountInput").customInput("value", num);
            var num = this.$("#amountInput").customInput("value");
            var interestBaseDays = (this.$("#interestBaseDays").val() || '').replace(/,/g, "");
            var planRate = this.pinganpiaoData.planRate;
            var plan = planRate * 0.01
            var year = 365;
            var interest = utils.string.numberFormat(num * plan / year * interestBaseDays)
            if (amountInput == "") {
                this.$("#interest").text("");

            }
            this.$("#interest").text(interest);
            var dhBalance = parseFloat(this.model.get("dhBalance"));
            //平安盈（大华）
            var totalBalance = parseFloat(this.model.get("totalBalance"));
            //活期余额+平安盈（大华）
            if (num <= parseFloat(this.balance)) {
                this.$("#selPaymentMethod").attr("payMethodAttr", "1");
                this.$("#selPaymentMethod p:first").text("活期余额");
                this.$("#selPaymentMethod p:last").text(utils.string.numberFormat(this.balance));
            } else {
                this.$("#selPaymentMethod").attr("payMethodAttr", "3");
                this.$("#selPaymentMethod p:first").text("活期余额+平安盈(大华)");
                this.$("#selPaymentMethod p:last").text(utils.string.numberFormat(totalBalance) + "=" + utils.string.numberFormat(this.balance) + "+" + utils.string.numberFormat(dhBalance));
            }

        },
        validate: function (amount, password) {
            var sf = this;
            var balance = this.balance, unitAmount = this.pinganpiaoData.unitAmount, maxAmount = this.pinganpiaoData.maxAmount, minAmount = this.pinganpiaoData.minAmount;

            if (amount == "") {
                safeKeyBoardHelper.setCustomValidity({
                    id: "amountInput",
                    message: "请输入购买金额"

                });
                return false;
            }

            if (isNaN(amount)) {
                safeKeyBoardHelper.setCustomValidity({
                    id: "amountInput",
                    message: "购买金额输入不合法"
                });
                return false;
            }

            if (parseFloat(amount) > parseFloat(this.model.get("totalBalance"))) {
                safeKeyBoardHelper.setCustomValidity({
                    id: "amountInput",
                    message: "账户余额不足"
                });
                return false;
            }

            if (parseFloat(amount) < parseFloat(minAmount)) {
                safeKeyBoardHelper.setCustomValidity({
                    id: "amountInput",
                    message: "此产品投资起点为" + sf.pinganpiaoData.minAmount + "元,请输入足够的金额"
                });
                return false;
            }

            if (parseFloat(amount) > parseFloat(maxAmount)) {
                safeKeyBoardHelper.setCustomValidity({
                    id: "amountInput",
                    message: "购买金额不能大于" + sf.pinganpiaoData.maxAmount + "元."
                });
                return false;
            }

            if (parseFloat(amount) % parseFloat(unitAmount) != 0) {
                safeKeyBoardHelper.setCustomValidity({
                    id: "amountInput",
                    message: "购买金额必须为" + sf.pinganpiaoData.unitAmount + "整数倍"
                });
                return false;
            }
            if (!this.ui.checkbox.eq(0).hasClass('on')) {
                utils.dialog.toast("请阅读并同意协议！");
                return false;
            }

            return true;

        },
        toggleCheckbox: function () {
            var checkbox = this.ui.checkbox.eq(0);
            checkbox.toggleClass("on");
        },
        openBookLink: function (e) {
            e.stopPropagation();
            var shortName = this.pinganpiaoData.shortName;
            utils.window.open({
                title: "产品说明",
                url: "http://bank.pingan.com/licaichanpin/" + shortName + ".shtml"
            });
        },

        confirm: function () {
            if (!this.validate())
                return;
            var password = App.storage.get('trading_password');

            this.trigger('confirm');
        },

        /**
         * wuwenjun059
         * 选择支付方式
         *
         */
        selPaymentMethod: function () {
            this.formInputData();
            App.navigate("common/selPaymentMethod/selPaymentMethod", true);
        },

        /**
         * wuwenjun059
         * 缓存页面数据
         *
         */
        formInputData: function () {
            var data = {};
            data.amountInput = this.$("#amountInput").customInput("value").replace(/,/g, '') * 1;
            //购买金额;
            data.interest = this.$("#interest").text();
            //预期收益
            data.payMentMethod = this.$("#selPaymentMethod").attr("payMethodAttr");
            //支付方式
            data.balance = this.model.get("balance");
            //余额
            data.dhBalance = this.model.get("dhBalance");
            //平安盈（大华）
            data.totalBalance = this.model.get("totalBalance");
            //活期余额+平安盈（大华）
            data.checkbox = this.$("#checkbox").hasClass("on");
            //是否同意协议
            data.selPayBackUrl = "pinganpiao/buy/input";
            App.storage.set("selPayBeforeData", data);
        }
    });
});
