/**
 *平安盈首页（登陆后）
 */
define(function(require, exports, module){
	var payIndexView = require("../view/payIndex");
	var payProfitDatails = require("../view/payProfitDatails");
	var payAssetsDatails = require("../view/payAssetsDatails");
	var payTransOut = require("../view/payTransOut");
	var transferInView = require("../view/payTransIn");
	var transOutPattern = require("../view/transOutPattern");
	var payTransOutSucc = require("../view/payTransOutSucc");
	var payModel = require("../model/payModel");
	var accountInfoStatus  = require("../../common/accountInfoStatus/accountInfoStatus");

	var Index = module.exports = Controller.extend({
		actions : {
			"index" : "index",
			"assetsDetails/:proCode":"_toAssetsDetails",
			"yieldDetails/:proCode":"_toYieldDetails",
			"payTransOut/:proCode":"_payTransOut",
			"payTransferIn/:proCode":"_payTransferIn",
			"toTransOutPettern/:proCode":"_toTransOutPettern",
			"transferOutSuccess":"_toTransOutSucc"
		},

		/**
		 * 初始化
		 */
		initialize: function(options){

		},
		//平安盈首页
		index : function(code){
			var indexModel = App.storage.get("pinganying/payIndex/index");
			if(indexModel){
				this.fromPage        = indexModel.get("fromPage");
			}

			var self = this
			App.header.reset({
				title : "产品详情",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					if(self.fromPage == "product"){//跳到产品首页
						App.navigate('products/index/index/depositTake', true);
					}else if(self.fromPage == "myProperty"){//我的资产
						App.navigate('myProperty/myProperty/index', true);
					}else if(self.fromPage == "benefits"){//我的收益分析
						App.navigate('index/indexLogined/benefits', true);
					}else{
						App.navigate('index/indexLogined/index', true);//首页
					}

					var indexModel = App.storage.get("pinganying/payIndex/index");
					if(indexModel) App.storage.remove("pinganying/payIndex/index");
				},
				rightButtonContent : "@share",
				rightButtonHandler : function(){
					var id = this.$("#catoryTip").find(".on").attr("id");
					var url = IS_RUN_IN_PRODUCTION_ENVIRONMENT == false ? "https://ibankibpu1.pingan.com.cn/ibd/page/web_for_h5/share_h5/index.html?" : "https://cz.pingan.com.cn/ibd/page/web_for_h5/share_h5/index.html?";
					var prdCode = id == "nfTab" ? config.values.fund_code_nanfang : config.values.fund_code_dahua;
					var prdName = id == "nfTab" ? "平安盈（南方）" : "平安盈（大华）";
					var money   = id == "nfTab" ? "20" : "50";
					var sevenIncomeRate = this.$("#profitYield").html();
					url = url+"type=4&code="+prdCode+"&name="+prdName+"&num="+sevenIncomeRate+"&t="+new Date().getTime();
					//缓存分享信息
                    App.storage.set("shareWLTData",{"share_module":config.values.shareProducts,"share_url":encodeURIComponent(url)});
					utils.native.shareProduct({"title":prdName,"message":money+"万赎回，一秒到账，就是这么任性！","url":url});
				}
			});
			App.footer.reset({"visible":false});
			App.container.show(new payIndexView());
		},

		//跳转到资产详情
		_toAssetsDetails:function(proCode){
			App.container.show(new payAssetsDatails({"prdCode":proCode}));
		},

		//跳转到收益详情
		_toYieldDetails:function(proCode){
			App.header.reset({
				title : "查看收益",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.storage.remove("qryProfitType");
					App.navigate('pinganying/payIndex/index', true);
				},
			});
			App.footer.reset({"visible":false});
			App.container.show(new payProfitDatails({"proCode":proCode}));
		},

		//平安盈转出
		_payTransOut:function(proCode){
			if (proCode == config.values.fund_code_dahua) {
				utils.native.talkingDataTrackEvent("2.0平安盈转出第一步（大华）");
			} else if(proCode == config.values.fund_code_nanfang) {
				utils.native.talkingDataTrackEvent("2.0平安盈转出第一步（南方）");
			}

			var dfd = accountInfoStatus.getAccountInfoStatus(false,"pinganying/payIndex/index");
			dfd.done(function(accountSta){
				if(accountSta){
					 App.header.reset({
						title : "转出",
						leftButtonContent : "@back",
						leftButtonHandler : function(){
							var model = new Model({prdCode:proCode});
							App.storage.set("pinganying/payIndex/index", model);
							App.navigate('pinganying/payIndex/index', true);
						}
					});
					App.footer.reset({"visible":false});
					App.container.show(new payTransOut({"proCode":proCode}));
				}
			});
		},
		 //平安盈转出选择方式
		_toTransOutPettern:function(proCode){
			App.header.reset({
					title : "转出",
					leftButtonContent : "@back",
					leftButtonHandler : function(){
					   // App.navigate('pinganying/payIndex/payTransOut' + , true);
					   App.back();
					}
				});
				App.footer.reset({"visible":false});
			App.container.show(new transOutPattern({"proCode":proCode}));
		},
		 //平安盈转出成功页面
		_toTransOutSucc:function(){
			//utils.native.talkingDataTrackEvent("2.0-产品-平安盈转出成功");
			App.header.reset({
				title : "转出",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.navigate('pinganying/payIndex/index', true);
				}
			});
			App.container.show(new payTransOutSucc());
		},
		 //平安盈转入
		_payTransferIn : function(query) {
			if (query == config.values.fund_code_dahua) {
				utils.native.talkingDataTrackEvent("2.0平安盈转入第一步（大华）");
			} else if(query == config.values.fund_code_nanfang) {
				utils.native.talkingDataTrackEvent("2.0平安盈转入第一步（南方）");
			}

			var dfd = accountInfoStatus.getAccountInfoStatus(false,"pinganying/payIndex/index");
			dfd.done(function(accountSta){
				if(accountSta){
					var proCode = query;
					App.container.show(new transferInView({'model':new Model({'fundCode':proCode})}));
				}
			});
		}
	});
});
