define(function(require, exports, module){
    var payChannelHtml = require("text!../template/payAccDetails.html");
    var channelDetailHtml = _.template(require("text!../template/payAccLists.html"));
    
    var payModel = require("../model/payModel");
    
    var self = null;
    
    var IndexView = module.exports = ItemView.extend({
        template : _.template(payChannelHtml),
        ui:{
            channelDetail:'#channelDetail'
        },
        events : {
            'click .dswkb' : 'selectOnWay'
        },
        /**
         * 初始化
         */
        initialize: function(options){
            self = this;
            var model = options.model;
            self.balance = model.get("balance");
            self.fundCode = model.get("fundCode");
            self.transferAmt = model.get("transferAmt");
            self.selectIcon = model.get("selectIcon");
        },
        onRender:function(){
            this._showPayDetail();
            //this._qryPayAccList();
            this._bankListView({});
        },
        onShow : function() {
            
        },
        _qryPayAccList : function() {
             payModel.qryPayAccList({
                "url" : "qryPayAccList",
                "data" : {},
                "callback" : function(response) {
                    response.payAcclist=response.payAcclist||[];
                    //支付列表
                    self._bankListView(response.payAcclist);
                }
            });
        },
        _bankListView : function(qurBanklist) {
            var template = channelDetailHtml({
                payBanklist : qurBanklist,
                "balance" : self.balance
            });
            this.ui.channelDetail.html(template);
       },
        selectOnWay : function(event) {
            var ctr = $(event.currentTarget);
            var htl = "";
            //设置样式
            $(".dswkb").removeClass('selected');
            $(".iconA49,mr_10").remove();
            // if("0"==self.balance){
                // htl = '<i class="mr_10" style="margin-right: 10px;">不可用</i>'
            // }else{
                // htl = '<i class="iconA49"></i>'
            // }
            ctr.addClass('selected').append('<i class="iconA49"></i>');
            //back
            self.getSelectedChannel();
            var transferInView = require("../view/payTransIn");
            var proCode = self.fundCode;
            var transferAmt = self.transferAmt;
            var selectIcon = self.selectIcon;
            App.container.show(new transferInView({"model":new Model({'fundCode':proCode,"selectIcon":selectIcon,"transferAmt":transferAmt})}));
        },
        getSelectedChannel : function() {
            $(".iconA49").remove();
            $(".selected div p:eq(1)").remove();
            $(".selected").append('<i class="iconA34"></i>');
            $(".selected div").wrap('<div class="m_r30"></div>');
            var template = $(".selected");
            App.storage.set("ctrSelectedChannel",template);
        },
        
        _showPayDetail:function(){
            var options = {
                title:"选择支付方式",
            };
            this._showHeader(options);
        },
        _showHeader:function(options){
            App.header.reset({
                title : options.title,
                titleContent : options.titleContent,
                titleId : options.titleId,
                titleHandler : options.titleHandler,
                leftButtonContent : "@back",
                leftButtonHandler : function(){
                    self.getSelectedChannel();
                    var transferInView = require("../view/payTransIn");
                    var proCode = self.fundCode;
                    var transferAmt = self.transferAmt;
                    App.container.show(new transferInView({"model":new Model({'fundCode':proCode,"selectIcon":self.selectIcon,"transferAmt":transferAmt})}));
                }
            });
        }

    });
})
