define(function(require, exports, module){
    var IndexTpl = require("text!../template/payAssetsDatails.html");
    var payModel = require("../model/payModel");
    var FUND_CODE_NANFANG = config.values.fund_code_nanfang;
    var FUND_CODE_DAHUA   = config.values.fund_code_dahua;
    var PTRScroll = require("component/PTRScroll");
    
    var IndexView = module.exports = ItemView.extend({
        template : _.template(IndexTpl),
        events:{

        },
        /**
         * 初始化
         */
        initialize: function(options){
        	self = this;
        	this.prdCode = options.prdCode;
        },
        
        onRender:function(){
        	this._showPayDetail();
        },
        
        //展示平安盈首页
        _showPayDetail:function(){
        	var options = {
        		title:"全部记录",
        		titleContent:"@title", 
        		titleId:"payAllTrans",
        		titleHandler:this._headCallback
        	};
        	this._showHeader(options);
        	
           	//请求数据
            var yieldOption = this._qryParams(1);
            this._queryTransDetails(yieldOption);
            this._initPTRScroll();
        },
        
        //头部展示
        _showHeader:function(options){
        	App.header.reset({
                title : options.title,
                titleContent : options.titleContent,
                titleId : options.titleId,
                titleHandler : options.titleHandler,
                leftButtonContent : "@back",
                leftButtonHandler : function(){
                	App.back();
                },
                rightButtonContent : "@share",
                rightButtonHandler : function(){
                	
                }
            });
        },
        
         //头部Tab回调函数
        _headCallback:function(){
        	var source = [{text:"全部记录",value:"payAllTrans"},{text:"转入",value:"payTransIn"},{text:"转出",value:"payTransOut"},{text:"收益",value:"yieldTrans"}];
            var tabIndex = App.storage.get("spinnerIndex");
            var index=!tabIndex&&tabIndex!==0?0:tabIndex;
            utils.dialog.spinner({
                title: "请选择查询类型",
                selectedIndex: index,
                source: source,
                callback: function(item, idx){
                	if($(document).find(".js-header-title>span").attr("id") == item.value){
                		return;
                	}else{
                		var options = {
			        		title:item.text,
			        		titleContent:"@title", 
			        		titleId:item.value,
			        		titleHandler:self._headCallback
			        	};
                		self._showHeader(options);
                		self.$("#assetsDetail").empty();
                		
                		// var commentOption = self._showYieldData(idx);
                		var yieldOption = {prdCode:self.prdCode,queryType:idx};
                		self._queryTransDetails(yieldOption);
                	}
                    App.storage.set("spinnerIndex",idx);
                }
            });
        },
        
        //查询交易记录(一月的七日年华率、万份收益)
        _queryTransDetails:function(options){
        	var self = this;
        	var data = options;
        	payModel.profitTransferQry({
        		url:"profitTransferQry",
        		data:options,
        		callback:function(res){
        			var options = res.transferRecordList;
        			var monthsData = self._getHisTransMonths(options);
        			var showDetailHtml = "";
        			
        			//Iscroller下拉时，请求第一页
        			if(data.pageIndex == 1){
        				self.$("#assetsDetail").empty();
        			}
        			//上拉最后一页时，禁用上拉
        			var totalRows = res.totalRows;
        			if(data.pageIndex * 10 >= totalRows){
	        			self.scroller.disablePullUpToLoadMore();
        			}else{
        				self.scroller.enablePullUpToLoadMore();
        			}
        			
        			for (var i=0; i < monthsData.length; i++) {
        				var showDetailLi = "";
        				var monthHead = 
                   			$("<p class='c_999 f16 m_t15 m_l10' id='"+monthsData[i]+"'>"+ monthsData[i] +"</p><div class='Columns m_t15'><ul class='ulStyle1'></ul></div>");
                   		var hisListUl = monthHead.find("div>ul");
                   		
           				for(var j=0; j<options.length; j++) {
           					options[j] = self._formatShowDate(options[j]);
           					if(options[j].transDate.substring(0,6) == monthsData[i]){
           						showDetailLi += 
           						"<li class='dswkb'>"+
				                    "<i class='"+ options[j].transIcon +"'></i>"+
				                    "<div class='flex1 m_l10'>"+
				                        "<p class='f14 c_000'>"+options[j].transName+"</p>"+
				                        // "<p class='f12 c_999'>余额"+options.+"</p>"+		                    
				                    "</div>"+
				                    "<div class='flex1 m_r10 tar'>"+
				                        "<p class='f12 c_999'>"+self._formatDate(options[j].transDate)+"</p>"+
				                        "<p class='f14 "+options[j].cssStyle+"'>"+ options[j].sign +options[j].transAmt+"</p>"+
				                    "</div>"+
				                "</li>";
           					}
						}
						
						//新加到已有的UL里面
						if(self.$("#assetsDetail").find("p[id='"+monthsData[i]+"']").length != 0){
							var idString = "#" + monthsData[i];
                   			self.$(idString).next().find("ul").append($(showDetailLi));
                   		}else{
                   			monthHead.find("ul").append($(showDetailLi));
                   			self.$("#assetsDetail").append(monthHead);
                   		}
                   		
        			}
                   
        		},
        		errorCallback:function(res){
    				utils.dialog.alert(res.message);
        		}
        	});
        },
        
        //获取交易的历史月份
        _getHisTransMonths:function(options){
        	var monthsDate = [];
        	for(var i=0; i<options.length; i++){
        		if($.inArray(options[i].transDate.substring(0,6), monthsDate) == -1){
        			monthsDate.push(options[i].transDate.substring(0,6));
        		}
        		continue;
        	}
        	return monthsDate;
        },
        
        //格式化日期
        _formatDate:function(date){
        	var year = date.substring(0,4);
        	var month = date.substring(4,6);
        	var day = date.substring(6,8);
        	return year + "-" + month + "-" + day;
        },
        
        //展示数据
        _formatShowDate:function(options){
        	if(options.transName == "转入"){
        		options.transIcon = "iconA51";
        		options.cssStyle = "c_f60";
        		options.sign = "+";
        	}else if(options.transName == "转出"){
        		options.transIcon = "iconA52";
        		options.cssStyle = "c_46B23F";
        		options.sign = "-";
        	}else if(options.transName == "收益"){
        		options.transIcon = "iconA53";
        		options.cssStyle = "c_f60";
        		options.sign = "+";
        	}else{
        		options.transIcon = "";
        		options.cssStyle = "";
        		options.sign = "";
        	}
        	return options;
        },
        
         //初始化上下拉
        _initPTRScroll : function(){
        	var self = this;
            if (this.scroller) return;
            var listHeight = $(window).height() - this.$("#iscroller").offset().top;
            var dom = this.$("#iscroller").css({"height":listHeight,"position":"relative"});

            //初始化iscroller
            this.scroller = new PTRScroll(dom[0],{
                "hScroll"          : false,
                "checkDOMChanges"  : true,
                "hideScrollbar"    : false,
                "pullDownToRefresh": true,
       			"pullUpToLoadMore" : true,
            });

            //下拉刷新
            this.pageIndex = 1;
            this.scroller.options.refreshContent = function(refresh){
            	self.pageIndex = 1;
                self._refreshContent(refresh, self.pageIndex);
            };

            //上拉加载
            this.scroller.options.loadMoreContent = function(refresh){
            	self.pageIndex++;
                self._loadMoreContent(refresh, self.pageIndex);
            };
        },
        
        //下拉请求数据
        _refreshContent:function(refresh, pageIndex){
        	//请求数据
            var yieldOption = this._qryParams(pageIndex);
        	this._queryTransDetails(yieldOption);
        	refresh();
        },
        
        //上拉请求数据
        _loadMoreContent:function(refresh, pageIndex){
        	//请求数据
            var yieldOption = this._qryParams(pageIndex);
        	this._queryTransDetails(yieldOption);
        	//请求数据
        	refresh();
        },
        
        //上送的数据
        _qryParams:function(pageIndex){
        	var userInfo = App.storage.get("UserInfo") ;  
        	var sysTime = App.storage.get("Login_SysTime");
            var d = new Date(sysTime);
        	var yieldOption = {
                "pageIndex" : pageIndex,
                "pageSize"  : 10,
                "startDate" : utils.date.diffDateAdd(d,-3,'d').format("yyyy-MM-dd"),
                "endDate"   : d.format("yyyy-MM-dd"),
                "prdCode"   : this.prdCode,
                "account"	: userInfo && userInfo.attributes.accNumber
            };
            return yieldOption;
        }
        
    });
})
