define(function(require, exports, module){
    var IndexTpl          = require("text!../template/payIndex.html");
    var payYieldCharts    = require("../view/payYieldCharts");
    var payModel          = require("../model/payModel");
    var FormComponent     = require("component/form");
    var IScroll           = require("component/PTRScroll");
    var accountInfoStatus = require("../../common/accountInfoStatus/accountInfoStatus");
    var FUND_CODE_NANFANG = config.values.fund_code_nanfang;
    var FUND_CODE_DAHUA   = config.values.fund_code_dahua;

    var IndexView = module.exports = FormComponent.extend({
        template : _.template(IndexTpl),
        events:{
            "tap #sevenYield"           : "_periodYearYield",
            "tap #oneMonthYield"        : "_periodYearYield",
            "tap #threeMonthYield"      : "_periodYearYield",
            "tap #dhTab"                : "_changeTab",
            "tap #nfTab"                : "_changeTab",
            "tap .instructions"         : "_showProInstructions",
            "tap #holdAssetsLi"         : "_toAssetsDetails",
            "tap #totalYieldsLi"        : "_toYieldDetails",
            "tap #yesYieldsLi"          : "_toYieldDetails",
            "tap #sevenYieldSpan"       : "_toYieldDetails",
            "tap #wfProfitSpan"         : "_toYieldDetails",
            "tap #payTransOut"          : "_toTransOut",
            "tap #payTransIn"           : "_toTransIn",
            "click .pay-entrust-revoke" : "_payEntrustRevoke",  //平安盈委托撤销
            "tap #faq":"bankfaq"
        },

        regions:{
            contentRegion :"#contentRegion"
        },

	    initialize:function(){
			this.payEntrust = false;
		},

        onRender:function(){
            this._showPayDetail();
        },
        onShow : function(){
            this._swipe();
            var self = this;
            setTimeout(function(){
                self._scroll();
            }, 2000);
        },

        _scroll: function(){
            var self      = this;
            if(this.scroller) {
            	this.scroller.destroy();
            	//delete this.scroller;
            }
            var wHeight   = $(window).outerHeight(true);
            var btnHeight = $(".pop_btn").outerHeight(true);
            var tabHeight = $(".tab").outerHeight(true);
            // console.log(App.locStorage.get("webviewHeight"));
            // console.log($(window).outerHeight(true));
            // console.log(btnHeight);
            // console.log(tabHeight);
            var dom       = $("#scrollContainer").css({"height":wHeight-btnHeight-tabHeight,"position":"relative"});
            this.scroller = new IScroll(dom[0],
            	{"hideScrollbar":true,
            	 "pullDownToRefresh": false,
        		 "pullUpToLoadMore": false
        		});
        },
        _swipe: function () {
            var _this = this;
            $(document).swipe(function () {
                var lis = $('#catoryTip li');
                var len = lis.size();
                var id = lis.filter('.on').index();
                if (this.direction == 'left') {
                    id ++;
                    if (id > len-1) {
                        id = 0;
                    }
                    lis.eq(id).trigger('tap');
                } else if(this.direction == 'right') {
                    id --;
                    if (id < 0) {
                        id = len-1;
                    }
                    lis.eq(id).trigger('tap');
                }
            });
        },
        onClose: function () {
            $(document)[0].swipe.destroy();
        },
        //展示平安盈首页
        _showPayDetail:function(){
			var self = this;
            //隐藏任意门
            this.renderAnyDoorPlugin();

            //首页传过来的数据
            var indexModel = App.storage.get("pinganying/payIndex/index");
            var proCode = FUND_CODE_DAHUA;
            if(indexModel){
                proCode = indexModel.attributes.prdCode;
                this._initTab(proCode);

            }
            var options = {qryType:"7", prdCode:proCode};//初始化数据

            //初始化七日年化率(七日、一月、三月)
            this._payYearYield(options);

            //初始化七日年化率和万份收益
            //this._paySevenYield(options);

            //查询个人信息
            //this._userYieldInfo(options);

            //可撤销委托
            //this._fundCancelCommision(options);

            //获取页面数据源
            var promise=$.when(
            	self._paySevenYield(options),
            	this._userYieldInfo(options),
            	this._fundCancelCommision(options)
            );
            promise.done(function(arg1, arg2, arg3){
            	self._paySevenYieldCallback(arg1[0].object);
            	self._userYieldInfo4Callback(arg2[0].object, options);
            	self._fundCancelCommision4Callback(arg3[0].object);
            });
            promise.fail(function(err){
            	self.$("#wfProfit").html('--');
            	self.$("#profitYield").html('--');
            	self.$("#yesProfit").html('--');
                self.$("#totalAssets").html('--');
                self.$("#totalYields").html('--');
                utils.dialog.alert(err.message);
            });

        },

        //初始化南方、大华页签
        _initTab:function(prdCode){
            if(prdCode == FUND_CODE_NANFANG){
                utils.native.talkingDataTrackEvent("2.0平安盈详情（南方）");
                this.$("#nfTab").addClass("on").siblings().removeClass("on");
            }else{
                utils.native.talkingDataTrackEvent("2.0平安盈详情（大华）");
                this.$("#dfTab").addClass("on").siblings().removeClass("on");
            }
        },

        //隐藏任意门
        renderAnyDoorPlugin: function(){
            utils.native.anydoor.hide();
        },

        //展示七日年化收益率和份分收益(大华、南方)
        _paySevenYield:function(options){
            var self = this;
            return payModel.paySevenYeildQry({
                url:"qryPaYingInfo",
                data:options
            });
        },

		/**
 		 * @param {Object} options
 		 * 改造七天年华收益率和万份收益
 		 * 成功回调方法
		 */
		_paySevenYieldCallback:function(res){
			var prdList = res.prdList;
            this.$("#wfProfit").html(prdList[0].incomeUnit);
            this.$("#profitYield").html((prdList[0].sevenIncomeRate*100).toFixed(2));
		},

        //七日年化收益率（南方-大华：七日、一个月、三个月）
        _payYearYield:function(options){
            var self = this;
            payModel.payYearYield({
                url:"qryPaYingIncomeList",
                data:options,
                callback:function(res){
                    res.servenIncomeList = self._averageSevenPoint(res.servenIncomeList);
                    self._showYieldChart(self, res);
                },
                errorCallback:function(res){
                    console.log("===============》七天年化收益率列表为空");
                    //utils.dialog.alert(res.message);
                }
            });
        },

        //取根据查询月份取七日、一月、三月的年华收益率,取一个数组中的七个点
        _averageSevenPoint:function(dataArray){
            var sevenPoints = [];
            if(dataArray.length < 8 && dataArray.length > 0){
                return dataArray.reverse();
            }else if (dataArray.length >= 8){
                var firstIndex = 0
                var lastIndex = dataArray.length - 1;
                var middleIndex = parseInt(lastIndex/2);
                var averageModel = Math.ceil((lastIndex - firstIndex)/7);
                sevenPoints.push(dataArray[lastIndex]);
                sevenPoints.push(dataArray[lastIndex - averageModel]);
                sevenPoints.push(dataArray[middleIndex + averageModel]);
                sevenPoints.push(dataArray[middleIndex]);
                sevenPoints.push(dataArray[middleIndex - averageModel]);
                sevenPoints.push(dataArray[firstIndex + averageModel]);
                sevenPoints.push(dataArray[firstIndex]);
                return sevenPoints;
            }
        },

        //展示highcharts数据
        _showYieldChart:function(_this, options){
            _this.contentRegion.show(new payYieldCharts({
                view:_this,
                data:options,
                model:new Model(options)
            }));
        },

        //用户已登陆的收益、账号信息（大华-南方：昨日收益、持有资产、累积收益）
        _userYieldInfo:function(options){
            var self = this;
            var url ="";
            var yesterdayIncome ="";
            var payDeposit = "";
            var payTotalincome = "";
            if(options.prdCode == FUND_CODE_DAHUA){
                url = "paydhProductMoneyQry";
                payDeposit = "paydhDeposit";
                yesterdayIncome = "yesterdaydhIncome";
                payTotalincome = "paydhTotalincome";
            }else{
                url = "paynfProductMoneyQry";
                payDeposit = "paynfDeposit";
                yesterdayIncome = "yesterdaynfIncome";
                payTotalincome = "paynfTotalincome";
            }
            return payModel.userYieldInfo({
                url:url,
                data:options
            });
        },

		/**
		 * @ex_huangzit
		 * 2015-07-13
		 * 查询用户信息进行回调
 		 * @param {Object} e
		 */
		_userYieldInfo4Callback:function(res, options){
			var self = this;
			var totalYields = "";
            if(options.prdCode == FUND_CODE_DAHUA){
                self.$("#yesProfit").html(res.yesterdaydhIncome);
                self.$("#totalAssets").html(utils.string.numberFormat(res.paydhDeposit,2));
                totalYields = utils.string.numberFormat(res.paydhTotalincome || 0, 2);
                self.$("#totalYields").html(totalYields);
            }else{
                self.$("#yesProfit").html(res.yesterdaynfIncome);
                self.$("#totalAssets").html(utils.string.numberFormat(res.paynfDeposit,2));
                totalYields = utils.string.numberFormat(res.paynfTotalincome || 0, 2);
                self.$("#totalYields").html(totalYields);
            }
            App.storage.set("pinganying/payIndex/profix",new Model({prdCode:options.prdCode, totalYields:totalYields}));
		},

        //平安盈编号
        _queryProCode:function(e){
            var proCode = FUND_CODE_DAHUA;
            if(this.$("#dhTab").hasClass("on")){
                proCode = FUND_CODE_DAHUA;
            }else{
                proCode = FUND_CODE_NANFANG;
            }
            return proCode;
        },

        //七日、一月、三月年化收益率(大华、南方), e:事件源
        _periodYearYield:function(e){
            e.stopPropagation();
            e.preventDefault();
            var options = {};
            //南方、大华标识
            if(this.$(e.currentTarget).attr("id") == "sevenYield"){
                options.qryType = '7';
            }else if(this.$(e.currentTarget).attr("id") == "oneMonthYield"){
                options.qryType = '1';
            }else{
                options.qryType = '3';
            }
            this.$(e.currentTarget).addClass("on").siblings().removeClass("on");
            //大华、南方标识
            options.prdCode = this._queryProCode();
            this._payYearYield(options);
        },

        //大华、南方页签 e:事件源
        _changeTab:function(e){
            var options = {};
			var self = this;
            if(this.$(e.currentTarget).attr("id") == "dhTab"){
                options.prdCode = FUND_CODE_DAHUA;
            }else if(this.$(e.currentTarget).attr("id") == "nfTab"){
                options.prdCode = FUND_CODE_NANFANG;
            }

            this.$(e.currentTarget).addClass("on").siblings().removeClass("on");
            this.$("#sevenYield").addClass("on").siblings().removeClass("on");


            //this._paySevenYield(options); //昨日万份收益、昨日年华收益率
            //this._userYieldInfo(options);//查询用户持有资产、昨日收益、累计收益
            //this._fundCancelCommision(options);//查询可撤销列表

            //获取页面数据源
            var promise=$.when(
            	self._paySevenYield(options),
            	this._userYieldInfo(options),
            	this._fundCancelCommision(options)
            );
            promise.done(function(arg1, arg2, arg3){
            	self._paySevenYieldCallback(arg1[0].object);
            	self._userYieldInfo4Callback(arg2[0].object, options);
            	self._fundCancelCommision4Callback(arg3[0].object);
            });
            promise.fail(function(err){
                utils.dialog.alert(err.message);
            });

            options.qryType = "7"; //初始化年化率 7:为七日年化率、1:一月年化率、3:三月年化率
            this._payYearYield(options);

            setTimeout(function(){
               self._scroll();
            }, 2000);
        },

        //产品介绍、收益到账说明、资金到账说明 e:事件源
        _showProInstructions:function(e){
            if(this.$(e.currentTarget).find("i").hasClass("on")){
                //隐藏
                this.$(e.currentTarget).find("i").removeClass("on");
                this.$(e.currentTarget).find(".con").hide();
                this.scroller.refresh();
            }else{
                //展示
                this.$(e.currentTarget).find("i").addClass("on");
                this.$(e.currentTarget).find(".con").show();

                this.scroller.refresh();
                //this.scroller.scrollTo(0,-1000,5000);
                this.scroller.scrollToElement(e.currentTarget,200);
            }
        },

        //可撤销查询
        _fundCancelCommision:function(options){
            var self = this;
            return payModel.queryFundCancelCommision({
                url:"queryFundCancelCommision",
                data:options
            });
        },

		/**
		 * @ex_huangzit
		 * @2015-07-13
 		 * @param {Object} e
		 */
		_fundCancelCommision4Callback:function(res){
			var self = this;
			var fundCancelCommisionList = res.transferRecordList;
            if(fundCancelCommisionList.length != 0){
                self.$("#cancelComment>p").first().siblings().remove();
                var showCancelCommisionHtml = "";
                for (var i=0; i < fundCancelCommisionList.length; i++) {
                  var cancelAmt = fundCancelCommisionList[i].fundShare;
                  showCancelCommisionHtml +=
                        "<p class='f28 c_000 h38'><span>"+ cancelAmt +"</span>" +
                            "<a class='UndoBtn f12 pay-entrust-revoke' entrust-seqNo='"+fundCancelCommisionList[i].seqNo+"' entrust-fundShare='"+fundCancelCommisionList[i].fundShare+"' entrust-date='"+fundCancelCommisionList[i].applyDate +"' style='margin-left:0px;'>撤销</a>" +
                        "</p>";
                }
                self.$("#cancelComment").height(45 * fundCancelCommisionList.length);
                self.$("#cancelComment").append(showCancelCommisionHtml);
                self.$("#cancelComment").show();
            }else{
                self.$("#cancelComment").hide();
            }
		},

        //平安盈委托撤销
        _payEntrustRevoke:function(e){
            var self = this;
            if(utils.string.interceptLoss()) return ;
            if(self.payEntrust) return;
            var target = e.currentTarget;
            var options = {
                assoSerial: this.$(target).attr("entrust-seqNo"),
                yebFlag   : 1,
                prdCode	  : this._queryProCode()
            };
            var message = "您确定撤销转出吗？点击确定则将转出款撤销至持有资产";
            var title = "";
            self.payEntrust = true;
            utils.dialog.confirm(message, {}, function(flag){
                self.payEntrust = false;
                if(flag){
                    self._payEntrustSubmit(options);
                }
            });
        },


        //提交撤销
        _payEntrustSubmit:function(options){
            var self = this;
            var proCode = this._queryProCode();
            payModel.entrustCommision4PAY(options).done(_.bind(function(res){
                //刷新数据
                this.$("#cancelComment>p").first().siblings().remove();
                var param = {prdCode:proCode, pageSize:50};
                //self._fundCancelCommision(param);
                //查询个人信息
                //this._userYieldInfo(param);

                var promise=$.when(
	            	self._userYieldInfo(options),
	            	self._fundCancelCommision(options)
	            );
	            promise.done(function(arg1, arg2){
	            	self._userYieldInfo4Callback(arg1[0].object, options);
	            	self._fundCancelCommision4Callback(arg2[0].object);
	            });
	            promise.fail(function(err){
	                utils.dialog.alert(err.message);
	            });

                //清掉“我”里面的平安盈数据
                App.requester.storage.remove("loginedAccountInfo");

                utils.dialog.toast("撤销成功");
            },this)).fail(function(error){
                utils.dialog.alert(error.message);
            });
        },

        //跳转到资产详情页面
         _toAssetsDetails:function(){
            //跳到记录详情
            var code = this._queryProCode();
            App.storage.set("pinganying/payIndex/index",new Model({prdCode:code}));
            var url = 'me/tradeRecords/tadereturn?code='+ code +"&returnURL=pinganying/payIndex/index&source="+Date.parse(new Date())
            App.navigate(url,{
                trigger: true,
                replace: true
            });
        },

        //跳转到收益详情页面
        _toYieldDetails:function(e){
            var proCode = this._queryProCode();
            var qryProfitType = 2;
            if(this.$(e.currentTarget).attr("id") == "wfProfitSpan"){
                qryProfitType = 1;
            }else if(this.$(e.currentTarget).attr("id") == "totalYieldsLi" || this.$(e.currentTarget).attr("id") == "yesYieldsLi"){
                qryProfitType = 3;
            }
            App.storage.set("pinganying/payIndex/index",new Model({prdCode:proCode}));
            App.storage.set("qryProfitType", qryProfitType);
            App.navigate("pinganying/payIndex/yieldDetails/"+ proCode, true);
        },

        //平安盈转出
        _toTransOut:function(){
            //判断账户的状态
            if(App.storage.get("transOutTempData")){
                App.storage.remove("transOutTempData");
            }
            var proCode = this._queryProCode();
            App.storage.set("pinganying/payIndex/index",new Model({prdCode:proCode}));
            App.navigate("pinganying/payIndex/payTransOut/"+ proCode, true);
        },

        //平安盈转入
        _toTransIn : function() {
            var proCode = this._queryProCode();
            App.storage.set("pinganying/payIndex/index",new Model({prdCode:proCode}));
            App.navigate("pinganying/payIndex/payTransferIn/"+ proCode, true);
        },
         bankfaq:function(){
         	App.navigate("czFaq/faqIndex/czFaq/pinganying", true);

       }

    });
})
