define(function(require, exports, module){
    var IndexTpl          = require("text!../template/payIndexLogin.html");
    var payYieldCharts    = require("../view/payYieldCharts");
    var payModel 	      = require("../model/payModel");
    var FormComponent  	  = require("component/form");
    var IScroll           = require("component/PTRScroll");
    var FUND_CODE_NANFANG = config.values.fund_code_nanfang;
    var FUND_CODE_DAHUA   = config.values.fund_code_dahua;
    
    var IndexView = module.exports = FormComponent.extend({
        template : _.template(IndexTpl),
        events:{
        	"tap #sevenYield"      : "_periodYearYield",
        	"tap #oneMonthYield"   : "_periodYearYield",
        	"tap #threeMonthYield" : "_periodYearYield",
        	"tap #dhTab"           : "_changeTab",
        	"tap #nfTab"           : "_changeTab",
        	"tap .instructions"    : "_showProInstructions",
        	"tap #payTransOut"     :"_toTransOut",
        	"tap #payTransIn"      : "_toTransIn",
            "tap #faq"             :"bankfaq"

        },
        
        
        regions:{
        	contentRegion :"#contentRegion"
        },
        
        onRender:function(){
        	this._showPayDetail();
        },
        onShow : function(){
            this._swipe();
            var self = this;
            setTimeout(function(){
                self._scroll();
            }, 2000);
        },
        _swipe: function () {
            var _this = this;
            $(document).swipe(function () {
                var lis = $('#catoryTip li');
                var len = lis.size();
                var id = lis.filter('.on').index();
                if (this.direction == 'left') {
                    id ++;
                    if (id > len-1) {
                        id = 0;
                    }
                    lis.eq(id).trigger('tap');
                } else if(this.direction == 'right') {
                    id --;
                    if (id < 0) {
                        id = len-1;
                    }
                    lis.eq(id).trigger('tap');
                }
            });
        },
        
         _scroll: function(){
            var self  = this;
            if(this.scroller) {
            	this.scroller.destroy();
            	//delete this.scroller;
            }
            
            var wHeight   = $(window).outerHeight(true);
            var btnHeight = $(".pop_btn").outerHeight(true);
            var tabHeight = $(".tab").outerHeight(true);
            // console.log(App.locStorage.get("webviewHeight"));
            // console.log($(window).outerHeight(true));
            // console.log(btnHeight);
            // console.log(tabHeight);
            var dom       = $("#scrollContainer").css({"height":wHeight-btnHeight-tabHeight,"position":"relative"});
            this.scroller = new IScroll(dom[0],
            	{"hideScrollbar":true,        
            	 "pullDownToRefresh": false,
        		 "pullUpToLoadMore": false
        		});
        },
        
        onClose: function () {
            $(document)[0].swipe.destroy();
        },
        //展示平安盈首页
        _showPayDetail:function(){
        	
        	//隐藏任意门
        	this.renderAnyDoorPlugin();
        	
        	//首页传过来的数据
        	var indexModel = App.storage.get("pinganying/payIndexLogin/index");
        	var proCode = FUND_CODE_DAHUA;
        	if(indexModel){
	        	proCode = indexModel.attributes.prdCode;
	        	this._initTab(proCode);
        	}
        	var options = {qryType:"7", prdCode:proCode};//初始化数据
        	
        	//初始化七日年化率和万份收益
        	this._paySevenYield(options);
        	
        	//初始化七日年化率(七日、一月、三月)
        	this._payYearYield(options);
        	
        },
        
         //初始化南方、大华页签
        _initTab:function(prdCode){
        	if(prdCode == FUND_CODE_NANFANG){
        	    utils.native.talkingDataTrackEvent("2.0-产品-平安盈详情（南方）");
	        	this.$("#nfTab").addClass("on").siblings().removeClass("on");
        	}else{
        	    utils.native.talkingDataTrackEvent("2.0-产品-平安盈详情（大华）");
        		this.$("#dfTab").addClass("on").siblings().removeClass("on");
        	}
        },
        //展示七日年化收益率和份分收益(大华、南方)
        _paySevenYield:function(options){
        	var self = this;
        	payModel.paySevenYeildQry({
        		url:"qryPaYingInfo",
        		data:options,
        		callback:function(res){
        			var prdList = res.prdList;
        			self.$("#wfProfit").html(prdList[0].incomeUnit);
        			// self.$("#profitYield").html(prdList[0].sevenIncomeRate);
        			self.$("#profitYield").html((prdList[0].sevenIncomeRate*100).toFixed(2));
        		},
        		errorCallback:function(res){
        			self.$("#wfProfit").html('--');
        			self.$("#profitYield").html('--');
        			utils.dialog.alert(res.message);
        		}
        	});
        },
        
        //七日年化收益率（南方-大华：七日、一个月、三个月）
        _payYearYield:function(options){
        	var self = this;
        	payModel.payYearYield({
        		url:"qryPaYingIncomeList",
        		data:options,
        		callback:function(res){
        			res.servenIncomeList = self._averageSevenPoint(res.servenIncomeList);
        			self._showYieldChart(self, res);
        		},
        		errorCallback:function(res){
        			console.log("===============》七天年化收益率列表为空");
        			//utils.dialog.alert(res.message);
        		}
        	});
        },
        
        //取根据查询月份取七日、一月、三月的年华收益率,取一个数组中的七个点
        _averageSevenPoint:function(dataArray){
        	var sevenPoints = [];
        	if(dataArray.length < 8 && dataArray.length > 0){
        		return dataArray.reverse();
        	}else if (dataArray.length >= 8){
        		var firstIndex = 0
        		var lastIndex = dataArray.length - 1;
        		var middleIndex = parseInt(lastIndex/2);
        		var averageModel = Math.ceil((lastIndex - firstIndex)/7);
        		sevenPoints.push(dataArray[lastIndex]);
        		sevenPoints.push(dataArray[lastIndex - averageModel]);
        		sevenPoints.push(dataArray[middleIndex + averageModel]);
        		sevenPoints.push(dataArray[middleIndex]);
        		sevenPoints.push(dataArray[middleIndex - averageModel]);
        		sevenPoints.push(dataArray[firstIndex + averageModel]);
        		sevenPoints.push(dataArray[firstIndex]);
	        	return sevenPoints;
        	}
        },
        
        //展示highcharts数据
        _showYieldChart:function(_this, options){
        	_this.contentRegion.show(new payYieldCharts({
                view:_this,
                data:options,
                model:new Model(options)
        	}));
        },
        
        //用户已登陆的收益、账号信息（大华-南方：昨日收益、持有资产、累积收益）
        _userYieldInfo:function(options){
        	var self = this;
        	var url ="";
        	var yesterdayIncome ="";
        	var payDeposit = "";
        	var payTotalincome = "";
        	if(options.prdCode == FUND_CODE_DAHUA){
        		url = "paydhProductMoneyQry";
        		payDeposit = "paydhDeposit";
        		yesterdayIncome = "yesterdaydhIncome";
        		payTotalincome = "paydhTotalincome";
        	}else{
        		url = "paynfProductMoneyQry";
        		payDeposit = "paynfDeposit";
        		yesterdayIncome = "yesterdaynfIncome";
        		payTotalincome = "paynfTotalincome";
        	}
        	payModel.userYieldInfo({
        		url:url,
        		data:options,
        		callback:function(res){
        			if(options.prdCode == FUND_CODE_DAHUA){
		        		self.$("#yesProfit").html(res.yesterdaydhIncome);
        				self.$("#totalAssets").html(res.paydhDeposit);
        				self.$("#totalYields").html(res.paydhTotalincome);
		        	}else{
		        		self.$("#yesProfit").html(res.yesterdaynfIncome);
        				self.$("#totalAssets").html(res.paynfDeposit);
        				self.$("#totalYields").html(res.paynfTotalincome);
		        	}
        		},
        		errorCallback:function(res){
    				self.$("#yesProfit").html("--");
        			self.$("#totalAssets").html("--");
        			self.$("#totalYields").html("--");
        			utils.dialog.alert(res.message);
        		}
        	});
        },
        
        //隐藏任意门
        renderAnyDoorPlugin: function(){
            utils.native.anydoor.hide();
        },
        
        //平安盈编号
        _queryProCode:function(e){
        	var proCode = FUND_CODE_DAHUA;
        	if(this.$("#dhTab").hasClass("on")){
        		proCode = FUND_CODE_DAHUA;
        	}else{
        		proCode = FUND_CODE_NANFANG;
        	}
        	return proCode;
        },
        
        //七日、一月、三月年化收益率(大华、南方), e:事件源
        _periodYearYield:function(e){
        	e.stopPropagation();
        	e.preventDefault();
        	var options = {};
        	//南方、大华标识
        	if(this.$(e.currentTarget).attr("id") == "sevenYield"){
        		options.qryType = '7';	
        	}else if(this.$(e.currentTarget).attr("id") == "oneMonthYield"){
        		options.qryType = '1';
        	}else{
        		options.qryType = '3';
        	}
        	this.$(e.currentTarget).addClass("on").siblings().removeClass("on");
        	//大华、南方标识
        	options.prdCode = this._queryProCode();
        	this._payYearYield(options);
        },
        
        //大华、南方页签 e:事件源
        _changeTab:function(e){
        	var options = {};
        	var self = this;
        	if(this.$(e.currentTarget).attr("id") == "dhTab"){
        		options.prdCode = FUND_CODE_DAHUA;
        	}else if(this.$(e.currentTarget).attr("id") == "nfTab"){
        		options.prdCode = FUND_CODE_NANFANG;
        	}
        	
        	this.$(e.currentTarget).addClass("on").siblings().removeClass("on");
        	this.$("#sevenYield").addClass("on").siblings().removeClass("on");
        	
        	//昨日万份收益、昨日年华收益率
        	this._paySevenYield(options);
        		
        	options.qryType = "7"; //初始化年化率 7:为七日年化率、1:一月年化率、3:三月年化率
        	this._payYearYield(options);
        	
        	setTimeout(function(){
               self._scroll();
            }, 2000);
        },
        
        //产品介绍、收益到账说明、资金到账说明 e:事件源
        _showProInstructions:function(e){
        	 if(this.$(e.currentTarget).find("i").hasClass("on")){
                //隐藏
                this.$(e.currentTarget).find("i").removeClass("on");
                this.$(e.currentTarget).find(".con").hide();
                this.scroller.refresh();
            }else{
                //展示
                this.$(e.currentTarget).find("i").addClass("on");
                this.$(e.currentTarget).find(".con").show();

                this.scroller.refresh();
                //this.scroller.scrollTo(0,-1000,5000);
                this.scroller.scrollToElement(e.currentTarget,200);
            }
        },
     
        //平安盈转出
        _toTransOut:function(){
        	if(App.storage.get("transOutTempData")){
        		App.storage.remove("transOutTempData");
        	}
        	var proCode = this._queryProCode();
        	App.navigate("pinganying/payIndex/payTransOut/"+ proCode, true);
        },
        
        //平安盈转入
        _toTransIn : function() {
            var proCode = this._queryProCode();
            App.navigate("pinganying/payIndex/payTransferIn/"+proCode, true);
        },
        
       
        bankfaq:function(){
         	App.navigate("czFaq/faqIndex/czFaq/pinganyinged", true);

       }

        
    });
})
