define(function(require, exports, module){
    var IndexTpl = require("text!../template/payProfitDatails.html");
    var payModel = require("../model/payModel");
    var FUND_CODE_NANFANG = config.values.fund_code_nanfang;
    var FUND_CODE_DAHUA   = config.values.fund_code_dahua;
    var PTRScroll = require("component/PTRScroll");

    var IndexView = module.exports = ItemView.extend({
        template : _.template(IndexTpl),
        events:{
        	"tap #millionYieldTab" : "_changeYieldTab",
        	"tap #sevenIncomeYieldTab" : "_changeYieldTab",
        	"tap #totalYieldTab":"_changeYieldTab"
        },

         /**
         * 初始化
         */
        initialize: function(options){
        	self = this;
        	this.proCode = options.proCode;
        },

        onRender:function(){
        	this._swipe();
        	this._showPayDetail();
        },

        //展示平安盈首页
        _showPayDetail:function(){

        	/**
        	 * qryProfitType :1-查询万份收益 ，2-查询七天年华收益率， 3-查询累计收益
        	 * qryType：1-查询一个月的数据
        	 */
        	this.qryProfitType = 1;
        	if(App.storage.get("qryProfitType")){
        		this.qryProfitType = App.storage.get("qryProfitType");
        		if(App.storage.get("qryProfitType") == 1){
        			this.$("#millionYieldTab").addClass("current").siblings().removeClass("current");
        		}else if(App.storage.get("qryProfitType") == 2){
        			this.$("#sevenIncomeYieldTab").addClass("current").siblings().removeClass("current");
        		}else{
        			this.$("#totalYieldTab").addClass("current").siblings().removeClass("current");
        		}
        	}
        	var yieldOption = {
        		prdCode:this.proCode,
        		qryType:1,
        		pageIndex:1,
        		pageSize:10,
        		qryProfitType:this.qryProfitType
        	};

           //this._initPTRScroll(yieldOption);

            if(this.qryProfitType == 1 || this.qryProfitType == 2){
	            this._queryYieldDetails(yieldOption);
            }else{
            	yieldOption.account = App.storage.get("UserInfo").get("accNumber");
        		yieldOption.amtDir = "2";
	            this._qryTotalYeildShow(yieldOption);
            }

        },

        //万分收益、七天年华收益率、累计收益 ,e:事件源
        _changeYieldTab : function(e){
        	var yieldOption = {
        		prdCode:this.proCode,
        		qryType:1,
        		pageIndex:1,
        		pageSize:10
        	};

        	if(this.$(e.currentTarget).attr("id") == "millionYieldTab"){
        		yieldOption.qryProfitType = "1";
        	}else if(this.$(e.currentTarget).attr("id") == "sevenIncomeYieldTab"){
        		yieldOption.qryProfitType = "2";
        	}else if(this.$(e.currentTarget).attr("id") == "totalYieldTab"){
        		yieldOption.qryProfitType = "3";
        	}
        	this.qryProfitType = yieldOption.qryProfitType;
        	this.pageIndex = yieldOption.pageIndex;
        	this.$(e.currentTarget).addClass("current").siblings().removeClass("current");
        	if(this.qryProfitType == "1" || this.qryProfitType == "2"){
	        	this._queryYieldDetails(yieldOption);
        	}else{
        		yieldOption.amtDir = "2";
        		yieldOption.account = App.storage.get("UserInfo").get("accNumber");
        		this._qryTotalYeildShow(yieldOption);
        	}
        },

        //分页
        _getPageLastSize:function(pageIndex, pageSize, length){
        	if((pageIndex*pageSize) - length > 0){
        		return length;
        	}else{
        		return pageIndex*pageSize;
        	}
        },

        //查询万份收益、七日年化收益率   (累积收益未有接口)
        _queryYieldDetails:function(options){
        	var self = this;

        	var data = options;
        	if(!App.storage.get("yieldTempData") || (App.storage.get("yieldTempData") && App.storage.get("yieldTempData").prdCode != this.proCode)){
	        	payModel.queryYieldDetails({
	        		url:"qryPaYingIncomeList",
	        		data:options,
	        		callback:function(res){
	        			if(res.servenIncomeList.length != 0){
		        			self._showProfitData(res, data);
		        			App.storage.set("yieldTempData", res);
	        			}else{
	        				utils.dialog.alert("no records!");
	        			}
	        		},
	        		errorCallback:function(res){
	    				utils.dialog.alert(res.message);
	        		}
	        	});
        	}else{
        		//不再请求后台数据，已放缓存
        		self._showProfitData(App.storage.get("yieldTempData"), data);
        	}
        },

        _showProfitData:function(response, data){
        	var options = {};
        	//var self = this;
        	var totalRows = 0;
        	var index = 0;
        	var pageLastSize = 0;
        	if(data.qryProfitType == "1" || data.qryProfitType == "2"){//万份收益和七天年化收益率
        		tempList = response.servenIncomeList;
        		totalRows = response.servenIncomeList.length;
	        	options = self._calculatePrecent(response.servenIncomeList, data.qryProfitType);
	        	index = (data.pageIndex-1)*data.pageSize;
	        	pageLastSize = options.length;
        	}else{//累计收益

        		this.$("#yeildTitle").html("累计收益");
				this.$("#dayComment").html("每日收益");
				var yeildData = App.storage.get("pinganying/payIndex/profix");
				var totalYields = yeildData.attributes.totalYields;
				if(!totalYields){
					totalYields = "0.00";
				}
				this.$("#yeildData").html(totalYields);

        		tempList = response.transferRecordList;
        		totalRows =  response.totalRows;
        		options = self._calculatePrecent(response.transferRecordList, data.qryProfitType);
				pageLastSize = self._getPageLastSize(data.pageIndex, data.pageSize, options.length);
        	}
			var showDetailHtml = "";
			for (var i=index; i<pageLastSize; i++) {
				//重新改造下options[i]对象
				options[i] = self._showYieldData(options[i], i, data.qryProfitType);
				options[i].classStyle = "";
				if(data.qryProfitType == 1 || data.qryProfitType == 2){
					//第一条记录展示在上面头部
					if(i == 0 && data.pageIndex == 1){
						self.$("#yeildTitle").html(options[i].yeildTitle + "（" +  options[i].issDate.substring(4,6) + "-" + options[i].issDate.substring(6,8) + "）");
						self.$("#dayComment").html(options[i].dayComment);
						self.$("#yeildData").html(options[i].transData);
					}else{
					    showDetailHtml +=
	    				"<li class='dswkb "+options[i].classStyle+"'>" +
	                    	"<span class='day'>"+  options[i].issDate.substring(4,6) + "-" + options[i].issDate.substring(6,8) +"</span>" +
	                    	"<span class='dayEarning'><i style='width:"+ options[i].precent +"%;'>"+ options[i].transData +"</i></span>"+
	                	"</li>";
					}
				}else{
					showDetailHtml +=
	    				"<li class='dswkb "+options[i].classStyle+"'>" +
	                    	"<span class='day'>"+  options[i].issDate.substring(4,6) + "-" + options[i].issDate.substring(6,8) +"</span>" +
	                    	"<span class='dayEarning'><i style='display: inline-block;'>"+ options[i].transData +"</i></span>"+
	                	"</li>";
				}
			}
			//Iscroller下拉时，请求第一页
			if(data.pageIndex == 1){
				self.$("#yieldUl>li").first().siblings().remove();
			}
			self.$("#yieldUl").append(showDetailHtml);

			//展示
			this._initPTRScroll(data);

			//上拉最后一页时，禁用上拉
			if(data.qryProfitType == "3"){
				if(data.pageIndex * data.pageSize >= totalRows){
	    			self.scroller.disablePullUpToLoadMore();
				}else{
					self.scroller.enablePullUpToLoadMore();
				}
			}
			self.scroller.refresh();
        },

        //计算百分比
        _calculatePrecent:function(options, qryProfitType){
        	var data = [];
        	for (var i=0; i < options.length; i++) {
        		if(qryProfitType == 1){
        			options[i].transData = options[i].incomeUnit;
        		}else if(qryProfitType == 2){
        			options[i].transData = options[i].sevenIncomeRate;
        		}else{
        			options[i].issDate = options[i].transDate;//累计收益
        			options[i].transData =  utils.string.numberFormat(options[i].transAmt);
        		}
			  	data.push(options[i].transData);
			}
			var maxData = Math.max.apply(null,data);

			for (var j=0; j < options.length; j++) {
			  options[j].precent = ((options[j].transData/maxData) * 95).toFixed(2);
              //2015-08-07 显示不全bug, 改为样式控制 min-width: 40px;
			  if(options[j].precent < 20){
			  	options[j].precent = 20.00;
			  }
			}
			return options;
        },

        //判断最新的收益日期是否是当日
        _formatDate:function(nearestDate){
        	var date = new Date();
        	var year = date.getFullYear();
        	var month = date.getMonth() + 1;
        	var day = date.getDate();
        	var today = year+"-"+month+"-"+day;
        	if(nearestDate == today){
        		return true;
        	}
        	return false;
        },

        //根据查询类型展示数据
        _showYieldData:function(options, index, qryProfitType){
        	//万份收益
        	if(qryProfitType == "1"){
        		if(index == 0){
	        		options.yeildTitle = "万份收益";
	        		options.dayComment = "万份收益";
        		}
        		options.transData = options.incomeUnit;
        	}else if(qryProfitType == "2"){//七日年化收益率
        		if(index == 0){
		        	options.yeildTitle = "最近七日年化收益率";
	        		options.dayComment = "七日年化收益率";
        		}
        		if(options.sevenIncomeRate == 0){
        			options.transData = "0.00%";
        		}else{
	        		options.transData = String((options.sevenIncomeRate*100).toFixed(2)).substring(0,5 ) + "%";
        		}
        	 }
        	return options;
        },

        /**
         * ex_huangzit
         * 2015-07-11
         * 新增左右滑动
         */
         _swipe: function () {
            var _this = this;
            $(document).swipe(function () {
                var lis = $('#profixPel span');
                var len = lis.size();
                var id  = lis.filter('.current').index();
                if (this.direction == 'left') {
                    id ++;
                    if (id > len-1) {
                        id = len-1;
                        return;
                    }
                    lis.eq(id).trigger('tap');
                } else if(this.direction == 'right') {
                    id --;
                    if (id < 0) {
                        id = 0;
                        return;
                    }
                    lis.eq(id).trigger('tap');
                }else if(this.direction == 'center'){

                }
            });
        },

        //初始化上下拉
        _initPTRScroll : function(options){
        	var self = this;
            if (this.scroller) {
            	this.scroller.destroy();
            	delete this.scroller;
            };
            var listHeight = $(window).height() - 168;
            var dom = this.$("#iscroller").css({"height":listHeight,"position":"relative", overflow: "hidden"});

			var scrollerOption = {};
			if(options.qryProfitType == 3){
				scrollerOption = {
					"hScroll"          : false,
	                // "vScrollbar"       : false,
	                "checkDOMChanges"  : true,
	                "hideScrollbar"    : false,
	                "pullDownToRefresh": true,
	       			"pullUpToLoadMore" : true
				};
			}else{
				scrollerOption = {
					"hScroll"          : false,
	                // "vScrollbar"       : false,
	                "checkDOMChanges"  : true,
	                "hideScrollbar"    : false,
	                "pullDownToRefresh": false,
	       			"pullUpToLoadMore" : false
				};
			}

            //初始化iscroller
            this.scroller = new PTRScroll(dom[0],scrollerOption);

            //收益分析才有上下拉动效果
            if(options.qryProfitType == 3){

            	//下拉刷新
	            this.pageIndex = 1;
	            this.scroller.options.refreshContent = function(refresh){
	            	self.pageIndex = 1;
	                self._refreshContent(refresh, self.pageIndex);
	            };

	            //上拉加载
	            this.scroller.options.loadMoreContent = function(refresh){
	            	self.pageIndex++;
	                self._loadMoreContent(refresh, self.pageIndex);
	            };
            }

        },

        //下拉请求数据
        _refreshContent:function(refresh, pageIndex){
        	//请求数据
        	var yieldOption = {
        		prdCode:this.proCode,
        		qryType:1,
        		pageIndex:pageIndex,
        		pageSize:10,
        		qryProfitType:this.qryProfitType
        	};

    		if(this.qryProfitType == "3"){
    			yieldOption.account = App.storage.get("UserInfo").get("accNumber");
        		yieldOption.amtDir = "2";
        		this._qryTotalYeildShow(yieldOption);
    		}
        	refresh();
        },

        //上拉请求数据
        _loadMoreContent:function(refresh, pageIndex){
        	//请求数据
        	var yieldOption = {
        		prdCode:this.proCode,
        		qryType:1,
        		pageIndex:pageIndex,
        		pageSize:10,
        		qryProfitType:this.qryProfitType
        	};

        	if(this.qryProfitType == "3"){
        		yieldOption.account = App.storage.get("UserInfo").get("accNumber");
        		yieldOption.amtDir = "2";
        		this._qryTotalYeildShow(yieldOption);
        	}
        	refresh();
        },

        //展示累计数据
        _qryTotalYeildShow:function(options){
        	var self = this;
        	//请求数据
        	payModel.profitTransferQry({
        		url:"profitTransferQry",
        		data:options,
        		callback:function(res){
        			var transferRecordList = res.transferRecordList;
        			self._showProfitData(res, options);
        		},
        		errorCallback:function(res){
    				utils.dialog.alert(res.message);
        		}
	        });
        }
    });
})
