define(function(require, exports, module){
    var IndexTpl = require("text!../template/payTransOutSucc.html");
    var payModel = require("../model/payModel");
    var FormComponent  = require("component/form");
    
    var IndexView = module.exports = FormComponent.extend({
        template : _.template(IndexTpl),
        events:{
        	"tap #transOutAgain":"_transOutAgain"
        },
        onRender:function(){
        	this._showPayDetail();
        },
        
        //转出首页
        _showPayDetail:function(){
        	var transOutSuccData = App.storage.get("transferOutSuccess");
        	if(transOutSuccData){
        		var amount = utils.string.formatMoneyNumber(transOutSuccData.amount);
        		var transOutFlag = transOutSuccData.transOutFlag;
        		if(transOutFlag == 0){//t+0
        			this.$("#transTime").html(new Date(transOutSuccData.transTime).format("MM-dd hh:mm"));
        			this.$("#transAmount").html(amount);
        			this.$("#complateTime").html(new Date(transOutSuccData.transTime).format("MM-dd") + " 24:00前");
        		}else{//t+1
        			if(transOutSuccData.transTime) this.$("#transTime").html(utils.date.formatTime(transOutSuccData.transTime).format("MM-dd hh:mm"));
        			this.$("#transAmount").html(amount);
        			if(transOutSuccData.accountTime){
        				this.$("#complateTime").html(utils.date.formatTime(transOutSuccData.accountTime).format("MM-dd") + " 24:00前");
        			}else {
        				this.$("#complateTime").html("预计下一至两个工作日到账");
        			}
        		}
        	}
        },
        
        //再转一笔
        _transOutAgain:function(){
        	App.back();
        }
    });
    
});
