define(function(require,exports,module){
    require("highcharts");
    var temp = require("text!../template/payYieldCharts.html");
    
    module.exports=ItemView.extend({
        template:_.template(temp),
        events:{
          "tap #consumeList_history":"toConsumeStory"  
        },
        onRender: function(){
            this.chartsData();
        },
        toConsumeStory:function(){
            $("#consume_story").trigger("tap"); 
        },
        
        chartsData: function(){
            var d = this.model.attributes.servenIncomeList;
            var categories = [];
            var data = [];
            var tempD;
            for (var i=0, len=d.length; i<len; i++) {
                tempD = d[i];
                categories.push(this._getCategorieLabel(tempD.issDate));
                data.push({
                    name: this._getYearMonthDayLabel(tempD.issDate),
                    y: Number(tempD.sevenIncomeRate*100 || 0)
                });
            }
            this._doCharts2(categories, data);
        },
        
        _getCategorieLabel: function(mStr){
            if (!mStr) return '';
            return Number(mStr.substring(4,6)) + '-' +  Number(mStr.substring(6,8));
        },
        
        _getYearMonthDayLabel: function(mStr){
            if (!mStr) return '';
            mStr = String(mStr);
            return mStr.substring(0,4) + '年' + mStr.substring(4,6) + '月' +  Number(mStr.substring(6,8)) + "日";
        },
        
        _queryMax:function(data){
        	var maxDataArr = [];
        	for(var i=0; i<data.length; i++){
        		maxDataArr.push(data[i].y);
        	}
        	var maxData = Math.max.apply(Math,maxDataArr);
        	return maxData;
        },
        
        _doCharts2: function(categories, data){
        	var maxData = this._queryMax(data);
        	if(maxData == 0){
        		maxData = 6;
        	}
            this.$('#chartsContainer').highcharts({
                chart: {
                    type: 'area'
                },
                title: {
                    text: ''
                },
                legend: {
                    enabled:false
                },
                xAxis: {
                    gridLineWidth:1,
                    gridLineColor: '#ffdf7f',
                    lineWidth:0,//
                    tickWidth:0,//刻度宽度
                    offset: 5,
                    // tickmarkPlacement: 'on', // label对齐tick
                    categories: categories,
                    title: {
                        enabled: false
                    }
                },
                yAxis: {
                	max:maxData,
                	min:0,
                    gridLineWidth:1,
                    gridLineColor: '#ffdf7f',
                    tickPixelInterval: 20,
                    title: {
                        enabled: false
                    },
                    labels: {
                        enabled: true
                    }
                },
                plotOptions: {
                    area: {
                        lineWidth:2,
                        lineColor: '#FE6601',
                        color:'#FE6601',
                        fillOpacity: 0.2,
                        marker: {
                            radius:5,
                            fillColor: '#FE6601',
                            lineWidth: 3,
                            lineColor: "#FFFFFF"
                        }
                    },
                    series: {
                        marker: {
                            states: {
                                hover: {
                                    lineWidth: 3, 
                                    radius: 8
                                }
                            }
                        }
                    }
                },
                tooltip: {
                    enabled: true,
                    shared: false,
                    useHTML: true,
                    headerFormat: '',
                    footerFormat:'',
                    backgroundColor:"#FE6601",
                    pointFormat: '<div style="font-size:14px;">{point.y:.2f}</div>'
                },
                series: [{
                    data: data
                }]
            });
        }
    });
});
