define(function(require, exports, module){
    var transferInResaultHtml = require("text!../template/transferInResault.html");
    var payModel = require("../model/payModel");
    
    var self = null;
    
    var IndexView = module.exports = ItemView.extend({
        template : _.template(transferInResaultHtml),
        events : {
            "click #againTransfer" : "_againTransfer",
            "click #newActivity" : "_newActivity"
        },
        /**
         * 初始化
         */
        initialize: function(options){
            App.navigate("pinganying/payIndex/submitTransferIn", false);
            self = this;
            self._initDate(options);
        },
        onRender:function(){
            this._showPayDetail();
        },
        onShow : function() {
            var template = App.storage.get("ctrSelectedChannel");
            if(template) {
                var htl = template.html();
                $("#payAccList").empty().append('<div class="flex1"><span class="f16">支付方式</span></div>').append(htl);
            }
            
        },
        _initDate : function(options) {
            var paramDate = options.model;
            self.fundCode = paramDate.get("fundCode");
            
            var nowDate = paramDate.get("nowDate");
            var year = nowDate.slice(4,6)+"-"+nowDate.slice(6,8);
            var hm = nowDate.slice(8,10)+":"+nowDate.slice(10);
            nowDate = year+" "+hm;
            if(paramDate.get("startDate")) {
                var startDate = utils.date.formatTime(paramDate.get("startDate")).format("yyyy-MM-dd");
                var stratWeek = utils.date.getWeek(startDate);
                startDate = startDate.slice(5);
                var endDate = utils.date.formatTime(paramDate.get("endDate")).format("yyyy-MM-dd");
                var endWeek = utils.date.getWeek(endDate);
                endDate = endDate.slice(5);
            }
            this.model = new Model({
                "transferAmt" : paramDate.get("transferAmt"),
                "nowDate":nowDate||"",
                "endDate":endDate||"",
                "endWeek":endWeek||"",
                "startDate":startDate||"",
                "stratWeek":stratWeek||""
            });
        },
        //再转一笔
        _againTransfer : function() {
            //App.back();
            App.navigate("pinganying/payIndex/index", true);
        },
        //最新活动
        _newActivity : function() {
            
        },
        _showPayDetail:function(){
            var options = {
                title:"转入结果",
            };
            this._showHeader(options);
        },
        //头部展示
        _showHeader:function(options){
            App.header.reset({
                title : options.title,
                titleContent : options.titleContent,
                titleId : options.titleId,
                titleHandler : options.titleHandler,
                leftButtonContent : "@back",
                leftButtonHandler : function(){
                   App.storage.set("pinganying/payIndex/index",new Model({prdCode:self.fundCode}));
                   App.navigate("pinganying/payIndex/index", true);
                   //App.navigate("pinganying/payIndex/payTransferIn/"+self.fundCode, true);
                }
            });
        }

    });
})
