/**
 * wuyongsheng560 产品购买
 */
define(function(require, exports, module) {
    var BillBuyView = require('../view/buy/billBuy');
    var FinishView = require('../view/buy/finish');
    var accountModel = require('mod/common/model/accountModel');
    module.exports = Controller.extend({
        actions: {
            'index(/*type)': 'index', //产品购买
            'finish': 'finish'
        },

        index: function(type) {
            type = type || 'bill';
            var billModel, backUrl;

            billModel = App.storage.get('myInvestment/commendProducts/curProObj');
            if (billModel instanceof Model) {
                billModel = billModel.clone();
            } else {
                App.navigate('products/index/index/finefinance', {
                    trigger: true,
                    replace: true
                });
            }

            backUrl = this._getBackUrl(billModel);
            billModel.set('backUrl', backUrl);

            this._setHeaderFooter({
                backUrl: backUrl
            });

            //判断是否存在选择支付方式缓存信息
            if (App.storage.get('selPayBeforeData')) {
                App.container.show(new BillBuyView({
                    model: App.storage.get('billBuyModel') || new Model()
                }));
            } else {
                accountModel.asycAccountInfo().done(function(res) {
                    // 由于小票含有字段balance(产品剩余)
                    // 这里账号余额balance重命名为accountBalance
                    // 取缓存selPayBeforeData时用balance，要注意区别
                    billModel.set({
                        accountBalance: res.object.balance || '0.0',
                        dhBalance: res.object.dhBalance || '0.0',
                        totalBalance: res.object.totalBalance || '0.0'
                    });

                    App.storage.set('billBuyModel', billModel);

                    App.container.show(new BillBuyView({
                        model: billModel
                    }));
                }).fail(function(err) {
                    err.message && utils.dialog.alert(err.message);
                });
            }
        },

        finish: function() {
            utils.native.talkingDataTrackEvent('2.0-产品-转跳小票购买成功页');
            var buyResult = App.storage.remove('products/buy/finish') || {};
            buyResult = (buyResult instanceof Model) ? buyResult : new Model(buyResult);
            this._setHeaderFooter({
                title: '提交成功',
                leftButtonContent: '@back',
                leftButtonHandler: function() {
                    App.navigate('products/index/index/finefinance', {
                        trigger: true,
                        replace: true
                    });
                }
            });
            App.container.show(new FinishView({
                model: buyResult
            }));
        },

        _getBackUrl: function(model) {
            var modelType, fromPage,
                isLogin = App.storage.get('isUserLoggedIn'),
                url = isLogin ? 'index/indexLogined/index' : 'index/index/index';

            if (model) {
                fromPage = model.get('fromPage');
                modelType = model.get('type');
            }

            if (fromPage === 'product') {
                url = 'products/index/index/finefinance';

                if (modelType === 'bill') {
                    url = 'products/detail/bill';
                }
            }
            return url;
        },

        _setHeaderFooter: function(options) {
            var opts = _.extend({
                title: '购买订单',
                leftButtonContent: '@back',
                leftButtonHandler: function() {
                    App.storage.remove('billBuyModel');
                    //选择支付方式缓存信息
                    App.storage.remove('selPayBeforeData');
                    if (options.backUrl) {
                        return App.navigate(options.backUrl, {
                            trigger: true,
                            replace: true
                        });
                    }

                    App.back();
                }
            }, options || {});

            App.header.reset(opts);
            App.footer.reset({
                visible: false
            });
        }

    });

});
