/**
 * ex-wuyongsheng001 产品 -> 产品详情
 */
define(function(require, exports, module) {
    var FinaceDetailView = require('../view/detail/productFinaceDetail');
    var NetworthDetaillView = require('../view/detail/networthDetail');
    var FundDetailView = require('../view/detail/fundDetail');
    var BillDetailView = require('../view/detail/billDetail');
    var FundRateView = require('../view/detail/fundRate');
    var GoldbaoView = require('../view/detail/goldbao');
    var ProductsQryModel = require('../model/ProductsQryModel');
    module.exports = Controller.extend({
        actions: {
            'finace': 'finace', //理财，养老产品详情 默认展示信息
            'fund': 'fund', //基金详情页
            'fundRate': 'fundRate', //基金费率查询
            'goldbao': 'goldbao', //黄金宝详情页
            'bill': 'bill' //小票详情页
        },

        authorize: function() {
            return true;
        },

        finace: function() {
            utils.native.talkingDataTrackEvent('2.0理财产品详情');
            var finaceType, fnType, fnDetailView, finaceModel, backUrl;
            finaceModel = App.storage.get('products/detail/finace');

            backUrl = this._getBackUrl(finaceModel);
            fnType = finaceModel.get('fnType');
            finaceType = finaceModel.get('type');
            if (!(finaceType === 'finance' || finaceType === 'pension' || finaceType === 'pap')) {
                App.navigate(backUrl, true);
                return;
            }

            finaceModel.set('backUrl', backUrl);

            this._setHeaderFooter({
                backUrl: backUrl,
                rightButtonContent: '@share',
                rightButtonHandler: function() {
                    var prdName = finaceModel.get("prdName");
                    var prdCode = finaceModel.get("prdCode");
                    var planRate = finaceModel.get("planRate"); //预期年化收益
                    var url = IS_RUN_IN_PRODUCTION_ENVIRONMENT == false ? "https://ibankibpu1.pingan.com.cn/ibd/page/web_for_h5/share_h5/index.html?" : "https://cz.pingan.com.cn/ibd/page/web_for_h5/share_h5/index.html?";
                    var type = 0;
                    if (finaceType == 'finance') {
                        type = 0;
                    } else if (finaceType == 'pension') {
                        type = 1;
                    } else if (finaceType == 'pap') {
                        type = 11;
                    }
                    url = url + "type=" + type + "&code=" + prdCode + "&name=" + prdName + "&num=" + planRate + "&t=" + new Date().getTime();
                    //缓存分享信息
                    App.storage.set("shareWLTData",{"share_module":config.values.shareProducts,"share_url":encodeURIComponent(url)});
                    utils.native.shareProduct({
                        "title": prdName,
                        "message": "哟，平安橙子的这款理财产品不错哦，你也看看？",
                        "url": url
                    });
                }
            });
            // 2015-12-11 增加日添利，净值产品特殊视图
            if (fnType) {
                fnDetailView = new NetworthDetaillView({
                    model: finaceModel
                });
            } else {
                fnDetailView = new FinaceDetailView({
                    model: finaceModel
                });
            }

            App.container.show(fnDetailView);
        },

        fund: function() {
			utils.native.talkingDataTrackEvent('2.0-产品-精选基金产品详情');
            var fundType, fundModel, backUrl;
            fundModel = App.storage.get('products/detail/fund');

            backUrl = this._getBackUrl(fundModel);
            fundType = fundModel.get('type');
            if (fundType !== 'fund') {
                App.navigate(backUrl, true);
                return;
            }

            fundModel.set('backUrl', backUrl);

            this._setHeaderFooter({
                backUrl: backUrl,
                rightButtonContent: '@share',
                rightButtonHandler: function() {
                    var prdName = fundModel.get("prdName");
                    var prdCode = fundModel.get("prdCode");
                    var nav = fundModel.get("nav"); //最新净值
                    var url = IS_RUN_IN_PRODUCTION_ENVIRONMENT == false ? "https://ibankibpu1.pingan.com.cn/ibd/page/web_for_h5/share_h5/index.html?" : "https://cz.pingan.com.cn/ibd/page/web_for_h5/share_h5/index.html?";
                    url = url + "type=6&code=" + prdCode + "&name=" + prdName + "&num=" + nav + "&t=" + new Date().getTime();
                    //缓存分享信息
                    App.storage.set("shareWLTData",{"share_module":config.values.shareProducts,"share_url":encodeURIComponent(url)});
                    utils.native.shareProduct({
                        "title": prdName,
                        "message": "我看中了这只产品，你也看看？",
                        "url": url
                    });
                }
            });


            //2016-03-21 增加搜索查询接口
            var fundDetailView,
                prdCode = fundModel.get('prdCode'),
                queryFundDetails = fundModel.get('queryFundDetails');
            if (queryFundDetails) {
                ProductsQryModel.queryFundDetails({
                    data : { prdCode : prdCode }
                }).done(function(res) {
                    var model = _.extend(fundModel.toJSON(), res.detailDTO || {});
                    model = new Model(model);
                    model.set('queryFundDetails', false);

                    App.storage.set('products/detail/fund', model);
                    fundDetailView = new FundDetailView({
                        model: model
                    });
                    App.container.show(fundDetailView);
                }).fail(function(e) {
                    if (e && e.message) utils.dialog.toast(e.message);
                });
            } else {
                fundDetailView = new FundDetailView({
                    model: fundModel
                });
                App.container.show(fundDetailView);
            }

        },

        fundRate: function() {
            //var params = this._getParams(location.hash);
            var params = App.storage.get('products/detail/fundRate');
            if (!params.prdCode) return;
            this._setHeaderFooter({
                title: '费率详情'
            });

            ProductsQryModel.qryFundRate({
                prdCode: params.prdCode
            }).done(function(res) {
                var model = new Model(res);
                model.set('prdName', params.prdName);

                App.container.show(new FundRateView({
                    model: model
                }));
            }).fail(function(e) {
                if (e && e.message) utils.dialog.toast(e.message);
            });
        },

        goldbao: function() {
			utils.native.talkingDataTrackEvent('2.0-产品-黄金宝产品详情');
            var goldbaoType, goldbaoModel, backUrl;
            goldbaoModel = App.storage.get('products/detail/goldbao');

            backUrl = this._getBackUrl(goldbaoModel);
            goldbaoType = goldbaoModel.get('type');
            if (goldbaoType !== 'goldbao') {
                App.navigate(backUrl, true);
                return;
            }

            goldbaoModel.set('backUrl', backUrl);

            this._setHeaderFooter({
                backUrl: backUrl,
                rightButtonContent: '@share',
                rightButtonHandler: function() {
                    var prdName = goldbaoModel.get("prdName");
                    var prdCode = goldbaoModel.get("prdCode");
                    var planRate = goldbaoModel.get("planRate"); //预期年化收益
                    var url = IS_RUN_IN_PRODUCTION_ENVIRONMENT == false ? "https://ibankibpu1.pingan.com.cn/ibd/page/web_for_h5/share_h5/index.html?" : "https://cz.pingan.com.cn/ibd/page/web_for_h5/share_h5/index.html?";
                    url = url + "type=10&code=" + prdCode + "&name=" + prdName + "&num=" + planRate + "&t=" + new Date().getTime();
                    //缓存分享信息
                    App.storage.set("shareWLTData",{"share_module":config.values.shareProducts,"share_url":encodeURIComponent(url)});
                    utils.native.shareProduct({
                        "title": prdName,
                        "message": "哟，平安橙子的这款产品不错哦，你也看看？",
                        "url": url
                    });
                }
            });

            var goldbaoView = new GoldbaoView({
                model: goldbaoModel
            });
            App.container.show(goldbaoView);
        },

        bill: function() {
			utils.native.talkingDataTrackEvent('2.0-产品-小票/E企盈产品详情');
            var billType, billModel, backUrl;
            billModel = App.storage.get('products/detail/bill');

            backUrl = this._getBackUrl(billModel);
            billType = billModel.get('type');
            if (billType !== 'bill') {
                App.navigate(backUrl, true);
                return false;
            }

            billModel.set('backUrl', backUrl);

            this._setHeaderFooter({
                backUrl: backUrl,
                rightButtonContent: null,
                rightButtonHandler: null
            });

            App.container.show(
                new BillDetailView({
                    model: billModel
                })
            );
        },

        _getParams: function(hash) {
            var params = {},
                i = 0,
                arr = [];
            if (!hash || !~(i = hash.indexOf('?'))) {
                return params;
            }
            arr = hash.slice(i + 1).split('&');
            arr.forEach(function(v) {
                v = v.split('=');
                v.length === 2 && (params[v[0]] = decodeURIComponent(v[1]));
            });
            return params;
        },

        _getBackUrl: function(model) {
            var modelType, fromPage,fundType,
                isLogin = App.storage.get('isUserLoggedIn'),
                url = isLogin ? 'index/indexLogined/index' : 'index/index/index';

            if (model instanceof Model) {
                fromPage = model.get('fromPage');
                modelType = model.get('type');
                fundType =  model.get('fundType');
            }

            if (fromPage === 'product' || fromPage === 'filterFund') {
                url = 'products/index/index/finefinance';
                if (modelType === 'fund') {
                    url = 'products/index/index/selectFund';
                    if(fundType){
                        if(fundType === 'selectFund'){
                            url = 'products/fund/selectFunds';
                        }else {
                            url = 'products/fund/specialFunds/' + fundType;
                        }
                    }
                }

                if (fromPage === 'filterFund') {
                    url = 'products/index/filterFund';
                }
            }
            return url;
        },

        _setHeaderFooter: function(options) {
            var opts = _.extend({
                title: '产品详情',
                // rightButtonContent: '@share',
                leftButtonContent: '@back',
                leftButtonHandler: function() {
                    if (options.backUrl) {
                        App.navigate(options.backUrl, true);
                    } else {
                        App.back();
                    }
                }
            }, options || {});

            App.header.reset(opts);
            App.footer.reset({
                visible: false
            });
        }

    });

});
