/**
 * ex_huangzit (2016-04-11)  基金产品控制器
 */
define(function(require, exports, module) {
    
    var SelectFundsView = require('mod/products/view/fund/selectFunds');              // 精选基金
    var ProductsQryModel    = require("mod/products/model/ProductsQryModel");         // 特色基金Model
    var specialFundView    = require('mod/products/view/fund/specialFundIndex');      // 特色基金Container
    
    
    module.exports = Controller.extend({
        actions: {
            'selectFunds':'_selectFunds', //精选基金列表
            'specialFunds(/*type)':'_qrySpecialFunds' //特色基金列表
        },
        
        authorize: function() {
            return true;
        },
        
        //精选基金列表
        _selectFunds: function(){
            this._setHeaderFooter({title : '精选基金'});
            ProductsQryModel.qryFundPrdInfo().done(function(res) {
                App.container.show(new SelectFundsView({model:new Model({"list": res.productList})}));
            }).fail(function(e) {
                utils.dialog.toast(e.message);
            });
        },
       
        initParam:{
                '201604010000000006':'定期开放债券基金', '201604010000000009':'百元基金', '201604010000000007':'理财型基金', 
                '201604010000000008':'保本基金'
        },
        
        //查询特色基金
        _qrySpecialFunds:function(type){
            this.fundType = type;
            var param = {specialType:this.fundType};
            var isLogin = App.storage.get('isUserLoggedIn');//true 为登陆， undefined未登陆
            
            var methodArr = {'loggedIn':'fundItemFund', 'loggedOut':'fundItemFundOut'};//loggedIn:登陆区内;loggedOut:登陆区外
            var specialMethod = methodArr['loggedOut'];
            this._setHeaderFooter({title : this.initParam[this.fundType]});
            
            if(isLogin) specialMethod = methodArr['loggedIn'];//登陆区内
            
            ProductsQryModel[specialMethod](param).done(_.bind(function (res) {
                var outDTO, fundOptions;
                if(specialMethod === 'fundItemFundOut'){//登陆区外
                    outDTO = this._fundItemOut(res.object);
                    fundOptions = _.extend(outDTO, param);
                }else{
                    fundOptions = _.extend(res.object, param);
                }
                App.container.show(new specialFundView({model:new Model({"object":fundOptions})}));
            }, this)).fail(function (error) {
                utils.dialog.alert(error.message);
            });
        },
        
        //处理登陆区外数据
        _fundItemOut:function (res) {
            if(!res) return;
            // var specialOption;
            var specialOption = App.storage.get('specialFund::specialOption');
            // var specialOption. = '1';
            // (specialOption={})['dispOrder'] = '1';
            /**
             * liuxiannan 注
             * List1 对应优先级dispOrder == 1
             * List2 对应优先级dispOrder == 2
             * List3 对应优先级dispOrder == 3
             * List4 对应优先级dispOrder == 4
             */
            var outDTO;
            switch (specialOption.dispOrder) {
                case 1:
                    outDTO = res.outDTO1;
                    break;
                case 2:
                    outDTO = res.outDTO2;
                    break;
                case 3:
                    outDTO = res.outDTO3;
                    break;
                case 4:
                    outDTO = res.outDTO4;
                    break;
                default:
                    outDTO = res.outDTO1;
                    break;
            }
            return outDTO || {};
        },
        
        //设置头部脚部
        _setHeaderFooter: function(options) {
            var defaults = _.extend({
                showFooter: false,
                leftButtonContent: "@back",
                leftButtonHandler: function(){
                    App.navigate("products/index/index/selectFund", true);
                }
            }, options || {});
            App.header.reset(defaults);
            App.footer.reset({
                visible: defaults.showFooter,
                selectedIndex: 0
            });
        }
        
    });
});
