define(function (require, exports, module) {
    var PrdModel = module.exports = Model.extend({}, {
        qryADimg: function (options) {
            var data = options || {};
            return App.request('qryADimg', {
                data: data
            });
        },

        //2016-03-03 增加搜索框
        searchFund: function (options) {
            if (!options || typeof options !== 'object') options = {};
            return App.request('searchFund', options).pipe(function (result) {
                result.object || (result.object = {});
                var fundList = result.object.list || [];
                if (fundList.length) {
                    //2015-09-07 暂时屏蔽 货币型， 这期不上
                    fundList = _.filter(fundList, function (item) {
                        return item.prdAttr && ('4' !== item.prdAttr);
                    });
                }

                return result.object;
            });
        },
        //基金详情查询
        queryFundDetails : function(options){
            if (!options || typeof options !== 'object') options = {};
            return App.request('queryFundDetails', options).pipe(function (result) {
                return result.object || {};
            });
        },
        //基金详情查询
        searchFundSwitch : function(options){
            if (!options || typeof options !== 'object') options = {};
            return App.request('searchFundSwitch', options).pipe(function (result) {
                return result.object || {};
            });
        },
        //2015-09-06 增加精选基金单独接口
        qryFundPrdInfo: function (options) {
            var data = options || {};
            return App.request('qryFundPrdInfo', data).pipe(function (res) {
                var fundList = (res.object && res.object.list) || [];

                if (fundList.length) {
                    fundList = PrdModel._setValue(fundList, 'fund');

                    //2015-09-07 暂时屏蔽 货币型， 这期不上
                    fundList = _.filter(fundList, function (item) {
                        return item.prdAttr && ('4' !== item.prdAttr);
                    });
                }

                //2015-09-15 基金精选接口第一请求平均耗时25s
                //为提高用户体验，缓存上次请求数据，
                //当用户从详情页返回精选基金时，检测缓存。若有缓存，
                //直接用缓存，防止再次卡25s
                if (fundList.length)
                    App.storage.set('prdIndexFundCache', {
                        productList: fundList,
                        params: {}
                    });

                return {
                    productList: fundList,
                    params: {}
                };
            });
        },

        queryProduct: function (options) {
            var data = options || {};
            return App.request('qryFistPageProductList', {
                data: data,
                isSave: true,
                key: 'qryFistPageProductListA'
            }).pipe(function (result) {
                App.storage.set('prdIndexLastRefresh', Date.now());
                return PrdModel._processQryPrdList(result);
            });
        },

        // 2015-11-03 增加E企盈接口
        qryBillList: function (options) {
            if (!options || typeof options !== 'object') options = {};
            // options.silent = (options.silent === void 0) ? true : options.silent;
            // options.cache = (options.cache === void 0) ? false : options.cache;

            return App.request('qryBillList', options).pipe(function (result) {
                var obj = result.object || (result.object = {});
                if (obj.list && obj.list.length) {
                    try {
                        obj.list = PrdModel._processBillProductList(obj.list, obj.currentTime);
                        App.storage.set('prdBillLastRefresh', Date.now());
                    } catch (e) { }
                }
                return obj;
            });
        },
        buyBillConfirm: function (options) {
            if (!options || typeof options !== 'object') options = {};

            App.request('buyBillConfirm', options);
        },
        qrySignBill: function (options) {
            if (!options || typeof options !== 'object') options = {};
            return App.request('qrySignBill', options).pipe(function (result) {
                return result.object || (result.object = {});
            });
        },
        signBill: function (options) {
            if (!options || typeof options !== 'object') options = {};
            return App.request('signBill', options);
        },

        // 2015-10-09 增加 黄金单价查询
        queryGoldPrice: function (options) {
            var data = options || {};
            return App.request('goldAcctQryGoldPrice', {
                data: data
            }).pipe(function (result) {
                return result.object;
            });
        },

        queryNativeProduct: function (options) {
            var data = options || {};
            var CFG = _.extend({
                key: 'qryFistPageProductListA'
            }, data);
            return utils.native.HTTPRequestCache(CFG).pipe(function (result) {
                return PrdModel._processQryPrdList(result);
            });
        },

        _processQryPrdList: function (result) {
            var res = {
                productList: [],
                params: {}
            };
            try {
                res = PrdModel._processQryResult(result);
            } catch (e) { }

            return res;
        },

        qryPaYingInfo: function (options) {
            var data = options || {};
            return App.request('qryPaYingInfo', {
                data: data
            });
        },
        qryDingHuoTong: function (options) {
            var data = options || {};
            return App.request('qryDingHuoTong', {
                data: data
            });
        },
        qryFinancingPrdList: function (options) {
            var data = options || {};
            return App.request('qryFinancingPrdList', {
                data: data
            });
        },

        qryFundPrdList: function (options) {
            var data = options || {};
            return App.request('qryFundPrdList', {
                data: data
            });
        },
        //七日年化收益率（七日、一个月、三个月）
        qryFundProfitList: function (options) {
            var data = options || {};
            return App.request('qryFundProfitList', {
                data: data
            });
        },
        //2015-12-17 理财产品历史收益列表查询(后台曹子瑜)
        qryFinanceHistoryYield: function (options) {
            var data = options || {};
            return App.request('qryFinanceHistoryYield', {
                data: data
            });
        },

        _getSetCachePrdList: function () {
            if (arguments.length > 0) {
                App.locStorage.set('modPrdIndexCache', arguments[0]);
            }
            return App.locStorage.get('modPrdIndexCache');
        },

        qryFundRate: function (options) {
            var data = options || {};
            return App.request('entrustFundRateDetails', {
                data: data
            }).pipe(function (result) {
                var res = result.object || {};
                if (!Array.isArray(res.plist)) res.plist = [];
                if (!Array.isArray(res.rlist)) res.rlist = [];
                if (!Array.isArray(res.slist)) res.slist = [];

                // if( 0 < res.plist.length)
                //     res.plist = PrdModel._sortFundRate(res.plist, 'pamt');
                // if( 0 < res.rlist.length)
                //     res.rlist = PrdModel._sortFundRate(res.rlist, 'date');
                // if( 0 < res.slist.length)
                //     res.slist = PrdModel._sortFundRate(res.slist, 'samt');

                return res;
            });
        },

        _sortFundRate: function (arr, skey) {
            return _.sortBy(arr, function (it) {
                var sortVal = it[skey],
                    level = 0,
                    grade = 99;
                if (!sortVal || (!~sortVal.indexOf('≥') &&
                    !~sortVal.indexOf('＞') &&
                    !~sortVal.indexOf('≤') &&
                    !~sortVal.indexOf('<') &&
                    !~sortVal.indexOf('＜'))) return -100 * grade;

                if (!!~sortVal.indexOf('M')) level += (10 * grade);

                if (!!~sortVal.indexOf('≥') || !!~sortVal.indexOf('＞')) level += grade;
                if (!!~sortVal.indexOf('＜') || !!~sortVal.indexOf('<')) {
                    if (!~sortVal.indexOf('≤')) {
                        level -= grade;
                    } else {
                        level += sortVal.length;
                    }
                }

                return level;
            }).reverse();
        },

        qryFundDiscountRate: function (options) {
            var data = options || {};
            return App.request('qryFundDiscountRate', {
                data: data
            });
        },

        /**
         * 处理接口数据
         * 产品数组list分离，其余非数组字段作为view 参数
         * 根据返回数据键，增加值 type 属性
         * type = 'pay' 表示平安盈 'fund' 表示基金产品 'finance' 表示理财产品
         *
         */
        _processQryResult: function (result) {
            //2015-09-24 增加黄金宝理财产品
            var productListArr = [
                'paYingList', 'fundList', 'financingPrdList',
                'pensionPrdList', 'papiaoPrdList', 'goldPrdList'
            ];
            var prdList = _.pick(result.object, productListArr);
            var productParam = _.omit(result.object, productListArr);
            prdList = _.reduce(prdList, function (memo, value, key) {
                if (value) memo[key] = value;
                return memo;
            }, {});

            ['financingPrdList', 'pensionPrdList',
                'papiaoPrdList'
            ].forEach(function (listType) {
                if (Array.isArray(prdList[listType]) && prdList[listType].length) {
                    prdList[listType] = PrdModel._processFinaceProductList(
                        prdList[listType], productParam.currentTime);
                }
            });

            // 2015-06-13 计算平安盈 7日年化收益率 与 活期利率 倍数
            if (prdList.paYingList) {
                _.each(prdList.paYingList, function (v, k) {
                    //后台所返回的活期利率为百分比,这里需要(sevenIncomeRate)乘以100
                    var mRate = Math.round(v.sevenIncomeRate * 100 / productParam.currentRate);
                    if (_.isNaN(mRate) || !_.isFinite(mRate)) {
                        v.mRate = 'x';
                    } else {
                        v.mRate = mRate;
                    }
                });
            }

            prdList = _.chain(prdList)
                .map(function (value, key) {
                    switch (key) {
                        case 'paYingList':
                            return PrdModel._setValue(value, 'paY');
                        case 'fundList':
                            return PrdModel._setValue(value, 'fund');
                        case 'financingPrdList':
                            return PrdModel._setValue(value, 'finance');
                        case 'pensionPrdList':
                            return PrdModel._setValue(value, 'pension');
                        case 'papiaoPrdList':
                            return PrdModel._setValue(value, 'pap');
                        case 'goldPrdList':
                            return PrdModel._setValue(value, 'goldbao');
                    }
                })
                .flatten(true)
                .sortBy(function (value, id) { //以index键 排序
                    return parseInt(value.index, 10);
                })
                .value();

            return {
                productList: prdList,
                params: productParam
            };
        },

        _setValue: function (obj, key) {
            var tkey, val;
            if (arguments.length > 2) {
                tkey = key;
                val = arguments[2];
            } else {
                tkey = 'type';
                val = key;
            }
            if (_.isArray(obj)) {
                _.each(obj, function (v, k) {
                    v[tkey] = val;
                });
            } else {
                obj[tkey] = val;
            }
            return obj;
        },

        /**
         * 处理理财产品信息
         * 增加 flag 0 表示预发布 1 表示正在发售 2 表示 已售完或者过期
         * 增加 countdown (秒) 倒计时时间 当 flag = 0 || 1
         * 增加 ratioRemark = balanceRemark / totalAmt
         * 2015/05/26 更改为
         * 增加 ratioRemark = remainQuota0799 / totalAmt
         *
         * 全开放式（日添利型）、收益类：CycleMode=40，TypeId=310，NavMode=1；
         * 全开放式（按天计收益型）、收益类：CycleMode=41，TypeId=311，NavMode=1；
         * 全开放式（真净值型）、净值类：CycleMode=50，TypeId=51开头（暂仅510），NavMode=0；
         * 2015/12/09 根据产品字段prdCode增加理财产品中的日添利，净值产品标志:
         * fnType : '1' 日添利， '2' 净值
         */
        _processFinaceProductList: function (list, currentTime) {
            if (!list || !_.isArray(list)) return;
            currentTime = new Date(currentTime).getTime() || new Date().getTime();
            return _.map(list, function (item, id) {
                var tempDate = item.saleStartDate1 + ' ' + item.saleStartTime.substr(0, 2) + ':' + item.saleStartTime.substr(2, 2);
                var startDate = new Date(tempDate.replace(/-/g, '/')).getTime();
                tempDate = item.saleEndDate1 + ' ' + item.saleEndTime.substr(0, 2) + ':' + item.saleEndTime.substr(2, 2);
                var endDate = new Date(tempDate.replace(/-/g, '/')).getTime();
                if (startDate > endDate) return;

                var flag = 2,
                    ratio;
                if (currentTime < startDate) {
                    flag = 0;
                } else if (currentTime < endDate && parseFloat(item.minAmount) < parseFloat(item.remainQuota0799)) {
                    flag = 1;
                }
                item.flag = flag;
                if (flag === 1 || flag === 0) {
                    item.countdown = parseInt((endDate - currentTime) / 1000, 10);
                    //if (flag == 1) {
                    ratio = (parseFloat(item.remainQuota0799) / parseFloat(item.totalAmt)) * 100;
                    if (_.isFinite(ratio)) {
                        ratio = ratio >= 1 ? parseInt(ratio, 10) : (ratio < 0.1 ? 0.1 : ratio.toFixed(1));
                    } else {
                        ratio = 99;
                    }
                    item.ratioRemark = ratio;
                    //}
                }

                if (flag === 2) {
                    item.balanceRemark = '0';
                }

                if (/^310/.test(item.prdCode)) {
                    item.fnType = '1';
                } else if (/^510/.test(item.prdCode)) {
                    item.fnType = '2';
                }

                return item;
            });
        },

        /**
         * 2015-11-04 处理小票产品信息
         * 增加 flag 0 表示预发布 1 表示正在发售 2 表示 已售完或者过期
         * balance 剩余额度（精确数据类型，跟业务确认过）
         * tranAmt 总额度（精确数据类型，跟业务确认过）
         * 增加 ratioRemark = balance / tranAmt
         */
        _processBillProductList: function (list, currentTime) {
            if (!list || !_.isArray(list)) return;
            currentTime = new Date(currentTime).getTime() || new Date().getTime();
            return _.map(list, function (item) {
                var startDate = utils.date.formatTime(item.beginTime).getTime();
                // 结束日期是起息日当晚9点（24小时制，业务刘磊）
                var endDate = utils.date.formatTime(item.intFrom + '210000').getTime();
                if (startDate > endDate) return;

                var flag = 2,
                    ratio;
                if (currentTime < startDate) {
                    flag = 0;
                } else if (currentTime < endDate && parseFloat(item.minSubscribeAmt) < parseFloat(item.tranAmt)) {
                    flag = 1;
                }
                item.flag = flag;
                if (flag === 1 || flag === 0) {
                    item.countdown = parseInt((endDate - currentTime) / 1000, 10);
                    //if (flag == 1) {
                    ratio = (parseFloat(item.balance) / parseFloat(item.tranAmt)) * 100;
                    if (_.isFinite(ratio)) {
                        ratio = ratio >= 1 ? parseInt(ratio, 10) : (ratio < 0.1 ? 0.1 : ratio.toFixed(1));
                    } else {
                        ratio = 99;
                    }
                    item.ratioRemark = ratio;
                    //}
                }

                if (flag === 2) {
                    item.balance = '0';
                }
                // 增加产品类型标志
                item.type = 'bill';
                item.riskLevel = 3;
                item.prdCode = item.tranId;

                return item;
            });
        },

        //抢购专区  wuwenjun
        qryPanicBuyList: function (options) {
            //登录区外
            var url = "qryPanicBuyListOutside";
            if (!options || typeof options !== 'object') options = {};
            if(App.storage.get("isUserLoggedIn")){
                //登录区内
                url = "qryPanicBuyList";
            }
            return App.request(url, options).pipe(function (result) {
                var obj = result.object || (result.object = {});
                if (obj.ruPurchasePrdInfoList && obj.ruPurchasePrdInfoList.length) {
                    try {
                        obj.ruPurchasePrdInfoList = PrdModel._processPanicBuyList(obj.ruPurchasePrdInfoList, obj.currentTime);
                        App.storage.set('prdPanicBuyLastRefresh', Date.now());
                    } catch (e) { }
                }
                return obj;
            });
        },

         /**
         * 2016-02-25 处理抢购专区产品信息
         * 增加 flag 0 表示预发布 1 表示正在发售 2 表示 已售完或者过期
         * balance 剩余额度（精确数据类型，跟业务确认过）
         * tranAmt 总额度（精确数据类型，跟业务确认过）
         * 增加 ratioRemark = balance / tranAmt
         */
        _processPanicBuyList: function (list, currentTime) {
            if (!list || !_.isArray(list)) return;
            currentTime = new Date(currentTime).getTime() || new Date().getTime();
            return _.map(list, function (item) {
                var tempDate = utils.date.formatTime(item.saleStartDate).format("yyyy/MM/dd") + ' ' + item.saleStartTime.substr(0, 2) + ':' + item.saleStartTime.substr(2, 2);
                var startDate = new Date(tempDate).getTime();
                tempDate = utils.date.formatTime(item.saleEndDate).format("yyyy/MM/dd") + ' ' + item.saleEndTime.substr(0, 2) + ':' + item.saleEndTime.substr(2, 2);
                var endDate = new Date(tempDate).getTime();
                if (startDate > endDate) return;

                var flag = 2,
                    ratio;
                if (currentTime < startDate) {
                    flag = 0;
                } else if (currentTime < endDate && parseFloat(item.minAmount) < parseFloat(item.evaluateRemainQuota)) {
                    flag = 1;
                }
                item.flag = flag;
                if (flag === 1 || flag === 0) {
                    if(flag === 0){
                        item.countdown = parseInt((startDate - currentTime) / 1000, 10);
                    }else{
                        item.countdown = parseInt((endDate - currentTime) / 1000, 10);
                    }
                    //if (flag == 1) {
                    ratio = (parseFloat(item.evaluateRemainQuota)/ parseFloat(item.allAmountLmt)) * 100;
                    if (_.isFinite(ratio)) {
                        ratio = ratio >= 1 ? parseInt(ratio, 10) : (ratio < 0.1 ? 0.1 : ratio.toFixed(1));
                    } else {
                        ratio = 99;
                    }
                    item.ratioRemark = ratio;
                    //}
                }

                if (flag === 2) {
                    item.balanceRemark = '0';
                }
                // 增加产品类型标志
                item.type = 'panic';
                return item;
            });
        },
         
       //特色基金(登录区内)
       fundItemFund : function(options){
			return App.request("fundItemFund" , {data:options});
	   },
       
       //特色基金(登录区外)
       fundItemFundOut : function(options){
			return App.request("fundItemFundOut" , {data:options});
	   },
       
       //基金首页
       fundMaxProfit : function(options){
			return App.request("fundMaxProfit" , {data:options});
	   }
    });
});
