/**
 * ex-wuyongsheng001 产品首页随存随取视图
 */
define(function(require, exports, module){
    var depositTakeTpl = _.template(require("text!../template/depositTake.html"));

    var ProductsQryModel = require("../model/ProductsQryModel");

    module.exports = ItemView.extend({
        className: 'depositTake',
        template: depositTakeTpl,
        templateHelpers: {
            minAmount : function (minAmount) {
                if (minAmount >= 10000) {
                    return  Math.floor(minAmount/10000)+'<i class="f12">万</i>';
                }else{
                    return  utils.string.numberFormat(minAmount,1)+'<i class="f12">元</i>';
                }
            },
            evalMarkup : function (val) {
                var monthMarkup = Number(val);
                if( -1 === monthMarkup || !val){
                    monthMarkup = '---';
                }else{
                    monthMarkup = this.splitStr(monthMarkup.toFixed(2)) + '<i class="f15 lh12">'+ this.splitStr(monthMarkup.toFixed(2), 1) +'%</i>';
                }
                return monthMarkup;
            },
            splitStr : function(val, index) {
                if(typeof val !== "string" && typeof val !== "number") return val;
                if(typeof val === "number") val = String(val);
                index = index == null ? 0 : index;
                var strArr = val.split('.'), sStr = strArr[1] ? ('.') + strArr[1] : '.00';
                strArr.splice(1, 1, sStr);
                return strArr[index];
            }
        },
        ui:{
            payProducts:'#payProducts',
            dingHuoTongProduct:'#dingHuoTongProduct'
        },
        events: {
            'tap [data-prdcode]' : 'toProductDetail', //跳转产品详情页
            'tap @ui.qryADimg' : 'toAD' //随存随取 广告链接
        },
        toProductDetail: function (e) {
            var _this = this, model,
                el = $(e.currentTarget),
                prdCode = el.data('prdcode') + '';
            if (prdCode == 'dht') {
                model = this.model;
                model.set('type', 'dht');
            }else{
                model = this.collection.findWhere({prdCode: prdCode});
            }
            Marionette.triggerMethod.call(_this.parentView,'toProductDetail', model, el);
        },
        serializeData: function(){
          var data = {};
          if (this.model) {
            data.params = this.model.toJSON();
          }
          if (this.collection) {
            data.list = this.collection.toJSON();
          }
          return data;
        },
        /**
         * 提取定活通对象， 平安盈数组
         */
        initialize: function (options) {
            var _this = this, paYList, dhtInfo;
            this.parentView = options.parent;
            paYList = _.where(options.processedResult.productList, {type: 'paY'});
            dhtInfo = options.processedResult.params.dhtInfo;

            this.collection = new Collection(paYList);
            this.model = new Model(dhtInfo);
        },

        onRender: function () {
            var _this = this;
            // ProductsQryModel.qryADimg().done(function (res) {
            //     var ADimageList = res.object.ADimageList;
            //     _this._renderADimg(ADimageList);
            // });
        },

        _renderADimg : function (list) {
            var len = list.length;
            if(len<1) return;
            var randId = Math.floor((Math.random() * len));
            var ADimg = this._ADimg = list[randId];
            var container = this.$('#qryADimg');
            var image = $('<img style="display:none;" />');
            image.on("load", function(){ image.show() });
            image.appendTo( container );
            image.attr("src", ADimg.imageUrl);

            setTimeout(function () {
                container.fadeOut();
            }, 5000);
        },

        toAD: function () {
            //alert(JSON.stringify(this._ADimg));
        }

    });
});
