/**
 * wuyongsheng560 黄金宝详情视图
 */
define(function(require, exports, module) {
	var initPTRScroll = require('mod/common/widget/initPTRScroll');

	var Tpl = _.template(require('text!../../template/detail/goldbao.html'));
	module.exports = ItemView.extend({
		className: 'goldbaoDetail',
		template: Tpl,
		events: {
			'tap #toggleWrap .title' : 'togglePanel', //产品说明面板折叠展开
			'tap #investNow'         : 'investNow', //立即投资
			'tap #faq'               : 'toFaq'
		},

		templateHelpers: {
			rCurrency : function (currency) {
				var cdata = {};
				cdata.code = currency;
				return utils.string.getCurrencyName(cdata) || '---';
			}
		},

		onShow: function() {
			var gap = 75;

			//初始化PTRScroll
			if (IS_RUN_ON_DEVICE) gap = 18;
			initPTRScroll.call(this, {
				gap: gap,
				pullDownToRefresh: false,
				pullUpToLoadMore: false
			});
		},

		onClose: function() {
			if (this.scroller) {
				this.scroller.destroy();
				delete this.scroller;
			}
		},

		toFaq: function(){
			App.navigate('czFaq/faqIndex/czFaq/goldbao', true);
		},

		investNow: function(e) {
			if (!this._investNowFlag) {
				this._investNowFlag = true;
				App.storage.set('myInvestment/commendProducts/curProObj', this.model);

				setTimeout(function() {
					App.navigate('myInvestment/commendProducts/riskgoldtreasure/4', true);
				}, 350);
			}
		},

		togglePanel: function(e) {
			var _this = this,
				titleEl = $(e.currentTarget),
				panelEl = titleEl.next('.proText');
			if (titleEl.length && panelEl.length) {
				if (panelEl.is(':visible')) {
					panelEl.slideUp(function() {
						if (_this.scroller) {
							_this.scroller.refresh();
						}
					});
					titleEl.find('i').removeClass('on');
				} else {
					panelEl.slideDown(function() {
						if (_this.scroller) {
							_this.scroller.refresh();
							_this.scroller.scrollToElement(titleEl[0], 200);
						}
					});
					titleEl.find('i').addClass('on');
				}

			}
		}

	});
});
