define(function (require, exports, module) {
    var itemTpl = _.template(require("text!../../template/filter/fundItem.html"));

    var FundItemView = ItemView.extend({
        className: 'Columns m_t15',
        template: itemTpl,
        templateHelpers: {
            evalMarkup: function (val) {
                var monthMarkup = Number(val);
                if (-1 === monthMarkup || !monthMarkup) {
                    monthMarkup = '---';
                } else {
                    monthMarkup = this.splitStr(((monthMarkup - 1) * 100).toFixed(2)) + '<i class="f15 lh12">' + this.splitStr(((monthMarkup - 1) * 100).toFixed(2), 1) + '%</i>';
                }
                return monthMarkup;
            },
            splitStr : function(val, index) {
                if(typeof val !== "string" && typeof val !== "number") return val;
                if(typeof val === "number") val = String(val);
                index = index == null ? 0 : index;
                var strArr = val.split('.'), sStr = strArr[1] ? ('.') + strArr[1] : '.00';
                strArr.splice(1, 1, sStr);
                return strArr[index];
            }
        },
        triggers: {
            'tap': 'tap'
        }
    });

    var FundEmptyView = ItemView.extend({
        className: 'tac',
        template: '<span class="iconA58 m_t40"></span><p class="c_999 f16 m_t20">抱歉！暂时未有此类型产品</p>'
    });

    module.exports = CollectionView.extend({
        itemView: FundItemView,
        emptyView: FundEmptyView,
        onItemviewTap: function (event, view) {
            view.model.set('type', 'fund');
            view.model.set('fromPage', 'filterFund');

            App.storage.set('products/detail/fund', view.model);
            App.navigate('products/detail/fund', true);
        }
    });

});
