/**
 * wuyongsheng560 基金搜索视图
 */
define(function(require, exports, module) {
    var Tpl = _.template(require("text!../../template/filter/search.html"));
    var FilterListView = require('./fundList')
    var ProductsQryModel = require("../../model/ProductsQryModel");
    var initPTRScroll = require("mod/common/widget/initPTRScroll");

    FilterListView = FilterListView.extend({
        emptyView : ItemView.extend({
            className: 'tac',
            template: '<span class="iconA58 m_t40"></span><p class="c_999 f16 m_t20">请输入基金名称，代码，简拼。 <br />如: 平安盈南方</p>'
        })
    });

    module.exports = Layout.extend({
        className: 'searchFund',
        template: Tpl,
        regions: {
            FundList: '#FundList'
        },
        events: {
            'focus #searchInput': 'toggleClearInput',
            'blur #searchInput': 'toggleClearInput',
            'tap #clearInput': 'clearInput',
            'tap #searchBtn': 'search'
        },
        initialize: function() {
            this.collection = new Collection();

            //初始化过滤条件
            this.qryParams = {};
        },
        onShow: function() {
            var _this = this;
            initPTRScroll.call(_this, {
                pullDownToRefresh : false,
                pullUpToLoadMore: false
            });

            //初始化列表并显示第一页基金数据
            this._showFundListView();
        },

        _showFundListView: function() {
            if (!this.fundListView) {
                this.fundListView = new FilterListView({
                    collection: this.collection
                });
            }
            this.FundList.show(this.fundListView);
        },

        toggleClearInput: function (e) {
            e.stopPropagation();e.preventDefault();
            this.$('#clearInput').parent().toggleClass('dsn');
        },
        clearInput: function (e) {
            this.$('#searchInput').val('');
        },

        search: function () {
            var _this = this,
                keywords = this.$('#searchInput').val().trim();

            if(this.refreshing || !keywords || keywords == this.qryParams.keywords) return;

            this.qryParams.keywords = keywords;
            this.refreshing = true;

            if(this.refreshTimer) clearTimeout(this.refreshTimer);
            this.refreshTimer = setTimeout(function () {

                ProductsQryModel.qryFundPrdList(_this.qryParams)
                .done(function (res) {
                    var result = res.object || {},
                        fundList = result.fundList;

                    if(Array.isArray(fundList) && (0 < fundList.length)){
                        _this.collection.reset(fundList);
                    }

                }).always(function () {
                    _this.refreshing = false;
                });

            }, 300);
        }

    });
});
