/**
 * ex_huangzit 基金产品首页（2016-04-11）
 */
define(function(require, exports, module){
    var Tpl = _.template(require('text!../template/fundIndex.html'));

    module.exports = Layout.extend({
        className: 'selectFund',
        template: Tpl,
        events: {
            'tap [data-prdcode]' : 'toProductDetail', //跳转产品详情页
            'tap #tofilterFund' : 'tofilterFund',     //基金选择页
            'tap #qrySelectFunds' :'selectFunds'      // 跳转到精选基金列表
        },
        templateHelpers: {
            minAmount : function (minAmount) {
                if (minAmount >= 10000) {
                    return  utils.string.numberFormat(minAmount/10000, 2, '.', '')+'万';
                }else{
                    return  utils.string.numberFormat(minAmount, 2, '.', '')+'';
                }
            },
            evalMarkup : function (val) {
                var monthMarkup = Number(val);
                if( -1 === monthMarkup || !monthMarkup ){
                    monthMarkup = '---';
                }else{
                    monthMarkup = this.splitStr(((monthMarkup - 1)*100).toFixed(2)) + '<i class="f15 lh12">'+ this.splitStr(((monthMarkup - 1)*100).toFixed(2),1)+'%</i>';
                }
                return monthMarkup;
            },
            rateTpl : function (val) {
                var cls = 'c_f60';
                val = Number(val);
                if( -1 === val || !val ){
                    val = '---';
                }else{
                    if (val < 0) cls = 'c_3eb';
                    val = this.splitStr(((val - 1)*100).toFixed(2)) + '<i class="f15 lh12">'+ this.splitStr(((val - 1)*100).toFixed(2), 1) +'%</i>';
                }
                return '<p class="f28 '+cls+'">'+val+'</p>';
            },
            
            splitStr : function(val, index) {
                if(typeof val !== "string" && typeof val !== "number") return val;
                if(typeof val === "number") val = String(val);
                index = index == null ? 0 : index;
                var strArr = val.split('.'), sStr = strArr[1] ? ('.') + strArr[1] : '.00';
                strArr.splice(1, 1, sStr);
                return strArr[index];
            },
            
            rPrdAttrName : function (name) {
                return name && name.replace(/^\s*\u57FA\u91D1/, '');
            },
            /**
             * 1 股票型 2 混合型 3 基金债券型 4 基金货币型 5 基金保本型 6 基金QDII 7 基金其他
             */
            rPrdAttrCls : function (prdAttr) {
                var cls = {
                    '1' : 'Stock',
                    '2' : 'Mix',
                    '3' : 'Bond',
                    '4' : 'Monetary',
                    '5' : 'Guaranteed',
                    '6' : 'QDII',
                    '7' : 'Other'
                };

                prdAttr = (prdAttr + '').trim();
                return cls[prdAttr] || 'Other';
            }
        },

        initialize: function (options) {
            var collection;
            this.parentView = options.parent;

            collection = _.where(options.processedResult.productList, {type: 'fund'});

            this.collection = new Collection(collection);
        },

        toProductDetail: function (e) {
            var _this = this, model,
                el = $(e.currentTarget),
                prdCode = el.data('prdcode') + '';

            model = this.collection.findWhere({prdCode: prdCode});
            Marionette.triggerMethod.call(_this.parentView, 'toProductDetail', model, el);
        },

        tofilterFund: function (e) {
            e.stopPropagation();e.preventDefault();
            App.navigate('products/index/filterFund', true);
        },
        
        //精选基金列表
        selectFunds:function(){
            App.navigate('products/fund/selectFunds', true);
        }

    });
});