/**
 * ex-wuwenjun001 抢购专区首页视图
 */
define(function(require, exports, module) {
    var initPTRScroll = require('mod/common/widget/initPTRScroll');

    var panicBuyIndex = _.template(require('text!../template/panicBuyIndex.html'));
    var panicBuyView = require('./panicBuy');

    var ProductsQryModel = require('../model/ProductsQryModel');

    module.exports = Layout.extend({
        template: panicBuyIndex,
        ui: {
            PTRScroller: '#PTRScroller',
            productType: '#productsType .flex1'
        },
        regions: {
            productsRegion: '#productsRegion'
        },
        events: {
            
        },
        initialize: function(options) {
            
        },

        onShow: function() {
            this.initPTRScroll();
            this.scrollerLoadData();
        },
        
        //初始化上下拉
        initPTRScroll : function() {
            var self = this, gap = 40;
            if (IS_RUN_ON_DEVICE)
                gap = 15;
            initPTRScroll.call(this, {
                gap : gap,
                pullDownToRefresh : true,
                refreshContent : function(refresh) {
                    self._refresher = refresh;
                    self.scrollerLoadData();
                }
            });
        },
        
        _refresherPanic : function() {
            var self = this;
            clearTimeout(self._refreshTimer);
            self._refreshTimer = setTimeout(function() {
                if (self._refresher) {
                    self._refresher();
                } else {
                    self.scroller && self.scroller.refresh();
                }
            }, 500);
        },
        
        //刷新数据
        scrollerLoadData: function(data) {
            var self = this;
            var param = (data) ? data : "";
            ProductsQryModel.qryPanicBuyList(param).done(function(result) {
                self.panicBuyShow(result);
            }).fail(function(e) {
                utils.dialog.toast(e.message);
            });
        },
        
        /**
         * 抢购专区
         */
        panicBuyShow: function(processedResult) {
            var panicBuy = new panicBuyView({
                parent: this,
                processedResult: processedResult
            });

            this.productsRegion.show(panicBuy);
        }

    });
});
