define(function(require,exports,module){
	var RedPacketTpl   = require("text!../template/redPacket.html");
	var RedPacketModel = require("../model/redPacketModel");
	var RedPacketList  = require("text!../template/redPacketList.html");
	var PTRScroll      = require("component/PTRScroll");
	module.exports = ItemView.extend({
		template:RedPacketTpl,
		events:{
			"tap .flex1"    : "changeStatus"
		},

		initialize: function(){
			this.pageIndex = "1";//页数
			this.code = ""; //使用状态码
			this.totalPage="";//总页数
		},

		onShow: function(){
			this.code="0|1";
			this.getRedPacketList(this.pageIndex,this.code);
		},

		changeStatus: function(e){
			var curr = e.currentTarget;
			this.pageIndex = "1";
			if(!$(curr).hasClass("on")){
				this.code = $(curr).attr("index")
				$(".flex1").removeClass("on");
				$(curr).addClass("on");
				this.getRedPacketList(this.pageIndex,this.code);
			}
		},

		//获取我的红包数据
		getRedPacketList: function(pageIndex,code){
			var self = this;
			var formData = {
				redPacketCategoryCode : "",
				redPacketStatusCode   : code,
				pageIndex             : pageIndex,
				pageSize              : "10"
			};
			RedPacketModel.qryRedPacketListByPage({
				params:formData,
				callback:function(res){
					var obj=res.object;
					self.totalPage = Math.ceil(obj.totalNum/obj.pageSize);
					var html = _.template(RedPacketList,obj.redPacketList);
					if(formData.pageIndex >1){
						$(".redPacketShow").append(html);
					}else{
						$(".redPacketShow").html(html);
					}
					self._initPTRScroll();
				},
				errorCallback:function(res){
					utils.dialog.alert(res.message);
				}
			});
		},

		//初始化上下拉
		_initPTRScroll: function(){
			var self = this;
			if (this.scroller) {
				this.scroller.destroy();
				delete this.scroller;
			};

			var listHeight = $(window).height() - 40;
			var dom = this.$("#redPacketShow").css({"height":listHeight,"position":"relative"});

			//初始化iscroller
			this.scroller = new PTRScroll(dom[0],{
				"hScroll"           : false,
				"hideScrollbar"     : false,
				"vScrollbar"        : true,
				"pullDownToRefresh" : true,
				"pullUpToLoadMore"  : true
			});

			if (this.pageIndex >= this.totalPage) {
				this.scroller.disablePullUpToLoadMore();
			}else {
				this.scroller.enablePullUpToLoadMore();
			}

			//下拉刷新
			self.scroller.options.refreshContent = function(refresh){
				self.pageIndex = 1;
				self.getRedPacketList(self.pageIndex,self.code);
			};

			//上拉加载
			this.scroller.options.loadMoreContent = function(refresh){
				self.pageIndex++;
				self.getRedPacketList(self.pageIndex,self.code);
			};
		}
	});
});