define(function(require, exports, module) {

	var riskExamView = require("../view/queAnsItem");
	var riskExamModel = require("../model/riskExam");

	module.exports = Controller.extend({
		actions : {
			"riskExam(/:code)" : "riskExam",
			"riskExamResult(/:code)" : "riskExamResult"
		},

		riskExam : function(code) {
			this.code = code;
			//智能理财跳转页面判断
			utils.native.talkingDataTrackEvent("2.0-新产品推荐-重新测试问卷");
			if (App.storage.get("smartFinancialRisk") == "1") {
				App.header.reset({
					title : "智能风险偏好评测",
					leftButtonContent : '@back',
					leftButtonHandler : function() {
						if (App.storage.get("smartFinancialRiskFromIndex")) {
							App.storage.remove("smartFinancialRiskFromIndex");
							if (App.storage.get("smartFinancial/smartFinancial/fromPage")) {
								var prdType = App.storage.remove("smartFinancial/smartFinancial/fromPage");
								switch (prdType) {
									case 1:
										App.navigate('myProperty/myProperty/index', true);
										break;
									case 2:
										App.navigate('index/indexLogined/index', true);
										break;
									case 3:
										App.navigate('products/index/index/depositTake', true);
										break;
								}
							} else {
								App.navigate('index/indexLogined/index', true);
							}
						} else {
							App.back();
						}
					}
				});
			} else if (App.storage.get("addFundExpired")) {
				App.storage.remove("addFundExpired");
				App.header.reset({
					title : "智能风险偏好评测",
					leftButtonContent : '@back',
					leftButtonHandler : function() {
						App.navigate("myInvestment/commendProducts/addPurchaseRiskfund/3", true);
					}
				});
			} else if (App.storage.get("addGoldTreasureExpired")) {
				App.storage.remove("addGoldTreasureExpired");
				App.header.reset({
					title : "智能风险偏好评测",
					leftButtonContent : '@back',
					leftButtonHandler : function() {
						App.navigate("myInvestment/commendProducts/appGoldTreasureRisk/6", true);
					}
				});
			} else {
				App.header.reset({
					title : "智能风险偏好评测",
					leftButtonContent : '@back',
					leftButtonHandler : function() {
						if(code == 0) {
							App.navigate('products/index/index/selectFund', true);
						}else if(code == 7){
							App.navigate("fundStrong/fundStrongLogin/index", true);
						}else{
							App.navigate("products/index/index/finefinance", true);
						}
					}
				});
			}

			App.footer.reset({
				visible : false
			});

			var queList = riskExamModel.questionList();
			//code
			var view = new riskExamView({
				model : new Model(queList)
			});
			var sf = this;
			//获取用户选择的问题
			view.on('riskExamFinish', function(ansIdList) {
				App.storage.set('riskExam/ansIdList', ansIdList);
				if (App.storage.get("smartFinancialRisk")) {
					App.navigate('smartFinancial/smartFinancial/evaluateResult', true);
				} else {

					var code = sf.code;
					App.navigate('riskExam/riskExam/riskExamResult/' + code, true);

				}
			});

			App.container.show(view);
		},
		//风险测评结果页
		riskExamResult : function(code) {
			this.code = code;
			var sf = this;

			var ansIdList = App.storage.remove('riskExam/ansIdList');
			if (!ansIdList)
				return;
			var riskExamResultView = require("../view/riskExamResult");
			//首次风测  0是首次风测1不是首次风测
			riskExamModel.checkFirstRisk({
				url : "checkFirstRisk",
				callback : function(res){
					//0是首次风测1不是首次风测
					App.storage.set("firstRiskType",res.object.firRa);
					riskExamModel.riskExam({
						param : {
							"riskAnswer" : ansIdList.join(',')
						},
						success : function(response) {
							//code
							var view = new riskExamResultView({
								model : new Model(response)
							});
							//监听测评结果页事件
							view.on('onRiskExam', function() {
								var code = sf.code;
								if (code == "3") {
									App.storage.set("addFundExpired", true);
								} else if (code == "6") {
									App.storage.set("addGoldTreasureExpired", true);
								}
								App.navigate("riskExam/riskExam/riskExam/" + code, true);
							});
							/*
							 code 0为基金购买 1为定投 3基金追加 5为购买理财或快E赢
							 *
							 * */

							view.on('confirm', function() {
								var code = sf.code;
								if (code == "0") {

									var model = App.storage.get('myInvestment/commendProducts/curProObj');
									var productType = model.get('type');

									if (productType == "fund") {
										App.navigate('myInvestment/commendProducts/riskfund/0', true);
										return;
									} else {
										App.navigate('myInvestment/commendProducts/riskAbilityTestQry/5', true);
										return;
									}

								} else if (code == "1") {

									var model = App.storage.get('myInvestment/commendProducts/curProObj');
									var productType = model.get('type');
									var priskLevel = model.get('riskLevel');
									//产品级别
									var riskLevel = response.riskLevel;
									//用户级别
									if (productType == "fund") {
										if (riskLevel < priskLevel) {
											App.navigate('myInvestment/commendProducts/riskfund/1', true);
											return;
										} else {

											App.navigate('myInvestment/commendProducts/riskfund/1', true);

											return;
										}
									}
								} else if (code == "3") {

									// var model = App.storage.get('myInvestment/commendProducts/curProObj');
									// var productType = model.get('type');
									var addFundData = App.storage.get("addPurchaseFundsData");
									var addFundRiskLevel = App.storage.get("addPurchaseFundsData").detailDTO.riskLevel;
									var priskLevel = addFundRiskLevel;
									//产品级别
									var riskLevel = response.riskLevel;
									//用户级别

									if (riskLevel < priskLevel) {
										utils.dialog.alert("您的风险测评等级不够请点击重新测评");
										// App.navigate('myInvestment/commendProducts/addPurchaseRiskfund/3', true);
										return;
									} else {
										if (addFundData.detailDTO.prdAttr == "4") {
											App.navigate('fund/buy/addMonetary', true);
										} else {
											App.navigate('fund/buy/addNoMonetary', true);
										}
										return;
									}
								} else if (code == "4") {

									App.navigate('myInvestment/commendProducts/riskgoldtreasure/4', true);

								} else if (code == "6") {
									/**liujun add 15.9.25
									 *  6 黄金宝追加购买
									 */
									//黄金追加detail
									var addGoldData = App.storage.get("goldTreasureAddDetailData");
									var addGoldRiskLevel = addGoldData.riskLevel;
									var priskLevel = addGoldRiskLevel;
									//产品级别
									var riskLevel = response.riskLevel;
									//用户级别

									if (riskLevel < priskLevel) {
										utils.dialog.alert("您的风险测评等级不够请点击重新测评");
										return;
									} else {
										App.navigate('goldtreasure/addPurchase/addPurchase', true);
										return;
									}
								}else if(code == "7"){
									App.navigate('fundStrong/fundStrongLogin/buy', true);
								} else {

									App.navigate('myInvestment/commendProducts/riskAbilityTestQry/5', true);
									return;

								}

							});

							App.container.show(view);
						},
						error : function(response) {
							utils.dialog.alert(response.message);
						}
					});

				},
				errorCallback : function(res){
					utils.dialog.alert(res.message);
				}
			});

		}
	});
});
