﻿/**
 * @author zhoushiwen
 * @ date ${date}
 * @company 中国平安
 * @param 渲染风险测评回答
 */

define(function (require, exports, module) {
	var compsiteTemp = require("text!../template/queAnsItem.html");
	var PTRScroll = require('component/PTRScroll');
	var loadingLayer = require("app/renderDuringRequest/loadingLayer");
	var itemView = module.exports = ItemView
		.extend({
			template : _.template(compsiteTemp),
			templateHelpers : {},
			events : {
				"tap .js-answer-list" : "itemTap"
			},
			ui : {
				scroller : '#scrollContainer',
				questionListTable : '#questionListTable',
				test : '#test'

			},

			itemTap : function (event) {
				event.stopPropagation();

				var sf = this;
				//跳转到下一个问题
				console.log(sf.$(event.target).closest("div").attr("index"));

				console.log(sf.$(event.target).closest("tbody").attr("index"));

				this.$(event.target).closest("tbody").hide();
				var listid = sf.$(event.target).closest("div").attr("index");

				var pageid = sf.$(event.target).closest("tbody").attr("index")
				// 获取每次选择的问题将下标转换成对应的问题代码
				var queList = sf.options;
				var arr = new String(listid);
				var A = "A";
				var B = "B";
				var C = "C";
				var D = "D";
				var E = "E";

				switch (listid) {
				case "0":
					listid = A;
					sf.ansIdList.push(listid);
					break;
				case "1":
					listid = B;
					sf.ansIdList.push(listid);
					break;
				case "2":
					listid = C;
					sf.ansIdList.push(listid);
					break;
				case "3":
					listid = D;
					sf.ansIdList.push(listid);
					break;
				case "4":
					listid = E;
					sf.ansIdList.push(listid);
					break;
				}
				if (sf.pageIndex == 0) {
					sf.pageIndex++;
					//如果页数大于数组的长度将所有问题传给后台计算结果

					if (sf.pageIndex >= queList.model.attributes.list.length) {
						sf.trigger('riskExamFinish', sf.ansIdList);
						return;
					}
					var queObj = queList.model.attributes.list[sf.pageIndex];

					queObj.queIndex = sf.pageIndex;
					var firstQue = queList.model.attributes.list[queObj.queIndex];

					var text = firstQue.que;
					$("#js-que-text").text(text);
					sf.$(event.target).closest("tbody").next().show();

					sf.pageIndex++;

				} else {
					//如果页数大于数组的长度将所有问题传给后台计算结果
					if (sf.pageIndex >= queList.model.attributes.list.length) {
						sf.scroller.destroy();
						sf.trigger('riskExamFinish', sf.ansIdList);
						return;
					}
					var queObj = queList.model.attributes.list[sf.pageIndex];

					queObj.queIndex = sf.pageIndex;
					var firstQue = queList.model.attributes.list[queObj.queIndex];

					var text = firstQue.que;
					$("#js-que-text").text(text);

					//追加样式并判断当前页数样式
					sf.$(event.target).closest("div").find('#js-slct-icon')
					.addClass('iconB38');

					var pageclass = sf.pageIndex - 1;
					var num = sf.ui.questionListTable.find(
							"tbody[index=" + pageclass + "]").find(
							".iconB38").length;

					console.log("现在的个数" + num);
					//当对号样式大于或等于2时移除上一次选择的对号
					if (num >= 2) {

						sf.ui.questionListTable.find(
							"tbody[index=" + pageclass + "]").find(
							'.js-slct-icon').removeClass('iconB38');

						sf.$(event.target).closest("div").find(
							'#js-slct-icon').addClass('iconB38');
					}
					sf.$(event.target).closest("tbody").next().show();

					sf.pageIndex++;

				}

			},

			initialize : function () {
				this.ansIdList = [];
				this.load = new loadingLayer();

			},
			//加载页面时，写入标题
			onShow : function () {
				var thisView = this;
				var queList = this.options;
				var queIndex = 0
					this.pageIndex = -1;
				var firstQue = queList.model.attributes.list[queIndex];
				var text = firstQue.que;
				$("#js-que-text").text(text);
				setTimeout(function () {
					$('#list').addClass('dsn');
				}, 3000);
				this.initPTRScroll();
			},
      
			initPTRScroll : function () {
				if (this.scroller)
					return;
				this.pageIndex = 1;

				var self = this;
				var wHeight = $(window).height();
				var navHeight = App.header.$el.height()
					var listHeight = wHeight - navHeight;
				var dom = self.ui.scroller.css({
						"height" : listHeight,
						"position" : "relative"
					});

				//初始化iscroller
				this.scroller = new PTRScroll(dom[0], {
						"hScroll" : false,
						"checkDOMChanges" : true,
						"hideScrollbar" : false,
						"pullUpToLoadMore" : false
					});

				this.scroller.options.refreshContent = function (refresh) {
					self.load.show();
					setTimeout(function () {
						self.load.hide();
						self._refreshContent(refresh);
					}, 300);

				};
			},

			//刷新到上一问题

			_refreshContent : function (refresh) {
				refresh();
				var queList = this.options;

				var pageId = $("tbody").filter(':visible').index();
				this.pageIndex = parseInt(pageId);


				if (this.pageIndex == 0) {
					this.pageIndex = 0;
					utils.dialog.alert("已经是第一页了");
					this.pageIndex++;
					return;
				}

				this.pageIndex--;

				var firstQue = queList.model.attributes.list[this.pageIndex];
				var text = firstQue.que;

				$("#js-que-text").text(text);
				this.ui.questionListTable.find('tbody').hide().eq(
					this.pageIndex).show();


				var lastlist = this.ansIdList;
				lastlist.splice(pageId - 1);

				this.pageIndex++;

				refresh();


			}

		});
});
