
define(function (require, exports, module) {
	var itemTemp = require("text!../template/riskExam.html");
	var queAnsView = require("./queAnsItem");

	module.exports = Layout.extend({

			template : _.template(itemTemp),

			regions : {
				"queAnsRegion" : "#js-que-ans-region"
			},

			onShow : function () {
				var thisView = this;
				var queList = this.options.queList;
				var queIndex = this.pageIndex = 0;
				var firstQue = queList[queIndex];

				firstQue.queIndex = queIndex + 1;

				var model = new Model(firstQue);
				var collection = new Collection(firstQue.ans);

				var view = new queAnsView({
						model : model,
						collection : collection
					});

				var ansIdList = [];
				view.on('itemTap', function (ansId) {
					ansIdList.push(ansId);

					thisView.pageIndex++;

					if (thisView.pageIndex >= queList.length) {
						thisView.trigger('riskExamFinish', ansIdList);
						return;
					}
					var queObj = queList[thisView.pageIndex];

					queObj.queIndex = thisView.pageIndex + 1;

					this.model.set(queObj);
					this.collection.reset(queObj.ans);
				});

				view.on('_refreshContent', function (pageId) {
					thisView.pageIndex = parseInt(pageId);
					thisView.pageIndex--;
					if (thisView.pageIndex == -1) {
						thisView.pageIndex = 0;
						return;

					}

					//ansIdList.push(ansId);


					if (thisView.pageIndex >= queList.length) {
						thisView.trigger('riskExamFinish', ansIdList);
						return;
					}

					var queObj = queList[thisView.pageIndex];

					this.model.set(queObj);
					this.collection.reset(queObj.ans);
				});
				this.queAnsRegion.show(view);
			}

		});

});
