//2016-3-28 保证金 ex-wuyongsheng001
define(function(require, exports, module) {
    var ViewFinish = require('../view/margin/finish');
    var ViewIndex = require('../view/margin/index');
    var ViewDetail = require('../view/margin/detail');

    var ModelMargin = require('../model/margin');
    var ViewActivityItem = require('../view/margin/activityItem');
    
    module.exports = Controller.extend({
        actions: {
            'index': 'index',
            'indexBus': 'indexBus',
            'detail': 'detail',
            'finish': 'finish',
            'activityItem': '_activityItem'
        },

        finish: function () {
            this._resetUI({ title: '申请结果' ,
                leftButtonHandler: function () {
                    App.navigate('search/margin/index', {trigger: true, replace: true});
                }
            });
            var model = App.storage.remove('search/margin/finish');
            if (!model || typeof model !== 'object') return App.navigate('search/margin/index', {trigger: true, replace: true});

            App.container.show(new ViewFinish({model: new Model(model)}));
        },

        //从我的订单进入详情
        detail: function() {
            var formBussWays = App.storage.get('formBussWays');//进入详情的方式：1.从‘我的订单’， 2.‘支持商家’
            this._resetUI({ 
                title: '订单详情',
                leftButtonHandler: function () {
                    if(formBussWays === '1'){
                        App.navigate('search/margin/index', {trigger: true, replace: true});
                    }else{
                        App.navigate('search/margin/indexBus', {trigger: true, replace: true});
                    }
                }
             });    
            
            if(formBussWays === '1'){
                var marginOrderNo = App.storage.get('marginOrderNo');
                if (!marginOrderNo) return;
                ModelMargin.qryMarginsOrderDetails({
                    data: { orderNo: marginOrderNo }
                }).done(function(res) {
                    var orderValidDate = new Date();

                    res = (typeof res.orderDetail === 'object') && res.orderDetail || {};
                    if (res.orderValidDate) {
                        orderValidDate = utils.date.formatTime(res.orderValidDate);
                    }
                    res.isAgree = true;
                    res.prdWay = 'orderWay';
                    App.container.show(new ViewDetail({model: new Model(res)}));
                }).fail(function(err) {
                    utils.dialog.toast(err.message || '订单详情接口异常！');
                });
            }else if(formBussWays === '2'){
                var activityItem = App.storage.get('bussWays::activityItem');
                activityItem.isAgree = true;
                App.container.show(new ViewDetail({model: new Model(activityItem)}));
            }
        },

        index: function() {
            this._resetUI({leftButtonHandler: function () {
                App.navigate('search/search/index', {trigger: true, replace: true});
            }});

            ModelMargin.qryMarginsOrderList()
                .done(function(res) {
                    if (!res.orderLists.length) {
                        App.navigate('search/margin/indexBus', {trigger: true, replace: true});
                        return;
                    }

                    App.container.show(new ViewIndex(res));
                }).fail(function(err) {
                    utils.dialog.toast(err.message || '订单接口异常！');
                });
        },

        indexBus: function() {
            this._resetUI({leftButtonHandler: function () {
                App.navigate('search/search/index', {trigger: true, replace: true});
            }});

            ModelMargin.qryMarginsCommercialList()
                .done(function(re) {
                    var result = {
                        commercialList: re && re.commercialList || []
                    };

                    App.container.show(new ViewIndex(result));
                }).fail(function(err) {
                    utils.dialog.toast(err.message || '商家接口异常！');
                });
        },
        
        //活动详情
        _activityItem:function () {
            this._resetUI({leftButtonHandler: function () { title: '产品详情',
                App.navigate('search/margin/indexBus', {trigger: true, replace: true});
            }});
            var activityItem = App.storage.get('bussWays::activityItem');
            App.container.show(new ViewActivityItem({model:new Model(activityItem)}));
        },

        _resetUI: function(options) {
            options || (options = {});
            var opts = {
                footFlag: false,
                title: '橙子保证金',
                leftButtonContent: '@back',
                rightButtonContent: null,
                rightButtonHandler: null
            };
            opts = _.extend(opts, options);

            App.header.reset(opts);
            App.footer.reset({ visible: opts.footFlag });
        }
    });
});
