/**
 * author:EX-yangjingpeng001
 *
 * 功能描述：话费充值
 */

define(function (require, exports, module) {
    var InputView = require("../view/prepaidRecharge/input");
    var FinishView = require("../view/prepaidRecharge/finish");
    var RecordView = require("../view/prepaidRecharge/record");
    var RecordDetailView = require("../view/prepaidRecharge/recordDetail");
    var accountModel = require("mod/common/model/accountModel");
    var stockModel = require("mod/stock/model/stockModel");
    var AccessControlView = require("mod/stock/view/accessControl");
    var Model = require("../model/prepaidRecharge");
    var PrepaidRechargeCon = module.exports = Controller.extend({
        actions: {
            "input": "input",
            "finish": "finish",
            "record": "record",
            "recordDetail": "recordDetail"
        },
        input: function () {
            App.header.reset({
                title: "手机充值",
                leftButtonContent: "@back",
                leftButtonHandler: function () {
                    App.navigate("search/search/index", true);
                },
                rightButtonContent: "充值记录",
                rightButtonHandler: function () {
                    App.navigate("search/prepaidRecharge/record", true);
                }
            });
            App.footer.reset({
                visible: false
            });


            // 1-个人网银高级用户
            // 2-身份证
            // 3-借记卡
            // 4-信用卡
            // 5- CFE迁移过来的数据， 在CFE时验证方式为同名户验证。
            // 6-历史数据修改， 迁移时存在一部分用户，他们的卡在卡管， FCR都已经激活，但在CFE为未激活状态。针对这类诡异数据，
            // 无法给出相对应的激活方式，所以修改这些历史数据时激活方式置为6
            // 7- 汽融
            // 8-人脸识别
            // 9-柜面核身
            stockModel.userVerifyMode({
                "url": "userVerifyMode",
                "data": {},
                "callback": function (res) {
                    if (res.object.verifyMode == 5) {
                        App.container.show(new AccessControlView());
                    } else {
                        if (App.storage.get("prepaidRecharge/rechargeRate")) {
                            var currentView = new InputView({
                                model: new Model(App.storage.remove("prepaidRecharge/rechargeRate"))
                            });
                            currentView.on("submit", function (formData) {
                                utils.native.talkingDataTrackEvent("2.0发现-话费充值-确定");
                                Model.recharge(formData).done(function () {
                                    currentView.submitFlag = false;
                                    App.navigate("search/prepaidRecharge/finish", true);
                                }).fail(function (error) {
                                    utils.native.talkingDataTrackEvent("2.0发现-话费充值-充值失败");
                                    currentView.submitFlag = false;
                                    utils.dialog.toast(error.message);
                                });
                            });
                            App.container.show(currentView);

                        } else {
                            var promise = $.when(Model.qryRechargeRate());
                            promise.done(function (arg1) {
                                var arg1 = arg1.object;
                                var currentView = new InputView({
                                    model: new Model(arg1)
                                });
                                currentView.on("submit", function (formData) {
                                    utils.native.talkingDataTrackEvent("2.0发现-话费充值-确定");
                                    Model.recharge(formData).done(function () {
                                        currentView.submitFlag = false;
                                        App.navigate("search/prepaidRecharge/finish", true);
                                    }).fail(function (error) {
                                        utils.native.talkingDataTrackEvent("2.0发现-话费充值-充值失败");
                                        currentView.submitFlag = false;
                                        utils.dialog.toast(error.message);
                                    });
                                });
                                App.container.show(currentView);
                            });
                            promise.fail(function (error) {
                                utils.dialog.toast(error.message);
                            });
                        }

                    }
                },
                "errorCallback": function (res) {
                    utils.dialog.alert(res.message);
                }
            });
        },

        finish: function () {
            utils.native.talkingDataTrackEvent("2.0发现-话费充值-充值成功");
            App.header.reset({
                title: "手机充值",
                leftButtonContent: "@back",
                leftButtonHandler: function () {
                    App.navigate("search/search/index", true);
                }
            });
            App.footer.reset({
                visible: false
            });

            App.container.show(new FinishView());
        },

        record: function () {
            App.header.reset({
                title: "充值记录",
                leftButtonContent: "@back"
            });
            App.footer.reset({
                visible: false
            });
            var currentView = new RecordView({
                model: new Model()
            });
            currentView.on("submit", function (option) {
                Model.qryRechargeList({
                    "pageIndex": option.pageIndex
                }).done(function (response) {
                    option.callback && option.callback(response.object);
                }).fail(function (error) {
                    utils.dialog.toast(error.message);
                });
            });
            App.container.show(currentView);

        },

        recordDetail: function () {
            App.header.reset({
                title: "充值记录",
                leftButtonContent: "@back"
            });
            App.footer.reset({
                visible: false
            });
            var data = App.storage.remove("prepaidRecharge/recordList");
            App.container.show(new RecordDetailView({
                model: new Model(data)
            }));
        }
    });
});
