define(function (require, exports, module) {
    var indexView = require("../view/wonderfulConsume/index");
    var ChooseMonthView = require("../view/wonderfulConsume/intelligentBill/chooseMonthView");
    var ConsumRankView = require("../view/wonderfulConsume/intelligentBill/consumRankView");
    var ConsumWayView = require("../view/wonderfulConsume/intelligentBill/consumWayView");
    var creditCardView = require("../view/wonderfulConsume/consumeStory/creditCard");
    var editConsumeDetailView = require("../view/wonderfulConsume/consumeStory/editConsumeDetailView");
    var bigImgView = require("../view/wonderfulConsume/consumeStory/bigImg");
    var consumeModel = require("../model/wonderfulConsume");
    var validateCardView = require("../view/wonderfulConsume/validateCard");
    var Index = module.exports = Controller.extend({
        actions: {
            "index": "index",
            "index/:code": "index",
            "chooseMonth": "chooseMonth",
            "consumRank": "consumRank",
            "consumWay": "consumWay",
            "editConsumeDetailPage": "editConsumeDetailPage", //消费详情编辑
            "bigImg/:code": "bigImg",//大图片
            "consumeDetailPage": "consumeDetailPage", //消费详情编辑
            "selectConsumeTypePage/:code": "selectConsumeTypePage", //选择消费类型
            "selectCreditCard/:code": "selectCreditCard", //选择绑定的信用卡
            "authetication": "authetication"  //未身份验证 页面提示
        },
        index: function (code) {
            App.request("timestamp", {type: "GET"}).done(function (arg) {
                //arg.object   2015/07/07 15:33:52
                //arg.object = "2016/01/07 15:33:52";
                App.storage.set("wonderCurrtTime", arg.object);
            });

            var accountSta = accountInfoStatus.getAccountInfoLossStatus("search/search/index");

            if (!accountSta) return;

            accountSta = accountInfoStatus.getAccountInfoCardStateStatus("search/search/index");

            if (!accountSta) return;

            App.header.reset({
                title: "精彩消费",
                leftButtonContent: "@back",
                leftButtonHandler: function () {
                    //App.back();
                    App.navigate("search/search/index", true);
                }
            });
            App.footer.reset({"visible": false});
            App.container.show(new indexView());
        },
        chooseMonth: function () {
            App.header.reset({
                title: "选择年份",
                leftButtonContent: "@back",
                leftButtonHandler: function () {
                    App.navigate("search/wonderfulConsume/index", true);
                }
            });
            App.footer.reset({"visible": false});
            var
                timeList = this._selTimeDataList(),
                monthList = [];
            for (var i = 0, tLLength = timeList.length; i < tLLength; i++) {
//                monthList.push(timeList[i].key);
                monthList.push(timeList[i]);
            }
            var tempData = new Model({model: {
                monthList: monthList
            }});
            App.container.show(new ChooseMonthView({model: tempData}));
        },
        consumRank: function () {
            utils.native.talkingDataTrackEvent("2.0精彩消费-智能账单-消费排名");
            App.header.reset({
                title: "精彩排名",
                leftButtonContent: "@back",
                leftButtonHandler: function () {
//                    App.back();
                    App.navigate("search/wonderfulConsume/index", true);
                }
            });
            App.footer.reset({"visible": false});
            //从缓存获取数据
            var data = App.storage.get("IntelligentBillData");
            var tempData = new Model({model: {
                custCityName: data.custCityName,
                consumRatioTotal: data.consumRatioTotal,
                consumRatioCount: data.consumRatioCount,
                consumRatioAvg: data.consumRatioAvg,
                consumRatioSimilar: data.consumRatioSimilar
            }});
            App.container.show(new ConsumRankView({model: tempData}));
        },
        consumWay: function () {
            utils.native.talkingDataTrackEvent("2.0精彩消费-智能账单-消费去向");
            App.header.reset({
                title: "消费去向",
                leftButtonContent: "@back",
                leftButtonHandler: function () {
                    App.navigate("search/wonderfulConsume/index", true);
                }
            });
            App.footer.reset({"visible": false});
            //从缓存获取数据
            var data = App.storage.get("IntelligentBillData");
            var tempData = new Model({model: {
                consumAmtTotal: data.consumAmtTotal,
                consumOwnerList: data.consumOwnerList
            }});
            console.info(JSON.stringify(tempData));
            App.container.show(new ConsumWayView({model: tempData}));
        },
        /*身份验证*/
        authetication: function () {
            App.header.reset({
                title: "未身份验证",
                leftButtonContent: "@back",
                leftButtonHandler: function () {
                    App.navigate("search/search/index", true);
                }
            });
            App.footer.reset({"visible": false});
            App.container.show(new validateCardView());
        },
        //选择消费类型
        selectConsumeTypePage: function (code) {
            App.header.reset({
                title: "选择消费类型",
                leftButtonContent: "@back",
                leftButtonHandler: function () {
                    App.storage.set("consumetype/toindex", "type");
                    App.navigate("search/wonderfulConsume/editConsumeDetailPage", true);
                }
            });
            App.footer.reset({"visible": false});
            var consumeTypeView = require("../view/wonderfulConsume/consumeStory/consumeTypeView");
            consumeModel.queryConsumeType({
                "data": {},
                "callback": function (response) {
                    var consumeTypes = response.object.consumeTypeList;
                    App.container.show(new consumeTypeView({
                        "model": new Model({"consumeTypeCode": code, 'consumeTypes': consumeTypes})
                    }));
                },
                "errorCallback": function (response) {
                    utils.dialog.alert(response.message);
                }
            });
        },
        selectCreditCard: function (query) {
            App.container.show(new creditCardView({"model": new Model({"crediTcardNum": query})}));
        },
        //没有编辑过消费项目 或者选择消费类型后 到这里 编辑消费详情
        editConsumeDetailPage: function (query) {
            var consumeDetail = App.storage.get("consume/notActiveCtrItem");
            //获取当前路径url window.location.search  判断是从哪里跳转进来的
            var url = window.location.href;
            if (url.indexOf("code") > 0) {        //选择消费类型后
                consumeDetail.activityName = App.storage.remove("editStoryContent") || consumeDetail.activityName;
            }
            App.header.reset({
                title: "编辑故事",
                leftButtonHandler: function () {
                    App.navigate("search/wonderfulConsume/index", true);
                    App.storage.remove("consume/notActiveCtrItem");
                    App.storage.remove("consumetype/toindex");
                    App.storage.remove("consumeimg/add");
                },
                leftButtonContent: "@back",
                rightButtonContent: ""
            });
            if (query) {
                consumeDetail.consumTypeCode = query.code;
                consumeDetail.consumTypeName = decodeURIComponent(query.type);
            }
            App.container.show(new editConsumeDetailView({"model": new Model(consumeDetail)}));
            var submitFlag = "0";
            App.container.currentView.on("form:submit", function (formData) {
                if (submitFlag == "1") {
                    return;
                }
                submitFlag = "1";
                // formData.activityName = encodeURIComponent(formData.activityName);
//                alert(formData.addPhotoUrl);
                consumeModel.editStory({
                    "data": formData,
                    "callback": function (resp) {
                        submitFlag = "0";
                        utils.dialog.alert("保存成功",function(){
                            App.navigate("search/wonderfulConsume/index", true);
                        });
                    },
                    "errorCallback": function (resp) {
                        submitFlag = "0";
                        utils.dialog.alert(resp.message);
                    }
                })
            });
        },
        //编辑过消费项目
        consumeDetailPage: function (query) {
            App.header.reset({
                title: "消费故事",
                leftButtonHandler: function () {
                    App.storage.remove("consume/activeCtrItem");
                    App.navigate("search/wonderfulConsume/index", true);
                },
                leftButtonContent: "@back",
                rightButtonContent: ""
            });
            var ctrItem = App.storage.get("consume/activeCtrItem");
            var detailsView = require("../view/wonderfulConsume/consumeStory/storyListDetail");
            App.container.show(new detailsView({"model": new Model(ctrItem)}));
        },
        bigImg: function (code) {
            App.header.reset({
                title: "消费故事图片",
                leftButtonContent: "@back",
                leftButtonHandler: function () {
                    App.navigate("search/wonderfulConsume/editConsumeDetailPage", true);
                }
            });
            App.footer.reset({"visible": false});
            App.container.show(new bigImgView({"model": new Model({"indexCode": code})}));
        },
        /*智能账单里时间列表*/
        _selTimeDataList: function () {
            var monthsList = App.storage.get("monthsList");
            if (monthsList) {
                return monthsList;
            } else {
                //var sysTime = "2015/01/22 11:39:14";
                var sysTime = App.storage.get("wonderCurrtTime");
                var year = sysTime.substring(0, 4),
                    month = sysTime.substring(5, 7),
                    yearNum = Number(year),
                    monthNum = Number(month);
                var listArray = [];
                if (monthNum === 1) {
                    while (yearNum > 2013) {
                        yearNum = yearNum - 1;
                        if (yearNum !== 2013) {
                            listArray.push({
                                key: yearNum + "年"
                            });
                        }
                    }
                } else {
                    monthNum = monthNum - 1; //2月
                    while (yearNum > 2013) {
                        while (monthNum > 0) {
                            if (monthNum > 9) {
                                listArray.push({
                                    key: yearNum + "年" + monthNum + "月"
                                });
                            } else {
                                listArray.push({
                                    key: yearNum + "年0" + monthNum + "月"
                                });
                            }
                            monthNum = monthNum - 1;
                        }
                        yearNum = yearNum - 1;
                        if (yearNum !== 2013) {
                            listArray.push({
                                key: yearNum + "年"
                            });
                        }
                    }
                }
                listArray[0].checked = true;
                App.storage.set("monthsList", listArray);
                return listArray;
            }
        }
    });
});