define(function(require, exports, module) {

    function _query (url, opt) {
        if (!url) throw new Error('pls input request url.');

        (typeof opt === 'object') || (opt = {});
        opt = _.extend({
            silent: false,
            data: {}
        }, opt);

        return App.request(url, opt).pipe(function (result) {
            result.object || (result.object = {});
            return result.object;
        });
    }

    module.exports = Model.extend({}, {
        qryMarginsOrderList: function (options) {
            return _query('qryMarginsOrderList', options).pipe(function (obj) {
                Array.isArray(obj.orderLists) || (obj.orderLists = []);
                if (obj.orderLists.length) {
                    obj.orderLists = _.filter(obj.orderLists, function (item) {
                        var end = item.orderValidDate && (utils.date.formatTime(item.orderValidDate)) || new Date();
                        var now = item.sysDate && (utils.date.formatTime(item.sysDate)) || new Date();
                        if ('2' !== item.orderState) {
                            if ('1' === item.orderState) {
                                if (1000 < (end - now)) {
                                    return true;
                                } else {
                                    return false;
                                }
                            }
                            return true;
                        }
                        return false;
                    });
                }

                return obj;
            });
        },
        qryMarginsOrderDetails: function (options) {
            return _query('qryMarginsOrderDetails', options);
        },
        qryMarginsCommercialList: function (options) {
            return _query('qryMarginsCommercialList', options);
        },
        qryBalance: function (options) {
            (typeof options === 'object') || (options = {});
            options.type = 'GET';
            return _query('currentToFixedTransferBalance', options);
        },
        confirmMarginsOrder: function (options) {
            return _query('confirmMarginsOrder', options);
        },
        createMarginsOrder: function (options) {
            return _query('createMarginsOrder', options);
        }
    });
});
