/**
 *精彩消费Model
 */
define(function (require, exports, module) {
    var cosumeModel = module.exports = Model.extend({}, {

        // 获取关联的信用卡列表
        relatingCreditCard: function (options) {
            // this._callInterface("relatingCreditCard", options);
            return App.request("creditCardQuery", {});
        },

        /*
         * 查询我的消费数据（按日期分组后的数据）
         */
        queryMyConsumeList: function (options) {
            //this._callInterface("queryMyConsumeList", options);
            App.request("queryMyConsumeList", {
                silent: options.param.isLoadingBlackTipShow,       //请求中，不需要显示 黑色"加载中.."字样 true不显示
                data: options.param,
                success: function (res) {
                    options.callback && options.callback(res);
                },
                error: function (error) {
                    utils.dialog.alert(error.message || error);
                },
                complete: function () {
                    options.complete && options.complete();
                }
            });
        },
        /*
         * 查询我的消费数据
         */
        queryConsumeList: function (options) {
            this._callInterface("consumeList", options);
        },

        /*
         * 查询消费类型
         */
        queryConsumeType: function (options) {
            this._callInterface("consumeType", options);
        },

        /*智能账单接口*/
        qryAptitudeReckoning: function (options) {
            this._callInterface("qryAptitudeReckoning", options);
        },
        /*
         * 调用接口的公共方法
         * 
         * 入参：
         *      url：接口路径
         *      options : 请求参数
         *          data：接口入参
         *          callback：接口成功回调函数
         *          errorCallback：接口错误回调函数
         * 
         * 返回：无
         */
        _callInterface: function (url, options) {
            App.request(url, {
                data: options.data,
                success: function (res) {
                    options.callback && options.callback(res);
                },
                error: function (res) {
                    options.errorCallback && options.errorCallback(res);
                }
            });
        },

        /**
         *消费编辑保存
         * @param {Object} options
         */
        editStory: function (options) {
            this._callInterface("editStory", options);
        },

        /**
         *查看消费编辑详情
         * @param {Object} options
         */
        qryMyConsumeInfo: function (options) {
            this._callInterface("qryMyConsumeInfo", options);
        }

    });
});

