define(function(require, exports, module) {
	var IndexTpl          = require("text!../template/index.html");
	var accountInfoStatus = require("../../common/accountInfoStatus/accountInfoStatus");
	var indexModel        = require("../model/index");
	var bindCardTip       = require('component/bindCardTip');
	var faceRecognition   = require("component/faceRecognition");
    var Iscroll = require('component/PTRScroll');

	var IndexView = module.exports = ItemView.extend({
		template : _.template(IndexTpl),

		events : {
			"tap #applyLoan" : "applyLoan",//橙E贷
			"tap #carArea" : "toCarArea",//汽车专区
			"tap #toStock"          : "toStock", //三方存管
			"tap #wonderfulConsume" : "toWonderful", //精彩消费
			"tap #orangeGame"       : "orangeGame", //彩票游戏
			"tap #insure"           : "insure", //保险
			"tap #dream"            : "dream", //梦想
			"tap #margin"           : "toMargin", //保证金
			"tap #jxActivity"       : "toJxActivityPage", //精选活动
			"tap #prepaidRecharge"  : "toPrepaidRechargePage", //话费充值
			"tap #paLottery"        : "paLottery", //平安彩票
			"tap #applyByYouCards"  : "applyByYouCards", //信用卡
			"tap #creditCardBill"   :"creditCardBill", //信用卡还款
			"tap #indianaJones"     : "indianaJones", //夺宝奇兵
			"tap #carAppraisement"		: "carAppraisement", //车估值
			"tap #houseAppraisement"	: "houseAppraisement" //房估值
		},

		onShow: function(){
            this.initIsroll();
		},

		onRender : function() {
			var self = this;
//            夺宝奇兵（新手专享）开关
            self.indianaJonesSwitch();
//            橙e贷开关
            self.loansDisplaySwitch();
			utils.native.versionInformation(function(data) {
				var version = data.version;
                if (version.replace(/\./g, "") * 1 < 213) {
                    self.$("#houseAppraisement").remove();
                    self.$("#carAppraisement").remove();
                }
				utils.native.readConfigAsXMLDoc().then(function(xml) {
					var tempXml = $(xml).find("MenuControl menu");
					self.menuMap = [];
					tempXml.map(function(idx, ele) {
						var index = $(ele).attr("index");
						var isOpen = $(ele).attr("isOpen");
						var hiddenVersion = $(ele).attr("hiddenVersion");
						self.menuMap.push({
							"index" : index,
							"isOpen" : isOpen,
							"hiddenVersion" : hiddenVersion
						});

						if (index == "1000") {
							if (version == hiddenVersion) {
								self.$("#jxActivity").remove();
							}
						}

						if (index == "1001") {
							if (version == hiddenVersion) {
								self.$("#orangeGame").remove();
							}
						}

						if (index == "1002") {
							if (version == hiddenVersion) {
								self.$("#dream").remove();
							}
						}

						if (index == "1003") {
							if (version == hiddenVersion) {
								self.$("#paLottery").remove();
							}
						}
					});
				});
			});
		},

        initIsroll : function(){
            var el = this.$('#wrapper');
            var wHeight = App.locStorage.get("webviewHeight") || $(window).outerHeight(true);
            el.css({height: wHeight,position:"relative"});
            var myScroll = new Iscroll("wrapper", {
                hScroll: false,
                hideScrollbar : true,
                'pullDownToRefresh': false,
                'pullUpToLoadMore': false
            });
        },

		/**
		 * 橙E贷
		 */
		applyLoan : function(){
			utils.native.talkingDataTrackEvent("2.0-我-橙e贷");
			var self = this;
			indexModel.checkApplyLoan({
				callback:function(res){
					var obj = res.object;
					App.storage.set("checkApplyLoan",obj);
					if(!obj.availAmt && !obj.usedLimit){
						if(obj.applyFlag=="0"||obj.applyFlag=="4"){
							App.navigate("loan/applyLoan/applyWait",true);
						}else if(obj.applyFlag=="2"){
							App.navigate("loan/applyLoan/applyFail",true);
						}else if(obj.applyFlag=="1"){
							if(obj.isSelf== "1"){
								App.navigate("loan/loan/index",true);
							}else{
								utils.dialog.confirm("为了您的资金安全，需要您先通过人脸识别。", function (ok) {
									if(ok){
										self.faceRecognite();
									}
								});
							}
						}else{
							if(obj.staffFlag == "1"){
								App.navigate("loan/applyLoan/selfBank",true);
							}else{
								App.navigate("loan/applyLoan/index",true);
							}
						}
					}else{
						var getDate = utils.date.formatTime(obj.updatedDate).format("yyyy.MM.dd");
						var toDate = utils.date.diffDateAdd(getDate,"180","d").format("yyyy.MM.dd");
						var theDay = utils.date.formatTime(App.storage.get("Login_SysTime")).format("yyyy.MM.dd");
						if(obj.isFirstDraw == "0" && (utils.date.compareDate(toDate,theDay)=="-1")){
							App.navigate("loan/applyLoan/index",true);
						}else{
							App.navigate("loan/loan/index",true);
						}
					}
				},
				errorCallback:function(res){
					utils.dialog.alert(res.message);
				}
			});
		},

		//人脸识别
		faceRecognite:function(){
			var self = this;
			faceRecognition(function(err, isSamePerson){
				if(err){
					utils.dialog.confirm('抱歉，您的验证失败，可以尝试通过以下方式：保持光线充足与均匀、确保人脸出现在方框内、避免戴帽子或眼睛', function(ok){
						if(ok){
							self.faceRecognition();
							return;
						}
					});
				}
				//是否是同一个人：true为同一人，false为不为同一人
				if(isSamePerson){
					loanModel.checkApplyLoan({
						callback:function(res){
							var obj = res.object;
							App.storage.set("checkApplyLoan",obj);
							if(obj.applyFlag == "0" || obj.applyFlag=="4"){
								App.navigate('loan/applyLoan/applyWait', true);
							}else if(obj.applyFlag == "1"){
								App.navigate("loan/loan/index",true);
							}else if(obj.applyFlag == "2"){
								App.navigate("loan/applyLoan/applyFail",true);
							}
						},
						errorCallback:function(res){
							utils.dialog.alert(res.message);
						}
					});
				}else{
					utils.dialog.alert('抱歉，您的验证失败，可以尝试通过以下方式：保持光线充足与均匀、确保人脸出现在方框内、避免戴帽子或眼睛');
					self.faceRecognition();
				}
			},{sceneNum: 'L003'});
		},

		/**
		 * 汽车专区
		 */
		toCarArea : function(){
			utils.dialog.alert("此功能暂未开放，敬请期待");
		},

		//2016-3-28 保证金
		toMargin: function () {
			utils.native.talkingDataTrackEvent("2.0发现-保证金");
			App.navigate('search/margin/index', true);
		},

		toStock : function() {
			utils.native.talkingDataTrackEvent("2.0发现-三方存款");
			var userInfo = App.storage.get('UserInfo').toJSON() || {};
			//1.低门槛登陆需要提示弹窗
			if ((userInfo.isTelephoneLogin && userInfo.bindCardFlag === '1') || bindCardTip.newBindFlag()) {
				bindCardTip.activeSwitch({
					susFlag : true,
					back : false
				});
				return;
			}
			App.navigate('stock/stock/index', true);
		},

		toWonderful : function() {
			//var accountSta = accountInfoStatus.getAccountInfoStatus(false,"search/search/index");
			//if(accountSta){
			utils.native.talkingDataTrackEvent("2.0发现-精彩消费");
			App.navigate('search/wonderfulConsume/index', true);
			// }
		},

		/**
		 *author:EX-ZHANGAOJIAO001
		 *
		 * 功能描述:平安娱乐免登
		 */
		orangeGame : function() {
			utils.native.talkingDataTrackEvent("2.0发现-橙子娱乐");
			if (!App.storage.get("isUserLoggedIn")) {
				App.navigate(config.base.login_url + "?returnURL=" + "search/search/index", true);
				return;
			}
			//1-平安彩票入口   0-平安娱乐入口
			var data = {
				"flag" : 0
			};
			//1.低门槛登陆需要提示弹窗
			var userInfo = App.storage.get("UserInfo").toJSON();
			if (userInfo.isTelephoneLogin) {
				bindCardTip.activeSwitch({
					susFlag : true,
					back : false
				});
				return;
			}
			indexModel.passwordLottery(data).done(_.bind(function(response) {
				var param = {
					"client_id" : response.object.clientId,
					"redirect_uri" : response.object.redirectUrl,
					"response_Type" : response.object.responseType,
					"sign" : response.object.sign,
					"clientNo" : response.object.clientNo,
					"timestamp" : response.object.timestamp,
					"media_source" : response.object.mediaSource
				};
				utils.window.open({
					title : '彩票游戏',
					url   : config.urls.get("toaLoginAuth") + "?" + $.param(param)
				})
			}, this)).fail(function(error) {
				utils.dialog.alert(error.message);
			});
		},

		insure : function() {
			utils.native.talkingDataTrackEvent("2.0发现-保险");
			var option = {
				title : '保险',
				url : config.urls.get("terms_of_search_insure_product")
			};
			utils.window.open(option);
		},

		//发现页梦想引导判断，点击一次不再进入引导
		dream : function() {
			utils.native.talkingDataTrackEvent("2.0发现-梦想账户");
			if (!App.storage.get("isUserLoggedIn")) {
				App.navigate(config.base.login_url + "?returnURL=" + "search/search/index", true);
				return;
			}
			var promise = indexModel.qryDreamState();
			promise.done(_.bind(function(arg1) {
				var arg1 = arg1.object.outExists;
				//0-不存在，1-存在
				if (arg1 == 1) {
					App.navigate('dream/dream/dreamWall', true);
				} else {
					App.footer.reset({
						"visible" : false
					});
					utils.native.dreamIndex();
				}
			}, this));
			promise.fail(function(err) {
				utils.dialog.toast(err.message);
			});
		},

		/**
		 *精选活动那个
		 */
		toJxActivityPage : function() {
			utils.native.talkingDataTrackEvent("2.0发现-精选活动");
			if (!App.storage.get("isUserLoggedIn")) {
				App.navigate(config.base.login_url + "?returnURL=" + "search/search/index", true);
				return;
			}

			//1.低门槛登陆需要提示弹窗
			if (bindCardTip.newBindFlag()) {
				bindCardTip.activeSwitch({
					susFlag : true,
					back : false
				});
				return;
			}

			var accountSta = accountInfoStatus.getAccountInfoLossStatus("search/search/index")

			if (!accountSta)
				return;

			accountSta = accountInfoStatus.getAccountInfoCardStateStatus("search/search/index");

			if (!accountSta)
				return;

			indexModel.passwordOperate().done(_.bind(function(response) {
				var platform = "WEB";
				if (IS_RUN_ON_ANDROID) {
					platform = "ANDROID";
				} else if (IS_RUN_ON_IDEVICE) {
					platform = "IOS"
				}
				var param = {
					"client_id" : response.object.clientId,
					"redirect_uri" : response.object.redirectUrl,
					"response_type" : response.object.responseType,
					"sign" : response.object.sign,
					"clientNo" : response.object.clientNo,
					"timestamp" : response.object.timestamp,
					"media_source" : response.object.mediaSource,
					"platform" : platform
				};
				var activityUrl = config.urls.get("toaLoginAuth") + "?" + $.param(param);
				utils.window.open({
					"title" : "精选活动",
					"url" : activityUrl
				});
			}, this)).fail(function(error) {
				utils.dialog.alert(error.message);
			});
		},

		/**
		 *author:EX-yangjingpeng
		 *
		 * 功能描述:话费充值
		 */
		toPrepaidRechargePage : function() {
			utils.native.talkingDataTrackEvent("2.0发现-话费充值");
			if (!App.storage.get("isUserLoggedIn")) {
				App.navigate(config.base.login_url + "?returnURL=" + "search/search/index", true);
				return;
			}

			//1.低门槛登陆需要提示弹窗
			if (bindCardTip.newBindFlag()) {
				bindCardTip.activeSwitch({
					susFlag : true,
					back : false
				});
				return;
			}

			var accountSta = accountInfoStatus.getAccountInfoLossStatus("search/search/index")

			if (!accountSta)
				return;

			accountSta = accountInfoStatus.getAccountInfoCardStateStatus("search/search/index");

			if (!accountSta)
				return;
			App.navigate("search/prepaidRecharge/input", true);
		},

		/**
		 *author:EX-ZHANGAOJIAO001
		 *
		 * 功能描述:平安彩票
		 */
		paLottery : function() {
			utils.native.talkingDataTrackEvent("2.0发现-平安彩票");
			if (!App.storage.get("isUserLoggedIn")) {
				App.navigate(config.base.login_url + '?returnURL=' + "search/search/index", true);
				return;
			}

			//1-平安彩票入口   0-平安娱乐入口
			var data = {
				"flag" : 1
			};

			//1.低门槛登陆需要提示弹窗
			var userInfo = App.storage.get("UserInfo").toJSON();
			if (userInfo.isTelephoneLogin) {
				bindCardTip.activeSwitch({
					susFlag : true,
					back : false
				});
				return;
			}

			indexModel.passwordLottery(data).done(_.bind(function(response) {
				var param = {
					"client_id" : response.object.clientId,
					"redirect_uri" : response.object.redirectUrl,
					"response_type" : response.object.responseType,
					"sign" : response.object.sign,
					"clientNo" : response.object.clientNo,
					"timestamp" : response.object.timestamp,
					"media_source" : response.object.mediaSource
				};
				utils.window.open({
					"title" : "平安彩票",
					"url"   : config.urls.get("toaLoginAuth") + "?" + $.param(param)
				});
			}, this)).fail(function(error) {
				utils.dialog.alert(error.message);
			});
		},

		/**
		 * ex-wuwenjun001
		 * 申请平安由你卡
		 */
		applyByYouCards : function(){
			utils.native.talkingDataTrackEvent("2.0发现-申请由你卡");
			utils.window.open({
				title: "申请由你卡",
				url  : config.urls.get("byYouCard_apply")
			});
		},

		//跳转到信用卡还款
		creditCardBill : function(){
			utils.native.talkingDataTrackEvent("2.0发现-信用卡还款");
            if (!App.storage.get("isUserLoggedIn")) {
                App.navigate(config.base.login_url + "?returnURL=" + "search/search/index", true);
                return;
            }
			App.navigate('me/creditCard/payBack',true);
		},

		//夺宝奇兵（新手专享）开关 ex-chenfuhua001
		indianaJonesSwitch : function(){
			var self           = this;
			var isUserLoggedIn = App.storage.get("isUserLoggedIn");
			var chestSwitchUrl = "";
			if(isUserLoggedIn){
				chestSwitchUrl = "chestSwitch";
			}else{
				chestSwitchUrl = "outsidelogin";
			}
			indexModel.chestSwitch({
				url:chestSwitchUrl,
				callback: function(res){
					//on开  off关
					if(res.object.chestSwitch != "on"){
						self.$("#indianaJones").remove();
					}else{
                        self.$("#indianaJones").show();
                    }
				},
				errorCallback: function(res){
					console.log(res.message);
				}
			});
		},

		/**
		 * 夺宝奇兵
		 */
		indianaJones : function(){
			utils.native.talkingDataTrackEvent("2.0发现-夺宝奇兵（新手专享）");
			App.navigate('indianaJones/indianaJones/index', true);
		},

		/**
		 * 车估值
		 */
		carAppraisement: function () {
			if (this.isLoginToaF()) {
				utils.native.talkingDataTrackEvent("2.0发现-车估值");
				utils.native.carLoan();
			}
		},

		/**
		 * 房估值
		 */
		houseAppraisement: function () {
			if (this.isLoginToaF()) {
				utils.native.talkingDataTrackEvent("2.0发现-房估值");
				utils.native.houseLoan();
			}
		},

		/**
		 * 一账通是否登录
		 */
		isLoginToaF: function () {
			if (App.storage.get('isUserLoggedIn')) {
				if (App.storage.get("isToaFLoginIn")) {
					return true;
				} else {
					utils.dialog.toast('数据加载中 , 请稍后! ');
					return false;
				}
			} else {
				App.navigate(config.base.login_url + "?returnURL=" + "search/search/index", true);
				return false;
			}
		},

		loansDisplaySwitch : function(){
            var _this = this;
            var isUserLoggedIn = App.storage.get("isUserLoggedIn");
            if(!isUserLoggedIn){
                _this.$("#applyLoan").remove();
                return;
            }
			indexModel.loansDisplaySwitch({
				callback: function(res){
					if(res.object.reCode != "1"){
                        _this.$("#applyLoan").remove();
					}else{
                        _this.$("#applyLoan").show();
                    }
				},
				errorCallback: function(res){
					console.log(res.message);
				}
			});
		}
	});
});