define(function (require, exports, module) {
	var InputTpl = require("text!./input.html");
	var CustomPwdInput = require("component/password/customPwdInput");
	var accountModel = require("mod/common/model/accountModel");
	var paymentMothodView = require("mod/common/selPaymentMethod/paymentMothodView");
	var RedPacket         = require("component/redPacket/redPacket");
	var Step1Veiw = module.exports = ItemView.extend({
		template: InputTpl,

		events: {
			"tap .recharge_amt_select li" : "rechargeAmtSelect",
			"tap #submitBtn"              : "submit"
		},
		templateHelpers: {
			mobileNumFormat: function (mobile) {
				if (mobile)
					return mobile.substr(0, 3) + " " + mobile.substr(3, 4) + " " + mobile.substr(7);
			}
		},

		initialize: function(){
			this.saleAmt = "";
			this.redPacketId = "";
			this.submitFlag = false;  // 确定充值防重复
			this.parent = "";
			this.redPacket = "";
		},

		onRender: function () {
			var rateIndex = App.storage.remove("prepaidRecharge/current") || 0;
			this.parent = this.$(".recharge_amt_select").find("li").eq(rateIndex);
			this.parent.addClass("current");

			this.paymentMothodView = new paymentMothodView();
			this.$(".rechargePaySelect").empty();
			this.$(".rechargePaySelect").append($(this.paymentMothodView.$el[0]));
			this.paymentMothodView.$el.on("tap", _.bind(this.formInputData, this));
		},

		onShow: function(){
			var amt = $("li.current").attr("amt");
			var saleAmt = $("li span");
			for(var m=0 ; m<saleAmt.length ; m++){
				$("li span").eq(m).html($("li").eq(m).attr("amt"));
			}
			this.redPacket = new RedPacket({
				amt:amt,
				title:"支付红包",
				text:"话费充值红包",
				selectionBox:"radio",
				redPacketCategoryCode:"00",
				redPacketStatusCode:"0|1",
				callback:function(){
					self.saleAmt = parseFloat(this.amt)-parseFloat(this.getSaleAmt());
					$("li.current span").html(self.saleAmt);
					$("li.current").attr("occrAmt",self.saleAmt);
				}
			});
			this.$("#redPacketSelect").empty();
			this.$("#redPacketSelect").append($(this.redPacket.$el[0]));
		},

		rechargeAmtSelect: function (event) {
			var current = this.$(event.currentTarget);
			var amt = current.attr("amt");
			var saleAmt = $("li span");
			if (current.hasClass("current")) {
                return;
            }
			for(var m=0 ; m<saleAmt.length ; m++){
				$("li span").eq(m).html($("li").eq(m).attr("amt"));
			}
			if (this.parent) {
				this.parent.removeClass("current");
			} else {
				current.parent().parent().find("li").eq(0).removeClass("current");
			}
			this.parent = current;
			current.addClass("current");
			this.redPacket.reload({amt: amt});
		},

		submit: function () {
			var _this = this;
			this.redPacketId = this.redPacket.getType();
			var payType = this.paymentMothodView.getPayMethod();
			var payAmt = this.paymentMothodView.getPayAmt();
			if (parseFloat(payAmt) < _this.parent.attr("occrAmt")) {
				utils.dialog.toast("余额不足");
				return;
			}

			if (!_this.submitFlag) {
				CustomPwdInput.customPwdInput(function (password) {
					var data = {
						payAmt: _this.parent ? _this.parent.attr("amt") : _this.model.get("rateList")[0].amt,
						occrAmt: $("li.current").attr("occrAmt"),
						redPacketId : _this.redPacketId,
						password: utils.crypto.RSAKey.encrypt(password, config.base.rsa_public_key),
						sm2Pwd: utils.sm2.SM2Key.encrypt(password, config.base.sm2_public_key),
						paymentType: payType
					};
					_this.submitFlag = true;
					_this.trigger("submit", data);
				});
			}

		},

		formInputData: function () {
			App.storage.set("prepaidRecharge/current", this.parent.attr("rateIndex"));
			App.storage.set("prepaidRecharge/rechargeRate", this.model.toJSON());
		}
	});
});