define(function(require, exports, module) {
    var RecordTpl = require("text!./record.html");
    var RrecordItemTpl = require("text!./recordItem.html");
    var PTRScroll = require("component/PTRScroll");
    var RecordView = module.exports = ItemView.extend({
        template : _.template(RecordTpl),

        events : {
            "tap #rechargeRecordUI li" : "toDetailPage"
        },

        ui : {
            rechargeRecordUI : "#rechargeRecordUI"
        },

        pageIndex :1,
        onRender : function() {
            var _this = this;
            this.trigger("submit", {
                pageIndex : 1,
                callback : function(response) {
                    _this.pageSum = Math.ceil(response.totalRows / 10);
                    _this.recordList = response.list;
                    _this.ui.rechargeRecordUI.html(_.template(RrecordItemTpl, response.list));
                    _this._initPTRScroll();
                }
            });
        },

        toDetailPage : function(e) {
            if (!this.recordList)
                return;
            var index = $(e.currentTarget).index();
            var data = {
                recordList : this.recordList,
                currentRow : index,
                pageIndex : this.pageIndex
            }
            App.storage.set("prepaidRecharge/recordList", data);
            App.navigate("search/prepaidRecharge/recordDetail", true);
        },

        _initPTRScroll : function() {
            var _this = this;
            if (_this.scroller)
                _this.scroller.destroy();
            var wHeight = $(window).outerHeight(true);
            var dom = _this.$("#rechargeRecordContainer").css({
                "height" : wHeight,
                "position" : "relative"
            });

            _this.scroller = new PTRScroll(dom[0], {
                "hScroll" : false,
                "hideScrollbar" : true,
                "vScrollbar" : false,
                "pullDownToRefresh" : true,
                "pullUpToLoadMore" : this.pageSum == 0 || this.pageSum == 1 ? false : true
            });

            // scrollToElement("ul:nth-child("+rowIndex+")",100);

            //下拉刷新
            _this.scroller.options.refreshContent = function(refresh) {
                _this._refreshContent(refresh);
            };

            //上拉加载
            _this.scroller.options.loadMoreContent = function(refresh) {
                _this._scrollerLoadData(refresh);
            };
        },

        _refreshContent : function(refresh) {
            var _this = this;
            if (this.pageSum > 1) {
                this.scroller.enablePullUpToLoadMore();
            }
            _this.pageIndex = 1;
            _this.trigger("submit", {
                pageIndex : _this.pageIndex,
                callback : function(response) {
                    _this.recordList = response.list;
                    _this.ui.rechargeRecordUI.html(_.template(RrecordItemTpl, response.list));
                    refresh();
                }
            });
        },

        _scrollerLoadData : function(refresh) {
            var _this = this;
            _this.pageIndex = _this.pageIndex + 1;
            if (_this.pageIndex > this.pageSum)
                return;
            if (_this.pageIndex == this.pageSum) {
                this.scroller.disabledPullUpToLoadMore();
            }

            _this.trigger("submit", {
                pageIndex : _this.pageIndex,
                callback : function(response) {
                    _this.recordList = _this.recordList.concat(response.list);
                    _this.ui.rechargeRecordUI.append(_.template(RrecordItemTpl, response.list));
                    refresh();
                }
            });

        }
    });
});
