/**
 *编辑消费详情View
 */
define(function (require, exports, module) {

    var template = require("text!../../../template/wonderfulConsume/consumeStory/editConsumeDetail.html");
    var consumeTypeView = require("./consumeTypeView");
    var PTRScroll = require("component/PTRScroll");
    var IScroll = require("vendor/iscroll");
    var count = null;
    var editConsumeDetailView = module.exports = Layout.extend({
        id : "wrapView",
        template : _.template(template),
        events : {
            "tap #addBtn" : "addImg",                              //添加照片
            //"tap .fileImg" : "openImg",
            "input #consume_actName" : "totalchar",                //消费故事 计算字符
            "focusout #consume_actName" : "focusoutStoryInput",     //消费故事编辑 失去聚焦
            "tap #consumeImgUl img" : "showGallery",               //打开照片墙
            "tap .delImg" : "delImg",                              //删除照片
            "tap #saveConsumeBtn" : "saveConsume",                 //点击确定按钮
            //"blur #consume_actName" : "validateVal",
            "tap #selectConsumeType" : "selectConsumeType"         //选择消费类型
        },
        initialize : function () {
            var source = App.storage.remove("consumetype/toindex");
            if (source) {
                var imgObj = App.storage.remove("consumetory/modelImg"); //当前model的录数
                var addurl = this.addImgUrl = App.storage.get("consumeimg/add");//增加的记录数
                var totalImg = null;
                if (addurl && addurl.length > 0) {
                    _.each(addurl, function (image, i) {//对新加的记录数进行改造
                        if (image.imageUrl.indexOf("data:image/jpeg;base64,") == -1) {
                            var url = "data:image/jpeg;base64," + image.imageUrl;
                            image.imageUrl = url;
                        }
                    });
                    totalImg = imgObj.concat(addurl);
                } else {
                    totalImg = imgObj
                }
                this.model.attributes.imagesList = totalImg;
                totalImg.length > 0 ? count = totalImg.length : count = 0;
                this.imgUrlList = imgObj;
                this.imgUrl = addurl;
            } else {
                var urls = null;
                urls = this.model.get("imagesList");
                urls.length > 0 ? count = urls.length : count = 0;
                this.imgUrlList = urls;
                var option = {
                    "delPhotoId" : "",
                    "delPhotoUrl" : "",
                    "addPhotoUrl" : ""
                };
                App.storage.set("consumeEditDetail", option);
                this.imgUrl = [];
            }
        },
        regions : {
            consumeTypeRegion : "#consumeTypeDiv"
        },

        onShow : function () {
            this.totalchar();
            this.showImg();
            this.scrollPage();
        },
        scrollPage : function () {
//            var wHeight = $(window).outerHeight(true);
            var wHeight = Number(App.locStorage.get("webviewHeight")) + 49;
            var dom = $("#scrollContainer").css({"height" : wHeight, "position" : "relative"});
            this.scroller = new PTRScroll(dom[0], {
                "hideScrollbar" : true,
                "checkDOMChanges" : true,
                onBeforeScrollStart : function (e) {
                    var nodeType = e.explicitOriginalTarget ? e.explicitOriginalTarget.nodeName.toLowerCase() : (e.target ? e.target.nodeName.toLowerCase() : "");
                    //if(nodeType != 'select' && nodeType != 'option' && nodeType != 'input' && nodeType != 'textarea'){
                    if (nodeType != 'textarea') {
                        e.preventDefault();
                    }
                }
            });
            this.scroller.disablePullDownToRefresh();
            this.scroller.disablePullUpToLoadMore();
        },
        //消费故事 计算字符
        totalchar : function () {
            var el = $("#consume_actName");
            el.val(el.val().replace(/[$:&#：%‘“\r\n<>/]/ig, ""));

            if(window.IS_RUN_ON_IDEVICE){  //如果在苹果端
                //计算"'"的个数
                var specialSignNum = 0;
                //拼音输入法时,字母与字母之间会有"'",但不会显示在手机上,可是又会计数,所以这里计算下"'"的个数
                if ((el.val()).indexOf("'") > -1) {
                    specialSignNum = (el.val()).match(/'/g).length;
                    console.info(specialSignNum);
                }
                console.info(el.val());
                var len = el.val().length - specialSignNum;
                //如果字符串中含有"'",并且len大于20时,可以输入的长度增加"'"的个数
//            if (len > 20 && (specialSignNum > 0)) {
//                var subStr = el.val().substring(0, 20 + specialSignNum);
//                el.val(subStr);
//            } else if (len > 20) {
//                var subStr = el.val().substring(0,20);
//                el.val(subStr);
//            }
                $("#ctrCharcount").text(len > 20 ? 20 : len);
            }else{
                var len = el.val().length;
                $("#ctrCharcount").text(len);
            }
        },
        //消费故事 失去聚焦
        focusoutStoryInput : function () {
            var el = $("#consume_actName");
            App.storage.set("editStoryContent", el.val().replace(/[$:&#：%‘“\r\n<>/]/ig, ""));
        },
        showImg : function () {
            //最多只能增加到8张图片
            if ($("#consumeImgUl li").length - 1 >= 8) {
                $("#addBtn").hide();
            } else {
                $("#addBtn").show();
            }
        },
        //新增图片
        addImg : function () {
            //获取当前新增加的图片张数  如果超过三张就返回 提示用户 一次性只能提交3张照片
            // var currtImgs = $("#consumeImgUl li img");
            // var currtImgsNums = currtImgs.length;
            // var oldImgscount = 0;
            // for (var i = 0, currtImgsNums = currtImgs.length; i < currtImgsNums; i++) {
            // var src = $("#consumeImgUl li img")[i].getAttribute('src');
            // if (src.indexOf("http") > -1) {  //是旧的图片
            // oldImgscount++;
            // }
            // }
            // var newAddImgsNum = currtImgsNums - oldImgscount;
            // if (newAddImgsNum >= 3) {
            // utils.dialog.alert("一次最多只能新增三张照片", function () {
            // return;
            // });
            // return
            // }

            utils.dialog.spinner({
                source : [
                    {"text" : "照片中选择", "value" : 0},
                    {"text" : "拍照", "value" : 1}
                ],
                callback : _.bind(function (selectedItem, selectedIndex) {
                    if (!navigator.camera) {
                        utils.dialog.alert("Camera API not supported", "Error");
                        return;
                    }
                    this.getPicture(selectedItem.value);
                }, this)
            });
        },
        // refresh_img: function () {
        // var len = $("#consumeImgUl li").length - 1;
        // var all = $("#consumeImgUl li");
        // var lk = $("#addBtn");
        // var obj = _.without(all, lk[0]);
        // for (var i = 0; i < len; i++) {
        // count = i + 1;
        // var el = $(obj[i]).children();
        // _.each(el, function (item, k) {
        // if (item.nodeName == "IMG") {
        // var src = item.getAttribute("src");
        // if (src.indexOf("data:image/jpeg;base64,") != -1) {//新增
        // $(item).attr("imgId", "imgId_" + i);
        // }
        // }
        // $(item).attr("index", i);
        // });
        // }
        // },
        validateVal : function () {
            var el = $("#consume_actName");
            var val = el.val();
            if (!utils.validate.specialCharacter(val)) {
                el.val("");
                utils.dialog.toast("您输入的信息不合法请重新输入");
                return false;
            }
            el.val(el.val().replace(/[\r\n]/ig, ""));
            return false;
        },
        //删除图片
        delImg : function (e) {
            e.stopPropagation();
            e.preventDefault();
            this.deleteFlag = true;
            if ($("#consume_actName:focus")[0]) {
                $("#consume_actName:focus").blur();
            } else {
                var consumeEditDetail = App.storage.get("consumeEditDetail");
                var delPhoto = $(e.currentTarget).prev().attr("src");
                var delPhotoId = $(e.currentTarget).prev().attr("imgId");
                var index = $(e.currentTarget).attr("index");
                $("#consumeImgUl img[index='" + index + "']").parents("li").remove();
                //this.refresh_img();
                //最多只能增加到8张图片
                if ($("#consumeImgUl li").length - 1 >= 8) {
                    $("#addBtn").hide();
                } else {
                    $("#addBtn").show();
                }
                //删除新增的，不需要写入删除中  新增的照片含有"data:image/jpeg;base64,"
                if (delPhoto.indexOf("data:image/jpeg;base64,") != -1) {
                    var imgUrls = this.imgUrl;
                    _.each(this.imgUrl, function (url, k) {
                        var dif = false;
                        if (url.consumImageId == delPhotoId) {
                            dif = true;
                        }
                        if (dif) {
                            imgUrls.splice(k, 1);
                        }
                    });
                    this.imgUrl = imgUrls;
                    App.storage.set("consumeimg/add", this.imgUrl);
                    count--;
                    this.deleteFlag = false;
                    return;
                }
                var imgUrlList = this.imgUrlList;
                _.each(this.imgUrlList, function (url, j) {
                    var dif = false;
                    if (url.consumImageId == delPhotoId) {
                        dif = true;
                    }
                    if (dif) {
                        imgUrlList.splice(j, 1);
                    }
                });
                this.imgUrlList = imgUrlList;
                if (consumeEditDetail && consumeEditDetail.delPhotoUrl) {
                    consumeEditDetail.delPhotoUrl += "_del" + delPhoto;
                    consumeEditDetail.delPhotoId += "_del" + delPhotoId;

                } else {
                    consumeEditDetail.delPhotoUrl = delPhoto;
                    consumeEditDetail.delPhotoId = delPhotoId;
                }
                App.storage.set("consumeEditDetail", consumeEditDetail);
            }
            this.deleteFlag = false;
            return false;
        },
        //大图片
        openImg : function () {
            var index = event.target.getAttribute("index");
            App.navigate("search/wonderfulConsume/bigImg/" + index, true);
        },
        //跳转到消费类型选择页面
        selectConsumeType : function (e) {
            var consumeTypeCode = $(e.currentTarget).attr("consumeTypeCode");
            if (!consumeTypeCode) {
                consumeTypeCode = 0;
            }
            var imgObj = this.imgUrlList;
            App.storage.set("consumetory/modelImg", imgObj);
            App.navigate("search/wonderfulConsume/selectConsumeTypePage/" + consumeTypeCode, true);
        },
        //从相册和照相选取照片
        addImurl : function (date) {    //延伸作用域链
            this.onPhotoDataSuccess(date);
        },
        getPicture : function (sourceType) {

            navigator.camera.getPicture(_.bind(this.onPhotoDataSuccess, this), this.onFail, {
                quality : 10,
                sourceType : sourceType,  //0:从相册 ,1:照相
                destinationType : 0, //选择返回数据的格式0:base64,1:url
                correctOrientation : true,
                encodingType : Camera.EncodingType.JPEG,
                targetWidth : 768,
                targetHeight : 1024
            });
        },
        onPhotoDataSuccess : function (imageData) {
            $("#addBtn").before("<li><img class='fileImg' index='" + count + "' src='data:image/jpeg;base64," + imageData + "' imgId='imgId_" + count + "' width='74' height='77'/><a index='" + count + "' class='dsb tac f16 delImg'>删除</a></li>");
            //最多只能增加到8张图片
            if ($("#consumeImgUl li").length - 1 >= 8) {
                $("#addBtn").hide();
            } else {
                $("#addBtn").show();
            }
            var url = {"imageUrl" : imageData, "consumImageId" : "imgId_" + count};
            if (!this.imgUrl) this.imgUrl = [];
            this.imgUrl.push(url);
            App.storage.set("consumeimg/add", this.imgUrl);
            var consumeEditDetail = App.storage.get("consumeEditDetail");
            var src = "data:image/jpeg;base64," + imageData;
            if (consumeEditDetail && consumeEditDetail.addPhotoUrl) {
                consumeEditDetail.addPhotoUrl += "_add" + src;
            } else {
                consumeEditDetail.addPhotoUrl = src;
            }
            count++;
            App.storage.set("consumeEditDetail", consumeEditDetail);
        },
        onFail : function (message) {
            //utils.dialog.alert(message);
//            alert("11");
        },
        //点击确定按钮
        saveConsume : function () {
            var consumeEditDetail = App.storage.get("consumeEditDetail");
            var imgList = $("#consumeImgUl img");
            consumeEditDetail.addPhotoUrl = "";
            _.each(imgList, function (list, i) {
                var imgSrc = list.src;
                if (imgSrc.indexOf("data:image/jpeg;base64,") != -1) {
                    if (consumeEditDetail && consumeEditDetail.addPhotoUrl) {
                        consumeEditDetail.addPhotoUrl += "_add" + imgSrc;
                    } else {
                        consumeEditDetail.addPhotoUrl = imgSrc;
                    }
                }
            });
            var option = {
                "consumptionId" : $("#consumptionId").attr("consumptionId"),
                "privateName" : $("#consume_proName").text(),
                "consumptionTypeCode" : $("#selectConsumeType").attr("consumeTypeCode"),
//                "activityName": ($("#consume_actName").val().replace(/[^0-9a-zA-Z\u4e00-\u9fa5]/g, '')).replace(/^\s*|\s*$/, ''),
                "activityName" : $("#consume_actName").val().trim(),
                "delPhotoId" : consumeEditDetail.delPhotoId,
                "delPhotoUrl" : consumeEditDetail.delPhotoUrl,
                "addPhotoUrl" : consumeEditDetail.addPhotoUrl
            };
            if (option.privateName == "") {
                option.privateName = " ";
            }
            if (option.activityName == "") {
                option.activityName = " ";
            }
            this.trigger("form:submit", option);
        },
        //显示照片墙
        getImgs : function () {
            var imgObj = null;
            var urlLists = [];
            if (this.imgUrl && this.imgUrl.length > 0) {
                imgObj = this.imgUrlList.concat(this.imgUrl);
            } else {
                imgObj = this.imgUrlList;
            }
            return imgObj;
        },
        showGallery : function (e) {
            if (this.deleteFlag) return; //删除流程走完后可以打开照片墙
            // 当前消费故事图片路径
            var imgIndex = $($(e.target).parents("li")).prevAll().length;
            var imgUrlList = [];
//            var imgObj = this.getImgs(); //万果石
            var imgs = $("#consumeImgUl li");
            var imgArray = [];
            for (var i = 0, imgsLength = imgs.length - 1 ; i < imgsLength ; i++) {
                imgArray.push(imgs[i]);
            }
//            _.each(imgObj, function (image) {   //万果石
//                var url = image.imageUrl.replace("data:image/jpeg;base64,", "");
//                imgUrlList.push(url);
//            });
            _.each(imgArray, function (image, i) {
//                var url = image.imageUrl.replace("data:image/jpeg;base64,", "");
                var url = $(imgArray[i]).find("img").attr("src").replace("data:image/jpeg;base64,", "");
                imgUrlList.push(url);
            });
            // 调用native方法展示照片墙
            utils.native.gallery.show({
                source : imgUrlList,
                highIndex : parseInt(imgIndex)
            });
        }
    });
});