define(function (require, exports, module) {
    var indexTl = require("text!../../../template/wonderfulConsume/consumeStory/index.html");
    var listView = require("./storyList.js");
    var consumeModel = require("../../../model/wonderfulConsume");
    var FormComponent = require("component/form");
    var PTRScroll = require("component/PTRScroll");
    var IScroll = require("vendor/iscroll");
    var self = null;
    var indexView = module.exports = FormComponent.extend({
        template: _.template(indexTl),
        regions: {
            consumeStoryRegion: "#consumeStoryContainer"
        },
        ui: {
            "startDateBtn": "#startDate",
            "endDateBtn": "#endDate",
            "startDateText": "#start-date-text",
            "endDateText": "#end-date-text"
        },
        events: {
            "tap #selectCreditCard": "_toCreditCard",   //选择信用卡
            "datepicker:dateSelect @ui.startDateBtn": "selectStartDate",   //选择开始日期
            "datepicker:dateSelect @ui.endDateBtn": "selectEndDate"     //选择结束日期
        },
        initialize: function () {
            this.param = this._getDefaultParam();
            //"search/consumestory/searchDate"   这个缓存是在消费记录列表中 点击某一条小记录的"消费故事"和"金额"时缓存的
            var date = App.storage.remove('search/consumestory/searchDate');
            if (date) {
                this.param.startDate = date.startDate;
                this.param.endDate = date.endDate;
            }
            this.model = new Model({"param": this.param});
            self = this;
            this.listViewInstance = null;
            App.storage.remove("consumeimg/add");
        },
        _getDefaultParam: function () {
            //每次进入这个页面(除了点击了消费记录列表中-某条"消费故事"和"金额") 都获取默认的用户登录系统时间
            var today = App.storage.get("Login_SysTime") || new Date();
            var cardLast4 = App.storage.get("consumee/creditCardNum");
            return {
                "startDate": new Date(utils.date.diffDateAdd(today, -6, "d")).format("yyyy-MM-dd"),
                "endDate": new Date(today).format("yyyy-MM-dd"),
                "currPage": "1",
                "rowCount": "10",
                "orderName": "TRANS_DATE",
                "orderType": "1",
                "cardLast4": cardLast4 || ""
            };
        },
        onShow: function () {
            if (!this.model.get('tempDataList')) {
                this.qryFirstPageData();
            } else {
                this.showTempPageData();
            }
            var cardLast4 = App.storage.remove("consumee/creditCardNum");
            if (cardLast4) {
                $("#creditCardAll").text("信用卡 ");
                $("#creditNum").text(cardLast4);
            } else {
                $("#creditCardAll").text("全部信用卡 ");
                $("#creditNum").text("");
            }
            self.cardLast4 = cardLast4 || "all";
        },
        showTempPageData: function () {
            var model = this.model;
            var list = model.get('tempDataList');
            var responseData = model.get('responseData');

            this.initPTRScroll();
            this.listViewCollectionChange(list);
            this.initPullUpToLoadMore(responseData.object);
        },
        // 准备查询（当首次进入页面 或 变更查询参数时）
        qryFirstPageData: function () {
            this.param.startDate = utils.date.formatTime($("#startDate").attr("data-initDate")).format("yyyyMMdd");//开始时间
            this.param.endDate = utils.date.formatTime($("#endDate").attr("data-initDate")).format("yyyyMMdd");//结束时间
            this.param.currPage = "1";
            var param = this.param;
            this.doQryFirstPageData(param);
        },
        // 执行查询（当首次进入页面 或 变更查询参数时）
        doQryFirstPageData: function (param) {
//            param.startDate = "20150101"; //测试数据xyt
//            param.endDate = "20150201"; //测试数据xyt
            this.qryData({
                param: param,
                callback: _.bind(function (response) {
                    $("#consumeErrMsg").remove();
                    this.model.set('responseData', response);
                    var list = response.object.consumeList;
                    if (!list || list.length == 0) {
                        //this.scroller && this.scroller.destroy();
                        this.showNullRecord();
                        //this.listViewCollectionChange([]);
                    } else {
//                        $("#consumeTotalAmt,#scrollContainer").show();
                        $("#consumeTotalAmt").show();
                        $("#consumeStoryContainer").show();
                        this.initPTRScroll();
                        for (var i = 0; i < list.length; i++) {
                            for (var j = 0; j < list[i].list.length; j++) {
                                list[i].list[j].imagesList = _.sortBy(list[i].list[j].imagesList, 'consumImageId');
                            }
                        }
                        this.listViewCollectionChange(list);
                        this.initPullUpToLoadMore(response.object);
                    }
                }, this)
            });
        },
        showNullRecord: function () {
            var htl = '<div class="m_t30 tac" id="consumeErrMsg">'
                + '<i class="faiCon tssbIcon"></i>'
                + '<p class="f15 p_t10 c_999"><span class="dsb f18">暂无记录</span>仅显示你身份认证之后的消费记录</p>'
                + '</div>';
//            $("#consumeTotalAmt,#scrollContainer").hide();
//            $("#headTip").after(htl);
            $("#scrollContainer").css({"background": ""});
            $("#consumeTotalAmt").hide();
            $("#consumeStoryContainer").hide();
            $("#consumeStoryContainer").after(htl);
        },
        //执行请求数据
        qryData: function (options) {
            var self = this;
            // 防重复提交
            if (self.submitFlag && self.submitFlag == 1) return;
            self.submitFlag = 1;
            console.info(JSON.stringify(options.param));
            consumeModel.queryMyConsumeList({
                param: options.param,
                callback: function (response) {
//                    debugger;
                    // for (var i = 0, rOCL = response.object.consumeList.length; i < rOCL; i++) {
                    // for (var j = 0, rOCLL = response.object.consumeList[i].list.length; j < rOCLL; j++) {
                    // var acName = response.object.consumeList[i].list[j].activityName;
                    // acName = encodeURIComponent(acName);
                    // }
                    // }
                    // 更新消费总额
                    $("#totalAmount").html(utils.string.formatMoneyNumber(response.object.totalAmount));
                    options.callback && options.callback(response);
                },
                complete: function () {
                    options.complete && options.complete();
                    self.submitFlag = 0;
                }
            });
        },
        //初始化上下拉
        initPTRScroll: function () {
            if (this.scroller) this.scroller.destroy();
            var self = this;
//            var wHeight = $(window).outerHeight(true);
            var wHeight = Number(App.locStorage.get("webviewHeight")) + 49;
//            var navHeight = $("#headTip").outerHeight(true) + $("#choicetip").outerHeight(true) + 30;
            var navHeight = $("#choicetip").outerHeight(true) + 15;
            var listHeight = wHeight - navHeight;
            var dom = $("#scrollContainer").css({"height": listHeight, "position": "relative"});
            //初始化iscroller
            this.scroller = new PTRScroll(dom[0], {
                "hScroll": false,
                "checkDOMChanges": true,
                "hideScrollbar": false,
                "hScrollbar": false,
                "vScrollbar": false
            });
            //下拉刷新
            this.scroller.options.refreshContent = function (refresh) {
                self.scrollerLoadData(refresh, 1);
            };
            //上拉加载
            this.scroller.options.loadMoreContent = function (refresh) {
                self.scrollerLoadData(refresh, parseInt(self.param.currPage) + 1);
            };
        },
        // 上下拉时加载数据
        scrollerLoadData: function (refresh, currPage) {
            var self = this;
            // 重置页码参数
            var param = this.param;
            //下拉时，不出现"加载中.."黑色框框 true表示不显示
            param.isLoadingBlackTipShow = true;
            param.cardLast4 = $("#creditNum").text().replace("全部", "");
            var tempParam = _.defaults({currPage: currPage}, param);
            // 请求数据
            self.qryData({
                param: tempParam,
                callback: function (response) {
                    param.currPage = "" + currPage;
                    var list = response.object.consumeList;
                    if (currPage == 1) {
                        self.listViewCollectionChange(list);
                    } else {
                        self.listViewCollectionAdd(list);
                    }
                    self.initPullUpToLoadMore(response.object);
                },
                complete: function () {
                    refresh();
                }
            });
        },
        //初始化上下拉标签
        initPullUpToLoadMore: function (object) {
            if (object.totalDays > 1 * this.param.currPage * object.rowCount) {
                this.scroller.enablePullUpToLoadMore();
            } else {
                this.scroller.disabledPullUpToLoadMore();
            }
        },
        // 更改collectionView中的collection，并渲染该view
        listViewCollectionChange: function (list) {
            this.model.set('tempDataList', list);
            if (this.listViewInstance) {
                this.listViewInstance.trigger("initCount");
                this.listViewInstance.collection.reset(list);
            } else {
                this.showRecordsListView(new Collection(list));
            }
        },
        // 增加collectionView中的collection，并渲染该view
        listViewCollectionAdd: function (list) {
            var tempDataList = this.model.get('tempDataList');
            this.model.set('tempDataList', tempDataList.concat(list));
            if (this.listViewInstance) {
                //this.listViewInstance.trigger("initCount");
                this.listViewInstance.collection.add(list);
            }
        },
        // 显示列表view
        showRecordsListView: function (collection) {
            var thisView = this;
            console.log(collection);
            var view = this.listViewInstance = new listView({
                collection: collection
            });
            this.consumeStoryRegion.show(view);
        },
        _toCreditCard: function () {
            App.navigate("search/wonderfulConsume/selectCreditCard/" + self.cardLast4, true);
        },
        // 选择开始日期
        selectStartDate: function (eve, _this, value) {//时间段可以查询今天数据
            this.dateSelect = "START";
            /*var consumeView = this;
             var sysTime = App.storage.get("Login_SysTime");
             var now = new Date();
             var taday = new Date(sysTime || now).format("yyyy-MM-dd");
             var yesToday = new Date(utils.date.diffDateAdd(sysTime|| now,-1,"d")).format("yyyy-MM-dd");
             if(value == taday){
             this.ui.endDateText.text(taday);
             $("#endDate").attr("data-initDate", taday);
             $("#endDate").attr("data-startDate", taday);
             $("#endDate").attr("data-endDate", taday);
             }else{
             $("#endDate").attr("data-startDate", value);
             $("#endDate").attr("data-endDate", yesToday);
             if(this.ui.endDateText.text() == taday){
             this.ui.endDateText.text(yesToday);
             $("#endDate").attr("data-initDate", yesToday);
             }
             }*/
            if (!this._validateDateSlct(value, this.ui.endDateBtn.attr("data-initDate"))) return;
            this.ui.startDateBtn.attr("data-initDate", value);
            this.ui.startDateText.text(value);
            this._validateDateThreeMotn(value, this.ui.endDateBtn.attr("data-initDate"));
            //this.qryFirstPageData();
        },
        // 选择结束日期
        selectEndDate: function (eve, _this, value) {
            this.dateSelect = "END";
            if (!this._validateDateSlct(this.ui.startDateBtn.attr("data-initDate"), value)) return;
            this.ui.endDateBtn.attr("data-initDate", value);
            this.ui.endDateText.text(value);
            this._validateDateThreeMotn(this.ui.startDateBtn.attr("data-initDate"), value);
            //this.qryFirstPageData();
        },
        _validateDateThreeMotn: function (startDate, endDate) {
            var pdate = utils.date.diffDateAdd(endDate, -3, "m");
            if (utils.date.diffDate(startDate, pdate) > 0) {
                utils.dialog.alert("查询时间段不能超过3个月", function () {
                    if (self.dateSelect && self.dateSelect == "START") {
                        var sdate = utils.date.diffDateAdd(startDate, 3, "m");
                        var formatDate1 = utils.date.formatTime(sdate).format("yyyy-MM-dd");
                        self.ui.endDateBtn.attr("data-initDate", formatDate1);
                        self.ui.endDateText.text(formatDate1);
                    } else if (self.dateSelect && self.dateSelect == "END") {
                        var sdate = utils.date.diffDateAdd(endDate, -3, "m");
                        var formatDate1 = utils.date.formatTime(sdate).format("yyyy-MM-dd");
                        self.ui.startDateBtn.attr("data-initDate", formatDate1);
                        self.ui.startDateText.text(formatDate1);
                    }
                    self.qryFirstPageData();
//                    $("#scrollContainer").css({"background":""});
//                    $("#consumeTotalAmt").hide();
                });
            } else {
                self.qryFirstPageData();
            }
        },
        _validateDateSlct: function (startDate, endDate) {
            if (utils.date.compareDate(startDate, endDate) == 1) {
                utils.dialog.toast("开始日期不能大于结束日期");
                return false;
            }
            return true;
        }
    });
});