define(function (require, exports, module) {
    var indexTl = require("text!../../../template/wonderfulConsume/consumeStory/storyListDetail.html");
    var iScroll = require("vendor/iscroll");
    var IndexView = module.exports = ItemView.extend({
        template: _.template(indexTl),
        events: {
            "tap #consumeType": "selectConsumeType",
            "tap #editStory": "showEditPage",
            "tap #photListDiv img": "showGallery",
            "tap #conEditSpan": "toEditPage"
        },
        initialize: function () {
            utils.native.setSideMenuDisabled(true);
            this.imgList = this.model.get("imagesList");
        },
        onShow: function () {
            $("#photListDiv").css({"width": document.body.clientWidth});
            new iScroll("photListDiv", {
                "hideScrollbar": false,
                "hScrollbar": true,
                "vScroll": false,
                hScrollbar: false,
                vScrollbar: false
            });
            //如果照片数量为0 那么就不显示照片框
            if (this.imgList.length === 0) {
                 $("#photListDiv").parent().hide();
            }else{
                $("#photListDiv").parent().show();
            }
        },
        //编辑消费记录
        showEditPage: function (e) {
            App.navigate("search/wonderfulConsume/editConsumeDetailPage", true);
        },
        //跳转到消费类型选择页面
        selectConsumeType: function () {
            var ctrConsumeTypeCode = "";
            App.navigate("search/wonderfulConsume/selectConsumeTypePage/" + ctrConsumeTypeCode, true);
        },
        //显示照片墙
        showGallery: function (e) {
            var imgIndex = e.target.getAttribute("index");
            // 获取当前消费故事所有图片路径
            var imgUrlList = [];
            $.each(this.imgList, function (i, item) {
                imgUrlList.push(item.imageUrl);
            });
            // 调用native方法展示照片墙
            utils.native.gallery.show({
                source: imgUrlList,
                highIndex: parseInt(imgIndex)
            });
        },
        toEditPage: function () {
            var obj = this.model.attributes;
            App.storage.set("consume/notActiveCtrItem", obj);
            App.navigate("search/wonderfulConsume/editConsumeDetailPage", true);
        }
    });
});
