define(function (require, exports, module) {
	var indexTl = require("text!../../template/wonderfulConsume/index.html");
	var StoryView = require("./consumeStory/index");
	var BillView = require("./intelligentBill/intelligentBillView");
	var consumeModel = require("../../model/wonderfulConsume");
	var FormComponent = require("component/form");
	var self = null;
	var IndexView = module.exports = FormComponent.extend({
		template: _.template(indexTl),
		regions: {
			contentRegion: "#contentRegion"
		},
		events: {
			"tap #consume_story": "_toStoryView",
			"tap #consume_intelligentBill": "_BillView"
		},
		initialize: function () {
			self = this;
			this._checkStatusAndCreditCard();
		},
		onShow: function () {
			var
				choseMonth = App.storage.get("choseMonth"),
				consumRank = App.storage.get("consumRank"),
				consumWays = App.storage.get("consumWays");
			if (choseMonth || consumRank || consumWays) {
				$("#consume_story").removeClass("on").next().addClass("on");
			}
			this._swipe();
		},
		onClose: function () {
			$(document)[0].swipe.destroy();
		},
		// wuyongsheng560 滑动事件简单封装
		_swipe: function () {
			var _this = this;
			$(document).swipe(function () {
				var lis = $('#choicetip li');
				var len = lis.size();
				var id = lis.filter('.on').index();
				if (this.direction == 'left') {
					id++;
					if (id > len - 1) {
						id = 0;
					}
					lis.eq(id).trigger('tap');
				} else if (this.direction == 'right') {
					id--;
					if (id < 0) {
						id = len - 1;
					}
					lis.eq(id).trigger('tap');
				}
			});
		},
		//展示消费故事
		_toStoryView: function () {
			utils.native.talkingDataTrackEvent("2.0精彩消费-消费故事");
			$("#consume_intelligentBill").removeClass("on").prev().addClass("on");
			if (App.storage.get("consume/validatedFail")) return;
			self.contentRegion.show(new StoryView());
		},
		//展示智能账单
		_BillView: function () {
			utils.native.talkingDataTrackEvent("2.0精彩消费-智能账单");
			$("#consume_story").removeClass("on").next().addClass("on");
			App.navigate("search/wonderfulConsume/index", false);
			if (App.storage.get("consume/validatedFail")) return;
			var storageIntelligentBillData = App.storage.get("IntelligentBillData");

			if (storageIntelligentBillData) {
				var tempData = new Model({model: storageIntelligentBillData});
				self.contentRegion.show(new BillView({model: tempData}));
			} else {
				//第一次进来 获取登录时间
				var tempTime = App.storage.get("wonderCurrtTime");
				var
					timeYear = tempTime.substring(0, 4),
					timeMonth = tempTime.substring(5, 7),
					timeYearNum = Number(timeYear),
					timeMonthNum = Number(timeMonth);
				var params = {};
				//判断当前月份 是不是一月份
				if (timeMonthNum === 1) {
					timeYearNum = timeYearNum - 1;
					params.billDate = timeYearNum + "";
				} else {
					timeMonthNum = timeMonthNum - 1;
					if (timeMonthNum < 10) {
						params.billDate = timeYear + "0" + timeMonthNum;
					} else {
						params.billDate = timeYear + timeMonthNum;
					}
				}
				consumeModel.qryAptitudeReckoning({
					data: params,
					callback: function (response) {
						var temp = response.object;
						var timeTick = "月度";
						timeTick = temp.billDate.length > 4 ? timeTick : "年度";
						temp.timeTick = timeTick;
						temp.billDate = temp.billDate.length > 4 ? temp.billDate.substr(0, 4) + "年" + temp.billDate.substr(4, 2) + "月" : temp.billDate + "年";

						App.storage.set("IntelligentBillData", temp);
						var tempData = new Model({model: temp});
						self.contentRegion.show(new BillView({model: tempData}));
					},
					errorCallback: function (response) {
						utils.dialog.alert(response.message);
					}
				});
			}
		},
		//初始化校验
		_checkStatusAndCreditCard: function () {
			var cardState = App.storage.get("UserInfo").get("cardState");
			if (cardState == "1") { //未进行身份验证，已经在进来这里之前就被过滤掉了(即现在都已身份验证)
				$.when(consumeModel.relatingCreditCard()).done(function (arg) {
					var response = arg;
					if (response.object.cardList.length == 0) {
						var view = new ItemView({
							template: _.template(
							'<div"><p class="c_999 f16 m_t15 m_l10 m_r10">您还没有关联信用卡，请先申请或者关联平安信用卡，谢谢！</p>'
								+ '<div class="applyCard m_t20">'
								+ '<i class="iconA60 m_l50" style="margin-top:-25px"></i>'
								+ '<div class="m_t30 m_l10 dsib">'
								+'<p id="applyByYouCards">申请平安由你卡</p>'
								+'<p id="applyCreditCards" class="m_t15">申请平安信用卡</p>'
								+ '</div></div></div>')
						});
						view.on('show', function(){
							view.$('#applyCreditCards').click(function(e){
								e.stopPropagation();
								e.preventDefault();
								utils.window.open({
									title:  "申请平安信用卡",
									url: config.urls.get("creditCard_apply")
								});
							});
							
							/**
							 * ex-wuwenjun001
							 * 申请平安由你卡 
							 */
							view.$('#applyByYouCards').click(function(e){
								e.stopPropagation();
								e.preventDefault();
								utils.window.open({
									title:  "申请平安由你卡",
									url: config.urls.get("byYouCard_apply")
								});
							});
						});
						self.contentRegion.show(view);
						App.storage.set("consume/validatedFail", true);
					} else {
						App.storage.remove("consume/validatedFail");
						// 缓存绑定信用卡数据
						App.storage.set("consumee/bindCreditCard", response.object.cardList);
						//从缓存获取一些数据 判定是否从智能账单那边回退回来的
						var
							choseMonth = App.storage.get("choseMonth"),
							consumRank = App.storage.get("consumRank"),
							consumWays = App.storage.get("consumWays");
						if (choseMonth || consumRank || consumWays) {
							self._BillView();
							App.storage.remove("choseMonth");
							App.storage.remove("consumRank");
							App.storage.remove("consumWays");
						} else {
							//默认展示消费故事
							self.contentRegion.show(new StoryView());
						}
					}
				}).fail(function () {
					App.storage.set("consume/validatedFail", true);
				});
			} else {
				App.storage.set("consume/validatedFail", true);
				utils.dialog.confirm(
					"你还未进行身份认证！请立即认证身份，通过后即可为你已持有的平安信用卡消费自动记账，体验精彩消费！",
					function (ok) {
						if (ok) {
							//App.navigate("personalCenter/securitySet/verifyIdentity",true);
						}
					}
				);
			}
		}
	});
});
