define(function (require, exports, module) {
    var chooseMonthTpl = require("text!../../../template/wonderfulConsume/intelligentBill/chooseMonths.html");
    var IScroll = require("vendor/iscroll");
    var self;
    var FormComponent = require("component/form");
    var consumeModel = require("mod/search/model/wonderfulConsume");

    var IndexView = module.exports = FormComponent.extend({
        template: _.template(chooseMonthTpl),
        initialize: function () {
            self = this;
            App.storage.set("choseMonth", "choseMonth");
        },
        onShow: function () {
            //初始化滚动条
            initScroll();
        },
        events: {
            "tap .month": "chooseMonth"
        },

        chooseMonth: function (e) {
            var temp = $(e.currentTarget);
            var timeDiv = $(temp).find("div").html().trim();//2014年06月
            var time = timeDiv.substring(0, 4) + timeDiv.substring(5, 7);
            var monthsList = App.storage.get("monthsList");
            console.info(JSON.stringify(monthsList));
            console.info(timeDiv);
            //选中某一个月份后 显示打勾的小图标
            if ($(temp).attr("dataflag") === "month") {
                App.storage.set("choseMonth", $(temp).html());
                $(temp).append($("[dataChooseMonthIcon]"));
                $("[dataChooseMonthIcon]").show();
            }
            //让选中的月份 在monthsList有一个标识(checked==true) 并用存入缓存
            for (var i = 0, length = monthsList.length; i < length; i++) {
                if (monthsList[i].key === timeDiv) {
                    monthsList[i].checked = true;
                }else{
                    monthsList[i].checked = false;
                }
            }
            App.storage.set("monthsList", monthsList);
            //根据选中的月份，进行查询 存入缓存
            qryBillByMonth(time);
        }
    });
    //初始化滚动条
    var initScroll = function () {
        var el = $('#wrapper');
        var height = $(window).height() - el.offset().top;
        el.css({height: height, position: 'relative'});
        var myScroll = new IScroll("wrapper", {
            "hScroll": false,
            "hideScrollbar": false
        });
    };
    //根据选中的月份，进行查询 存入缓存
    var qryBillByMonth = function (time) {
        //传必传参数过去
        var params = {
            billDate: time
        };
        console.info(JSON.stringify(params));
        consumeModel.qryAptitudeReckoning({
            data: params,
            callback: function (response) {
                var temp = response.object;
                //判断 选择的是整年度 还是某个月份
                if (temp.billDate.length > 4) {
                    temp.timeTick = "月度"
                } else {
                    temp.timeTick = "年度"
                }
                temp.billDate = temp.billDate.length > 4 ? temp.billDate.substr(0, 4) + "年" + temp.billDate.substr(4, 2) + "月" : temp.billDate + "年";
                App.storage.set("IntelligentBillData", temp);
                App.navigate("search/wonderfulConsume/index", true);
            },
            errorCallback: function (response) {
                utils.dialog.alert(response.message);
            }
        });
    }
});