define(function (require, exports, module) {
    var consumRankTpl = require("text!../../../template/wonderfulConsume/intelligentBill/consumRanks.html");
    var IScroll = require("vendor/iscroll");
    var self;
    var FormComponent = require("component/form");

    var IndexView = module.exports = FormComponent.extend({
        template: _.template(consumRankTpl),
        initialize: function () {
            self = this;
            var data = App.storage.get("IntelligentBillData");
            App.storage.set("consumRank","consumRank");
            this.model = new Model({
                "custCityName": data.custCityName,
                "consumRatioTotal": data.consumRatioTotal,
                "consumRatioCount": data.consumRatioCount,
                "consumRatioAvg": data.consumRatioAvg
            });
            App.storage.set("consumRank","consumRank");
        },
        onRender: function () {
            var attrs = [
                //本期交易金额
                this.model.attributes.consumRatioTotal,
                //本月交易金额
                this.model.attributes.consumRatioCount,
                //平均交易金额
                this.model.attributes.consumRatioAvg
            ];
            self._renderRatioremark(attrs);
        },
        onShow: function () {

        },
        events: {
        },
        //渲染圆饼
        _renderRatioremark: function (percents) {
            //对应百分比颜色库 因为可能用到5种颜色或者7种颜色
//            var percentsColorsLib = ['#ff6633', '#ff9900', '#7ecef4', '#cc66cc', '#cfa972', "#ffcc33", "#df2938"];
            var consumRatioTotalPercents = Number(percents[0]);
            var consumRatioCountPercents = Number(percents[1]);
            var consumRatioAvgPercents = Number(percents[2]);
            //本期交易金额
            var ratioremarkEl1 = this.$('[data-ratioremark1]');
            if (ratioremarkEl1.length < 1) return;
            ratioremarkEl1.each(function (i, el) {
                var color, style, html,
                    ratioremark = $(el).data('ratioremark');
                (ratioremark <= 10) ? (ratioremark = 10) : (ratioremark = parseFloat(ratioremark));
                new Highcharts.Chart({
                    chart: {
                        renderTo: el,
                        height: 110,
                        width: 110,
                        style: {left: '0px', top: '0px'},
                        backgroundColor: ""
                    },
                    title: { text: ''},
                    tooltip: { enabled: false },
                    colors: [ '#f60', '#aaa'],
                    plotOptions: {
                        pie: {
                            states:{
                                hover:{
                                    enabled:false
                                }
                            },
                            allowPointSelect: false,
                            borderWidth: 0,
                            dataLabels: {
                                enabled: false
                            },
                            size: 100,
                            innerSize: 80,
                            startAngle: 45,
                            center: ['50%', '53%']
                        }
                    },
                    series: [
                        {
                            type: 'pie',
                        data: [consumRatioTotalPercents, 100-consumRatioTotalPercents]
                            //要传的百分比数组
//                            data: percents
                        }
                    ]
                });
            });
            //本月交易金额
            var ratioremarkEl2 = this.$('[data-ratioremark2]');
            if (ratioremarkEl2.length < 1) return;
            ratioremarkEl2.each(function (i, el) {
                var color, style, html
                    ,ratioremark = $(el).data('ratioremark');
                (ratioremark <= 10) ? (ratioremark = 10) : (ratioremark = parseFloat(ratioremark));
                new Highcharts.Chart({
                    chart: {
                        renderTo: el,
                        height: 110,
                        width: 110,
                        style: {left: '0px', top: '0px'},
                        backgroundColor: ""
                    },
                    title: { text: ''},
                    tooltip: { enabled: false },
                    colors: [ '#ff9900', '#aaa'],
                    plotOptions: {
                        pie: {
                            states:{
                                hover:{
                                    enabled:false
                                }
                            },
                            borderWidth: 0,
                            dataLabels: {
                                enabled: false
                            },
                            size: 100,
                            innerSize: 80,
                            startAngle: 45,
                            center: ['50%', '53%']
                        }
                    },
                    series: [
                        {
                            type: 'pie',
                            data: [consumRatioCountPercents, 100-consumRatioCountPercents]
                        }
                    ]
                });
            });
            //平均交易金额
            var ratioremarkEl3 = this.$('[data-ratioremark3]');
            if (ratioremarkEl3.length < 1) return;
            ratioremarkEl3.each(function (i, el) {
                var color, style, html
                    ,ratioremark = $(el).data('ratioremark');
                (ratioremark <= 10) ? (ratioremark = 10) : (ratioremark = parseFloat(ratioremark));
                new Highcharts.Chart({
                    chart: {
                        renderTo: el,
                        height: 110,
                        width: 110,
                        style: {left: '0px', top: '0px'},
                        backgroundColor: ""
                    },
                    title: { text: ''},
                    tooltip: { enabled: false },
                    colors: [ '#077CFD', '#aaa',],
                    plotOptions: {
                        pie: {
                            states:{
                                hover:{
                                    enabled:false
                                }
                            },
                            borderWidth: 0,
                            dataLabels: {
                                enabled: false
                            },
                            size: 100,
                            innerSize: 80,
                            startAngle: 45,
                            center: ['50%', '53%']
                        }
                    },
                    series: [
                        {
                            type: 'pie',
                            data: [consumRatioAvgPercents, 100-consumRatioAvgPercents]
                        }
                    ]
                });
            });
        }
    });
});