define(function (require, exports, module) {
    var intelligentBillTpl = require("text!../../../template/wonderfulConsume/intelligentBill/intelligentBills.html");
//    var IScroll = require("vendor/iscroll");
    var payModel = require("mod/pinganying/model/payModel");
    var payYieldCharts = require("mod/search/view/wonderfulConsume/intelligentBill/payYieldCharts");
    var IScroll = require("vendor/iscroll");
    var self;
    var FormComponent = require("component/form");
    require('highcharts');

    var IndexView = module.exports = FormComponent.extend({
        template: _.template(intelligentBillTpl),
        initialize: function () {
            self = this;
        },
        regions: {
            contentRegion: "#consumTrendChart"
        },
        events: {
            "tap #chooseMonth": "chooseMonth",
            "tap #skipToConsumRank": "skipToConsumRank",
            "tap #consumWay": "skipToConsumWay",
            "tap #consumStory": "skipToConsumStory"
        },
        onRender: function () {
            var ratioreData = this._initRatioremarkData();
            this._renderRatioremark(ratioreData.ways, ratioreData.percents);
        },
        onShow: function () {
            this._showYieldChart();
            self._scroll();
        },
        _scroll: function () {
            var wHeight = $(window).outerHeight(true);
            var tabHeight = $("#choicetip").outerHeight(true);
            var dom = $("#contentRegion").css({"height": wHeight - tabHeight, "position": "relative"});
            this.scroller = new IScroll(dom[0], {
                "hScroll": false,
                "hideScrollbar": false,
                "vScrollbar":false
            });
        },
        //跳转到选择月份的页面
        chooseMonth: function () {
            App.navigate("search/wonderfulConsume/chooseMonth", true);
        },
        //跳转到消费排名页面
        skipToConsumRank: function () {
            App.navigate("search/wonderfulConsume/consumRank", true);
        },
        //跳转到消费去向页面
        skipToConsumWay: function () {
            App.navigate("search/wonderfulConsume/consumWay", true);
        },
        //跳转到消费故事页面
        skipToConsumStory: function () {
            App.navigate("search/wonderfulConsume/index/story", true);
        },
        //展示近一年消费趋势数据
        _showYieldChart: function () {
            var intelligentBillData = App.storage.get("IntelligentBillData");
            self.contentRegion.show(new payYieldCharts({
                view: self,
                data: intelligentBillData,
                model: new Model(intelligentBillData)
            }));

        },
        //初始化圆饼数据
        _initRatioremarkData: function () {
            var tempRatioreData = {};
            var temp = App.storage.get("IntelligentBillData");
            //消费方式列表
            var tempWays = [];
            //消费方式列表中的数据对应的百分比
            var tempPercents = [];
            var consumOwnerList = temp.consumOwnerList;
            /*
             * 最好要求 后台返回的数据是按照倒叙排序的 =====================
             * 将consumOwnerList列表里面的数据按txnIssAmt值进行降序排序
             * 取前面的5个数据,分类讨论consumOwnerList.length<5和>=5的情形
             * */
            for (var j = 0; j < consumOwnerList.length - 1; j++) {
                for (var i = 0; i < consumOwnerList.length - 1; i++) {
                    if (Number(consumOwnerList[i].txnIssAmt) < Number(consumOwnerList[i + 1].txnIssAmt)) {
                        var tempTxnIssAmt = consumOwnerList[i];
                        consumOwnerList[i] = consumOwnerList[i + 1];
                        consumOwnerList[i + 1] = tempTxnIssAmt;
                    }
                }
            }
            //本月度总消费金额
            var consumAmtTotal = temp.consumAmtTotal;
            if (consumOwnerList.length <= 5) {
                var sum = 0;
                for (var i = 0, cOLLength = consumOwnerList.length; i < cOLLength; i++) {
                    var consumTypeName = consumOwnerList[i].consumTypeName;
                    var consumPercent = parseInt(Number(consumOwnerList[i].txnIssAmt) / Number(consumAmtTotal) * 100);
                    tempWays.push(consumTypeName);
                    if (i + 1 === cOLLength) {
                        tempPercents.push(100 - sum);
                    } else {
                        sum = sum + consumPercent;
                        tempPercents.push(consumPercent);
                    }
                }
                tempRatioreData.ways = tempWays;
                tempRatioreData.percents = tempPercents;
                return tempRatioreData;
            } else {
//              后台返回消费方式数组，超过5条
                var sum = 0;
                for (var i = 0, cOLLength = consumOwnerList.length; i < cOLLength && i <= 5; i++) {
                    var consumTypeName = consumOwnerList[i].consumTypeName;
                    var consumPercent = parseInt(Number(consumOwnerList[i].txnIssAmt) / Number(consumAmtTotal) * 100);
                    tempWays.push(consumTypeName);
                    tempPercents.push(consumPercent);
                    sum = sum + consumPercent;
                }
                tempWays.push("其他");
                tempPercents.push(100 - sum);
                tempRatioreData.ways = tempWays;
                tempRatioreData.percents = tempPercents;
                return tempRatioreData;
            }
        },
        //渲染圆饼
        _renderRatioremark: function (consumWays, percents) {
            //对应百分比颜色库 因为可能用到5种颜色或者7种颜色  (需求说明提到最多5种)
            var percentsColorsLib = ['#ff6633', '#ff9900', '#7ecef4', '#cc66cc', '#cfa972', "#ffcc33", "#df2938"];
            var percentsColors = [];
            for (var i = 0; i < consumWays.length; i++) {
                percentsColors.push(percentsColorsLib[i]);
            }
            var ratioremarkEl = this.$('[data-ratioremark]');
            if (ratioremarkEl.length < 1) return;
            ratioremarkEl.each(function (i, el) {
                var color, style, html,
                    ratioremark = $(el).data('ratioremark');
                (ratioremark <= 10) ? (ratioremark = 10) : (ratioremark = parseFloat(ratioremark));
                new Highcharts.Chart({
                    chart: {
                        renderTo: el,
                        height: 138,
                        width: 138,
                        style: {left: '0px', top: '0px'},
                        backgroundColor: ""
                    },
                    title: { text: ''},
                    tooltip: { enabled: false },
                    colors: percentsColors,
                    plotOptions: {
                        pie: {
                            states: {
                                hover: {
                                    enabled: false
                                }
                            },
                            borderWidth: 0,
                            dataLabels: {
                                enabled: false
                            },
                            size: 138,
                            innerSize: 100,
                            startAngle: 45,
                            center: ['50%', '53%']
                        }
                    },
                    series: [
                        {
                            type: 'pie',
                            data: percents
                        }
                    ]
                });
            });
        }
    });
});