define(function (require, exports, module) {
    require("highcharts");
    var temp = require("text!mod/search/template/wonderfulConsume/intelligentBill/payYieldCharts.html");

    module.exports = ItemView.extend({
        template: _.template(temp),
        events: {
            "tap #consumeList_history": "toConsumeStory"
        },
        onRender: function () {
            this.chartsData();
        },
        toConsumeStory: function () {
            $("#consume_story").trigger("tap");
        },

        chartsData: function () {
            var d = this.model.attributes.consumTrendList;
            var categories = [];
            var data = [];
            var tempD;
            for (var i = 0, len = d.length; i < len; i++) {
                tempD = d[i];
                categories.push(this._getCategorieLabel(tempD.transMonth));
                data.push({
                    name: this._getYearMonthDayLabel(tempD.transMonth),
                    y: Number(tempD.txnIssAmt || 0)
                });
            }
            this._doCharts2(categories, data);
        },

        _getCategorieLabel: function (mStr) {
//            mStr=201306
//            if (!mStr) return '';
//            return Number(mStr.substring(4,6)) + '-' +  Number(mStr.substring(6,8));
            if (!mStr) return '';
            var month = mStr.substring(4, 6);
            if (month[0] !== "0") {
//                return month + "月";
                return month;
            } else {
                return month[1];
//                return month[1] + "月";
            }
        },

        _getYearMonthDayLabel: function (mStr) {
            if (!mStr) return '';
            var month = mStr.substring(4, 6);
            if (month[0] !== "0") {
                return mStr.substring(0, 4) + '年' + month + "月";
            } else {
                return mStr.substring(0, 4) + '年' + month[1] + "月";
            }
        },

        _doCharts2: function (categories, data) {
            for (var i = 0, Length = data.length, max = data[0].y; i < Length - 1; i++) {
                if (max < data[i + 1].y) {
                    max = data[i + 1].y;
                }
            }
            for (var j = 0, Length = data.length; j < Length; j++) {
                data[j].z = utils.string.formatMoneyNumber(data[j].y);
            }
            this.$('#chartsContainer').highcharts({
                chart: {
                    type: 'area'
                },
                title: {
                    text: ''
                },
                legend: {
                    enabled: false
                },
                xAxis: {
                    gridLineWidth: 1,
                    gridLineColor: '#ffdf7f',
                    tickColor: "#ffdf7f",   //纵轴线(刻度)的颜色
                    tickWidth: 1,          //纵轴线(刻度)的线宽
                    tickPosition: "inside", //刻度线相对于轴线的位置  有inside和outside
                    lineWidth: 0,          //横轴的宽度
//                    lineColor:"",        //横轴的颜色
//                    offset: 20,            //横轴离最近刻度的横轴的距离
                    // tickmarkPlacement: 'on', // label对齐tick
                    categories: categories,
                    title: {
                        enabled: false
                    }
                },
                yAxis: {
                    max: (max === 0) ? 10000 : max,
                    maxPadding: 10,         //y轴方向 数据的点与最高横轴的距离
                    min: 0,
                    startOnTick: true,
                    gridLineWidth: 1,
                    gridLineColor: '#ffdf7f',
                    tickPixelInterval: 20,
                    title: {
                        enabled: false
                    },
                    labels: {
                        enabled: true
                    }

                },
                plotOptions: {
                    area: {
                        lineWidth: 2,
                        lineColor: '#ffc000',
                        color: '#ffc000',
                        fillOpacity: 0.2,
                        marker: {
                            radius: 5,
                            fillColor: '#ffffff',
                            lineWidth: 3,
                            lineColor: "#ffc000"
                        }
                    },
                    series: {
                        marker: {
                            states: {
                                hover: {
                                    lineWidth: 3,
                                    radius: 8
                                }
                            }
                        }
                    }
                },
                tooltip: {
                    animation: false,
                    enabled: true,
                    shared: false,
                    useHTML: true,
                    headerFormat: '',
                    footerFormat: '',
                    pointFormat: '<div style="font-size:14px;">￥{point.z}</div><div style="font-size:12px;color:#999;">{point.name}</div>'

                },
                series: [
                    {
                        data: data
                    }
                ]
            });
        }
    });
});
