/**
 * liujun
 * 智能理财
 *
 */
define(function(require, exports, module){
    var IndexView = require("../view/index");
    var evaluatedView = require("../view/evaluated");
    var evaluateResultView = require("../view/evaluateResult");
    var signView = require("../view/sign");
    var signedView = require("../view/signed");
    var prdDateView = require("../view/prdDate");
    var smartFinancialSuccessView = require("../view/smartFinancialSuccess");
    var executeRecordView = require("../view/executeRecord");
    var orderSmartFinancialView = require("../view/orderSmartFinancial");
    var smartFinancialModel  = require("../model/smartFinancial");
    var FUND_CODE_DAHUA   = config.values.fund_code_dahua;
    var Index = module.exports = Controller.extend({
        actions : {
            index : "index",                       //未评测页
            evaluated: "evaluated",               //已评测页
            evaluateResult: "evaluateResult",     //风测结果页
            sign: "sign",                //签约页
            signed : "signed",          //已签约页
            prdDate: "prdDate",          //签约页，产品期限选择页
            order: "order",                  //确认预约购买
            executeRecord: "executeRecord",            //执行记录
            "executeRecord/:code": "executeRecord",
            smartFinancialSuccess: "smartFinancialSuccess"
        },
        //智能理财引导页
        index : function(query){
            App.header.reset({
                title : "智能理财",
                leftButtonContent : "@back",
                leftButtonHandler : function(){
                    if(App.storage.get("smartFinancial/smartFinancial/fromPage")){
                        var prdType = App.storage.remove("smartFinancial/smartFinancial/fromPage");
                        switch(prdType){
                            case 1:
                                App.navigate('myProperty/myProperty/index', true);
                                break;
                            case 2:
                                App.navigate('index/indexLogined/index', true);
                                break;
                            case 3:
                                App.navigate('products/index/index/depositTake', true);
                                break;    
                        }
                    }else{
                        App.navigate('index/indexLogined/index', true);
                    }
                }
            });
            App.footer.reset({
                "visible": false
            });
            //加载后，其余部分视图initialize中处理
            App.container.show(new IndexView());
        },
        //智能理财已评测页
        evaluated : function(query){
            App.header.reset({
                title : "智能理财",
                leftButtonContent : "@back",
                leftButtonHandler : function(){
                    if(App.storage.get("smartFinancial/smartFinancial/fromPage")){
                        var prdType = App.storage.remove("smartFinancial/smartFinancial/fromPage");
                        switch(prdType){
                            case 1:
                                App.navigate('myProperty/myProperty/index', true);
                                break;
                            case 2:
                                App.navigate('index/indexLogined/index', true);
                                break;
                            case 3:
                                App.navigate('products/index/index/depositTake', true);
                                break;    
                        }
                    }else{
                        App.navigate('index/indexLogined/index', true);
                    }
                }
            });
            App.footer.reset({
                "visible": false
            });
            //加载后，其余部分视图initialize中处理
            App.container.show(new evaluatedView());
        },
        //智能理财评测结果页
        evaluateResult : function(query){
            App.header.reset({
                title : "智能理财",
                leftButtonContent : "@back",
                leftButtonHandler : function(){
                    if(App.storage.get("smartFinancial/smartFinancial/fromPage")){
                        var prdType = App.storage.remove("smartFinancial/smartFinancial/fromPage");
                        switch(prdType){
                            case 1:
                                App.navigate('myProperty/myProperty/index', true);
                                break;
                            case 2:
                                App.navigate('index/indexLogined/index', true);
                                break;
                            case 3:
                                App.navigate('products/index/index/depositTake', true);
                                break;    
                        }
                    }else{
                        App.navigate('index/indexLogined/index', true);
                    }
                }
            });
            App.footer.reset({
                "visible": false,
                selectedIndex: 3
            });

            var ansIdList = App.storage.remove('riskExam/ansIdList');
            if (!ansIdList) return;
            
            //首次风测0是首次风测1不是首次风测
            smartFinancialModel.checkFirstRisk({
                url : "checkFirstRisk",
                callback : function(res){
                    App.storage.set("firstRiskType",res.object.firRa);
                    smartFinancialModel.riskExam({
                        param:{
                            "riskAnswer": ansIdList.join(',')
                        },
                        success:function(response){
                            // var view = new evaluateResultView({
                            //     model: new Model(response)
                            // });
                            var view = new evaluateResultView(response);
                            
                            // view.on('confirm', function(){
                            //     App.navigate('', true);
                            // });
                            
                            App.container.show(view);
                        },
                        error:function(response){
                            alert(response.message);
                        }
                    });
                },
                errorCallback : function(res){
                    utils.dialog.alert(res.message);
                }
            });
            
            
            // App.container.show(new evaluateResultView());
        },
        //智能理财未签约页
        sign: function(){
            App.header.reset({
                title : "智能理财签约",
                leftButtonContent : "@back",
                leftButtonHandler : function(){
                    if(App.storage.get("smartFinancial/smartFinancial/fromPage")){
                        if(App.storage.get("smartFinancial/smartFinancial/signed/edit")){
                            App.navigate("smartFinancial/smartFinancial/signed",true);
                        }else{
                            if(App.storage.get("smartFinancial/smartFinancial/sign/evaluated")){
                                App.storage.remove("smartFinancial/smartFinancial/sign/evaluated");
                                App.navigate('smartFinancial/smartFinancial/evaluated', true);
                            }else{
                                var prdType = App.storage.remove("smartFinancial/smartFinancial/fromPage");
                                switch(prdType){
                                    case 1:
                                        App.navigate('myProperty/myProperty/index', true);
                                        break; 
                                    case 2:
                                        App.navigate('index/indexLogined/index', true);
                                        break;
                                    case 3:
                                        App.navigate('products/index/index/depositTake', true);
                                        break;    
                                }
                            }
                        }
                    }else{
                        App.navigate('index/indexLogined/index', true);
                    }
                }
            });
            App.footer.reset({
                "visible": false,
                selectedIndex: 3
            });
            var promise= smartFinancialModel.qrySmartFinancialState();
            promise.done(_.bind(function(arg1){
                arg1 = arg1.object;
                if(arg1){
                    var data = {};
                    data = arg1;
                    if(arg1.status == "1"){
                        //如果以往是解约状态
                        //add 未签约，解约tips
                        if(App.storage.get("smartInSignPage")){
                            App.storage.remove("smartInSignPage");
                            App.storage.set("smartUnsignedTips",true);
                        }
                        App.storage.set("smartFinancial/smartFinancial/sign/again",true);
                        data.level = App.storage.get("smartFinancialLevel");
                        App.container.show(new signView(data));
                    }else{
                        data.level = App.storage.get("smartFinancialLevel");
                        App.container.show(new signView(data));
                    }
                }else{
                    if(App.storage.get("smartFinancialLevel")){
                        //add 未签约，解约tips
                        if(App.storage.get("smartInSignPage")){
                            App.storage.remove("smartInSignPage");
                            App.storage.set("smartUnsignedTips",true);
                        }
                        var data = {};
                        data.level = App.storage.get("smartFinancialLevel");
                        App.container.show(new signView(data)); 
                    }else{
                        // App.container.show(new signView());
                        utils.dialog.toast("没有风险测评等级"); 
                    }
                }
            },this));

            promise.fail(function(err){
                utils.dialog.toast(err.message);
            });
        },
        //签约页产品期限选择
        prdDate: function(){
            App.header.reset({
                title : "产品期限",
                leftButtonContent : "@back",
                leftButtonHandler : function(){
                     App.navigate('smartFinancial/smartFinancial/sign', true);
                }
            });
            App.footer.reset({
                "visible": false,
                selectedIndex: 3
            });
            
            App.container.show(new prdDateView()); 
        },
        //智能理财成功页
        smartFinancialSuccess: function(){
            App.header.reset({
                title : "智能理财",
                leftButtonContent : "@back",
                leftButtonHandler : function(){
                    //已签约页
                    App.navigate('smartFinancial/smartFinancial/signed', true);
                }
            });
            App.footer.reset({
                "visible": false,
                selectedIndex: 3
            });
            
            App.container.show(new smartFinancialSuccessView()); 
        },
        //智能理财预约购买页
        order: function(){
            App.header.reset({
                title : "智能理财",
                leftButtonContent : "@back",
                leftButtonHandler : function(){
                    //已签约页
                    App.navigate('smartFinancial/smartFinancial/signed', true);
                }
            });
            App.footer.reset({
                "visible": false,
                selectedIndex: 3
            });
            if(App.storage.get("smartFinancial/smartFinancial/order")){
                var data = {};
                data = App.storage.remove("smartFinancial/smartFinancial/order");
                App.container.show(new orderSmartFinancialView(data));  
            }else{
                App.container.show(new orderSmartFinancialView());  
            } 
        },
        //智能理财已签约页
        signed: function(){
            App.header.reset({
                title : "智能理财",
                leftButtonContent : "@back",
                leftButtonHandler : function(){
                    if(App.storage.get("smartFinancial/smartFinancial/fromPage")){
                        var prdType = App.storage.remove("smartFinancial/smartFinancial/fromPage");
                        switch(prdType){
                            case 1:
                                App.navigate('myProperty/myProperty/index', true);
                                break;
                            case 2:
                                App.navigate('index/indexLogined/index', true);
                                break;
                            case 3:
                                App.navigate('products/index/index/depositTake', true);
                                break;    
                        }
                    }else{
                        App.navigate('index/indexLogined/index', true);
                    }
                },
                rightButtonContent : "@more",
                rightButtonHandler : function(){
                    if($('.SmartF_pop').css('display') == "none"){
                        $('.SmartF_pop').css('display','auto');
                    }else{
                        $('.SmartF_pop').css('display','none');
                    }
                }
            });
            App.footer.reset({
                "visible": false
            });
            //加载后，其余部分视图initialize中处理
            var promise = smartFinancialModel.qrySmartFinancialState();

                promise.done(_.bind(function(arg1){
                    arg1 = arg1.object;
                    if(arg1.prod_pay == "1" && arg1.prod_pap == "1"){
                        //如果平安盈与平安票都签，昨日收益累加
                        //查询平安盈、查询平安票产品、查询平安票未确定产品
                        var promisePrd = $.when(
                            smartFinancialModel.qryPinganyingDhMoney({ data: {prdCode: FUND_CODE_DAHUA} }),
                            smartFinancialModel.qryPapRemainPrd(),
                            smartFinancialModel.qryUnsureProduct(),
                            smartFinancialModel.qryPapEntrustPrd(),
                            smartFinancialModel.qryPinganyingInfo({ data: {prdCode: FUND_CODE_DAHUA} })
                            //平安票接口，以及未确定product接口
                        );

                        promisePrd.done(_.bind(function(arg2,arg3,arg4,arg5,arg6){
                            var arg2 = arg2[0].object;
                            var arg3 = arg3[0].object;
                            var arg4 = arg4[0].object;
                            var arg5 = arg5[0].object;
                            var arg6 = arg6[0].object;
                            var prdData = {};
                            prdData.smartFinancialStatus = arg1;
                            prdData.pinganying = arg2;
                            prdData.pinganpiao = arg3;
                            prdData.unsure = arg4;
                            prdData.papEntrust = arg5;
                            prdData.pinganyingInfo = arg6;
                            App.container.show(new signedView(prdData)); 

                        },this));

                        promisePrd.fail(function(err){
                            utils.dialog.toast(err.message);
                        });

                    }else if(arg1.prod_pay == "1"){
                        //只查平安盈，只有平安盈昨日收益
                        // smartFinancialModel.qryPinganyingDhMoneyTip({
                        //     data: {prdCode: FUND_CODE_DAHUA},
                        //     callback: function(res){
                        //         var prdData = {};
                        //         prdData.smartFinancialStatus = arg1;
                        //         prdData.pinganying = res.object;
                        //         App.container.show(new signedView(prdData)); 
                        //     },
                        //     errorCallback: function(err){
                        //         utils.dialog.toast(err.message);
                        //     }
                        // });
                        var promisePay = $.when(
                            smartFinancialModel.qryPinganyingDhMoney({ data: {prdCode: FUND_CODE_DAHUA} }),
                            smartFinancialModel.qryPinganyingInfo({ data: {prdCode: FUND_CODE_DAHUA} })
                        );

                        promisePay.done(_.bind(function(arg7,arg8){
                            var prdData = {};
                            prdData.smartFinancialStatus = arg1;
                            prdData.pinganying = arg7[0].object;
                            prdData.pinganyingInfo = arg8[0].object;
                            App.container.show(new signedView(prdData)); 
                        },this));

                        promisePay.fail(function(err){
                            utils.dialog.toast(err.message);
                        });
                    }else{ 
                        App.container.show(new signedView());
                    }
                },this));

                promise.fail(function(err){
                    utils.dialog.toast(err.message);
                });
        }, 
        //执行记录分页查询参数配置
        _getDefaultParam: function(){
            var date = new Date(App.storage.get("Login_SysTime") || new Date()); 
            return {
                "startDate": utils.date.diffDateAdd(date,-7,'d').format("yyyy-MM-dd"),
                "endDate"  : utils.date.diffDateAdd(date,0,'d').format("yyyy-MM-dd"),
                "pageIndex": 1,
                "pageSize" : 10
                // "prdCode"  : code,
                // ,"account"  : App.storage.get("UserInfo").get("accNumber")
            };
        },
        //执行记录
        executeRecord: function(){
            App.header.reset({
                title : "智能理财",
                leftButtonContent : "@back",
                leftButtonHandler : function(){
                    //已签约页
                    App.navigate('smartFinancial/smartFinancial/signed', true);
                }
            });
            App.footer.reset({
                "visible": false,
                selectedIndex: 3
            });
            var param = this._getDefaultParam();
            App.container.show(new executeRecordView({"model":new Model({'param':param})}));
        }
    });
})
