define(function(require,exports,module){
    var smartFinancialModel = module.exports = Model.extend({},{
        
        //查询智能理财签约状态
        qrySmartFinancialState: function(){
            return App.request("qrySmartFinancialStatus",{
                data: {}
            });
        },
        //签约
        confirmSmartFinancial: function(options){
            App.request(options.url,{
                data: options.data,
                success: function(res){
                    if(res.success){
                        options.callback(res);
                    }
                },
                error: function(err){
                    options.errorCallback(err);
                }
            });
        },

        //修改协议
        editSmartFinancial: function(options){
            App.request(options.url,{
                data: options.data,
                success: function(res){
                    if(res.success){
                        options.callback(res);
                    }
                },
                error: function(err){
                    options.errorCallback(err);
                }
            });
        },

        riskAbilityTestQry: function(){
            return App.request("riskAbilityTestQry",{
                data: {"channelType" : "0"}
            });
        },
        //平安盈大华收益查询
        qryPinganyingDhMoney: function(options){
        	return App.request("paydhProductMoneyQry",{
                data: options.data
            });
        },

        qryPinganyingDhMoneyTip: function(options){
        	App.request("paydhProductMoneyQry",{
                data: options.data,
                success: function(res){
                	if(res.success){
                		options.callback(res);
                	}
                },
                error: function(err){
                	options.errorCallback(err);
                }
            });
        },
        //平安盈收益信息
        qryPinganyingInfo: function(options){
            return App.request("qryPaYingInfo",{
                data: options.data
            });
        },

        //平安票持有
        qryPapRemainPrd: function(){
        	return App.request("qryPapRemainList",{
                data: {}
            });
        },
        //平安票委托
        qryPapEntrustPrd: function(){
            return App.request("qryPapEntrustList",{
                data: {}
            });
        },

        //修改签约状态
        editStatusSmartFinancial: function(options){
            App.request(options.url,{
                data: options.data,
                success: function(res){
                    if(res.success){
                        options.callback(res);
                    }
                },
                error: function(err){
                    options.errorCallback(err);
                }
            });
        },

        //未有执行记录时间查询接口
        qryExecuteRecord : function(options){
            App.request("smartFinancialExecuteRecord",{
                data : options.param,
                success : function(res){
                    options.callback && options.callback(res);
                },
                error : function(err){
                    options.errorCallback && options.errorCallback(err);
                },
                complete: function(){
                    options.complete && options.complete();
                }
            });
        },

        //查询未确定产品
        qryUnsureProduct: function(){
            return App.request("qryUnsurePrdList",{
                data: {}
            });
        },

        //委托购买
        confirmBuySF: function(options){
            App.request(options.url,{
                data: options.data,
                success: function(res){
                    if(res.success){
                        options.callback(res);
                    }
                },
                error: function(err){
                    options.errorCallback(err);
                }
            });
        },

        //委托撤销
        cancelBuySF: function(options){
            App.request(options.url,{
                data: options.data,
                success: function(res){
                    if(res.success){
                        options.callback(res);
                    }
                },
                error: function(err){
                    options.errorCallback(err);
                }
            });
        },
        
        /**
         * 
         * 是否首次风险测评
         */
        checkFirstRisk : function(options){
            App.request(options.url,{
                data: options.data,
                success: function(res){
                    if(res.success){
                        options.callback && options.callback(res);
                    }
                },
                error: function(err){
                    options.errorCallback && options.errorCallback(err);
                }
            });
        },

        standards:[{
          "prdRiskLevelName":"一级（低）",
          "score":"",
          "riskLevel":"1",
          "riskStatus":"",
          "scoreman":"稳健型投资者",
          "items":{
             "1":"稳定收益",
             "2":"40-70",
             "3":"25-60",
             "4":"0-5"

        } 
       	},{
         "prdRiskLevelName":"二级（中低）",
         "score":"",
          "riskLevel":"2",      
          "riskStatus":"",      
          "scoreman":"稳健型投资者",
          "items":{
             "1":"中等收益",
             "2":"10-25",
             "3":"25-65",
             "4":"25-50"
          } 
        },{
          "prdRiskLevelName":"三级（中）",
          "score":"",
          "riskLevel":"3",    
          "riskStatus":"",       
          "scoreman":"平衡型投资者",
          "items":{
             "1":"中等收益",
             "2":"10-25",
             "3":"25-65",
             "4":"25-50"
          } 
        },{
          "prdRiskLevelName":"四级（中高）",
          "score":"",
          "riskLevel":"4",  
          "riskStatus":"",        
          "scoreman":"成长型投资者",
          "items":{
             "1":"高收益",
             "2":"5-20",
             "3":"5-45",
             "4":"50-75"
          } 
        },{
          "prdRiskLevelName":"五级（高）",
          "score":"",
          "riskLevel":"5",  
          "riskStatus":"",        
          "scoreman":"进取型投资者",
          "items":{
             "1":"高收益",
             "2":"5-10",
             "3":"0-45",
             "4":"50-90"
          } 
        },{
          "prdRiskLevelName":"",
          "riskLevel":"",  
          "riskStatus":"稳健型投资者",        
          "items":{
            
          } 
        }],

        riskExam:function(options){
            var self=this;
            var success=options.success;
            var error=options.error;
            var param=options.param;
            App.request("riskExam",{
                data:param,
                success:function(response){
                    var tempData = {};
                    $.each(self.standards,function(i,temp){
                            if(response.object.riskLevel == temp.riskLevel){
                                tempData = temp;
                                tempData.riskStatus = response.object.riskStatus;
                                tempData.riskLevelName = response.object.riskLevelName;
                                tempData.score=response.object.score;
                                tempData.list = response.object.list[0];
                                return;
                            }
                    });
                    success(tempData);
                },
                error:function(response){
                    error(response);
                }
            });
        },

        questionList: function(){
            var list = {"list":[{
                "que": "1,你的年龄是？",
                "ans": [{
                    "id": "A",
                    "text": "18-30岁",
                    "class":"iconB01 m_t10",
                     "msg":"(我是小青年)",
                     "pageid":"0"
                     
                    	 
                },{
                    "id": "B",
                    "text": "31-50岁",
                    "class":"iconB02 m_t10",
                    "msg":"(我是正值壮年)",
                    "pageid":"0"
                    
                    	
                },{
                    "id": "C",
                    "text": "51-60岁",
                    "class":"iconB03 m_t10",
                    "msg":"(人到中年)",
                    "pageid":"0"
                    
                },{
                    "id": "D",
                    "text": "高于60岁",
                    "class":"iconB04 m_t10",
                    "msg":"(我是退休老年人)",
                    "pageid":"0"
                    
                }]
            },{
                "que": "2,你的家庭年收入为(折合人民币)？",
                "ans": [{
                    "id": "A",
                    "text": "5万元以下",
                    "class":"iconB05 m_t10",
                    "msg":"(草根家庭)",
                    "pageid":"1"
                    
                },{
                    "id": "B",
                    "text": "5-20万元",
                    "class":"iconB06 m_t10",
                    "msg":"(普通家庭)",
                    "pageid":"1"
                    
                },{
                    "id": "C",
                    "text": "20-50万元",
                    "class":"iconB07 m_t10",
                    "msg":"(小资家庭)",
                    "pageid":"1"
                    
                },{
                    "id": "D",
                    "text": "50-100万元",
                    "class":"iconB08 m_t10",
                    "msg":"(中产家庭)",
                    "pageid":"1"
                    
                },{
                    "id": "E",
                    "text": "100万元以上",
                    "class":"iconB09 m_t10",
                    "msg":"(精英家庭)",
                    "pageid":"1"
                    
                },null]
            },{
                "que": "3,在你每年的家庭收入中，可用于金额投资(储蓄存款除外)的比例为？",
                "ans": [{
                    "id": "A",
                    "text": "小于10%",
                    "class":"iconB10 m_t10",
                    "msg":"",
                    "pageid":"2"
                    
                },{
                    "id": "B",
                    "text": "10%至25%",
                    "class":"iconB11 m_t10",
                    "msg":"",
                    "pageid":"2"
                    
                },{
                    "id": "C",
                    "text": "25%至50%",
                    "class":"iconB10 m_t10",
                    "msg":"",
                    "pageid":"2"
                    
                },{
                    "id": "D",
                    "text": "大于50%",
                    "class":"iconB11 m_t10",
                    "msg":"",
                    "pageid":"2"
                    
                }]
            },{
                "que": "4,以下哪项最能说明你的投资经验？",
                "ans": [{
                    "id": "A",
                    "text": "除存款、国债外，我几乎不投资其他金融产品",
                    "class":"iconB14 m_t10",
                    "msg":"",
                    "pageid":"3"
                    
                },{
                    "id": "B",
                    "text": "大部分投资于存款、国债等，较少投资于股票、基金等风险产品",
                    "class":"iconB15 m_t10",
                    "msg":"",
                    "pageid":"3"
                    
                },{
                    "id": "C",
                    "text": "资产均衡地分布于存款、国债、银行理财产品、信托产品、股票、基金等",
                    "class":"iconB16 m_t10",
                    "msg":"",
                    "pageid":"3"
                    
                },{
                    "id": "D",
                    "text": "大部分投资于股票、基金、外汇等高风险产品，较少投资于存款、国债",
                    "class":"iconB17 m_t10",
                    "msg":"",
                    "pageid":"3"
                    
                }]
            },{
                "que": "5,你有多少年投资股票、基金、外汇、金融衍生产品等风险投资品的经验？",
                "ans": [{
                    "id": "A",
                    "text": "没有经验",
                    "class":"iconB18 m_t10",
                    "msg":"",
                    "pageid":"4"
                    
                },{
                    "id": "B",
                    "text": "少于2年",
                    "class":"iconB19 m_t10",
                    "msg":"",
                    "pageid":"4"
                    
                },{
                    "id": "C",
                    "text": "2至5年",
                    "class":"iconB20 m_t10",
                    "msg":"",
                    "pageid":"4"
                    
                },{
                    "id": "D",
                    "text": "5至8年",
                    "class":"iconB21 m_t10",
                    "msg":"",
                    "pageid":"4"
                    
                },{
                    "id": "E",
                    "text": "8年以上",
                    "class":"iconB22 m_t10",
                    "msg":"",
                    "pageid":"4"
                    
                },null]
            },{
                "que": "6,以下哪项描述最符合你的投资态度？",
                "ans": [{
                    "id": "A",
                    "text": "风险厌恶，不希望本金损失，希望获得稳定回报",
                    "class":"iconB23 m_t10",
                    "msg":"",
                    "pageid":"5"
                    
                },{
                    "id": "B",
                    "text": "保守投资，不希望本金损失，愿意承担一定幅度的收益波动",
                    "class":"iconB24 m_t10",
                    "msg":"",
                    "pageid":"5"
                    
                },{
                    "id": "C",
                    "text": "寻求资金的较高收益和成长性，愿意为此承担有限本金损失",
                    "class":"iconB25 m_t10",
                    "msg":"",
                    "pageid":"5"
                    
                },{
                    "id": "D",
                    "text": "希望赚取高回报，愿意为此承担较大本金损失",
                    "class":"iconB26 m_t10",
                    "msg":"",
                    "pageid":"5"
                    
                }]
            },{
                "que": "7,以下情况，你会选择哪一种？",
                "ans": [{
                    "id": "A",
                    "text": "有100%的机会赢取1000元现金",
                    "class":"iconB27 m_t10",
                    "msg":"",
                    "pageid":"6"
                    
                },{
                    "id": "B",
                    "text": "有50%的机会赢取5万元现金",
                    "class":"iconB28 m_t10",
                    "msg":"",
                    "pageid":"6"
                    
                },{
                    "id": "C",
                    "text": "有25%的机会赢取50万元现金",
                    "class":"iconB29 m_t10",
                    "msg":"",
                    "pageid":"6"
                    
                },{
                    "id": "D",
                    "text": "有10%的机会赢取100万元现金",
                    "class":"iconB30 m_t10",
                    "msg":"",
                    "pageid":"6"
                    
                }]
            },{
                "que": "8,你计划的投资期限是多久？",
                "ans": [{
                    "id": "A",
                    "text": "1年以下",
                    "class":"iconB31 m_t10",
                    "msg":"",
                    "pageid":"7"
                    
                },{
                    "id": "B",
                    "text": "1-3年",
                    "class":"iconB32 m_t10",
                    "msg":"",
                    "pageid":"7"
                    
                },{
                    "id": "C",
                    "text": "3-5年",
                    "class":"iconB33 m_t10",
                    "msg":"",
                    "pageid":"7"
                    
                },{
                    "id": "D",
                    "text": "5年以上",
                    "class":"iconB34 m_t10",
                    "msg":"",
                    "pageid":"7"
                    
                }]
            },{
                "que": "9,你的投资目的？",
                "ans": [{
                    "id": "A",
                    "text": "资产保值",
                    "class":"iconB35 m_t10",
                    "msg":"",
                    "pageid":"8"
                    
                },{
                    "id": "B",
                    "text": "资产稳健增长",
                    "class":"iconB36 m_t10",
                    "msg":"",
                    "pageid":"8"
                    
                },{
                    "id": "C",
                    "text": "资产迅速增长",
                    "class":"iconB37 m_t10",
                    "msg":"",
                    "pageid":"8"
                    
                },null]
            },{
                "que": "10,你的投资出现何种程度的波动时，你会呈现明显的焦虑？",
                "ans": [{
                    "id": "A",
                    "text": "本金无损失，但收益未达预期",
                    "class":"iconB14 m_t10",
                    "msg":"",
                    "pageid":"9"
                    
                },{
                    "id": "B",
                    "text": "出现轻微本金损失",
                    "class":"iconB15 m_t10",
                    "msg":"",
                    "pageid":"9"
                    
                },{
                    "id": "C",
                    "text": "本金10%以内的损失",
                    "class":"iconB16 m_t10",
                    "msg":"",
                    "pageid":"9"
                    
                },{
                    "id": "D",
                    "text": "本金20-50%的损失",
                    "class":"iconB17 m_t10",
                    "msg":"",
                    "pageid":"9"
                    
                },{
                    "id": "E",
                    "text": "本金50%以上的损失",
                    "class":"iconB17 m_t10",
                    "msg":"",
                    "pageid":"9"
                    
                },null]
            }]};
            
            return list;
        }

    });
});

