/*
*  智能理财-结果页
*  liujun
*/
define(function(require, exports, module){
    var evaluateResultHtml = require("text!../template/evaluateResult.html");
    require("highcharts");
    require("highchartsMore");
    var smartFinancialModel = require("../model/smartFinancial");
    var accountModel  = require("mod/common/model/accountModel");

    var IndexView = module.exports = ItemView.extend({
        template : _.template(evaluateResultHtml),

        events: {
           "tap #signBtn": "signBtn",
           "tap #againEvaluate": "againEvaluate"
        },

        initialize: function(obj){
            result = [];
            result.push(obj.list.financialFlow);
            result.push(obj.list.financialStrength);
            result.push(obj.list.investExperience);
            result.push(obj.list.willingGain);
            result.push(obj.list.riskCapacity);
            data = obj;
        },

        onRender: function(){
            this.evaluateResultChart();
        },

        onShow: function(){
            if(App.storage.get("smartFinancialRisk")){
                App.storage.remove("smartFinancialRisk");
            }
            $("#evaluateResultChart").find(".highcharts-container").css("overflow","visible");
            $("#evaluateResultChart").find(".highcharts-container").children("svg").css({"overflow":"visible"});

            //是否送万里通积分
            this.checkFirstRisk();
        },
        //结果蜘蛛网图
        evaluateResultChart: function(){
            this.$('#evaluateResultChart').highcharts({

                chart: {
                    polar: true,
                    type: 'area',
                    height: ($(window).height())/2
                },

                title: {
                    text: ''
                },

                pane: {
                    size: '65%'
                },

                xAxis: {
                    categories: ['资金流动需求', '资金实力', '投资经验', '盈利意愿', '风险承受力'],
                    tickmarkPlacement: 'on',
                    lineWidth: 0
                },

                yAxis: {
                    gridLineInterpolation: 'polygon',
                    lineWidth: 0,
                    labels:{
                        enabled: false
                    },
                    tickInterval: 1.8,
                    floor: 0,
                    ceiling: 9,
                    plotBands: [
                        {
                          from: 0,
                          to: 1.8,
                          color: "#f7f7f7"
                        },
                        {
                          from: 1.8,
                          to: 3.6,
                          color: "#ffffff"
                        },
                        {
                          from: 3.6,
                          to: 5.4,
                          color: "#f7f7f7"
                        },
                        {
                          from: 5.4,
                          to: 7.2,
                          color: "#ffffff"
                        },
                        {
                          from: 7.2,
                          to: 9,
                          color: "#f7f7f7"
                        }
                    ]
                },

                tooltip: {
                    // enabled: true,
                    // shared: true,
                    style: {
                        display: "none"
                    }
                    // pointFormat: '<span style="color:{series.color}">{series.name}: <b>${point.y:,.0f}</b><br>'
                    // pointFormat: '<span style="color:{series.color}">{series.name}: <b>${point.y:,.0f}</b><br>'
                },

                legend: {
                    enabled: false,
                },

                series: [
                    {
                        // name: 'Allocated Budget',
                        data: [2*(result[0]), result[1],result[2], result[3]*(1.285), result[4]],
                        pointPlacement: 'on',
                        lineWidth: 2,
                        lineColor: "#fe6700",
                        marker: {
                            fillColor: "#fe6700"
                        },
                        color: "#ffc2ad"
                    }
                ],

                credits: {
                    enabled: false
                }
            });

        },
        //进入签约页
        signBtn: function(e){
            var curr = e.currentTarget;
            var level = $(curr).attr("data-level");
            App.storage.set("smartFinancialLevel",level);
            App.storage.set("smartInSignPage",true);
            App.navigate("smartFinancial/smartFinancial/sign",true);
        },
        //重测按钮
        againEvaluate: function(){
            App.storage.set("smartFinancialRisk","1");
            App.navigate("riskExam/riskExam/riskExam/2015910",true);
        },

        //是否首次测评
        checkFirstRisk : function(){
            var self = this;
            var firstRiskType = App.storage.get("firstRiskType");
            if(firstRiskType && firstRiskType == 0){
                accountModel.getWLTCheckRule({
                    data : {"ruleId":config.values.wltFengCe},
                    callback : function(res){
                        //0是送积分1不送积分
                        if(res.object.wanlitongRule && res.object.wanlitongRule == 0){
                            self.$("#wanlitongPrompt").show();
                        }
                    },
                    errorCallback : function(res){
                        //utils.dialog.alert(res.message);
                    }
                });
            }
        }

    });
});
