/*
 *  预约购买
 *  liujun
 */
define(function (require, exports, module) {
    var orderSmartFinancialHtml = require("text!../template/orderSmartFinancial.html");
    var smartFinancialModel = require("../model/smartFinancial");
    // var CustomPwdOtpInput = require("component/password/customPwdOtpInput");
    var CustomPwdInput = require("component/password/customPwdInput");
    module.exports = ItemView.extend({
        template: _.template(orderSmartFinancialHtml),
        events: {
            "tap #buySmartPrd": "buySmartPrd",
            "tap #cancelSmartPrd": "cancelSmartPrd",
            "tap #confirmSwitch": "confirmSwitch",
            "tap #prdAgreement": "prdAgreement"
        },
        initialize: function (options) {
            if (options) {
                data = options;
            }
            submitStates = false;
        },
        onRender: function () {
        },
        //购买按钮
        buySmartPrd: function (e) {
            if (submitStates == false) {
                if ($("#lastTime").text() == "00:00") {
                    utils.dialog.toast("已过锁定期，此笔预约已自动撤消");
                } else {
                    var curr = e.currentTarget;
                    var buyData = {};
                    if ($("#confirmSwitch").hasClass("on")) {
                        if (data) {
                            buyData.tranSysNo = data.tranSysNo;
                            CustomPwdInput.customPwdInput(
                                function (pwd) {
                                    buyData.password = utils.crypto.RSAKey.encrypt(pwd, config.base.rsa_public_key);
                                    buyData.sm2Pwd = utils.sm2.SM2Key.encrypt(pwd, config.base.sm2_public_key);
                                    // dataArg.otp = otp;
                                    smartFinancialModel.confirmBuySF({
                                        url: "confirmBuySmartFinancial",
                                        data: buyData,
                                        callback: function (res) {
                                            submitStates = true;
                                            utils.dialog.toast("委托购买成功");
                                            App.navigate("smartFinancial/smartFinancial/signed", true);
                                        },
                                        errorCallback: function (err) {
                                            utils.dialog.alert(err.message);
                                        }
                                    });
                                }
                            );
                        }
                    } else {
                        utils.dialog.toast("请同意用户协议后继续操作");
                    }
                }
            } else {
                utils.dialog.toast("请勿重复提交");
            }

        },
        //取消按钮
        cancelSmartPrd: function (e) {
            if (submitStates == false) {
                var curr = e.currentTarget;
                var cancelData = {};
                if ($("#confirmSwitch").hasClass("on")) {
                    if (data) {
                        cancelData.tranSysNo = data.tranSysNo;
                        CustomPwdInput.customPwdInput(
                            function (pwd) {
                                cancelData.password = utils.crypto.RSAKey.encrypt(pwd, config.base.rsa_public_key);
                                cancelData.sm2Pwd = utils.sm2.SM2Key.encrypt(pwd, config.base.sm2_public_key);
                                smartFinancialModel.cancelBuySF({
                                    url: "cancelBuySmartFinancial",
                                    data: cancelData,
                                    callback: function (res) {
                                        submitStates = true;
                                        utils.dialog.toast("委托撤销成功");
                                        App.navigate("smartFinancial/smartFinancial/signed", true);
                                    },
                                    errorCallback: function (err) {
                                        utils.dialog.alert(err.message);
                                    }
                                });
                            }
                        );
                    }
                } else {
                    utils.dialog.toast("请同意用户协议后继续操作");
                }
            } else {
                utils.dialog.toast("请勿重复提交");
            }
        },
        //是否认同协议
        confirmSwitch: function (e) {
            var curr = e.currentTarget;
            if ($(curr).hasClass("on")) {
                $(curr).removeClass("on");
            } else {
                $(curr).addClass("on");
            }
        },
        //产品协议
        prdAgreement: function () {
            var papShortName = "";
            if (data) {
                papShortName = data.shortName;
                utils.window.open({
                    title: "产品说明",
                    url: 'http://bank.pingan.com/licaichanpin/' + papShortName + '.shtml'
                });
            }
        }

    });
});