/*
 *  已签约页
 *  liujun
 */
define(function (require, exports, module) {
    var signedHtml = require("text!../template/signed.html");
    var smartModel = require("../model/smartFinancial");
    var CustomPwdInput = require("component/password/customPwdInput");
    var safeKeyBoardHelper = require("component/customInput.helper");
    module.exports = ItemView.extend({
        template: _.template(signedHtml),

        events: {
            "tap .unsurePap": "unsurePap",
            "tap .SmartF_pop": "SmartF_pop",
            "tap .executeRecord": "executeRecord",
            "tap .changeItem": "changeItem",
            "tap .stopItem": "stopItem",
            "tap .resumeItem": "resumeItem",
            "tap .cancelItem": "cancelItem",
            "tap": "yingcangMenu"
        },

        initialize: function (options) {
            data = options;
            shouyiNum = 0;
            if (data.pinganying) {
                SFstatus = data.smartFinancialStatus.status;
                if (data.pinganying.yesterdaydhIncome == null) {
                    shouyiNum = 0;
                } else {
                    shouyiNum = parseFloat(data.pinganying.yesterdaydhIncome);
                }
                if (data.pinganpiao) {
                    for (var i = 0; i < data.pinganpiao.list.length; ++i) {
                        var item = 0;
                        item = parseFloat(data.pinganpiao.list[i].sourceAmount) * parseFloat(data.pinganpiao.list[i].planRate) / 36500;
                        shouyiNum = shouyiNum + item;
                    }
                }
                if (data.unsure) {
                    App.storage.set("smartFinancial/smartFinancial/flowId", data.unsure.tranSysNo);
                }
            }
        },

        onRender: function () {

        },

        //点击不确定的平安票
        unsurePap: function (e) {
            var curr = e.currentTarget;
            var data = JSON.parse($(curr).attr("data-obj"));
            if (App.storage.get("smartFinancial/smartFinancial/flowId")) {
                data.flowId = App.storage.remove("smartFinancial/smartFinancial/flowId");
                App.storage.set("smartFinancial/smartFinancial/order", data);
                App.navigate("smartFinancial/smartFinancial/order", true);
            }
        },

        SmartF_pop: function (e) {
            var curr = e.currentTarget;
            if ($(curr).css('display') == "none") {
                $(curr).css('display', 'auto');
            } else {
                $(curr).css('display', "none");
            }
        },
        //执行记录
        executeRecord: function () {
            App.navigate("smartFinancial/smartFinancial/executeRecord", true);
        },
        //更改协议
        changeItem: function () {
            utils.dialog.customDialog("更改定投协议可重新选择您的组合产品，新组合产品签约成功后，原组合产品将不再自动购买，请确认是否更改。", {
                title: "",
                okButtonText: "确认",
                cancelButtonText: "取消"
            }, function (e) {
                if (e == true) {
                    App.storage.set("smartFinancial/smartFinancial/signed/edit", true);
                    App.navigate("smartFinancial/smartFinancial/sign", true);
                }
            });

        },
        //协议暂停
        stopItem: function (e) {
            var curr = e.currentTarget;
            utils.dialog.customDialog("暂停定投功能后，我们将不再继续自动购买组合产品，请确认是否暂停！", {
                title: "",
                okButtonText: "确认",
                cancelButtonText: "取消"
            }, function (e) {
                if (e == true) {
                    var data = {};
                    data.status = 2;
                    CustomPwdInput.customPwdInput(function (password) {
                        data.password = utils.crypto.RSAKey.encrypt(password, config.base.rsa_public_key);
                        data.sm2Pwd = utils.sm2.SM2Key.encrypt(password, config.base.sm2_public_key);
                        smartModel.editStatusSmartFinancial({
                            url: "editStatusSmartFinancial",
                            data: data,
                            callback: function (res) {
                                $(curr).css("display", "none");
                                $(curr).siblings('.resumeItem').css("display", "auto");
                                utils.dialog.toast("签约暂停操作成功");
                            },
                            errorCallback: function (err) {
                                utils.dialog.alert(err.message);
                            }
                        });
                    });
                }
            });
        },
        //协议恢复
        resumeItem: function (e) {
            var curr = e.currentTarget;
            utils.dialog.customDialog("激活智能定投协议后，我们将继续为您自动购买组合产品，请确认是否激活协议。", {
                title: "",
                okButtonText: "确认",
                cancelButtonText: "取消"
            }, function (e) {
                if (e == true) {
                    var data = {};
                    data.status = 0;
                    CustomPwdInput.customPwdInput(function (password) {
                        data.password = utils.crypto.RSAKey.encrypt(password, config.base.rsa_public_key);
                        data.sm2Pwd = utils.sm2.SM2Key.encrypt(password, config.base.sm2_public_key);
                        smartModel.editStatusSmartFinancial({
                            url: "editStatusSmartFinancial",
                            data: data,
                            callback: function (res) {
                                $(curr).css("display", "none");
                                $(curr).siblings('.stopItem').css("display", "auto");
                                utils.dialog.toast("签约激活成功");
                            },
                            errorCallback: function (err) {
                                utils.dialog.alert(err.message);
                            }
                        });
                    });
                }
            });
        },
        //协议解除
        cancelItem: function () {
            var data = {};
            data.status = 1;
            utils.dialog.customDialog("解除智能定投协议后，后续将不再为您继续自动购买组合产品（正在执行指令将会继续完成），您确定要解约吗？真的要解约吗？", {
                title: "",
                okButtonText: "确认",
                cancelButtonText: "取消"
            }, function (e) {
                if (e == true) {
                    CustomPwdInput.customPwdInput(function (password) {
                        data.password = utils.crypto.RSAKey.encrypt(password, config.base.rsa_public_key);
                        data.sm2Pwd = utils.sm2.SM2Key.encrypt(password, config.base.sm2_public_key);
                        smartModel.editStatusSmartFinancial({
                            url: "editStatusSmartFinancial",
                            data: data,
                            callback: function (res) {
                                utils.dialog.toast("签约解约操作成功");
                                setTimeout(function () {
                                    App.navigate("index/indexLogined/index", true);
                                }, 2000);
                            },
                            errorCallback: function (err) {
                                utils.dialog.alert(err.message);
                            }
                        });
                    });
                }

            });

        },

        //点击其他
        yingcangMenu: function () {
            if ($('.SmartF_pop').css('display') == "none") {
            } else {
                $('.SmartF_pop').css('display', 'none');
            }
        }
    });
});
