/**
 * 证券-三方存管首页控制器
 * by 7iang(wangqiang873)
 * 2015-06-03
 */
define(function(require, exports, module){
	var StockView               = require("../view/stock");
	var AccessControlView       = require("../view/accessControl");

	var PrespecifiedView        = require("../view/prespecified");
	var PrespecifiedVerifyView  = require("../view/prespecifiedVerify");
	var PrespecifiedSuccessView = require("../view/prespecifiedSuccess");

	var Bank2StockView          = require("../view/bank2Stock");
	var Bank2stockVerifyView    = require("../view/bank2StockVerify");
	var Bank2stockSuccessView   = require("../view/bank2StockSuccess");

	var Stock2BankView          = require("../view/stock2Bank");
	var Stock2BankVerifyView    = require("../view/stock2BankVerify");
	var Stock2BankSuccessView   = require("../view/stock2BankSuccess");

	var BalanceStockView        = require("../view/balanceStock");
	var BalanceShowView         = require("../view/balanceShow");
	var Query3dmView            = require("../view/query3dm");
	var Query3dmDetailsView     = require("../view/query3dmDetails");

	var WhatIs3dmView           = require("../view/whatis3dm");
	var stockModel              = require("../model/stockModel");
	var accountInfoStatus       = require("mod/common/accountInfoStatus/accountInfoStatus");

	var Stock = module.exports = Controller.extend({
		actions : {
			"index"               : "index",                //首页
			"prespecified"        : "prespecified",         //预指定确认列表
			"prespecifiedVerify"  : "prespecifiedVerify",   //预指定确认校验
			"prespecifiedSuccess" : "prespecifiedSuccess",  //预指定确认成功
			"bank2Stock"          : "bank2Stock",           //银转证
			"bank2StockVerify"    : "bank2StockVerify",     //银转证验证
			"bank2StockSuccess"   : "bank2StockSuccess",    //银转证成功
			"stock2Bank"          : "stock2Bank",           //证转银
			"stock2BankVerify"    : "stock2BankVerify",     //证转银验证
			"stock2BankSuccess"   : "stock2BankSuccess",    //证转银成功
			"balanceStock"        : "balanceStock",         //查询证券资金余额
			"showBalance"         : "showBalance",          //显示证券资金余额
			"query3dm"            : "query3dm",             //银证转账交易记录
			"query3dmDetails"     : "query3dmDetails",      //银证转账交易记录详情
			"whatIsStock3dm"      : "whatIsStock3dm"        //什么是三方存管
		},

		// authorize: function(){
			// return true;
		// },

		/**
		 * 三方存管主页面
		 */
		index : function(){
			utils.native.talkingDataTrackEvent("2.0发现-证券三方存管-功能列表");
			App.header.reset({
				title : "证券三方存管",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.navigate('search/search/index', true);
				}

				// rightButtonContent : "登录",
				// rightButtonHandler : function(){
					// App.navigate("login/login/toaIndex",true);
				// }
			});

			App.footer.reset({"visible":false});
            // 1-个人网银高级用户
            // 2-身份证
            // 3-借记卡
            // 4-信用卡
            // 5- CFE迁移过来的数据， 在CFE时验证方式为同名户验证。
            // 6-历史数据修改， 迁移时存在一部分用户，他们的卡在卡管， FCR都已经激活，但在CFE为未激活状态。针对这类诡异数据，
            // 无法给出相对应的激活方式，所以修改这些历史数据时激活方式置为6
            // 7- 汽融
            // 8-人脸识别
            // 9-柜面核身
			stockModel.userVerifyMode({
                "url" : "userVerifyMode",
                "data": {},
                "callback": function(res){
                    if(res.object.verifyMode == 3){
                        App.container.show(new StockView());
                    }else{
                        App.container.show(new AccessControlView());
                    }
                },
                "errorCallback": function(res){
                    utils.dialog.alert(res.message);
                }
            });
		},

		whatIsStock3dm: function(){
			App.header.reset({
				title : "什么是第三方存管",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.navigate('stock/stock/index', true);
				}
			});
			App.container.show(new WhatIs3dmView());
		},

		query3dm: function(){
			if(!this._cardState())return;
			utils.native.talkingDataTrackEvent("2.0发现-证券三方存管-银证转账交易记录");
			App.header.reset({
				title : "银证转账交易记录",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.navigate('stock/stock/index', true);
				}
			});
			stockModel.qryBankToSecurities({
				"url" : "qryBankToSecurities",
				"data": {
					//"cardId"    : App.storage.get("UserInfo").get("accNumber"),
					"ccyCode"   : "RMB",
					"qryType"   : "01",
					"startDate" : new Date(App.storage.get("Login_SysTime")).format("yyyy-MM-dd"),
					"endDate"   : new Date(App.storage.get("Login_SysTime")).format("yyyy-MM-dd"),
					"pageIndex" : 1,
					"pageSize"  : 10
				},
				"callback": function(res){
					App.storage.set("query_3dm_transferDetailInfoList",res.object.transferDetailInfoList);
					App.container.show(new Query3dmView({model:new Model(res.object),param:this.data}));
				},
				"errorCallback": function(res){
					utils.dialog.alert(res.message,function(){
						App.navigate("stock/stock/index",true);
					});
				}
			});
		},

		query3dmDetails: function(){
			App.header.reset({
				title: "银证转账交易明细",
				leftButtonContent: "@back"
			});
			App.container.show(new Query3dmDetailsView());
		},

		/**
		 * 证券资金余额查询——显示出已签约列表
		 */
		balanceStock: function(){
			if(!this._cardState())return;
			utils.native.talkingDataTrackEvent("2.0发现-证券三方存管-资金余额查询-选择券商");
			App.header.reset({
				title : "证券资金余额查询",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.navigate('stock/stock/index', true);
				}
			});
			stockModel.qryInstructionInfo({
				"url" : "qryInstructionInfo",
				"data": {},
				"callback": function(res){
					App.container.show(new BalanceStockView({model:new Model(res.object)}));
				},
				"errorCallback": function(res){
					utils.dialog.alert(res.message,function(){
						App.navigate("stock/stock/index",true);
					});
				}
			});
		},

		/**
		 * 显示余额详情
		 */

		showBalance: function(){
			utils.native.talkingDataTrackEvent("2.0发现-证券三方存管-资金余额查询-查询结果");
			App.header.reset({
				title : "证券资金余额",
				leftButtonContent : "@back"
			});
			App.container.show(new BalanceShowView());
		},
		/**
		 * 银转证成功页
		 */
		bank2StockSuccess: function(){
			utils.native.talkingDataTrackEvent("2.0发现-证券三方存管-银转证-转账完成");
			App.header.reset({
				title : "转入结果",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.navigate('stock/stock/index', true);
				}
			});
			App.container.show(new Bank2stockSuccessView());
		},

		/**
		 * 银转证校验页
		 */
		bank2StockVerify: function(){
			utils.native.talkingDataTrackEvent("2.0发现-证券三方存管-银转证-校验密码");
			var data = App.storage.get("bank2stock_stockAccList");
			App.container.show(new Bank2stockVerifyView({model:new Model(data)}));
		},

		/**
		 * 银转证
		 */
		bank2Stock: function(){
			if(!this._lossStatus())return;
			if(!this._cardState())return;
			utils.native.talkingDataTrackEvent("2.0发现-证券三方存管-银转证-选择券商");
			App.header.reset({
				title : "银行转证券",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.navigate('stock/stock/index', true);
				}
			});
			stockModel.qryInstructionInfo({
				"url" : "qryInstructionInfo",
				"data": {},
				"callback": function(res){
					App.container.show(new Bank2StockView({model:new Model(res.object)}));
				},
				"errorCallback": function(res){
					utils.dialog.alert(res.message,function(){
						App.navigate("stock/stock/index",true);
					});
				}
			});
		},


		/**
		 * 证转银成功页
		 */
		stock2BankSuccess: function(){
			utils.native.talkingDataTrackEvent("2.0发现-证券三方存管-证转银-转账完成");
			App.header.reset({
				title : "转出结果",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.navigate('stock/stock/index', true);
				}
			});
			App.container.show(new Stock2BankSuccessView());
		},

		/**
		 * 证转银校验页
		 */
		stock2BankVerify: function(){
			if(!this._lossStatus())return;
			if(!this._cardState())return;
			utils.native.talkingDataTrackEvent("2.0发现-证券三方存管-证转银-校验密码");
			App.header.reset({
				title : "证券转银行",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.navigate('stock/stock/index', true);
				}
			});

			var stockAccListInfo = App.storage.get("balanceStock_stockAccList_selectListInfo");
			if(stockAccListInfo){
				//从证券余额查询跳转过来
				App.storage.set("stock2bank_stockAccList",stockAccListInfo);
				App.storage.remove("balanceStock_stockAccList_selectListInfo");
				App.container.show(new Stock2BankVerifyView({model:new Model(stockAccListInfo)}));
			}else{
				var data = App.storage.get("stock2bank_stockAccList");
				App.container.show(new Stock2BankVerifyView({model:new Model(data)}));
			}
		},

		/**
		 * 证转银
		 */
		stock2Bank: function(){
			if(!this._lossStatus())return;
			if(!this._cardState())return;
			utils.native.talkingDataTrackEvent("2.0发现-证券三方存管-证转银-选择券商");
			App.header.reset({
				title : "证券转银行",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.navigate('stock/stock/index', true);
				}
			});

			stockModel.qryInstructionInfo({
				"url" : "qryInstructionInfo",
				"data": {},
				"callback": function(res){
					App.container.show(new Stock2BankView({model:new Model(res.object)}));
				},
				"errorCallback": function(res){
					utils.dialog.alert(res.message,function(){
						App.navigate("stock/stock/index",true);
					});
				}
			});
		},

		/**
		 * 预指定确认成功
		 */
		 prespecifiedSuccess: function(){
		 	utils.native.talkingDataTrackEvent("2.0发现-证券三方存管-预指定确认-结果页");
			App.header.reset({
				title : "预指定确认成功！",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.navigate('stock/stock/index', true);
				}
			});
			App.container.show(new PrespecifiedSuccessView());
		 },

		/**
		 * 预指定确认校验
		 */
		 prespecifiedVerify: function(){
		 	utils.native.talkingDataTrackEvent("2.0发现-证券三方存管-预指定确认-填写信息");
			var data = App.storage.get("prespecifiedInfoItem");
			App.container.show(new PrespecifiedVerifyView({model:new Model(data)}));
		 },

		/**
		 * 预指定确认
		 */
		prespecified: function(){
			if(!this._lossStatus())return;
			if(!this._cardState())return;
			utils.native.talkingDataTrackEvent("2.0发现-证券三方存管-预指定确认-选择券商");
			App.header.reset({
				title : "预指定确认",
				leftButtonContent : "@back",
				leftButtonHandler : function(){
					App.navigate('stock/stock/index', true);
				}
			});
			stockModel.qrySignListBase({
				"url" : "qrySignListBase",
				"data": {},
				"callback": function(res){
					App.container.show(new PrespecifiedView({model:new Model(res.object)}));
				},
				"errorCallback": function(res){
					utils.dialog.alert(res.message,function(){
						App.navigate("stock/stock/index",true);
					});
				}
			});
		},

		_cardState: function(){
			var cardState  = App.storage.get("UserInfo").get("cardState");  //是否激活
			if(cardState && cardState != 1){
				// utils.dialog.confirm("您还未验证身份，身份认证以后才能进行此操作！",{"okButtonText":"立即验证"},function(ok){
					// if(ok){
						// App.navigate("verifyAccount/main/verify",true);
					// }
				// });
				App.storage.set("backUrl","stock/stock/index");
				App.navigate("common/accountInfoCon/accountNoCard", true);
				return false;
			}
			return true;
		},

		_lossStatus: function(){
			var lossStatus = App.storage.get("cradLossStatus");  //是否挂失
			if(lossStatus){
				// utils.dialog.alert("您的账户已挂失，请解挂以后再使用该功能，谢谢！",function(){
					// App.navigate("stock/stock/index",true);
				// });
				App.storage.set("backUrl","stock/stock/index");
				App.navigate("common/accountInfoCon/accountLoss", true);
				return false;
			}
			return true;
		}

	});
});