define(function(require, exports, module){

    var stockModel = module.exports = Model.extend({}, {

        /*
         * 查询激活方式
         */
        userVerifyMode: function(options){
            this._callInterface(options);
        },
        /*
         * 查询银证转账交易记录
         */
        qryBankToSecurities: function(options){
            this._callInterface(options);
        },

        /*
         * 查询证券可用余额
         */
        qrySecuritiMoney: function(options){
            this._callInterface(options);
        },
        /*
         * 银转证、证转银已签约列表
         */
        qryInstructionInfo: function(options){
            this._callInterface(options);
        },

        /*
         * 银转证确认
         */
        bankToSecurities: function(options){
            this._callInterface(options);
        },

        /*
         * 证转银确认
         */
        securitiesToBank: function(options){
            this._callInterface(options);
        },

        /*
         * 预指定签约关系查询--及未签约列表
         */
        qrySignListBase: function(options){
            this._callInterface(options);
        },

        /*
         * 预指定确认
         */
        instructionConfirm: function(options){
            this._callInterface(options);
        },

        /*
         * 调用接口的公共方法
         *
         * 入参：
         *      options : 请求参数
         *          url：接口路径
         *          data：接口入参
         *          callback：接口成功回调函数
         *          errorCallback：接口错误回调函数
         *
         * 返回：无
         */
        _callInterface: function (options){
            App.request(options.url,{
                data    : options.data,
                success : function(res){
                    if(res.success) {
                        options.callback(res);
                    }else{
                        options.errorCallback(res);
                    }
                },
                error : function(res){
                    options.errorCallback(res);
                }
            });
        }

    });
});