define(function(require, exports, module){
    var BalanceStockTpl = require("text!../template/balanceStock.html");
    var FormComponent   = require("component/form");
    var CustomPwdInput  = require("component/password/customPwdInput");
    var stockModel      = require('../model/stockModel');

    var BalanceStockView = module.exports = ItemView.extend({
        template : _.template(BalanceStockTpl),
        events:{
            "tap .bsItem"  : "queryBalance"
        },

        /**
         * 查询余额
         */
        queryBalance: function(e){
            var id   = $(e.currentTarget).attr("data-id");
            var list = this.model.get("appointmentRelationList");
            App.storage.set("balanceStock_stockAccList_selectListInfo",list[id]);
            this._submit(list[id]);
        },

        _submit: function(d){
            var self = this;
            var data = d;
            utils.native.talkingDataTrackEvent("2.0发现-证券三方存管-资金余额查询-输入证券密码");
            CustomPwdInput.customPwdInput(function(pwd){
                stockModel.qrySecuritiMoney({
                    "url" : "qrySecuritiMoney",
                    "data": {
                        //"cardId"   : App.storage.get("UserInfo").get("accNumber"),
                        "stkCode"    : data.stkCode,
                        "range"      : "1",
                        "curCode"    : data.curCodeText,
                        "stkAcct"    : data.stkAcct,
                        "stkAcctPwd" : utils.crypto.RSAKey.encrypt(pwd,config.base.bkey)
                    },
                    "callback": function(res){
                        App.storage.set("balanceStock_balanceAndStockInfo",{"data":data,"balance":res.object});
                        App.navigate('stock/stock/showBalance', true);
                    },
                    "errorCallback": function(res){
                        utils.dialog.alert(res.message);
                    }
                });
            },{"titleText":"请输入证券资金账号密码"});
        }

    });
});