define(function(require, exports, module){
    var Query3dmTpl   = require("text!../template/query3dm.html");
    var FormComponent = require("component/form");
    var stockModel    = require('../model/stockModel');
    var PTRScroll     = require("component/PTRScroll");

    var Query3dmView = module.exports = FormComponent.extend({
        template : _.template(Query3dmTpl),
        events:{
            "tap .listItem"      : "showDetails",
            "tap #todayRecord"   : "todayRecord",
            "tap #historyRecord" : "historyRecord",
            "datepicker:dateSelect @ui.startDateBtn" : "selectStartDate",   //选择开始日期
            "datepicker:dateSelect @ui.endDateBtn"   : "selectEndDate"     //选择结束日期
        },

        initialize:function(option){
            this.param = option.param;
            thatView   = this;
        },

        ui: {
            "startDateBtn"  : "#startDate",
            "endDateBtn"    : "#endDate"
        },

        onShow: function(){
            this._pullDown(this.model.attributes);
        },

        /**
         * 当天记录
         */
        todayRecord: function(e){
            utils.native.talkingDataTrackEvent("2.0发现-证券三方存管-交易记录-今日记录");
            var self = this;
            var t    = $(e.currentTarget);
            $("#historyRecord").find('i').removeClass('on');
            $("#selectDate").hide();

            this.param.startDate = new Date(App.storage.get("Login_SysTime")).format("yyyy-MM-dd");
            this.param.endDate   = new Date(App.storage.get("Login_SysTime")).format("yyyy-MM-dd");
            this.param.pageIndex = 1;

            this._getData({
                callback: function(res){
                    self._fillData(res.object,"refresh");
                    self.scroller && self.scroller.destroy();
                    self._pullDown(res.object);
                },
                errorCallback: function(res){
                    utils.dialog.alert(res.message);
                }
            });
        },

        /**
         * 历史记录
         */
        historyRecord: function(e){
            utils.native.talkingDataTrackEvent("2.0发现-证券三方存管-交易记录-历史记录");
            var t     = $(e.currentTarget);
            t.find('i').toggleClass('on');
            $("#selectDate").toggle();
        },

        _pullDown : function(data){
            var self=this;

            if(data.totalNum == null || data.totalNum == ""){
                data.totalNum=0;
            }

            var wHeight=$(window).outerHeight(true);
            var navHeight=this.$(".menu").outerHeight(true);
            var listHeight = wHeight-navHeight;

            var dom = $("#scrollContainer").css({"height":listHeight,"position":"relative"});
            this.scroller = new PTRScroll(dom[0],{"hideScrollbar":true});

            self.param.pageCount = Math.ceil(parseInt(data.totalNum)/self.param.pageSize);

            this.scroller.options.refreshContent = function(refresh){
                self.param.pageIndex=1;
                self.param.pageCount = 0;
                self._getData({
                    callback: function (res) {
                        self._fillData(res.object,"refresh");
                        if(res.object.totalNum == null || res.object.totalNum ==""){
                            res.object.totalNum=0;
                        }
                        self.param.pageCount = Math.ceil(parseInt(res.object.totalNum)/self.param.pageSize);
                        if (self.param.pageCount <= 1) {
                            self.scroller.disablePullUpToLoadMore();
                        } else {
                            self.scroller.enablePullUpToLoadMore();
                        }
                        refresh();
                    },
                    errorCallback: function(){
                        refresh();
                    }
                });
            };
            this.scroller.options.loadMoreContent = function(refresh){
                self.param.pageIndex+=1;
                if(self.param.pageIndex > self.param.pageCount){
                    refresh();
                    self.scroller.disablePullUpToLoadMore();
                    return false;
                }

                self._getData({
                    callback: function (res) {
                        self._fillData(res.object);
                        if(res.object.totalNum == null || res.object.totalNum == ""){
                            res.object.totalNum=0;
                        }
                        self.param.pageCount = Math.ceil(parseInt(res.object.totalNum)/self.param.pageSize);
                        if(self.param.pageIndex >= self.param.pageCount){
                            refresh();
                            self.scroller.disablePullUpToLoadMore();
                            //$("#historyList").append('<tr><td colspan="2" style="text-align: center;">查无记录</td></tr>');
                            //self.scroller.pullUpEl.html("已经到底啦，求求你别拉了！");
                            return false;
                        }
                        if (self.param.pageCount <= 1) {
                            self.scroller.disablePullUpToLoadMore();
                        } else {
                            self.scroller.enablePullUpToLoadMore();
                        }
                        refresh();
                    },
                    errorCallback: function(){
                        self.pageIndex-=1;
                        refresh();
                    }
                });
            };
            if(self.param.pageCount <= 1){
                this.scroller.disablePullUpToLoadMore();
            }
        },

        _getData : function(option){
            var callback      = option.callback;
            var errorCallback = option.errorCallback;
            var taday         = new Date(App.storage.get("Login_SysTime") || new Date()).format("yyyy-MM-dd");
            if(this.param.startDate == this.param.endDate && this.param.startDate == taday && this.param.endDate == taday){
                this.param.qryType="01";
            }else{
                this.param.qryType="02";
            }

            delete this.param.pageCount;

            stockModel.qryBankToSecurities({
                "url"           : "qryBankToSecurities",
                "data"          : this.param,
                errorCallback   : function(res){
                    errorCallback(res);
                },
                callback: function(res){
                    callback(res);
                }
            });
        },

        /**
         *
         * 填充数据
         *
         */
        _fillData : function(data,type){
            var html     = "";
            var dataList = "";
            var startId  = 0;

            if(type && type == "refresh"){
                startId = 0;
                this.$("#transferList").empty();
                App.storage.set("query_3dm_transferDetailInfoList",data.transferDetailInfoList);
            }else{
                dataList = App.storage.get("query_3dm_transferDetailInfoList");
                startId = dataList.length;
                dataList = dataList.concat(data.transferDetailInfoList);
                App.storage.set("query_3dm_transferDetailInfoList",dataList);
            }

            if(data.transferDetailInfoList && data.transferDetailInfoList.length>0){
                 _.each(data.transferDetailInfoList, function(item,i){
                    var color = item.tranType == "银转证" ? "c_46B23F" : "c_f60";
                    var type  = item.tranType == "银转证" ? "-":"+";
                    html+='<li class="dswkb listItem" data-id="'+(startId++)+'">'+
                        '<div class="f14 tac w30 c_999">'+utils.date.formatTime(item.tranDate).format("yyyy-MM-dd")+'</div>'+
                        '<div class="f16 tac w20">'+item.tranType+'</div>'+
                        '<div class="f16 tac w50 p_r30 '+ color +'">'+type+utils.string.numberFormat(item.tranAmount)+'</div>'+
                        '<i class="iconA34"></i>'+
                    '</li>';
                });
            }else{
                html+='<li class="dswkb"><div class="m_t30 tac flex1"><p class="f15 p_t10 c_999"><span class="dsb f18">查无记录</span></p></div></li>';
            }
            this.$("#transferList").append(html);
        },

        qryFirstPageData: function(startDate,endDate){
            var self = this;
            $("#historyRecord").find('i').removeClass('on');
            $("#selectDate").hide();

            this.param.pageIndex = 1;
            this.param.startDate = startDate;
            this.param.endDate   = endDate;
            // utils.dialog.alert("start = "+startDate);
            // utils.dialog.alert("end = "+endDate);

            this._getData({
                "callback" : function (res) {
                    self._fillData(res.object,"refresh");
                    self.scroller && self.scroller.destroy();
                    self._pullDown(res.object);
                },
                "errorCallback" : function(res){
                    utils.dialog.alert(res.message);
                }
            });
        },

        /**
         * 选择开始日期
         * @param  {[type]} eve   [description]
         * @param  {[type]} _this [description]
         * @param  {[type]} value [description]
         * @return {[type]}       [description]
         */
        selectStartDate : function(eve,_this,value){
            // var consumeView = this;
            // var taday = new Date(App.storage.get("Login_SysTime") || new Date()).format("yyyy-MM-dd");
            // var yesToday = new Date(utils.date.diffDateAdd(App.storage.get("Login_SysTime") || new Date(),-1,"d")).format("yyyy-MM-dd");
            // if(value == taday){
                // //thatView.param.endDate = taday;
                // $("#endDate .js-date-text").text(taday);
                // $("#endDate").attr("data-initDate", taday);
                // $("#endDate").attr("data-startDate", taday);
                // $("#endDate").attr("data-endDate", taday);
            // }else{
                // $("#endDate").attr("data-startDate", value);
                // $("#endDate").attr("data-endDate", yesToday);
                // if($("#endDate .js-date-text").text() == taday){
                    // //thatView.param.endDate = yesToday;
                    // $("#endDate .js-date-text").text(yesToday);
                    // $("#endDate").attr("data-initDate", yesToday);
                // }
            // }
            if (!this._validateDateSlct(value, this.ui.endDateBtn.attr("data-initDate"))) return;
            this.ui.startDateBtn.attr("data-initDate",value).find("span.js-date-text").html(value);
            this.qryFirstPageData(value, this.ui.endDateBtn.attr("data-initDate"));
        },

        // 选择结束日期
        selectEndDate : function(eve,_this,value){
            if (!this._validateDateSlct(this.ui.startDateBtn.attr("data-initDate"), value)) return;
            this.ui.endDateBtn.attr("data-initDate",value).find("span.js-date-text").html(value);
            this.qryFirstPageData(this.ui.startDateBtn.attr("data-initDate"), value);
        },

        _validateDateSlct: function(startDate, endDate){
            if(utils.date.compareDate(startDate, endDate) == 1){
                utils.dialog.toast("开始日期不能大于结束日期");
                return false;
            }
            var sdate = utils.date.diffDateAdd(endDate,-3,"m");
            if(utils.date.diffDate(startDate, sdate) >0){
                utils.dialog.toast("查询时间段不能超过3个月");
                return false;
            }
            return true;
        },
        /**
         * 显示详情页
         */
        showDetails: function(e){
            utils.native.talkingDataTrackEvent("2.0发现-证券三方存管-交易记录-交易详情");
            var id = $(e.currentTarget).attr("data-id");
            var list = App.storage.get("query_3dm_transferDetailInfoList");//this.model.get("transferDetailInfoList");
            App.storage.set("query_3dm_transferDetailInfo",list[id]);
            App.navigate('stock/stock/query3dmDetails', true);
        }

    });
});