/**
 * ex_huangzit 新绑定激活流程
 */
define(function (require, exports, module) {
    var bindCardView      = require("../view/newActive/inputBindCard");
    var bindCardAuth      = require("../view/newActive/bindCardAuth");
    var bankListModel     = require("mod/me/model/transferModel");
    var bindCardSuView    = require("../view/newActive/bindCardSuccess");
    var openBankSelView   = require("../view/verifyIdentity/openBankSelect");

    module.exports = Controller.extend({
        actions: {
            'inputBindCard'   : 'inputBindCard',	// 跳转到银行卡输入页面
            'bindCardAuth'    : 'bindCardAuth',	    // 跳转到新绑定卡流程
            'toBankInfo'      : 'toBankInfo',       // 跳转银行卡选择页面
            'bindCardSuccess' : 'bindCardSuccess'   // 跳转绑定成功页面
        },

        _initialize: function () {
            App.footer.reset({ visible: false });
        },


        //输入银行卡号信息
        inputBindCard: function(){
            utils.native.talkingDataTrackEvent("2.0注册-绑卡-录入卡号");
            this._initialize();
            this._setHead({
                leftButtonHandler: function () {
                    var flag = App.storage.get("register/inputBindCard");
                    App.storage.remove("toPostUnionPay_formData");
                    App.storage.remove("verifyIdentity/bankOption");
                    if(App.storage.get("bankManageObj")) App.storage.remove("bankManageObj");
                    (flag) ? App.navigate("login/login/gestureLogin",true) : App.navigate('me/accoutAndSecurity/bankManage/bindCard', true);
                }
            });
            App.container.show(new bindCardView());
        },

        //头部
        _setHead: function (options) {
            var defaults = {
                title: '绑定借记卡',
                leftButtonContent: '@back'
            };
            defaults = _.extend(defaults, options || {});
            App.header.reset(defaults);
        },

        //展示银行信息
        bindCardAuth:function(){
            utils.native.talkingDataTrackEvent('2.0-激活借记卡绑定第二步');
            this._setHead({
                leftButtonHandler: function () {
                    App.storage.remove("toPostUnionPay_formData");
                    App.storage.remove("verifyIdentity/bankOption");
                    App.navigate('verifyAccount/bindCard/inputBindCard', true);
                }
            });
            var options = App.storage.get('newActive/bankInfo');
            App.container.show(new bindCardAuth({model:new Model(options)}));
        },

        /**
		 * 功能：绑定他行借记卡开户行列表页面
		 * author:ex_huangzit
		 * data:2015-08-18
		 */
        toBankInfo:function(){
            var url = 'verifyAccount/bindCard/bindCardAuth';
            this._setHead({
                leftButtonHandler: function () {
                    App.navigate(url, true);
                }
            });
            //银行列表
            var openBankList = App.storage.get("verifyIdentity/openBankList");
            if(!openBankList){
                bankListModel.queryAllBankList({
                    "url" : "queryAllBankList",
                    "callback" : function(response){
                        //跳到借记卡银行列表
                        App.container.show(new openBankSelView({model:new Model({"openBankList": response.object.bankList, "url":url})}));
                    },
                    "errorCallback" : function(response){
                        utils.dialog.alert(response.message);
                    }
                });
            }else{
                App.container.show(new openBankSelView({model:new Model({"openBankList": openBankList, "url":url})}));
            }
        },

        //跳转到本地行成功页面
        bindCardSuccess:function(){
            utils.native.talkingDataTrackEvent('2.0注册-绑卡-绑定成功提示');
            this._setHead({
                leftButtonHandler: function () {
                    App.storage.remove("toPostUnionPay_formData");
                    App.storage.remove("verifyIdentity/bankOption");
                    if(App.storage.get("bankManageObj")) App.storage.remove("bankManageObj");
                    var flag = App.storage.get("register/inputBindCard");
                    (flag) ? App.navigate("login/login/gestureLogin",true) : App.navigate('me/accoutAndSecurity/bankManage/bindCard', true);
                }
            });
            App.container.show(new bindCardSuView());
        }
    });
});
