/**
 * ex-wuyongsheng001 一账通校验 主流程控制器
 */
define(function (require, exports, module) {
    var services                = require("mod/index/services/services");
    var IdentityModel           = require("../model/identityModel");
    var IdentityConfig          = require("../view/verifyIdentity/identityConfig");

    var VerifyYZTView           = require("../view/verifyYZT");
    var AccountInfoImproveView  = require("../view/accountInfoImprove");
    var AccountInfoSetView      = require("../view/accountInfoSet");
    var ProListView        		= require("../view/registerProList");//省份列表
    var CityListView       		= require("../view/registerCityList");//城市列表
    var registerTools      		= require("mod/openAccount/common/registerTools");
    var accountInfoSta     		= require("mod/common/accountInfoStatus/accountInfoStatus");

    var VerifySelectionView     = require("../view/verifyIdentity/selection");
    var ByIdCardView            = require("../view/verifyIdentity/byIdCard");
    var ByLivenessDetectionView = require("../view/verifyIdentity/livenessDetection");

    var ByCreditCardView        = require("../view/verifyIdentity/byCreditCard");
    var ByDebitView             = require("../view/verifyIdentity/byDebitCard");
	var ByFastAuthView          = require("../view/verifyIdentity/byFastAuth");
	var openBankSelView      	= require("../view/verifyIdentity/openBankSelect");
	var ByFastAuthSubmitView    = require("../view/verifyIdentity/byFastAuthSubmit");
	var ByFastAuthSuccessView   = require("../view/verifyIdentity/byFastAuthSuccess");
	var ByFastAuthFailView      = require("../view/verifyIdentity/byFastAuthFail");
	var ByFastAuthReturnView    = require("../view/verifyIdentity/byFastAuthReturnSuc");
    var PersonalInfoModel       = require("../model/personalInfo");

    var bindCardTip = require('component/bindCardTip');

    module.exports = Controller.extend({
        actions: {
            /**
             * 激活 流程
             * -------------------------------------------------------
             */
            "verify": "verify",                                     // 账户检测
            "verifyYZT": "verifyYZT",                               // 一账通账户校验
            "accountInfoImprove": "accountInfoImprove",             // 完善账户信息
            "accountInfoSet": "accountInfoSet",                     // 设置账户信息

            "showProPage":"showProPage",                            // 跳转 省市选择
            "showCityPage" : "showCityPage",                        // 显示城市
            'verifyIdentity': 'verifyIdentity',                     // 认证方式选择

            'toLivenessDetection'           : 'toLivenessDetection',        // 人脸识别补拍两张照片
            'toIdCardView'                  : 'toIdCardView',               // 上传身份证认证视图
            'toDebitCardView'               : 'toDebitCardView',            // 平安借记卡认证视图
            'toCreditCardView'              : 'toCreditCardView',           // 平安信用卡认证视图
			'toFastAuthView'				: 'toFastAuthView' ,			// 快捷认证视图
			'toFastAuthSubmitView(/:code)'	: 'toFastAuthSubmitView',		// 快捷认证提交页面
			'tobankInfoView'				: 'tobankInfoView',			    // 借记卡认证银行卡信息
			'toFastAuthSuccessView'         : 'toFastAuthSuccessView',      // 借记卡认证成功
			'toFastAuthFailView'            : 'toFastAuthFailView',         // 借记卡认证失败
            'toFastAuthReturnSuc'           : 'toFastAuthReturnSuc',        // 展示成功页
            'toPostToUnionPay'				: 'toPostToUnionPay'			// Post到银联
            //'securityLevel'                 : 'securityLevel'
        },

        initialize: function () {
            App.footer.reset({ visible: false });
        },

        /**
         * 橙子2.0， 激活 流程
         * -------------------------------------------------------
         *
         * 是否绑定一账通 -> 是 ->是否设置交易密码 -> 是 -> 身份认证
         *                -> 是 ->是否设置交易密码 -> 否 -> 设置电子邮箱、交易密码 -> 身份认证
         *                -> 否 ->是否一账通用户   -> 是 -> 验证一账通 -> 设置电子邮箱、交易密码 -> 身份认证
         *                                         -> 否 -> 设置一账通用户名、密码、电子邮箱、交易密码 -> 身份认证
         *
         * -------------------------------------------------------
         */
        verify: function () {

            //新激活流程开关确保不被漏掉 ex_huangzit 2015-12-26
            // if (bindCardTip.newBindFlag()) {
            //     bindCardTip.activeSwitch();
            //     return;
            // }

            /**
            * userFlag：
            * 0:非一账通用户，需要完善一账通信息;
            * 1:没有绑定的一账通用户，需要用户名、密码校验;
            * 2:绑定的一账通用户，未设置交易密码，需设置(关联开户);
            * 3:绑定的一账通用户，已设置交易密码，直接身份验证
            */
            var accountSta = accountInfoSta.getAccountInfoLossStatus("me/accoutAndSecurity/index");
			if(accountSta){

             //身份认证上传映像时，查询可疑名单,Y-是可疑名单,弹出提示; N-不是可疑名单,按原来流程走身份认证
             PersonalInfoModel.checkAccountSuspicious({
            	url : "checkAccountSuspicious",
            	data : {},
                callback : function(res){
                	var isSuspicious = res.object.isSuspicious;
                	if(isSuspicious && isSuspicious == 'N'){
                         IdentityModel.validateUserInfo({
                            callback: function(res){
                                var userFlag = res.object.userFlag;
                                var mobile = res.object.mobile;
                                var email = res.object.email;
                                var birthDate = res.object.birthDate;
                                var userInfoOption = {
                                    mobile:mobile,
                                    email:email,
                                    userFlag:userFlag,
                                    birthDate:birthDate
                                };

                                App.storage.set("verifyAccount/userInfoOption", userInfoOption);
                                if(userFlag == "1"){
                                    App.navigate('verifyAccount/main/verifyYZT', true);
                                }else if(userFlag == "0"){
                                    App.storage.remove("verifyAccount/main/tempFormData");
                                    App.navigate('verifyAccount/main/accountInfoSet', true);
                                }else if(userFlag == "2"){
                                    App.navigate("verifyAccount/main/accountInfoImprove", true);
                                }else if(userFlag == "3"){
                                    App.navigate('verifyAccount/main/verifyIdentity', true);
                                }else{
                                    utils.dialog.alert("橙子账号状态不正常，请联系橙子客服，谢谢！");
                                }
                            },
                            errorCallback : function(res){
                                utils.dialog.alert(res.message);
                            }
                        });
                	}else{
                		 utils.dialog.alert("经审核发现您上传的身份证影像不符合标准，可联系电话中心95511-3，了解原因并由客服指导您后续操作。", function(){
                            App.back();
                         });
                	}
                },
                errorCallback : function(res){
                	utils.dialog.alert(res.message);
                }
            });



           }
        },

        verifyYZT: function () {
			this._setHead({
                title: "登录验证",
                leftButtonHandler: function () {
                    App.navigate("index/indexLogined/index", true);
                }
            });
            App.footer.reset({"visible":false});
            App.container.show(new VerifyYZTView());
        },

        accountInfoImprove: function () {
			this._setHead({
                title: "完善账户信息",
                leftButtonHandler: function () {
                    App.navigate("index/indexLogined/index", true);
                }
            });
            App.footer.reset({"visible":false});
            App.container.show(new AccountInfoImproveView());
        },

        accountInfoSet: function (code) {
			this._setHead({
                title: "设置账户信息",
                leftButtonHandler: function () {
                	App.storage.remove("verifyAccount/main/tempFormData");
                	App.storage.remove("transfer_cityData");
                    App.navigate("index/indexLogined/index", true);
                }
            });
            App.footer.reset({"visible":false});
            App.container.show(new AccountInfoSetView());
        },

        verifyIdentity: function(){
            utils.native.talkingDataTrackEvent("2.0身份认证");
            this._setHead({
                title: "身份认证",
                leftButtonHandler: function () {
                    App.navigate("me/logined/index", true);
                }
            });
			App.footer.reset({"visible":false});
            var self = this, message;

            //判断是否可激活用户
            var cardState = App.storage.get("UserInfo").get("cardState");
            if(cardState=="0" || cardState=="2"){
                self._verifySelection();
            } else if (cardState == "1") {
                //2015-06-30
                //2.0 激活(财富E迁移情况下，卡已激活，但需要再次验证身份)
                //判断是否能再次身份验证(0:不需要身份验证   1：需要身份验证)
                IdentityModel.againVerify({
                    success : function (res) {
                        if (res.object == '1') {
                            /**
                             * 功能：卡已激活状态，但是是财富E升级用户，需重新认证，不能走银联鉴权，设置财富E标识-caifuE
                             * ex_huangzit
                             * 2015-09-01
                             */
                            App.storage.set("verifyIndentity/caifuE" , true);
                            self._verifySelection();
                        }else{
                            //已认证
                            message = "你已进行身份认证，请不要重复操作。";
                            utils.dialog.alert(message, function () {
                                App.navigate("me/logined/index", {
                                    trigger: true,
                                    replace: true
                                });
                            });
                        }
                    },
                    errorCallback : function (res) {
                        utils.dialog.alert(res.message);
                    }
                });
            } else if (cardState == "3") {
                //审核中
                message = "你已进行身份认证，请耐心等候审核结果。";
                utils.dialog.alert(message, function () {
                    App.navigate("me/logined/index", {
                        trigger: true,
                        replace: true
                    });
                });
            }
        },

        _verifySelection: function () {
            var self = this;
            IdentityModel.qryIsCanFaceActive({
                success: function(res){
                    if(res.object.isSuspicious == "0"){//是否可疑用户
                        IdentityModel.getUserType({
                            success:function(response){
                                var options = IdentityConfig(response.object.userType);
                                //将身份证号传给人脸识别使用
                                options.cardId = res.object.idNo||"";
                                options.livenessDetection = false;
                                var callBack = function(){
                                    App.container.show(new VerifySelectionView({
                                        model:new Model(options)
                                    }));
                                };

                                // 2015-12-30 (dev许海鹏)
                                // 1.屏蔽人脸识别激活入口
                                // 2.删除试点城市用户自动调转人脸识别代码
                                // if(res.object.isCanFaceActiveFlag == "0"){
                                //     self._location(options, callBack);
                                // }else{
                                //     callBack();
                                // }

                                callBack();
                            },
                            errorCallback : function(response){
                                utils.dialog.alert(response.message);
                            }
                        });
                    }else if(res.object.isSuspicious == "1"){
                        utils.dialog.alert("您暂不符合身份认证条件，请电联95511-3了解原因并由客服指导您后续操作。");
                    }else{
                        utils.dialog.alert("系统异常！");
                    }
                },
                errorCallback : function(res){
                    utils.dialog.alert(res.message);
                }
            });
        },

        /*
         * 获取试点城市及人脸识别开关
         */
        _location: function (options, callBack) {
            var citySwitch = false;
            var dfd = services.getOcrVersion();
            dfd.progress(function(ocrSwitch){
                if(ocrSwitch == "1"){
                    services.RemoteRegister().done(function(remoteObj){
                        if(remoteObj.remoteIsOpened == "true"){
                            if(remoteObj.OpenAllCity == "true"){
                                citySwitch = true;
                                dfd.resolve(citySwitch);
                            }else{
                                var cityList = remoteObj.TestCity;
                                //返的试点城市列表为空
                                if((cityList.length==1) && (cityList[0]=="")){
                                    dfd.reject(citySwitch);
                                }else{
                                    utils.native.location(function(data){
                                        if(data != ""){
                                            data = JSON.parse(data);
                                            var cityType = false;
                                            var i;
                                            for (i in cityList) {
                                                if (data.address.indexOf(cityList[i])==0) {
                                                    citySwitch = true;
                                                    cityType = true;
                                                    dfd.resolve(citySwitch);
                                                    break;
                                                }
                                            }
                                            if(!cityType){
                                                dfd.reject(citySwitch);
                                            }
                                        }else{
                                            dfd.reject(citySwitch);
                                        }
                                    });
                                }
                            }
                        }else{
                            dfd.reject(citySwitch);
                        }
                   });
                }else{
                    dfd.reject(citySwitch);
                }
            });
            dfd.done(function (res) {
                options.livenessDetection = res;
                callBack();
            }).fail(function (res) {
                options.livenessDetection = res;
                callBack();
            });
        },

        //平安借记卡认证
        toDebitCardView: function () {
            utils.native.talkingDataTrackEvent("2.0身份认证-借记卡认证");
            this._setHead({title: "平安借记卡认证"});
            var data = App.storage.remove('verifyAccount/main/toDebitCardView');
            if(!data) return;

            App.container.show(new ByDebitView({
                model: new Model(data)
            }));
        },


        //平安信用卡认证
        toCreditCardView: function () {
            utils.native.talkingDataTrackEvent("2.0身份认证-信用卡认证");
            this._setHead({title: "平安信用卡认证"});
            var data = App.storage.remove('verifyAccount/main/toCreditCardView');
            if(!data) return;

            App.container.show(new ByCreditCardView({
                model: new Model(data)
            }));
        },

        //上传身份证认证视图
        toIdCardView: function () {
            utils.native.talkingDataTrackEvent("2.0身份认证-上传身份证");
            this._setHead({title: "上传身份证"});
            var data = App.storage.remove('verifyAccount/main/toIdCardView');
            if(!data) return;

            App.container.show(new ByIdCardView({
                model: new Model(data)
            }));
        },

        //人脸识别补拍两张照片
        toLivenessDetection: function () {
            utils.native.talkingDataTrackEvent("2.0-我-身份认证-人脸识别");
            this._setHead({title: "身份证上传", leftButtonHandler : function () {
                App.navigate('index/indexLogined/index', true);
            }});

            //人脸识别补拍2张身法证，需要传参身法证号;
            var cardId = App.storage.get('verifyAccount/main/toLivenessDetection');

            App.container.show(new ByLivenessDetectionView({
                model: new Model({
                    cardId: cardId
                })
            }));
        },

        securityLevel: function (code) {
            this._setHead({title: "了解橙级"});

            securitySetModel.settingSecurity({
                "silent": false,
                "param": "",
                "errorCallback": function (res) {
                    utils.dialog.alert(res.message);
                },
                "callback": function (res) {
                    App.container.show(new SecurityLevelView({model: new Model(res.object)}));
                }
            });

        },

        _setHead: function (options) {
            var defaults = {
                title: '开户',
                leftButtonContent: '@back'
            };
            defaults = _.extend(defaults, options || {});
            App.header.reset(defaults);
        },

         //激活-常驻城市：省份
        showProPage : function(){
        	App.header.reset({
                title:"选择省份",
                leftButtonHandler : function() {
                   var tempFormData = App.storage.get("verifyAccount/main/tempFormData");
                	if(tempFormData.fromPage == "accountInfoImprove"){
		            	App.navigate("verifyAccount/main/accountInfoImprove", true);
		            }else{
			            App.navigate("verifyAccount/main/accountInfoSet", true);
		            }
                },
                leftButtonContent:"@back"
            });
            App.container.show(new ProListView({model:new Model({"proList" : registerTools.assCityData(registerTools.getProvinceInfo)})}));
        },

        //激活-常驻城市：城市
        showCityPage : function(){
        	App.header.reset({
                title:"常驻城市",
                leftButtonHandler : function() {
                    App.navigate("verifyAccount/main/showProPage",true);
                },
                leftButtonContent:"@back"
            });
            App.container.show(new CityListView({model : new Model({"cityList" : registerTools.assCityData(App.storage.get("transfer_cityData").list)})}));
        },

        /**
		 * 功能：快捷认证
		 * author:ex_huangzit
		 * data:2015-08-17
		 */
		toFastAuthView: function () {
            var changeBindCard = App.storage.get('fastAuthBindCard/changeBindCard');
            if(changeBindCard && changeBindCard.fastAuth && changeBindCard.fastAuth == "changeBindCard"){
                this._setHead({
                    title: "更换绑定卡",
                    leftButtonHandler: function () {
                    	App.storage.remove('verifyIdentity/openBankList');
                		App.storage.remove('verifyIdentity/bankOption');
                		App.storage.remove('verifyIdentity/byFastAuth');
                        App.storage.remove("toPostUnionPay_formData");
                        if(App.storage.get("bankManageObj")) App.storage.remove("bankManageObj");
                       	App.navigate("me/accoutAndSecurity/bankManage/bindCard", true);
                    }
                });
            }else{
                this._setHead({
                    title: " 绑定借记卡",
                    leftButtonHandler: function () {
                    	App.storage.remove('verifyIdentity/openBankList');
                		App.storage.remove('verifyIdentity/bankOption');
                		App.storage.remove('verifyIdentity/byFastAuth');
                        App.storage.remove("toPostUnionPay_formData");
                        if(App.storage.get("bankManageObj")) App.storage.remove("bankManageObj");
                       	App.navigate("verifyAccount/main/verifyIdentity", true);
                    }
                });
            }
            var data = App.storage.get('verifyAccount/main/toFastAuthView');
            App.container.show(new ByFastAuthView({
                model: new Model(data)
            }));
        },

        /**
		 * 功能：跳到他行借记卡认证开户行列表页面
		 * author:ex_huangzit
		 * data:2015-08-18
		 */
        tobankInfoView:function(){
        	var changeBindCard = App.storage.get('fastAuthBindCard/changeBindCard');
            if(changeBindCard && changeBindCard.fastAuth && changeBindCard.fastAuth == "changeBindCard"){
                this._setHead({
                    title: "更换绑定卡",
                    leftButtonHandler: function () {
                        App.navigate("me/accoutAndSecurity/bankManage/bindCard", true);
                    }
                });
            }else{
                this._setHead({
                    title: "绑定借记卡",
                    leftButtonHandler: function () {
                        App.navigate("verifyAccount/main/toFastAuthView", true);
                    }
                });
            }
            //银行列表
            var openBankList = App.storage.get("verifyIdentity/openBankList");
            //跳到借记卡银行列表
            App.container.show(new openBankSelView({model:new Model({"openBankList":openBankList})}));
        },

        /**
		 * 功能：跳到他行借记卡认证最终确定页面
		 * author:ex_huangzit
		 * data:2015-08-18
		 */
        toFastAuthSubmitView:function(code){
            utils.native.talkingDataTrackEvent('2.0注册-绑卡-跳转银联鉴权');
        	this._setHead({
                title: "提示",
                leftButtonHandler: function () {
                    var registerBind= App.storage.get("register/bindCardFlag");
                    var bindCardFlag = App.storage.get('UserInfo').get('bindCardFlag');

                    App.storage.remove("toPostUnionPay_formData");
                    App.storage.remove("verifyIdentity/bankOption");
                    if(App.storage.get("bankManageObj")) App.storage.remove("bankManageObj");

                    if (bindCardFlag === '1' || registerBind === '1') {
                        var flag = App.storage.get("register/inputBindCard");
                        (flag) ? App.navigate("login/login/gestureLogin",true) : App.navigate("verifyAccount/bindCard/bindCardAuth", true);;
                    } else {
                        App.navigate("verifyAccount/main/toFastAuthView", true);
                    }

                }
            });
            App.storage.set("pageCode",code);
            //跳到借记卡银行列表
            App.container.show(new ByFastAuthSubmitView());
        },

        /**
         * 功能：借记卡认证成功
         * author:wuwenjun059
         * data:2015-08-24
         */
        toFastAuthSuccessView : function(){
            utils.native.talkingDataTrackEvent("2.0注册-绑卡-绑定成功提示");
            this._setHead({
                title: "绑定借记卡",
                leftButtonHandler: function () {
                	App.storage.remove('verifyIdentity/openBankList');
                	App.storage.remove("verifyIdentity/byFastAuth");
    				App.storage.remove("verifyIdentity/bankOption");

                    App.storage.remove("toPostUnionPay_formData");
                    if(App.storage.get("bankManageObj")) App.storage.remove("bankManageObj");

                    //成功之后的返回页面
                    App.navigate('index/indexLogined/index', true);
                }
            });

            App.container.show(new ByFastAuthSuccessView());
        },

        /**
         * 功能：借记卡认证失败
         * author:wuwenjun059
         * data:2015-08-24
         */
        toFastAuthFailView : function(){
            utils.native.talkingDataTrackEvent("2.0注册-绑卡-绑定失败提示");
            this._setHead({
                title: "绑定借记卡",
                leftButtonHandler: function () {
                	App.storage.remove('verifyIdentity/openBankList');
                	App.storage.remove("verifyIdentity/byFastAuth");
    				App.storage.remove("verifyIdentity/bankOption");
                    App.storage.remove("toPostUnionPay_formData");
                    if(App.storage.get("bankManageObj")) App.storage.remove("bankManageObj");

                    var registerBind= App.storage.get("register/bindCardFlag");
                    var bindCardFlag = App.storage.get('UserInfo').get('bindCardFlag');
                    if (bindCardFlag === '1' || registerBind === '1') {
                        var flag = App.storage.get("register/inputBindCard");
                        (flag) ? App.navigate("login/login/gestureLogin", true) :  App.navigate('me/accoutAndSecurity/bankManage/bindCard', true);
                    }else{
                        //失败的返回页面
                        App.navigate("verifyAccount/main/verifyIdentity", true);
                    }
                }
            });
            //认证失败原因
            var failReason = App.storage.get("verifyFailReason");
            App.container.show(new ByFastAuthFailView(new Model({"failReason":failReason})));
        },

        /**
         * 功能：展示成功页
         * author:wuwenjun059
         * data:2015-08-27
         */
        toFastAuthReturnSuc : function(){
            //关闭银联鉴权页面
            utils.window.close();
            this._setHead({
                title: "银联认证结果",
                leftButtonHandler: function () {
                    //失败的返回页面
                    App.navigate("verifyAccount/main/verifyIdentity", true);
                }
            });
            App.container.show(new ByFastAuthReturnView());
        },

        /**
         * 功能：POST到银联
         * author:ex_huangzit
         * data:2015-09-04
         */
        toPostToUnionPay : function(){
            //关闭银联鉴权页面
            // this._setHead({
                // title: "银联认证结果",
                // leftButtonHandler: function () {
                    // //失败的返回页面
                    // App.navigate("verifyAccount/main/verifyIdentity", true);
                // }
            // });
            var options = App.storage.get("postToUnionPayOption");
            App.container.show(new PostToUnionPayView({"model":new Model(options)}));
        }
    });
});
