define(function (require, exports, module) {

    exports.creditCardActivation = function(formData, callback){
        return App.request("creditCardActivation", {
            data: formData,
            complete: function(err, resp){
                callback(err, resp);
            }
        });
    };

    exports.upLoadImFile = function(formData, callback){
        return App.request("upLoadImFile", {
            data: formData,
            complete: callback
        });
    };

	//人脸识别上传三张图片
    exports.upLoadFaceImFile = function(formData, callback){
        return App.request("upLoadFaceImFile", {
            data: formData,
            complete: callback
        });
    };

    exports.debitCardActivation = function(formData, callback){
        return App.request("veryifyByDebitCard", {
            data: formData,
            complete: function(err, resp){
                callback(err, resp);
            }
        });
    };

    exports.otpActivation=function(options){
        App.request("veryifyByOtp",{
            success:function(response){
                options.success(response);
            },
            error:function(response){
                options.error(response);
            }
        });
    };

    exports.getUserType=function(options){
        App.request("veryifyGetUserType",{
            //请求的data是多余的，后面要删掉
            data:{
                "ecifNo" : "655000594334"
            },
            success:function(response){
                options.success(response);
            },
            error:function(response){
                utils.dialog.alert(response.message);
            }
        });
    };

    //该接口为网银后端提供的接口，返回规范略有不一样
    exports.uploadIdPhoto = function(option){
        var param         = option.param,
            errorCallback = option.errorCallback,
            callback      = option.callback;

        App.request("uploadIdPhoto", {
            type    : "post",
            silent  : false,//true 不显示loading
            data    : param,
            success : function(resp){
                callback && callback(resp.responseBody);
            },
            error   : function(resp){
                if (resp.errCode === '000') {
                    callback && callback(resp.responseBody);
                } else {
                    errorCallback && errorCallback(resp.errMsg || resp.message);
                }
            }
        });
    };

    //判断是否为可疑名单、平安大数据用户、人工审核状态
    exports.qryIsCanFaceActive=function(options){
        App.request("qryIsCanFaceActive",{
            success:function(response){
                options.success(response);
            },
            error:function(response){
                options.errorCallback(response);
            }
        });
    };

    //人脸相似度判断
    exports.faceCompareByPhoto=function(options){
        App.request("faceCompareByPhoto",{
            data: options.param,
            success:function(response){
                options.callback(response);
            },
            error:function(response){
                options.errorCallback(response);
            }
        });
    };

    exports.validateUserInfo = function(options){
    	App.request("validateUserInfo",{
            data: {},
            success:function(response){
                options.callback(response);
            },
            error:function(response){
                options.errorCallback(response);
            }
        });
    };

    //校验一账通或则设置一账通信息
    exports.settingUserInfo = function(options){
    	App.request("settingUserInfo",{
            data: options.formData,
            success:function(response){
                options.callback(response);
            },
            error:function(response){
                options.errorCallback(response);
            }
        });
    };

    //校验一账通信息
    exports.activateLoginVerify = function(options){
    	App.request("activateLoginVerify",{
            data: options.formData,
            success:function(response){
                options.callback(response);
            },
            error:function(response){
                options.errorCallback(response);
            }
        });
    };

    //校验一账通信息
    exports.settingSecurityInfo = function(options){
    	App.request("settingSecurity",{
            data: options.formData,
            success:function(response){
                options.callback(response);
            },
            error:function(response){
                options.errorCallback(response);
            }
        });
    };

    //2015-06-30
    //2.0 激活(财富E迁移情况下，卡已激活，但需要再次验证身份)
    //判断是否能再次身份验证(0:不需要身份验证   1：需要身份验证)
    exports.againVerify = function(options){
        App.request("againVerify",{
            data: options.formData,
            success:function(response){
                options.success(response);
            },
            error:function(response){
                options.errorCallback(response);
            }
        });
    };
    
 
    //他行借记卡认证确认变更
    exports.byFastAuthChange = function(options){
        App.request(options.url,{
            success : function(response){
                options.success(response);
            },
            error : function(response){
                options.errorCallback(response);
            }
        });
    };
    
    //银联鉴权加签接口
    exports.unionPaySign = function(options){
        App.request(options.url,{
        	data : options.data,
            success : function(response){
                options.callback(response);
            },
            error : function(response){
                options.errorCallback(response);
            }
        });
    };
    
    //鉴权变更状态
    exports.successUpdate = function(options){
        App.request(options.url,{
        	data : options.data,
            success : function(response){
                options.callback(response);
            },
            error : function(response){
                options.errorCallback(response);
            }
        });
    };
    
    //鉴权开关
    exports.qryUseSwitch = function(options){
        App.request(options.url,{
        	data : options.data,
            success : function(response){
                options.callback(response);
            },
            error : function(response){
                options.errorCallback(response);
            }
        });
    };
    
    exports.queryAllBankList = function(options){
        App.request(options.url,{
        	data : options.data,
            success : function(response){
                options.callback(response);
            },
            error : function(response){
                options.errorCallback(response);
            }
        });
    };
    
    //新增绑定借记卡卡信息
    exports.validateDebitCard = function(options){
        App.request(options.url,{
        	data : options.data,
            success : function(response){
                options.callback(response);
            },
            error : function(response){
                options.errorCallback(response);
            }
        });
    };
    
    //绑定本行卡
    exports.bindSameBankCard = function(options){
        App.request(options.url,{
        	data : options.data,
            success : function(response){
                options.callback(response);
            },
            error : function(response){
                options.errorCallback(response);
            }
        });
    };
    
    //银联鉴权
    exports.unionSendBack = function(options){
        App.request(options.url,{
        	data : options.data,
            success : function(response){
                options.callback(response);
            },
            error : function(response){
                options.errorCallback(response);
            }
        });
    };
    
    //取消绑定
    exports.cancelBindCard = function(options){
        App.request(options.url,{
        	data : options.data,
            success : function(response){
                options.callback(response);
            },
            error : function(response){
                options.errorCallback(response);
            }
        });
    };
    
    exports.checkAccountSuspicious = function(options){
       App.request(options.url,{
           data:options.data,
           success:function(response){
               options.callback(response);
           },
           error:function(response){
               options.errorCallback(response);
           }
       });  
    };
    
});