/**
 * ex-wuyongsheng001 一账通 完善账户信息 视图
 */
define(function(require, exports, module){
    var safeKeyBoardHelper = require("component/customInput.helper");
	var FormLayout         = require("component/form");
    var identityModel      = require("../model/identityModel");
    var Tpl                = _.template(require("text!../template/accountInfoImprove.html"));

    module.exports = FormLayout.extend({
        template: Tpl,
        ui: {
            nextStepBtn : '#nextStepBtn'
        },
        events    : {
            'tap @ui.nextStepBtn': '_toNextStep',
            "input #email" : "_setFullFill",
            "customInputKeyup #transPwd" : "_setFullFill",
            "customInputKeyup #transRePwd" : "_setFullFill",
            "customInputFocusIn #transPwd"  : "_customInputPwdFocusIn", 
            "customInputFocusOut #transPwd" : "_customInputPwdFocusOut",
            "customInputFocusIn #transRePwd"  : "_customInputRePwdFocusIn", 
            "customInputFocusOut #transRePwd" : "_customInputRePwdFocusOut",
            "tap #cityInfo": "_toCityInfo"
        },
        initialize:function(){
        	this._submitFlag = false;
        },
        onRender:function(){
        	this._showSafeKeyBoard();
        	//this._getLocation();
        	this._showInitEl();
        },
        
        //展示邮箱
        _showInitEl:function(){
        	var userInfoOption = App.storage.get("verifyAccount/userInfoOption");
        	if(userInfoOption){
	        	this.userFlag = userInfoOption.userFlag;
	        	var email = userInfoOption.email;
	        	if(email) this.$("#email").val(email);
        	}
        	
        	var tempFormData = App.storage.get("verifyAccount/main/tempFormData");
            if (tempFormData) {
                //常驻城市
                // this.$("#cityInfo>p").attr("provinceName", tempFormData.provinceValue);
                // this.$("#cityInfo>p").attr("cityName", tempFormData.cityValue);
                
                this.$("#email").val(tempFormData.email);
            }
        },
        
        _setFullFill : function () {
        	 var email =  this.$('#email').val();
        	 var transPwd = this.$("#transPwd").customInput('value');
        	 var transRePwd = this.$("#transRePwd").customInput('value');
        	 
        	 //常驻城市
             //var provinceName = this.$("#cityInfo>p").attr("provinceName");
            // var cityName = this.$("#cityInfo>p").attr("cityName");

        	 if(email && transPwd && transRePwd){
        	 	if(this.$('#nextStepBtn').hasClass("btn_disable")) this.$('#nextStepBtn').removeClass('btn_disable');
        	 	this.$('#nextStepBtn').addClass("btn_orange");
        	 	this.$('#nextStepBtn').prop("disabled", false);
        	 }else{
        	 	if(this.$('#nextStepBtn').hasClass("btn_orange")) this.$('#nextStepBtn').removeClass('btn_orange');
        	 	this.$('#nextStepBtn').addClass("btn_disable");
        	 	this.$('#nextStepBtn').prop("disabled", true);
        	 }
        },
        
        _showSafeKeyBoard:function(){
            this.$("#transPwd").customInput({
               type: "password-number",
               placeholder: "交易密码",
               className:"safeKeyBoard",
               maxLength:"6"
            });
            
            this.$("#transRePwd").customInput({
               type: "password-number",
               placeholder: "请再次输入交易密码",
               className:"safeKeyBoard",
                maxLength:"6"
            });
        },
        
        _customInputPwdFocusIn : function(){
            safeKeyBoardHelper.focusIn({id :"transPwd"});
        },

        _customInputPwdFocusOut : function(){
            safeKeyBoardHelper.focusOut({id :"transPwd"});
        },
        
        _customInputRePwdFocusIn : function(){
            safeKeyBoardHelper.focusIn({id :"transRePwd"});
        },

        _customInputRePwdFocusOut : function(){
            safeKeyBoardHelper.focusOut({id :"transRePwd"});
        },
        
        _formData:function(){
        	// var userInfoOption = App.storage.get("verifyAccount/userInfoOption");
        	// var userName = "";//一账通用户名
        	// var password = "";//一账通密码
        	var tranPwd = $("#transPwd").customInput("value");//交易密码
		var sm2Pwd = utils.sm2.SM2Key.encrypt(tranPwd,config.base.sm2_public_key);
        	tranPwd = utils.crypto.RSAKey.encrypt(tranPwd, config.base.rsa_public_key);
        	var email = $("#email").val();//邮箱
        	
        	// if(userInfoOption){
	        // 	var mobile = userInfoOption.mobile;//手机
	        // 	var userFlag = userInfoOption.userFlag;//标识
        	// }
        	
        	//省份城市
            // var provinceName = this.$("#cityInfo>p").attr("provinceName");
            // var cityName = this.$("#cityInfo>p").attr("cityName");
            
        	var formData = {
        		fromPage:"accountInfoImprove",
        		tranPwd:tranPwd,
			sm2Pwd:sm2Pwd,
        		email:email,
        		userFlag:this.userFlag,
        		provinceName: '广东',
                cityName: '深圳'
        	};
			
        	return formData;
        },
        
        //提交
        _toNextStep: function (e) {
        	var self = this;
        	//防止重复提交
        	if(self._submitFlag){
        		return;
        	}
        	if(self._validataData()){
	        	self._submitFlag = true;
	        	identityModel.settingUserInfo({
	                formData : self._formData(),
	                callback : function(resp) {
	                    self._submitFlag = false;
                        App.storage.get("UserInfo").set({"isTelephoneLogin": false});
	                    var message = "设置成功！下次请使用用户名，密码登陆平安橙子！";
	                    utils.dialog.alert(message, function(flag){
							if(flag){
								App.storage.remove("verifyAccount/main/tempFormData");
                                var bindCardFlag = App.storage.get('UserInfo').get('bindCardFlag');
                                if(bindCardFlag == 1){
                                    App.navigate('verifyAccount/bindCard/inputBindCard', true);//新流程
                                }else{
                                    App.navigate('verifyAccount/main/verifyIdentity', true);//老流程
                                }
							}
						}); 
	                },
	                errorCallback : function(resp) {
	                    self._submitFlag = false;
	                    utils.dialog.alert(resp.message);
	                }
	            });
        	}
        },
        
        //选择常驻省份-城市
        _toCityInfo: function () {
            var tempFormData = this._formData();
            App.storage.set("verifyAccount/main/tempFormData", tempFormData);
            App.navigate("verifyAccount/main/showProPage", true);
        },
        
        //获取地理位置
        _getLocation: function () {
            var transfer_cityData = App.storage.get("transfer_cityData");
            var showCityInfo = '<p class="f14 omit tar city" style="width:70%" provinceName="广东" cityName="深圳">广东，深圳</p>';
            if (transfer_cityData) {
                var cityValue = transfer_cityData.cityValue;
                if (!cityValue) {
                    cityValue = "";
                }
                var provinceValue = transfer_cityData.provinceValue;
                if (!provinceValue) {
                    provinceValue = "";
                }
                showCityInfo = '<p class="f14 omit tar city" style="width:70%" provinceName="' + provinceValue + '" cityName="' + cityValue + '">' + provinceValue + '，' + cityValue + '</p>'
            }
            
            if(this.$("#cityInfo>p").length){
                this.$("#cityInfo").find('p').remove();
            }
            this.$("#commonCity").after(showCityInfo);
        },
        
        //校验数据
        _validataData:function(){
        	//校验email是否为空
        	var email = $("#email").val();
        	if(email == "" || email == null){
                utils.dialog.toast("请输入电子邮箱"); 
                return false;
            }
            
        	//校验email格式
            if(!utils.validate.email(email)){
                utils.dialog.toast("输入电子邮箱格式不正确"); 
                return false;
            }
            
             //校验一账通常驻城市
            // var provinceName = this.$("#cityInfo>p").attr("provinceName");
            // var cityName = this.$("#cityInfo>p").attr("cityName");
            // if (!provinceName || !cityName) {
            //     utils.dialog.toast("请选择常驻城市");
            //     return false;
            // }
            
            //校验密码是否为空
            var password = $("#transPwd").customInput("value");
            var rePassword = $("#transRePwd").customInput("value");
            if (password === "") {
                utils.dialog.toast("请输入交易密码"); 
                return false;
            }
            if (rePassword === "") {
                utils.dialog.toast("请输入重复交易密码"); 
                return false;
            }  
            
        	//校验两次密码是否相同
        	if (password != rePassword) {
                utils.dialog.toast("两次输入交易密码不一致"); 
                return false;
            }
            return true;
        }

    });
});
