/**
 * ex-wuyongsheng001 一账通账户登录验证
 */
define(function (require, exports, module) {
    var verifyAccountTpl = _.template(require("text!../template/accountInfoSet.html"));
    var FormLayout = require("component/form");
    var safeKeyBoardHelper = require("component/customInput.helper");

    var identityModel = require("../model/identityModel");
    var registerTools = require("mod/openAccount/common/registerTools");
    var registerLang = require("mod/openAccount/common/registerLang");

    module.exports = FormLayout.extend({
        template: verifyAccountTpl,
        ui: {
            nextStepBtn: '#nextStepBtn'
        },
        modelEvents: {
            'change': '_validateInfo'
        },
        events: {
            'tap @ui.nextStepBtn': 'toNextStep',
            "customInputFocusIn #transPwd": "_customInputPwdFocusIn",     //交易密码
            "customInputFocusOut #transPwd": "_customInputPwdFocusOut",    //交易密码
            "customInputFocusIn #transRePwd": "_customInputRePwdFocusIn", //交易重复密码
            "customInputFocusOut #transRePwd": "_customInputRePwdFocusOut",//交易重复密码
            "customInputFocusIn #yztPassword": "_customInputYztPwdFocusIn",         //一账通登录密码    ?
            "customInputFocusOut #yztPassword": "_customInputYztPwdFocusOut",        //一账通登录密码    ?
            "customInputFocusIn #yztRePassword": "_customRePwdFocusIn",     //一账通重复登录密码?
            "customInputFocusOut #yztRePassword": "_customRePwdFocusOut",    //一账通重复登录密码?
            "tap #cityInfo": "_toCityInfo",
            "input #email": "_setFullFill",                       //电子邮箱
            "customInputKeyup #transPwd": "_setFullFill",         //交易密码
            "customInputKeyup #transRePwd": "_setFullFill",       //交易重复密码
            "input #YZT_username": "_setFullFill",     			  //用户名
            "customInputKeyup #yztPassword": "_setFullFill",      //一账通登录密码            ?
            "customInputKeyup #yztRePassword": "_setFullFill"     //一账通重复登录密码        ?
        },

        initialize: function () {
            this._submitFlag = false;
        },

        onRender: function () {
            this._showSafeKeyBoard();
            //this._getLocation();
            this._showDetail();

            var userInfoOption = App.storage.get("verifyAccount/userInfoOption");
            if (userInfoOption) {
                this.mobile = userInfoOption.mobile;
                this.birthDate = userInfoOption.birthDate;
                if (!this.birthDate) {
                    this.birthDate = "";
                }
                if (!this.mobile) {
                    this._queryMobile();
                }
            }

        },

        //查询手机号
        _queryMobile: function () {
            var self = this;
            identityModel.settingSecurityInfo({
                formData: {},
                callback: function (resp) {
                    if (resp.object.mobileNum) {
                        self.mobile = resp.object.mobileNum;
                    } else {
                        self.mobile = "";
                    }
                },
                errorCallback: function (resp) {
                    self.mobile = "";
                    utils.dialog.alert(resp.message);
                }
            });
        },

        //展示数据
        _showDetail: function () {
            var tempFormData = App.storage.get("verifyAccount/main/tempFormData");
            if (tempFormData) {
                //一账通用户名
                this.$('#YZT_username').val(tempFormData.userName);
                //校验一账通密码
//                this.$("#yztPassword").customInput("value", tempFormData.password);
//                this.$("#yztRePassword").customInput("value", tempFormData.passwordOrg);
                this.$("#yztPassword").customInput("value", (!tempFormData.passwordOrg) ? "" : tempFormData.passwordOrg);
                this.$("#yztRePassword").customInput("value", (!tempFormData.rePasswordOrg) ? "" : tempFormData.rePasswordOrg);

                //常驻城市
                //this.$("#cityInfo>p").attr("provinceName", tempFormData.provinceValue);
                //this.$("#cityInfo>p").attr("cityName", tempFormData.cityValue);

                //email
                this.$('#email').val(tempFormData.email);

                //交易密码
//                this.$("#transPwd").customInput("value", tempFormData.transPwd);
//                this.$("#transRePwd").customInput("value", tempFormData.transRePwd);
                this.$("#transPwd").customInput("value", (!tempFormData.tranPwdOrg) ? "" : tempFormData.tranPwdOrg);
                this.$("#transRePwd").customInput("value", (!tempFormData.tranRePwdOrg) ? "" : tempFormData.tranRePwdOrg);
            }
            
            this._setFullFill();
        },

        //校验按钮disabled
        _setFullFill: function () {
            //一账通用户名
            var YZT_username = this.$('#YZT_username').val();

            //校验一账通密码
            var yztPassword = this.$("#yztPassword").customInput("value");
            var yztRePassword = this.$("#yztRePassword").customInput("value");

            //常驻城市
            //var provinceName = this.$("#cityInfo>p").attr("provinceName");
            //var cityName = this.$("#cityInfo>p").attr("cityName");

            //email
            var email = this.$('#email').val();

            //交易密码
            var transPwd = this.$("#transPwd").customInput('value');
            var transRePwd = this.$("#transRePwd").customInput('value');

            if (YZT_username && yztPassword && yztRePassword && email && transPwd && transRePwd) {
                if (this.$('#nextStepBtn').hasClass("btn_disable")) this.$('#nextStepBtn').removeClass('btn_disable');
                this.$('#nextStepBtn').addClass("btn_orange");
                this.$('#nextStepBtn').prop("disabled", false);
            } else {
                if (this.$('#nextStepBtn').hasClass("btn_orange")) this.$('#nextStepBtn').removeClass('btn_orange');
                this.$('#nextStepBtn').addClass("btn_disable");
                this.$('#nextStepBtn').prop("disabled", true);
            }
        },

        //获取地理位置
        _getLocation: function () {
            var self = this;
            var transfer_cityData = App.storage.get("transfer_cityData");
            var showCityInfo = '<p class="f14 omit tar city" style="width:70%" provinceName="广东" cityName="深圳">广东，深圳</p>'
            if (transfer_cityData) {
                var cityValue = transfer_cityData.cityValue;
                if (!cityValue) {
                    cityValue = "";
                }
                var provinceValue = transfer_cityData.provinceValue;
                if (!provinceValue) {
                    provinceValue = "";
                }
                showCityInfo = '<p class="f14 omit tar city" style="width:70%" provinceName="' + provinceValue + '" cityName="' + cityValue + '">' + provinceValue + '，' + cityValue + '</p>'
            }
            // else{
            // utils.native.location(function(data){
            // if(data.administrativeArea && data.locality){
            // showCityInfo = '<p class="f14 omit tar city" style="width:70%" provinceName="'+data.administrativeArea+'" cityName="'+data.locality+'">'+data.administrativeArea +'，'+data.locality+'</p>'
            // }
            // });
            // }
            if(this.$("#cityInfo>p").length){
                this.$("#cityInfo").find('p').remove();
            }
            this.$("#commonCity").after(showCityInfo);
        },

        //初始化一账通登陆密码、重复密码，橙子交易密码、重复密码
        _showSafeKeyBoard: function () {

            //一账通登陆密码、重复密码
            this.$("#yztPassword").customInput({
                type: "password-ascii",
                placeholder: "8-16个字符",
                className: "safeKeyBoard",
                maxLength: "16"
            });
            this.$("#yztRePassword").customInput({
                type: "password-ascii",
                placeholder: "请再次输入密码",
                className: "safeKeyBoard",
                maxLength: "16"
            });

            //橙子交易密码、重复密码
            this.$("#transPwd").customInput({
                type: "password-number",
                placeholder: "6位数字",
                className: "safeKeyBoard",
                maxLength: "6"
            });

            this.$("#transRePwd").customInput({
                type: "password-number",
                placeholder: "请再次输入密码",
                className: "safeKeyBoard",
                maxLength: "6"
            });

            App.storage.set("initSafeKeyBoard", true);
        },

        /**
         * 一账通登陆密码 、重复登陆密码
         */
        _customInputYztPwdFocusIn: function () {
            safeKeyBoardHelper.focusIn({id: "yztPassword"});
        },

        _customInputYztPwdFocusOut: function () {
            safeKeyBoardHelper.focusOut({id: "yztPassword"});
        },

        _customRePwdFocusIn: function () {
            safeKeyBoardHelper.focusIn({id: "yztRePassword"});
        },

        _customRePwdFocusOut: function () {
            safeKeyBoardHelper.focusOut({id: "yztRePassword"});
        },

        /**
         * 交易密码 、重复密码
         */
        _customInputPwdFocusIn: function () {
            safeKeyBoardHelper.focusIn({id: "transPwd"});
        },
        _pwdFocusIn: function () {
            safeKeyBoardHelper.focusIn({id: "transPwd"});
        },
        _customInputPwdFocusOut: function () {
            safeKeyBoardHelper.focusOut({id: "transPwd"});
        },

        _customInputRePwdFocusIn: function () {
            safeKeyBoardHelper.focusIn({id: "transRePwd"});
        },

        _customInputRePwdFocusOut: function () {
            safeKeyBoardHelper.focusOut({id: "transRePwd"});
        },

        //校验数据
        _validateInfo: function () {
            //校验一账通用户名
            var YZT_username = $("#YZT_username").val();

            //用户名为空
            if (!YZT_username) {
                utils.dialog.toast(registerLang("registerUserNameEmpty"));
                return false;
            }
            var isValidUserName = registerTools.isValidateUserName(YZT_username);
            if (isValidUserName != true) {
                utils.dialog.toast(isValidUserName);
                return false;
            }

            //校验一账通密码
            var yztPassword = $("#yztPassword").customInput("value");

            if (!yztPassword) {
                utils.dialog.toast(registerLang("registerLoginPwdEmpty"));
                return false;
            }

            var option = {
                "value": yztPassword,
                "mobile": this.mobile,
                "birthday": this.birthDate,
                "uid": YZT_username
            };
            var isValidPwd = registerTools.isValidatePassword(option);
            if (isValidPwd != true) {
                utils.dialog.toast(isValidPwd);
                return false;
            }

            //重复密码
            var yztRePassword = $("#yztRePassword").customInput("value");
            if (!yztRePassword) {
                utils.dialog.toast(registerLang("registerConfLoginPwdEmpty"));
                return false;
            }

            //校验两次密码是否相同
            if (yztPassword != yztRePassword) {
                utils.dialog.toast(registerLang("registerSetUserSecEqu"));
                return false;
            }

            //校验一账通常驻城市
            // var provinceName = this.$("#cityInfo>p").attr("provinceName");
            // var cityName = this.$("#cityInfo>p").attr("cityName");
            // if (!provinceName || !cityName) {
            //     utils.dialog.toast("请选择常驻城市");
            //     return false;
            // }

            //校验邮箱
            var email = $("#email").val();
            if (email == "" || email == null) {
                utils.dialog.toast("请输入电子邮箱");
                return false;
            }

            //校验email格式
            if (!utils.validate.email(email)) {
                utils.dialog.toast("输入电子邮箱格式不正确");
                return false;
            }

            //校验一橙子交易密码
            var password = $("#transPwd").customInput("value");
            var rePassword = $("#transRePwd").customInput("value");
            if (password === "") {
                utils.dialog.toast("请输入交易密码");
                return false;
            }
            if (rePassword === "") {
                utils.dialog.toast("请输入重复交易密码");
                return false;
            }

            //校验两次密码是否相同
            if (password != rePassword) {
                utils.dialog.toast("两次输入交易密码不相同");
                return false;
            }
            return true;
        },

        //准备数据
        _formData: function () {
            var userInfoOption = App.storage.get("verifyAccount/userInfoOption");
            var userName = $("#YZT_username").val();                                         //一账通用户名
            var passwordOrg = $("#yztPassword").customInput("value");                        //一账通密码
            var rePasswordOrg = $("#yztRePassword").customInput("value");                    //一账通密码
            var password = utils.crypto.RSAKey.encrypt(passwordOrg, config.base.ras_um_key);
            var sm2Pwd = utils.sm2.SM2Key.encrypt(passwordOrg,config.base.sm2_um_key);
            var tranPwdOrg = $("#transPwd").customInput("value");                            //交易密码
            var tranRePwdOrg = $("#transRePwd").customInput("value");                        //重复交易密码
            var tranPwd = utils.crypto.RSAKey.encrypt(tranPwdOrg, config.base.rsa_public_key);
            var tranSm2Pwd = utils.sm2.SM2Key.encrypt(tranPwdOrg,config.base.sm2_public_key);
            var email = $("#email").val();//邮箱
            var mobile = "";
            var userFlag = "";
            //省份城市
            // var provinceName = this.$("#cityInfo>p").attr("provinceName");
            // var cityName = this.$("#cityInfo>p").attr("cityName");

            if (userInfoOption) {
                mobile = userInfoOption.mobile;//手机
                this.userFlag = userFlag = userInfoOption.userFlag;//标识
            }
            var formData = {
            	fromPage:"accountInfoSet",
                userName: userName,
                password: password,              //加密后的 一账通密码
                sm2Pwd : sm2Pwd,                 //一账通sm2密文
                tranPwd: tranPwd,                //加密后的 交易密码
                tranSm2Pwd: tranSm2Pwd,          //交易密码sm2密文
                email: email,
                mobile: mobile,
                userFlag: userFlag,
                passwordOrg: passwordOrg,        //未加密的 一账通密码
                rePasswordOrg: rePasswordOrg,    //未加密的 重复一账通密码
                tranPwdOrg: tranPwdOrg,          //未加密的 交易密码
                tranRePwdOrg: tranRePwdOrg,      //未加密的 重复交易密码
                provinceName: '广东',
                cityName: '深圳'
            };
            return formData;
        },

        //提交数据
        toNextStep: function (e) {
            var self = this;
            //防止重复提交
            if (self._submitFlag) {
                return;
            }
            if (self._validateInfo()) {
                self._submitFlag = true;
                identityModel.settingUserInfo({
                    formData: self._formData(),
                    callback: function (resp) {
                        self._submitFlag = false;
                        App.storage.get("UserInfo").set({"isTelephoneLogin": false});
                        var message = "设置成功！下次请使用用户名，密码登录平安橙子！";
                        utils.dialog.alert(message, function (flag) {
                            if (flag) {
                            	App.storage.remove("verifyAccount/main/tempFormData");
                                var bindCardFlag = App.storage.get('UserInfo').get('bindCardFlag');
                                if(bindCardFlag == 1){
                                    App.navigate('verifyAccount/bindCard/inputBindCard', true);//新流程
                                }else{
                                    App.navigate('verifyAccount/main/verifyIdentity', true);//老流程
                                }
                            }
                        });
                    },
                    errorCallback: function (resp) {
                        self._submitFlag = false;
                        utils.dialog.alert(resp.message);
                    }
                });
            }
        },

        //选择常驻省份-城市
        _toCityInfo: function () {
            var tempFormData = this._formData();
            App.storage.set("verifyAccount/main/tempFormData", tempFormData);
            App.navigate("verifyAccount/main/showProPage", true);
        }
    });
});
