/**
 *注册城市列表页View
 */
define(function(require, exports, module){

    var template      = require("text!../template/registerCityList.html");
    var registerTools = require("mod/openAccount/common/registerTools");

    var transferCityListView = module.exports = Layout.extend({
        template: _.template(template),
        events: {
            "input #reg_city" : "filterCity",  //筛选城市
            "tap #reg_cityDiv li" : "showCity"  //显示城市列表
        },

        filterCity : function(e) {
            var keyWord = $(e.currentTarget).val().replace(/[ ]/g,"").toUpperCase();
            //分组排序后的数组
            var cityList = App.storage.get("transfer_cityData").list;
             //根据拼音匹配
            var filterList = [];

            // 关键字为空时，过滤出所有省份
            if(keyWord == "") {
                filterList = cityList;
            }else {
                 _.each(cityList,function(city,i){
                     if(city.cityPy.indexOf(keyWord) == 0) {
                        filterList.push(city);
                     }
                 });

                 //根据中文匹配
                 _.each(cityList,function(city,j) {
                     if(city.cityName.indexOf(keyWord) == 0) {
                        filterList.push(city);
                     }
                 });
            }

            // 重新生成城市列表选项
            if(filterList.length == 0) {
                 // 清空所有城市列表
                $("#reg_cityDiv").html("");
                $("#searchCity,#searchCityRes").show();
            }else{
            	$("#searchCity,#searchCityRes").hide();
                var newFilterList = registerTools.assCityData(filterList);

                var cityDivList = "";
                var newCityDivList = "<div class='qyMain'>";
                _.each(newFilterList,function(newList,j) {
                    cityDivList = '<p class="c_999 f14  m_l10 p_t10_b10">'+newList.Ab+'</p><div class="Columns b_t0"><ul class="ulStyle1 fannyulStyle2">';
                    _.each(newList.lists,function(list,i) {
                        cityDivList+='<li class="dswkb" cityKey='+list.cityId+'>'+list.cityName+'</li>';
                    });
                    cityDivList=cityDivList+'</ul></div>'
                    newCityDivList += cityDivList;
                });
                newCityDivList += "</div>";
                $("#reg_cityDiv").html(newCityDivList);

            }
        },

        /**
         *城市写入
         */
        showCity : function(e) {
        	var self = this;
        	e.stopPropagation();
        	e.preventDefault();
            setTimeout(function(){
            	self.showCityTimeOut(e);
            }, 300);
        },
        
        showCityTimeOut:function(e){
        	var cityData = App.storage.get("transfer_cityData");
            cityData.cityId = $(e.currentTarget).attr("cityKey");
            cityData.cityValue = $(e.currentTarget).text();
            App.storage.set("transfer_cityData",cityData);
            var tempFormData = $.extend({},App.storage.get("verifyAccount/main/tempFormData"),cityData);
            App.storage.set("verifyAccount/main/tempFormData", tempFormData);
            if(tempFormData.fromPage == "accountInfoImprove"){
            	App.navigate("verifyAccount/main/accountInfoImprove", true);
            }else{
	            App.navigate("verifyAccount/main/accountInfoSet", true);
            }
        }

    });
});