define(function(require, exports, module) {
    var temp 			   = require("text!../../template/verifyIdentity/byFastAuth.html");
    var FormComponent 	   = require("component/form");
    var IdentityModel      = require("../../model/identityModel");
    var bankListModel      = require("mod/me/model/transferModel");
    var safeKeyBoardHelper = require("component/customInput.helper");
    var OtpView			   = require("component/otp/OtpView");

    module.exports = FormComponent.extend({
        template: _.template(temp),
        events: {
            'tap #nextStepBtn'	 : '_toSubmit',
            'tap #bankInfo'		 : '_toBankInfoPattern',
            'input #bankCardNo'	 : '_setFullFill',
         	'input #mobile'		 : '_setFullFill',
          	'input #otp_passWord': '_setFullFill',
          	'tap #checkbox'		 : '_clickPayment',
          	'tap #userPayment'	 : '_clickUserPayment'
          	
        },
        
		initialize:function(){
			this.submitFlag = false;
		},
		
        onRender: function(){
        	
        	//激活帮卡标识
        	var verifyMode = App.storage.get("changeBindCard_verifyMode");
        	var statusState = App.storage.get("UserInfo").get("cardState");
        	var userName = App.storage.get("UserInfo").get("trueName");
        	this.$('#userName').html(userName);
        	//激活
			if(statusState == "1" && verifyMode && verifyMode == 'a'){
        	 	this.$("#fastActive").hide();
        	 	this.$("#changeBindCard").show();
        	}
            //查询开户行
            if(!App.storage.get("verifyIdentity/openBankList")){
	           this._qryPaPayBankList();
            }

            //卡bin列表
            if(!App.storage.get("verifyIdentity/bankBinList")){
	           this._qryBankBinSel();
            }

            //开户行信息
            if(App.storage.get("verifyIdentity/bankOption")){
            	var bankOption = this.bankOption = App.storage.get("verifyIdentity/bankOption");
            	this.$("#bankInfo div").html(bankOption.recBankName);
            }

            //选择卡号回填
            var byFastAuthOption = App.storage.get("verifyIdentity/byFastAuth");
            if(byFastAuthOption && byFastAuthOption.cardNo){
            	this.$('#bankCardNo').val(byFastAuthOption.cardNo);
            	this._setFullFill();
            }
        },

		_setFullFill : function () {
        	 var bankCardNo = this.$("#bankCardNo").val();
        	 var openBankList = App.storage.get("verifyIdentity/openBankList");//取得银行列表
        	 
        	 //匹配卡Bin
        	 if(openBankList){
	        	 //if(!App.storage.get("verifyIdentity/bankOption")){
		        	 var cardLengh = bankCardNo.length;
		        	 if(cardLengh >= 6){
		        	 	var bankBinList = App.storage.get("verifyIdentity/bankBinList");
		        	 	var bankOption;
		        	 	for(var i=0; i<bankBinList.length; i++){
		        	 		if((bankCardNo.substring(0, 6) == bankBinList[i].cardBin) && (bankBinList[i].bankCode == '307')){
		        	 			bankOption = this.bankOption = {
		        	 				recBankId:'307',
		        	 				recBankName:'平安银行'
		        	 			};
		        	 			App.storage.set("verifyIdentity/bankOption", bankOption);
		            			this.$("#bankInfo div").html('平安银行');
			        	 		break;
		        	 		}else{
			        	 		for(var j=0; j<openBankList.length; j++){
				        	 		if((bankCardNo.substring(0, 6) == bankBinList[i].cardBin) && (bankBinList[i].bankCode == openBankList[j].recBankId)){
				        	 			bankOption = this.bankOption = {
				        	 				recBankId:bankBinList[i].bankCode,
				        	 				recBankName:bankBinList[i].bankName
				        	 			};
				        	 			App.storage.set("verifyIdentity/bankOption", bankOption);
				            			this.$("#bankInfo div").html(bankBinList[i].bankName);
					        	 		break;
				        	 		}
			        	 		}
		        	 		}
		        	 	}
		        	 }
	        	 //}
        	 }
        	 
        	 
        	 /**
        	  * 判断四家银行（招行308、广发306、华夏304、民生305）则走老流程，其他的走新流程，新流程展示手机号和OTP
        	  */
        	 if(this.bankOption){
	        	 var recBankId = this.bankOption.recBankId;
	        	 if(recBankId != '308' && recBankId != '306' && recBankId != '305' && recBankId != '304'){
		            var _this = this;
	        	 	this.$('#mobileLi').css("display", '');
	        	 	this.$('#transOtp').show();
		            var options = {
		                isOtpSended : true,
		                isNeedSendOtpValidate : false,
		                isQryOtpPhoneNo : false, //不调用接口查询手机号码
		                otpEnable : null,
		                isMobilePhoneByUser : true, //手机号码是用户输入的
		                resendBtnHandler : _.debounce(_.bind(_this.resendBtnHandler, _this), 300),  //点击“立即获取”按钮调用方法
		                isOutLogin : true
		            };
		            if(!this.otpView){
			            this.otpView = new OtpView();
			            this.otpView.initOtp(options);
			            this.$("#transOtp").empty();
			            this.$("#transOtp").append($(this.otpView.$el[0]));
		            }
		            var mobileNo = this.$("#mobile").val().trim();
	           	 	var code  	 = this.$('#otp_passWord').val().trim(); 
		            if(bankCardNo && this.bankOption && mobileNo && code && this.$("#checkbox").hasClass('on')){
		        	 	if(this.$('#nextStepBtn').hasClass("btn_disable")) this.$('#nextStepBtn').removeClass('btn_disable');
		        	 	this.$('#nextStepBtn').addClass("btn_orange");
			        }else{
		        	 	if(this.$('#nextStepBtn').hasClass("btn_orange")) this.$('#nextStepBtn').removeClass('btn_orange');
		        	 	this.$('#nextStepBtn').addClass("btn_disable");
			        }
	        	 }else{
	        	 	 this.$('#mobileLi').hide();
	        	 	 this.$('#transOtp').hide();
		        	 if(bankCardNo && this.bankOption && this.$("#checkbox").hasClass('on')){
		        	 	if(this.$('#nextStepBtn').hasClass("btn_disable")) this.$('#nextStepBtn').removeClass('btn_disable');
		        	 	this.$('#nextStepBtn').addClass("btn_orange");
		        	 }else{
		        	 	if(this.$('#nextStepBtn').hasClass("btn_orange")) this.$('#nextStepBtn').removeClass('btn_orange');
		        	 	this.$('#nextStepBtn').addClass("btn_disable");
		        	 }
	        	 }
        	 }
        },

		resendBtnHandler : function() {
            var _this = this;
            var mobile  = _this.$('#mobile').val().trim();
            if(_this._validMobile(mobile)) {
                if(_this.submitFlag) return;
                var url = config.urls.get('sendByPhoneNo')+"/"+config.values.union_pay;
                _this.otpView.sendSmsOTP(url, {
                    mobileNo : mobile,
                    successFunction : _.bind(_this.successFunction, _this),
                    errorFunction : _.bind(_this.errorFunction, _this)
                }, _this);
            }
        },
        
         _validMobile : function(mobile) {
            if(!mobile) {
                utils.dialog.toast("请输入手机号。");
                return false;
            }
            if(mobile && !utils.validate.phone(mobile)){
                utils.dialog.toast("你输入的手机号不符合规范。");
                return false;
            }
            return true;
        },

        successFunction : function () {
            this.$('#payMentCheck').addClass('m_t20');
        },

        errorFunction : function () {
            // if (this.$('#otp_label').text().indexOf('动态密码') < 0) {
                // this.$('#Columns').removeClass('m_t30');
            // }
        },
		
        _toSubmit: function(){
        	if(this.$('#nextStepBtn').hasClass("btn_disable")){
        		return;
        	}
			var _this = this;
            var formData = this._formData();
            if (this.validateForm(formData)) {
                if (!this.submitFlag) {
                    this.submitFlag = true;

		            //缓存页面数据
		            App.storage.set("toPostUnionPay_formData",formData);

		            //判断卡状态跳到本贷本激活
		            var state = App.storage.get("UserInfo").get("cardState");//激活状态：0. 未激活;1.激活 ;2.重新验证
		            
		             /**
        	  		  * 判断四家银行（招行308、广发306、华夏304、民生305）则走老流程，其他的走新流程
        	  		  */
		             var recBankId = formData.bankCode;
		             if(recBankId == '308' || recBankId == '306' || recBankId == '305' || recBankId == '304'){
			          
                        //调生成订单接口，该接口返回订单信息给前端
                        App.navigate('verifyAccount/main/toFastAuthSubmitView', true);
                        
        	 		}else{
						_this._unionSendBack(formData);
        	 		}
                }
            }
        },
        
        /**
         * 功能：银联鉴权新改造
		 * author:ex_huangzit
		 * time: 2015-09-30
         */
		_unionSendBack:function(options){
			 var self = this;
			 IdentityModel.queryAllBankList({
                "url" : "unionSendBack",
                "data" : options,
                "callback" : function(response){
                	//清除银行信息缓存
		            App.storage.remove( "verifyIdentity/openBankList");
                	self.submitFlag = false;
                    //跳到成功页面
                    App.navigate("verifyAccount/main/toFastAuthSuccessView",true);
                },
                "errorCallback" : function(response){
                	self.submitFlag = false;
                	//失败
                    utils.dialog.alert("您绑定的银行卡因为“" + response.message + "”的原因，绑定卡失败。");
                }
            });
		},
        

		/**
		 * 功能：校验数据
		 * author:ex_huangzit
		 * time: 2015-08-19
		 */
        validateForm: function(formData){
        	var checkFlag = this.$("#checkbox").hasClass('on');
            var cardNo = formData.cardNo;
            if (cardNo === "") {
                utils.dialog.toast("输入你的他行借记卡卡号！");
                return false;
            }else if(!(/^[0-9]*$/).test(cardNo)){
            	utils.dialog.toast("请输入正确的银行卡号！");
                return false;
            }else if (cardNo.length != 16 && cardNo.length != 19){
                utils.dialog.toast("输入卡号位数有误！");
                return false;
            }
            if(!this.bankOption){
            	utils.dialog.toast("请选择借记卡开户行");
                return false;
            }
            
            var recBankId = formData.bankCode;
            if(recBankId != '308' && recBankId != '306' && recBankId != '305' && recBankId != '304'){
	            var code = formData.code;
	           	if(!code){
	            	utils.dialog.toast("请输入手机动态码");
	                return false;
	            }
	            
	            //校验手机号
	        	this._validMobile(formData.mobileNo);
        	}
        	
        	
        	if(!checkFlag){
        		utils.dialog.toast("请勾选用户协议");
        	}
            return true;
        },

        _formData: function(){
            var cardNo   = this.$("#bankCardNo").val().trim();
            var bankCode = this.bankOption.recBankId;
            var bankName = this.bankOption.recBankName;
            if(bankCode != '308' && bankCode != '306' && bankCode != '305' && bankCode != '304'){
				var mobileNo = this.$("#mobile").val().trim();
	            var code  	 = this.$('#otp_passWord').val().trim();
        		return {
	                cardNo   : cardNo,
	                bankCode : bankCode,
	                bankName : bankName,
	                mobileNo : mobileNo,
	                code     : code
	            };
        	}else{
	            return {
	                cardNo   : cardNo,
	                bankCode : bankCode,
	                bankName : bankName
	            };
            }
        },

		//跳转到选择借记卡银行
		_toBankInfoPattern: function(){
			//传递卡号
			var options = {cardNo : this.$("#bankCardNo").val()};
			App.storage.set("verifyIdentity/byFastAuth", options);
			//跳转页面
			App.navigate('verifyAccount/main/tobankInfoView', true);
		},

		//查询开户行
		_qryPaPayBankList:function(){
			 bankListModel.queryAllBankList({
                "url" : "queryAllBankList",
                "data" : {},
                "callback" : function(response){
                    // 缓存所有银行信息
                    App.storage.set("verifyIdentity/openBankList", response.object.bankList);
                },
                "errorCallback" : function(response){
                    utils.dialog.alert(response.message);
                }
            });
		},

		/**
	     * 功能：卡Bin匹配银行
	     * author:ex_huangzit
	     * time:2015-08-31
	     */
        _qryBankBinSel : function(){
            bankListModel.qryBankBinInfo({
               "url" : "qryBankBinInfo",
               "data" : {},
               "callback" : function(response){
                    var bankBinList = response.object.bankBinList;
                    App.storage.set("verifyIdentity/bankBinList",bankBinList);
                },
                "errorCallback" : function(response){
                    utils.dialog.toast(response.message);
                }
            });
        },
        
        _clickPayment:function(){
        	if(this.$("#checkbox").hasClass('on')){
        		this.$("#checkbox").removeClass('on');
        	}else{
        		this.$("#checkbox").addClass('on');
        	}
        	this._setFullFill();
        },
        
        //用户协议
        _clickUserPayment:function(){
        	var userPayMentUrl = 'https://ssl.pingan.com/bank/xieyi/zt/daishou.html';
			utils.window.open({"title": "用户协议","url": userPayMentUrl});
        }
    });
});