define(function(require, exports, module) {
	var temp          = require("text!../../template/verifyIdentity/byFastAuthSubmit.html");
	var FormComponent = require("component/form");
	var IdentityModel = require("../../model/identityModel");


	module.exports = FormComponent.extend({
		template: _.template(temp),
		events: {
			'tap #btnSubmit' : 'toSubmit',
			'tap #btnCancel' : 'toCancel'
		},

		onShow : function(){
			//1为银联鉴权成功之后显示的页面
			var pageCode = App.storage.get("pageCode");
			if(pageCode == 1){
				this.openPopLayer();
			}
		},

		/**
		 * 功能：跳转到银联
		 * author:ex_huangzit
		 * time: 2015-08-19
		 */
		toSubmit:function(){
			var self = this;
			var data = App.storage.get("toPostUnionPay_formData");
			//跳转到银联鉴权页面
			//App.navigate("verifyAccount/unionPay/toPostToUnionPay",true);
			IdentityModel.unionPaySign({
				"url" : "unionPaySign",
				"data" : data,
				"callback" : function(response){
					
					//清除银行信息缓存
		            App.storage.remove("verifyIdentity/openBankList");
					var orderId = response.object.orderId;
                    var search = location.search ? location.search.replace('?', '') + '&' : '';
					var unionPayUrl = encodeURI(location.href.split("index.html")[0] + "toUnionPay.html?"+ search +"data="+response.object.htmlForm);
					utils.window.open({"title": "银联","url": unionPayUrl});
					//弹出银联提示框
					self.openPopLayer(orderId);
				},
				"errorCallback" : function(response){
					utils.dialog.alert(response.message);
				}
			});
		},

		 /**
		 * 功能：回跳快捷认证
		 * author:ex_huangzit
		 * time: 2015-08-19
		 */
		toCancel:function(){
            this._clearData();
            var registerBind= App.storage.get("register/bindCardFlag");
            var bindCardFlag = App.storage.get('UserInfo').get('bindCardFlag');
            if (bindCardFlag === '1' || registerBind === '1') {  
                var flag = App.storage.get("register/inputBindCard");
                (flag) ? App.navigate("login/login/gestureLogin",true) : App.navigate('me/accoutAndSecurity/bankManage/bindCard', true);
            }else{
                var verifyMode = App.storage.get("changeBindCard_verifyMode");
                if(verifyMode && verifyMode == 'a'){
                    App.navigate("me/accoutAndSecurity/bankManage/bindCard", true);//跳到绑定卡页面
                }else{
                    App.navigate("verifyAccount/main/verifyIdentity",true);//跳到激活认证页面
                }
            }
		},

		/**
		 * 功能：打开弹出层
		 * author:wuwenjun059
		 * time: 2015-08-27
		 */
		openPopLayer : function(orderId){
			var self = this;
            var registerBind= App.storage.get("register/bindCardFlag");
            var bindCardFlag = App.storage.get('UserInfo').get('bindCardFlag');
			 //打开弹出层
			utils.dialog.confirm("请您在新打开的银联页面进行验证，验证完成前请不要关闭该窗口。",{
				okButtonText:"验证完成",
				cancelButtonText:"验证失败"
			},function(ok){
				if(ok){
					var options = {orderId: orderId};
					self.successUpdate(options);
				}else{
                    self._clearData();
                    if (bindCardFlag === '1' || registerBind === '1') { 
                        var flag = App.storage.get("register/inputBindCard");
                        (flag) ? App.navigate("login/login/gestureLogin",true) : App.navigate('me/accoutAndSecurity/bankManage/bindCard', true);
                    }else{
                        var verifyMode = App.storage.get("changeBindCard_verifyMode");
                        if(verifyMode && verifyMode == 'a'){
                            App.navigate("me/accoutAndSecurity/bankManage/bindCard", true);//跳到绑定卡页面
                        }else{
                            App.navigate("verifyAccount/main/verifyIdentity", true);//跳到激活认证页面
                        }
                    }
				}
			});
		},
		
		/**
		 *功能：银联鉴权-验证成功和验证失败 
		 */
		successUpdate:function(options){
            var bindCardFlag = App.storage.get('UserInfo').get('bindCardFlag');
            var verifyMode = App.storage.get("changeBindCard_verifyMode");
            var registerBind= App.storage.get("register/bindCardFlag");
			IdentityModel.successUpdate({
					url : "successUpdate",
					data : options,
					callback : function(res){
                        if (bindCardFlag === '1' || registerBind === '1') { 
                            App.navigate("verifyAccount/bindCard/bindCardSuccess", true);
                        }else{
                            //成功或者失败标识
                            if(verifyMode == 'a'){//跳转到绑定成功页面
                                App.navigate("me/fastAuthBindCard/modifyCardSuc",true);
                            }else{//跳转到激活鉴权成功页面
                                App.navigate("verifyAccount/main/toFastAuthSuccessView",true);
                            }
                        }
					},
					errorCallback : function(res){
						//认证失败
                        App.storage.set("verifyFailReason",res.message)
                        if (bindCardFlag === '1' || registerBind === '1') { 
                            App.navigate("verifyAccount/main/toFastAuthFailView",true);
                        }else{
                            if(verifyMode == 'a'){//跳转到绑定失败页面
                                App.navigate("me/fastAuthBindCard/modifyCardFail",true);
                            }else{//跳转到激活鉴权失败页面
                                App.navigate("verifyAccount/main/toFastAuthFailView",true);
                            }
                        }
					}
				});
		},
        _clearData:function(){
            App.storage.remove('verifyIdentity/openBankList');
            App.storage.remove('verifyIdentity/bankOption');
            App.storage.remove('verifyIdentity/byFastAuth');
            App.storage.remove("toPostUnionPay_formData");
        }
	});
});