define(function(require, exports, module) {
    var livenessDetectionTemp = require("text!../../template/verifyIdentity/livenessDetection.html");
    var IdentityModel = require("../../model/identityModel");
    var FormComponent = require("component/form");
    var accountModel  = require("mod/common/model/accountModel");

    function encodeImageData(imageData){
        // TODO: 上送数据应该经过 x-www-form-urlencoded 编码。
        // 当前情况是JS端和android端未做数据编码，IOS端做了编码工作（所有接口)。
        // 需要在下个版本中修正该问题。
        // 解决方案：
        // 1）　JS端编码所有上送字段，android和IOS不编码。
        // 2)  或者 JS端不编码，由android和IOS端编码
        // PS: 在JS端做判断，根据不同平台选择是否编码是可行的，不过不建议
        if(IS_RUN_ON_ANDROID){
            return encodeURIComponent(imageData);
        }

        if(imageData.indexOf("+")){
            return encodeURIComponent(imageData);
        }else{
            return imageData;
        }
    }


    module.exports = FormComponent.extend({

        template: _.template(livenessDetectionTemp),

        templateHelpers: {
            addHiddenInput: function(){
                var accountNo = App.storage.get("UserInfo").get("accNumber");

                var html = '<input type="hidden" name="accountNo" id="accountNo" value="' + accountNo + '">'
                html += '<input type="hidden" name="idNo" id="idNo" value="' + this.cardId + '">';

                return html;
            }
        },

        ui: {
            "imageFileAShow": "#imageFileAShow",
            "imageFileBShow": "#imageFileBShow"
        },

        events: {
            'tap [data-showimg]' : 'showGallery',
            'tap #imageFileA': 'chooseImageFileA',
            'tap #imageFileB': 'chooseImageFileB',
            'tap #btnSubmit' : 'toSubmit',
            'tap #btnFileA'  : 'chooseBtnFileA',
            'tap #btnFileB'  : 'chooseBtnFileB'
        },

        modelEvents: {
            'change' : 'checkFullFill'
        },

        initialize: function () {
            this.model.set('fileA', false);
            this.model.set('fileB', false);
        },

        checkFullFill: function () {
            var fullFill = this.model.attributes;
            if (fullFill.fileA && fullFill.fileB) {
                this.$('#btnSubmit').removeClass('btn_disable');
                return true;
            }else{
                this.$('#btnSubmit').addClass('btn_disable');
                return false;
            }
        },

        onShow: function(){
            //$('#imgHeight').load(_.bind(function(){
                // 加载完成
                //var imgOutHeight = $("#imgHeight").outerHeight();
                //$(".image50show img").height(imgOutHeight);
                //if(App.idCardScan != "1") return;//使用过ocr且身份核查通过标志获取缓存图片
                // 获取缓存图片
                utils.native.getIDCardImage(_.bind(function(data){
                    data = JSON.parse(data);
                    if(!!data.idCard1){
                        var pic1 = data.idCard1;
                        this.imageId = 'imageFileAShow';
                        this.onPhotoDataSuccess(pic1.replace(/^data:image\/jpeg;base64,/, ''));
                    }
                    if(!!data.idCard2){
                        var pic2 = data.idCard2;
                        this.imageId = 'imageFileBShow';
                        this.onPhotoDataSuccess(pic2.replace(/^data:image\/jpeg;base64,/, ''));
                    }

                    // 从缓存取，非常重要!!!
                    if(!!data.selfImage){
                        this.imageFileCShow = data.selfImage;
                    }else{
                        utils.dialog.alert('认证失败，请重试', function(){
                            App.navigate("verifyAccount/main/verifyIdentity", true);
                        });
                    }
                },this));
            //},this));
        },

        chooseImageFileA: function(){
            //this.imageShowField = this.ui.imageFileAShow;
            this.imageId = 'imageFileAShow';
            this.chooseImage();
        },

        chooseImageFileB: function(){
            //this.imageShowField = this.ui.imageFileBShow;
            this.imageId = 'imageFileBShow';
            this.chooseImage();
        },

        /*
         * 重新上传按钮
         */
        chooseBtnFileA: function(e){
            e.preventDefault();e.stopPropagation();
            this.chooseImageFileA();
        },

        chooseBtnFileB: function(e){
            e.preventDefault();e.stopPropagation();
            this.chooseImageFileB();
        },

        /**
         *选择图片
         */
        chooseImage : function() {
            utils.dialog.spinner({
                source : [{"text":"照片中选择", "value":0},{"text":"拍照", "value":1}],
                callback : _.bind(function(selectedItem, selectedIndex) {
                     if (!navigator.camera) {
                          utils.dialog.alert("Camera API not supported", "Error");
                          return;
                      }
                      this.getPicture(selectedItem.value);
                },this)
            });
        },

        /**
         *拍照
         */
        getPicture : function(sourceType) {
            navigator.camera.getPicture(_.bind(this.onPhotoDataSuccess, this), this.onFail,{
                quality: 50,
                sourceType : sourceType,  //0:从相册 ,1:照相
                destinationType: 0, //选择返回数据的格式0:base64,1:url
                correctOrientation: true,
                encodingType : Camera.EncodingType.JPEG
            });
        },

        onPhotoDataSuccess : function(imageData) {
            var _this = this, id= _this.imageId;
            // 2015-06-25 wuyongsheng560 图片调节
            var imgClone = $('<img class="scts" id="'+ id +'" />');
            this.$('#' + id).replaceWith(imgClone);
            imgClone.on('load', function(){
                var img = this, imgSize = img.fileSize;
                if ((imgSize / 1024*1024) > 2) {
                    imgClone.attr('data-selected', '0');
                    imgClone.parent().prev().show();
                    imgClone.parent().hide();

                    _this._changeModelState();
                    utils.dialog.alert('请勿上传大于2m的图片!');
                }

                //var rect = _this._imgZoom(144, 75, img.offsetWidth, img.offsetHeight);
                var rect = {top:0, left:0, width:144, height:75};
                $(img).css({
                    width       : rect.width,
                    height      : rect.height,
                    left        : rect.left,
                    top         : rect.top
                });

                imgClone.off('load');
            });

            imgClone.attr('src', 'data:image/jpeg;base64,' + imageData);
            imgClone.attr('data-selected', '1');
            imgClone.parent().prev().hide();
            imgClone.parent().show();
            // this.imageShowField.parent().next().show();

            this._changeModelState();
        },

        _changeModelState: function () {
            if (this.$('#imageFileAShow').attr('data-selected') == '1') {
                this.model.set('fileA', true);
            }else{
                this.model.set('fileA', false);
            }
            if (this.$('#imageFileBShow').attr('data-selected') == '1') {
                this.model.set('fileB', true);
            }else{
                this.model.set('fileB', false);
            }
        },

        onFail : function(message) {
            //alert('Failed because: ' + message);
        },

        // 2015-06-25 wuyongsheng560 图片调节
        _imgZoom: function ( maxWidth, maxHeight, width, height ) {
            var param = {top:0, left:0, width:width, height:height};
            if( width > maxWidth || height > maxHeight ){
                rateWidth = width / maxWidth;
                rateHeight = height / maxHeight;

                if( rateWidth > rateHeight ){
                    param.width =  maxWidth;
                    param.height = Math.round(height / rateWidth);

                    param.left = 0;
                }else{
                    param.width = Math.round(width / rateHeight);
                    param.height = maxHeight;

                    param.left = Math.round((maxWidth - param.width) / 2);
                }
            }
            return param;
        },

        toSubmit: function(){
            if (this.checkFullFill()) {
                if (!this.submitFlag) {
                    this.submitFlag=true;
                    this._doSubmit();
                }
            }
        },

        _doSubmit: function(){
            var thisView = this;
            IdentityModel.uploadIdPhoto({
                param: {
                    responseDataType: "JSON",
                    channelType: "1",
                    idNo: thisView.model.get('cardId'),
                    accountNo: App.storage.get("UserInfo").get("accNumber"),
                    imageFileA: encodeImageData(thisView._getImageElmSrc('imageFileAShow')),
                    imageFileB: encodeImageData(thisView._getImageElmSrc('imageFileBShow')),
                    imageFileC: encodeImageData(thisView.imageFileCShow.replace(/^data:image\/jpeg;base64,/, ''))
                },
                callback: function(response){
                    thisView.upLoadImFile(response);
                    //thisView.submitFlag = false;
                },
                errorCallback: function(err){
                    utils.dialog.alert(err);
                    thisView.submitFlag = false;
                }
            });
        },

        _getImageElmSrc: function(name){
            return this.$('#'+ name).prop('src').replace(/^data:image\/jpeg;base64,/, '');
        },

        // 上传验证信息到后台
        upLoadImFile: function(data){
            var formData = {};
            formData.upLoadFileA = data.nameA;
            formData.upLoadFileB = data.nameB;
            formData.upLoadFileC = data.nameC;
            formData.retFlag = data.retFlag;

            IdentityModel.upLoadFaceImFile(formData, _.bind(function(err, resp){
                this.submitFlag = false;
                if (err) {
                    return utils.dialog.alert(err.message || err);
                }

                this.renderSuccessContent();
            }, this));
        },

        // 提交成功
        renderSuccessContent: function(){
            //万里通积分提示
            //var wltPrompt = "审核通过后您将获得奖励积分。请前往转账记录-万里通积分查询。";
            // 记录卡审核中
            App.storage.get("UserInfo").set("cardState", "3");
             App.storage.get('UserInfo').set('verifyMode', '8')
            utils.native.talkingDataTrackEvent("2.0-身份认证-上传成功");
            
            utils.dialog.alert("身份证上传成功! 请等待审核结果...", function () {
                App.navigate('index/indexLogined/index', true);
            });

            //是否送万里通积分
            // accountModel.getWLTCheckRule({
            //     data : {"ruleId":config.values.wltJiHuo},
            //     callback : function(res){
            //         //0是送积分1不送积分
            //         if(res.object.wanlitongRule && res.object.wanlitongRule == 0){
            //             utils.dialog.alert("身份证上传成功! 请等待审核结果..."+wltPrompt, function () {
            //                 App.navigate('index/indexLogined/index', true);
            //             });
            //         }else{
            //             utils.dialog.alert("身份证上传成功! 请等待审核结果...", function () {
            //                 App.navigate('index/indexLogined/index', true);
            //             });
            //         }
            //     },
            //     errorCallback : function(res){
            //         //utils.dialog.alert(res.message);
            //     }
            // });

        },

        /*
         * 显示照片
         */
        showGallery : function(e){
            var consumeView = this;
            e.stopPropagation();

            var consumeUrl = $(e.currentTarget).children("img").attr("src").replace(/^data:image\/jpeg;base64,/, '');
            var imgUrlList = [consumeUrl];

            // 调用native方法展示照片墙
            utils.native.gallery.show({
                source:imgUrlList
            });
        }

    });
});