/**
 * EX-WUWENJUN
 * 选择开户行View
 * 
 */
define(function(require, exports, module){
   var FormComponent = require("component/form"); 
   var template 	 = require("text!../../template/verifyIdentity/openBankSelect.html");
   var transferLang  = require("mod/me/common/transferLang");
   var transferTools = require("mod/me/common/transferTools");
   var transModel    = require("mod/me/model/transferModel");
   
   var IndexView =  module.exports =  FormComponent.extend({
        template : _.template(template),

        events : {
        	"input #OpenBankInput"     : "filterOpenBank",     //筛选开户行
            "tap #OpenBankBox li"      : "writeOpenBank"       //写入开户行
        },

        initialize:function(options){
        	this.model = options.model;
        },
        
        /**
         * 筛选开户行
         */
        filterOpenBank : function(e) {
            var keyWord = $(e.currentTarget).val().replace(/\s/g,"").toUpperCase();
            //分组排序后的数组
            var openBankList = this.model.get("openBankList");
             //根据拼音匹配
            var filterList = [];

            // 关键字为空时显示所有
            if(keyWord == "") {
            	$("#selRecBankInfo,hr").show();
            	$("#searchBank,#searchNoResult").hide();
            	$("#OpenBankBox").removeClass("m_t10");
                filterList = openBankList;
            }else {
            	$("#selRecBankInfo,hr").hide();
            	$("#searchBank").show();
            	$("#OpenBankBox").addClass("m_t10");
                _.each(openBankList,function(item,i){
                    if(item.recBankName.indexOf(keyWord) >= 0) {
                        filterList.push(item);
                    }
                });
            }
            App.storage.set("filterOpenBankList",filterList);

            // 重新生成城市列表选项
            if(filterList.length == 0) {
                 // 清空所有城市列表
                $("#OpenBankBox").html("");
                $("#searchNoResult").show();
            }else{
            	$("#searchNoResult").hide();
                var OpenBankListHtml = "<div class='Columns b_t0'><ul class='ulStyle1 fannyulStyle1'>";
                _.each(filterList,function(item,i) {
                    OpenBankListHtml += 
                    	'<li class="dswkb" data-recBankId="'+item.recBankId+'" data-index="'+i+'">' +
	                    	'<p class="tac ibank_daf ibank_'+item.recBankId.substr(0,3)+'"></p>' +
                	    	'<div class="m_l10 flex1">' +
					   			'<p class="c_333">'+item.recBankName+'</span></p>' +
				    		'</div>' +
                        '</li>';
                });
                OpenBankListHtml += "</ul></div>";
                $("#OpenBankBox").html(OpenBankListHtml);
            }
        },

        /**
         * 写入开户行
         */
        writeOpenBank : function(e) {
            var list  = App.storage.get("filterOpenBankList") || this.model.get("openBankList");
            var index = $(e.currentTarget).attr("data-index");
            $("#OpenBankBox li i").remove();
            $(e.currentTarget).append("<i class='iconA59'></i>");
            var data  = list[index];
            App.storage.set("verifyIdentity/bankOption", data);
            
            var url = this.model.get("url");
            if(url && url == 'verifyAccount/bindCard/bindCardAuth'){
                App.navigate(url,true);
            }else{
                App.navigate("verifyAccount/main/toFastAuthView",true);
            }
        }
  });
});
