﻿define(function(require, exports, module) {
    var Tpl = _.template(require("text!../../template/verifyIdentity/selection.html"));
    var selectTpl = _.template(require("text!../../template/verifyIdentity/selectionItem.html"));

    var IdentityModel = require("../../model/identityModel");
    var PersonalInfoModel = require("../../model/personalInfo");

    module.exports = ItemView.extend({
        template: Tpl,
        ui: {
            selectItem	: '#selectItem'
        },

        events: {
            'tap .activateMethod': 'showTypeSelection',
            "tap #faq":"bankfaq"

        },
        onShow: function(){
            this.cardId = this.model.get("cardId");

            // 2015-12-30 (dev许海鹏)
            // 1.屏蔽人脸识别激活入口
            // 2.删除试点城市用户自动调转人脸识别代码

            //人脸识别
            // this.livenessDetection = this.model.get('livenessDetection') || false;
            // if(this.livenessDetection){
            // 	this.livenessDetection = true;
            // 	this.toLivenessDetection();
            // }else{
        	// 	this.livenessDetection = false;
            // }

            this.initSelectionSource();
        },

        initSelectionSource: function(){
            var source = this.selectionSource = [];
            var bindCardFlag = App.storage.get('UserInfo').get('bindCardFlag');//新增绑定借记卡改造标识：0:关, 1:开
            
            /**
             * ex-huangzt(2016-04-05)
             * 1-个人网银高级用户，2-身份证，3-借记卡，4-信用卡，5-CFE迁移过来的数据， 在CFE时验证方式为同名户验证。
             * 6-历史数据修改， 迁移时存在一部分用户，他们的卡在卡管， FCR都已经激活，但在CFE为未激活状态。针对这类诡异数据，
             * 	  无法给出相对应的激活方式，所以修改这些历史数据时激活方式置为6
             * 7-汽融，8-人脸识别，9-柜面核身
            */
            var verifyMode = App.storage.get('UserInfo').get('verifyMode');
            if(verifyMode == '5' || bindCardFlag == 0){
                this.model.get('bydebitCard') && source.push({ method: 'bydebitCard', text: "平安借记卡认证"});
                this.model.get('bycreditCard') && source.push({ method: 'bycreditCard', text: "平安信用卡认证"});
                source.push({ method: 'byidCard', text: "上传身份证"});
            }else{
                source.push({ method: 'bindCard', text: "绑定借记卡"}); //财富E用户不展示银联鉴权
            }
            // 2015-12-30 去掉老的人脸激活选项(dev许海鹏)
            //if(bindCardFlag == 0 && this.livenessDetection ) source.push({ method: 'byliveness', text: "人脸识别"});

            //author:ex_huangzit date:2015-09-07
            //var caifuE = App.storage.get("verifyIndentity/caifuE");//功能：卡已激活状态，但是是财富E升级用户，需重新认证，不能走银联鉴权，设置财富E标识-caifuE
            //if(bindCardFlag == 0 && !caifuE) source.push({ method: 'byFastAuth', text: '他行借记卡认证', moduleChannel:'fastAuthActive'});

            this.ui.selectItem.html(selectTpl({ source: source }));
        },

        showTypeSelection: function(e){
            var _this = this,
                target = $(e.currentTarget),
                method = target.data('method');
            switch(method){
                case 'bydebitCard':
                    _this.toDebitCardView();
                    break;
                case 'bycreditCard':
                    _this.toCreditCardView();
                    break;
                case 'byFastAuth':
                	_this.toFastAuthView();
                	break;
                // case 'byliveness':
                //     _this.toLivenessDetection();
                //     break;
                case 'bindCard':
                    _this.bindCard();
                    break;
                case 'byidCard':
                default :
                    _this.toIdCardView();
                    break;
            }
        },

        //绑定借记卡
        bindCard:function(){
            App.navigate('verifyAccount/bindCard/inputBindCard', true);
        },

        //平安借记卡认证
        toDebitCardView: function(){
            var data = this.model.toJSON();
            App.storage.set('verifyAccount/main/toDebitCardView', data);
            App.navigate('verifyAccount/main/toDebitCardView', true);
        },

        //平安信用卡认证
        toCreditCardView: function(){
            var data = this.model.toJSON();
            App.storage.set('verifyAccount/main/toCreditCardView', data);
            App.navigate('verifyAccount/main/toCreditCardView', true);
        },

        //上传身份证
        toIdCardView: function(){
             var _this = this;
             //身份认证上传映像时，查询可疑名单,Y-是可疑名单,弹出提示; N-不是可疑名单,按原来流程走身份认证
             PersonalInfoModel.checkAccountSuspicious({
            	url : "checkAccountSuspicious",
            	data : {},
                callback : function(res){
                	var isSuspicious = res.object.isSuspicious;
                	if(isSuspicious && isSuspicious == 'N'){
			            PersonalInfoModel.getIdentityCardNumber(_.bind(function(err, identityNumber){
			                if(err) return utils.dialog.alert(err.message || err);
			                var data = _this.model.toJSON();
			                data.identityNumber = identityNumber;
			                data.cardId = _this.cardId;
			                App.storage.set('verifyAccount/main/toIdCardView', data);
			                App.navigate('verifyAccount/main/toIdCardView', true);
			            }, _this));
                	}else{
                		 utils.dialog.alert("经审核发现您上传的身份证影像不符合标准，可联系电话中心95511-3，了解原因并由客服指导您后续操作。");
                	}
                },
                errorCallback : function(res){
                	utils.dialog.alert(res.message);
                }
            });
        },

		/**
		 * 功能：快捷认证
		 * author:ex_huangzit
		 * data:2015-08-17
		 */
        toFastAuthView: function(){
        	var data = this.model.toJSON();
        	 App.storage.set('verifyAccount/main/toFastAuthView', data);
             App.navigate('verifyAccount/main/toFastAuthView', true);
        },

        //人脸识别
        toLivenessDetection: function(){
            throw new Error('old face recognition is not permitted!');
	        var self = this, version,
                urlFlag = 2,
                cardId = this.model.get("cardId");
            if(!cardId) return;

            utils.native.livenessDetection(cardId, function(data){
                data = JSON.parse(data);
                data.id = data.id || "";
                if(data.id == ""){
                    utils.dialog.alert("认证失败，请重试");
                    return;
                }

                utils.native.versionInformation(function (ver) {
                    version = ver.version.replace(/\./g,"") * 1;
                    if(version > 203){
                        urlFlag = 1;
                    }

                    self._faceCompareByPhoto(data.id, urlFlag, cardId);
                });
            });
        },

        //调人脸相似度判断
        _faceCompareByPhoto: function (pictureNo, urlFlag, cardId) {
            throw new Error('old face recognition is not permitted!');
            IdentityModel.faceCompareByPhoto({
                param: { responsePictureNo: pictureNo, urlFlag : urlFlag },
                callback: function(response){
                    if(response.object.isSamePeople == "1"){
                    	//App.storage.get("UserInfo").set("cardState", "1");
                        //人脸识别补拍2张身法证，需要传参身法证号;
                        App.storage.set('verifyAccount/main/toLivenessDetection', cardId);

	        			App.navigate("verifyAccount/main/toLivenessDetection", true);
        			}else if(response.object.isSamePeople == "0"){
        				//错误提示页面
        				utils.dialog.alert("认证失败，请重试");
        			}else{
        				utils.dialog.alert("系统错误！");
        			}
                },
                errorCallback: function(err){
                    utils.dialog.alert(err.message);
                }
            });
        },
        bankfaq:function(){
         	App.navigate('czFaq/faqIndex/czFaq/verifyIdentity', true);
        }

    });
});