/**
 * ex-wuyongsheng001 一账通 登录验证
 */
define(function(require, exports, module){
    var FormLayout         = require("component/form");
    var safeKeyBoardHelper = require("component/customInput.helper");

    var identityModel 	   = require("../model/identityModel");
    var registerTools      = require("mod/openAccount/common/registerTools");

    var Tpl                = _.template(require("text!../template/verifyYZT.html"));
    
    module.exports = FormLayout.extend({
        template: Tpl,
        events: {
            "tap #nextStepBtn" : "toNextStep",
            "input #userName" : "_setFullFill",
            "customInputKeyup #password" : "_setFullFill",
            "jsClearIconHandler #password" : "_setFullFill",
            "customInputFocusIn #password"  : "_customInputFocusIn", //登录密码
            "customInputFocusOut #password" : "_customInputFocusOut",
            "tap #find_yzt_uerName" : "findYztUserName",
            "tap #forget_yzt_password" : "forgetYztPassword"
        },

        _fullFill : false,
        _submitFlag : 0,
        _setFullFill : function () {
            this._fullFill = false;
            this.$('#nextStepBtn').addClass('btn_disable');
            var userName = this.$("#userName").val().trim();
            var password = this.$("#password").customInput('value');
            if (!userName || !password) return;
            this._fullFill = true;
            this.$('#nextStepBtn').removeClass('btn_disable');
            return true;
        },
		
        onRender:function(){
           this._showSafeKeyBoard();
        },

        _showSafeKeyBoard:function(){
            this.$("#password").customInput({
               type: "password-ascii",
               placeholder: "一账通用户密码",
               className:"safeKeyBoard",
               maxLength:"16"
            });
        },

        _customInputFocusIn : function(){
            safeKeyBoardHelper.focusIn({
                id :"password"
            });
        },

        _customInputFocusOut : function(){
            safeKeyBoardHelper.focusOut({
                id :"password"
            });
        },

        toNextStep : function() {
            var formData = {
                userName : this.$("#userName").val().trim(),
                password : this.$("#password").customInput('value')
            };
            if (!this._fullFill || (this._submitFlag != 0)) return;
            if(this._validInput(formData)) {
                formData.sm2Pwd = utils.sm2.SM2Key.encrypt(formData.password, config.base.sm2_public_key);
                formData.password = utils.crypto.RSAKey.encrypt(formData.password, config.base.rsa_public_key);
                this._submit(formData);
            }
        },

        _submit: function (formData) {
            if(this._submitFlag) return;
            var _this = this;
            _this._submitFlag = 1;
            identityModel.activateLoginVerify({
                formData : formData,
                callback : function(resp) {
                    _this._submitFlag = 0;
                    resp.formData = formData;
                    App.storage.set('verifyAccount/main/verifyYZT', resp);
                    App.navigate("verifyAccount/main/accountInfoImprove", true);
                },
                errorCallback : function(resp) {
                    _this._submitFlag = 0;
                    utils.dialog.alert(resp.message);
                }
            });
        },

        _validInput : function(formData) {
            var userName = formData.userName;
            var password = formData.password;
            if(!userName || userName == "") {
                utils.dialog.toast("用户名不能为空");
                return false;
            }
            if(!password || password == "") {
                safeKeyBoardHelper.setCustomValidity({
                    id : "password",
                    message : "密码不能为空"
                });
                //utils.dialog.toast(registerLang("registerUserNameEmpty"));
                return false;
            }
            return true;
        },

        findYztUserName : function(){
            utils.window.open({
                title:  "忘记用户名",
                url: "https://www.pingan.com.cn/pinganone/pa/retrieveVerify.do?isPS="
            });
        },

        forgetYztPassword : function(){
            utils.window.open({
                title:  "忘记密码",
                url: "https://www.pingan.com.cn/pinganone/pa/paResetIndex.screen"
            });
        }

    });
});