define(function(require, exports, module){
    
    var bin2hex = require("./bin2hex");
    require("./atob");
    
    var fingerprinting;
    
    exports.get = function(){
        if(fingerprinting !== undefined){
            return fingerprinting;
        }
        
        try{
            var canvas = document.createElement("canvas");
        
            canvas.setAttribute("width", 220);
            canvas.setAttribute("height", 30);
            
            var ctx = canvas.getContext("2d");
            ctx.textBaseline = "top";
            ctx.font = "14px 'Arial'";
            ctx.textBaseline = "alphabetic";
            ctx.fillStyle = "#f60";
            ctx.fillRect(125, 1, 62, 20);
            ctx.fillStyle = "#069";
            ctx.fillText("Hello, User.", 2,15);
            ctx.fillStyle = "rgba(102, 204, 0, 0.7)";
            ctx.fillText("Hello, User.", 4,17);
            
            var b64 = canvas.toDataURL().replace("data:image/png;base64,", "");
            var bin = atob(b64);

            // crc32 takes only 4 bytes and placed from 16 to 12 byte from the end of file
            return (fingerprinting = bin2hex(bin.slice(-16,-12)));
        }catch(e){
            return (fingerprinting = "");
        }
    };
    
});