define(function (require, exports, module) {

    var native = require("./native");
    exports.toast = function(message,callback){
        if($(".js-toast-error").length>0)return;
        var toast='';
        toast+='<div class="Mask2 js-toast-error"><div class="center"><div class="pop_tips tac">';
        toast+='<p>'+message+'</p>';
        toast+='</div></div></div>';
        var $el = $(toast);
        $("body").append($el);

        window.setTimeout(function(){
            $el.find(".pop_tips").fadeOut(500,function(){
                $(".js-toast-error").remove();
                if(callback && _.isFunction(callback)){
                    callback();
                }
            });

        },2000);
    };

    exports.alert = function(message, options, callback){
        if(_.isFunction(options)){
            callback = options;
            options = null;
        }

        if(!options) options = {};
        if(!options.buttonText) options.buttonText = "确定";
        options.message = message;

        if(!callback) callback = function(){};

        native.dialogAlert(options, callback);
    };


    exports.confirm = function(message, options, callback){
        if(_.isFunction(options)){
            callback = options;
            options = null;
        }

        options = _.defaults({}, options, {
            okButtonText: "确定",
            cancelButtonText: "取消"
        });
        options.message = message;

        if(!callback) callback = function(){};

        native.dialogAlert(options, callback);
    };

    exports.spinner = function(options){
        var source = options.source || [];
        var textField = options.textField || "text";
        var textList = _.map(source, function(item){
            return item && item[textField] || "";
        });

        native.dialogSpinner({
            title: options.title,
            options: textList,
            selectedIndex: options.selectedIndex,
            callback: function(idx){
                options.callback && options.callback(source[idx], idx);
            }
        });
    };

    //message, options, callback
	exports.customDialog = function(message,options,callback){

			var confirmBtnText= "<div class='tac w50 c_f60 js_confirm_button'>确定</div>";

			var cancelBtnText = "<div class='tac w50 br1d c_f60 js_cancel_button'>取消</div>";

			if(_.isFunction(options)){
                callback = options;
                options = null;
            }

            callback = callback || function(){};
            options = options || {};
            options.message = message;
            var title = options.title || "温馨提示";
            var message = options.message;

            var Cls = options.className;
            var htmlMsg = /^<[a-z]+\s+/.test(message);

            var confirmBtn = options.okButtonText? confirmBtnText.replace("确定",options.okButtonText):confirmBtnText;
            var cancelBtn = options.cancelButtonText?cancelBtnText.replace("取消",options.cancelButtonText):"";
			if(!cancelBtn) confirmBtn = confirmBtn.replace("w50","flex1");
			if($(".js-toast-error").length>0)return;
	        var toast='';
	        toast+='<div class="Mask js-toast-error '+(Cls ? Cls : '')+'" style="top: 0px;">';
	        toast+='	<div class="center">';
			toast+='        <div class="pop_pay">';
			toast+='            <h3>'+ title +'</h3>';
            if (htmlMsg) {
                toast+='            <div class="p_10 p_t5_b5">'+ message +'</div>';
            } else {
    			toast+='            <p class="tac c_000 p_t20 p_b20">'+ message +'</p>';
            }
	        toast+=' 			<div class="dswkb btn">';
	        toast+=cancelBtn;
            toast+=confirmBtn;
	        toast+='			</div>';
	        toast+='       </div>';
        	toast+='	</div>';
   		 	toast+='</div>';

   		 	this.$el = $(toast);
	        $("body").append(this.$el);
	        native.showMask("true");

	        var destoryCustomDialog = _.bind(function(){
                this.$el.remove();
                native.showMask("false");
	        },this);

	        App.listenTo(nativeBroadcast, "backbutton", function(event){
                destoryCustomDialog();
            });

	        this.$el.find(".js_cancel_button").on("tap", _.bind(function() {
	        	destoryCustomDialog();
	        	callback(false)
			},this));

	        this.$el.find(".js_confirm_button").on("tap", _.bind(function() {
	            destoryCustomDialog();
	        	callback(true);
			},this));



		};
    // for development (run on browser of pc)
    ///////////////////////////////////////////////
    if(ENABLE_PHONEGAP) return;

    exports.alert = function(message, options, callback){
        if(_.isFunction(options)) callback = options;
        if(!callback) callback = function(){};
        alert(message);
        callback(true);
    };

    exports.confirm = function(message, options, callback){
        if(_.isFunction(options)) callback = options;
        if(!callback) callback = function(){};
        callback(confirm(message));
    };

    exports.spinner = function(options){
        var source = options.source || [];
        var textField = options.textField || "text";
        var callback = options.callback;
        var container = options.eventObj && $(options.eventObj.target).parent() || $("body");

        var textList = _.map(source, function(item){
            return item && item[textField] || "";
        });

        if(!textList.length) return;

        var menu = $("<ul />").append(_.map(textList, function(text){
            var item = $("<li>").html(text);
            return item[0]
        }));

        menu.on("click", "li", function(event){
            var idx = $(event.currentTarget).index();
            callback && callback(source[idx], idx);
            menu.remove();
        });

        menu.addClass("suggestMenu");
        menu.appendTo(container);
    };

	exports.myCom = function(options){
        var source = options.source || [];
        var textField = options.textField || "text";
        var callback = options.callback;
        var container = options.eventObj && $(options.eventObj.target).parent() || $("body");

        var textList = _.map(source, function(item){
            return item && item[textField] || "";
        });

        if(!textList.length) return;

        var menu = $("<ul />").append(_.map(textList, function(text){
            var item = $("<li>").html(text);
            return item[0]
        }));

        menu.on("click", "li", function(event){
            var idx = $(event.currentTarget).index();
            callback && callback(source[idx], idx);
            menu.remove();
        });

        menu.addClass("suggestMenu");
        menu.appendTo(container);
    };
});