/**
 * User: YUEDAIPING966
 * Date: 14-5-6
 * Time: 下午5:31
 * 封装用于js调用native接口的统一入口API
 */
;(function(window,undefined) {
    "use strict";
    var callIndex = 0,
    isIOSNative = navigator.userAgent.indexOf("One Account IOS") > -1,
    isAndroidNative = navigator.userAgent.indexOf("One Account Android") > -1,
    AppNativeForCZ = window.AppNativeForCZ = {};
    AppNativeForCZ.nativeCallbacks = {};

    AppNativeForCZ.call = (function(){
        function processArguments(methodName) {
            var args = Array.prototype.slice.call(arguments, 1),
            callback = '',
            item = null;                      
            //遍历
            for(var i = 0, len = args.length; i < len; i++) {
                item = args[i];
                if(typeof item === "undefined") {
                    item = '';
                } else if(typeof (item) == 'function') {
                    // 如果参数是一个Function类型, 则将Function存储到window对象, 并将函数名传递给Native
                    callback = methodName + '_Callback' + (callIndex++);
                    this.nativeCallbacks[callback] = item;
                    item = "AppNativeForCZ.nativeCallbacks." + callback;
                }
                args[i] = encodeURI(item);
            }
            return args;
        }
        var call;
        if(isIOSNative) {
            call = function call(methodName) {
                var args = processArguments.apply(this, arguments);
                if(args.length) {
                    args = '/' + args.join('||');
                }else{
                    args =  '/';
                }
                // IOS通过location.href调用Native方法, _call变量存储一个随机数确保每次调用时URL不一致
                ++callIndex;
                var iframe = document.createElement("iframe");
                iframe.style.display = 'none';
                //iframe.cssText = "display: none; position: absolute; left: -100px; top: -100px; width: 0px;height: 0px; z-index: -1;";
                iframe.src = 'paone://' + methodName + args + '||' + callIndex;
                document.body.appendChild(iframe);
                document.body.removeChild(iframe);
                iframe = null;
            }
        } else if(isAndroidNative){
            call = function call(methodName) {
                var args = processArguments.apply(this, arguments);
                try {
                    for(var i = 0, len = args.length; i < len; i++) {
                        args[i] = '\'' + args[i] + '\''; 
                    }
                    eval('window.android.' + methodName + '(' + args.join(',') + ')');
                } catch(e) {
                    console.log(e);
                }
            }
        }         
        return call;
    }());
}(window));
