(function(){

    var dependencies = ["jquery"];

    if(ENABLE_PHONEGAP && IS_RUN_ON_ANDROID) dependencies.push("vendor/cordova.android-2.5.0");
    if(ENABLE_PHONEGAP && IS_RUN_ON_IDEVICE) dependencies.push("vendor/cordova.ios-2.5.0");

    define(dependencies, function(){

        // 因为一些原因(未定位，android phonegap代码被改过), 应用不会触发deviceready事件
        // 添加这个补丁去实现deviceready事件，使用document.addDeviceReadyEventListener
        // 方法监听deviceready事件 

        var deviceReadyCallbacks = $.Callbacks("once memory");
        var intervalId = null;

        // public API
        document.addDeviceReadyEventListener = deviceReadyCallbacks.add;

        document.addDeviceReadyEventListener(function(){
            clearInterval(intervalId);
        });

        document.addEventListener("deviceready", deviceReadyCallbacks.fire, false);

        intervalId = setInterval(function(){
            if(window.cordova && window.cordova.exec)
                deviceReadyCallbacks.fire();
        }, 50);

        if(!ENABLE_PHONEGAP) deviceReadyCallbacks.fire();

    });

})();